/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_00hh(Libderiv_t *, prim_data *);

  /* Computes derivatives of (00|hh) integrals */

void d1hrr_order_00hh(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[0][5][11] = int_stack + 0;
 Libderiv->deriv_classes[0][6][11] = int_stack + 21;
 Libderiv->deriv_classes[0][7][11] = int_stack + 49;
 Libderiv->deriv_classes[0][8][11] = int_stack + 85;
 Libderiv->deriv_classes[0][9][11] = int_stack + 130;
 Libderiv->deriv_classes[0][10][11] = int_stack + 185;
 Libderiv->deriv_classes[0][5][10] = int_stack + 251;
 Libderiv->deriv_classes[0][6][10] = int_stack + 272;
 Libderiv->deriv_classes[0][7][10] = int_stack + 300;
 Libderiv->deriv_classes[0][8][10] = int_stack + 336;
 Libderiv->deriv_classes[0][9][10] = int_stack + 381;
 Libderiv->deriv_classes[0][10][10] = int_stack + 436;
 Libderiv->deriv_classes[0][5][9] = int_stack + 502;
 Libderiv->deriv_classes[0][6][9] = int_stack + 523;
 Libderiv->deriv_classes[0][7][9] = int_stack + 551;
 Libderiv->deriv_classes[0][8][9] = int_stack + 587;
 Libderiv->deriv_classes[0][9][9] = int_stack + 632;
 Libderiv->deriv_classes[0][10][9] = int_stack + 687;
 Libderiv->deriv_classes[0][5][8] = int_stack + 753;
 Libderiv->deriv_classes[0][6][8] = int_stack + 774;
 Libderiv->deriv_classes[0][7][8] = int_stack + 802;
 Libderiv->deriv_classes[0][8][8] = int_stack + 838;
 Libderiv->deriv_classes[0][9][8] = int_stack + 883;
 Libderiv->deriv_classes[0][10][8] = int_stack + 938;
 Libderiv->deriv_classes[0][5][7] = int_stack + 1004;
 Libderiv->deriv_classes[0][6][7] = int_stack + 1025;
 Libderiv->deriv_classes[0][7][7] = int_stack + 1053;
 Libderiv->deriv_classes[0][8][7] = int_stack + 1089;
 Libderiv->deriv_classes[0][9][7] = int_stack + 1134;
 Libderiv->deriv_classes[0][10][7] = int_stack + 1189;
 Libderiv->dvrr_classes[0][5] = int_stack + 1255;
 Libderiv->deriv_classes[0][5][6] = int_stack + 1276;
 Libderiv->dvrr_classes[0][6] = int_stack + 1297;
 Libderiv->deriv_classes[0][6][6] = int_stack + 1325;
 Libderiv->dvrr_classes[0][7] = int_stack + 1353;
 Libderiv->deriv_classes[0][7][6] = int_stack + 1389;
 Libderiv->dvrr_classes[0][8] = int_stack + 1425;
 Libderiv->deriv_classes[0][8][6] = int_stack + 1470;
 Libderiv->dvrr_classes[0][9] = int_stack + 1515;
 Libderiv->deriv_classes[0][9][6] = int_stack + 1570;
 Libderiv->deriv_classes[0][10][6] = int_stack + 1625;
 Libderiv->deriv_classes[0][5][2] = int_stack + 1691;
 Libderiv->deriv_classes[0][6][2] = int_stack + 1712;
 Libderiv->deriv_classes[0][7][2] = int_stack + 1740;
 Libderiv->deriv_classes[0][8][2] = int_stack + 1776;
 Libderiv->deriv_classes[0][9][2] = int_stack + 1821;
 Libderiv->deriv_classes[0][10][2] = int_stack + 1876;
 Libderiv->deriv_classes[0][5][1] = int_stack + 1942;
 Libderiv->deriv_classes[0][6][1] = int_stack + 1963;
 Libderiv->deriv_classes[0][7][1] = int_stack + 1991;
 Libderiv->deriv_classes[0][8][1] = int_stack + 2027;
 Libderiv->deriv_classes[0][9][1] = int_stack + 2072;
 Libderiv->deriv_classes[0][10][1] = int_stack + 2127;
 Libderiv->deriv_classes[0][5][0] = int_stack + 2193;
 Libderiv->deriv_classes[0][6][0] = int_stack + 2214;
 Libderiv->deriv_classes[0][7][0] = int_stack + 2242;
 Libderiv->deriv_classes[0][8][0] = int_stack + 2278;
 Libderiv->deriv_classes[0][9][0] = int_stack + 2323;
 Libderiv->deriv_classes[0][10][0] = int_stack + 2378;
 memset(int_stack,0,19552);

 Libderiv->dvrr_stack = int_stack + 8860;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_00hh(Libderiv, Data);
   Data++;
 }

 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2444,int_stack+1297,int_stack+1255,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2507,int_stack+1353,int_stack+1297,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2591,int_stack+2507,int_stack+2444,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2717,int_stack+1425,int_stack+1353,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2825,int_stack+2717,int_stack+2507,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2993,int_stack+2825,int_stack+2591,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3203,int_stack+1515,int_stack+1425,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3338,int_stack+3203,int_stack+2717,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+3554,int_stack+3338,int_stack+2825,1);
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3834,int_stack+3554,int_stack+2993,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4149,int_stack+21,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1255,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4212,int_stack+49,int_stack+21, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1297,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4296,int_stack+4212,int_stack+4149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2444,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4422,int_stack+85,int_stack+49, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1353,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4530,int_stack+4422,int_stack+4212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2507,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4698,int_stack+4530,int_stack+4296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2591,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4149,int_stack+130,int_stack+85, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1425,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4908,int_stack+4149,int_stack+4422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2717,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+5124,int_stack+4908,int_stack+4530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2825,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4284,int_stack+5124,int_stack+4698, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2993,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4599,int_stack+185,int_stack+130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1515,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5404,int_stack+4599,int_stack+4149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3203,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+5674,int_stack+5404,int_stack+4908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3338,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4599,int_stack+5674,int_stack+5124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3554,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4149,int_stack+272,int_stack+251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1255, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5019,int_stack+300,int_stack+272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1297, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5103,int_stack+5019,int_stack+4149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2444, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4149,int_stack+336,int_stack+300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1353, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5229,int_stack+4149,int_stack+5019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2507, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+5397,int_stack+5229,int_stack+5103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2591, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5019,int_stack+381,int_stack+336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1425, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+5607,int_stack+5019,int_stack+4149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2717, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+5823,int_stack+5607,int_stack+5229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2825, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6103,int_stack+5823,int_stack+5397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2993, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+5154,int_stack+436,int_stack+381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1515, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5319,int_stack+5154,int_stack+5019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3203, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6418,int_stack+5319,int_stack+5607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3338, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+5019,int_stack+6418,int_stack+5823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3554, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6418,int_stack+523,int_stack+502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1255, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6481,int_stack+551,int_stack+523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1297, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6565,int_stack+6481,int_stack+6418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2444, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6691,int_stack+587,int_stack+551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1353, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6799,int_stack+6691,int_stack+6481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2507, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+5439,int_stack+6799,int_stack+6565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2591, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4149,int_stack+632,int_stack+587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1425, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6418,int_stack+4149,int_stack+6691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2717, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+5649,int_stack+6418,int_stack+6799, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2825, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6634,int_stack+5649,int_stack+5439, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2993, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+5439,int_stack+687,int_stack+632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1515, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+0,int_stack+5439,int_stack+4149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3203, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+270,int_stack+0,int_stack+6418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3338, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6949,int_stack+270,int_stack+5649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3554, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6418,int_stack+774,int_stack+753, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6481,int_stack+802,int_stack+774, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+6481,int_stack+6418, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+126,int_stack+838,int_stack+802, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+234,int_stack+126,int_stack+6481, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6418,int_stack+234,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4149,int_stack+883,int_stack+838, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+402,int_stack+4149,int_stack+126, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+5439,int_stack+402,int_stack+234, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+0,int_stack+5439,int_stack+6418, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6418,int_stack+938,int_stack+883, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+618,int_stack+6418,int_stack+4149, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+5719,int_stack+618,int_stack+402, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+315,int_stack+5719,int_stack+5439, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5439,int_stack+1025,int_stack+1004, 0.0, zero_stack, 1.0, int_stack+1255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5502,int_stack+1053,int_stack+1025, 0.0, zero_stack, 1.0, int_stack+1297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5586,int_stack+5502,int_stack+5439, 0.0, zero_stack, 1.0, int_stack+2444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5712,int_stack+1089,int_stack+1053, 0.0, zero_stack, 1.0, int_stack+1353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5820,int_stack+5712,int_stack+5502, 0.0, zero_stack, 1.0, int_stack+2507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6418,int_stack+5820,int_stack+5586, 0.0, zero_stack, 1.0, int_stack+2591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4149,int_stack+1134,int_stack+1089, 0.0, zero_stack, 1.0, int_stack+1425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+5439,int_stack+4149,int_stack+5712, 0.0, zero_stack, 1.0, int_stack+2717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+735,int_stack+5439,int_stack+5820, 0.0, zero_stack, 1.0, int_stack+2825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+5655,int_stack+735,int_stack+6418, 0.0, zero_stack, 1.0, int_stack+2993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6418,int_stack+1189,int_stack+1134, 0.0, zero_stack, 1.0, int_stack+1515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7369,int_stack+6418,int_stack+4149, 0.0, zero_stack, 1.0, int_stack+3203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7639,int_stack+7369,int_stack+5439, 0.0, zero_stack, 1.0, int_stack+3338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7999,int_stack+7639,int_stack+735, 0.0, zero_stack, 1.0, int_stack+3554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+735,int_stack+1325,int_stack+1276, 1.0, int_stack+1255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+798,int_stack+1389,int_stack+1325, 1.0, int_stack+1297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+882,int_stack+798,int_stack+735, 1.0, int_stack+2444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1008,int_stack+1470,int_stack+1389, 1.0, int_stack+1353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1116,int_stack+1008,int_stack+798, 1.0, int_stack+2507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+5439,int_stack+1116,int_stack+882, 1.0, int_stack+2591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4149,int_stack+1570,int_stack+1470, 1.0, int_stack+1425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6418,int_stack+4149,int_stack+1008, 1.0, int_stack+2717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2444,int_stack+6418,int_stack+1116, 1.0, int_stack+2825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+735,int_stack+2444,int_stack+5439, 1.0, int_stack+2993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+5439,int_stack+1625,int_stack+1570, 1.0, int_stack+1515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2724,int_stack+5439,int_stack+4149, 1.0, int_stack+3203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1050,int_stack+2724,int_stack+6418, 1.0, int_stack+3338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2724,int_stack+1050,int_stack+2444, 1.0, int_stack+3554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2444,int_stack+1712,int_stack+1691,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2507,int_stack+1740,int_stack+1712,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2591,int_stack+2507,int_stack+2444,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1050,int_stack+1776,int_stack+1740,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1158,int_stack+1050,int_stack+2507,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1326,int_stack+1158,int_stack+2591,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+4149,int_stack+1821,int_stack+1776,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6418,int_stack+4149,int_stack+1050,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2444,int_stack+6418,int_stack+1158,1);
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3144,int_stack+2444,int_stack+1326,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1050,int_stack+1876,int_stack+1821,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1215,int_stack+1050,int_stack+4149,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1485,int_stack+1215,int_stack+6418,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1050,int_stack+1485,int_stack+2444,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2444,int_stack+1963,int_stack+1942,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2507,int_stack+1991,int_stack+1963,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2591,int_stack+2507,int_stack+2444,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6418,int_stack+2027,int_stack+1991,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1470,int_stack+6418,int_stack+2507,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1638,int_stack+1470,int_stack+2591,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+4149,int_stack+2072,int_stack+2027,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5439,int_stack+4149,int_stack+6418,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2444,int_stack+5439,int_stack+1470,1);
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3459,int_stack+2444,int_stack+1638,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1470,int_stack+2127,int_stack+2072,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1635,int_stack+1470,int_stack+4149,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+7369,int_stack+1635,int_stack+5439,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1470,int_stack+7369,int_stack+2444,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2444,int_stack+2214,int_stack+2193,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2507,int_stack+2242,int_stack+2214,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2591,int_stack+2507,int_stack+2444,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+7369,int_stack+2278,int_stack+2242,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+7477,int_stack+7369,int_stack+2507,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+7645,int_stack+7477,int_stack+2591,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+4149,int_stack+2323,int_stack+2278,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5439,int_stack+4149,int_stack+7369,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2444,int_stack+5439,int_stack+7477,1);
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1890,int_stack+2444,int_stack+7645,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+7369,int_stack+2378,int_stack+2323,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+7534,int_stack+7369,int_stack+4149,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+8419,int_stack+7534,int_stack+5439,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+7369,int_stack+8419,int_stack+2444,1);
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+8419,int_stack+4599,int_stack+4284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3834,1);
     Libderiv->ABCD[11] = int_stack + 8419;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4149,int_stack+5019,int_stack+6103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3834, 0.0, zero_stack,1);
     Libderiv->ABCD[10] = int_stack + 4149;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4590,int_stack+6949,int_stack+6634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3834, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[9] = int_stack + 4590;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+5031,int_stack+315,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[8] = int_stack + 5031;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+0,int_stack+7999,int_stack+5655, 0.0, zero_stack, 1.0, int_stack+3834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[7] = int_stack + 0;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+5472,int_stack+2724,int_stack+735, 1.0, int_stack+3834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[6] = int_stack + 5472;
 /*--- compute (00|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+441,int_stack+1050,int_stack+3144,1);
     Libderiv->ABCD[2] = int_stack + 441;
 /*--- compute (00|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+882,int_stack+1470,int_stack+3459,1);
     Libderiv->ABCD[1] = int_stack + 882;
 /*--- compute (00|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1323,int_stack+7369,int_stack+1890,1);
     Libderiv->ABCD[0] = int_stack + 1323;

}
