/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_00if(Libderiv_t *, prim_data *);

  /* Computes derivatives of (00|if) integrals */

void d1hrr_order_00if(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[0][6][11] = int_stack + 0;
 Libderiv->deriv_classes[0][7][11] = int_stack + 28;
 Libderiv->deriv_classes[0][8][11] = int_stack + 64;
 Libderiv->deriv_classes[0][9][11] = int_stack + 109;
 Libderiv->deriv_classes[0][6][10] = int_stack + 164;
 Libderiv->deriv_classes[0][7][10] = int_stack + 192;
 Libderiv->deriv_classes[0][8][10] = int_stack + 228;
 Libderiv->deriv_classes[0][9][10] = int_stack + 273;
 Libderiv->deriv_classes[0][6][9] = int_stack + 328;
 Libderiv->deriv_classes[0][7][9] = int_stack + 356;
 Libderiv->deriv_classes[0][8][9] = int_stack + 392;
 Libderiv->deriv_classes[0][9][9] = int_stack + 437;
 Libderiv->deriv_classes[0][6][8] = int_stack + 492;
 Libderiv->deriv_classes[0][7][8] = int_stack + 520;
 Libderiv->deriv_classes[0][8][8] = int_stack + 556;
 Libderiv->deriv_classes[0][9][8] = int_stack + 601;
 Libderiv->deriv_classes[0][6][7] = int_stack + 656;
 Libderiv->deriv_classes[0][7][7] = int_stack + 684;
 Libderiv->deriv_classes[0][8][7] = int_stack + 720;
 Libderiv->deriv_classes[0][9][7] = int_stack + 765;
 Libderiv->dvrr_classes[0][6] = int_stack + 820;
 Libderiv->deriv_classes[0][6][6] = int_stack + 848;
 Libderiv->dvrr_classes[0][7] = int_stack + 876;
 Libderiv->deriv_classes[0][7][6] = int_stack + 912;
 Libderiv->dvrr_classes[0][8] = int_stack + 948;
 Libderiv->deriv_classes[0][8][6] = int_stack + 993;
 Libderiv->deriv_classes[0][9][6] = int_stack + 1038;
 Libderiv->deriv_classes[0][6][2] = int_stack + 1093;
 Libderiv->deriv_classes[0][7][2] = int_stack + 1121;
 Libderiv->deriv_classes[0][8][2] = int_stack + 1157;
 Libderiv->deriv_classes[0][9][2] = int_stack + 1202;
 Libderiv->deriv_classes[0][6][1] = int_stack + 1257;
 Libderiv->deriv_classes[0][7][1] = int_stack + 1285;
 Libderiv->deriv_classes[0][8][1] = int_stack + 1321;
 Libderiv->deriv_classes[0][9][1] = int_stack + 1366;
 Libderiv->deriv_classes[0][6][0] = int_stack + 1421;
 Libderiv->deriv_classes[0][7][0] = int_stack + 1449;
 Libderiv->deriv_classes[0][8][0] = int_stack + 1485;
 Libderiv->deriv_classes[0][9][0] = int_stack + 1530;
 memset(int_stack,0,12680);

 Libderiv->dvrr_stack = int_stack + 4448;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_00if(Libderiv, Data);
   Data++;
 }

 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1585,int_stack+876,int_stack+820,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1669,int_stack+948,int_stack+876,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1777,int_stack+1669,int_stack+1585,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1945,int_stack+28,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+820,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2029,int_stack+64,int_stack+28, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+876,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2137,int_stack+2029,int_stack+1945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1585,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2305,int_stack+109,int_stack+64, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+948,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2440,int_stack+2305,int_stack+2029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1669,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2305,int_stack+192,int_stack+164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+820, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1945,int_stack+228,int_stack+192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+876, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+1945,int_stack+2305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1585, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2305,int_stack+273,int_stack+228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+948, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2656,int_stack+2305,int_stack+1945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1669, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1945,int_stack+356,int_stack+328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+820, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2029,int_stack+392,int_stack+356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+876, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+168,int_stack+2029,int_stack+1945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1585, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2305,int_stack+437,int_stack+392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+948, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2872,int_stack+2305,int_stack+2029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1669, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2305,int_stack+520,int_stack+492, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1945,int_stack+556,int_stack+520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+336,int_stack+1945,int_stack+2305, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2305,int_stack+601,int_stack+556, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3088,int_stack+2305,int_stack+1945, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1945,int_stack+684,int_stack+656, 0.0, zero_stack, 1.0, int_stack+820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2029,int_stack+720,int_stack+684, 0.0, zero_stack, 1.0, int_stack+876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+504,int_stack+2029,int_stack+1945, 0.0, zero_stack, 1.0, int_stack+1585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2305,int_stack+765,int_stack+720, 0.0, zero_stack, 1.0, int_stack+948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3304,int_stack+2305,int_stack+2029, 0.0, zero_stack, 1.0, int_stack+1669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2305,int_stack+912,int_stack+848, 1.0, int_stack+820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1945,int_stack+993,int_stack+912, 1.0, int_stack+876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+672,int_stack+1945,int_stack+2305, 1.0, int_stack+1585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2305,int_stack+1038,int_stack+993, 1.0, int_stack+948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+840,int_stack+2305,int_stack+1945, 1.0, int_stack+1669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1945,int_stack+1121,int_stack+1093,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2029,int_stack+1157,int_stack+1121,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1585,int_stack+2029,int_stack+1945,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2305,int_stack+1202,int_stack+1157,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3520,int_stack+2305,int_stack+2029,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2305,int_stack+1285,int_stack+1257,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1945,int_stack+1321,int_stack+1285,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1056,int_stack+1945,int_stack+2305,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2305,int_stack+1366,int_stack+1321,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3736,int_stack+2305,int_stack+1945,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1945,int_stack+1449,int_stack+1421,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2029,int_stack+1485,int_stack+1449,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1224,int_stack+2029,int_stack+1945,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2305,int_stack+1530,int_stack+1485,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3952,int_stack+2305,int_stack+2029,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4168,int_stack+2440,int_stack+2137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1777,1);
     Libderiv->ABCD[11] = int_stack + 4168;
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1945,int_stack+2656,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1777, 0.0, zero_stack,1);
     Libderiv->ABCD[10] = int_stack + 1945;
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2225,int_stack+2872,int_stack+168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1777, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[9] = int_stack + 2225;
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+3088,int_stack+336, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2505,int_stack+3304,int_stack+504, 0.0, zero_stack, 1.0, int_stack+1777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[7] = int_stack + 2505;
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+280,int_stack+840,int_stack+672, 1.0, int_stack+1777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[6] = int_stack + 280;
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+560,int_stack+3520,int_stack+1585,1);
     Libderiv->ABCD[2] = int_stack + 560;
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2785,int_stack+3736,int_stack+1056,1);
     Libderiv->ABCD[1] = int_stack + 2785;
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+840,int_stack+3952,int_stack+1224,1);
     Libderiv->ABCD[0] = int_stack + 840;

}
