/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_00ih(Libderiv_t *, prim_data *);

  /* Computes derivatives of (00|ih) integrals */

void d1hrr_order_00ih(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[0][6][11] = int_stack + 0;
 Libderiv->deriv_classes[0][7][11] = int_stack + 28;
 Libderiv->deriv_classes[0][8][11] = int_stack + 64;
 Libderiv->deriv_classes[0][9][11] = int_stack + 109;
 Libderiv->deriv_classes[0][10][11] = int_stack + 164;
 Libderiv->deriv_classes[0][11][11] = int_stack + 230;
 Libderiv->deriv_classes[0][6][10] = int_stack + 308;
 Libderiv->deriv_classes[0][7][10] = int_stack + 336;
 Libderiv->deriv_classes[0][8][10] = int_stack + 372;
 Libderiv->deriv_classes[0][9][10] = int_stack + 417;
 Libderiv->deriv_classes[0][10][10] = int_stack + 472;
 Libderiv->deriv_classes[0][11][10] = int_stack + 538;
 Libderiv->deriv_classes[0][6][9] = int_stack + 616;
 Libderiv->deriv_classes[0][7][9] = int_stack + 644;
 Libderiv->deriv_classes[0][8][9] = int_stack + 680;
 Libderiv->deriv_classes[0][9][9] = int_stack + 725;
 Libderiv->deriv_classes[0][10][9] = int_stack + 780;
 Libderiv->deriv_classes[0][11][9] = int_stack + 846;
 Libderiv->deriv_classes[0][6][8] = int_stack + 924;
 Libderiv->deriv_classes[0][7][8] = int_stack + 952;
 Libderiv->deriv_classes[0][8][8] = int_stack + 988;
 Libderiv->deriv_classes[0][9][8] = int_stack + 1033;
 Libderiv->deriv_classes[0][10][8] = int_stack + 1088;
 Libderiv->deriv_classes[0][11][8] = int_stack + 1154;
 Libderiv->deriv_classes[0][6][7] = int_stack + 1232;
 Libderiv->deriv_classes[0][7][7] = int_stack + 1260;
 Libderiv->deriv_classes[0][8][7] = int_stack + 1296;
 Libderiv->deriv_classes[0][9][7] = int_stack + 1341;
 Libderiv->deriv_classes[0][10][7] = int_stack + 1396;
 Libderiv->deriv_classes[0][11][7] = int_stack + 1462;
 Libderiv->dvrr_classes[0][6] = int_stack + 1540;
 Libderiv->deriv_classes[0][6][6] = int_stack + 1568;
 Libderiv->dvrr_classes[0][7] = int_stack + 1596;
 Libderiv->deriv_classes[0][7][6] = int_stack + 1632;
 Libderiv->dvrr_classes[0][8] = int_stack + 1668;
 Libderiv->deriv_classes[0][8][6] = int_stack + 1713;
 Libderiv->dvrr_classes[0][9] = int_stack + 1758;
 Libderiv->deriv_classes[0][9][6] = int_stack + 1813;
 Libderiv->dvrr_classes[0][10] = int_stack + 1868;
 Libderiv->deriv_classes[0][10][6] = int_stack + 1934;
 Libderiv->deriv_classes[0][11][6] = int_stack + 2000;
 Libderiv->deriv_classes[0][6][2] = int_stack + 2078;
 Libderiv->deriv_classes[0][7][2] = int_stack + 2106;
 Libderiv->deriv_classes[0][8][2] = int_stack + 2142;
 Libderiv->deriv_classes[0][9][2] = int_stack + 2187;
 Libderiv->deriv_classes[0][10][2] = int_stack + 2242;
 Libderiv->deriv_classes[0][11][2] = int_stack + 2308;
 Libderiv->deriv_classes[0][6][1] = int_stack + 2386;
 Libderiv->deriv_classes[0][7][1] = int_stack + 2414;
 Libderiv->deriv_classes[0][8][1] = int_stack + 2450;
 Libderiv->deriv_classes[0][9][1] = int_stack + 2495;
 Libderiv->deriv_classes[0][10][1] = int_stack + 2550;
 Libderiv->deriv_classes[0][11][1] = int_stack + 2616;
 Libderiv->deriv_classes[0][6][0] = int_stack + 2694;
 Libderiv->deriv_classes[0][7][0] = int_stack + 2722;
 Libderiv->deriv_classes[0][8][0] = int_stack + 2758;
 Libderiv->deriv_classes[0][9][0] = int_stack + 2803;
 Libderiv->deriv_classes[0][10][0] = int_stack + 2858;
 Libderiv->deriv_classes[0][11][0] = int_stack + 2924;
 memset(int_stack,0,24016);

 Libderiv->dvrr_stack = int_stack + 12021;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_00ih(Libderiv, Data);
   Data++;
 }

 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3002,int_stack+1596,int_stack+1540,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3086,int_stack+1668,int_stack+1596,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3194,int_stack+3086,int_stack+3002,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3362,int_stack+1758,int_stack+1668,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3497,int_stack+3362,int_stack+3086,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+3713,int_stack+3497,int_stack+3194,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+3993,int_stack+1868,int_stack+1758,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+4158,int_stack+3993,int_stack+3362,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+4428,int_stack+4158,int_stack+3497,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+4788,int_stack+4428,int_stack+3713,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5208,int_stack+28,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1540,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5292,int_stack+64,int_stack+28, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1596,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5400,int_stack+5292,int_stack+5208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3002,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5568,int_stack+109,int_stack+64, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1668,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+5703,int_stack+5568,int_stack+5292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3086,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+5919,int_stack+5703,int_stack+5400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3194,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+5208,int_stack+164,int_stack+109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1758,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6199,int_stack+5208,int_stack+5568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3362,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6469,int_stack+6199,int_stack+5703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3497,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+5373,int_stack+6469,int_stack+5919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3713,1);
 /*--- compute (00|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+5793,int_stack+230,int_stack+164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1868,1);
 /*--- compute (00|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+6829,int_stack+5793,int_stack+5208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3993,1);
 /*--- compute (00|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+7159,int_stack+6829,int_stack+6199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4158,1);
 /*--- compute (00|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+5793,int_stack+7159,int_stack+6469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4428,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5208,int_stack+336,int_stack+308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1540, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6333,int_stack+372,int_stack+336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1596, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6441,int_stack+6333,int_stack+5208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3002, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5208,int_stack+417,int_stack+372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1668, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6609,int_stack+5208,int_stack+6333, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3086, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6825,int_stack+6609,int_stack+6441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3194, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6333,int_stack+472,int_stack+417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1758, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7105,int_stack+6333,int_stack+5208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3362, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7375,int_stack+7105,int_stack+6609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3497, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+7375,int_stack+6825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3713, 0.0, zero_stack,1);
 /*--- compute (00|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+6498,int_stack+538,int_stack+472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1868, 0.0, zero_stack,1);
 /*--- compute (00|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+6696,int_stack+6498,int_stack+6333, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3993, 0.0, zero_stack,1);
 /*--- compute (00|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+7735,int_stack+6696,int_stack+7105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4158, 0.0, zero_stack,1);
 /*--- compute (00|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+6333,int_stack+7735,int_stack+7375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4428, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6873,int_stack+644,int_stack+616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1540, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6957,int_stack+680,int_stack+644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1596, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7065,int_stack+6957,int_stack+6873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3002, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7233,int_stack+725,int_stack+680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1668, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7368,int_stack+7233,int_stack+6957, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3086, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7584,int_stack+7368,int_stack+7065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3194, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+5208,int_stack+780,int_stack+725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1758, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6873,int_stack+5208,int_stack+7233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3362, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+420,int_stack+6873,int_stack+7368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3497, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7143,int_stack+420,int_stack+7584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3713, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+7563,int_stack+846,int_stack+780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1868, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+7761,int_stack+7563,int_stack+5208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3993, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+8091,int_stack+7761,int_stack+6873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4158, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+8541,int_stack+8091,int_stack+420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4428, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+420,int_stack+952,int_stack+924, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504,int_stack+988,int_stack+952, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+612,int_stack+504,int_stack+420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+780,int_stack+1033,int_stack+988, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6873,int_stack+780,int_stack+504, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7563,int_stack+6873,int_stack+612, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+5208,int_stack+1088,int_stack+1033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+420,int_stack+5208,int_stack+780, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+690,int_stack+420,int_stack+6873, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7843,int_stack+690,int_stack+7563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+7563,int_stack+1154,int_stack+1088, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+9081,int_stack+7563,int_stack+5208, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+9411,int_stack+9081,int_stack+420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+9861,int_stack+9411,int_stack+690, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+420,int_stack+1260,int_stack+1232, 0.0, zero_stack, 1.0, int_stack+1540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504,int_stack+1296,int_stack+1260, 0.0, zero_stack, 1.0, int_stack+1596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+612,int_stack+504,int_stack+420, 0.0, zero_stack, 1.0, int_stack+3002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+780,int_stack+1341,int_stack+1296, 0.0, zero_stack, 1.0, int_stack+1668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+915,int_stack+780,int_stack+504, 0.0, zero_stack, 1.0, int_stack+3086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7563,int_stack+915,int_stack+612, 0.0, zero_stack, 1.0, int_stack+3194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+5208,int_stack+1396,int_stack+1341, 0.0, zero_stack, 1.0, int_stack+1758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6873,int_stack+5208,int_stack+780, 0.0, zero_stack, 1.0, int_stack+3362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+420,int_stack+6873,int_stack+915, 0.0, zero_stack, 1.0, int_stack+3497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+780,int_stack+420,int_stack+7563, 0.0, zero_stack, 1.0, int_stack+3713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+7563,int_stack+1462,int_stack+1396, 0.0, zero_stack, 1.0, int_stack+1868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1200,int_stack+7563,int_stack+5208, 0.0, zero_stack, 1.0, int_stack+3993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+9081,int_stack+1200,int_stack+6873, 0.0, zero_stack, 1.0, int_stack+4158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+10401,int_stack+9081,int_stack+420, 0.0, zero_stack, 1.0, int_stack+4428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+420,int_stack+1632,int_stack+1568, 1.0, int_stack+1540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504,int_stack+1713,int_stack+1632, 1.0, int_stack+1596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+612,int_stack+504,int_stack+420, 1.0, int_stack+3002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9081,int_stack+1813,int_stack+1713, 1.0, int_stack+1668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+9216,int_stack+9081,int_stack+504, 1.0, int_stack+3086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7563,int_stack+9216,int_stack+612, 1.0, int_stack+3194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+5208,int_stack+1934,int_stack+1813, 1.0, int_stack+1758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6873,int_stack+5208,int_stack+9081, 1.0, int_stack+3362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+420,int_stack+6873,int_stack+9216, 1.0, int_stack+3497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+9081,int_stack+420,int_stack+7563, 1.0, int_stack+3713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+7563,int_stack+2000,int_stack+1934, 1.0, int_stack+1868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+9501,int_stack+7563,int_stack+5208, 1.0, int_stack+3993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3002,int_stack+9501,int_stack+6873, 1.0, int_stack+4158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3452,int_stack+3002,int_stack+420, 1.0, int_stack+4428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+420,int_stack+2106,int_stack+2078,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+504,int_stack+2142,int_stack+2106,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+612,int_stack+504,int_stack+420,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3002,int_stack+2187,int_stack+2142,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3137,int_stack+3002,int_stack+504,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+7563,int_stack+3137,int_stack+612,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5208,int_stack+2242,int_stack+2187,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+6873,int_stack+5208,int_stack+3002,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+420,int_stack+6873,int_stack+3137,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+3002,int_stack+420,int_stack+7563,1);
 /*--- compute (00|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+7563,int_stack+2308,int_stack+2242,1);
 /*--- compute (00|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+9501,int_stack+7563,int_stack+5208,1);
 /*--- compute (00|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+3992,int_stack+9501,int_stack+6873,1);
 /*--- compute (00|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+1200,int_stack+3992,int_stack+420,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+420,int_stack+2414,int_stack+2386,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+504,int_stack+2450,int_stack+2414,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+612,int_stack+504,int_stack+420,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3992,int_stack+2495,int_stack+2450,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+4127,int_stack+3992,int_stack+504,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+7563,int_stack+4127,int_stack+612,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5208,int_stack+2550,int_stack+2495,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+6873,int_stack+5208,int_stack+3992,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+420,int_stack+6873,int_stack+4127,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+3992,int_stack+420,int_stack+7563,1);
 /*--- compute (00|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+7563,int_stack+2616,int_stack+2550,1);
 /*--- compute (00|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+4412,int_stack+7563,int_stack+5208,1);
 /*--- compute (00|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+1740,int_stack+4412,int_stack+6873,1);
 /*--- compute (00|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+10941,int_stack+1740,int_stack+420,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+420,int_stack+2722,int_stack+2694,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+504,int_stack+2758,int_stack+2722,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+612,int_stack+504,int_stack+420,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1740,int_stack+2803,int_stack+2758,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1875,int_stack+1740,int_stack+504,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+7563,int_stack+1875,int_stack+612,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5208,int_stack+2858,int_stack+2803,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+6873,int_stack+5208,int_stack+1740,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+420,int_stack+6873,int_stack+1875,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1740,int_stack+420,int_stack+7563,1);
 /*--- compute (00|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+7563,int_stack+2924,int_stack+2858,1);
 /*--- compute (00|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+2160,int_stack+7563,int_stack+5208,1);
 /*--- compute (00|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+2490,int_stack+2160,int_stack+6873,1);
 /*--- compute (00|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+11481,int_stack+2490,int_stack+420,1);
 /*--- compute (00|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+2160,int_stack+5793,int_stack+5373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4788,1);
     Libderiv->ABCD[11] = int_stack + 2160;
 /*--- compute (00|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+5208,int_stack+6333,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4788, 0.0, zero_stack,1);
     Libderiv->ABCD[10] = int_stack + 5208;
 /*--- compute (00|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+0,int_stack+8541,int_stack+7143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4788, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[9] = int_stack + 0;
 /*--- compute (00|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+5796,int_stack+9861,int_stack+7843, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[8] = int_stack + 5796;
 /*--- compute (00|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+6384,int_stack+10401,int_stack+780, 0.0, zero_stack, 1.0, int_stack+4788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[7] = int_stack + 6384;
 /*--- compute (00|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+588,int_stack+3452,int_stack+9081, 1.0, int_stack+4788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[6] = int_stack + 588;
 /*--- compute (00|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+6972,int_stack+1200,int_stack+3002,1);
     Libderiv->ABCD[2] = int_stack + 6972;
 /*--- compute (00|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+2748,int_stack+10941,int_stack+3992,1);
     Libderiv->ABCD[1] = int_stack + 2748;
 /*--- compute (00|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+3336,int_stack+11481,int_stack+1740,1);
     Libderiv->ABCD[0] = int_stack + 3336;

}
