/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_h0ig(Libderiv_t *, prim_data *);

  /* Computes derivatives of (h0|ig) integrals */

void d1hrr_order_h0ig(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][6][11] = int_stack + 0;
 Libderiv->deriv_classes[5][7][11] = int_stack + 588;
 Libderiv->deriv_classes[5][8][11] = int_stack + 1344;
 Libderiv->deriv_classes[5][9][11] = int_stack + 2289;
 Libderiv->deriv_classes[5][10][11] = int_stack + 3444;
 Libderiv->deriv_classes[5][6][10] = int_stack + 4830;
 Libderiv->deriv_classes[5][7][10] = int_stack + 5418;
 Libderiv->deriv_classes[5][8][10] = int_stack + 6174;
 Libderiv->deriv_classes[5][9][10] = int_stack + 7119;
 Libderiv->deriv_classes[5][10][10] = int_stack + 8274;
 Libderiv->deriv_classes[5][6][9] = int_stack + 9660;
 Libderiv->deriv_classes[5][7][9] = int_stack + 10248;
 Libderiv->deriv_classes[5][8][9] = int_stack + 11004;
 Libderiv->deriv_classes[5][9][9] = int_stack + 11949;
 Libderiv->deriv_classes[5][10][9] = int_stack + 13104;
 Libderiv->deriv_classes[5][6][8] = int_stack + 14490;
 Libderiv->deriv_classes[5][7][8] = int_stack + 15078;
 Libderiv->deriv_classes[5][8][8] = int_stack + 15834;
 Libderiv->deriv_classes[5][9][8] = int_stack + 16779;
 Libderiv->deriv_classes[5][10][8] = int_stack + 17934;
 Libderiv->deriv_classes[5][6][7] = int_stack + 19320;
 Libderiv->deriv_classes[5][7][7] = int_stack + 19908;
 Libderiv->deriv_classes[5][8][7] = int_stack + 20664;
 Libderiv->deriv_classes[5][9][7] = int_stack + 21609;
 Libderiv->deriv_classes[5][10][7] = int_stack + 22764;
 Libderiv->dvrr_classes[5][6] = int_stack + 24150;
 Libderiv->deriv_classes[5][6][6] = int_stack + 24738;
 Libderiv->dvrr_classes[5][7] = int_stack + 25326;
 Libderiv->deriv_classes[5][7][6] = int_stack + 26082;
 Libderiv->dvrr_classes[5][8] = int_stack + 26838;
 Libderiv->deriv_classes[5][8][6] = int_stack + 27783;
 Libderiv->dvrr_classes[5][9] = int_stack + 28728;
 Libderiv->deriv_classes[5][9][6] = int_stack + 29883;
 Libderiv->deriv_classes[5][10][6] = int_stack + 31038;
 Libderiv->deriv_classes[5][6][2] = int_stack + 32424;
 Libderiv->deriv_classes[5][7][2] = int_stack + 33012;
 Libderiv->deriv_classes[5][8][2] = int_stack + 33768;
 Libderiv->deriv_classes[5][9][2] = int_stack + 34713;
 Libderiv->deriv_classes[5][10][2] = int_stack + 35868;
 Libderiv->deriv_classes[5][6][1] = int_stack + 37254;
 Libderiv->deriv_classes[5][7][1] = int_stack + 37842;
 Libderiv->deriv_classes[5][8][1] = int_stack + 38598;
 Libderiv->deriv_classes[5][9][1] = int_stack + 39543;
 Libderiv->deriv_classes[5][10][1] = int_stack + 40698;
 Libderiv->deriv_classes[5][6][0] = int_stack + 42084;
 Libderiv->deriv_classes[5][7][0] = int_stack + 42672;
 Libderiv->deriv_classes[5][8][0] = int_stack + 43428;
 Libderiv->deriv_classes[5][9][0] = int_stack + 44373;
 Libderiv->deriv_classes[5][10][0] = int_stack + 45528;
 memset(int_stack,0,375312);

 Libderiv->dvrr_stack = int_stack + 169134;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_h0ig(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+46914,int_stack+25326,int_stack+24150,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+48678,int_stack+26838,int_stack+25326,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+50946,int_stack+48678,int_stack+46914,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+54474,int_stack+28728,int_stack+26838,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+57309,int_stack+54474,int_stack+48678,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+61845,int_stack+57309,int_stack+50946,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+67725,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24150,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+69489,int_stack+1344,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25326,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+71757,int_stack+69489,int_stack+67725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46914,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+75285,int_stack+2289,int_stack+1344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26838,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+78120,int_stack+75285,int_stack+69489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48678,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+82656,int_stack+78120,int_stack+71757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50946,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+67725,int_stack+3444,int_stack+2289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28728,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+88536,int_stack+67725,int_stack+75285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54474,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+67725,int_stack+88536,int_stack+78120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57309,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+88536,int_stack+5418,int_stack+4830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24150, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+90300,int_stack+6174,int_stack+5418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25326, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+75285,int_stack+90300,int_stack+88536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46914, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+78813,int_stack+7119,int_stack+6174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26838, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+78813,int_stack+90300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48678, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+88536,int_stack+0,int_stack+75285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50946, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+75285,int_stack+8274,int_stack+7119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28728, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+94416,int_stack+75285,int_stack+78813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54474, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+100086,int_stack+94416,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57309, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+10248,int_stack+9660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24150, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1764,int_stack+11004,int_stack+10248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25326, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4032,int_stack+1764,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46914, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7560,int_stack+11949,int_stack+11004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26838, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+94416,int_stack+7560,int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48678, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+75285,int_stack+94416,int_stack+4032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50946, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+13104,int_stack+11949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28728, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+107646,int_stack+0,int_stack+7560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54474, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+0,int_stack+107646,int_stack+94416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57309, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+94416,int_stack+15078,int_stack+14490, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+96180,int_stack+15834,int_stack+15078, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+107646,int_stack+96180,int_stack+94416, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7560,int_stack+16779,int_stack+15834, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+10395,int_stack+7560,int_stack+96180, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+111174,int_stack+10395,int_stack+107646, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+107646,int_stack+17934,int_stack+16779, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+94416,int_stack+107646,int_stack+7560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+117054,int_stack+94416,int_stack+10395, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+94416,int_stack+19908,int_stack+19320, 0.0, zero_stack, 1.0, int_stack+24150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+96180,int_stack+20664,int_stack+19908, 0.0, zero_stack, 1.0, int_stack+25326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+107646,int_stack+96180,int_stack+94416, 0.0, zero_stack, 1.0, int_stack+46914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7560,int_stack+21609,int_stack+20664, 0.0, zero_stack, 1.0, int_stack+26838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+10395,int_stack+7560,int_stack+96180, 0.0, zero_stack, 1.0, int_stack+48678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+14931,int_stack+10395,int_stack+107646, 0.0, zero_stack, 1.0, int_stack+50946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+107646,int_stack+22764,int_stack+21609, 0.0, zero_stack, 1.0, int_stack+28728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+94416,int_stack+107646,int_stack+7560, 0.0, zero_stack, 1.0, int_stack+54474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+124614,int_stack+94416,int_stack+10395, 0.0, zero_stack, 1.0, int_stack+57309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+94416,int_stack+26082,int_stack+24738, 1.0, int_stack+24150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+96180,int_stack+27783,int_stack+26082, 1.0, int_stack+25326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+107646,int_stack+96180,int_stack+94416, 1.0, int_stack+46914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7560,int_stack+29883,int_stack+27783, 1.0, int_stack+26838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+10395,int_stack+7560,int_stack+96180, 1.0, int_stack+48678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+20811,int_stack+10395,int_stack+107646, 1.0, int_stack+50946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+107646,int_stack+31038,int_stack+29883, 1.0, int_stack+28728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+94416,int_stack+107646,int_stack+7560, 1.0, int_stack+54474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+46914,int_stack+94416,int_stack+10395, 1.0, int_stack+57309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+94416,int_stack+33012,int_stack+32424,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+96180,int_stack+33768,int_stack+33012,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+107646,int_stack+96180,int_stack+94416,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+7560,int_stack+34713,int_stack+33768,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+10395,int_stack+7560,int_stack+96180,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+54474,int_stack+10395,int_stack+107646,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+107646,int_stack+35868,int_stack+34713,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+94416,int_stack+107646,int_stack+7560,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+26691,int_stack+94416,int_stack+10395,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+94416,int_stack+37842,int_stack+37254,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+96180,int_stack+38598,int_stack+37842,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+107646,int_stack+96180,int_stack+94416,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+7560,int_stack+39543,int_stack+38598,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+10395,int_stack+7560,int_stack+96180,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+132174,int_stack+10395,int_stack+107646,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+107646,int_stack+40698,int_stack+39543,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+94416,int_stack+107646,int_stack+7560,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+34251,int_stack+94416,int_stack+10395,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+94416,int_stack+42672,int_stack+42084,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+96180,int_stack+43428,int_stack+42672,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+107646,int_stack+96180,int_stack+94416,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+7560,int_stack+44373,int_stack+43428,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+10395,int_stack+7560,int_stack+96180,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+138054,int_stack+10395,int_stack+107646,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+107646,int_stack+45528,int_stack+44373,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+94416,int_stack+107646,int_stack+7560,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+143934,int_stack+94416,int_stack+10395,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+151494,int_stack+67725,int_stack+82656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+61845,21);
     Libderiv->ABCD[11] = int_stack + 151494;
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+160314,int_stack+100086,int_stack+88536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+61845, 0.0, zero_stack,21);
     Libderiv->ABCD[10] = int_stack + 160314;
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+81165,int_stack+0,int_stack+75285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+61845, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[9] = int_stack + 81165;
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+117054,int_stack+111174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+61845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+67725,int_stack+124614,int_stack+14931, 0.0, zero_stack, 1.0, int_stack+61845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[7] = int_stack + 67725;
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+8820,int_stack+46914,int_stack+20811, 1.0, int_stack+61845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[6] = int_stack + 8820;
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+17640,int_stack+26691,int_stack+54474,21);
     Libderiv->ABCD[2] = int_stack + 17640;
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+41811,int_stack+34251,int_stack+132174,21);
     Libderiv->ABCD[1] = int_stack + 41811;
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+26460,int_stack+143934,int_stack+138054,21);
     Libderiv->ABCD[0] = int_stack + 26460;

}
