/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_hdhh(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hd|hh) integrals */

void d1hrr_order_hdhh(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][5][11] = int_stack + 0;
 Libderiv->deriv_classes[5][6][11] = int_stack + 441;
 Libderiv->deriv_classes[5][7][11] = int_stack + 1029;
 Libderiv->deriv_classes[5][8][11] = int_stack + 1785;
 Libderiv->deriv_classes[5][9][11] = int_stack + 2730;
 Libderiv->deriv_classes[5][10][11] = int_stack + 3885;
 Libderiv->deriv_classes[6][5][11] = int_stack + 5271;
 Libderiv->deriv_classes[6][6][11] = int_stack + 5859;
 Libderiv->deriv_classes[6][7][11] = int_stack + 6643;
 Libderiv->deriv_classes[6][8][11] = int_stack + 7651;
 Libderiv->deriv_classes[6][9][11] = int_stack + 8911;
 Libderiv->deriv_classes[6][10][11] = int_stack + 10451;
 Libderiv->deriv_classes[7][5][11] = int_stack + 12299;
 Libderiv->deriv_classes[7][6][11] = int_stack + 13055;
 Libderiv->deriv_classes[7][7][11] = int_stack + 14063;
 Libderiv->deriv_classes[7][8][11] = int_stack + 15359;
 Libderiv->deriv_classes[7][9][11] = int_stack + 16979;
 Libderiv->deriv_classes[7][10][11] = int_stack + 18959;
 Libderiv->deriv_classes[5][5][10] = int_stack + 21335;
 Libderiv->deriv_classes[5][6][10] = int_stack + 21776;
 Libderiv->deriv_classes[5][7][10] = int_stack + 22364;
 Libderiv->deriv_classes[5][8][10] = int_stack + 23120;
 Libderiv->deriv_classes[5][9][10] = int_stack + 24065;
 Libderiv->deriv_classes[5][10][10] = int_stack + 25220;
 Libderiv->deriv_classes[6][5][10] = int_stack + 26606;
 Libderiv->deriv_classes[6][6][10] = int_stack + 27194;
 Libderiv->deriv_classes[6][7][10] = int_stack + 27978;
 Libderiv->deriv_classes[6][8][10] = int_stack + 28986;
 Libderiv->deriv_classes[6][9][10] = int_stack + 30246;
 Libderiv->deriv_classes[6][10][10] = int_stack + 31786;
 Libderiv->deriv_classes[7][5][10] = int_stack + 33634;
 Libderiv->deriv_classes[7][6][10] = int_stack + 34390;
 Libderiv->deriv_classes[7][7][10] = int_stack + 35398;
 Libderiv->deriv_classes[7][8][10] = int_stack + 36694;
 Libderiv->deriv_classes[7][9][10] = int_stack + 38314;
 Libderiv->deriv_classes[7][10][10] = int_stack + 40294;
 Libderiv->deriv_classes[5][5][9] = int_stack + 42670;
 Libderiv->deriv_classes[5][6][9] = int_stack + 43111;
 Libderiv->deriv_classes[5][7][9] = int_stack + 43699;
 Libderiv->deriv_classes[5][8][9] = int_stack + 44455;
 Libderiv->deriv_classes[5][9][9] = int_stack + 45400;
 Libderiv->deriv_classes[5][10][9] = int_stack + 46555;
 Libderiv->deriv_classes[6][5][9] = int_stack + 47941;
 Libderiv->deriv_classes[6][6][9] = int_stack + 48529;
 Libderiv->deriv_classes[6][7][9] = int_stack + 49313;
 Libderiv->deriv_classes[6][8][9] = int_stack + 50321;
 Libderiv->deriv_classes[6][9][9] = int_stack + 51581;
 Libderiv->deriv_classes[6][10][9] = int_stack + 53121;
 Libderiv->deriv_classes[7][5][9] = int_stack + 54969;
 Libderiv->deriv_classes[7][6][9] = int_stack + 55725;
 Libderiv->deriv_classes[7][7][9] = int_stack + 56733;
 Libderiv->deriv_classes[7][8][9] = int_stack + 58029;
 Libderiv->deriv_classes[7][9][9] = int_stack + 59649;
 Libderiv->deriv_classes[7][10][9] = int_stack + 61629;
 Libderiv->deriv_classes[5][5][8] = int_stack + 64005;
 Libderiv->deriv_classes[5][6][8] = int_stack + 64446;
 Libderiv->deriv_classes[5][7][8] = int_stack + 65034;
 Libderiv->deriv_classes[5][8][8] = int_stack + 65790;
 Libderiv->deriv_classes[5][9][8] = int_stack + 66735;
 Libderiv->deriv_classes[5][10][8] = int_stack + 67890;
 Libderiv->deriv_classes[6][5][8] = int_stack + 69276;
 Libderiv->deriv_classes[6][6][8] = int_stack + 69864;
 Libderiv->deriv_classes[6][7][8] = int_stack + 70648;
 Libderiv->deriv_classes[6][8][8] = int_stack + 71656;
 Libderiv->deriv_classes[6][9][8] = int_stack + 72916;
 Libderiv->deriv_classes[6][10][8] = int_stack + 74456;
 Libderiv->deriv_classes[7][5][8] = int_stack + 76304;
 Libderiv->deriv_classes[7][6][8] = int_stack + 77060;
 Libderiv->deriv_classes[7][7][8] = int_stack + 78068;
 Libderiv->deriv_classes[7][8][8] = int_stack + 79364;
 Libderiv->deriv_classes[7][9][8] = int_stack + 80984;
 Libderiv->deriv_classes[7][10][8] = int_stack + 82964;
 Libderiv->deriv_classes[5][5][7] = int_stack + 85340;
 Libderiv->deriv_classes[5][6][7] = int_stack + 85781;
 Libderiv->deriv_classes[5][7][7] = int_stack + 86369;
 Libderiv->deriv_classes[5][8][7] = int_stack + 87125;
 Libderiv->deriv_classes[5][9][7] = int_stack + 88070;
 Libderiv->deriv_classes[5][10][7] = int_stack + 89225;
 Libderiv->deriv_classes[6][5][7] = int_stack + 90611;
 Libderiv->deriv_classes[6][6][7] = int_stack + 91199;
 Libderiv->deriv_classes[6][7][7] = int_stack + 91983;
 Libderiv->deriv_classes[6][8][7] = int_stack + 92991;
 Libderiv->deriv_classes[6][9][7] = int_stack + 94251;
 Libderiv->deriv_classes[6][10][7] = int_stack + 95791;
 Libderiv->deriv_classes[7][5][7] = int_stack + 97639;
 Libderiv->deriv_classes[7][6][7] = int_stack + 98395;
 Libderiv->deriv_classes[7][7][7] = int_stack + 99403;
 Libderiv->deriv_classes[7][8][7] = int_stack + 100699;
 Libderiv->deriv_classes[7][9][7] = int_stack + 102319;
 Libderiv->deriv_classes[7][10][7] = int_stack + 104299;
 Libderiv->deriv_classes[5][5][6] = int_stack + 106675;
 Libderiv->deriv_classes[5][6][6] = int_stack + 107116;
 Libderiv->deriv_classes[5][7][6] = int_stack + 107704;
 Libderiv->deriv_classes[5][8][6] = int_stack + 108460;
 Libderiv->deriv_classes[5][9][6] = int_stack + 109405;
 Libderiv->deriv_classes[5][10][6] = int_stack + 110560;
 Libderiv->deriv_classes[6][5][6] = int_stack + 111946;
 Libderiv->deriv_classes[6][6][6] = int_stack + 112534;
 Libderiv->deriv_classes[6][7][6] = int_stack + 113318;
 Libderiv->deriv_classes[6][8][6] = int_stack + 114326;
 Libderiv->deriv_classes[6][9][6] = int_stack + 115586;
 Libderiv->deriv_classes[6][10][6] = int_stack + 117126;
 Libderiv->dvrr_classes[7][5] = int_stack + 118974;
 Libderiv->deriv_classes[7][5][6] = int_stack + 119730;
 Libderiv->dvrr_classes[7][6] = int_stack + 120486;
 Libderiv->deriv_classes[7][6][6] = int_stack + 121494;
 Libderiv->dvrr_classes[7][7] = int_stack + 122502;
 Libderiv->deriv_classes[7][7][6] = int_stack + 123798;
 Libderiv->dvrr_classes[7][8] = int_stack + 125094;
 Libderiv->deriv_classes[7][8][6] = int_stack + 126714;
 Libderiv->dvrr_classes[7][9] = int_stack + 128334;
 Libderiv->deriv_classes[7][9][6] = int_stack + 130314;
 Libderiv->deriv_classes[7][10][6] = int_stack + 132294;
 Libderiv->deriv_classes[5][5][2] = int_stack + 134670;
 Libderiv->deriv_classes[5][6][2] = int_stack + 135111;
 Libderiv->deriv_classes[5][7][2] = int_stack + 135699;
 Libderiv->deriv_classes[5][8][2] = int_stack + 136455;
 Libderiv->deriv_classes[5][9][2] = int_stack + 137400;
 Libderiv->deriv_classes[5][10][2] = int_stack + 138555;
 Libderiv->deriv_classes[6][5][2] = int_stack + 139941;
 Libderiv->deriv_classes[6][6][2] = int_stack + 140529;
 Libderiv->deriv_classes[6][7][2] = int_stack + 141313;
 Libderiv->deriv_classes[6][8][2] = int_stack + 142321;
 Libderiv->deriv_classes[6][9][2] = int_stack + 143581;
 Libderiv->deriv_classes[6][10][2] = int_stack + 145121;
 Libderiv->deriv_classes[7][5][2] = int_stack + 146969;
 Libderiv->deriv_classes[7][6][2] = int_stack + 147725;
 Libderiv->deriv_classes[7][7][2] = int_stack + 148733;
 Libderiv->deriv_classes[7][8][2] = int_stack + 150029;
 Libderiv->deriv_classes[7][9][2] = int_stack + 151649;
 Libderiv->deriv_classes[7][10][2] = int_stack + 153629;
 Libderiv->deriv_classes[5][5][1] = int_stack + 156005;
 Libderiv->deriv_classes[5][6][1] = int_stack + 156446;
 Libderiv->deriv_classes[5][7][1] = int_stack + 157034;
 Libderiv->deriv_classes[5][8][1] = int_stack + 157790;
 Libderiv->deriv_classes[5][9][1] = int_stack + 158735;
 Libderiv->deriv_classes[5][10][1] = int_stack + 159890;
 Libderiv->deriv_classes[6][5][1] = int_stack + 161276;
 Libderiv->deriv_classes[6][6][1] = int_stack + 161864;
 Libderiv->deriv_classes[6][7][1] = int_stack + 162648;
 Libderiv->deriv_classes[6][8][1] = int_stack + 163656;
 Libderiv->deriv_classes[6][9][1] = int_stack + 164916;
 Libderiv->deriv_classes[6][10][1] = int_stack + 166456;
 Libderiv->deriv_classes[7][5][1] = int_stack + 168304;
 Libderiv->deriv_classes[7][6][1] = int_stack + 169060;
 Libderiv->deriv_classes[7][7][1] = int_stack + 170068;
 Libderiv->deriv_classes[7][8][1] = int_stack + 171364;
 Libderiv->deriv_classes[7][9][1] = int_stack + 172984;
 Libderiv->deriv_classes[7][10][1] = int_stack + 174964;
 Libderiv->dvrr_classes[5][5] = int_stack + 177340;
 Libderiv->dvrr_classes[5][6] = int_stack + 177781;
 Libderiv->dvrr_classes[5][7] = int_stack + 178369;
 Libderiv->dvrr_classes[5][8] = int_stack + 179125;
 Libderiv->dvrr_classes[5][9] = int_stack + 180070;
 Libderiv->dvrr_classes[5][10] = int_stack + 181225;
 Libderiv->deriv_classes[5][5][0] = int_stack + 182611;
 Libderiv->deriv_classes[5][6][0] = int_stack + 183052;
 Libderiv->deriv_classes[5][7][0] = int_stack + 183640;
 Libderiv->deriv_classes[5][8][0] = int_stack + 184396;
 Libderiv->deriv_classes[5][9][0] = int_stack + 185341;
 Libderiv->deriv_classes[5][10][0] = int_stack + 186496;
 Libderiv->dvrr_classes[6][5] = int_stack + 187882;
 Libderiv->dvrr_classes[6][6] = int_stack + 188470;
 Libderiv->dvrr_classes[6][7] = int_stack + 189254;
 Libderiv->dvrr_classes[6][8] = int_stack + 190262;
 Libderiv->dvrr_classes[6][9] = int_stack + 191522;
 Libderiv->dvrr_classes[6][10] = int_stack + 193062;
 Libderiv->deriv_classes[6][5][0] = int_stack + 194910;
 Libderiv->deriv_classes[6][6][0] = int_stack + 195498;
 Libderiv->deriv_classes[6][7][0] = int_stack + 196282;
 Libderiv->deriv_classes[6][8][0] = int_stack + 197290;
 Libderiv->deriv_classes[6][9][0] = int_stack + 198550;
 Libderiv->deriv_classes[6][10][0] = int_stack + 200090;
 Libderiv->deriv_classes[7][5][0] = int_stack + 201938;
 Libderiv->deriv_classes[7][6][0] = int_stack + 202694;
 Libderiv->deriv_classes[7][7][0] = int_stack + 203702;
 Libderiv->deriv_classes[7][8][0] = int_stack + 204998;
 Libderiv->deriv_classes[7][9][0] = int_stack + 206618;
 Libderiv->deriv_classes[7][10][0] = int_stack + 208598;
 memset(int_stack,0,1687792);

 Libderiv->dvrr_stack = int_stack + 797904;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_hdhh(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+210974,int_stack+177781,int_stack+177340,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+212297,int_stack+178369,int_stack+177781,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+214061,int_stack+212297,int_stack+210974,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+216707,int_stack+179125,int_stack+178369,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+218975,int_stack+216707,int_stack+212297,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+222503,int_stack+218975,int_stack+214061,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+226913,int_stack+180070,int_stack+179125,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+229748,int_stack+226913,int_stack+216707,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+234284,int_stack+229748,int_stack+218975,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+240164,int_stack+234284,int_stack+222503,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+246779,int_stack+441,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177340,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+248102,int_stack+1029,int_stack+441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177781,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+249866,int_stack+248102,int_stack+246779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210974,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+252512,int_stack+1785,int_stack+1029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178369,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+254780,int_stack+252512,int_stack+248102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212297,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+258308,int_stack+254780,int_stack+249866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214061,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+246779,int_stack+2730,int_stack+1785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179125,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+262718,int_stack+246779,int_stack+252512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216707,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+267254,int_stack+262718,int_stack+254780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218975,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+249614,int_stack+267254,int_stack+258308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222503,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+256229,int_stack+3885,int_stack+2730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180070,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+273134,int_stack+256229,int_stack+246779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226913,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+278804,int_stack+273134,int_stack+262718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229748,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+256229,int_stack+278804,int_stack+267254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234284,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+265049,int_stack+256229,int_stack+249614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+240164,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+246779,int_stack+188470,int_stack+187882,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+248543,int_stack+189254,int_stack+188470,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+250895,int_stack+248543,int_stack+246779,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+254423,int_stack+190262,int_stack+189254,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+257447,int_stack+254423,int_stack+248543,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+274310,int_stack+257447,int_stack+250895,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+280190,int_stack+191522,int_stack+190262,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+283970,int_stack+280190,int_stack+254423,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+290018,int_stack+283970,int_stack+257447,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+297858,int_stack+290018,int_stack+274310,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+262151,int_stack+5859,int_stack+5271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187882,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+6643,int_stack+5859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188470,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2352,int_stack+0,int_stack+262151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246779,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+306678,int_stack+7651,int_stack+6643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189254,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+309702,int_stack+306678,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248543,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+314406,int_stack+309702,int_stack+2352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250895,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+8911,int_stack+7651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190262,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+320286,int_stack+0,int_stack+306678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254423,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+326334,int_stack+320286,int_stack+309702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257447,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+334174,int_stack+326334,int_stack+314406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274310,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+306678,int_stack+10451,int_stack+8911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191522,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+311298,int_stack+306678,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280190,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+0,int_stack+311298,int_stack+320286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283970,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+306678,int_stack+0,int_stack+326334, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+290018,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+318438,int_stack+306678,int_stack+334174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297858,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+330786,int_stack+318438,int_stack+265049,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+306678,int_stack+120486,int_stack+118974,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+308946,int_stack+122502,int_stack+120486,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+311970,int_stack+308946,int_stack+306678,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+125094,int_stack+122502,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3888,int_stack+0,int_stack+308946,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+262151,int_stack+3888,int_stack+311970,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+358569,int_stack+128334,int_stack+125094,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+363429,int_stack+358569,int_stack+0,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+371205,int_stack+363429,int_stack+3888,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+381285,int_stack+371205,int_stack+262151,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9936,int_stack+13055,int_stack+12299, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+118974,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+269711,int_stack+14063,int_stack+13055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+120486,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+392625,int_stack+269711,int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306678,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9936,int_stack+15359,int_stack+14063, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122502,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+397161,int_stack+9936,int_stack+269711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308946,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+403209,int_stack+397161,int_stack+392625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311970,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+410769,int_stack+16979,int_stack+15359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125094,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+415629,int_stack+410769,int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+423405,int_stack+415629,int_stack+397161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3888,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+433485,int_stack+423405,int_stack+403209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262151,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+9936,int_stack+18959,int_stack+16979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128334,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+392625,int_stack+9936,int_stack+410769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358569,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+402345,int_stack+392625,int_stack+415629, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363429,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+444825,int_stack+402345,int_stack+423405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371205,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+392625,int_stack+444825,int_stack+433485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+381285,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+408501,int_stack+392625,int_stack+318438,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+392625,int_stack+21776,int_stack+21335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177340, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+393948,int_stack+22364,int_stack+21776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177781, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+395712,int_stack+393948,int_stack+392625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210974, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+398358,int_stack+23120,int_stack+22364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178369, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+400626,int_stack+398358,int_stack+393948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212297, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+445545,int_stack+400626,int_stack+395712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214061, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+392625,int_stack+24065,int_stack+23120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179125, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+449955,int_stack+392625,int_stack+398358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216707, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+9936,int_stack+449955,int_stack+400626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218975, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+395460,int_stack+9936,int_stack+445545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222503, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+445545,int_stack+25220,int_stack+24065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180070, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+402075,int_stack+445545,int_stack+392625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226913, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+15816,int_stack+402075,int_stack+449955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229748, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+445545,int_stack+15816,int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234284, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+9936,int_stack+445545,int_stack+395460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+240164, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+445545,int_stack+27194,int_stack+26606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187882, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447309,int_stack+27978,int_stack+27194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188470, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+449661,int_stack+447309,int_stack+445545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246779, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+453189,int_stack+28986,int_stack+27978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189254, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19197,int_stack+453189,int_stack+447309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248543, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+392625,int_stack+19197,int_stack+449661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250895, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+445545,int_stack+30246,int_stack+28986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190262, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+23901,int_stack+445545,int_stack+453189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254423, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+449325,int_stack+23901,int_stack+19197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257447, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+398505,int_stack+449325,int_stack+392625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274310, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+392625,int_stack+31786,int_stack+30246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191522, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+316506,int_stack+392625,int_stack+445545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280190, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+457165,int_stack+316506,int_stack+23901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283970, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+316506,int_stack+457165,int_stack+449325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+290018, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+445545,int_stack+316506,int_stack+398505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297858, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+457893,int_stack+445545,int_stack+9936,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9936,int_stack+34390,int_stack+33634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+118974, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12204,int_stack+35398,int_stack+34390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+120486, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15228,int_stack+12204,int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306678, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+19764,int_stack+36694,int_stack+35398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122502, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+23652,int_stack+19764,int_stack+12204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308946, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+316506,int_stack+23652,int_stack+15228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311970, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9936,int_stack+38314,int_stack+36694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125094, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+29700,int_stack+9936,int_stack+19764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+392625,int_stack+29700,int_stack+23652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3888, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+14796,int_stack+392625,int_stack+316506, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262151, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+316506,int_stack+40294,int_stack+38314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128334, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+485676,int_stack+316506,int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358569, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+316506,int_stack+485676,int_stack+29700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363429, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+26136,int_stack+316506,int_stack+392625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371205, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+392625,int_stack+26136,int_stack+14796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+381285, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+485676,int_stack+392625,int_stack+445545,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+445545,int_stack+43111,int_stack+42670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177340, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+446868,int_stack+43699,int_stack+43111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177781, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+448632,int_stack+446868,int_stack+445545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210974, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+451278,int_stack+44455,int_stack+43699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178369, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+453546,int_stack+451278,int_stack+446868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212297, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+392625,int_stack+453546,int_stack+448632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214061, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+445545,int_stack+45400,int_stack+44455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179125, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+397035,int_stack+445545,int_stack+451278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216707, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+401571,int_stack+397035,int_stack+453546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218975, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+448380,int_stack+401571,int_stack+392625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222503, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+392625,int_stack+46555,int_stack+45400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180070, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+316506,int_stack+392625,int_stack+445545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226913, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+322176,int_stack+316506,int_stack+397035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229748, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+392625,int_stack+322176,int_stack+401571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234284, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+316506,int_stack+392625,int_stack+448380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+240164, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+392625,int_stack+48529,int_stack+47941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187882, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+394389,int_stack+49313,int_stack+48529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188470, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+396741,int_stack+394389,int_stack+392625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246779, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+400269,int_stack+50321,int_stack+49313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189254, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+403293,int_stack+400269,int_stack+394389, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248543, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+445545,int_stack+403293,int_stack+396741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250895, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+392625,int_stack+51581,int_stack+50321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190262, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+451425,int_stack+392625,int_stack+400269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254423, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+9936,int_stack+451425,int_stack+403293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257447, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+396405,int_stack+9936,int_stack+445545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274310, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+445545,int_stack+53121,int_stack+51581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191522, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+17776,int_stack+445545,int_stack+392625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280190, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+25336,int_stack+17776,int_stack+451425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283970, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+445545,int_stack+25336,int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+290018, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+9936,int_stack+445545,int_stack+396405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297858, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+22284,int_stack+9936,int_stack+316506,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+316506,int_stack+55725,int_stack+54969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+118974, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+318774,int_stack+56733,int_stack+55725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+120486, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+321798,int_stack+318774,int_stack+316506, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306678, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+326334,int_stack+58029,int_stack+56733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122502, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+445545,int_stack+326334,int_stack+318774, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308946, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+50067,int_stack+445545,int_stack+321798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311970, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+316506,int_stack+59649,int_stack+58029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125094, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+392625,int_stack+316506,int_stack+326334, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+522720,int_stack+392625,int_stack+445545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3888, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+445545,int_stack+522720,int_stack+50067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262151, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+50067,int_stack+61629,int_stack+59649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128334, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+532800,int_stack+50067,int_stack+316506, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358569, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+316506,int_stack+532800,int_stack+392625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363429, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+392625,int_stack+316506,int_stack+522720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371205, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+522720,int_stack+392625,int_stack+445545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+381285, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+538596,int_stack+522720,int_stack+9936,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9936,int_stack+64446,int_stack+64005, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+11259,int_stack+65034,int_stack+64446, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+13023,int_stack+11259,int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15669,int_stack+65790,int_stack+65034, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17937,int_stack+15669,int_stack+11259, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+522720,int_stack+17937,int_stack+13023, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9936,int_stack+66735,int_stack+65790, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+527130,int_stack+9936,int_stack+15669, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+531666,int_stack+527130,int_stack+17937, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+12771,int_stack+531666,int_stack+522720, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+522720,int_stack+67890,int_stack+66735, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+445545,int_stack+522720,int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+392625,int_stack+445545,int_stack+527130, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+445545,int_stack+392625,int_stack+531666, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+392625,int_stack+445545,int_stack+12771, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+240164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+445545,int_stack+69864,int_stack+69276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447309,int_stack+70648,int_stack+69864, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+449661,int_stack+447309,int_stack+445545, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+453189,int_stack+71656,int_stack+70648, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+401886,int_stack+453189,int_stack+447309, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9936,int_stack+401886,int_stack+449661, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+445545,int_stack+72916,int_stack+71656, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+15816,int_stack+445545,int_stack+453189, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+449325,int_stack+15816,int_stack+401886, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+522720,int_stack+449325,int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+9936,int_stack+74456,int_stack+72916, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+316506,int_stack+9936,int_stack+445545, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+50067,int_stack+316506,int_stack+15816, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+316506,int_stack+50067,int_stack+449325, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+290018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+445545,int_stack+316506,int_stack+522720, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+575640,int_stack+445545,int_stack+392625,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+392625,int_stack+77060,int_stack+76304, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+118974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+394893,int_stack+78068,int_stack+77060, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+120486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+397917,int_stack+394893,int_stack+392625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+402453,int_stack+79364,int_stack+78068, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+522720,int_stack+402453,int_stack+394893, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+528768,int_stack+522720,int_stack+397917, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+392625,int_stack+80984,int_stack+79364, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+316506,int_stack+392625,int_stack+402453, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+397485,int_stack+316506,int_stack+522720, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+50067,int_stack+397485,int_stack+528768, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+522720,int_stack+82964,int_stack+80984, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128334, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+528660,int_stack+522720,int_stack+392625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+61407,int_stack+528660,int_stack+316506, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+522720,int_stack+61407,int_stack+397485, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+392625,int_stack+522720,int_stack+50067, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+381285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+603423,int_stack+392625,int_stack+445545,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+445545,int_stack+85781,int_stack+85340, 0.0, zero_stack, 1.0, int_stack+177340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+446868,int_stack+86369,int_stack+85781, 0.0, zero_stack, 1.0, int_stack+177781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+448632,int_stack+446868,int_stack+445545, 0.0, zero_stack, 1.0, int_stack+210974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+451278,int_stack+87125,int_stack+86369, 0.0, zero_stack, 1.0, int_stack+178369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+453546,int_stack+451278,int_stack+446868, 0.0, zero_stack, 1.0, int_stack+212297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+392625,int_stack+453546,int_stack+448632, 0.0, zero_stack, 1.0, int_stack+214061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+445545,int_stack+88070,int_stack+87125, 0.0, zero_stack, 1.0, int_stack+179125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+397035,int_stack+445545,int_stack+451278, 0.0, zero_stack, 1.0, int_stack+216707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+401571,int_stack+397035,int_stack+453546, 0.0, zero_stack, 1.0, int_stack+218975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+448380,int_stack+401571,int_stack+392625, 0.0, zero_stack, 1.0, int_stack+222503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+392625,int_stack+89225,int_stack+88070, 0.0, zero_stack, 1.0, int_stack+180070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+50067,int_stack+392625,int_stack+445545, 0.0, zero_stack, 1.0, int_stack+226913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+55737,int_stack+50067,int_stack+397035, 0.0, zero_stack, 1.0, int_stack+229748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+392625,int_stack+55737,int_stack+401571, 0.0, zero_stack, 1.0, int_stack+234284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+50067,int_stack+392625,int_stack+448380, 0.0, zero_stack, 1.0, int_stack+240164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+392625,int_stack+91199,int_stack+90611, 0.0, zero_stack, 1.0, int_stack+187882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+394389,int_stack+91983,int_stack+91199, 0.0, zero_stack, 1.0, int_stack+188470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+396741,int_stack+394389,int_stack+392625, 0.0, zero_stack, 1.0, int_stack+246779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+400269,int_stack+92991,int_stack+91983, 0.0, zero_stack, 1.0, int_stack+189254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+403293,int_stack+400269,int_stack+394389, 0.0, zero_stack, 1.0, int_stack+248543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+59328,int_stack+403293,int_stack+396741, 0.0, zero_stack, 1.0, int_stack+250895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+392625,int_stack+94251,int_stack+92991, 0.0, zero_stack, 1.0, int_stack+190262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+65208,int_stack+392625,int_stack+400269, 0.0, zero_stack, 1.0, int_stack+254423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+71256,int_stack+65208,int_stack+403293, 0.0, zero_stack, 1.0, int_stack+257447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+396405,int_stack+71256,int_stack+59328, 0.0, zero_stack, 1.0, int_stack+274310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+59328,int_stack+95791,int_stack+94251, 0.0, zero_stack, 1.0, int_stack+191522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+79096,int_stack+59328,int_stack+392625, 0.0, zero_stack, 1.0, int_stack+280190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+86656,int_stack+79096,int_stack+65208, 0.0, zero_stack, 1.0, int_stack+283970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+59328,int_stack+86656,int_stack+71256, 0.0, zero_stack, 1.0, int_stack+290018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+445545,int_stack+59328,int_stack+396405, 0.0, zero_stack, 1.0, int_stack+297858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+59328,int_stack+445545,int_stack+50067,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+50067,int_stack+98395,int_stack+97639, 0.0, zero_stack, 1.0, int_stack+118974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+52335,int_stack+99403,int_stack+98395, 0.0, zero_stack, 1.0, int_stack+120486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+87111,int_stack+52335,int_stack+50067, 0.0, zero_stack, 1.0, int_stack+306678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+55359,int_stack+100699,int_stack+99403, 0.0, zero_stack, 1.0, int_stack+122502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+91647,int_stack+55359,int_stack+52335, 0.0, zero_stack, 1.0, int_stack+308946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+392625,int_stack+91647,int_stack+87111, 0.0, zero_stack, 1.0, int_stack+311970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+50067,int_stack+102319,int_stack+100699, 0.0, zero_stack, 1.0, int_stack+125094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+400185,int_stack+50067,int_stack+55359, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+522720,int_stack+400185,int_stack+91647, 0.0, zero_stack, 1.0, int_stack+3888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+87111,int_stack+522720,int_stack+392625, 0.0, zero_stack, 1.0, int_stack+262151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+392625,int_stack+104299,int_stack+102319, 0.0, zero_stack, 1.0, int_stack+128334, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+316506,int_stack+392625,int_stack+50067, 0.0, zero_stack, 1.0, int_stack+358569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+640467,int_stack+316506,int_stack+400185, 0.0, zero_stack, 1.0, int_stack+363429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+392625,int_stack+640467,int_stack+522720, 0.0, zero_stack, 1.0, int_stack+371205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+522720,int_stack+392625,int_stack+87111, 0.0, zero_stack, 1.0, int_stack+381285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+640467,int_stack+522720,int_stack+445545,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+445545,int_stack+107116,int_stack+106675, 1.0, int_stack+177340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+446868,int_stack+107704,int_stack+107116, 1.0, int_stack+177781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+448632,int_stack+446868,int_stack+445545, 1.0, int_stack+210974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+451278,int_stack+108460,int_stack+107704, 1.0, int_stack+178369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+453546,int_stack+451278,int_stack+446868, 1.0, int_stack+212297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+522720,int_stack+453546,int_stack+448632, 1.0, int_stack+214061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+210974,int_stack+109405,int_stack+108460, 1.0, int_stack+179125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+445545,int_stack+210974,int_stack+451278, 1.0, int_stack+216707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+527130,int_stack+445545,int_stack+453546, 1.0, int_stack+218975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+213809,int_stack+527130,int_stack+522720, 1.0, int_stack+222503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+522720,int_stack+110560,int_stack+109405, 1.0, int_stack+180070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+220424,int_stack+522720,int_stack+210974, 1.0, int_stack+226913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+450081,int_stack+220424,int_stack+445545, 1.0, int_stack+229748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+87111,int_stack+450081,int_stack+527130, 1.0, int_stack+234284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+50067,int_stack+87111,int_stack+213809, 1.0, int_stack+240164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+87111,int_stack+112534,int_stack+111946, 1.0, int_stack+187882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+88875,int_stack+113318,int_stack+112534, 1.0, int_stack+188470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+91227,int_stack+88875,int_stack+87111, 1.0, int_stack+246779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+94755,int_stack+114326,int_stack+113318, 1.0, int_stack+189254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+97779,int_stack+94755,int_stack+88875, 1.0, int_stack+248543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+102483,int_stack+97779,int_stack+91227, 1.0, int_stack+250895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+246779,int_stack+115586,int_stack+114326, 1.0, int_stack+190262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+87111,int_stack+246779,int_stack+94755, 1.0, int_stack+254423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+445545,int_stack+87111,int_stack+97779, 1.0, int_stack+257447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+250559,int_stack+445545,int_stack+102483, 1.0, int_stack+274310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+93159,int_stack+117126,int_stack+115586, 1.0, int_stack+191522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+97779,int_stack+93159,int_stack+246779, 1.0, int_stack+280190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+105339,int_stack+97779,int_stack+87111, 1.0, int_stack+283970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+87111,int_stack+105339,int_stack+445545, 1.0, int_stack+290018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+445545,int_stack+87111,int_stack+250559, 1.0, int_stack+297858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+87111,int_stack+445545,int_stack+50067,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+50067,int_stack+121494,int_stack+119730, 1.0, int_stack+118974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+52335,int_stack+123798,int_stack+121494, 1.0, int_stack+120486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+114894,int_stack+52335,int_stack+50067, 1.0, int_stack+306678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+55359,int_stack+126714,int_stack+123798, 1.0, int_stack+122502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+246779,int_stack+55359,int_stack+52335, 1.0, int_stack+308946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+252827,int_stack+246779,int_stack+114894, 1.0, int_stack+311970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+114894,int_stack+130314,int_stack+126714, 1.0, int_stack+125094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+119754,int_stack+114894,int_stack+55359, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+306678,int_stack+119754,int_stack+246779, 1.0, int_stack+3888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+0,int_stack+306678,int_stack+252827, 1.0, int_stack+262151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+246779,int_stack+132294,int_stack+130314, 1.0, int_stack+128334, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+252719,int_stack+246779,int_stack+114894, 1.0, int_stack+358569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+262439,int_stack+252719,int_stack+119754, 1.0, int_stack+363429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+114894,int_stack+262439,int_stack+306678, 1.0, int_stack+371205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+522720,int_stack+114894,int_stack+0, 1.0, int_stack+381285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+358569,int_stack+522720,int_stack+445545,441);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+445545,int_stack+181225,int_stack+180070,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+449010,int_stack+445545,int_stack+226913,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+522720,int_stack+449010,int_stack+229748,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+445545,int_stack+522720,int_stack+234284,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+50067,int_stack+445545,int_stack+240164,21);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+445545,int_stack+193062,int_stack+191522,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+450165,int_stack+445545,int_stack+280190,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+522720,int_stack+450165,int_stack+283970,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+445545,int_stack+522720,int_stack+290018,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+522720,int_stack+445545,int_stack+297858,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+210974,int_stack+522720,int_stack+50067,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+445545,int_stack+135111,int_stack+134670,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+446868,int_stack+135699,int_stack+135111,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+448632,int_stack+446868,int_stack+445545,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+451278,int_stack+136455,int_stack+135699,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+535068,int_stack+451278,int_stack+446868,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+535068,int_stack+448632,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+445545,int_stack+137400,int_stack+136455,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+4410,int_stack+445545,int_stack+451278,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+448380,int_stack+4410,int_stack+535068,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+8946,int_stack+448380,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+138555,int_stack+137400,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+15561,int_stack+0,int_stack+445545,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+114894,int_stack+15561,int_stack+4410,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+114894,int_stack+448380,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+114894,int_stack+0,int_stack+8946,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+140529,int_stack+139941,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1764,int_stack+141313,int_stack+140529,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+535068,int_stack+1764,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+4116,int_stack+142321,int_stack+141313,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+7140,int_stack+4116,int_stack+1764,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+11844,int_stack+7140,int_stack+535068,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+143581,int_stack+142321,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+124155,int_stack+0,int_stack+4116,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+130203,int_stack+124155,int_stack+7140,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+445545,int_stack+130203,int_stack+11844,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+3780,int_stack+145121,int_stack+143581,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+8400,int_stack+3780,int_stack+0,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+395613,int_stack+8400,int_stack+124155,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+395613,int_stack+130203,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+395613,int_stack+0,int_stack+445545,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+238757,int_stack+395613,int_stack+114894, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+114894,int_stack+147725,int_stack+146969,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+117162,int_stack+148733,int_stack+147725,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+120186,int_stack+117162,int_stack+114894,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+124722,int_stack+150029,int_stack+148733,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+128610,int_stack+124722,int_stack+117162,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+134658,int_stack+128610,int_stack+120186,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+114894,int_stack+151649,int_stack+150029,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+142218,int_stack+114894,int_stack+124722,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+445545,int_stack+142218,int_stack+128610,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+119754,int_stack+445545,int_stack+134658,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+131094,int_stack+153629,int_stack+151649,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+0,int_stack+131094,int_stack+114894,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+266540,int_stack+0,int_stack+142218,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+266540,int_stack+445545,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+266540,int_stack+0,int_stack+119754,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+282416,int_stack+266540,int_stack+395613, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+395613,int_stack+156446,int_stack+156005,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+396936,int_stack+157034,int_stack+156446,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+398700,int_stack+396936,int_stack+395613,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+401346,int_stack+157790,int_stack+157034,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+535068,int_stack+401346,int_stack+396936,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+403614,int_stack+535068,int_stack+398700,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+395613,int_stack+158735,int_stack+157790,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+266540,int_stack+395613,int_stack+401346,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+271076,int_stack+266540,int_stack+535068,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+0,int_stack+271076,int_stack+403614,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+535068,int_stack+159890,int_stack+158735,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+398448,int_stack+535068,int_stack+395613,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6615,int_stack+398448,int_stack+266540,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+395613,int_stack+6615,int_stack+271076,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+6615,int_stack+395613,int_stack+0,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+161864,int_stack+161276,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1764,int_stack+162648,int_stack+161864,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+535068,int_stack+1764,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+395613,int_stack+163656,int_stack+162648,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+398637,int_stack+395613,int_stack+1764,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+398637,int_stack+535068,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+403341,int_stack+164916,int_stack+163656,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+15876,int_stack+403341,int_stack+395613,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+266540,int_stack+15876,int_stack+398637,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+445545,int_stack+266540,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+166456,int_stack+164916,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+395613,int_stack+0,int_stack+403341,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+319460,int_stack+395613,int_stack+15876,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+395613,int_stack+319460,int_stack+266540,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+266540,int_stack+395613,int_stack+445545,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+114894,int_stack+266540,int_stack+6615, 0.0, zero_stack, 1.0, int_stack+50067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+445545,int_stack+169060,int_stack+168304,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+447813,int_stack+170068,int_stack+169060,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+450837,int_stack+447813,int_stack+445545,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+395613,int_stack+171364,int_stack+170068,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+399501,int_stack+395613,int_stack+447813,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+319460,int_stack+399501,int_stack+450837,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+445545,int_stack+172984,int_stack+171364,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+445545,int_stack+395613,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+7776,int_stack+0,int_stack+399501,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+395613,int_stack+7776,int_stack+319460,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+319460,int_stack+174964,int_stack+172984,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+142677,int_stack+319460,int_stack+445545,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+152397,int_stack+142677,int_stack+0,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+165357,int_stack+152397,int_stack+7776,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+0,int_stack+165357,int_stack+395613,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+142677,int_stack+0,int_stack+266540, 0.0, zero_stack, 1.0, int_stack+522720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+266540,int_stack+183052,int_stack+182611,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+267863,int_stack+183640,int_stack+183052,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+269627,int_stack+267863,int_stack+266540,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+272273,int_stack+184396,int_stack+183640,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+535068,int_stack+272273,int_stack+267863,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+274541,int_stack+535068,int_stack+269627,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+266540,int_stack+185341,int_stack+184396,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+266540,int_stack+272273,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+4536,int_stack+0,int_stack+535068,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+10416,int_stack+4536,int_stack+274541,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+535068,int_stack+186496,int_stack+185341,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+269375,int_stack+535068,int_stack+266540,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+395613,int_stack+269375,int_stack+0,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+266540,int_stack+395613,int_stack+4536,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+395613,int_stack+266540,int_stack+10416,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+266540,int_stack+195498,int_stack+194910,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+268304,int_stack+196282,int_stack+195498,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+535068,int_stack+268304,int_stack+266540,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+270656,int_stack+197290,int_stack+196282,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+273680,int_stack+270656,int_stack+268304,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+273680,int_stack+535068,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+266540,int_stack+198550,int_stack+197290,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5880,int_stack+266540,int_stack+270656,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+11928,int_stack+5880,int_stack+273680,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+270320,int_stack+11928,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+200090,int_stack+198550,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+179721,int_stack+0,int_stack+266540,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+187281,int_stack+179721,int_stack+5880,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+187281,int_stack+11928,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+445545,int_stack+0,int_stack+270320,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+677511,int_stack+445545,int_stack+395613, 1.0, int_stack+50067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+50067,int_stack+202694,int_stack+201938,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+52335,int_stack+203702,int_stack+202694,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+395613,int_stack+52335,int_stack+50067,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+55359,int_stack+204998,int_stack+203702,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+400149,int_stack+55359,int_stack+52335,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+400149,int_stack+395613,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+50067,int_stack+206618,int_stack+204998,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+7560,int_stack+50067,int_stack+55359,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+179721,int_stack+7560,int_stack+400149,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+395613,int_stack+179721,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+208598,int_stack+206618,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+189801,int_stack+0,int_stack+50067,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+266540,int_stack+189801,int_stack+7560,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+189801,int_stack+266540,int_stack+179721,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+266540,int_stack+189801,int_stack+395613,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+705294,int_stack+266540,int_stack+445545, 1.0, int_stack+522720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+742338,int_stack+408501,int_stack+330786,441);
     Libderiv->ABCD[11] = int_stack + 742338;
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+395613,int_stack+485676,int_stack+457893,441);
     Libderiv->ABCD[10] = int_stack + 395613;
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+451179,int_stack+538596,int_stack+22284,441);
     Libderiv->ABCD[9] = int_stack + 451179;
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+506745,int_stack+603423,int_stack+575640,441);
     Libderiv->ABCD[8] = int_stack + 506745;
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+562311,int_stack+640467,int_stack+59328,441);
     Libderiv->ABCD[7] = int_stack + 562311;
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+617877,int_stack+358569,int_stack+87111,441);
     Libderiv->ABCD[6] = int_stack + 617877;
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+0,int_stack+282416,int_stack+238757, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[2] = int_stack + 0;
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+238757,int_stack+142677,int_stack+114894, 0.0, zero_stack, 1.0, int_stack+210974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[1] = int_stack + 238757;
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+294323,int_stack+705294,int_stack+677511, 1.0, int_stack+210974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[0] = int_stack + 294323;

}
