/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_hpgg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hp|gg) integrals */

void d1hrr_order_hpgg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][4][11] = int_stack + 0;
 Libderiv->deriv_classes[5][5][11] = int_stack + 315;
 Libderiv->deriv_classes[5][6][11] = int_stack + 756;
 Libderiv->deriv_classes[5][7][11] = int_stack + 1344;
 Libderiv->deriv_classes[5][8][11] = int_stack + 2100;
 Libderiv->deriv_classes[6][4][11] = int_stack + 3045;
 Libderiv->deriv_classes[6][5][11] = int_stack + 3465;
 Libderiv->deriv_classes[6][6][11] = int_stack + 4053;
 Libderiv->deriv_classes[6][7][11] = int_stack + 4837;
 Libderiv->deriv_classes[6][8][11] = int_stack + 5845;
 Libderiv->deriv_classes[5][4][10] = int_stack + 7105;
 Libderiv->deriv_classes[5][5][10] = int_stack + 7420;
 Libderiv->deriv_classes[5][6][10] = int_stack + 7861;
 Libderiv->deriv_classes[5][7][10] = int_stack + 8449;
 Libderiv->deriv_classes[5][8][10] = int_stack + 9205;
 Libderiv->deriv_classes[6][4][10] = int_stack + 10150;
 Libderiv->deriv_classes[6][5][10] = int_stack + 10570;
 Libderiv->deriv_classes[6][6][10] = int_stack + 11158;
 Libderiv->deriv_classes[6][7][10] = int_stack + 11942;
 Libderiv->deriv_classes[6][8][10] = int_stack + 12950;
 Libderiv->deriv_classes[5][4][9] = int_stack + 14210;
 Libderiv->deriv_classes[5][5][9] = int_stack + 14525;
 Libderiv->deriv_classes[5][6][9] = int_stack + 14966;
 Libderiv->deriv_classes[5][7][9] = int_stack + 15554;
 Libderiv->deriv_classes[5][8][9] = int_stack + 16310;
 Libderiv->deriv_classes[6][4][9] = int_stack + 17255;
 Libderiv->deriv_classes[6][5][9] = int_stack + 17675;
 Libderiv->deriv_classes[6][6][9] = int_stack + 18263;
 Libderiv->deriv_classes[6][7][9] = int_stack + 19047;
 Libderiv->deriv_classes[6][8][9] = int_stack + 20055;
 Libderiv->deriv_classes[5][4][8] = int_stack + 21315;
 Libderiv->deriv_classes[5][5][8] = int_stack + 21630;
 Libderiv->deriv_classes[5][6][8] = int_stack + 22071;
 Libderiv->deriv_classes[5][7][8] = int_stack + 22659;
 Libderiv->deriv_classes[5][8][8] = int_stack + 23415;
 Libderiv->deriv_classes[6][4][8] = int_stack + 24360;
 Libderiv->deriv_classes[6][5][8] = int_stack + 24780;
 Libderiv->deriv_classes[6][6][8] = int_stack + 25368;
 Libderiv->deriv_classes[6][7][8] = int_stack + 26152;
 Libderiv->deriv_classes[6][8][8] = int_stack + 27160;
 Libderiv->deriv_classes[5][4][7] = int_stack + 28420;
 Libderiv->deriv_classes[5][5][7] = int_stack + 28735;
 Libderiv->deriv_classes[5][6][7] = int_stack + 29176;
 Libderiv->deriv_classes[5][7][7] = int_stack + 29764;
 Libderiv->deriv_classes[5][8][7] = int_stack + 30520;
 Libderiv->deriv_classes[6][4][7] = int_stack + 31465;
 Libderiv->deriv_classes[6][5][7] = int_stack + 31885;
 Libderiv->deriv_classes[6][6][7] = int_stack + 32473;
 Libderiv->deriv_classes[6][7][7] = int_stack + 33257;
 Libderiv->deriv_classes[6][8][7] = int_stack + 34265;
 Libderiv->deriv_classes[5][4][6] = int_stack + 35525;
 Libderiv->deriv_classes[5][5][6] = int_stack + 35840;
 Libderiv->deriv_classes[5][6][6] = int_stack + 36281;
 Libderiv->deriv_classes[5][7][6] = int_stack + 36869;
 Libderiv->deriv_classes[5][8][6] = int_stack + 37625;
 Libderiv->dvrr_classes[6][4] = int_stack + 38570;
 Libderiv->deriv_classes[6][4][6] = int_stack + 38990;
 Libderiv->dvrr_classes[6][5] = int_stack + 39410;
 Libderiv->deriv_classes[6][5][6] = int_stack + 39998;
 Libderiv->dvrr_classes[6][6] = int_stack + 40586;
 Libderiv->deriv_classes[6][6][6] = int_stack + 41370;
 Libderiv->dvrr_classes[6][7] = int_stack + 42154;
 Libderiv->deriv_classes[6][7][6] = int_stack + 43162;
 Libderiv->deriv_classes[6][8][6] = int_stack + 44170;
 Libderiv->deriv_classes[5][4][2] = int_stack + 45430;
 Libderiv->deriv_classes[5][5][2] = int_stack + 45745;
 Libderiv->deriv_classes[5][6][2] = int_stack + 46186;
 Libderiv->deriv_classes[5][7][2] = int_stack + 46774;
 Libderiv->deriv_classes[5][8][2] = int_stack + 47530;
 Libderiv->deriv_classes[6][4][2] = int_stack + 48475;
 Libderiv->deriv_classes[6][5][2] = int_stack + 48895;
 Libderiv->deriv_classes[6][6][2] = int_stack + 49483;
 Libderiv->deriv_classes[6][7][2] = int_stack + 50267;
 Libderiv->deriv_classes[6][8][2] = int_stack + 51275;
 Libderiv->deriv_classes[5][4][1] = int_stack + 52535;
 Libderiv->deriv_classes[5][5][1] = int_stack + 52850;
 Libderiv->deriv_classes[5][6][1] = int_stack + 53291;
 Libderiv->deriv_classes[5][7][1] = int_stack + 53879;
 Libderiv->deriv_classes[5][8][1] = int_stack + 54635;
 Libderiv->deriv_classes[6][4][1] = int_stack + 55580;
 Libderiv->deriv_classes[6][5][1] = int_stack + 56000;
 Libderiv->deriv_classes[6][6][1] = int_stack + 56588;
 Libderiv->deriv_classes[6][7][1] = int_stack + 57372;
 Libderiv->deriv_classes[6][8][1] = int_stack + 58380;
 Libderiv->dvrr_classes[5][4] = int_stack + 59640;
 Libderiv->dvrr_classes[5][5] = int_stack + 59955;
 Libderiv->dvrr_classes[5][6] = int_stack + 60396;
 Libderiv->dvrr_classes[5][7] = int_stack + 60984;
 Libderiv->dvrr_classes[5][8] = int_stack + 61740;
 Libderiv->deriv_classes[5][4][0] = int_stack + 62685;
 Libderiv->deriv_classes[5][5][0] = int_stack + 63000;
 Libderiv->deriv_classes[5][6][0] = int_stack + 63441;
 Libderiv->deriv_classes[5][7][0] = int_stack + 64029;
 Libderiv->deriv_classes[5][8][0] = int_stack + 64785;
 Libderiv->deriv_classes[6][4][0] = int_stack + 65730;
 Libderiv->deriv_classes[6][5][0] = int_stack + 66150;
 Libderiv->deriv_classes[6][6][0] = int_stack + 66738;
 Libderiv->deriv_classes[6][7][0] = int_stack + 67522;
 Libderiv->deriv_classes[6][8][0] = int_stack + 68530;
 memset(int_stack,0,558320);

 Libderiv->dvrr_stack = int_stack + 183589;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_hpgg(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+69790,int_stack+59955,int_stack+59640,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+70735,int_stack+60396,int_stack+59955,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+72058,int_stack+70735,int_stack+69790,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+73948,int_stack+60984,int_stack+60396,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+75712,int_stack+73948,int_stack+70735,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+78358,int_stack+75712,int_stack+72058,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+81508,int_stack+315,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59640,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82453,int_stack+756,int_stack+315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59955,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83776,int_stack+82453,int_stack+81508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69790,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+85666,int_stack+1344,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60396,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+87430,int_stack+85666,int_stack+82453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70735,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+90076,int_stack+87430,int_stack+83776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72058,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+81508,int_stack+2100,int_stack+1344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60984,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+93226,int_stack+81508,int_stack+85666, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73948,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+81508,int_stack+93226,int_stack+87430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75712,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+93226,int_stack+81508,int_stack+90076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78358,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+81508,int_stack+39410,int_stack+38570,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+82768,int_stack+40586,int_stack+39410,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+84532,int_stack+82768,int_stack+81508,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+87052,int_stack+42154,int_stack+40586,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+89404,int_stack+87052,int_stack+82768,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+97951,int_stack+89404,int_stack+84532,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+3465,int_stack+3045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38570,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1260,int_stack+4053,int_stack+3465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39410,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+102151,int_stack+1260,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81508,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104671,int_stack+4837,int_stack+4053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40586,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+107023,int_stack+104671,int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82768,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+0,int_stack+107023,int_stack+102151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84532,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+110551,int_stack+5845,int_stack+4837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42154,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+113575,int_stack+110551,int_stack+104671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87052,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+118279,int_stack+113575,int_stack+107023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89404,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+102151,int_stack+118279,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97951,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+7420,int_stack+7105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59640, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+945,int_stack+7861,int_stack+7420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59955, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2268,int_stack+945,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69790, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4158,int_stack+8449,int_stack+7861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60396, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+108451,int_stack+4158,int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70735, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+111097,int_stack+108451,int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72058, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+9205,int_stack+8449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60984, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5922,int_stack+0,int_stack+4158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73948, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+5922,int_stack+108451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75712, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+4410,int_stack+0,int_stack+111097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78358, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+10570,int_stack+10150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38570, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1260,int_stack+11158,int_stack+10570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39410, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+108451,int_stack+1260,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81508, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+110971,int_stack+11942,int_stack+11158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40586, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+113323,int_stack+110971,int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82768, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+0,int_stack+113323,int_stack+108451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84532, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+116851,int_stack+12950,int_stack+11942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42154, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+119875,int_stack+116851,int_stack+110971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87052, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+124579,int_stack+119875,int_stack+113323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89404, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+108451,int_stack+124579,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97951, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+14525,int_stack+14210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59640, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+945,int_stack+14966,int_stack+14525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59955, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2268,int_stack+945,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69790, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+114751,int_stack+15554,int_stack+14966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60396, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+116515,int_stack+114751,int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70735, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+119161,int_stack+116515,int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72058, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+16310,int_stack+15554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60984, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+122311,int_stack+0,int_stack+114751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73948, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+122311,int_stack+116515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75712, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+122311,int_stack+0,int_stack+119161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78358, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+17675,int_stack+17255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38570, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1260,int_stack+18263,int_stack+17675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39410, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+127036,int_stack+1260,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81508, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+114751,int_stack+19047,int_stack+18263, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40586, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+117103,int_stack+114751,int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82768, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+0,int_stack+117103,int_stack+127036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84532, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+127036,int_stack+20055,int_stack+19047, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42154, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9135,int_stack+127036,int_stack+114751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87052, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13839,int_stack+9135,int_stack+117103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89404, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+114751,int_stack+13839,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97951, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+21630,int_stack+21315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+945,int_stack+22071,int_stack+21630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2268,int_stack+945,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9135,int_stack+22659,int_stack+22071, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10899,int_stack+9135,int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+13545,int_stack+10899,int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72058, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+23415,int_stack+22659, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+16695,int_stack+0,int_stack+9135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+16695,int_stack+10899, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+16695,int_stack+0,int_stack+13545, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+121051,int_stack+24780,int_stack+24360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+25368,int_stack+24780, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1764,int_stack+0,int_stack+121051, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21420,int_stack+26152,int_stack+25368, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9135,int_stack+21420,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+127036,int_stack+9135,int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+27160,int_stack+26152, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+131236,int_stack+0,int_stack+21420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+21420,int_stack+131236,int_stack+9135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+9135,int_stack+21420,int_stack+127036, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+127036,int_stack+28735,int_stack+28420, 0.0, zero_stack, 1.0, int_stack+59640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127981,int_stack+29176,int_stack+28735, 0.0, zero_stack, 1.0, int_stack+59955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+129304,int_stack+127981,int_stack+127036, 0.0, zero_stack, 1.0, int_stack+69790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+131194,int_stack+29764,int_stack+29176, 0.0, zero_stack, 1.0, int_stack+60396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+132958,int_stack+131194,int_stack+127981, 0.0, zero_stack, 1.0, int_stack+70735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+21420,int_stack+132958,int_stack+129304, 0.0, zero_stack, 1.0, int_stack+72058, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+127036,int_stack+30520,int_stack+29764, 0.0, zero_stack, 1.0, int_stack+60984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+24570,int_stack+127036,int_stack+131194, 0.0, zero_stack, 1.0, int_stack+73948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+24570,int_stack+132958, 0.0, zero_stack, 1.0, int_stack+75712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+24570,int_stack+0,int_stack+21420, 0.0, zero_stack, 1.0, int_stack+78358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15435,int_stack+31885,int_stack+31465, 0.0, zero_stack, 1.0, int_stack+38570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21420,int_stack+32473,int_stack+31885, 0.0, zero_stack, 1.0, int_stack+39410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+21420,int_stack+15435, 0.0, zero_stack, 1.0, int_stack+81508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+29295,int_stack+33257,int_stack+32473, 0.0, zero_stack, 1.0, int_stack+40586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+127036,int_stack+29295,int_stack+21420, 0.0, zero_stack, 1.0, int_stack+82768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+130564,int_stack+127036,int_stack+0, 0.0, zero_stack, 1.0, int_stack+84532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+34265,int_stack+33257, 0.0, zero_stack, 1.0, int_stack+42154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+134764,int_stack+0,int_stack+29295, 0.0, zero_stack, 1.0, int_stack+87052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+29295,int_stack+134764,int_stack+127036, 0.0, zero_stack, 1.0, int_stack+89404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+134764,int_stack+29295,int_stack+130564, 0.0, zero_stack, 1.0, int_stack+97951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+29295,int_stack+35840,int_stack+35525, 1.0, int_stack+59640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+30240,int_stack+36281,int_stack+35840, 1.0, int_stack+59955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+31563,int_stack+30240,int_stack+29295, 1.0, int_stack+69790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+33453,int_stack+36869,int_stack+36281, 1.0, int_stack+60396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+127036,int_stack+33453,int_stack+30240, 1.0, int_stack+70735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+21420,int_stack+127036,int_stack+31563, 1.0, int_stack+72058, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+69790,int_stack+37625,int_stack+36869, 1.0, int_stack+60984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+29295,int_stack+69790,int_stack+33453, 1.0, int_stack+73948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+29295,int_stack+127036, 1.0, int_stack+75712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+127036,int_stack+0,int_stack+21420, 1.0, int_stack+78358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15435,int_stack+39998,int_stack+38990, 1.0, int_stack+38570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21420,int_stack+41370,int_stack+39998, 1.0, int_stack+39410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+21420,int_stack+15435, 1.0, int_stack+81508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+131761,int_stack+43162,int_stack+41370, 1.0, int_stack+40586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+29295,int_stack+131761,int_stack+21420, 1.0, int_stack+82768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+32823,int_stack+29295,int_stack+0, 1.0, int_stack+84532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+44170,int_stack+43162, 1.0, int_stack+42154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+81508,int_stack+0,int_stack+131761, 1.0, int_stack+87052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+37023,int_stack+81508,int_stack+29295, 1.0, int_stack+89404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+81508,int_stack+37023,int_stack+32823, 1.0, int_stack+97951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+97951,int_stack+61740,int_stack+60984,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+29295,int_stack+97951,int_stack+73948,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+29295,int_stack+75712,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+29295,int_stack+0,int_stack+78358,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+45745,int_stack+45430,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+945,int_stack+46186,int_stack+45745,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2268,int_stack+945,int_stack+0,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+34020,int_stack+46774,int_stack+46186,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+35784,int_stack+34020,int_stack+945,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+21420,int_stack+35784,int_stack+2268,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+47530,int_stack+46774,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+38430,int_stack+0,int_stack+34020,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+38430,int_stack+35784,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+34020,int_stack+0,int_stack+21420,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+15435,int_stack+48895,int_stack+48475,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+21420,int_stack+49483,int_stack+48895,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+21420,int_stack+15435,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+38745,int_stack+50267,int_stack+49483,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+41097,int_stack+38745,int_stack+21420,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+97951,int_stack+41097,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+51275,int_stack+50267,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+44625,int_stack+0,int_stack+38745,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+69790,int_stack+44625,int_stack+41097,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+38745,int_stack+69790,int_stack+97951,28);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+97951,int_stack+52850,int_stack+52535,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+98896,int_stack+53291,int_stack+52850,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+100219,int_stack+98896,int_stack+97951,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+69790,int_stack+53879,int_stack+53291,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+71554,int_stack+69790,int_stack+98896,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+21420,int_stack+71554,int_stack+100219,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+97951,int_stack+54635,int_stack+53879,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+74200,int_stack+97951,int_stack+69790,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+74200,int_stack+71554,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+69790,int_stack+0,int_stack+21420,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+15435,int_stack+56000,int_stack+55580,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+21420,int_stack+56588,int_stack+56000,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+21420,int_stack+15435,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+74515,int_stack+57372,int_stack+56588,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+76867,int_stack+74515,int_stack+21420,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+97951,int_stack+76867,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+58380,int_stack+57372,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+45045,int_stack+0,int_stack+74515,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+49749,int_stack+45045,int_stack+76867,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+74515,int_stack+49749,int_stack+97951,28);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+97951,int_stack+63000,int_stack+62685,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+98896,int_stack+63441,int_stack+63000,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+100219,int_stack+98896,int_stack+97951,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+45045,int_stack+64029,int_stack+63441,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+46809,int_stack+45045,int_stack+98896,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+21420,int_stack+46809,int_stack+100219,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+97951,int_stack+64785,int_stack+64029,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+49455,int_stack+97951,int_stack+45045,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+49455,int_stack+46809,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+45045,int_stack+0,int_stack+21420,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+15435,int_stack+66150,int_stack+65730,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+21420,int_stack+66738,int_stack+66150,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+21420,int_stack+15435,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+49770,int_stack+67522,int_stack+66738,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+52122,int_stack+49770,int_stack+21420,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+97951,int_stack+52122,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+68530,int_stack+67522,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+55650,int_stack+0,int_stack+49770,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+60354,int_stack+55650,int_stack+52122,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+49770,int_stack+60354,int_stack+97951,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+141064,int_stack+102151,int_stack+93226,225);
     Libderiv->ABCD[11] = int_stack + 141064;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+87808,int_stack+108451,int_stack+4410,225);
     Libderiv->ABCD[10] = int_stack + 87808;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+155239,int_stack+114751,int_stack+122311,225);
     Libderiv->ABCD[9] = int_stack + 155239;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+101983,int_stack+9135,int_stack+16695,225);
     Libderiv->ABCD[8] = int_stack + 101983;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+0,int_stack+134764,int_stack+24570,225);
     Libderiv->ABCD[7] = int_stack + 0;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+14175,int_stack+81508,int_stack+127036,225);
     Libderiv->ABCD[6] = int_stack + 14175;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+116158,int_stack+38745,int_stack+34020, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[2] = int_stack + 116158;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+169414,int_stack+74515,int_stack+69790, 0.0, zero_stack, 1.0, int_stack+29295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[1] = int_stack + 169414;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+56070,int_stack+49770,int_stack+45045, 1.0, int_stack+29295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[0] = int_stack + 56070;

}
