/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_idhh(Libderiv_t *, prim_data *);

  /* Computes derivatives of (id|hh) integrals */

void d1hrr_order_idhh(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][5][11] = int_stack + 0;
 Libderiv->deriv_classes[6][6][11] = int_stack + 588;
 Libderiv->deriv_classes[6][7][11] = int_stack + 1372;
 Libderiv->deriv_classes[6][8][11] = int_stack + 2380;
 Libderiv->deriv_classes[6][9][11] = int_stack + 3640;
 Libderiv->deriv_classes[6][10][11] = int_stack + 5180;
 Libderiv->deriv_classes[7][5][11] = int_stack + 7028;
 Libderiv->deriv_classes[7][6][11] = int_stack + 7784;
 Libderiv->deriv_classes[7][7][11] = int_stack + 8792;
 Libderiv->deriv_classes[7][8][11] = int_stack + 10088;
 Libderiv->deriv_classes[7][9][11] = int_stack + 11708;
 Libderiv->deriv_classes[7][10][11] = int_stack + 13688;
 Libderiv->deriv_classes[8][5][11] = int_stack + 16064;
 Libderiv->deriv_classes[8][6][11] = int_stack + 17009;
 Libderiv->deriv_classes[8][7][11] = int_stack + 18269;
 Libderiv->deriv_classes[8][8][11] = int_stack + 19889;
 Libderiv->deriv_classes[8][9][11] = int_stack + 21914;
 Libderiv->deriv_classes[8][10][11] = int_stack + 24389;
 Libderiv->deriv_classes[6][5][10] = int_stack + 27359;
 Libderiv->deriv_classes[6][6][10] = int_stack + 27947;
 Libderiv->deriv_classes[6][7][10] = int_stack + 28731;
 Libderiv->deriv_classes[6][8][10] = int_stack + 29739;
 Libderiv->deriv_classes[6][9][10] = int_stack + 30999;
 Libderiv->deriv_classes[6][10][10] = int_stack + 32539;
 Libderiv->deriv_classes[7][5][10] = int_stack + 34387;
 Libderiv->deriv_classes[7][6][10] = int_stack + 35143;
 Libderiv->deriv_classes[7][7][10] = int_stack + 36151;
 Libderiv->deriv_classes[7][8][10] = int_stack + 37447;
 Libderiv->deriv_classes[7][9][10] = int_stack + 39067;
 Libderiv->deriv_classes[7][10][10] = int_stack + 41047;
 Libderiv->deriv_classes[8][5][10] = int_stack + 43423;
 Libderiv->deriv_classes[8][6][10] = int_stack + 44368;
 Libderiv->deriv_classes[8][7][10] = int_stack + 45628;
 Libderiv->deriv_classes[8][8][10] = int_stack + 47248;
 Libderiv->deriv_classes[8][9][10] = int_stack + 49273;
 Libderiv->deriv_classes[8][10][10] = int_stack + 51748;
 Libderiv->deriv_classes[6][5][9] = int_stack + 54718;
 Libderiv->deriv_classes[6][6][9] = int_stack + 55306;
 Libderiv->deriv_classes[6][7][9] = int_stack + 56090;
 Libderiv->deriv_classes[6][8][9] = int_stack + 57098;
 Libderiv->deriv_classes[6][9][9] = int_stack + 58358;
 Libderiv->deriv_classes[6][10][9] = int_stack + 59898;
 Libderiv->deriv_classes[7][5][9] = int_stack + 61746;
 Libderiv->deriv_classes[7][6][9] = int_stack + 62502;
 Libderiv->deriv_classes[7][7][9] = int_stack + 63510;
 Libderiv->deriv_classes[7][8][9] = int_stack + 64806;
 Libderiv->deriv_classes[7][9][9] = int_stack + 66426;
 Libderiv->deriv_classes[7][10][9] = int_stack + 68406;
 Libderiv->deriv_classes[8][5][9] = int_stack + 70782;
 Libderiv->deriv_classes[8][6][9] = int_stack + 71727;
 Libderiv->deriv_classes[8][7][9] = int_stack + 72987;
 Libderiv->deriv_classes[8][8][9] = int_stack + 74607;
 Libderiv->deriv_classes[8][9][9] = int_stack + 76632;
 Libderiv->deriv_classes[8][10][9] = int_stack + 79107;
 Libderiv->deriv_classes[6][5][8] = int_stack + 82077;
 Libderiv->deriv_classes[6][6][8] = int_stack + 82665;
 Libderiv->deriv_classes[6][7][8] = int_stack + 83449;
 Libderiv->deriv_classes[6][8][8] = int_stack + 84457;
 Libderiv->deriv_classes[6][9][8] = int_stack + 85717;
 Libderiv->deriv_classes[6][10][8] = int_stack + 87257;
 Libderiv->deriv_classes[7][5][8] = int_stack + 89105;
 Libderiv->deriv_classes[7][6][8] = int_stack + 89861;
 Libderiv->deriv_classes[7][7][8] = int_stack + 90869;
 Libderiv->deriv_classes[7][8][8] = int_stack + 92165;
 Libderiv->deriv_classes[7][9][8] = int_stack + 93785;
 Libderiv->deriv_classes[7][10][8] = int_stack + 95765;
 Libderiv->deriv_classes[8][5][8] = int_stack + 98141;
 Libderiv->deriv_classes[8][6][8] = int_stack + 99086;
 Libderiv->deriv_classes[8][7][8] = int_stack + 100346;
 Libderiv->deriv_classes[8][8][8] = int_stack + 101966;
 Libderiv->deriv_classes[8][9][8] = int_stack + 103991;
 Libderiv->deriv_classes[8][10][8] = int_stack + 106466;
 Libderiv->deriv_classes[6][5][7] = int_stack + 109436;
 Libderiv->deriv_classes[6][6][7] = int_stack + 110024;
 Libderiv->deriv_classes[6][7][7] = int_stack + 110808;
 Libderiv->deriv_classes[6][8][7] = int_stack + 111816;
 Libderiv->deriv_classes[6][9][7] = int_stack + 113076;
 Libderiv->deriv_classes[6][10][7] = int_stack + 114616;
 Libderiv->deriv_classes[7][5][7] = int_stack + 116464;
 Libderiv->deriv_classes[7][6][7] = int_stack + 117220;
 Libderiv->deriv_classes[7][7][7] = int_stack + 118228;
 Libderiv->deriv_classes[7][8][7] = int_stack + 119524;
 Libderiv->deriv_classes[7][9][7] = int_stack + 121144;
 Libderiv->deriv_classes[7][10][7] = int_stack + 123124;
 Libderiv->deriv_classes[8][5][7] = int_stack + 125500;
 Libderiv->deriv_classes[8][6][7] = int_stack + 126445;
 Libderiv->deriv_classes[8][7][7] = int_stack + 127705;
 Libderiv->deriv_classes[8][8][7] = int_stack + 129325;
 Libderiv->deriv_classes[8][9][7] = int_stack + 131350;
 Libderiv->deriv_classes[8][10][7] = int_stack + 133825;
 Libderiv->deriv_classes[6][5][6] = int_stack + 136795;
 Libderiv->deriv_classes[6][6][6] = int_stack + 137383;
 Libderiv->deriv_classes[6][7][6] = int_stack + 138167;
 Libderiv->deriv_classes[6][8][6] = int_stack + 139175;
 Libderiv->deriv_classes[6][9][6] = int_stack + 140435;
 Libderiv->deriv_classes[6][10][6] = int_stack + 141975;
 Libderiv->deriv_classes[7][5][6] = int_stack + 143823;
 Libderiv->deriv_classes[7][6][6] = int_stack + 144579;
 Libderiv->deriv_classes[7][7][6] = int_stack + 145587;
 Libderiv->deriv_classes[7][8][6] = int_stack + 146883;
 Libderiv->deriv_classes[7][9][6] = int_stack + 148503;
 Libderiv->deriv_classes[7][10][6] = int_stack + 150483;
 Libderiv->dvrr_classes[8][5] = int_stack + 152859;
 Libderiv->deriv_classes[8][5][6] = int_stack + 153804;
 Libderiv->dvrr_classes[8][6] = int_stack + 154749;
 Libderiv->deriv_classes[8][6][6] = int_stack + 156009;
 Libderiv->dvrr_classes[8][7] = int_stack + 157269;
 Libderiv->deriv_classes[8][7][6] = int_stack + 158889;
 Libderiv->dvrr_classes[8][8] = int_stack + 160509;
 Libderiv->deriv_classes[8][8][6] = int_stack + 162534;
 Libderiv->dvrr_classes[8][9] = int_stack + 164559;
 Libderiv->deriv_classes[8][9][6] = int_stack + 167034;
 Libderiv->deriv_classes[8][10][6] = int_stack + 169509;
 Libderiv->deriv_classes[6][5][2] = int_stack + 172479;
 Libderiv->deriv_classes[6][6][2] = int_stack + 173067;
 Libderiv->deriv_classes[6][7][2] = int_stack + 173851;
 Libderiv->deriv_classes[6][8][2] = int_stack + 174859;
 Libderiv->deriv_classes[6][9][2] = int_stack + 176119;
 Libderiv->deriv_classes[6][10][2] = int_stack + 177659;
 Libderiv->deriv_classes[7][5][2] = int_stack + 179507;
 Libderiv->deriv_classes[7][6][2] = int_stack + 180263;
 Libderiv->deriv_classes[7][7][2] = int_stack + 181271;
 Libderiv->deriv_classes[7][8][2] = int_stack + 182567;
 Libderiv->deriv_classes[7][9][2] = int_stack + 184187;
 Libderiv->deriv_classes[7][10][2] = int_stack + 186167;
 Libderiv->deriv_classes[8][5][2] = int_stack + 188543;
 Libderiv->deriv_classes[8][6][2] = int_stack + 189488;
 Libderiv->deriv_classes[8][7][2] = int_stack + 190748;
 Libderiv->deriv_classes[8][8][2] = int_stack + 192368;
 Libderiv->deriv_classes[8][9][2] = int_stack + 194393;
 Libderiv->deriv_classes[8][10][2] = int_stack + 196868;
 Libderiv->deriv_classes[6][5][1] = int_stack + 199838;
 Libderiv->deriv_classes[6][6][1] = int_stack + 200426;
 Libderiv->deriv_classes[6][7][1] = int_stack + 201210;
 Libderiv->deriv_classes[6][8][1] = int_stack + 202218;
 Libderiv->deriv_classes[6][9][1] = int_stack + 203478;
 Libderiv->deriv_classes[6][10][1] = int_stack + 205018;
 Libderiv->deriv_classes[7][5][1] = int_stack + 206866;
 Libderiv->deriv_classes[7][6][1] = int_stack + 207622;
 Libderiv->deriv_classes[7][7][1] = int_stack + 208630;
 Libderiv->deriv_classes[7][8][1] = int_stack + 209926;
 Libderiv->deriv_classes[7][9][1] = int_stack + 211546;
 Libderiv->deriv_classes[7][10][1] = int_stack + 213526;
 Libderiv->deriv_classes[8][5][1] = int_stack + 215902;
 Libderiv->deriv_classes[8][6][1] = int_stack + 216847;
 Libderiv->deriv_classes[8][7][1] = int_stack + 218107;
 Libderiv->deriv_classes[8][8][1] = int_stack + 219727;
 Libderiv->deriv_classes[8][9][1] = int_stack + 221752;
 Libderiv->deriv_classes[8][10][1] = int_stack + 224227;
 Libderiv->dvrr_classes[6][5] = int_stack + 227197;
 Libderiv->dvrr_classes[6][6] = int_stack + 227785;
 Libderiv->dvrr_classes[6][7] = int_stack + 228569;
 Libderiv->dvrr_classes[6][8] = int_stack + 229577;
 Libderiv->dvrr_classes[6][9] = int_stack + 230837;
 Libderiv->dvrr_classes[6][10] = int_stack + 232377;
 Libderiv->deriv_classes[6][5][0] = int_stack + 234225;
 Libderiv->deriv_classes[6][6][0] = int_stack + 234813;
 Libderiv->deriv_classes[6][7][0] = int_stack + 235597;
 Libderiv->deriv_classes[6][8][0] = int_stack + 236605;
 Libderiv->deriv_classes[6][9][0] = int_stack + 237865;
 Libderiv->deriv_classes[6][10][0] = int_stack + 239405;
 Libderiv->dvrr_classes[7][5] = int_stack + 241253;
 Libderiv->dvrr_classes[7][6] = int_stack + 242009;
 Libderiv->dvrr_classes[7][7] = int_stack + 243017;
 Libderiv->dvrr_classes[7][8] = int_stack + 244313;
 Libderiv->dvrr_classes[7][9] = int_stack + 245933;
 Libderiv->dvrr_classes[7][10] = int_stack + 247913;
 Libderiv->deriv_classes[7][5][0] = int_stack + 250289;
 Libderiv->deriv_classes[7][6][0] = int_stack + 251045;
 Libderiv->deriv_classes[7][7][0] = int_stack + 252053;
 Libderiv->deriv_classes[7][8][0] = int_stack + 253349;
 Libderiv->deriv_classes[7][9][0] = int_stack + 254969;
 Libderiv->deriv_classes[7][10][0] = int_stack + 256949;
 Libderiv->deriv_classes[8][5][0] = int_stack + 259325;
 Libderiv->deriv_classes[8][6][0] = int_stack + 260270;
 Libderiv->deriv_classes[8][7][0] = int_stack + 261530;
 Libderiv->deriv_classes[8][8][0] = int_stack + 263150;
 Libderiv->deriv_classes[8][9][0] = int_stack + 265175;
 Libderiv->deriv_classes[8][10][0] = int_stack + 267650;
 memset(int_stack,0,2164960);

 Libderiv->dvrr_stack = int_stack + 1017594;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_idhh(Libderiv, Data);
   Data++;
 }

 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+270620,int_stack+227785,int_stack+227197,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+272384,int_stack+228569,int_stack+227785,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+274736,int_stack+272384,int_stack+270620,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+278264,int_stack+229577,int_stack+228569,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+281288,int_stack+278264,int_stack+272384,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+285992,int_stack+281288,int_stack+274736,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+291872,int_stack+230837,int_stack+229577,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+295652,int_stack+291872,int_stack+278264,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+301700,int_stack+295652,int_stack+281288,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+309540,int_stack+301700,int_stack+285992,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+318360,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227197,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+320124,int_stack+1372,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227785,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+322476,int_stack+320124,int_stack+318360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270620,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+326004,int_stack+2380,int_stack+1372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228569,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+329028,int_stack+326004,int_stack+320124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272384,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+333732,int_stack+329028,int_stack+322476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274736,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+318360,int_stack+3640,int_stack+2380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229577,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+339612,int_stack+318360,int_stack+326004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+278264,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+345660,int_stack+339612,int_stack+329028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+281288,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+322140,int_stack+345660,int_stack+333732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285992,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+330960,int_stack+5180,int_stack+3640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230837,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+353500,int_stack+330960,int_stack+318360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+291872,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+361060,int_stack+353500,int_stack+339612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295652,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+330960,int_stack+361060,int_stack+345660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+301700,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+342720,int_stack+330960,int_stack+322140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+309540,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+318360,int_stack+242009,int_stack+241253,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+320628,int_stack+243017,int_stack+242009,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+323652,int_stack+320628,int_stack+318360,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+328188,int_stack+244313,int_stack+243017,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+332076,int_stack+328188,int_stack+320628,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+355068,int_stack+332076,int_stack+323652,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+362628,int_stack+245933,int_stack+244313,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+367488,int_stack+362628,int_stack+328188,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+375264,int_stack+367488,int_stack+332076,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+385344,int_stack+375264,int_stack+355068,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+338124,int_stack+7784,int_stack+7028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241253,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+8792,int_stack+7784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242009,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3024,int_stack+0,int_stack+338124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318360,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+338124,int_stack+10088,int_stack+8792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243017,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+396684,int_stack+338124,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320628,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+402732,int_stack+396684,int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+323652,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+11708,int_stack+10088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244313,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+410292,int_stack+0,int_stack+338124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+328188,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+418068,int_stack+410292,int_stack+396684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332076,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+428148,int_stack+418068,int_stack+402732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355068,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+396684,int_stack+13688,int_stack+11708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245933,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4860,int_stack+396684,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362628,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+396684,int_stack+4860,int_stack+410292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+367488,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+396684,int_stack+418068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375264,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+396684,int_stack+0,int_stack+428148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385344,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+412560,int_stack+396684,int_stack+342720,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+154749,int_stack+152859,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2835,int_stack+157269,int_stack+154749,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6615,int_stack+2835,int_stack+0,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+338124,int_stack+160509,int_stack+157269,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+342984,int_stack+338124,int_stack+2835,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+449604,int_stack+342984,int_stack+6615,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+459054,int_stack+164559,int_stack+160509,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+465129,int_stack+459054,int_stack+338124,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+474849,int_stack+465129,int_stack+342984,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+487449,int_stack+474849,int_stack+449604,45);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12285,int_stack+17009,int_stack+16064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152859,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+350544,int_stack+18269,int_stack+17009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+154749,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+501624,int_stack+350544,int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12285,int_stack+19889,int_stack+18269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157269,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+507294,int_stack+12285,int_stack+350544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+514854,int_stack+507294,int_stack+501624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+524304,int_stack+21914,int_stack+19889, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160509,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+530379,int_stack+524304,int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+338124,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+540099,int_stack+530379,int_stack+507294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342984,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+552699,int_stack+540099,int_stack+514854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+449604,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+12285,int_stack+24389,int_stack+21914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164559,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+501624,int_stack+12285,int_stack+524304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+459054,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+513774,int_stack+501624,int_stack+530379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+465129,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+566874,int_stack+513774,int_stack+540099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474849,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+501624,int_stack+566874,int_stack+552699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487449,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+521469,int_stack+501624,int_stack+396684,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+396684,int_stack+27947,int_stack+27359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227197, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+398448,int_stack+28731,int_stack+27947, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227785, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+400800,int_stack+398448,int_stack+396684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270620, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+404328,int_stack+29739,int_stack+28731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228569, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+407352,int_stack+404328,int_stack+398448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272384, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+501624,int_stack+407352,int_stack+400800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274736, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+396684,int_stack+30999,int_stack+29739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229577, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+507504,int_stack+396684,int_stack+404328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+278264, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+513552,int_stack+507504,int_stack+407352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+281288, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+400464,int_stack+513552,int_stack+501624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285992, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+501624,int_stack+32539,int_stack+30999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230837, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+569097,int_stack+501624,int_stack+396684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+291872, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+12285,int_stack+569097,int_stack+507504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295652, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+569097,int_stack+12285,int_stack+513552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+301700, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+12285,int_stack+569097,int_stack+400464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+309540, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+569097,int_stack+35143,int_stack+34387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241253, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+571365,int_stack+36151,int_stack+35143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242009, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+574389,int_stack+571365,int_stack+569097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318360, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+578925,int_stack+37447,int_stack+36151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243017, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+24633,int_stack+578925,int_stack+571365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320628, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+396684,int_stack+24633,int_stack+574389, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+323652, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+569097,int_stack+39067,int_stack+37447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244313, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+30681,int_stack+569097,int_stack+578925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+328188, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+573957,int_stack+30681,int_stack+24633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332076, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+501624,int_stack+573957,int_stack+396684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355068, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+396684,int_stack+41047,int_stack+39067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245933, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+402624,int_stack+396684,int_stack+569097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362628, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+584037,int_stack+402624,int_stack+30681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+367488, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+396684,int_stack+584037,int_stack+573957, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375264, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+569097,int_stack+396684,int_stack+501624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385344, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+584973,int_stack+569097,int_stack+12285,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12285,int_stack+44368,int_stack+43423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152859, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15120,int_stack+45628,int_stack+44368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+154749, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+18900,int_stack+15120,int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24570,int_stack+47248,int_stack+45628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157269, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+29430,int_stack+24570,int_stack+15120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+36990,int_stack+29430,int_stack+18900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12285,int_stack+49273,int_stack+47248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160509, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+501624,int_stack+12285,int_stack+24570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+338124, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+396684,int_stack+501624,int_stack+29430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342984, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+18360,int_stack+396684,int_stack+36990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+449604, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+32535,int_stack+51748,int_stack+49273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164559, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+39960,int_stack+32535,int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+459054, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+622017,int_stack+39960,int_stack+501624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+465129, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+501624,int_stack+622017,int_stack+396684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474849, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+32535,int_stack+501624,int_stack+18360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487449, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+622017,int_stack+32535,int_stack+569097,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+569097,int_stack+55306,int_stack+54718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227197, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+570861,int_stack+56090,int_stack+55306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227785, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+573213,int_stack+570861,int_stack+569097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270620, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+576741,int_stack+57098,int_stack+56090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228569, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+579765,int_stack+576741,int_stack+570861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272384, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+501624,int_stack+579765,int_stack+573213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274736, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+569097,int_stack+58358,int_stack+57098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229577, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+507504,int_stack+569097,int_stack+576741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+278264, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+513552,int_stack+507504,int_stack+579765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+281288, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+572877,int_stack+513552,int_stack+501624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285992, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+501624,int_stack+59898,int_stack+58358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230837, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+396684,int_stack+501624,int_stack+569097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+291872, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+12285,int_stack+396684,int_stack+507504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295652, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+396684,int_stack+12285,int_stack+513552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+301700, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+12285,int_stack+396684,int_stack+572877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+309540, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+396684,int_stack+62502,int_stack+61746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241253, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+398952,int_stack+63510,int_stack+62502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242009, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+401976,int_stack+398952,int_stack+396684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318360, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+406512,int_stack+64806,int_stack+63510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243017, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+24633,int_stack+406512,int_stack+398952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320628, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+30681,int_stack+24633,int_stack+401976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+323652, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+396684,int_stack+66426,int_stack+64806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244313, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+38241,int_stack+396684,int_stack+406512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+328188, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+401544,int_stack+38241,int_stack+24633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332076, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+46017,int_stack+401544,int_stack+30681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355068, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+24633,int_stack+68406,int_stack+66426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245933, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+57357,int_stack+24633,int_stack+396684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362628, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+24633,int_stack+57357,int_stack+38241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+367488, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+569097,int_stack+24633,int_stack+401544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375264, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+396684,int_stack+569097,int_stack+46017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385344, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+24633,int_stack+396684,int_stack+12285,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12285,int_stack+71727,int_stack+70782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152859, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15120,int_stack+72987,int_stack+71727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+154749, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+18900,int_stack+15120,int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+569097,int_stack+74607,int_stack+72987, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157269, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+573957,int_stack+569097,int_stack+15120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+61677,int_stack+573957,int_stack+18900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12285,int_stack+76632,int_stack+74607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160509, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+501624,int_stack+12285,int_stack+569097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+338124, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+669645,int_stack+501624,int_stack+573957, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342984, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+569097,int_stack+669645,int_stack+61677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+449604, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+61677,int_stack+79107,int_stack+76632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164559, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+69102,int_stack+61677,int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+459054, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+682245,int_stack+69102,int_stack+501624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+465129, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+501624,int_stack+682245,int_stack+669645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474849, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+669645,int_stack+501624,int_stack+569097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487449, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+689490,int_stack+669645,int_stack+396684,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+396684,int_stack+82665,int_stack+82077, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+398448,int_stack+83449,int_stack+82665, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+400800,int_stack+398448,int_stack+396684, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+404328,int_stack+84457,int_stack+83449, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+407352,int_stack+404328,int_stack+398448, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+669645,int_stack+407352,int_stack+400800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+396684,int_stack+85717,int_stack+84457, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229577, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+675525,int_stack+396684,int_stack+404328, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+278264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+681573,int_stack+675525,int_stack+407352, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+281288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+400464,int_stack+681573,int_stack+669645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+669645,int_stack+87257,int_stack+85717, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+569097,int_stack+669645,int_stack+396684, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+291872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+501624,int_stack+569097,int_stack+675525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+569097,int_stack+501624,int_stack+681573, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+301700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+12285,int_stack+569097,int_stack+400464, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+309540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+569097,int_stack+89861,int_stack+89105, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+571365,int_stack+90869,int_stack+89861, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+574389,int_stack+571365,int_stack+569097, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+578925,int_stack+92165,int_stack+90869, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+501624,int_stack+578925,int_stack+571365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+507672,int_stack+501624,int_stack+574389, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+323652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+569097,int_stack+93785,int_stack+92165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+396684,int_stack+569097,int_stack+578925, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+328188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+573957,int_stack+396684,int_stack+501624, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+669645,int_stack+573957,int_stack+507672, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+501624,int_stack+95765,int_stack+93785, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+507564,int_stack+501624,int_stack+569097, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+61677,int_stack+507564,int_stack+396684, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+367488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+396684,int_stack+61677,int_stack+573957, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+569097,int_stack+396684,int_stack+669645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+737118,int_stack+569097,int_stack+12285,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12285,int_stack+99086,int_stack+98141, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15120,int_stack+100346,int_stack+99086, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+154749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+18900,int_stack+15120,int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+669645,int_stack+101966,int_stack+100346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+674505,int_stack+669645,int_stack+15120, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+396684,int_stack+674505,int_stack+18900, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12285,int_stack+103991,int_stack+101966, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+61677,int_stack+12285,int_stack+669645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+338124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+71397,int_stack+61677,int_stack+674505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+669645,int_stack+71397,int_stack+396684, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+449604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+396684,int_stack+106466,int_stack+103991, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+83997,int_stack+396684,int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+459054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+501624,int_stack+83997,int_stack+61677, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+465129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+83997,int_stack+501624,int_stack+71397, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+501624,int_stack+83997,int_stack+669645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+61677,int_stack+501624,int_stack+569097,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+569097,int_stack+110024,int_stack+109436, 0.0, zero_stack, 1.0, int_stack+227197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+570861,int_stack+110808,int_stack+110024, 0.0, zero_stack, 1.0, int_stack+227785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+573213,int_stack+570861,int_stack+569097, 0.0, zero_stack, 1.0, int_stack+270620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+576741,int_stack+111816,int_stack+110808, 0.0, zero_stack, 1.0, int_stack+228569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+579765,int_stack+576741,int_stack+570861, 0.0, zero_stack, 1.0, int_stack+272384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+501624,int_stack+579765,int_stack+573213, 0.0, zero_stack, 1.0, int_stack+274736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+569097,int_stack+113076,int_stack+111816, 0.0, zero_stack, 1.0, int_stack+229577, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+507504,int_stack+569097,int_stack+576741, 0.0, zero_stack, 1.0, int_stack+278264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+513552,int_stack+507504,int_stack+579765, 0.0, zero_stack, 1.0, int_stack+281288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+572877,int_stack+513552,int_stack+501624, 0.0, zero_stack, 1.0, int_stack+285992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+501624,int_stack+114616,int_stack+113076, 0.0, zero_stack, 1.0, int_stack+230837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+669645,int_stack+501624,int_stack+569097, 0.0, zero_stack, 1.0, int_stack+291872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+677205,int_stack+669645,int_stack+507504, 0.0, zero_stack, 1.0, int_stack+295652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+501624,int_stack+677205,int_stack+513552, 0.0, zero_stack, 1.0, int_stack+301700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+12285,int_stack+501624,int_stack+572877, 0.0, zero_stack, 1.0, int_stack+309540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+501624,int_stack+117220,int_stack+116464, 0.0, zero_stack, 1.0, int_stack+241253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+503892,int_stack+118228,int_stack+117220, 0.0, zero_stack, 1.0, int_stack+242009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+506916,int_stack+503892,int_stack+501624, 0.0, zero_stack, 1.0, int_stack+318360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+511452,int_stack+119524,int_stack+118228, 0.0, zero_stack, 1.0, int_stack+243017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+515340,int_stack+511452,int_stack+503892, 0.0, zero_stack, 1.0, int_stack+320628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+669645,int_stack+515340,int_stack+506916, 0.0, zero_stack, 1.0, int_stack+323652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+501624,int_stack+121144,int_stack+119524, 0.0, zero_stack, 1.0, int_stack+244313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+677205,int_stack+501624,int_stack+511452, 0.0, zero_stack, 1.0, int_stack+328188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+569097,int_stack+677205,int_stack+515340, 0.0, zero_stack, 1.0, int_stack+332076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+506484,int_stack+569097,int_stack+669645, 0.0, zero_stack, 1.0, int_stack+355068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+669645,int_stack+123124,int_stack+121144, 0.0, zero_stack, 1.0, int_stack+245933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+109305,int_stack+669645,int_stack+501624, 0.0, zero_stack, 1.0, int_stack+362628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+396684,int_stack+109305,int_stack+677205, 0.0, zero_stack, 1.0, int_stack+367488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+109305,int_stack+396684,int_stack+569097, 0.0, zero_stack, 1.0, int_stack+375264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+569097,int_stack+109305,int_stack+506484, 0.0, zero_stack, 1.0, int_stack+385344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+774162,int_stack+569097,int_stack+12285,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12285,int_stack+126445,int_stack+125500, 0.0, zero_stack, 1.0, int_stack+152859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15120,int_stack+127705,int_stack+126445, 0.0, zero_stack, 1.0, int_stack+154749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+18900,int_stack+15120,int_stack+12285, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+109305,int_stack+129325,int_stack+127705, 0.0, zero_stack, 1.0, int_stack+157269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+114165,int_stack+109305,int_stack+15120, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+396684,int_stack+114165,int_stack+18900, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12285,int_stack+131350,int_stack+129325, 0.0, zero_stack, 1.0, int_stack+160509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+501624,int_stack+12285,int_stack+109305, 0.0, zero_stack, 1.0, int_stack+338124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+669645,int_stack+501624,int_stack+114165, 0.0, zero_stack, 1.0, int_stack+342984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+109305,int_stack+669645,int_stack+396684, 0.0, zero_stack, 1.0, int_stack+449604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+396684,int_stack+133825,int_stack+131350, 0.0, zero_stack, 1.0, int_stack+164559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+123480,int_stack+396684,int_stack+12285, 0.0, zero_stack, 1.0, int_stack+459054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+811206,int_stack+123480,int_stack+501624, 0.0, zero_stack, 1.0, int_stack+465129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+501624,int_stack+811206,int_stack+669645, 0.0, zero_stack, 1.0, int_stack+474849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+669645,int_stack+501624,int_stack+109305, 0.0, zero_stack, 1.0, int_stack+487449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+811206,int_stack+669645,int_stack+569097,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+569097,int_stack+137383,int_stack+136795, 1.0, int_stack+227197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+570861,int_stack+138167,int_stack+137383, 1.0, int_stack+227785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+573213,int_stack+570861,int_stack+569097, 1.0, int_stack+270620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+576741,int_stack+139175,int_stack+138167, 1.0, int_stack+228569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+579765,int_stack+576741,int_stack+570861, 1.0, int_stack+272384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+669645,int_stack+579765,int_stack+573213, 1.0, int_stack+274736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+270620,int_stack+140435,int_stack+139175, 1.0, int_stack+229577, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+569097,int_stack+270620,int_stack+576741, 1.0, int_stack+278264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+675525,int_stack+569097,int_stack+579765, 1.0, int_stack+281288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+274400,int_stack+675525,int_stack+669645, 1.0, int_stack+285992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+669645,int_stack+141975,int_stack+140435, 1.0, int_stack+230837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+283220,int_stack+669645,int_stack+270620, 1.0, int_stack+291872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+109305,int_stack+283220,int_stack+569097, 1.0, int_stack+295652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+569097,int_stack+109305,int_stack+675525, 1.0, int_stack+301700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+12285,int_stack+569097,int_stack+274400, 1.0, int_stack+309540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+569097,int_stack+144579,int_stack+143823, 1.0, int_stack+241253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+571365,int_stack+145587,int_stack+144579, 1.0, int_stack+242009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+574389,int_stack+571365,int_stack+569097, 1.0, int_stack+318360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+578925,int_stack+146883,int_stack+145587, 1.0, int_stack+243017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+109305,int_stack+578925,int_stack+571365, 1.0, int_stack+320628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+115353,int_stack+109305,int_stack+574389, 1.0, int_stack+323652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+318360,int_stack+148503,int_stack+146883, 1.0, int_stack+244313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+569097,int_stack+318360,int_stack+578925, 1.0, int_stack+328188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+122913,int_stack+569097,int_stack+109305, 1.0, int_stack+332076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+323220,int_stack+122913,int_stack+115353, 1.0, int_stack+355068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+109305,int_stack+150483,int_stack+148503, 1.0, int_stack+245933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+132993,int_stack+109305,int_stack+318360, 1.0, int_stack+362628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+109305,int_stack+132993,int_stack+569097, 1.0, int_stack+367488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+569097,int_stack+109305,int_stack+122913, 1.0, int_stack+375264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+396684,int_stack+569097,int_stack+323220, 1.0, int_stack+385344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+109305,int_stack+396684,int_stack+12285,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12285,int_stack+156009,int_stack+153804, 1.0, int_stack+152859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15120,int_stack+158889,int_stack+156009, 1.0, int_stack+154749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+18900,int_stack+15120,int_stack+12285, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+569097,int_stack+162534,int_stack+158889, 1.0, int_stack+157269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+573957,int_stack+569097,int_stack+15120, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+146349,int_stack+573957,int_stack+18900, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+167034,int_stack+162534, 1.0, int_stack+160509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6075,int_stack+0,int_stack+569097, 1.0, int_stack+338124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+318360,int_stack+6075,int_stack+573957, 1.0, int_stack+342984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+569097,int_stack+318360,int_stack+146349, 1.0, int_stack+449604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+449604,int_stack+169509,int_stack+167034, 1.0, int_stack+164559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+146349,int_stack+449604,int_stack+0, 1.0, int_stack+459054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+330960,int_stack+146349,int_stack+6075, 1.0, int_stack+465129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+146349,int_stack+330960,int_stack+318360, 1.0, int_stack+474849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+669645,int_stack+146349,int_stack+569097, 1.0, int_stack+487449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+449604,int_stack+669645,int_stack+396684,441);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+396684,int_stack+232377,int_stack+230837,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+401304,int_stack+396684,int_stack+291872,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+669645,int_stack+401304,int_stack+295652,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+396684,int_stack+669645,int_stack+301700,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+669645,int_stack+396684,int_stack+309540,28);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+396684,int_stack+247913,int_stack+245933,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+402624,int_stack+396684,int_stack+362628,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+569097,int_stack+402624,int_stack+367488,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+396684,int_stack+569097,int_stack+375264,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+569097,int_stack+396684,int_stack+385344,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+270620,int_stack+569097,int_stack+669645,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+681993,int_stack+173067,int_stack+172479,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+683757,int_stack+173851,int_stack+173067,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+146349,int_stack+683757,int_stack+681993,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+686109,int_stack+174859,int_stack+173851,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+149877,int_stack+686109,int_stack+683757,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+154581,int_stack+149877,int_stack+146349,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+681993,int_stack+176119,int_stack+174859,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+160461,int_stack+681993,int_stack+686109,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+166509,int_stack+160461,int_stack+149877,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+0,int_stack+166509,int_stack+154581,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+146349,int_stack+177659,int_stack+176119,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+150969,int_stack+146349,int_stack+681993,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+8820,int_stack+150969,int_stack+160461,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+146349,int_stack+8820,int_stack+166509,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+8820,int_stack+146349,int_stack+0,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+180263,int_stack+179507,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+181271,int_stack+180263,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+146349,int_stack+2268,int_stack+0,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+150885,int_stack+182567,int_stack+181271,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+154773,int_stack+150885,int_stack+2268,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+154773,int_stack+146349,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+160821,int_stack+184187,int_stack+182567,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+165681,int_stack+160821,int_stack+150885,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+173457,int_stack+165681,int_stack+154773,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+146349,int_stack+173457,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+186167,int_stack+184187,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+497232,int_stack+0,int_stack+160821,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+506952,int_stack+497232,int_stack+165681,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+157689,int_stack+506952,int_stack+173457,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+497232,int_stack+157689,int_stack+146349,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+146349,int_stack+497232,int_stack+8820, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+183393,int_stack+189488,int_stack+188543,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+513108,int_stack+190748,int_stack+189488,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+513108,int_stack+183393,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+183393,int_stack+192368,int_stack+190748,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5670,int_stack+183393,int_stack+513108,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+13230,int_stack+5670,int_stack+0,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+513108,int_stack+194393,int_stack+192368,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+307664,int_stack+513108,int_stack+183393,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+317384,int_stack+307664,int_stack+5670,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+329984,int_stack+317384,int_stack+13230,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+183393,int_stack+196868,int_stack+194393,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+0,int_stack+183393,int_stack+513108,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+183393,int_stack+0,int_stack+307664,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+183393,int_stack+317384,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+307664,int_stack+0,int_stack+329984,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+327509,int_stack+307664,int_stack+497232, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+497232,int_stack+200426,int_stack+199838,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+498996,int_stack+201210,int_stack+200426,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+501348,int_stack+498996,int_stack+497232,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+504876,int_stack+202218,int_stack+201210,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+507900,int_stack+504876,int_stack+498996,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+512604,int_stack+507900,int_stack+501348,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+497232,int_stack+203478,int_stack+202218,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+307664,int_stack+497232,int_stack+504876,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+313712,int_stack+307664,int_stack+507900,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+501012,int_stack+313712,int_stack+512604,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+509832,int_stack+205018,int_stack+203478,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+0,int_stack+509832,int_stack+497232,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+509832,int_stack+0,int_stack+307664,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+509832,int_stack+313712,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+307664,int_stack+0,int_stack+501012,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+207622,int_stack+206866,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+208630,int_stack+207622,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5292,int_stack+2268,int_stack+0,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+9828,int_stack+209926,int_stack+208630,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+13716,int_stack+9828,int_stack+2268,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+497232,int_stack+13716,int_stack+5292,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+211546,int_stack+209926,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+504792,int_stack+0,int_stack+9828,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+183393,int_stack+504792,int_stack+13716,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+4860,int_stack+183393,int_stack+497232,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+497232,int_stack+213526,int_stack+211546,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+193473,int_stack+497232,int_stack+0,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+375137,int_stack+193473,int_stack+504792,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+193473,int_stack+375137,int_stack+183393,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+375137,int_stack+193473,int_stack+4860,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+858834,int_stack+375137,int_stack+307664, 0.0, zero_stack, 1.0, int_stack+669645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+307664,int_stack+216847,int_stack+215902,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+310499,int_stack+218107,int_stack+216847,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+314279,int_stack+310499,int_stack+307664,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+319949,int_stack+219727,int_stack+218107,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+183393,int_stack+319949,int_stack+310499,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+190953,int_stack+183393,int_stack+314279,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+307664,int_stack+221752,int_stack+219727,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+200403,int_stack+307664,int_stack+319949,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+313739,int_stack+200403,int_stack+183393,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+391013,int_stack+313739,int_stack+190953,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+183393,int_stack+224227,int_stack+221752,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+210123,int_stack+183393,int_stack+307664,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+183393,int_stack+210123,int_stack+200403,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+199593,int_stack+183393,int_stack+313739,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+307664,int_stack+199593,int_stack+391013,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+183393,int_stack+307664,int_stack+375137, 0.0, zero_stack, 1.0, int_stack+569097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+375137,int_stack+234813,int_stack+234225,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+376901,int_stack+235597,int_stack+234813,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+379253,int_stack+376901,int_stack+375137,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+382781,int_stack+236605,int_stack+235597,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+385805,int_stack+382781,int_stack+376901,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+390509,int_stack+385805,int_stack+379253,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+375137,int_stack+237865,int_stack+236605,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+396389,int_stack+375137,int_stack+382781,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+402437,int_stack+396389,int_stack+385805,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+378917,int_stack+402437,int_stack+390509,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+387737,int_stack+239405,int_stack+237865,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+307664,int_stack+387737,int_stack+375137,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+315224,int_stack+307664,int_stack+396389,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+387737,int_stack+315224,int_stack+402437,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+307664,int_stack+387737,int_stack+378917,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+320012,int_stack+251045,int_stack+250289,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+322280,int_stack+252053,int_stack+251045,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+375137,int_stack+322280,int_stack+320012,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+379673,int_stack+253349,int_stack+252053,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+383561,int_stack+379673,int_stack+322280,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+389609,int_stack+383561,int_stack+375137,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+320012,int_stack+254969,int_stack+253349,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+397169,int_stack+320012,int_stack+379673,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+231021,int_stack+397169,int_stack+383561,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+375137,int_stack+231021,int_stack+389609,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+386477,int_stack+256949,int_stack+254969,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+241101,int_stack+386477,int_stack+320012,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+0,int_stack+241101,int_stack+397169,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+241101,int_stack+0,int_stack+231021,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+0,int_stack+241101,int_stack+375137,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+375137,int_stack+0,int_stack+307664, 1.0, int_stack+669645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+669645,int_stack+260270,int_stack+259325,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+672480,int_stack+261530,int_stack+260270,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+676260,int_stack+672480,int_stack+669645,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+681930,int_stack+263150,int_stack+261530,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+307664,int_stack+681930,int_stack+672480,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+315224,int_stack+307664,int_stack+676260,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+669645,int_stack+265175,int_stack+263150,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+231021,int_stack+669645,int_stack+681930,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+675720,int_stack+231021,int_stack+307664,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+240741,int_stack+675720,int_stack+315224,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+307664,int_stack+267650,int_stack+265175,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+315089,int_stack+307664,int_stack+669645,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+497232,int_stack+315089,int_stack+231021,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+307664,int_stack+497232,int_stack+675720,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+669645,int_stack+307664,int_stack+240741,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+895878,int_stack+669645,int_stack+0, 1.0, int_stack+569097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+943506,int_stack+521469,int_stack+412560,441);
     Libderiv->ABCD[11] = int_stack + 943506;
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+497232,int_stack+622017,int_stack+584973,441);
     Libderiv->ABCD[10] = int_stack + 497232;
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+571320,int_stack+689490,int_stack+24633,441);
     Libderiv->ABCD[9] = int_stack + 571320;
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+645408,int_stack+61677,int_stack+737118,441);
     Libderiv->ABCD[8] = int_stack + 645408;
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+0,int_stack+811206,int_stack+774162,441);
     Libderiv->ABCD[7] = int_stack + 0;
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+719496,int_stack+449604,int_stack+109305,441);
     Libderiv->ABCD[6] = int_stack + 719496;
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+412181,int_stack+327509,int_stack+146349, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[2] = int_stack + 412181;
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+74088,int_stack+183393,int_stack+858834, 0.0, zero_stack, 1.0, int_stack+270620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[1] = int_stack + 74088;
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+148176,int_stack+895878,int_stack+375137, 1.0, int_stack+270620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[0] = int_stack + 148176;

}
