/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_iphf(Libderiv_t *, prim_data *);

  /* Computes derivatives of (ip|hf) integrals */

void d1hrr_order_iphf(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][5][11] = int_stack + 0;
 Libderiv->deriv_classes[6][6][11] = int_stack + 588;
 Libderiv->deriv_classes[6][7][11] = int_stack + 1372;
 Libderiv->deriv_classes[6][8][11] = int_stack + 2380;
 Libderiv->deriv_classes[7][5][11] = int_stack + 3640;
 Libderiv->deriv_classes[7][6][11] = int_stack + 4396;
 Libderiv->deriv_classes[7][7][11] = int_stack + 5404;
 Libderiv->deriv_classes[7][8][11] = int_stack + 6700;
 Libderiv->deriv_classes[6][5][10] = int_stack + 8320;
 Libderiv->deriv_classes[6][6][10] = int_stack + 8908;
 Libderiv->deriv_classes[6][7][10] = int_stack + 9692;
 Libderiv->deriv_classes[6][8][10] = int_stack + 10700;
 Libderiv->deriv_classes[7][5][10] = int_stack + 11960;
 Libderiv->deriv_classes[7][6][10] = int_stack + 12716;
 Libderiv->deriv_classes[7][7][10] = int_stack + 13724;
 Libderiv->deriv_classes[7][8][10] = int_stack + 15020;
 Libderiv->deriv_classes[6][5][9] = int_stack + 16640;
 Libderiv->deriv_classes[6][6][9] = int_stack + 17228;
 Libderiv->deriv_classes[6][7][9] = int_stack + 18012;
 Libderiv->deriv_classes[6][8][9] = int_stack + 19020;
 Libderiv->deriv_classes[7][5][9] = int_stack + 20280;
 Libderiv->deriv_classes[7][6][9] = int_stack + 21036;
 Libderiv->deriv_classes[7][7][9] = int_stack + 22044;
 Libderiv->deriv_classes[7][8][9] = int_stack + 23340;
 Libderiv->deriv_classes[6][5][8] = int_stack + 24960;
 Libderiv->deriv_classes[6][6][8] = int_stack + 25548;
 Libderiv->deriv_classes[6][7][8] = int_stack + 26332;
 Libderiv->deriv_classes[6][8][8] = int_stack + 27340;
 Libderiv->deriv_classes[7][5][8] = int_stack + 28600;
 Libderiv->deriv_classes[7][6][8] = int_stack + 29356;
 Libderiv->deriv_classes[7][7][8] = int_stack + 30364;
 Libderiv->deriv_classes[7][8][8] = int_stack + 31660;
 Libderiv->deriv_classes[6][5][7] = int_stack + 33280;
 Libderiv->deriv_classes[6][6][7] = int_stack + 33868;
 Libderiv->deriv_classes[6][7][7] = int_stack + 34652;
 Libderiv->deriv_classes[6][8][7] = int_stack + 35660;
 Libderiv->deriv_classes[7][5][7] = int_stack + 36920;
 Libderiv->deriv_classes[7][6][7] = int_stack + 37676;
 Libderiv->deriv_classes[7][7][7] = int_stack + 38684;
 Libderiv->deriv_classes[7][8][7] = int_stack + 39980;
 Libderiv->deriv_classes[6][5][6] = int_stack + 41600;
 Libderiv->deriv_classes[6][6][6] = int_stack + 42188;
 Libderiv->deriv_classes[6][7][6] = int_stack + 42972;
 Libderiv->deriv_classes[6][8][6] = int_stack + 43980;
 Libderiv->dvrr_classes[7][5] = int_stack + 45240;
 Libderiv->deriv_classes[7][5][6] = int_stack + 45996;
 Libderiv->dvrr_classes[7][6] = int_stack + 46752;
 Libderiv->deriv_classes[7][6][6] = int_stack + 47760;
 Libderiv->dvrr_classes[7][7] = int_stack + 48768;
 Libderiv->deriv_classes[7][7][6] = int_stack + 50064;
 Libderiv->deriv_classes[7][8][6] = int_stack + 51360;
 Libderiv->deriv_classes[6][5][2] = int_stack + 52980;
 Libderiv->deriv_classes[6][6][2] = int_stack + 53568;
 Libderiv->deriv_classes[6][7][2] = int_stack + 54352;
 Libderiv->deriv_classes[6][8][2] = int_stack + 55360;
 Libderiv->deriv_classes[7][5][2] = int_stack + 56620;
 Libderiv->deriv_classes[7][6][2] = int_stack + 57376;
 Libderiv->deriv_classes[7][7][2] = int_stack + 58384;
 Libderiv->deriv_classes[7][8][2] = int_stack + 59680;
 Libderiv->deriv_classes[6][5][1] = int_stack + 61300;
 Libderiv->deriv_classes[6][6][1] = int_stack + 61888;
 Libderiv->deriv_classes[6][7][1] = int_stack + 62672;
 Libderiv->deriv_classes[6][8][1] = int_stack + 63680;
 Libderiv->deriv_classes[7][5][1] = int_stack + 64940;
 Libderiv->deriv_classes[7][6][1] = int_stack + 65696;
 Libderiv->deriv_classes[7][7][1] = int_stack + 66704;
 Libderiv->deriv_classes[7][8][1] = int_stack + 68000;
 Libderiv->dvrr_classes[6][5] = int_stack + 69620;
 Libderiv->dvrr_classes[6][6] = int_stack + 70208;
 Libderiv->dvrr_classes[6][7] = int_stack + 70992;
 Libderiv->dvrr_classes[6][8] = int_stack + 72000;
 Libderiv->deriv_classes[6][5][0] = int_stack + 73260;
 Libderiv->deriv_classes[6][6][0] = int_stack + 73848;
 Libderiv->deriv_classes[6][7][0] = int_stack + 74632;
 Libderiv->deriv_classes[6][8][0] = int_stack + 75640;
 Libderiv->deriv_classes[7][5][0] = int_stack + 76900;
 Libderiv->deriv_classes[7][6][0] = int_stack + 77656;
 Libderiv->deriv_classes[7][7][0] = int_stack + 78664;
 Libderiv->deriv_classes[7][8][0] = int_stack + 79960;
 memset(int_stack,0,652640);

 Libderiv->dvrr_stack = int_stack + 217012;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_iphf(Libderiv, Data);
   Data++;
 }

 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+81580,int_stack+70208,int_stack+69620,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+83344,int_stack+70992,int_stack+70208,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+85696,int_stack+83344,int_stack+81580,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+89224,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69620,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+90988,int_stack+1372,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70208,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+93340,int_stack+90988,int_stack+89224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81580,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+96868,int_stack+2380,int_stack+1372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70992,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+99892,int_stack+96868,int_stack+90988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83344,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+104596,int_stack+99892,int_stack+93340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85696,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+89224,int_stack+46752,int_stack+45240,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+91492,int_stack+48768,int_stack+46752,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+94516,int_stack+91492,int_stack+89224,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+99052,int_stack+4396,int_stack+3640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45240,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+101320,int_stack+5404,int_stack+4396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46752,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+101320,int_stack+99052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89224,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+110476,int_stack+6700,int_stack+5404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48768,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+114364,int_stack+110476,int_stack+101320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91492,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+120412,int_stack+114364,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94516,36);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+8908,int_stack+8320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69620, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1764,int_stack+9692,int_stack+8908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70208, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4116,int_stack+1764,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81580, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+110476,int_stack+10700,int_stack+9692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70992, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+113500,int_stack+110476,int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83344, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+127972,int_stack+113500,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85696, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+110476,int_stack+12716,int_stack+11960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45240, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+112744,int_stack+13724,int_stack+12716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46752, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+115768,int_stack+112744,int_stack+110476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89224, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+15020,int_stack+13724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48768, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3888,int_stack+0,int_stack+112744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91492, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+133852,int_stack+3888,int_stack+115768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94516, 0.0, zero_stack,36);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+17228,int_stack+16640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69620, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1764,int_stack+18012,int_stack+17228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70208, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4116,int_stack+1764,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81580, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7644,int_stack+19020,int_stack+18012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70992, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+10668,int_stack+7644,int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83344, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+110476,int_stack+10668,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85696, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+21036,int_stack+20280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45240, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+22044,int_stack+21036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46752, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5292,int_stack+2268,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89224, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9828,int_stack+23340,int_stack+22044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48768, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13716,int_stack+9828,int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91492, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+141412,int_stack+13716,int_stack+5292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94516, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+25548,int_stack+24960, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1764,int_stack+26332,int_stack+25548, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4116,int_stack+1764,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7644,int_stack+27340,int_stack+26332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+10668,int_stack+7644,int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+15372,int_stack+10668,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+29356,int_stack+28600, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+30364,int_stack+29356, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5292,int_stack+2268,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9828,int_stack+31660,int_stack+30364, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+21252,int_stack+9828,int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+148972,int_stack+21252,int_stack+5292, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21252,int_stack+33868,int_stack+33280, 0.0, zero_stack, 1.0, int_stack+69620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23016,int_stack+34652,int_stack+33868, 0.0, zero_stack, 1.0, int_stack+70208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25368,int_stack+23016,int_stack+21252, 0.0, zero_stack, 1.0, int_stack+81580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+28896,int_stack+35660,int_stack+34652, 0.0, zero_stack, 1.0, int_stack+70992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+31920,int_stack+28896,int_stack+23016, 0.0, zero_stack, 1.0, int_stack+83344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+31920,int_stack+25368, 0.0, zero_stack, 1.0, int_stack+85696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21252,int_stack+37676,int_stack+36920, 0.0, zero_stack, 1.0, int_stack+45240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23520,int_stack+38684,int_stack+37676, 0.0, zero_stack, 1.0, int_stack+46752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+26544,int_stack+23520,int_stack+21252, 0.0, zero_stack, 1.0, int_stack+89224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+31080,int_stack+39980,int_stack+38684, 0.0, zero_stack, 1.0, int_stack+48768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+34968,int_stack+31080,int_stack+23520, 0.0, zero_stack, 1.0, int_stack+91492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+5880,int_stack+34968,int_stack+26544, 0.0, zero_stack, 1.0, int_stack+94516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21252,int_stack+42188,int_stack+41600, 1.0, int_stack+69620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23016,int_stack+42972,int_stack+42188, 1.0, int_stack+70208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25368,int_stack+23016,int_stack+21252, 1.0, int_stack+81580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+28896,int_stack+43980,int_stack+42972, 1.0, int_stack+70992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+31920,int_stack+28896,int_stack+23016, 1.0, int_stack+83344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+36624,int_stack+31920,int_stack+25368, 1.0, int_stack+85696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21252,int_stack+47760,int_stack+45996, 1.0, int_stack+45240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23520,int_stack+50064,int_stack+47760, 1.0, int_stack+46752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+26544,int_stack+23520,int_stack+21252, 1.0, int_stack+89224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+31080,int_stack+51360,int_stack+50064, 1.0, int_stack+48768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+42504,int_stack+31080,int_stack+23520, 1.0, int_stack+91492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+156532,int_stack+42504,int_stack+26544, 1.0, int_stack+94516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+42504,int_stack+72000,int_stack+70992,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+45528,int_stack+42504,int_stack+83344,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+89224,int_stack+45528,int_stack+85696,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+42504,int_stack+53568,int_stack+52980,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+44268,int_stack+54352,int_stack+53568,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+46620,int_stack+44268,int_stack+42504,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+50148,int_stack+55360,int_stack+54352,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+95104,int_stack+50148,int_stack+44268,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+50148,int_stack+95104,int_stack+46620,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+95104,int_stack+57376,int_stack+56620,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+97372,int_stack+58384,int_stack+57376,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+42504,int_stack+97372,int_stack+95104,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+100396,int_stack+59680,int_stack+58384,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+21252,int_stack+100396,int_stack+97372,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+95104,int_stack+21252,int_stack+42504,36);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+42504,int_stack+61888,int_stack+61300,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+44268,int_stack+62672,int_stack+61888,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+46620,int_stack+44268,int_stack+42504,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+21252,int_stack+63680,int_stack+62672,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+24276,int_stack+21252,int_stack+44268,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+28980,int_stack+24276,int_stack+46620,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+21252,int_stack+65696,int_stack+64940,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+23520,int_stack+66704,int_stack+65696,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+42504,int_stack+23520,int_stack+21252,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+56028,int_stack+68000,int_stack+66704,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+59916,int_stack+56028,int_stack+23520,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+21252,int_stack+59916,int_stack+42504,36);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+34860,int_stack+73848,int_stack+73260,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+42504,int_stack+74632,int_stack+73848,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+44856,int_stack+42504,int_stack+34860,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+56028,int_stack+75640,int_stack+74632,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+59052,int_stack+56028,int_stack+42504,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+63756,int_stack+59052,int_stack+44856,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+42504,int_stack+77656,int_stack+76900,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+44772,int_stack+78664,int_stack+77656,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+56028,int_stack+44772,int_stack+42504,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+69636,int_stack+79960,int_stack+78664,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+73524,int_stack+69636,int_stack+44772,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+42504,int_stack+73524,int_stack+56028,36);
 /*--- compute (ip|hf) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+69636,int_stack+120412,int_stack+104596,210);
     Libderiv->ABCD[11] = int_stack + 69636;
 /*--- compute (ip|hf) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+164092,int_stack+133852,int_stack+127972,210);
     Libderiv->ABCD[10] = int_stack + 164092;
 /*--- compute (ip|hf) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+116356,int_stack+141412,int_stack+110476,210);
     Libderiv->ABCD[9] = int_stack + 116356;
 /*--- compute (ip|hf) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+181732,int_stack+148972,int_stack+15372,210);
     Libderiv->ABCD[8] = int_stack + 181732;
 /*--- compute (ip|hf) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+133996,int_stack+5880,int_stack+0,210);
     Libderiv->ABCD[7] = int_stack + 133996;
 /*--- compute (ip|hf) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+0,int_stack+156532,int_stack+36624,210);
     Libderiv->ABCD[6] = int_stack + 0;
 /*--- compute (ip|hf) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+199372,int_stack+95104,int_stack+50148, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[2] = int_stack + 199372;
 /*--- compute (ip|hf) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+95104,int_stack+21252,int_stack+28980, 0.0, zero_stack, 1.0, int_stack+89224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[1] = int_stack + 95104;
 /*--- compute (ip|hf) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+17640,int_stack+42504,int_stack+63756, 1.0, int_stack+89224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[0] = int_stack + 17640;

}
