/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <libint/libint.h>
#include "libderiv.h"

void deriv_build_DX_n(prim_data *Data, const int abc_num, double *vp, const double *I0, const double *I1)
{
  const double twotzeta = Data->twozeta_d;
  const double *i0, *i1;
  int abc;

  for(abc=0;abc<abc_num;abc++) {
    *(vp++) = twotzeta*I0[0] - 10.000000*I1[0];
    *(vp++) = twotzeta*I0[1] - 9.000000*I1[1];
    *(vp++) = twotzeta*I0[2] - 9.000000*I1[2];
    *(vp++) = twotzeta*I0[3] - 8.000000*I1[3];
    *(vp++) = twotzeta*I0[4] - 8.000000*I1[4];
    *(vp++) = twotzeta*I0[5] - 8.000000*I1[5];
    *(vp++) = twotzeta*I0[6] - 7.000000*I1[6];
    *(vp++) = twotzeta*I0[7] - 7.000000*I1[7];
    *(vp++) = twotzeta*I0[8] - 7.000000*I1[8];
    *(vp++) = twotzeta*I0[9] - 7.000000*I1[9];
    *(vp++) = twotzeta*I0[10] - 6.000000*I1[10];
    *(vp++) = twotzeta*I0[11] - 6.000000*I1[11];
    *(vp++) = twotzeta*I0[12] - 6.000000*I1[12];
    *(vp++) = twotzeta*I0[13] - 6.000000*I1[13];
    *(vp++) = twotzeta*I0[14] - 6.000000*I1[14];
    *(vp++) = twotzeta*I0[15] - 5.000000*I1[15];
    *(vp++) = twotzeta*I0[16] - 5.000000*I1[16];
    *(vp++) = twotzeta*I0[17] - 5.000000*I1[17];
    *(vp++) = twotzeta*I0[18] - 5.000000*I1[18];
    *(vp++) = twotzeta*I0[19] - 5.000000*I1[19];
    *(vp++) = twotzeta*I0[20] - 5.000000*I1[20];
    *(vp++) = twotzeta*I0[21] - 4.000000*I1[21];
    *(vp++) = twotzeta*I0[22] - 4.000000*I1[22];
    *(vp++) = twotzeta*I0[23] - 4.000000*I1[23];
    *(vp++) = twotzeta*I0[24] - 4.000000*I1[24];
    *(vp++) = twotzeta*I0[25] - 4.000000*I1[25];
    *(vp++) = twotzeta*I0[26] - 4.000000*I1[26];
    *(vp++) = twotzeta*I0[27] - 4.000000*I1[27];
    *(vp++) = twotzeta*I0[28] - 3.000000*I1[28];
    *(vp++) = twotzeta*I0[29] - 3.000000*I1[29];
    *(vp++) = twotzeta*I0[30] - 3.000000*I1[30];
    *(vp++) = twotzeta*I0[31] - 3.000000*I1[31];
    *(vp++) = twotzeta*I0[32] - 3.000000*I1[32];
    *(vp++) = twotzeta*I0[33] - 3.000000*I1[33];
    *(vp++) = twotzeta*I0[34] - 3.000000*I1[34];
    *(vp++) = twotzeta*I0[35] - 3.000000*I1[35];
    *(vp++) = twotzeta*I0[36] - 2.000000*I1[36];
    *(vp++) = twotzeta*I0[37] - 2.000000*I1[37];
    *(vp++) = twotzeta*I0[38] - 2.000000*I1[38];
    *(vp++) = twotzeta*I0[39] - 2.000000*I1[39];
    *(vp++) = twotzeta*I0[40] - 2.000000*I1[40];
    *(vp++) = twotzeta*I0[41] - 2.000000*I1[41];
    *(vp++) = twotzeta*I0[42] - 2.000000*I1[42];
    *(vp++) = twotzeta*I0[43] - 2.000000*I1[43];
    *(vp++) = twotzeta*I0[44] - 2.000000*I1[44];
    *(vp++) = twotzeta*I0[45] - 1.000000*I1[45];
    *(vp++) = twotzeta*I0[46] - 1.000000*I1[46];
    *(vp++) = twotzeta*I0[47] - 1.000000*I1[47];
    *(vp++) = twotzeta*I0[48] - 1.000000*I1[48];
    *(vp++) = twotzeta*I0[49] - 1.000000*I1[49];
    *(vp++) = twotzeta*I0[50] - 1.000000*I1[50];
    *(vp++) = twotzeta*I0[51] - 1.000000*I1[51];
    *(vp++) = twotzeta*I0[52] - 1.000000*I1[52];
    *(vp++) = twotzeta*I0[53] - 1.000000*I1[53];
    *(vp++) = twotzeta*I0[54] - 1.000000*I1[54];
    *(vp++) = twotzeta*I0[55] ;
    *(vp++) = twotzeta*I0[56] ;
    *(vp++) = twotzeta*I0[57] ;
    *(vp++) = twotzeta*I0[58] ;
    *(vp++) = twotzeta*I0[59] ;
    *(vp++) = twotzeta*I0[60] ;
    *(vp++) = twotzeta*I0[61] ;
    *(vp++) = twotzeta*I0[62] ;
    *(vp++) = twotzeta*I0[63] ;
    *(vp++) = twotzeta*I0[64] ;
    *(vp++) = twotzeta*I0[65] ;
  I0 += 78;  I1 += 55;
  }
}
