/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_d0ml(Libint_t*, prim_data*);

  /* Computes quartets of (d0|ml) integrals */

REALTYPE *hrr_order_d0ml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][9] = int_stack + 0;
 Libint->vrr_classes[2][10] = int_stack + 330;
 Libint->vrr_classes[2][11] = int_stack + 726;
 Libint->vrr_classes[2][12] = int_stack + 1194;
 Libint->vrr_classes[2][13] = int_stack + 1740;
 Libint->vrr_classes[2][14] = int_stack + 2370;
 Libint->vrr_classes[2][15] = int_stack + 3090;
 Libint->vrr_classes[2][16] = int_stack + 3906;
 Libint->vrr_classes[2][17] = int_stack + 4824;
 memset(int_stack,0,5850*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 5850;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_d0ml(Libint, Data);
   Data++;
 }
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+5850,int_stack+330,int_stack+0,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+6840,int_stack+726,int_stack+330,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+8028,int_stack+6840,int_stack+5850,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10008,int_stack+1194,int_stack+726,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+11412,int_stack+10008,int_stack+6840,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+13788,int_stack+11412,int_stack+8028,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+5850,int_stack+1740,int_stack+1194,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+17088,int_stack+5850,int_stack+10008,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+19896,int_stack+17088,int_stack+11412,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+7488,int_stack+19896,int_stack+13788,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+12438,int_stack+2370,int_stack+1740,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+23856,int_stack+12438,int_stack+5850,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+27132,int_stack+23856,int_stack+17088,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+31812,int_stack+27132,int_stack+19896,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+14328,int_stack+31812,int_stack+7488,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+5850,int_stack+3090,int_stack+2370,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+8010,int_stack+5850,int_stack+12438,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+37752,int_stack+8010,int_stack+23856,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+43212,int_stack+37752,int_stack+27132,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+21258,int_stack+43212,int_stack+31812,6);
 /*--- compute (d0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+50232,int_stack+21258,int_stack+14328,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+11790,int_stack+3906,int_stack+3090,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+14238,int_stack+11790,int_stack+5850,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+29574,int_stack+14238,int_stack+8010,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+59472,int_stack+29574,int_stack+37752,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+67662,int_stack+59472,int_stack+43212,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+35874,int_stack+67662,int_stack+21258,6);
 /*--- compute (d0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+77490,int_stack+35874,int_stack+50232,6);
 /*--- compute (d0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+5850,int_stack+4824,int_stack+3906,6);
 /*--- compute (d0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+18558,int_stack+5850,int_stack+11790,6);
 /*--- compute (d0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+46962,int_stack+18558,int_stack+14238,6);
 /*--- compute (d0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+46962,int_stack+29574,6);
 /*--- compute (d0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+46962,int_stack+0,int_stack+59472,6);
 /*--- compute (d0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+46962,int_stack+67662,6);
 /*--- compute (d0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+46962,int_stack+0,int_stack+35874,6);
 /*--- compute (d0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+46962,int_stack+77490,6);
 return int_stack+0;}
