/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddgd(Libint_t*, prim_data*);

  /* Computes quartets of (dd|gd) integrals */

REALTYPE *hrr_order_ddgd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][4] = int_stack + 0;
 Libint->vrr_classes[2][5] = int_stack + 90;
 Libint->vrr_classes[2][6] = int_stack + 216;
 Libint->vrr_classes[3][4] = int_stack + 384;
 Libint->vrr_classes[3][5] = int_stack + 534;
 Libint->vrr_classes[3][6] = int_stack + 744;
 Libint->vrr_classes[4][4] = int_stack + 1024;
 Libint->vrr_classes[4][5] = int_stack + 1249;
 Libint->vrr_classes[4][6] = int_stack + 1564;
 memset(int_stack,0,1984*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1984;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddgd(Libint, Data);
   Data++;
 }
 /*--- compute (d0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+1984,int_stack+90,int_stack+0,6);
 /*--- compute (d0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+2254,int_stack+216,int_stack+90,6);
 /*--- compute (d0|gd) ---*/
 hrr3_build_gd(Libint->CD,int_stack+2632,int_stack+2254,int_stack+1984,6);
 /*--- compute (f0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+1984,int_stack+534,int_stack+384,10);
 /*--- compute (f0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+3172,int_stack+744,int_stack+534,10);
 /*--- compute (f0|gd) ---*/
 hrr3_build_gd(Libint->CD,int_stack+0,int_stack+3172,int_stack+1984,10);
 /*--- compute (dp|gd) ---*/
 hrr1_build_dp(Libint->AB,int_stack+3172,int_stack+0,int_stack+2632,90);
 /*--- compute (g0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+1984,int_stack+1249,int_stack+1024,15);
 /*--- compute (g0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+4792,int_stack+1564,int_stack+1249,15);
 /*--- compute (g0|gd) ---*/
 hrr3_build_gd(Libint->CD,int_stack+5737,int_stack+4792,int_stack+1984,15);
 /*--- compute (fp|gd) ---*/
 hrr1_build_fp(Libint->AB,int_stack+7087,int_stack+5737,int_stack+0,90);
 /*--- compute (dd|gd) ---*/
 hrr1_build_dd(Libint->AB,int_stack+9787,int_stack+7087,int_stack+3172,90);
 return int_stack+9787;}
