/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_dpki(Libint_t*, prim_data*);

  /* Computes quartets of (dp|ki) integrals */

REALTYPE *hrr_order_dpki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][7] = int_stack + 0;
 Libint->vrr_classes[2][8] = int_stack + 216;
 Libint->vrr_classes[2][9] = int_stack + 486;
 Libint->vrr_classes[2][10] = int_stack + 816;
 Libint->vrr_classes[2][11] = int_stack + 1212;
 Libint->vrr_classes[2][12] = int_stack + 1680;
 Libint->vrr_classes[2][13] = int_stack + 2226;
 Libint->vrr_classes[3][7] = int_stack + 2856;
 Libint->vrr_classes[3][8] = int_stack + 3216;
 Libint->vrr_classes[3][9] = int_stack + 3666;
 Libint->vrr_classes[3][10] = int_stack + 4216;
 Libint->vrr_classes[3][11] = int_stack + 4876;
 Libint->vrr_classes[3][12] = int_stack + 5656;
 Libint->vrr_classes[3][13] = int_stack + 6566;
 memset(int_stack,0,7616*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 7616;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_dpki(Libint, Data);
   Data++;
 }
 /*--- compute (d0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+7616,int_stack+216,int_stack+0,6);
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8264,int_stack+486,int_stack+216,6);
 /*--- compute (d0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+9074,int_stack+8264,int_stack+7616,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10370,int_stack+816,int_stack+486,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+11360,int_stack+10370,int_stack+8264,6);
 /*--- compute (d0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+12980,int_stack+11360,int_stack+9074,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7616,int_stack+1212,int_stack+816,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+15140,int_stack+7616,int_stack+10370,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+17120,int_stack+15140,int_stack+11360,6);
 /*--- compute (d0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+8804,int_stack+17120,int_stack+12980,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+12044,int_stack+1680,int_stack+1212,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+19820,int_stack+12044,int_stack+7616,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+22196,int_stack+19820,int_stack+15140,6);
 /*--- compute (d0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+25496,int_stack+22196,int_stack+17120,6);
 /*--- compute (d0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+13448,int_stack+25496,int_stack+8804,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+7616,int_stack+2226,int_stack+1680,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+7616,int_stack+12044,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+7616,int_stack+0,int_stack+19820,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+29546,int_stack+7616,int_stack+22196,6);
 /*--- compute (d0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+7616,int_stack+29546,int_stack+25496,6);
 /*--- compute (d0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+17984,int_stack+7616,int_stack+13448,6);
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+7616,int_stack+3216,int_stack+2856,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8696,int_stack+3666,int_stack+3216,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+10046,int_stack+8696,int_stack+7616,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12206,int_stack+4216,int_stack+3666,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+13856,int_stack+12206,int_stack+8696,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+13856,int_stack+10046,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7616,int_stack+4876,int_stack+4216,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+24032,int_stack+7616,int_stack+12206,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+27332,int_stack+24032,int_stack+13856,10);
 /*--- compute (f0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+9596,int_stack+27332,int_stack+0,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+5656,int_stack+4876,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+31832,int_stack+0,int_stack+7616,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+35792,int_stack+31832,int_stack+24032,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+41292,int_stack+35792,int_stack+27332,10);
 /*--- compute (f0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+24032,int_stack+41292,int_stack+9596,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+7616,int_stack+6566,int_stack+5656,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+10346,int_stack+7616,int_stack+0,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+10346,int_stack+31832,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+6600,int_stack+0,int_stack+35792,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+31592,int_stack+6600,int_stack+41292,10);
 /*--- compute (f0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+0,int_stack+31592,int_stack+24032,10);
 /*--- compute (dp|ki) ---*/
 hrr1_build_dp(Libint->AB,int_stack+24032,int_stack+0,int_stack+17984,1008);
 return int_stack+24032;}
