/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_f0mm(Libint_t*, prim_data*);

  /* Computes quartets of (f0|mm) integrals */

REALTYPE *hrr_order_f0mm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[3][11] = int_stack + 1210;
 Libint->vrr_classes[3][12] = int_stack + 1990;
 Libint->vrr_classes[3][13] = int_stack + 2900;
 Libint->vrr_classes[3][14] = int_stack + 3950;
 Libint->vrr_classes[3][15] = int_stack + 5150;
 Libint->vrr_classes[3][16] = int_stack + 6510;
 Libint->vrr_classes[3][17] = int_stack + 8040;
 Libint->vrr_classes[3][18] = int_stack + 9750;
 memset(int_stack,0,11650*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 11650;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_f0mm(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+11650,int_stack+550,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+13300,int_stack+1210,int_stack+550,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+15280,int_stack+13300,int_stack+11650,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18580,int_stack+1990,int_stack+1210,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+20920,int_stack+18580,int_stack+13300,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+24880,int_stack+20920,int_stack+15280,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+11650,int_stack+2900,int_stack+1990,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+30380,int_stack+11650,int_stack+18580,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+35060,int_stack+30380,int_stack+20920,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+14380,int_stack+35060,int_stack+24880,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+22630,int_stack+3950,int_stack+2900,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+41660,int_stack+22630,int_stack+11650,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+47120,int_stack+41660,int_stack+30380,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+54920,int_stack+47120,int_stack+35060,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+25780,int_stack+54920,int_stack+14380,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+11650,int_stack+5150,int_stack+3950,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+15250,int_stack+11650,int_stack+22630,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+64820,int_stack+15250,int_stack+41660,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+73920,int_stack+64820,int_stack+47120,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+37330,int_stack+73920,int_stack+54920,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+85620,int_stack+37330,int_stack+25780,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+21550,int_stack+6510,int_stack+5150,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+25630,int_stack+21550,int_stack+11650,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+51190,int_stack+25630,int_stack+15250,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+101020,int_stack+51190,int_stack+64820,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+114670,int_stack+101020,int_stack+73920,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+61690,int_stack+114670,int_stack+37330,10);
 /*--- compute (f0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+131050,int_stack+61690,int_stack+85620,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+11650,int_stack+8040,int_stack+6510,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+32830,int_stack+11650,int_stack+21550,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+80170,int_stack+32830,int_stack+25630,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+16240,int_stack+80170,int_stack+51190,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+40990,int_stack+16240,int_stack+101020,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+92170,int_stack+40990,int_stack+114670,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+150850,int_stack+92170,int_stack+61690,10);
 /*--- compute (f0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+174610,int_stack+150850,int_stack+131050,10);
 /*--- compute (f0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+60100,int_stack+9750,int_stack+8040,10);
 /*--- compute (f0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+65230,int_stack+60100,int_stack+11650,10);
 /*--- compute (f0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+114010,int_stack+65230,int_stack+32830,10);
 /*--- compute (f0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+60100,int_stack+114010,int_stack+80170,10);
 /*--- compute (f0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+114010,int_stack+60100,int_stack+16240,10);
 /*--- compute (f0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+60100,int_stack+114010,int_stack+40990,10);
 /*--- compute (f0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+114010,int_stack+60100,int_stack+92170,10);
 /*--- compute (f0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+114010,int_stack+150850,10);
 /*--- compute (f0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+29700,int_stack+0,int_stack+174610,10);
 return int_stack+29700;}
