/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdkg(Libint_t*, prim_data*);

  /* Computes quartets of (fd|kg) integrals */

REALTYPE *hrr_order_fdkg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][7] = int_stack + 0;
 Libint->vrr_classes[3][8] = int_stack + 360;
 Libint->vrr_classes[3][9] = int_stack + 810;
 Libint->vrr_classes[3][10] = int_stack + 1360;
 Libint->vrr_classes[3][11] = int_stack + 2020;
 Libint->vrr_classes[4][7] = int_stack + 2800;
 Libint->vrr_classes[4][8] = int_stack + 3340;
 Libint->vrr_classes[4][9] = int_stack + 4015;
 Libint->vrr_classes[4][10] = int_stack + 4840;
 Libint->vrr_classes[4][11] = int_stack + 5830;
 Libint->vrr_classes[5][7] = int_stack + 7000;
 Libint->vrr_classes[5][8] = int_stack + 7756;
 Libint->vrr_classes[5][9] = int_stack + 8701;
 Libint->vrr_classes[5][10] = int_stack + 9856;
 Libint->vrr_classes[5][11] = int_stack + 11242;
 memset(int_stack,0,12880*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 12880;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdkg(Libint, Data);
   Data++;
 }
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+12880,int_stack+360,int_stack+0,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+13960,int_stack+810,int_stack+360,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+15310,int_stack+13960,int_stack+12880,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+17470,int_stack+1360,int_stack+810,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19120,int_stack+17470,int_stack+13960,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+21820,int_stack+19120,int_stack+15310,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12880,int_stack+2020,int_stack+1360,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+25420,int_stack+12880,int_stack+17470,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+12880,int_stack+25420,int_stack+19120,10);
 /*--- compute (f0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+25420,int_stack+12880,int_stack+21820,10);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+12880,int_stack+3340,int_stack+2800,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+14500,int_stack+4015,int_stack+3340,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+16525,int_stack+14500,int_stack+12880,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+19765,int_stack+4840,int_stack+4015,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+19765,int_stack+14500,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+30820,int_stack+0,int_stack+16525,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12880,int_stack+5830,int_stack+4840,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+36220,int_stack+12880,int_stack+19765,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+12880,int_stack+36220,int_stack+0,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+36220,int_stack+12880,int_stack+30820,15);
 /*--- compute (fp|kg) ---*/
 hrr1_build_fp(Libint->AB,int_stack+44320,int_stack+36220,int_stack+25420,540);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+12880,int_stack+7756,int_stack+7000,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15148,int_stack+8701,int_stack+7756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+17983,int_stack+15148,int_stack+12880,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+22519,int_stack+9856,int_stack+8701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+25984,int_stack+22519,int_stack+15148,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+25984,int_stack+17983,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12880,int_stack+11242,int_stack+9856,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+60520,int_stack+12880,int_stack+22519,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+7560,int_stack+60520,int_stack+25984,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+17010,int_stack+7560,int_stack+0,21);
 /*--- compute (gp|kg) ---*/
 hrr1_build_gp(Libint->AB,int_stack+60520,int_stack+17010,int_stack+36220,540);
 /*--- compute (fd|kg) ---*/
 hrr1_build_fd(Libint->AB,int_stack+0,int_stack+60520,int_stack+44320,540);
 return int_stack+0;}
