/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_g0nh(Libint_t*, prim_data*);

  /* Computes quartets of (g0|nh) integrals */

REALTYPE *hrr_order_g0nh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[4][15] = int_stack + 6900;
 memset(int_stack,0,8940*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 8940;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_g0nh(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+8940,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+11910,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15420,int_stack+11910,int_stack+8940,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+21360,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+25455,int_stack+21360,int_stack+11910,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+32475,int_stack+25455,int_stack+15420,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+8940,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+42375,int_stack+8940,int_stack+21360,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+13665,int_stack+42375,int_stack+25455,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+50565,int_stack+13665,int_stack+32475,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+25365,int_stack+6900,int_stack+5100,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+30765,int_stack+25365,int_stack+8940,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+30765,int_stack+42375,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+25365,int_stack+0,int_stack+13665,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+25365,int_stack+50565,15);
 return int_stack+0;}
