/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gfmi(Libint_t*, prim_data*);

  /* Computes quartets of (gf|mi) integrals */

REALTYPE *hrr_order_gfmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][9] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 825;
 Libint->vrr_classes[4][11] = int_stack + 1815;
 Libint->vrr_classes[4][12] = int_stack + 2985;
 Libint->vrr_classes[4][13] = int_stack + 4350;
 Libint->vrr_classes[4][14] = int_stack + 5925;
 Libint->vrr_classes[4][15] = int_stack + 7725;
 Libint->vrr_classes[5][9] = int_stack + 9765;
 Libint->vrr_classes[5][10] = int_stack + 10920;
 Libint->vrr_classes[5][11] = int_stack + 12306;
 Libint->vrr_classes[5][12] = int_stack + 13944;
 Libint->vrr_classes[5][13] = int_stack + 15855;
 Libint->vrr_classes[5][14] = int_stack + 18060;
 Libint->vrr_classes[5][15] = int_stack + 20580;
 Libint->vrr_classes[6][9] = int_stack + 23436;
 Libint->vrr_classes[6][10] = int_stack + 24976;
 Libint->vrr_classes[6][11] = int_stack + 26824;
 Libint->vrr_classes[6][12] = int_stack + 29008;
 Libint->vrr_classes[6][13] = int_stack + 31556;
 Libint->vrr_classes[6][14] = int_stack + 34496;
 Libint->vrr_classes[6][15] = int_stack + 37856;
 Libint->vrr_classes[7][9] = int_stack + 41664;
 Libint->vrr_classes[7][10] = int_stack + 43644;
 Libint->vrr_classes[7][11] = int_stack + 46020;
 Libint->vrr_classes[7][12] = int_stack + 48828;
 Libint->vrr_classes[7][13] = int_stack + 52104;
 Libint->vrr_classes[7][14] = int_stack + 55884;
 Libint->vrr_classes[7][15] = int_stack + 60204;
 memset(int_stack,0,65100*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 65100;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gfmi(Libint, Data);
   Data++;
 }
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+65100,int_stack+825,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+67575,int_stack+1815,int_stack+825,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+70545,int_stack+67575,int_stack+65100,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+75495,int_stack+2985,int_stack+1815,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+79005,int_stack+75495,int_stack+67575,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+84945,int_stack+79005,int_stack+70545,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+65100,int_stack+4350,int_stack+2985,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+93195,int_stack+65100,int_stack+75495,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+100215,int_stack+93195,int_stack+79005,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+69195,int_stack+100215,int_stack+84945,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+81570,int_stack+5925,int_stack+4350,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+110115,int_stack+81570,int_stack+65100,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+118305,int_stack+110115,int_stack+93195,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+130005,int_stack+118305,int_stack+100215,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+86295,int_stack+130005,int_stack+69195,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+65100,int_stack+7725,int_stack+5925,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+70500,int_stack+65100,int_stack+81570,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+144855,int_stack+70500,int_stack+110115,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+65100,int_stack+144855,int_stack+118305,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+103620,int_stack+65100,int_stack+130005,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+124410,int_stack+103620,int_stack+86295,15);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+65100,int_stack+10920,int_stack+9765,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68565,int_stack+12306,int_stack+10920,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+72723,int_stack+68565,int_stack+65100,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+79653,int_stack+13944,int_stack+12306,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84567,int_stack+79653,int_stack+68565,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+92883,int_stack+84567,int_stack+72723,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+65100,int_stack+15855,int_stack+13944,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+104433,int_stack+65100,int_stack+79653,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+104433,int_stack+84567,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+70833,int_stack+0,int_stack+92883,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+88158,int_stack+18060,int_stack+15855,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+147510,int_stack+88158,int_stack+65100,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+158976,int_stack+147510,int_stack+104433,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+94773,int_stack+158976,int_stack+0,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+175356,int_stack+94773,int_stack+70833,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+20580,int_stack+18060,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+7560,int_stack+0,int_stack+88158,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+65100,int_stack+7560,int_stack+147510,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+199611,int_stack+65100,int_stack+158976,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+65100,int_stack+199611,int_stack+94773,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+199611,int_stack+65100,int_stack+175356,21);
 /*--- compute (gp|mi) ---*/
 hrr1_build_gp(Libint->AB,int_stack+231951,int_stack+199611,int_stack+124410,1540);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+65100,int_stack+24976,int_stack+23436,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+69720,int_stack+26824,int_stack+24976,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+75264,int_stack+69720,int_stack+65100,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84504,int_stack+29008,int_stack+26824,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+91056,int_stack+84504,int_stack+69720,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+102144,int_stack+91056,int_stack+75264,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+65100,int_stack+31556,int_stack+29008,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+117544,int_stack+65100,int_stack+84504,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+130648,int_stack+117544,int_stack+91056,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+72744,int_stack+130648,int_stack+102144,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+95844,int_stack+34496,int_stack+31556,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+149128,int_stack+95844,int_stack+65100,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+164416,int_stack+149128,int_stack+117544,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+164416,int_stack+130648,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+104664,int_stack+0,int_stack+72744,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+65100,int_stack+37856,int_stack+34496,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+75180,int_stack+65100,int_stack+95844,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+301251,int_stack+75180,int_stack+149128,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+65100,int_stack+301251,int_stack+164416,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+137004,int_stack+65100,int_stack+0,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+301251,int_stack+137004,int_stack+104664,28);
 /*--- compute (hp|mi) ---*/
 hrr1_build_hp(Libint->AB,int_stack+65100,int_stack+301251,int_stack+199611,1540);
 /*--- compute (gd|mi) ---*/
 hrr1_build_gd(Libint->AB,int_stack+344371,int_stack+65100,int_stack+231951,1540);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+43644,int_stack+41664,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+5940,int_stack+46020,int_stack+43644,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+13068,int_stack+5940,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+24948,int_stack+48828,int_stack+46020,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33372,int_stack+24948,int_stack+5940,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+162120,int_stack+33372,int_stack+13068,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+52104,int_stack+48828,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+181920,int_stack+0,int_stack+24948,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+198768,int_stack+181920,int_stack+33372,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+9828,int_stack+198768,int_stack+162120,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+162120,int_stack+55884,int_stack+52104,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+222528,int_stack+162120,int_stack+0,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+242184,int_stack+222528,int_stack+181920,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+482971,int_stack+242184,int_stack+198768,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+173460,int_stack+482971,int_stack+9828,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+60204,int_stack+55884,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+12960,int_stack+0,int_stack+162120,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+518611,int_stack+12960,int_stack+222528,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+518611,int_stack+242184,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+215040,int_stack+0,int_stack+482971,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+482971,int_stack+215040,int_stack+173460,36);
 /*--- compute (ip|mi) ---*/
 hrr1_build_ip(Libint->AB,int_stack+162120,int_stack+482971,int_stack+301251,1540);
 /*--- compute (hd|mi) ---*/
 hrr1_build_hd(Libint->AB,int_stack+482971,int_stack+162120,int_stack+65100,1540);
 /*--- compute (gf|mi) ---*/
 hrr1_build_gf(Libint->AB,int_stack+0,int_stack+482971,int_stack+344371,1540);
 return int_stack+0;}
