/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gfmp(Libint_t*, prim_data*);

  /* Computes quartets of (gf|mp) integrals */

REALTYPE *hrr_order_gfmp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][9] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 825;
 Libint->vrr_classes[5][9] = int_stack + 1815;
 Libint->vrr_classes[5][10] = int_stack + 2970;
 Libint->vrr_classes[6][9] = int_stack + 4356;
 Libint->vrr_classes[6][10] = int_stack + 5896;
 Libint->vrr_classes[7][9] = int_stack + 7744;
 Libint->vrr_classes[7][10] = int_stack + 9724;
 memset(int_stack,0,12100*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 12100;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gfmp(Libint, Data);
   Data++;
 }
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12100,int_stack+825,int_stack+0,15);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14575,int_stack+2970,int_stack+1815,21);
 /*--- compute (gp|mp) ---*/
 hrr1_build_gp(Libint->AB,int_stack+18040,int_stack+14575,int_stack+12100,165);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25465,int_stack+5896,int_stack+4356,28);
 /*--- compute (hp|mp) ---*/
 hrr1_build_hp(Libint->AB,int_stack+30085,int_stack+25465,int_stack+14575,165);
 /*--- compute (gd|mp) ---*/
 hrr1_build_gd(Libint->AB,int_stack+40480,int_stack+30085,int_stack+18040,165);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12100,int_stack+9724,int_stack+7744,36);
 /*--- compute (ip|mp) ---*/
 hrr1_build_ip(Libint->AB,int_stack+55330,int_stack+12100,int_stack+25465,165);
 /*--- compute (hd|mp) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+55330,int_stack+30085,165);
 /*--- compute (gf|mp) ---*/
 hrr1_build_gf(Libint->AB,int_stack+55330,int_stack+0,int_stack+40480,165);
 return int_stack+55330;}
