/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gfnk(Libint_t*, prim_data*);

  /* Computes quartets of (gf|nk) integrals */

REALTYPE *hrr_order_gfnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[4][15] = int_stack + 6900;
 Libint->vrr_classes[4][16] = int_stack + 8940;
 Libint->vrr_classes[4][17] = int_stack + 11235;
 Libint->vrr_classes[5][10] = int_stack + 13800;
 Libint->vrr_classes[5][11] = int_stack + 15186;
 Libint->vrr_classes[5][12] = int_stack + 16824;
 Libint->vrr_classes[5][13] = int_stack + 18735;
 Libint->vrr_classes[5][14] = int_stack + 20940;
 Libint->vrr_classes[5][15] = int_stack + 23460;
 Libint->vrr_classes[5][16] = int_stack + 26316;
 Libint->vrr_classes[5][17] = int_stack + 29529;
 Libint->vrr_classes[6][10] = int_stack + 33120;
 Libint->vrr_classes[6][11] = int_stack + 34968;
 Libint->vrr_classes[6][12] = int_stack + 37152;
 Libint->vrr_classes[6][13] = int_stack + 39700;
 Libint->vrr_classes[6][14] = int_stack + 42640;
 Libint->vrr_classes[6][15] = int_stack + 46000;
 Libint->vrr_classes[6][16] = int_stack + 49808;
 Libint->vrr_classes[6][17] = int_stack + 54092;
 Libint->vrr_classes[7][10] = int_stack + 58880;
 Libint->vrr_classes[7][11] = int_stack + 61256;
 Libint->vrr_classes[7][12] = int_stack + 64064;
 Libint->vrr_classes[7][13] = int_stack + 67340;
 Libint->vrr_classes[7][14] = int_stack + 71120;
 Libint->vrr_classes[7][15] = int_stack + 75440;
 Libint->vrr_classes[7][16] = int_stack + 80336;
 Libint->vrr_classes[7][17] = int_stack + 85844;
 memset(int_stack,0,92000*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 92000;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gfnk(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+92000,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+94970,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+98480,int_stack+94970,int_stack+92000,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+104420,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+108515,int_stack+104420,int_stack+94970,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+115535,int_stack+108515,int_stack+98480,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+92000,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+125435,int_stack+92000,int_stack+104420,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+96725,int_stack+125435,int_stack+108515,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+133625,int_stack+96725,int_stack+115535,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+108425,int_stack+6900,int_stack+5100,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113825,int_stack+108425,int_stack+92000,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+148475,int_stack+113825,int_stack+125435,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+162125,int_stack+148475,int_stack+96725,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+179675,int_stack+162125,int_stack+133625,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+92000,int_stack+8940,int_stack+6900,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+123275,int_stack+92000,int_stack+108425,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+200465,int_stack+123275,int_stack+113825,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+98120,int_stack+200465,int_stack+148475,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+134075,int_stack+98120,int_stack+162125,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+216215,int_stack+134075,int_stack+179675,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+158645,int_stack+11235,int_stack+8940,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+165530,int_stack+158645,int_stack+92000,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+177770,int_stack+165530,int_stack+123275,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+243935,int_stack+177770,int_stack+200465,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+158645,int_stack+243935,int_stack+98120,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+92000,int_stack+158645,int_stack+134075,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+124760,int_stack+92000,int_stack+216215,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+92000,int_stack+15186,int_stack+13800,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+96158,int_stack+16824,int_stack+15186,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+101072,int_stack+96158,int_stack+92000,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+109388,int_stack+18735,int_stack+16824,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+160400,int_stack+109388,int_stack+96158,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+170228,int_stack+160400,int_stack+101072,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+92000,int_stack+20940,int_stack+18735,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+184088,int_stack+92000,int_stack+109388,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+98615,int_stack+184088,int_stack+160400,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+195554,int_stack+98615,int_stack+170228,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+160400,int_stack+23460,int_stack+20940,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+167960,int_stack+160400,int_stack+92000,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+216344,int_stack+167960,int_stack+184088,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+235454,int_stack+216344,int_stack+98615,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+92000,int_stack+235454,int_stack+195554,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+181190,int_stack+26316,int_stack+23460,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+189758,int_stack+181190,int_stack+160400,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+189758,int_stack+167960,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+260024,int_stack+0,int_stack+216344,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+288689,int_stack+260024,int_stack+235454,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+204878,int_stack+288689,int_stack+92000,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+92000,int_stack+29529,int_stack+26316,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+101639,int_stack+92000,int_stack+181190,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+160400,int_stack+101639,int_stack+189758,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+323087,int_stack+160400,int_stack+0,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+160400,int_stack+323087,int_stack+260024,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+323087,int_stack+160400,int_stack+288689,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+243686,int_stack+323087,int_stack+204878,21);
 /*--- compute (gp|nk) ---*/
 hrr1_build_gp(Libint->AB,int_stack+293582,int_stack+243686,int_stack+124760,2376);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+34968,int_stack+33120,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5544,int_stack+37152,int_stack+34968,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+12096,int_stack+5544,int_stack+0,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+23184,int_stack+39700,int_stack+37152,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+92000,int_stack+23184,int_stack+5544,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+105104,int_stack+92000,int_stack+12096,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+42640,int_stack+39700,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+123584,int_stack+0,int_stack+23184,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+8820,int_stack+123584,int_stack+92000,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+138872,int_stack+8820,int_stack+105104,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+92000,int_stack+46000,int_stack+42640,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+102080,int_stack+92000,int_stack+0,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+166592,int_stack+102080,int_stack+123584,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+192072,int_stack+166592,int_stack+8820,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+192072,int_stack+138872,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+119720,int_stack+49808,int_stack+46000,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+131144,int_stack+119720,int_stack+92000,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+400502,int_stack+131144,int_stack+102080,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+429902,int_stack+400502,int_stack+166592,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+468122,int_stack+429902,int_stack+192072,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+151304,int_stack+468122,int_stack+0,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+54092,int_stack+49808,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+12852,int_stack+0,int_stack+119720,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+92000,int_stack+12852,int_stack+131144,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+92000,int_stack+400502,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+92000,int_stack+0,int_stack+429902,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+400502,int_stack+92000,int_stack+468122,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+461654,int_stack+400502,int_stack+151304,28);
 /*--- compute (hp|nk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+92000,int_stack+461654,int_stack+243686,2376);
 /*--- compute (gd|nk) ---*/
 hrr1_build_gd(Libint->AB,int_stack+528182,int_stack+92000,int_stack+293582,2376);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+241688,int_stack+61256,int_stack+58880,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+248816,int_stack+64064,int_stack+61256,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+257240,int_stack+248816,int_stack+241688,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+271496,int_stack+67340,int_stack+64064,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+281324,int_stack+271496,int_stack+248816,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+298172,int_stack+281324,int_stack+257240,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+241688,int_stack+71120,int_stack+67340,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+321932,int_stack+241688,int_stack+271496,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+253028,int_stack+321932,int_stack+281324,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+341588,int_stack+253028,int_stack+298172,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+281108,int_stack+75440,int_stack+71120,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+294068,int_stack+281108,int_stack+241688,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+377228,int_stack+294068,int_stack+321932,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+409988,int_stack+377228,int_stack+253028,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+409988,int_stack+341588,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+241688,int_stack+80336,int_stack+75440,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+316748,int_stack+241688,int_stack+281108,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+742022,int_stack+316748,int_stack+294068,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+256376,int_stack+742022,int_stack+377228,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+342668,int_stack+256376,int_stack+409988,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+779822,int_stack+342668,int_stack+0,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+85844,int_stack+80336,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+16524,int_stack+0,int_stack+241688,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+45900,int_stack+16524,int_stack+316748,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+401636,int_stack+45900,int_stack+742022,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+401636,int_stack+256376,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+241688,int_stack+0,int_stack+342668,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+241688,int_stack+779822,36);
 /*--- compute (ip|nk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+241688,int_stack+0,int_stack+461654,2376);
 /*--- compute (hd|nk) ---*/
 hrr1_build_hd(Libint->AB,int_stack+742022,int_stack+241688,int_stack+92000,2376);
 /*--- compute (gf|nk) ---*/
 hrr1_build_gf(Libint->AB,int_stack+0,int_stack+742022,int_stack+528182,2376);
 return int_stack+0;}
