/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggif(Libint_t*, prim_data*);

  /* Computes quartets of (gg|if) integrals */

REALTYPE *hrr_order_ggif(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][6] = int_stack + 0;
 Libint->vrr_classes[4][7] = int_stack + 420;
 Libint->vrr_classes[4][8] = int_stack + 960;
 Libint->vrr_classes[4][9] = int_stack + 1635;
 Libint->vrr_classes[5][6] = int_stack + 2460;
 Libint->vrr_classes[5][7] = int_stack + 3048;
 Libint->vrr_classes[5][8] = int_stack + 3804;
 Libint->vrr_classes[5][9] = int_stack + 4749;
 Libint->vrr_classes[6][6] = int_stack + 5904;
 Libint->vrr_classes[6][7] = int_stack + 6688;
 Libint->vrr_classes[6][8] = int_stack + 7696;
 Libint->vrr_classes[6][9] = int_stack + 8956;
 Libint->vrr_classes[7][6] = int_stack + 10496;
 Libint->vrr_classes[7][7] = int_stack + 11504;
 Libint->vrr_classes[7][8] = int_stack + 12800;
 Libint->vrr_classes[7][9] = int_stack + 14420;
 Libint->vrr_classes[8][6] = int_stack + 16400;
 Libint->vrr_classes[8][7] = int_stack + 17660;
 Libint->vrr_classes[8][8] = int_stack + 19280;
 Libint->vrr_classes[8][9] = int_stack + 21305;
 memset(int_stack,0,23780*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 23780;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggif(Libint, Data);
   Data++;
 }
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+23780,int_stack+420,int_stack+0,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+25040,int_stack+960,int_stack+420,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+26660,int_stack+25040,int_stack+23780,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+29180,int_stack+1635,int_stack+960,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+31205,int_stack+29180,int_stack+25040,15);
 /*--- compute (g0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+34445,int_stack+31205,int_stack+26660,15);
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+23780,int_stack+3048,int_stack+2460,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+25544,int_stack+3804,int_stack+3048,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+27812,int_stack+25544,int_stack+23780,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+31340,int_stack+4749,int_stack+3804,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+0,int_stack+31340,int_stack+25544,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+38645,int_stack+0,int_stack+27812,21);
 /*--- compute (gp|if) ---*/
 hrr1_build_gp(Libint->AB,int_stack+44525,int_stack+38645,int_stack+34445,280);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+6688,int_stack+5904,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+2352,int_stack+7696,int_stack+6688,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+23780,int_stack+2352,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+28484,int_stack+8956,int_stack+7696,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+32264,int_stack+28484,int_stack+2352,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+32264,int_stack+23780,28);
 /*--- compute (hp|if) ---*/
 hrr1_build_hp(Libint->AB,int_stack+57125,int_stack+0,int_stack+38645,280);
 /*--- compute (gd|if) ---*/
 hrr1_build_gd(Libint->AB,int_stack+74765,int_stack+57125,int_stack+44525,280);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+23780,int_stack+11504,int_stack+10496,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+26804,int_stack+12800,int_stack+11504,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+30692,int_stack+26804,int_stack+23780,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+36740,int_stack+14420,int_stack+12800,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+41600,int_stack+36740,int_stack+26804,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+99965,int_stack+41600,int_stack+30692,36);
 /*--- compute (ip|if) ---*/
 hrr1_build_ip(Libint->AB,int_stack+23780,int_stack+99965,int_stack+0,280);
 /*--- compute (hd|if) ---*/
 hrr1_build_hd(Libint->AB,int_stack+110045,int_stack+23780,int_stack+57125,280);
 /*--- compute (gf|if) ---*/
 hrr1_build_gf(Libint->AB,int_stack+145325,int_stack+110045,int_stack+74765,280);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+17660,int_stack+16400,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3780,int_stack+19280,int_stack+17660,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+8640,int_stack+3780,int_stack+0,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+47300,int_stack+21305,int_stack+19280,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+53375,int_stack+47300,int_stack+3780,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+63095,int_stack+53375,int_stack+8640,45);
 /*--- compute (kp|if) ---*/
 hrr1_build_kp(Libint->AB,int_stack+187325,int_stack+63095,int_stack+99965,280);
 /*--- compute (id|if) ---*/
 hrr1_build_id(Libint->AB,int_stack+47300,int_stack+187325,int_stack+23780,280);
 /*--- compute (hf|if) ---*/
 hrr1_build_hf(Libint->AB,int_stack+187325,int_stack+47300,int_stack+110045,280);
 /*--- compute (gg|if) ---*/
 hrr1_build_gg(Libint->AB,int_stack+0,int_stack+187325,int_stack+145325,280);
 return int_stack+0;}
