/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggig(Libint_t*, prim_data*);

  /* Computes quartets of (gg|ig) integrals */

REALTYPE *hrr_order_ggig(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][6] = int_stack + 0;
 Libint->vrr_classes[4][7] = int_stack + 420;
 Libint->vrr_classes[4][8] = int_stack + 960;
 Libint->vrr_classes[4][9] = int_stack + 1635;
 Libint->vrr_classes[4][10] = int_stack + 2460;
 Libint->vrr_classes[5][6] = int_stack + 3450;
 Libint->vrr_classes[5][7] = int_stack + 4038;
 Libint->vrr_classes[5][8] = int_stack + 4794;
 Libint->vrr_classes[5][9] = int_stack + 5739;
 Libint->vrr_classes[5][10] = int_stack + 6894;
 Libint->vrr_classes[6][6] = int_stack + 8280;
 Libint->vrr_classes[6][7] = int_stack + 9064;
 Libint->vrr_classes[6][8] = int_stack + 10072;
 Libint->vrr_classes[6][9] = int_stack + 11332;
 Libint->vrr_classes[6][10] = int_stack + 12872;
 Libint->vrr_classes[7][6] = int_stack + 14720;
 Libint->vrr_classes[7][7] = int_stack + 15728;
 Libint->vrr_classes[7][8] = int_stack + 17024;
 Libint->vrr_classes[7][9] = int_stack + 18644;
 Libint->vrr_classes[7][10] = int_stack + 20624;
 Libint->vrr_classes[8][6] = int_stack + 23000;
 Libint->vrr_classes[8][7] = int_stack + 24260;
 Libint->vrr_classes[8][8] = int_stack + 25880;
 Libint->vrr_classes[8][9] = int_stack + 27905;
 Libint->vrr_classes[8][10] = int_stack + 30380;
 memset(int_stack,0,33350*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 33350;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggig(Libint, Data);
   Data++;
 }
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+33350,int_stack+420,int_stack+0,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+34610,int_stack+960,int_stack+420,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+36230,int_stack+34610,int_stack+33350,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+38750,int_stack+1635,int_stack+960,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+40775,int_stack+38750,int_stack+34610,15);
 /*--- compute (g0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+44015,int_stack+40775,int_stack+36230,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33350,int_stack+2460,int_stack+1635,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+48215,int_stack+33350,int_stack+38750,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+33350,int_stack+48215,int_stack+40775,15);
 /*--- compute (g0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+48215,int_stack+33350,int_stack+44015,15);
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+33350,int_stack+4038,int_stack+3450,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+35114,int_stack+4794,int_stack+4038,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+37382,int_stack+35114,int_stack+33350,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+40910,int_stack+5739,int_stack+4794,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+0,int_stack+40910,int_stack+35114,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+54515,int_stack+0,int_stack+37382,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33350,int_stack+6894,int_stack+5739,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+60395,int_stack+33350,int_stack+40910,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+33350,int_stack+60395,int_stack+0,21);
 /*--- compute (h0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+60395,int_stack+33350,int_stack+54515,21);
 /*--- compute (gp|ig) ---*/
 hrr1_build_gp(Libint->AB,int_stack+69215,int_stack+60395,int_stack+48215,420);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+33350,int_stack+9064,int_stack+8280,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+35702,int_stack+10072,int_stack+9064,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+38726,int_stack+35702,int_stack+33350,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+43430,int_stack+11332,int_stack+10072,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+47210,int_stack+43430,int_stack+35702,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+47210,int_stack+38726,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33350,int_stack+12872,int_stack+11332,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+88115,int_stack+33350,int_stack+43430,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+33350,int_stack+88115,int_stack+47210,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+43430,int_stack+33350,int_stack+0,28);
 /*--- compute (hp|ig) ---*/
 hrr1_build_hp(Libint->AB,int_stack+88115,int_stack+43430,int_stack+60395,420);
 /*--- compute (gd|ig) ---*/
 hrr1_build_gd(Libint->AB,int_stack+114575,int_stack+88115,int_stack+69215,420);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+15728,int_stack+14720,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3024,int_stack+17024,int_stack+15728,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+6912,int_stack+3024,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+33350,int_stack+18644,int_stack+17024,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+55190,int_stack+33350,int_stack+3024,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+62966,int_stack+55190,int_stack+6912,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+20624,int_stack+18644,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+5940,int_stack+0,int_stack+33350,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+73046,int_stack+5940,int_stack+55190,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+0,int_stack+73046,int_stack+62966,36);
 /*--- compute (ip|ig) ---*/
 hrr1_build_ip(Libint->AB,int_stack+152375,int_stack+0,int_stack+43430,420);
 /*--- compute (hd|ig) ---*/
 hrr1_build_hd(Libint->AB,int_stack+33350,int_stack+152375,int_stack+88115,420);
 /*--- compute (gf|ig) ---*/
 hrr1_build_gf(Libint->AB,int_stack+187655,int_stack+33350,int_stack+114575,420);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+86270,int_stack+24260,int_stack+23000,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+90050,int_stack+25880,int_stack+24260,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+94910,int_stack+90050,int_stack+86270,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+102470,int_stack+27905,int_stack+25880,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+108545,int_stack+102470,int_stack+90050,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+118265,int_stack+108545,int_stack+94910,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+86270,int_stack+30380,int_stack+27905,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+130865,int_stack+86270,int_stack+102470,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+86270,int_stack+130865,int_stack+108545,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+130865,int_stack+86270,int_stack+118265,45);
 /*--- compute (kp|ig) ---*/
 hrr1_build_kp(Libint->AB,int_stack+250655,int_stack+130865,int_stack+0,420);
 /*--- compute (id|ig) ---*/
 hrr1_build_id(Libint->AB,int_stack+296015,int_stack+250655,int_stack+152375,420);
 /*--- compute (hf|ig) ---*/
 hrr1_build_hf(Libint->AB,int_stack+86270,int_stack+296015,int_stack+33350,420);
 /*--- compute (gg|ig) ---*/
 hrr1_build_gg(Libint->AB,int_stack+250655,int_stack+86270,int_stack+187655,420);
 return int_stack+250655;}
