/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggmf(Libint_t*, prim_data*);

  /* Computes quartets of (gg|mf) integrals */

REALTYPE *hrr_order_ggmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][9] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 825;
 Libint->vrr_classes[4][11] = int_stack + 1815;
 Libint->vrr_classes[4][12] = int_stack + 2985;
 Libint->vrr_classes[5][9] = int_stack + 4350;
 Libint->vrr_classes[5][10] = int_stack + 5505;
 Libint->vrr_classes[5][11] = int_stack + 6891;
 Libint->vrr_classes[5][12] = int_stack + 8529;
 Libint->vrr_classes[6][9] = int_stack + 10440;
 Libint->vrr_classes[6][10] = int_stack + 11980;
 Libint->vrr_classes[6][11] = int_stack + 13828;
 Libint->vrr_classes[6][12] = int_stack + 16012;
 Libint->vrr_classes[7][9] = int_stack + 18560;
 Libint->vrr_classes[7][10] = int_stack + 20540;
 Libint->vrr_classes[7][11] = int_stack + 22916;
 Libint->vrr_classes[7][12] = int_stack + 25724;
 Libint->vrr_classes[8][9] = int_stack + 29000;
 Libint->vrr_classes[8][10] = int_stack + 31475;
 Libint->vrr_classes[8][11] = int_stack + 34445;
 Libint->vrr_classes[8][12] = int_stack + 37955;
 memset(int_stack,0,42050*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 42050;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggmf(Libint, Data);
   Data++;
 }
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+42050,int_stack+825,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44525,int_stack+1815,int_stack+825,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+47495,int_stack+44525,int_stack+42050,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+52445,int_stack+2985,int_stack+1815,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+55955,int_stack+52445,int_stack+44525,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+61895,int_stack+55955,int_stack+47495,15);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+42050,int_stack+5505,int_stack+4350,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+45515,int_stack+6891,int_stack+5505,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+49673,int_stack+45515,int_stack+42050,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+56603,int_stack+8529,int_stack+6891,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+56603,int_stack+45515,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+70145,int_stack+0,int_stack+49673,21);
 /*--- compute (gp|mf) ---*/
 hrr1_build_gp(Libint->AB,int_stack+81695,int_stack+70145,int_stack+61895,550);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+11980,int_stack+10440,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4620,int_stack+13828,int_stack+11980,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+42050,int_stack+4620,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+51290,int_stack+16012,int_stack+13828,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+57842,int_stack+51290,int_stack+4620,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+57842,int_stack+42050,28);
 /*--- compute (hp|mf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+106445,int_stack+0,int_stack+70145,550);
 /*--- compute (gd|mf) ---*/
 hrr1_build_gd(Libint->AB,int_stack+141095,int_stack+106445,int_stack+81695,550);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+42050,int_stack+20540,int_stack+18560,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47990,int_stack+22916,int_stack+20540,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+55118,int_stack+47990,int_stack+42050,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+66998,int_stack+25724,int_stack+22916,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+75422,int_stack+66998,int_stack+47990,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+190595,int_stack+75422,int_stack+55118,36);
 /*--- compute (ip|mf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+42050,int_stack+190595,int_stack+0,550);
 /*--- compute (hd|mf) ---*/
 hrr1_build_hd(Libint->AB,int_stack+210395,int_stack+42050,int_stack+106445,550);
 /*--- compute (gf|mf) ---*/
 hrr1_build_gf(Libint->AB,int_stack+279695,int_stack+210395,int_stack+141095,550);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+31475,int_stack+29000,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7425,int_stack+34445,int_stack+31475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16335,int_stack+7425,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+88250,int_stack+37955,int_stack+34445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+98780,int_stack+88250,int_stack+7425,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+116600,int_stack+98780,int_stack+16335,45);
 /*--- compute (kp|mf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+362195,int_stack+116600,int_stack+190595,550);
 /*--- compute (id|mf) ---*/
 hrr1_build_id(Libint->AB,int_stack+88250,int_stack+362195,int_stack+42050,550);
 /*--- compute (hf|mf) ---*/
 hrr1_build_hf(Libint->AB,int_stack+362195,int_stack+88250,int_stack+210395,550);
 /*--- compute (gg|mf) ---*/
 hrr1_build_gg(Libint->AB,int_stack+0,int_stack+362195,int_stack+279695,550);
 return int_stack+0;}
