/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpig(Libint_t*, prim_data*);

  /* Computes quartets of (gp|ig) integrals */

REALTYPE *hrr_order_gpig(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][6] = int_stack + 0;
 Libint->vrr_classes[4][7] = int_stack + 420;
 Libint->vrr_classes[4][8] = int_stack + 960;
 Libint->vrr_classes[4][9] = int_stack + 1635;
 Libint->vrr_classes[4][10] = int_stack + 2460;
 Libint->vrr_classes[5][6] = int_stack + 3450;
 Libint->vrr_classes[5][7] = int_stack + 4038;
 Libint->vrr_classes[5][8] = int_stack + 4794;
 Libint->vrr_classes[5][9] = int_stack + 5739;
 Libint->vrr_classes[5][10] = int_stack + 6894;
 memset(int_stack,0,8280*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 8280;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpig(Libint, Data);
   Data++;
 }
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+8280,int_stack+420,int_stack+0,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+9540,int_stack+960,int_stack+420,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+11160,int_stack+9540,int_stack+8280,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+13680,int_stack+1635,int_stack+960,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+15705,int_stack+13680,int_stack+9540,15);
 /*--- compute (g0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+18945,int_stack+15705,int_stack+11160,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8280,int_stack+2460,int_stack+1635,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23145,int_stack+8280,int_stack+13680,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+8280,int_stack+23145,int_stack+15705,15);
 /*--- compute (g0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+23145,int_stack+8280,int_stack+18945,15);
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+8280,int_stack+4038,int_stack+3450,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+10044,int_stack+4794,int_stack+4038,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+12312,int_stack+10044,int_stack+8280,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15840,int_stack+5739,int_stack+4794,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+0,int_stack+15840,int_stack+10044,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+29445,int_stack+0,int_stack+12312,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8280,int_stack+6894,int_stack+5739,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+35325,int_stack+8280,int_stack+15840,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+4536,int_stack+35325,int_stack+0,21);
 /*--- compute (h0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+12096,int_stack+4536,int_stack+29445,21);
 /*--- compute (gp|ig) ---*/
 hrr1_build_gp(Libint->AB,int_stack+29445,int_stack+12096,int_stack+23145,420);
 return int_stack+29445;}
