/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdii(Libint_t*, prim_data*);

  /* Computes quartets of (hd|ii) integrals */

REALTYPE *hrr_order_hdii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][6] = int_stack + 0;
 Libint->vrr_classes[5][7] = int_stack + 588;
 Libint->vrr_classes[5][8] = int_stack + 1344;
 Libint->vrr_classes[5][9] = int_stack + 2289;
 Libint->vrr_classes[5][10] = int_stack + 3444;
 Libint->vrr_classes[5][11] = int_stack + 4830;
 Libint->vrr_classes[5][12] = int_stack + 6468;
 Libint->vrr_classes[6][6] = int_stack + 8379;
 Libint->vrr_classes[6][7] = int_stack + 9163;
 Libint->vrr_classes[6][8] = int_stack + 10171;
 Libint->vrr_classes[6][9] = int_stack + 11431;
 Libint->vrr_classes[6][10] = int_stack + 12971;
 Libint->vrr_classes[6][11] = int_stack + 14819;
 Libint->vrr_classes[6][12] = int_stack + 17003;
 Libint->vrr_classes[7][6] = int_stack + 19551;
 Libint->vrr_classes[7][7] = int_stack + 20559;
 Libint->vrr_classes[7][8] = int_stack + 21855;
 Libint->vrr_classes[7][9] = int_stack + 23475;
 Libint->vrr_classes[7][10] = int_stack + 25455;
 Libint->vrr_classes[7][11] = int_stack + 27831;
 Libint->vrr_classes[7][12] = int_stack + 30639;
 memset(int_stack,0,33915*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 33915;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdii(Libint, Data);
   Data++;
 }
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+33915,int_stack+588,int_stack+0,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+35679,int_stack+1344,int_stack+588,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+37947,int_stack+35679,int_stack+33915,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41475,int_stack+2289,int_stack+1344,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+44310,int_stack+41475,int_stack+35679,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+48846,int_stack+44310,int_stack+37947,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33915,int_stack+3444,int_stack+2289,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+54726,int_stack+33915,int_stack+41475,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+60396,int_stack+54726,int_stack+44310,21);
 /*--- compute (h0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+37380,int_stack+60396,int_stack+48846,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+46200,int_stack+4830,int_stack+3444,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+67956,int_stack+46200,int_stack+33915,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+74886,int_stack+67956,int_stack+54726,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+84336,int_stack+74886,int_stack+60396,21);
 /*--- compute (h0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+50358,int_stack+84336,int_stack+37380,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33915,int_stack+6468,int_stack+4830,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+33915,int_stack+46200,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+33915,int_stack+0,int_stack+67956,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+95676,int_stack+33915,int_stack+74886,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+33915,int_stack+95676,int_stack+84336,21);
 /*--- compute (h0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+62706,int_stack+33915,int_stack+50358,21);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+33915,int_stack+9163,int_stack+8379,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+36267,int_stack+10171,int_stack+9163,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+39291,int_stack+36267,int_stack+33915,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+43995,int_stack+11431,int_stack+10171,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+47775,int_stack+43995,int_stack+36267,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+53823,int_stack+47775,int_stack+39291,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33915,int_stack+12971,int_stack+11431,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+33915,int_stack+43995,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+79170,int_stack+0,int_stack+47775,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+38535,int_stack+79170,int_stack+53823,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+50295,int_stack+14819,int_stack+12971,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+89250,int_stack+50295,int_stack+33915,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+98490,int_stack+89250,int_stack+0,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+111090,int_stack+98490,int_stack+79170,28);
 /*--- compute (i0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+126210,int_stack+111090,int_stack+38535,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+79170,int_stack+17003,int_stack+14819,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+79170,int_stack+50295,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+33915,int_stack+0,int_stack+89250,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+33915,int_stack+98490,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+33915,int_stack+0,int_stack+111090,28);
 /*--- compute (i0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+79170,int_stack+33915,int_stack+126210,28);
 /*--- compute (hp|ii) ---*/
 hrr1_build_hp(Libint->AB,int_stack+101122,int_stack+79170,int_stack+62706,784);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+33915,int_stack+20559,int_stack+19551,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+36939,int_stack+21855,int_stack+20559,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+40827,int_stack+36939,int_stack+33915,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+46875,int_stack+23475,int_stack+21855,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+51735,int_stack+46875,int_stack+36939,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+59511,int_stack+51735,int_stack+40827,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33915,int_stack+25455,int_stack+23475,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+33915,int_stack+46875,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+9720,int_stack+0,int_stack+51735,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+39855,int_stack+9720,int_stack+59511,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+54975,int_stack+27831,int_stack+25455,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+62103,int_stack+54975,int_stack+33915,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+150514,int_stack+62103,int_stack+0,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+166714,int_stack+150514,int_stack+9720,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+0,int_stack+166714,int_stack+39855,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33915,int_stack+30639,int_stack+27831,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+186154,int_stack+33915,int_stack+54975,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+21168,int_stack+186154,int_stack+62103,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+40968,int_stack+21168,int_stack+150514,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+186154,int_stack+40968,int_stack+166714,36);
 /*--- compute (k0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+150514,int_stack+186154,int_stack+0,36);
 /*--- compute (ip|ii) ---*/
 hrr1_build_ip(Libint->AB,int_stack+0,int_stack+150514,int_stack+79170,784);
 /*--- compute (hd|ii) ---*/
 hrr1_build_hd(Libint->AB,int_stack+150514,int_stack+0,int_stack+101122,784);
 return int_stack+150514;}
