/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfnh(Libint_t*, prim_data*);

  /* Computes quartets of (hf|nh) integrals */

REALTYPE *hrr_order_hfnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[5][15] = int_stack + 9660;
 Libint->vrr_classes[6][10] = int_stack + 12516;
 Libint->vrr_classes[6][11] = int_stack + 14364;
 Libint->vrr_classes[6][12] = int_stack + 16548;
 Libint->vrr_classes[6][13] = int_stack + 19096;
 Libint->vrr_classes[6][14] = int_stack + 22036;
 Libint->vrr_classes[6][15] = int_stack + 25396;
 Libint->vrr_classes[7][10] = int_stack + 29204;
 Libint->vrr_classes[7][11] = int_stack + 31580;
 Libint->vrr_classes[7][12] = int_stack + 34388;
 Libint->vrr_classes[7][13] = int_stack + 37664;
 Libint->vrr_classes[7][14] = int_stack + 41444;
 Libint->vrr_classes[7][15] = int_stack + 45764;
 Libint->vrr_classes[8][10] = int_stack + 50660;
 Libint->vrr_classes[8][11] = int_stack + 53630;
 Libint->vrr_classes[8][12] = int_stack + 57140;
 Libint->vrr_classes[8][13] = int_stack + 61235;
 Libint->vrr_classes[8][14] = int_stack + 65960;
 Libint->vrr_classes[8][15] = int_stack + 71360;
 memset(int_stack,0,77480*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 77480;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfnh(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+77480,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+81638,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+86552,int_stack+81638,int_stack+77480,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+94868,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100601,int_stack+94868,int_stack+81638,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+110429,int_stack+100601,int_stack+86552,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+77480,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+124289,int_stack+77480,int_stack+94868,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+84095,int_stack+124289,int_stack+100601,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+135755,int_stack+84095,int_stack+110429,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+100475,int_stack+9660,int_stack+7140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+108035,int_stack+100475,int_stack+77480,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+156545,int_stack+108035,int_stack+124289,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+100475,int_stack+156545,int_stack+84095,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+156545,int_stack+100475,int_stack+135755,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+77480,int_stack+14364,int_stack+12516,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+83024,int_stack+16548,int_stack+14364,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+89576,int_stack+83024,int_stack+77480,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+100664,int_stack+19096,int_stack+16548,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+108308,int_stack+100664,int_stack+83024,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+121412,int_stack+108308,int_stack+89576,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+77480,int_stack+22036,int_stack+19096,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+139892,int_stack+77480,int_stack+100664,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+86300,int_stack+139892,int_stack+108308,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+185651,int_stack+86300,int_stack+121412,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+108140,int_stack+25396,int_stack+22036,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+118220,int_stack+108140,int_stack+77480,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+118220,int_stack+139892,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+108140,int_stack+0,int_stack+86300,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+213371,int_stack+108140,int_stack+185651,28);
 /*--- compute (hp|nh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+252179,int_stack+213371,int_stack+156545,1386);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+31580,int_stack+29204,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+7128,int_stack+34388,int_stack+31580,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15552,int_stack+7128,int_stack+0,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+77480,int_stack+37664,int_stack+34388,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+87308,int_stack+77480,int_stack+7128,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+104156,int_stack+87308,int_stack+15552,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+41444,int_stack+37664,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+11340,int_stack+0,int_stack+77480,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+127916,int_stack+11340,int_stack+87308,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+155996,int_stack+127916,int_stack+104156,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+77480,int_stack+45764,int_stack+41444,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+90440,int_stack+77480,int_stack+0,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+339497,int_stack+90440,int_stack+11340,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+339497,int_stack+127916,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+77480,int_stack+0,int_stack+155996,36);
 /*--- compute (ip|nh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+339497,int_stack+77480,int_stack+213371,1386);
 /*--- compute (hd|nh) ---*/
 hrr1_build_hd(Libint->AB,int_stack+455921,int_stack+339497,int_stack+252179,1386);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+53630,int_stack+50660,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8910,int_stack+57140,int_stack+53630,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+19440,int_stack+8910,int_stack+0,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+37260,int_stack+61235,int_stack+57140,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+127376,int_stack+37260,int_stack+8910,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+148436,int_stack+127376,int_stack+19440,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+65960,int_stack+61235,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+178136,int_stack+0,int_stack+37260,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+14175,int_stack+178136,int_stack+127376,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+202706,int_stack+14175,int_stack+148436,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+127376,int_stack+71360,int_stack+65960,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+143576,int_stack+127376,int_stack+0,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+247256,int_stack+143576,int_stack+178136,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+127376,int_stack+247256,int_stack+14175,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+247256,int_stack+127376,int_stack+202706,45);
 /*--- compute (kp|nh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+630557,int_stack+247256,int_stack+77480,1386);
 /*--- compute (id|nh) ---*/
 hrr1_build_id(Libint->AB,int_stack+0,int_stack+630557,int_stack+339497,1386);
 /*--- compute (hf|nh) ---*/
 hrr1_build_hf(Libint->AB,int_stack+630557,int_stack+0,int_stack+455921,1386);
 return int_stack+630557;}
