/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgnm(Libint_t*, prim_data*);

  /* Computes quartets of (hg|nm) integrals */

REALTYPE *hrr_order_hgnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[5][15] = int_stack + 9660;
 Libint->vrr_classes[5][16] = int_stack + 12516;
 Libint->vrr_classes[5][17] = int_stack + 15729;
 Libint->vrr_classes[5][18] = int_stack + 19320;
 Libint->vrr_classes[5][19] = int_stack + 23310;
 Libint->vrr_classes[6][10] = int_stack + 27720;
 Libint->vrr_classes[6][11] = int_stack + 29568;
 Libint->vrr_classes[6][12] = int_stack + 31752;
 Libint->vrr_classes[6][13] = int_stack + 34300;
 Libint->vrr_classes[6][14] = int_stack + 37240;
 Libint->vrr_classes[6][15] = int_stack + 40600;
 Libint->vrr_classes[6][16] = int_stack + 44408;
 Libint->vrr_classes[6][17] = int_stack + 48692;
 Libint->vrr_classes[6][18] = int_stack + 53480;
 Libint->vrr_classes[6][19] = int_stack + 58800;
 Libint->vrr_classes[7][10] = int_stack + 64680;
 Libint->vrr_classes[7][11] = int_stack + 67056;
 Libint->vrr_classes[7][12] = int_stack + 69864;
 Libint->vrr_classes[7][13] = int_stack + 73140;
 Libint->vrr_classes[7][14] = int_stack + 76920;
 Libint->vrr_classes[7][15] = int_stack + 81240;
 Libint->vrr_classes[7][16] = int_stack + 86136;
 Libint->vrr_classes[7][17] = int_stack + 91644;
 Libint->vrr_classes[7][18] = int_stack + 97800;
 Libint->vrr_classes[7][19] = int_stack + 104640;
 Libint->vrr_classes[8][10] = int_stack + 112200;
 Libint->vrr_classes[8][11] = int_stack + 115170;
 Libint->vrr_classes[8][12] = int_stack + 118680;
 Libint->vrr_classes[8][13] = int_stack + 122775;
 Libint->vrr_classes[8][14] = int_stack + 127500;
 Libint->vrr_classes[8][15] = int_stack + 132900;
 Libint->vrr_classes[8][16] = int_stack + 139020;
 Libint->vrr_classes[8][17] = int_stack + 145905;
 Libint->vrr_classes[8][18] = int_stack + 153600;
 Libint->vrr_classes[8][19] = int_stack + 162150;
 Libint->vrr_classes[9][10] = int_stack + 171600;
 Libint->vrr_classes[9][11] = int_stack + 175230;
 Libint->vrr_classes[9][12] = int_stack + 179520;
 Libint->vrr_classes[9][13] = int_stack + 184525;
 Libint->vrr_classes[9][14] = int_stack + 190300;
 Libint->vrr_classes[9][15] = int_stack + 196900;
 Libint->vrr_classes[9][16] = int_stack + 204380;
 Libint->vrr_classes[9][17] = int_stack + 212795;
 Libint->vrr_classes[9][18] = int_stack + 222200;
 Libint->vrr_classes[9][19] = int_stack + 232650;
 memset(int_stack,0,244200*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 244200;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgnm(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+244200,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+248358,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+253272,int_stack+248358,int_stack+244200,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+261588,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+267321,int_stack+261588,int_stack+248358,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+277149,int_stack+267321,int_stack+253272,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+244200,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+291009,int_stack+244200,int_stack+261588,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+250815,int_stack+291009,int_stack+267321,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+302475,int_stack+250815,int_stack+277149,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+267195,int_stack+9660,int_stack+7140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+274755,int_stack+267195,int_stack+244200,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+323265,int_stack+274755,int_stack+291009,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+342375,int_stack+323265,int_stack+250815,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+366945,int_stack+342375,int_stack+302475,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+244200,int_stack+12516,int_stack+9660,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+287985,int_stack+244200,int_stack+267195,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+396051,int_stack+287985,int_stack+274755,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+252768,int_stack+396051,int_stack+323265,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+303105,int_stack+252768,int_stack+342375,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+418101,int_stack+303105,int_stack+366945,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+337503,int_stack+15729,int_stack+12516,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+347142,int_stack+337503,int_stack+244200,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+364278,int_stack+347142,int_stack+287985,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+456909,int_stack+364278,int_stack+396051,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+489984,int_stack+456909,int_stack+252768,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+244200,int_stack+489984,int_stack+303105,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+530115,int_stack+244200,int_stack+418101,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+290064,int_stack+19320,int_stack+15729,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+300837,int_stack+290064,int_stack+337503,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+389478,int_stack+300837,int_stack+347142,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+320115,int_stack+389478,int_stack+364278,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+580011,int_stack+320115,int_stack+456909,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+418038,int_stack+580011,int_stack+489984,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+626316,int_stack+418038,int_stack+244200,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+685284,int_stack+626316,int_stack+530115,21);
 /*--- compute (h0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+244200,int_stack+23310,int_stack+19320,21);
 /*--- compute (h0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+256170,int_stack+244200,int_stack+290064,21);
 /*--- compute (h0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+471546,int_stack+256170,int_stack+300837,21);
 /*--- compute (h0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+244200,int_stack+471546,int_stack+389478,21);
 /*--- compute (h0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+471546,int_stack+244200,int_stack+320115,21);
 /*--- compute (h0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+244200,int_stack+471546,int_stack+580011,21);
 /*--- compute (h0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+471546,int_stack+244200,int_stack+418038,21);
 /*--- compute (h0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+244200,int_stack+471546,int_stack+626316,21);
 /*--- compute (h0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+317910,int_stack+244200,int_stack+685284,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+244200,int_stack+29568,int_stack+27720,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+249744,int_stack+31752,int_stack+29568,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+256296,int_stack+249744,int_stack+244200,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+267384,int_stack+34300,int_stack+31752,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+275028,int_stack+267384,int_stack+249744,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+288132,int_stack+275028,int_stack+256296,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+244200,int_stack+37240,int_stack+34300,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+394140,int_stack+244200,int_stack+267384,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+253020,int_stack+394140,int_stack+275028,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+409428,int_stack+253020,int_stack+288132,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+274860,int_stack+40600,int_stack+37240,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+284940,int_stack+274860,int_stack+244200,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+437148,int_stack+284940,int_stack+394140,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+462628,int_stack+437148,int_stack+253020,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+495388,int_stack+462628,int_stack+409428,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+394140,int_stack+44408,int_stack+40600,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+405564,int_stack+394140,int_stack+274860,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+244200,int_stack+405564,int_stack+284940,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+273600,int_stack+244200,int_stack+437148,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+534196,int_stack+273600,int_stack+462628,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+425724,int_stack+534196,int_stack+495388,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+477468,int_stack+48692,int_stack+44408,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+490320,int_stack+477468,int_stack+394140,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+580060,int_stack+490320,int_stack+405564,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+613660,int_stack+580060,int_stack+244200,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+657760,int_stack+613660,int_stack+273600,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+244200,int_stack+657760,int_stack+534196,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+513168,int_stack+244200,int_stack+425724,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+394140,int_stack+53480,int_stack+48692,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+408504,int_stack+394140,int_stack+477468,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+434208,int_stack+408504,int_stack+490320,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+434208,int_stack+580060,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+711268,int_stack+0,int_stack+613660,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+579696,int_stack+711268,int_stack+657760,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+773008,int_stack+579696,int_stack+244200,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+851632,int_stack+773008,int_stack+513168,28);
 /*--- compute (i0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+244200,int_stack+58800,int_stack+53480,28);
 /*--- compute (i0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+260160,int_stack+244200,int_stack+394140,28);
 /*--- compute (i0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+472288,int_stack+260160,int_stack+408504,28);
 /*--- compute (i0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+244200,int_stack+472288,int_stack+434208,28);
 /*--- compute (i0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+394140,int_stack+244200,int_stack+0,28);
 /*--- compute (i0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+464700,int_stack+394140,int_stack+711268,28);
 /*--- compute (i0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+651040,int_stack+464700,int_stack+579696,28);
 /*--- compute (i0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+394140,int_stack+651040,int_stack+773008,28);
 /*--- compute (i0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+492420,int_stack+394140,int_stack+851632,28);
 /*--- compute (hp|nm) ---*/
 hrr1_build_hp(Libint->AB,int_stack+594060,int_stack+492420,int_stack+317910,3630);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+822750,int_stack+67056,int_stack+64680,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+829878,int_stack+69864,int_stack+67056,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+838302,int_stack+829878,int_stack+822750,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+852558,int_stack+73140,int_stack+69864,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+862386,int_stack+852558,int_stack+829878,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+879234,int_stack+862386,int_stack+838302,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+822750,int_stack+76920,int_stack+73140,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+902994,int_stack+822750,int_stack+852558,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+834090,int_stack+902994,int_stack+862386,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+834090,int_stack+879234,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+862170,int_stack+81240,int_stack+76920,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+875130,int_stack+862170,int_stack+822750,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+35640,int_stack+875130,int_stack+902994,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+244200,int_stack+35640,int_stack+834090,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+286320,int_stack+244200,int_stack+0,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+86136,int_stack+81240,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+822750,int_stack+0,int_stack+862170,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+336216,int_stack+822750,int_stack+875130,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+848670,int_stack+336216,int_stack+35640,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+14688,int_stack+848670,int_stack+244200,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+374016,int_stack+14688,int_stack+286320,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+244200,int_stack+91644,int_stack+86136,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+260724,int_stack+244200,int_stack+0,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+290100,int_stack+260724,int_stack+822750,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+897810,int_stack+290100,int_stack+336216,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+954510,int_stack+897810,int_stack+848670,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1023306,int_stack+954510,int_stack+14688,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1023306,int_stack+374016,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+822750,int_stack+97800,int_stack+91644,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+841218,int_stack+822750,int_stack+244200,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+333300,int_stack+841218,int_stack+260724,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+382260,int_stack+333300,int_stack+290100,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+244200,int_stack+382260,int_stack+897810,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1101930,int_stack+244200,int_stack+954510,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+874266,int_stack+1101930,int_stack+1023306,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+975354,int_stack+874266,int_stack+0,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+104640,int_stack+97800,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+20520,int_stack+0,int_stack+822750,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1193658,int_stack+20520,int_stack+841218,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+1193658,int_stack+333300,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1193658,int_stack+0,int_stack+382260,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+0,int_stack+1193658,int_stack+244200,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+244200,int_stack+0,int_stack+1101930,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+362136,int_stack+244200,int_stack+874266,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+822750,int_stack+362136,int_stack+975354,36);
 /*--- compute (ip|nm) ---*/
 hrr1_build_ip(Libint->AB,int_stack+953430,int_stack+822750,int_stack+492420,3630);
 /*--- compute (hd|nm) ---*/
 hrr1_build_hd(Libint->AB,int_stack+1258350,int_stack+953430,int_stack+594060,3630);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+244200,int_stack+115170,int_stack+112200,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+253110,int_stack+118680,int_stack+115170,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+263640,int_stack+253110,int_stack+244200,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+281460,int_stack+122775,int_stack+118680,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+293745,int_stack+281460,int_stack+253110,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+314805,int_stack+293745,int_stack+263640,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+244200,int_stack+127500,int_stack+122775,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+344505,int_stack+244200,int_stack+281460,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+258375,int_stack+344505,int_stack+293745,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+369075,int_stack+258375,int_stack+314805,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+293475,int_stack+132900,int_stack+127500,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+309675,int_stack+293475,int_stack+244200,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+413625,int_stack+309675,int_stack+344505,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+454575,int_stack+413625,int_stack+258375,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+507225,int_stack+454575,int_stack+369075,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+244200,int_stack+139020,int_stack+132900,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+338025,int_stack+244200,int_stack+293475,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+569595,int_stack+338025,int_stack+309675,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+262560,int_stack+569595,int_stack+413625,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+370425,int_stack+262560,int_stack+454575,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+616845,int_stack+370425,int_stack+507225,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+444135,int_stack+145905,int_stack+139020,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+464790,int_stack+444135,int_stack+244200,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+501510,int_stack+464790,int_stack+338025,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+700005,int_stack+501510,int_stack+569595,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+700005,int_stack+262560,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+244200,int_stack+0,int_stack+370425,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1715730,int_stack+244200,int_stack+616845,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+342480,int_stack+153600,int_stack+145905,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+365565,int_stack+342480,int_stack+444135,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+555510,int_stack+365565,int_stack+464790,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+406875,int_stack+555510,int_stack+501510,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1822650,int_stack+406875,int_stack+700005,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+616710,int_stack+1822650,int_stack+0,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+616710,int_stack+244200,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1921875,int_stack+0,int_stack+1715730,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1715730,int_stack+162150,int_stack+153600,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1741380,int_stack+1715730,int_stack+342480,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+244200,int_stack+1741380,int_stack+365565,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1715730,int_stack+244200,int_stack+555510,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+244200,int_stack+1715730,int_stack+406875,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+357600,int_stack+244200,int_stack+1822650,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1715730,int_stack+357600,int_stack+616710,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+244200,int_stack+1715730,int_stack+0,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+244200,int_stack+1921875,45);
 /*--- compute (kp|nm) ---*/
 hrr1_build_kp(Libint->AB,int_stack+244200,int_stack+0,int_stack+822750,3630);
 /*--- compute (id|nm) ---*/
 hrr1_build_id(Libint->AB,int_stack+1715730,int_stack+244200,int_stack+953430,3630);
 /*--- compute (hf|nm) ---*/
 hrr1_build_hf(Libint->AB,int_stack+2325570,int_stack+1715730,int_stack+1258350,3630);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+636240,int_stack+175230,int_stack+171600,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+647130,int_stack+179520,int_stack+175230,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+660000,int_stack+647130,int_stack+636240,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+681780,int_stack+184525,int_stack+179520,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+696795,int_stack+681780,int_stack+647130,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+722535,int_stack+696795,int_stack+660000,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+636240,int_stack+190300,int_stack+184525,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+758835,int_stack+636240,int_stack+681780,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+653565,int_stack+758835,int_stack+696795,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+788865,int_stack+653565,int_stack+722535,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+696465,int_stack+196900,int_stack+190300,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+716265,int_stack+696465,int_stack+636240,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+843315,int_stack+716265,int_stack+758835,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+893365,int_stack+843315,int_stack+653565,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+957715,int_stack+893365,int_stack+788865,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+636240,int_stack+204380,int_stack+196900,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+750915,int_stack+636240,int_stack+696465,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1033945,int_stack+750915,int_stack+716265,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+658680,int_stack+1033945,int_stack+843315,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+790515,int_stack+658680,int_stack+893365,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1091695,int_stack+790515,int_stack+957715,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+880605,int_stack+212795,int_stack+204380,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+905850,int_stack+880605,int_stack+636240,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+950730,int_stack+905850,int_stack+750915,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1193335,int_stack+950730,int_stack+1033945,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1279960,int_stack+1193335,int_stack+658680,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+636240,int_stack+1279960,int_stack+790515,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1385065,int_stack+636240,int_stack+1091695,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+756360,int_stack+222200,int_stack+212795,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+784575,int_stack+756360,int_stack+880605,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1016730,int_stack+784575,int_stack+905850,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+835065,int_stack+1016730,int_stack+950730,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1515745,int_stack+835065,int_stack+1193335,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1091530,int_stack+1515745,int_stack+1279960,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3087870,int_stack+1091530,int_stack+636240,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3242310,int_stack+3087870,int_stack+1385065,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+636240,int_stack+232650,int_stack+222200,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+667590,int_stack+636240,int_stack+756360,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1231670,int_stack+667590,int_stack+784575,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+636240,int_stack+1231670,int_stack+1016730,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1231670,int_stack+636240,int_stack+835065,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+636240,int_stack+1231670,int_stack+1515745,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1231670,int_stack+636240,int_stack+1091530,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+636240,int_stack+1231670,int_stack+3087870,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+829290,int_stack+636240,int_stack+3242310,55);
 /*--- compute (lp|nm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1028940,int_stack+829290,int_stack+0,3630);
 /*--- compute (kd|nm) ---*/
 hrr1_build_kd(Libint->AB,int_stack+3087870,int_stack+1028940,int_stack+244200,3630);
 /*--- compute (if|nm) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+3087870,int_stack+1715730,3630);
 /*--- compute (hg|nm) ---*/
 hrr1_build_hg(Libint->AB,int_stack+1016400,int_stack+0,int_stack+2325570,3630);
 return int_stack+1016400;}
