/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hhmm(Libint_t*, prim_data*);

  /* Computes quartets of (hh|mm) integrals */

REALTYPE *hrr_order_hhmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[5][14] = int_stack + 8295;
 Libint->vrr_classes[5][15] = int_stack + 10815;
 Libint->vrr_classes[5][16] = int_stack + 13671;
 Libint->vrr_classes[5][17] = int_stack + 16884;
 Libint->vrr_classes[5][18] = int_stack + 20475;
 Libint->vrr_classes[6][9] = int_stack + 24465;
 Libint->vrr_classes[6][10] = int_stack + 26005;
 Libint->vrr_classes[6][11] = int_stack + 27853;
 Libint->vrr_classes[6][12] = int_stack + 30037;
 Libint->vrr_classes[6][13] = int_stack + 32585;
 Libint->vrr_classes[6][14] = int_stack + 35525;
 Libint->vrr_classes[6][15] = int_stack + 38885;
 Libint->vrr_classes[6][16] = int_stack + 42693;
 Libint->vrr_classes[6][17] = int_stack + 46977;
 Libint->vrr_classes[6][18] = int_stack + 51765;
 Libint->vrr_classes[7][9] = int_stack + 57085;
 Libint->vrr_classes[7][10] = int_stack + 59065;
 Libint->vrr_classes[7][11] = int_stack + 61441;
 Libint->vrr_classes[7][12] = int_stack + 64249;
 Libint->vrr_classes[7][13] = int_stack + 67525;
 Libint->vrr_classes[7][14] = int_stack + 71305;
 Libint->vrr_classes[7][15] = int_stack + 75625;
 Libint->vrr_classes[7][16] = int_stack + 80521;
 Libint->vrr_classes[7][17] = int_stack + 86029;
 Libint->vrr_classes[7][18] = int_stack + 92185;
 Libint->vrr_classes[8][9] = int_stack + 99025;
 Libint->vrr_classes[8][10] = int_stack + 101500;
 Libint->vrr_classes[8][11] = int_stack + 104470;
 Libint->vrr_classes[8][12] = int_stack + 107980;
 Libint->vrr_classes[8][13] = int_stack + 112075;
 Libint->vrr_classes[8][14] = int_stack + 116800;
 Libint->vrr_classes[8][15] = int_stack + 122200;
 Libint->vrr_classes[8][16] = int_stack + 128320;
 Libint->vrr_classes[8][17] = int_stack + 135205;
 Libint->vrr_classes[8][18] = int_stack + 142900;
 Libint->vrr_classes[9][9] = int_stack + 151450;
 Libint->vrr_classes[9][10] = int_stack + 154475;
 Libint->vrr_classes[9][11] = int_stack + 158105;
 Libint->vrr_classes[9][12] = int_stack + 162395;
 Libint->vrr_classes[9][13] = int_stack + 167400;
 Libint->vrr_classes[9][14] = int_stack + 173175;
 Libint->vrr_classes[9][15] = int_stack + 179775;
 Libint->vrr_classes[9][16] = int_stack + 187255;
 Libint->vrr_classes[9][17] = int_stack + 195670;
 Libint->vrr_classes[9][18] = int_stack + 205075;
 Libint->vrr_classes[10][9] = int_stack + 215525;
 Libint->vrr_classes[10][10] = int_stack + 219155;
 Libint->vrr_classes[10][11] = int_stack + 223511;
 Libint->vrr_classes[10][12] = int_stack + 228659;
 Libint->vrr_classes[10][13] = int_stack + 234665;
 Libint->vrr_classes[10][14] = int_stack + 241595;
 Libint->vrr_classes[10][15] = int_stack + 249515;
 Libint->vrr_classes[10][16] = int_stack + 258491;
 Libint->vrr_classes[10][17] = int_stack + 268589;
 Libint->vrr_classes[10][18] = int_stack + 279875;
 memset(int_stack,0,292415*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 292415;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hhmm(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+292415,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+295880,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+300038,int_stack+295880,int_stack+292415,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+306968,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+311882,int_stack+306968,int_stack+295880,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+320198,int_stack+311882,int_stack+300038,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+292415,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+331748,int_stack+292415,int_stack+306968,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+341576,int_stack+331748,int_stack+311882,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+298148,int_stack+341576,int_stack+320198,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+315473,int_stack+8295,int_stack+6090,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+355436,int_stack+315473,int_stack+292415,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+366902,int_stack+355436,int_stack+331748,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+383282,int_stack+366902,int_stack+341576,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+322088,int_stack+383282,int_stack+298148,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+292415,int_stack+10815,int_stack+8295,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+299975,int_stack+292415,int_stack+315473,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+404072,int_stack+299975,int_stack+355436,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+423182,int_stack+404072,int_stack+366902,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+346343,int_stack+423182,int_stack+383282,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+447752,int_stack+346343,int_stack+322088,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+313205,int_stack+13671,int_stack+10815,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+321773,int_stack+313205,int_stack+292415,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+375449,int_stack+321773,int_stack+299975,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+480092,int_stack+375449,int_stack+404072,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+508757,int_stack+480092,int_stack+423182,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+397499,int_stack+508757,int_stack+346343,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+543155,int_stack+397499,int_stack+447752,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+292415,int_stack+16884,int_stack+13671,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+336893,int_stack+292415,int_stack+313205,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+436307,int_stack+336893,int_stack+321773,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+302054,int_stack+436307,int_stack+375449,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+354029,int_stack+302054,int_stack+480092,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+461507,int_stack+354029,int_stack+508757,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+584735,int_stack+461507,int_stack+397499,21);
 /*--- compute (h0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+634631,int_stack+584735,int_stack+543155,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+394160,int_stack+20475,int_stack+16884,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+404933,int_stack+394160,int_stack+292415,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+507371,int_stack+404933,int_stack+336893,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+394160,int_stack+507371,int_stack+436307,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+507371,int_stack+394160,int_stack+302054,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+394160,int_stack+507371,int_stack+354029,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+507371,int_stack+394160,int_stack+461507,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+292415,int_stack+507371,int_stack+584735,21);
 /*--- compute (h0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+354785,int_stack+292415,int_stack+634631,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+292415,int_stack+26005,int_stack+24465,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+297035,int_stack+27853,int_stack+26005,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+302579,int_stack+297035,int_stack+292415,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+311819,int_stack+30037,int_stack+27853,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+318371,int_stack+311819,int_stack+297035,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+329459,int_stack+318371,int_stack+302579,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+292415,int_stack+32585,int_stack+30037,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+418310,int_stack+292415,int_stack+311819,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+431414,int_stack+418310,int_stack+318371,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+300059,int_stack+431414,int_stack+329459,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+323159,int_stack+35525,int_stack+32585,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+331979,int_stack+323159,int_stack+292415,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+449894,int_stack+331979,int_stack+418310,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+471734,int_stack+449894,int_stack+431414,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+499454,int_stack+471734,int_stack+300059,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+418310,int_stack+38885,int_stack+35525,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+428390,int_stack+418310,int_stack+323159,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+292415,int_stack+428390,int_stack+331979,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+317895,int_stack+292415,int_stack+449894,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+531794,int_stack+317895,int_stack+471734,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+446030,int_stack+531794,int_stack+499454,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+489150,int_stack+42693,int_stack+38885,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+500574,int_stack+489150,int_stack+418310,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+570602,int_stack+500574,int_stack+428390,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+600002,int_stack+570602,int_stack+292415,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+638222,int_stack+600002,int_stack+317895,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+292415,int_stack+638222,int_stack+531794,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+684086,int_stack+292415,int_stack+446030,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+418310,int_stack+46977,int_stack+42693,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+431162,int_stack+418310,int_stack+489150,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+454010,int_stack+431162,int_stack+500574,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+487610,int_stack+454010,int_stack+570602,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+531710,int_stack+487610,int_stack+600002,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+739526,int_stack+531710,int_stack+638222,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+585218,int_stack+739526,int_stack+292415,28);
 /*--- compute (i0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+800678,int_stack+585218,int_stack+684086,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+292415,int_stack+51765,int_stack+46977,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+306779,int_stack+292415,int_stack+418310,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+651746,int_stack+306779,int_stack+431162,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+292415,int_stack+651746,int_stack+454010,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+651746,int_stack+292415,int_stack+487610,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+418310,int_stack+651746,int_stack+531710,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+651746,int_stack+418310,int_stack+739526,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+418310,int_stack+651746,int_stack+585218,28);
 /*--- compute (i0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+501470,int_stack+418310,int_stack+800678,28);
 /*--- compute (hp|mm) ---*/
 hrr1_build_hp(Libint->AB,int_stack+586170,int_stack+501470,int_stack+354785,3025);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+776745,int_stack+59065,int_stack+57085,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+782685,int_stack+61441,int_stack+59065,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+789813,int_stack+782685,int_stack+776745,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+801693,int_stack+64249,int_stack+61441,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+810117,int_stack+801693,int_stack+782685,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+824373,int_stack+810117,int_stack+789813,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+776745,int_stack+67525,int_stack+64249,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+844173,int_stack+776745,int_stack+801693,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+292415,int_stack+844173,int_stack+810117,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+786573,int_stack+292415,int_stack+824373,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+816273,int_stack+71305,int_stack+67525,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+316175,int_stack+816273,int_stack+776745,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+335831,int_stack+316175,int_stack+844173,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+827613,int_stack+335831,int_stack+292415,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+363911,int_stack+827613,int_stack+786573,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+292415,int_stack+75625,int_stack+71305,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+776745,int_stack+292415,int_stack+816273,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+405491,int_stack+776745,int_stack+316175,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+438251,int_stack+405491,int_stack+335831,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+305375,int_stack+438251,int_stack+827613,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+799425,int_stack+305375,int_stack+363911,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+355271,int_stack+80521,int_stack+75625,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+369959,int_stack+355271,int_stack+292415,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+369959,int_stack+776745,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+854865,int_stack+0,int_stack+405491,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+904005,int_stack+854865,int_stack+438251,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+395879,int_stack+904005,int_stack+305375,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+962973,int_stack+395879,int_stack+799425,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+776745,int_stack+86029,int_stack+80521,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+793269,int_stack+776745,int_stack+355271,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+292415,int_stack+793269,int_stack+369959,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+335615,int_stack+292415,int_stack+0,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+335615,int_stack+854865,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+822645,int_stack+0,int_stack+904005,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1034253,int_stack+822645,int_stack+395879,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+392315,int_stack+1034253,int_stack+962973,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+901269,int_stack+92185,int_stack+86029,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+919737,int_stack+901269,int_stack+776745,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+952785,int_stack+919737,int_stack+793269,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1119789,int_stack+952785,int_stack+292415,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+901269,int_stack+1119789,int_stack+335615,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+292415,int_stack+901269,int_stack+0,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+901269,int_stack+292415,int_stack+822645,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+776745,int_stack+901269,int_stack+1034253,36);
 /*--- compute (k0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+883665,int_stack+776745,int_stack+392315,36);
 /*--- compute (ip|mm) ---*/
 hrr1_build_ip(Libint->AB,int_stack+992565,int_stack+883665,int_stack+501470,3025);
 /*--- compute (hd|mm) ---*/
 hrr1_build_hd(Libint->AB,int_stack+1246665,int_stack+992565,int_stack+586170,3025);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+292415,int_stack+101500,int_stack+99025,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+299840,int_stack+104470,int_stack+101500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+308750,int_stack+299840,int_stack+292415,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+323600,int_stack+107980,int_stack+104470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+334130,int_stack+323600,int_stack+299840,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+351950,int_stack+334130,int_stack+308750,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+292415,int_stack+112075,int_stack+107980,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+376700,int_stack+292415,int_stack+323600,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+397760,int_stack+376700,int_stack+334130,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+304700,int_stack+397760,int_stack+351950,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+341825,int_stack+116800,int_stack+112075,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+427460,int_stack+341825,int_stack+292415,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+452030,int_stack+427460,int_stack+376700,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+487130,int_stack+452030,int_stack+397760,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+356000,int_stack+487130,int_stack+304700,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+292415,int_stack+122200,int_stack+116800,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+308615,int_stack+292415,int_stack+341825,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+531680,int_stack+308615,int_stack+427460,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+572630,int_stack+531680,int_stack+452030,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+407975,int_stack+572630,int_stack+487130,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+625280,int_stack+407975,int_stack+356000,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+336965,int_stack+128320,int_stack+122200,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+355325,int_stack+336965,int_stack+292415,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+470345,int_stack+355325,int_stack+308615,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+694580,int_stack+470345,int_stack+531680,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+756005,int_stack+694580,int_stack+572630,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+517595,int_stack+756005,int_stack+407975,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+517595,int_stack+625280,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+292415,int_stack+135205,int_stack+128320,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+387725,int_stack+292415,int_stack+336965,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+600755,int_stack+387725,int_stack+355325,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+313070,int_stack+600755,int_stack+470345,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+424445,int_stack+313070,int_stack+694580,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+654755,int_stack+424445,int_stack+756005,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+753035,int_stack+654755,int_stack+517595,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1627815,int_stack+753035,int_stack+0,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+142900,int_stack+135205,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+23085,int_stack+0,int_stack+292415,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+64395,int_stack+23085,int_stack+387725,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+510440,int_stack+64395,int_stack+600755,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+510440,int_stack+313070,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+510440,int_stack+0,int_stack+424445,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+510440,int_stack+654755,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+292415,int_stack+0,int_stack+753035,45);
 /*--- compute (l0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+0,int_stack+292415,int_stack+1627815,45);
 /*--- compute (kp|mm) ---*/
 hrr1_build_kp(Libint->AB,int_stack+292415,int_stack+0,int_stack+883665,3025);
 /*--- compute (id|mm) ---*/
 hrr1_build_id(Libint->AB,int_stack+1627815,int_stack+292415,int_stack+992565,3025);
 /*--- compute (hf|mm) ---*/
 hrr1_build_hf(Libint->AB,int_stack+2136015,int_stack+1627815,int_stack+1246665,3025);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+619115,int_stack+154475,int_stack+151450,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+628190,int_stack+158105,int_stack+154475,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+639080,int_stack+628190,int_stack+619115,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+657230,int_stack+162395,int_stack+158105,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+670100,int_stack+657230,int_stack+628190,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+691880,int_stack+670100,int_stack+639080,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+619115,int_stack+167400,int_stack+162395,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+722130,int_stack+619115,int_stack+657230,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+747870,int_stack+722130,int_stack+670100,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+634130,int_stack+747870,int_stack+691880,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+679505,int_stack+173175,int_stack+167400,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+784170,int_stack+679505,int_stack+619115,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+814200,int_stack+784170,int_stack+722130,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+857100,int_stack+814200,int_stack+747870,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+696830,int_stack+857100,int_stack+634130,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+619115,int_stack+179775,int_stack+173175,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+638915,int_stack+619115,int_stack+679505,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+911550,int_stack+638915,int_stack+784170,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+961600,int_stack+911550,int_stack+814200,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+760355,int_stack+961600,int_stack+857100,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1025950,int_stack+760355,int_stack+696830,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+673565,int_stack+187255,int_stack+179775,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+696005,int_stack+673565,int_stack+619115,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+836585,int_stack+696005,int_stack+638915,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1110650,int_stack+836585,int_stack+911550,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1185725,int_stack+1110650,int_stack+961600,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+894335,int_stack+1185725,int_stack+760355,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1275815,int_stack+894335,int_stack+1025950,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+619115,int_stack+195670,int_stack+187255,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+735605,int_stack+619115,int_stack+673565,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+995975,int_stack+735605,int_stack+696005,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+644360,int_stack+995975,int_stack+836585,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+780485,int_stack+644360,int_stack+1110650,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1061975,int_stack+780485,int_stack+1185725,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1384715,int_stack+1061975,int_stack+894335,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2771265,int_stack+1384715,int_stack+1275815,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+885590,int_stack+205075,int_stack+195670,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+913805,int_stack+885590,int_stack+619115,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1182095,int_stack+913805,int_stack+735605,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+885590,int_stack+1182095,int_stack+995975,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1182095,int_stack+885590,int_stack+644360,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+885590,int_stack+1182095,int_stack+780485,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1182095,int_stack+885590,int_stack+1061975,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+619115,int_stack+1182095,int_stack+1384715,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+782465,int_stack+619115,int_stack+2771265,55);
 /*--- compute (lp|mm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+948840,int_stack+782465,int_stack+0,3025);
 /*--- compute (kd|mm) ---*/
 hrr1_build_kd(Libint->AB,int_stack+2771265,int_stack+948840,int_stack+292415,3025);
 /*--- compute (if|mm) ---*/
 hrr1_build_if(Libint->AB,int_stack+3424665,int_stack+2771265,int_stack+1627815,3025);
 /*--- compute (hg|mm) ---*/
 hrr1_build_hg(Libint->AB,int_stack+4271665,int_stack+3424665,int_stack+2136015,3025);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+292415,int_stack+219155,int_stack+215525,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+303305,int_stack+223511,int_stack+219155,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+316373,int_stack+303305,int_stack+292415,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+338153,int_stack+228659,int_stack+223511,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+353597,int_stack+338153,int_stack+303305,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+379733,int_stack+353597,int_stack+316373,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+292415,int_stack+234665,int_stack+228659,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+416033,int_stack+292415,int_stack+338153,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+446921,int_stack+416033,int_stack+353597,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+310433,int_stack+446921,int_stack+379733,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+364883,int_stack+241595,int_stack+234665,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+490481,int_stack+364883,int_stack+292415,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+526517,int_stack+490481,int_stack+416033,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+577997,int_stack+526517,int_stack+446921,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+385673,int_stack+577997,int_stack+310433,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+292415,int_stack+249515,int_stack+241595,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+316175,int_stack+292415,int_stack+364883,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+643337,int_stack+316175,int_stack+490481,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+703397,int_stack+643337,int_stack+526517,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+461903,int_stack+703397,int_stack+577997,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+461903,int_stack+385673,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+357755,int_stack+258491,int_stack+249515,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+384683,int_stack+357755,int_stack+292415,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+553379,int_stack+384683,int_stack+316175,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+101640,int_stack+553379,int_stack+643337,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1357215,int_stack+101640,int_stack+703397,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+622679,int_stack+1357215,int_stack+461903,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1465323,int_stack+622679,int_stack+0,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+268589,int_stack+258491,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+30294,int_stack+0,int_stack+357755,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+292415,int_stack+30294,int_stack+384683,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+371615,int_stack+292415,int_stack+553379,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+475565,int_stack+371615,int_stack+101640,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+84150,int_stack+475565,int_stack+1357215,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1596003,int_stack+84150,int_stack+622679,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+601691,int_stack+1596003,int_stack+1465323,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1357215,int_stack+279875,int_stack+268589,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1391073,int_stack+1357215,int_stack+0,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1451661,int_stack+1391073,int_stack+30294,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1752819,int_stack+1451661,int_stack+292415,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1357215,int_stack+1752819,int_stack+371615,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1752819,int_stack+1357215,int_stack+475565,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1357215,int_stack+1752819,int_stack+84150,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1752819,int_stack+1357215,int_stack+1596003,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1357215,int_stack+1752819,int_stack+601691,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1556865,int_stack+1357215,int_stack+782465,3025);
 /*--- compute (ld|mm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+0,int_stack+1556865,int_stack+948840,3025);
 /*--- compute (kf|mm) ---*/
 hrr1_build_kf(Libint->AB,int_stack+816750,int_stack+0,int_stack+2771265,3025);
 /*--- compute (ig|mm) ---*/
 hrr1_build_ig(Libint->AB,int_stack+1905750,int_stack+816750,int_stack+3424665,3025);
 /*--- compute (hh|mm) ---*/
 hrr1_build_hh(Libint->AB,int_stack+0,int_stack+1905750,int_stack+4271665,3025);
 return int_stack+0;}
