/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hhnf(Libint_t*, prim_data*);

  /* Computes quartets of (hh|nf) integrals */

REALTYPE *hrr_order_hhnf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[6][10] = int_stack + 7140;
 Libint->vrr_classes[6][11] = int_stack + 8988;
 Libint->vrr_classes[6][12] = int_stack + 11172;
 Libint->vrr_classes[6][13] = int_stack + 13720;
 Libint->vrr_classes[7][10] = int_stack + 16660;
 Libint->vrr_classes[7][11] = int_stack + 19036;
 Libint->vrr_classes[7][12] = int_stack + 21844;
 Libint->vrr_classes[7][13] = int_stack + 25120;
 Libint->vrr_classes[8][10] = int_stack + 28900;
 Libint->vrr_classes[8][11] = int_stack + 31870;
 Libint->vrr_classes[8][12] = int_stack + 35380;
 Libint->vrr_classes[8][13] = int_stack + 39475;
 Libint->vrr_classes[9][10] = int_stack + 44200;
 Libint->vrr_classes[9][11] = int_stack + 47830;
 Libint->vrr_classes[9][12] = int_stack + 52120;
 Libint->vrr_classes[9][13] = int_stack + 57125;
 Libint->vrr_classes[10][10] = int_stack + 62900;
 Libint->vrr_classes[10][11] = int_stack + 67256;
 Libint->vrr_classes[10][12] = int_stack + 72404;
 Libint->vrr_classes[10][13] = int_stack + 78410;
 memset(int_stack,0,85340*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 85340;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hhnf(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85340,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+89498,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+94412,int_stack+89498,int_stack+85340,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+102728,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+108461,int_stack+102728,int_stack+89498,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+118289,int_stack+108461,int_stack+94412,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85340,int_stack+8988,int_stack+7140,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+90884,int_stack+11172,int_stack+8988,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+97436,int_stack+90884,int_stack+85340,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+108524,int_stack+13720,int_stack+11172,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+108524,int_stack+90884,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+132149,int_stack+0,int_stack+97436,28);
 /*--- compute (hp|nf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+150629,int_stack+132149,int_stack+118289,660);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+19036,int_stack+16660,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+7128,int_stack+21844,int_stack+19036,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+85340,int_stack+7128,int_stack+0,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+99596,int_stack+25120,int_stack+21844,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+109424,int_stack+99596,int_stack+7128,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+109424,int_stack+85340,36);
 /*--- compute (ip|nf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+192209,int_stack+0,int_stack+132149,660);
 /*--- compute (hd|nf) ---*/
 hrr1_build_hd(Libint->AB,int_stack+247649,int_stack+192209,int_stack+150629,660);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85340,int_stack+31870,int_stack+28900,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+94250,int_stack+35380,int_stack+31870,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+104780,int_stack+94250,int_stack+85340,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+122600,int_stack+39475,int_stack+35380,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+134885,int_stack+122600,int_stack+94250,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+155945,int_stack+134885,int_stack+104780,45);
 /*--- compute (kp|nf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+330809,int_stack+155945,int_stack+0,660);
 /*--- compute (id|nf) ---*/
 hrr1_build_id(Libint->AB,int_stack+402089,int_stack+330809,int_stack+192209,660);
 /*--- compute (hf|nf) ---*/
 hrr1_build_hf(Libint->AB,int_stack+512969,int_stack+402089,int_stack+247649,660);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+47830,int_stack+44200,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+52120,int_stack+47830,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23760,int_stack+10890,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+85340,int_stack+57125,int_stack+52120,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100355,int_stack+85340,int_stack+10890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+185645,int_stack+100355,int_stack+23760,55);
 /*--- compute (lp|nf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+221945,int_stack+185645,int_stack+155945,660);
 /*--- compute (kd|nf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+651569,int_stack+221945,int_stack+330809,660);
 /*--- compute (if|nf) ---*/
 hrr1_build_if(Libint->AB,int_stack+794129,int_stack+651569,int_stack+402089,660);
 /*--- compute (hg|nf) ---*/
 hrr1_build_hg(Libint->AB,int_stack+978929,int_stack+794129,int_stack+512969,660);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85340,int_stack+67256,int_stack+62900,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+98408,int_stack+72404,int_stack+67256,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+113852,int_stack+98408,int_stack+85340,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+139988,int_stack+78410,int_stack+72404,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+139988,int_stack+98408,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+139988,int_stack+0,int_stack+113852,66);
 /*--- compute (mp|nf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+0,int_stack+139988,int_stack+185645,660);
 /*--- compute (ld|nf) ---*/
 hrr1_build_ld(Libint->AB,int_stack+311045,int_stack+0,int_stack+221945,660);
 /*--- compute (kf|nf) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+311045,int_stack+651569,660);
 /*--- compute (ig|nf) ---*/
 hrr1_build_ig(Libint->AB,int_stack+237600,int_stack+0,int_stack+794129,660);
 /*--- compute (hh|nf) ---*/
 hrr1_build_hh(Libint->AB,int_stack+514800,int_stack+237600,int_stack+978929,660);
 return int_stack+514800;}
