/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_i0gg(Libint_t*, prim_data*);

  /* Computes quartets of (i0|gg) integrals */

REALTYPE *hrr_order_i0gg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][4] = int_stack + 0;
 Libint->vrr_classes[6][5] = int_stack + 420;
 Libint->vrr_classes[6][6] = int_stack + 1008;
 Libint->vrr_classes[6][7] = int_stack + 1792;
 Libint->vrr_classes[6][8] = int_stack + 2800;
 memset(int_stack,0,4060*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 4060;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_i0gg(Libint, Data);
   Data++;
 }
 /*--- compute (i0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+4060,int_stack+420,int_stack+0,28);
 /*--- compute (i0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+5320,int_stack+1008,int_stack+420,28);
 /*--- compute (i0|gd) ---*/
 hrr3_build_gd(Libint->CD,int_stack+7084,int_stack+5320,int_stack+4060,28);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+9604,int_stack+1792,int_stack+1008,28);
 /*--- compute (i0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+11956,int_stack+9604,int_stack+5320,28);
 /*--- compute (i0|gf) ---*/
 hrr3_build_gf(Libint->CD,int_stack+15484,int_stack+11956,int_stack+7084,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+4060,int_stack+2800,int_stack+1792,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+19684,int_stack+4060,int_stack+9604,28);
 /*--- compute (i0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+0,int_stack+19684,int_stack+11956,28);
 /*--- compute (i0|gg) ---*/
 hrr3_build_gg(Libint->CD,int_stack+5880,int_stack+0,int_stack+15484,28);
 return int_stack+5880;}
