/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_idmp(Libint_t*, prim_data*);

  /* Computes quartets of (id|mp) integrals */

REALTYPE *hrr_order_idmp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[7][9] = int_stack + 3388;
 Libint->vrr_classes[7][10] = int_stack + 5368;
 Libint->vrr_classes[8][9] = int_stack + 7744;
 Libint->vrr_classes[8][10] = int_stack + 10219;
 memset(int_stack,0,13189*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 13189;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_idmp(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+13189,int_stack+1540,int_stack+0,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+17809,int_stack+5368,int_stack+3388,36);
 /*--- compute (ip|mp) ---*/
 hrr1_build_ip(Libint->AB,int_stack+23749,int_stack+17809,int_stack+13189,165);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+10219,int_stack+7744,45);
 /*--- compute (kp|mp) ---*/
 hrr1_build_kp(Libint->AB,int_stack+37609,int_stack+0,int_stack+17809,165);
 /*--- compute (id|mp) ---*/
 hrr1_build_id(Libint->AB,int_stack+55429,int_stack+37609,int_stack+23749,165);
 return int_stack+55429;}
