/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ifkh(Libint_t*, prim_data*);

  /* Computes quartets of (if|kh) integrals */

REALTYPE *hrr_order_ifkh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][7] = int_stack + 0;
 Libint->vrr_classes[6][8] = int_stack + 1008;
 Libint->vrr_classes[6][9] = int_stack + 2268;
 Libint->vrr_classes[6][10] = int_stack + 3808;
 Libint->vrr_classes[6][11] = int_stack + 5656;
 Libint->vrr_classes[6][12] = int_stack + 7840;
 Libint->vrr_classes[7][7] = int_stack + 10388;
 Libint->vrr_classes[7][8] = int_stack + 11684;
 Libint->vrr_classes[7][9] = int_stack + 13304;
 Libint->vrr_classes[7][10] = int_stack + 15284;
 Libint->vrr_classes[7][11] = int_stack + 17660;
 Libint->vrr_classes[7][12] = int_stack + 20468;
 Libint->vrr_classes[8][7] = int_stack + 23744;
 Libint->vrr_classes[8][8] = int_stack + 25364;
 Libint->vrr_classes[8][9] = int_stack + 27389;
 Libint->vrr_classes[8][10] = int_stack + 29864;
 Libint->vrr_classes[8][11] = int_stack + 32834;
 Libint->vrr_classes[8][12] = int_stack + 36344;
 Libint->vrr_classes[9][7] = int_stack + 40439;
 Libint->vrr_classes[9][8] = int_stack + 42419;
 Libint->vrr_classes[9][9] = int_stack + 44894;
 Libint->vrr_classes[9][10] = int_stack + 47919;
 Libint->vrr_classes[9][11] = int_stack + 51549;
 Libint->vrr_classes[9][12] = int_stack + 55839;
 memset(int_stack,0,60844*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 60844;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ifkh(Libint, Data);
   Data++;
 }
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+60844,int_stack+1008,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+63868,int_stack+2268,int_stack+1008,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+67648,int_stack+63868,int_stack+60844,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+73696,int_stack+3808,int_stack+2268,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+78316,int_stack+73696,int_stack+63868,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+85876,int_stack+78316,int_stack+67648,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+60844,int_stack+5656,int_stack+3808,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+95956,int_stack+60844,int_stack+73696,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+105196,int_stack+95956,int_stack+78316,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+66388,int_stack+105196,int_stack+85876,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+81508,int_stack+7840,int_stack+5656,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+117796,int_stack+81508,int_stack+60844,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+128884,int_stack+117796,int_stack+95956,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+81508,int_stack+128884,int_stack+105196,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+100408,int_stack+81508,int_stack+66388,28);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+60844,int_stack+11684,int_stack+10388,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+64732,int_stack+13304,int_stack+11684,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+69592,int_stack+64732,int_stack+60844,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+77368,int_stack+15284,int_stack+13304,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+83308,int_stack+77368,int_stack+64732,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+121576,int_stack+83308,int_stack+69592,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+60844,int_stack+17660,int_stack+15284,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+60844,int_stack+77368,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+134536,int_stack+0,int_stack+83308,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+67972,int_stack+134536,int_stack+121576,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+121576,int_stack+20468,int_stack+17660,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+150736,int_stack+121576,int_stack+60844,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+164992,int_stack+150736,int_stack+0,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+184792,int_stack+164992,int_stack+134536,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+121576,int_stack+184792,int_stack+67972,36);
 /*--- compute (ip|kh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+148792,int_stack+121576,int_stack+100408,756);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+25364,int_stack+23744,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+4860,int_stack+27389,int_stack+25364,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+10935,int_stack+4860,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+60844,int_stack+29864,int_stack+27389,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+68269,int_stack+60844,int_stack+4860,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+80419,int_stack+68269,int_stack+10935,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+32834,int_stack+29864,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+8910,int_stack+0,int_stack+60844,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+96619,int_stack+8910,int_stack+68269,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+212296,int_stack+96619,int_stack+80419,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+60844,int_stack+36344,int_stack+32834,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+71374,int_stack+60844,int_stack+0,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+236596,int_stack+71374,int_stack+8910,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+236596,int_stack+96619,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+60844,int_stack+0,int_stack+212296,45);
 /*--- compute (kp|kh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+212296,int_stack+60844,int_stack+121576,756);
 /*--- compute (id|kh) ---*/
 hrr1_build_id(Libint->AB,int_stack+293944,int_stack+212296,int_stack+148792,756);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+42419,int_stack+40439,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5940,int_stack+44894,int_stack+42419,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13365,int_stack+5940,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25245,int_stack+47919,int_stack+44894,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+94864,int_stack+25245,int_stack+5940,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+109714,int_stack+94864,int_stack+13365,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+51549,int_stack+47919,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+129514,int_stack+0,int_stack+25245,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+10890,int_stack+129514,int_stack+94864,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+147664,int_stack+10890,int_stack+109714,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+94864,int_stack+55839,int_stack+51549,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+107734,int_stack+94864,int_stack+0,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+177364,int_stack+107734,int_stack+129514,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+94864,int_stack+177364,int_stack+10890,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+94864,int_stack+147664,55);
 /*--- compute (lp|kh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+94864,int_stack+0,int_stack+60844,756);
 /*--- compute (kd|kh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+420952,int_stack+94864,int_stack+212296,756);
 /*--- compute (if|kh) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+420952,int_stack+293944,756);
 return int_stack+0;}
