/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iflp(Libint_t*, prim_data*);

  /* Computes quartets of (if|lp) integrals */

REALTYPE *hrr_order_iflp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[7][8] = int_stack + 2800;
 Libint->vrr_classes[7][9] = int_stack + 4420;
 Libint->vrr_classes[8][8] = int_stack + 6400;
 Libint->vrr_classes[8][9] = int_stack + 8425;
 Libint->vrr_classes[9][8] = int_stack + 10900;
 Libint->vrr_classes[9][9] = int_stack + 13375;
 memset(int_stack,0,16400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 16400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iflp(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+16400,int_stack+1260,int_stack+0,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20180,int_stack+4420,int_stack+2800,36);
 /*--- compute (ip|lp) ---*/
 hrr1_build_ip(Libint->AB,int_stack+25040,int_stack+20180,int_stack+16400,135);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+8425,int_stack+6400,45);
 /*--- compute (kp|lp) ---*/
 hrr1_build_kp(Libint->AB,int_stack+36380,int_stack+0,int_stack+20180,135);
 /*--- compute (id|lp) ---*/
 hrr1_build_id(Libint->AB,int_stack+50960,int_stack+36380,int_stack+25040,135);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+16400,int_stack+13375,int_stack+10900,55);
 /*--- compute (lp|lp) ---*/
 hrr1_build_lp(Libint->AB,int_stack+73640,int_stack+16400,int_stack+0,135);
 /*--- compute (kd|lp) ---*/
 hrr1_build_kd(Libint->AB,int_stack+0,int_stack+73640,int_stack+36380,135);
 /*--- compute (if|lp) ---*/
 hrr1_build_if(Libint->AB,int_stack+73640,int_stack+0,int_stack+50960,135);
 return int_stack+73640;}
