/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ihnl(Libint_t*, prim_data*);

  /* Computes quartets of (ih|nl) integrals */

REALTYPE *hrr_order_ihnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[6][14] = int_stack + 9520;
 Libint->vrr_classes[6][15] = int_stack + 12880;
 Libint->vrr_classes[6][16] = int_stack + 16688;
 Libint->vrr_classes[6][17] = int_stack + 20972;
 Libint->vrr_classes[6][18] = int_stack + 25760;
 Libint->vrr_classes[7][10] = int_stack + 31080;
 Libint->vrr_classes[7][11] = int_stack + 33456;
 Libint->vrr_classes[7][12] = int_stack + 36264;
 Libint->vrr_classes[7][13] = int_stack + 39540;
 Libint->vrr_classes[7][14] = int_stack + 43320;
 Libint->vrr_classes[7][15] = int_stack + 47640;
 Libint->vrr_classes[7][16] = int_stack + 52536;
 Libint->vrr_classes[7][17] = int_stack + 58044;
 Libint->vrr_classes[7][18] = int_stack + 64200;
 Libint->vrr_classes[8][10] = int_stack + 71040;
 Libint->vrr_classes[8][11] = int_stack + 74010;
 Libint->vrr_classes[8][12] = int_stack + 77520;
 Libint->vrr_classes[8][13] = int_stack + 81615;
 Libint->vrr_classes[8][14] = int_stack + 86340;
 Libint->vrr_classes[8][15] = int_stack + 91740;
 Libint->vrr_classes[8][16] = int_stack + 97860;
 Libint->vrr_classes[8][17] = int_stack + 104745;
 Libint->vrr_classes[8][18] = int_stack + 112440;
 Libint->vrr_classes[9][10] = int_stack + 120990;
 Libint->vrr_classes[9][11] = int_stack + 124620;
 Libint->vrr_classes[9][12] = int_stack + 128910;
 Libint->vrr_classes[9][13] = int_stack + 133915;
 Libint->vrr_classes[9][14] = int_stack + 139690;
 Libint->vrr_classes[9][15] = int_stack + 146290;
 Libint->vrr_classes[9][16] = int_stack + 153770;
 Libint->vrr_classes[9][17] = int_stack + 162185;
 Libint->vrr_classes[9][18] = int_stack + 171590;
 Libint->vrr_classes[10][10] = int_stack + 182040;
 Libint->vrr_classes[10][11] = int_stack + 186396;
 Libint->vrr_classes[10][12] = int_stack + 191544;
 Libint->vrr_classes[10][13] = int_stack + 197550;
 Libint->vrr_classes[10][14] = int_stack + 204480;
 Libint->vrr_classes[10][15] = int_stack + 212400;
 Libint->vrr_classes[10][16] = int_stack + 221376;
 Libint->vrr_classes[10][17] = int_stack + 231474;
 Libint->vrr_classes[10][18] = int_stack + 242760;
 Libint->vrr_classes[11][10] = int_stack + 255300;
 Libint->vrr_classes[11][11] = int_stack + 260448;
 Libint->vrr_classes[11][12] = int_stack + 266532;
 Libint->vrr_classes[11][13] = int_stack + 273630;
 Libint->vrr_classes[11][14] = int_stack + 281820;
 Libint->vrr_classes[11][15] = int_stack + 291180;
 Libint->vrr_classes[11][16] = int_stack + 301788;
 Libint->vrr_classes[11][17] = int_stack + 313722;
 Libint->vrr_classes[11][18] = int_stack + 327060;
 memset(int_stack,0,341880*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 341880;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ihnl(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+341880,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+347424,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+353976,int_stack+347424,int_stack+341880,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+365064,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+372708,int_stack+365064,int_stack+347424,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+385812,int_stack+372708,int_stack+353976,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+341880,int_stack+9520,int_stack+6580,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+404292,int_stack+341880,int_stack+365064,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+350700,int_stack+404292,int_stack+372708,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+419580,int_stack+350700,int_stack+385812,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+372540,int_stack+12880,int_stack+9520,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+382620,int_stack+372540,int_stack+341880,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+447300,int_stack+382620,int_stack+404292,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+472780,int_stack+447300,int_stack+350700,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+505540,int_stack+472780,int_stack+419580,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+341880,int_stack+16688,int_stack+12880,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+400260,int_stack+341880,int_stack+372540,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+544348,int_stack+400260,int_stack+382620,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+353304,int_stack+544348,int_stack+447300,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+420420,int_stack+353304,int_stack+472780,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+573748,int_stack+420420,int_stack+505540,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+466284,int_stack+20972,int_stack+16688,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+479136,int_stack+466284,int_stack+341880,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+501984,int_stack+479136,int_stack+400260,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+625492,int_stack+501984,int_stack+544348,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+669592,int_stack+625492,int_stack+353304,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+341880,int_stack+669592,int_stack+420420,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+723100,int_stack+341880,int_stack+573748,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+403032,int_stack+25760,int_stack+20972,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+417396,int_stack+403032,int_stack+466284,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+535584,int_stack+417396,int_stack+479136,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+403032,int_stack+535584,int_stack+501984,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+453432,int_stack+403032,int_stack+625492,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+515172,int_stack+453432,int_stack+669592,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+403032,int_stack+515172,int_stack+341880,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+481656,int_stack+403032,int_stack+723100,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+341880,int_stack+33456,int_stack+31080,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+349008,int_stack+36264,int_stack+33456,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+357432,int_stack+349008,int_stack+341880,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+371688,int_stack+39540,int_stack+36264,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+381516,int_stack+371688,int_stack+349008,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+398364,int_stack+381516,int_stack+357432,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+341880,int_stack+43320,int_stack+39540,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+422124,int_stack+341880,int_stack+371688,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+353220,int_stack+422124,int_stack+381516,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+441780,int_stack+353220,int_stack+398364,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+381300,int_stack+47640,int_stack+43320,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+394260,int_stack+381300,int_stack+341880,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+564816,int_stack+394260,int_stack+422124,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+597576,int_stack+564816,int_stack+353220,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+639696,int_stack+597576,int_stack+441780,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+341880,int_stack+52536,int_stack+47640,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+416940,int_stack+341880,int_stack+381300,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+442860,int_stack+416940,int_stack+394260,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+356568,int_stack+442860,int_stack+564816,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+689592,int_stack+356568,int_stack+597576,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+564816,int_stack+689592,int_stack+639696,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+631344,int_stack+58044,int_stack+52536,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+647868,int_stack+631344,int_stack+341880,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+647868,int_stack+416940,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+748560,int_stack+0,int_stack+442860,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+405708,int_stack+748560,int_stack+356568,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+805260,int_stack+405708,int_stack+689592,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+883884,int_stack+805260,int_stack+564816,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+564816,int_stack+64200,int_stack+58044,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+583284,int_stack+564816,int_stack+631344,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+341880,int_stack+583284,int_stack+647868,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+564816,int_stack+341880,int_stack+0,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+629616,int_stack+564816,int_stack+748560,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+708996,int_stack+629616,int_stack+405708,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+564816,int_stack+708996,int_stack+805260,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+665904,int_stack+564816,int_stack+883884,36);
 /*--- compute (ip|nl) ---*/
 hrr1_build_ip(Libint->AB,int_stack+772824,int_stack+665904,int_stack+481656,2970);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+74010,int_stack+71040,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8910,int_stack+77520,int_stack+74010,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+19440,int_stack+8910,int_stack+0,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+37260,int_stack+81615,int_stack+77520,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+49545,int_stack+37260,int_stack+8910,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+341880,int_stack+49545,int_stack+19440,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+86340,int_stack+81615,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+371580,int_stack+0,int_stack+37260,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+14175,int_stack+371580,int_stack+49545,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+396150,int_stack+14175,int_stack+341880,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+341880,int_stack+91740,int_stack+86340,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+49275,int_stack+341880,int_stack+0,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+440700,int_stack+49275,int_stack+371580,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+481650,int_stack+440700,int_stack+14175,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+534300,int_stack+481650,int_stack+396150,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+97860,int_stack+91740,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+358080,int_stack+0,int_stack+341880,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+390480,int_stack+358080,int_stack+49275,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+18360,int_stack+390480,int_stack+440700,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1022304,int_stack+18360,int_stack+481650,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+437730,int_stack+1022304,int_stack+534300,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+520890,int_stack+104745,int_stack+97860,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+541545,int_stack+520890,int_stack+0,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+578265,int_stack+541545,int_stack+358080,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1096014,int_stack+578265,int_stack+390480,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+341880,int_stack+1096014,int_stack+18360,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+341880,int_stack+1022304,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1166889,int_stack+0,int_stack+437730,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1022304,int_stack+112440,int_stack+104745,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1045389,int_stack+1022304,int_stack+520890,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+427875,int_stack+1045389,int_stack+541545,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+489075,int_stack+427875,int_stack+578265,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1273809,int_stack+489075,int_stack+1096014,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+427875,int_stack+1273809,int_stack+341880,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1022304,int_stack+427875,int_stack+0,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+341880,int_stack+1022304,int_stack+1166889,45);
 /*--- compute (kp|nl) ---*/
 hrr1_build_kp(Libint->AB,int_stack+1022304,int_stack+341880,int_stack+665904,2970);
 /*--- compute (id|nl) ---*/
 hrr1_build_id(Libint->AB,int_stack+1343064,int_stack+1022304,int_stack+772824,2970);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+124620,int_stack+120990,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+128910,int_stack+124620,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23760,int_stack+10890,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+45540,int_stack+133915,int_stack+128910,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+60555,int_stack+45540,int_stack+10890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+86295,int_stack+60555,int_stack+23760,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+139690,int_stack+133915,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+475530,int_stack+0,int_stack+45540,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+17325,int_stack+475530,int_stack+60555,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+505560,int_stack+17325,int_stack+86295,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+60225,int_stack+146290,int_stack+139690,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+80025,int_stack+60225,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+560010,int_stack+80025,int_stack+475530,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+610060,int_stack+560010,int_stack+17325,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+674410,int_stack+610060,int_stack+505560,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+475530,int_stack+153770,int_stack+146290,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+497970,int_stack+475530,int_stack+60225,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+497970,int_stack+80025,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+57750,int_stack+0,int_stack+560010,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+750640,int_stack+57750,int_stack+610060,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+537570,int_stack+750640,int_stack+674410,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+639210,int_stack+162185,int_stack+153770,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+664455,int_stack+639210,int_stack+475530,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+840730,int_stack+664455,int_stack+497970,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+906730,int_stack+840730,int_stack+0,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1842024,int_stack+906730,int_stack+57750,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1842024,int_stack+750640,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+709335,int_stack+0,int_stack+537570,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+120120,int_stack+171590,int_stack+162185,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+475530,int_stack+120120,int_stack+639210,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+526020,int_stack+475530,int_stack+664455,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+600820,int_stack+526020,int_stack+840730,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+475530,int_stack+600820,int_stack+906730,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+840015,int_stack+475530,int_stack+1842024,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+475530,int_stack+840015,int_stack+0,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+475530,int_stack+709335,55);
 /*--- compute (lp|nl) ---*/
 hrr1_build_lp(Libint->AB,int_stack+475530,int_stack+0,int_stack+341880,2970);
 /*--- compute (kd|nl) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1842024,int_stack+475530,int_stack+1022304,2970);
 /*--- compute (if|nl) ---*/
 hrr1_build_if(Libint->AB,int_stack+2483544,int_stack+1842024,int_stack+1343064,2970);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+341880,int_stack+186396,int_stack+182040,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+354948,int_stack+191544,int_stack+186396,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+370392,int_stack+354948,int_stack+341880,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+396528,int_stack+197550,int_stack+191544,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+414546,int_stack+396528,int_stack+354948,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+876480,int_stack+414546,int_stack+370392,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+341880,int_stack+204480,int_stack+197550,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+920040,int_stack+341880,int_stack+396528,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+362670,int_stack+920040,int_stack+414546,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+956076,int_stack+362670,int_stack+876480,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+876480,int_stack+212400,int_stack+204480,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+414150,int_stack+876480,int_stack+341880,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1021416,int_stack+414150,int_stack+920040,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1081476,int_stack+1021416,int_stack+362670,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1158696,int_stack+1081476,int_stack+956076,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+341880,int_stack+221376,int_stack+212400,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+900240,int_stack+341880,int_stack+876480,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+947760,int_stack+900240,int_stack+414150,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+368808,int_stack+947760,int_stack+1021416,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1250172,int_stack+368808,int_stack+1081476,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1017060,int_stack+1250172,int_stack+1158696,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1139028,int_stack+231474,int_stack+221376,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1169322,int_stack+1139028,int_stack+341880,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1358280,int_stack+1169322,int_stack+900240,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1437480,int_stack+1358280,int_stack+947760,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+876480,int_stack+1437480,int_stack+368808,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1541430,int_stack+876480,int_stack+1250172,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3315144,int_stack+1541430,int_stack+1017060,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+341880,int_stack+242760,int_stack+231474,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+375738,int_stack+341880,int_stack+1139028,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1002606,int_stack+375738,int_stack+1169322,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+341880,int_stack+1002606,int_stack+1358280,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1002606,int_stack+341880,int_stack+1437480,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1148136,int_stack+1002606,int_stack+876480,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+876480,int_stack+1148136,int_stack+1541430,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1061808,int_stack+876480,int_stack+3315144,66);
 /*--- compute (mp|nl) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1257828,int_stack+1061808,int_stack+0,2970);
 /*--- compute (ld|nl) ---*/
 hrr1_build_ld(Libint->AB,int_stack+3315144,int_stack+1257828,int_stack+475530,2970);
 /*--- compute (kf|nl) ---*/
 hrr1_build_kf(Libint->AB,int_stack+4117044,int_stack+3315144,int_stack+1842024,2970);
 /*--- compute (ig|nl) ---*/
 hrr1_build_ig(Libint->AB,int_stack+5186244,int_stack+4117044,int_stack+2483544,2970);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+260448,int_stack+255300,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+266532,int_stack+260448,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+273630,int_stack+266532,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+122382,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+281820,int_stack+273630,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+173862,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+173862,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1747878,int_stack+24570,int_stack+122382,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+85410,int_stack+291180,int_stack+281820,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113490,int_stack+85410,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+216450,int_stack+113490,int_stack+173862,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1825098,int_stack+216450,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1916358,int_stack+1825098,int_stack+1747878,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1747878,int_stack+301788,int_stack+291180,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+1747878,int_stack+85410,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2024466,int_stack+0,int_stack+113490,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+56160,int_stack+2024466,int_stack+216450,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+162630,int_stack+56160,int_stack+1825098,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2106366,int_stack+162630,int_stack+1916358,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1779702,int_stack+313722,int_stack+301788,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1815504,int_stack+1779702,int_stack+1747878,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1879152,int_stack+1815504,int_stack+0,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2250510,int_stack+1879152,int_stack+2024466,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2373360,int_stack+2250510,int_stack+56160,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2522418,int_stack+2373360,int_stack+162630,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2522418,int_stack+2106366,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+185328,int_stack+327060,int_stack+313722,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+225342,int_stack+185328,int_stack+1779702,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+296946,int_stack+225342,int_stack+1815504,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+403026,int_stack+296946,int_stack+1879152,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+185328,int_stack+403026,int_stack+2250510,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+357318,int_stack+185328,int_stack+2373360,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+556062,int_stack+357318,int_stack+2522418,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+185328,int_stack+556062,int_stack+0,78);
 /*--- compute (np|nl) ---*/
 hrr1_build_np(Libint->AB,int_stack+416988,int_stack+185328,int_stack+1061808,2970);
 /*--- compute (md|nl) ---*/
 hrr1_build_md(Libint->AB,int_stack+1747878,int_stack+416988,int_stack+1257828,2970);
 /*--- compute (lf|nl) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+1747878,int_stack+3315144,2970);
 /*--- compute (kg|nl) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1336500,int_stack+0,int_stack+4117044,2970);
 /*--- compute (ih|nl) ---*/
 hrr1_build_ih(Libint->AB,int_stack+2940300,int_stack+1336500,int_stack+5186244,2970);
 return int_stack+2940300;}
