/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iilh(Libint_t*, prim_data*);

  /* Computes quartets of (ii|lh) integrals */

REALTYPE *hrr_order_iilh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[6][13] = int_stack + 9380;
 Libint->vrr_classes[7][8] = int_stack + 12320;
 Libint->vrr_classes[7][9] = int_stack + 13940;
 Libint->vrr_classes[7][10] = int_stack + 15920;
 Libint->vrr_classes[7][11] = int_stack + 18296;
 Libint->vrr_classes[7][12] = int_stack + 21104;
 Libint->vrr_classes[7][13] = int_stack + 24380;
 Libint->vrr_classes[8][8] = int_stack + 28160;
 Libint->vrr_classes[8][9] = int_stack + 30185;
 Libint->vrr_classes[8][10] = int_stack + 32660;
 Libint->vrr_classes[8][11] = int_stack + 35630;
 Libint->vrr_classes[8][12] = int_stack + 39140;
 Libint->vrr_classes[8][13] = int_stack + 43235;
 Libint->vrr_classes[9][8] = int_stack + 47960;
 Libint->vrr_classes[9][9] = int_stack + 50435;
 Libint->vrr_classes[9][10] = int_stack + 53460;
 Libint->vrr_classes[9][11] = int_stack + 57090;
 Libint->vrr_classes[9][12] = int_stack + 61380;
 Libint->vrr_classes[9][13] = int_stack + 66385;
 Libint->vrr_classes[10][8] = int_stack + 72160;
 Libint->vrr_classes[10][9] = int_stack + 75130;
 Libint->vrr_classes[10][10] = int_stack + 78760;
 Libint->vrr_classes[10][11] = int_stack + 83116;
 Libint->vrr_classes[10][12] = int_stack + 88264;
 Libint->vrr_classes[10][13] = int_stack + 94270;
 Libint->vrr_classes[11][8] = int_stack + 101200;
 Libint->vrr_classes[11][9] = int_stack + 104710;
 Libint->vrr_classes[11][10] = int_stack + 109000;
 Libint->vrr_classes[11][11] = int_stack + 114148;
 Libint->vrr_classes[11][12] = int_stack + 120232;
 Libint->vrr_classes[11][13] = int_stack + 127330;
 Libint->vrr_classes[12][8] = int_stack + 135520;
 Libint->vrr_classes[12][9] = int_stack + 139615;
 Libint->vrr_classes[12][10] = int_stack + 144620;
 Libint->vrr_classes[12][11] = int_stack + 150626;
 Libint->vrr_classes[12][12] = int_stack + 157724;
 Libint->vrr_classes[12][13] = int_stack + 166005;
 memset(int_stack,0,175560*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 175560;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iilh(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+175560,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+179340,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+183960,int_stack+179340,int_stack+175560,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+191520,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+197064,int_stack+191520,int_stack+179340,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+206304,int_stack+197064,int_stack+183960,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+175560,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+218904,int_stack+175560,int_stack+191520,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+229992,int_stack+218904,int_stack+197064,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+182112,int_stack+229992,int_stack+206304,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+201012,int_stack+9380,int_stack+6832,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+245392,int_stack+201012,int_stack+175560,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+258496,int_stack+245392,int_stack+218904,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+201012,int_stack+258496,int_stack+229992,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+224112,int_stack+201012,int_stack+182112,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+175560,int_stack+13940,int_stack+12320,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+180420,int_stack+15920,int_stack+13940,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+186360,int_stack+180420,int_stack+175560,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+196080,int_stack+18296,int_stack+15920,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+203208,int_stack+196080,int_stack+180420,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+250572,int_stack+203208,int_stack+186360,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+175560,int_stack+21104,int_stack+18296,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+175560,int_stack+196080,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+266772,int_stack+0,int_stack+203208,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+183984,int_stack+266772,int_stack+250572,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+250572,int_stack+24380,int_stack+21104,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+286572,int_stack+250572,int_stack+175560,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+303420,int_stack+286572,int_stack+0,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+327180,int_stack+303420,int_stack+266772,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+250572,int_stack+327180,int_stack+183984,36);
 /*--- compute (ip|lh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+284592,int_stack+250572,int_stack+224112,945);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+30185,int_stack+28160,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+6075,int_stack+32660,int_stack+30185,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+13500,int_stack+6075,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+175560,int_stack+35630,int_stack+32660,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+184470,int_stack+175560,int_stack+6075,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+199320,int_stack+184470,int_stack+13500,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+39140,int_stack+35630,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+10530,int_stack+0,int_stack+175560,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+219570,int_stack+10530,int_stack+184470,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+363972,int_stack+219570,int_stack+199320,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+175560,int_stack+43235,int_stack+39140,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+187845,int_stack+175560,int_stack+0,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+394347,int_stack+187845,int_stack+10530,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+394347,int_stack+219570,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+175560,int_stack+0,int_stack+363972,45);
 /*--- compute (kp|lh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+363972,int_stack+175560,int_stack+250572,945);
 /*--- compute (id|lh) ---*/
 hrr1_build_id(Libint->AB,int_stack+466032,int_stack+363972,int_stack+284592,945);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+50435,int_stack+47960,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7425,int_stack+53460,int_stack+50435,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+16500,int_stack+7425,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+31350,int_stack+57090,int_stack+53460,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+218085,int_stack+31350,int_stack+7425,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+236235,int_stack+218085,int_stack+16500,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+61380,int_stack+57090,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+260985,int_stack+0,int_stack+31350,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+12870,int_stack+260985,int_stack+218085,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+282765,int_stack+12870,int_stack+236235,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+218085,int_stack+66385,int_stack+61380,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+233100,int_stack+218085,int_stack+0,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+319890,int_stack+233100,int_stack+260985,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+218085,int_stack+319890,int_stack+12870,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+218085,int_stack+282765,55);
 /*--- compute (lp|lh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+218085,int_stack+0,int_stack+175560,945);
 /*--- compute (kd|lh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+624792,int_stack+218085,int_stack+363972,945);
 /*--- compute (if|lh) ---*/
 hrr1_build_if(Libint->AB,int_stack+828912,int_stack+624792,int_stack+466032,945);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+175560,int_stack+75130,int_stack+72160,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+184470,int_stack+78760,int_stack+75130,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+195360,int_stack+184470,int_stack+175560,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+345660,int_stack+83116,int_stack+78760,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+358728,int_stack+345660,int_stack+184470,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+380508,int_stack+358728,int_stack+195360,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+175560,int_stack+88264,int_stack+83116,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+191004,int_stack+175560,int_stack+345660,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+410208,int_stack+191004,int_stack+358728,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+446508,int_stack+410208,int_stack+380508,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+345660,int_stack+94270,int_stack+88264,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+363678,int_stack+345660,int_stack+175560,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+491058,int_stack+363678,int_stack+191004,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+345660,int_stack+491058,int_stack+410208,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+491058,int_stack+345660,int_stack+446508,66);
 /*--- compute (mp|lh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1093512,int_stack+491058,int_stack+0,945);
 /*--- compute (ld|lh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1249437,int_stack+1093512,int_stack+218085,945);
 /*--- compute (kf|lh) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1504587,int_stack+1249437,int_stack+624792,945);
 /*--- compute (ig|lh) ---*/
 hrr1_build_ig(Libint->AB,int_stack+1844787,int_stack+1504587,int_stack+828912,945);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+104710,int_stack+101200,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10530,int_stack+109000,int_stack+104710,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23400,int_stack+10530,int_stack+0,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44460,int_stack+114148,int_stack+109000,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+59904,int_stack+44460,int_stack+10530,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+553428,int_stack+59904,int_stack+23400,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+120232,int_stack+114148,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+85644,int_stack+0,int_stack+44460,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+588528,int_stack+85644,int_stack+59904,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+18252,int_stack+588528,int_stack+553428,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+553428,int_stack+127330,int_stack+120232,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+631428,int_stack+553428,int_stack+0,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+667932,int_stack+631428,int_stack+85644,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+70902,int_stack+667932,int_stack+588528,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+553428,int_stack+70902,int_stack+18252,78);
 /*--- compute (np|lh) ---*/
 hrr1_build_np(Libint->AB,int_stack+627138,int_stack+553428,int_stack+491058,945);
 /*--- compute (md|lh) ---*/
 hrr1_build_md(Libint->AB,int_stack+175560,int_stack+627138,int_stack+1093512,945);
 /*--- compute (lf|lh) ---*/
 hrr1_build_lf(Libint->AB,int_stack+814248,int_stack+175560,int_stack+1249437,945);
 /*--- compute (kg|lh) ---*/
 hrr1_build_kg(Libint->AB,int_stack+2241687,int_stack+814248,int_stack+1504587,945);
 /*--- compute (ih|lh) ---*/
 hrr1_build_ih(Libint->AB,int_stack+1239498,int_stack+2241687,int_stack+1844787,945);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+139615,int_stack+135520,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12285,int_stack+144620,int_stack+139615,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+27300,int_stack+12285,int_stack+0,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51870,int_stack+150626,int_stack+144620,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+69888,int_stack+51870,int_stack+12285,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+99918,int_stack+69888,int_stack+27300,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+157724,int_stack+150626,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1795158,int_stack+0,int_stack+51870,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1831194,int_stack+1795158,int_stack+69888,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+21294,int_stack+1831194,int_stack+99918,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+82719,int_stack+166005,int_stack+157724,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+107562,int_stack+82719,int_stack+0,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1881244,int_stack+107562,int_stack+1795158,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+82719,int_stack+1881244,int_stack+1831194,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1795158,int_stack+82719,int_stack+21294,91);
 /*--- compute (op|lh) ---*/
 hrr1_build_op(Libint->AB,int_stack+1881153,int_stack+1795158,int_stack+553428,945);
 /*--- compute (nd|lh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2751987,int_stack+1881153,int_stack+627138,945);
 /*--- compute (mf|lh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3126207,int_stack+2751987,int_stack+175560,945);
 /*--- compute (lg|lh) ---*/
 hrr1_build_lg(Libint->AB,int_stack+0,int_stack+3126207,int_stack+814248,945);
 /*--- compute (kh|lh) ---*/
 hrr1_build_kh(Libint->AB,int_stack+2751987,int_stack+0,int_stack+2241687,945);
 /*--- compute (ii|lh) ---*/
 hrr1_build_ii(Libint->AB,int_stack+0,int_stack+2751987,int_stack+1239498,945);
 return int_stack+0;}
