/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iili(Libint_t*, prim_data*);

  /* Computes quartets of (ii|li) integrals */

REALTYPE *hrr_order_iili(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[6][13] = int_stack + 9380;
 Libint->vrr_classes[6][14] = int_stack + 12320;
 Libint->vrr_classes[7][8] = int_stack + 15680;
 Libint->vrr_classes[7][9] = int_stack + 17300;
 Libint->vrr_classes[7][10] = int_stack + 19280;
 Libint->vrr_classes[7][11] = int_stack + 21656;
 Libint->vrr_classes[7][12] = int_stack + 24464;
 Libint->vrr_classes[7][13] = int_stack + 27740;
 Libint->vrr_classes[7][14] = int_stack + 31520;
 Libint->vrr_classes[8][8] = int_stack + 35840;
 Libint->vrr_classes[8][9] = int_stack + 37865;
 Libint->vrr_classes[8][10] = int_stack + 40340;
 Libint->vrr_classes[8][11] = int_stack + 43310;
 Libint->vrr_classes[8][12] = int_stack + 46820;
 Libint->vrr_classes[8][13] = int_stack + 50915;
 Libint->vrr_classes[8][14] = int_stack + 55640;
 Libint->vrr_classes[9][8] = int_stack + 61040;
 Libint->vrr_classes[9][9] = int_stack + 63515;
 Libint->vrr_classes[9][10] = int_stack + 66540;
 Libint->vrr_classes[9][11] = int_stack + 70170;
 Libint->vrr_classes[9][12] = int_stack + 74460;
 Libint->vrr_classes[9][13] = int_stack + 79465;
 Libint->vrr_classes[9][14] = int_stack + 85240;
 Libint->vrr_classes[10][8] = int_stack + 91840;
 Libint->vrr_classes[10][9] = int_stack + 94810;
 Libint->vrr_classes[10][10] = int_stack + 98440;
 Libint->vrr_classes[10][11] = int_stack + 102796;
 Libint->vrr_classes[10][12] = int_stack + 107944;
 Libint->vrr_classes[10][13] = int_stack + 113950;
 Libint->vrr_classes[10][14] = int_stack + 120880;
 Libint->vrr_classes[11][8] = int_stack + 128800;
 Libint->vrr_classes[11][9] = int_stack + 132310;
 Libint->vrr_classes[11][10] = int_stack + 136600;
 Libint->vrr_classes[11][11] = int_stack + 141748;
 Libint->vrr_classes[11][12] = int_stack + 147832;
 Libint->vrr_classes[11][13] = int_stack + 154930;
 Libint->vrr_classes[11][14] = int_stack + 163120;
 Libint->vrr_classes[12][8] = int_stack + 172480;
 Libint->vrr_classes[12][9] = int_stack + 176575;
 Libint->vrr_classes[12][10] = int_stack + 181580;
 Libint->vrr_classes[12][11] = int_stack + 187586;
 Libint->vrr_classes[12][12] = int_stack + 194684;
 Libint->vrr_classes[12][13] = int_stack + 202965;
 Libint->vrr_classes[12][14] = int_stack + 212520;
 memset(int_stack,0,223440*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 223440;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iili(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+223440,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+227220,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+231840,int_stack+227220,int_stack+223440,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+239400,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+244944,int_stack+239400,int_stack+227220,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+254184,int_stack+244944,int_stack+231840,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+223440,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+266784,int_stack+223440,int_stack+239400,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+277872,int_stack+266784,int_stack+244944,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+229992,int_stack+277872,int_stack+254184,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+248892,int_stack+9380,int_stack+6832,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+293272,int_stack+248892,int_stack+223440,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+306376,int_stack+293272,int_stack+266784,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+324856,int_stack+306376,int_stack+277872,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+256536,int_stack+324856,int_stack+229992,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+223440,int_stack+12320,int_stack+9380,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+232260,int_stack+223440,int_stack+248892,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+347956,int_stack+232260,int_stack+293272,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+223440,int_stack+347956,int_stack+306376,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+282996,int_stack+223440,int_stack+324856,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+315336,int_stack+282996,int_stack+256536,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+223440,int_stack+17300,int_stack+15680,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+228300,int_stack+19280,int_stack+17300,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+234240,int_stack+228300,int_stack+223440,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+243960,int_stack+21656,int_stack+19280,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+251088,int_stack+243960,int_stack+228300,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+262968,int_stack+251088,int_stack+234240,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+223440,int_stack+24464,int_stack+21656,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+279168,int_stack+223440,int_stack+243960,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+293424,int_stack+279168,int_stack+251088,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+231864,int_stack+293424,int_stack+262968,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+256164,int_stack+27740,int_stack+24464,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+350616,int_stack+256164,int_stack+223440,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+350616,int_stack+279168,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+367464,int_stack+0,int_stack+293424,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+265992,int_stack+367464,int_stack+231864,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+223440,int_stack+31520,int_stack+27740,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+234780,int_stack+223440,int_stack+256164,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+397164,int_stack+234780,int_stack+350616,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+223440,int_stack+397164,int_stack+0,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+397164,int_stack+223440,int_stack+367464,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+350616,int_stack+397164,int_stack+265992,36);
 /*--- compute (ip|li) ---*/
 hrr1_build_ip(Libint->AB,int_stack+395976,int_stack+350616,int_stack+315336,1260);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+223440,int_stack+37865,int_stack+35840,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+229515,int_stack+40340,int_stack+37865,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+236940,int_stack+229515,int_stack+223440,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+249090,int_stack+43310,int_stack+40340,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+258000,int_stack+249090,int_stack+229515,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+272850,int_stack+258000,int_stack+236940,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+223440,int_stack+46820,int_stack+43310,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+293100,int_stack+223440,int_stack+249090,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+310920,int_stack+293100,int_stack+258000,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+233970,int_stack+310920,int_stack+272850,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+264345,int_stack+50915,int_stack+46820,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+264345,int_stack+223440,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+21060,int_stack+0,int_stack+293100,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+501816,int_stack+21060,int_stack+310920,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+276630,int_stack+501816,int_stack+233970,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+223440,int_stack+55640,int_stack+50915,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+237615,int_stack+223440,int_stack+264345,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+538941,int_stack+237615,int_stack+0,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+223440,int_stack+538941,int_stack+21060,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+223440,int_stack+501816,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+501816,int_stack+0,int_stack+276630,45);
 /*--- compute (kp|li) ---*/
 hrr1_build_kp(Libint->AB,int_stack+558516,int_stack+501816,int_stack+350616,1260);
 /*--- compute (id|li) ---*/
 hrr1_build_id(Libint->AB,int_stack+694596,int_stack+558516,int_stack+395976,1260);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+63515,int_stack+61040,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7425,int_stack+66540,int_stack+63515,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+16500,int_stack+7425,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+31350,int_stack+70170,int_stack+66540,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+42240,int_stack+31350,int_stack+7425,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+223440,int_stack+42240,int_stack+16500,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+74460,int_stack+70170,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+248190,int_stack+0,int_stack+31350,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+269970,int_stack+248190,int_stack+42240,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+12870,int_stack+269970,int_stack+223440,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+223440,int_stack+79465,int_stack+74460,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+49995,int_stack+223440,int_stack+0,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+300220,int_stack+49995,int_stack+248190,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+336520,int_stack+300220,int_stack+269970,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+238455,int_stack+336520,int_stack+12870,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+85240,int_stack+79465,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+17325,int_stack+0,int_stack+223440,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+381895,int_stack+17325,int_stack+49995,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+381895,int_stack+300220,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+381895,int_stack+0,int_stack+336520,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+381895,int_stack+238455,55);
 /*--- compute (lp|li) ---*/
 hrr1_build_lp(Libint->AB,int_stack+223440,int_stack+0,int_stack+501816,1260);
 /*--- compute (kd|li) ---*/
 hrr1_build_kd(Libint->AB,int_stack+906276,int_stack+223440,int_stack+558516,1260);
 /*--- compute (if|li) ---*/
 hrr1_build_if(Libint->AB,int_stack+1178436,int_stack+906276,int_stack+694596,1260);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+69300,int_stack+94810,int_stack+91840,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+78210,int_stack+98440,int_stack+94810,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+393540,int_stack+78210,int_stack+69300,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+411360,int_stack+102796,int_stack+98440,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+424428,int_stack+411360,int_stack+78210,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+69300,int_stack+424428,int_stack+393540,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+393540,int_stack+107944,int_stack+102796,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+446208,int_stack+393540,int_stack+411360,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+472344,int_stack+446208,int_stack+424428,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+508644,int_stack+472344,int_stack+69300,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+69300,int_stack+113950,int_stack+107944,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+408984,int_stack+69300,int_stack+393540,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+553194,int_stack+408984,int_stack+446208,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+596754,int_stack+553194,int_stack+472344,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+439872,int_stack+596754,int_stack+508644,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+87318,int_stack+120880,int_stack+113950,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+502242,int_stack+87318,int_stack+69300,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+69300,int_stack+502242,int_stack+408984,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+651204,int_stack+69300,int_stack+553194,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+502242,int_stack+651204,int_stack+596754,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+578472,int_stack+502242,int_stack+439872,66);
 /*--- compute (mp|li) ---*/
 hrr1_build_mp(Libint->AB,int_stack+661632,int_stack+578472,int_stack+0,1260);
 /*--- compute (ld|li) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1531236,int_stack+661632,int_stack+223440,1260);
 /*--- compute (kf|li) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1871436,int_stack+1531236,int_stack+906276,1260);
 /*--- compute (ig|li) ---*/
 hrr1_build_ig(Libint->AB,int_stack+2325036,int_stack+1871436,int_stack+1178436,1260);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+223440,int_stack+132310,int_stack+128800,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+233970,int_stack+136600,int_stack+132310,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+246840,int_stack+233970,int_stack+223440,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+267900,int_stack+141748,int_stack+136600,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+283344,int_stack+267900,int_stack+233970,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+309084,int_stack+283344,int_stack+246840,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+223440,int_stack+147832,int_stack+141748,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+344184,int_stack+223440,int_stack+267900,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+375072,int_stack+344184,int_stack+283344,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+241692,int_stack+375072,int_stack+309084,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+294342,int_stack+154930,int_stack+147832,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+417972,int_stack+294342,int_stack+223440,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+454476,int_stack+417972,int_stack+344184,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+505956,int_stack+454476,int_stack+375072,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+315636,int_stack+505956,int_stack+241692,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+223440,int_stack+163120,int_stack+154930,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+248010,int_stack+223440,int_stack+294342,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+248010,int_stack+417972,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+223440,int_stack+0,int_stack+454476,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+223440,int_stack+505956,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+389346,int_stack+0,int_stack+315636,78);
 /*--- compute (np|li) ---*/
 hrr1_build_np(Libint->AB,int_stack+869532,int_stack+389346,int_stack+578472,1260);
 /*--- compute (md|li) ---*/
 hrr1_build_md(Libint->AB,int_stack+2854236,int_stack+869532,int_stack+661632,1260);
 /*--- compute (lf|li) ---*/
 hrr1_build_lf(Libint->AB,int_stack+3270036,int_stack+2854236,int_stack+1531236,1260);
 /*--- compute (kg|li) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1119012,int_stack+3270036,int_stack+1871436,1260);
 /*--- compute (ih|li) ---*/
 hrr1_build_ih(Libint->AB,int_stack+3837036,int_stack+1119012,int_stack+2325036,1260);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+176575,int_stack+172480,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12285,int_stack+181580,int_stack+176575,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+27300,int_stack+12285,int_stack+0,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51870,int_stack+187586,int_stack+181580,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+69888,int_stack+51870,int_stack+12285,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+99918,int_stack+69888,int_stack+27300,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+194684,int_stack+187586,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+140868,int_stack+0,int_stack+51870,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+223440,int_stack+140868,int_stack+69888,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+21294,int_stack+223440,int_stack+99918,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+82719,int_stack+202965,int_stack+194684,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+273490,int_stack+82719,int_stack+0,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+316078,int_stack+273490,int_stack+140868,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+107562,int_stack+316078,int_stack+223440,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+487626,int_stack+107562,int_stack+21294,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+223440,int_stack+212520,int_stack+202965,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+223440,int_stack+82719,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+182637,int_stack+0,int_stack+273490,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+182637,int_stack+316078,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+182637,int_stack+0,int_stack+107562,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+182637,int_stack+487626,91);
 /*--- compute (op|li) ---*/
 hrr1_build_op(Libint->AB,int_stack+487626,int_stack+0,int_stack+389346,1260);
 /*--- compute (nd|li) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1799412,int_stack+487626,int_stack+869532,1260);
 /*--- compute (mf|li) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+1799412,int_stack+2854236,1260);
 /*--- compute (lg|li) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1799412,int_stack+0,int_stack+3270036,1260);
 /*--- compute (kh|li) ---*/
 hrr1_build_kh(Libint->AB,int_stack+0,int_stack+1799412,int_stack+1119012,1260);
 /*--- compute (ii|li) ---*/
 hrr1_build_ii(Libint->AB,int_stack+952560,int_stack+0,int_stack+3837036,1260);
 return int_stack+952560;}
