/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iphh(Libint_t*, prim_data*);

  /* Computes quartets of (ip|hh) integrals */

REALTYPE *hrr_order_iphh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][5] = int_stack + 0;
 Libint->vrr_classes[6][6] = int_stack + 588;
 Libint->vrr_classes[6][7] = int_stack + 1372;
 Libint->vrr_classes[6][8] = int_stack + 2380;
 Libint->vrr_classes[6][9] = int_stack + 3640;
 Libint->vrr_classes[6][10] = int_stack + 5180;
 Libint->vrr_classes[7][5] = int_stack + 7028;
 Libint->vrr_classes[7][6] = int_stack + 7784;
 Libint->vrr_classes[7][7] = int_stack + 8792;
 Libint->vrr_classes[7][8] = int_stack + 10088;
 Libint->vrr_classes[7][9] = int_stack + 11708;
 Libint->vrr_classes[7][10] = int_stack + 13688;
 memset(int_stack,0,16064*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 16064;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iphh(Libint, Data);
   Data++;
 }
 /*--- compute (i0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+16064,int_stack+588,int_stack+0,28);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+17828,int_stack+1372,int_stack+588,28);
 /*--- compute (i0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+20180,int_stack+17828,int_stack+16064,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+23708,int_stack+2380,int_stack+1372,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+26732,int_stack+23708,int_stack+17828,28);
 /*--- compute (i0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+31436,int_stack+26732,int_stack+20180,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+16064,int_stack+3640,int_stack+2380,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+37316,int_stack+16064,int_stack+23708,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+43364,int_stack+37316,int_stack+26732,28);
 /*--- compute (i0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+19844,int_stack+43364,int_stack+31436,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+28664,int_stack+5180,int_stack+3640,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+51204,int_stack+28664,int_stack+16064,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+58764,int_stack+51204,int_stack+37316,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+28664,int_stack+58764,int_stack+43364,28);
 /*--- compute (i0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+40424,int_stack+28664,int_stack+19844,28);
 /*--- compute (k0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+16064,int_stack+7784,int_stack+7028,36);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+18332,int_stack+8792,int_stack+7784,36);
 /*--- compute (k0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+21356,int_stack+18332,int_stack+16064,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+25892,int_stack+10088,int_stack+8792,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+29780,int_stack+25892,int_stack+18332,36);
 /*--- compute (k0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+52772,int_stack+29780,int_stack+21356,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+16064,int_stack+11708,int_stack+10088,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+60332,int_stack+16064,int_stack+25892,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+60332,int_stack+29780,36);
 /*--- compute (k0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+20924,int_stack+0,int_stack+52772,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+52772,int_stack+13688,int_stack+11708,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+68108,int_stack+52772,int_stack+16064,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+77828,int_stack+68108,int_stack+60332,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+52772,int_stack+77828,int_stack+0,36);
 /*--- compute (k0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+0,int_stack+52772,int_stack+20924,36);
 /*--- compute (ip|hh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+52772,int_stack+0,int_stack+40424,441);
 return int_stack+52772;}
