/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdkf(Libint_t*, prim_data*);

  /* Computes quartets of (kd|kf) integrals */

REALTYPE *hrr_order_kdkf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][7] = int_stack + 0;
 Libint->vrr_classes[7][8] = int_stack + 1296;
 Libint->vrr_classes[7][9] = int_stack + 2916;
 Libint->vrr_classes[7][10] = int_stack + 4896;
 Libint->vrr_classes[8][7] = int_stack + 7272;
 Libint->vrr_classes[8][8] = int_stack + 8892;
 Libint->vrr_classes[8][9] = int_stack + 10917;
 Libint->vrr_classes[8][10] = int_stack + 13392;
 Libint->vrr_classes[9][7] = int_stack + 16362;
 Libint->vrr_classes[9][8] = int_stack + 18342;
 Libint->vrr_classes[9][9] = int_stack + 20817;
 Libint->vrr_classes[9][10] = int_stack + 23842;
 memset(int_stack,0,27472*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 27472;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdkf(Libint, Data);
   Data++;
 }
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+27472,int_stack+1296,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+31360,int_stack+2916,int_stack+1296,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+36220,int_stack+31360,int_stack+27472,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+43996,int_stack+4896,int_stack+2916,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+49936,int_stack+43996,int_stack+31360,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+59656,int_stack+49936,int_stack+36220,36);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+27472,int_stack+8892,int_stack+7272,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+32332,int_stack+10917,int_stack+8892,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+38407,int_stack+32332,int_stack+27472,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+48127,int_stack+13392,int_stack+10917,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+48127,int_stack+32332,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+72616,int_stack+0,int_stack+38407,45);
 /*--- compute (kp|kf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+88816,int_stack+72616,int_stack+59656,360);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+18342,int_stack+16362,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5940,int_stack+20817,int_stack+18342,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+27472,int_stack+5940,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+39352,int_stack+23842,int_stack+20817,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+48427,int_stack+39352,int_stack+5940,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+48427,int_stack+27472,55);
 /*--- compute (lp|kf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+19800,int_stack+0,int_stack+72616,360);
 /*--- compute (kd|kf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+127696,int_stack+19800,int_stack+88816,360);
 return int_stack+127696;}
