/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdlg(Libint_t*, prim_data*);

  /* Computes quartets of (kd|lg) integrals */

REALTYPE *hrr_order_kdlg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[8][8] = int_stack + 12060;
 Libint->vrr_classes[8][9] = int_stack + 14085;
 Libint->vrr_classes[8][10] = int_stack + 16560;
 Libint->vrr_classes[8][11] = int_stack + 19530;
 Libint->vrr_classes[8][12] = int_stack + 23040;
 Libint->vrr_classes[9][8] = int_stack + 27135;
 Libint->vrr_classes[9][9] = int_stack + 29610;
 Libint->vrr_classes[9][10] = int_stack + 32635;
 Libint->vrr_classes[9][11] = int_stack + 36265;
 Libint->vrr_classes[9][12] = int_stack + 40555;
 memset(int_stack,0,45560*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 45560;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdlg(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+45560,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+50420,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+56360,int_stack+50420,int_stack+45560,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+66080,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+73208,int_stack+66080,int_stack+50420,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+85088,int_stack+73208,int_stack+56360,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45560,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+101288,int_stack+45560,int_stack+66080,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+45560,int_stack+101288,int_stack+73208,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+101288,int_stack+45560,int_stack+85088,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+45560,int_stack+14085,int_stack+12060,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+51635,int_stack+16560,int_stack+14085,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+59060,int_stack+51635,int_stack+45560,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+71210,int_stack+19530,int_stack+16560,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+80120,int_stack+71210,int_stack+51635,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+125588,int_stack+80120,int_stack+59060,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45560,int_stack+23040,int_stack+19530,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+45560,int_stack+71210,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+45560,int_stack+0,int_stack+80120,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+70310,int_stack+45560,int_stack+125588,45);
 /*--- compute (kp|lg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+125588,int_stack+70310,int_stack+101288,675);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+45560,int_stack+29610,int_stack+27135,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+52985,int_stack+32635,int_stack+29610,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+52985,int_stack+45560,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+14850,int_stack+36265,int_stack+32635,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+100685,int_stack+14850,int_stack+52985,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+45560,int_stack+100685,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+40555,int_stack+36265,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+198488,int_stack+0,int_stack+14850,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+198488,int_stack+100685,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+198488,int_stack+0,int_stack+45560,55);
 /*--- compute (lp|lg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+235613,int_stack+198488,int_stack+70310,675);
 /*--- compute (kd|lg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+326738,int_stack+235613,int_stack+125588,675);
 return int_stack+326738;}
