/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdnl(Libint_t*, prim_data*);

  /* Computes quartets of (kd|nl) integrals */

REALTYPE *hrr_order_kdnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[7][17] = int_stack + 26964;
 Libint->vrr_classes[7][18] = int_stack + 33120;
 Libint->vrr_classes[8][10] = int_stack + 39960;
 Libint->vrr_classes[8][11] = int_stack + 42930;
 Libint->vrr_classes[8][12] = int_stack + 46440;
 Libint->vrr_classes[8][13] = int_stack + 50535;
 Libint->vrr_classes[8][14] = int_stack + 55260;
 Libint->vrr_classes[8][15] = int_stack + 60660;
 Libint->vrr_classes[8][16] = int_stack + 66780;
 Libint->vrr_classes[8][17] = int_stack + 73665;
 Libint->vrr_classes[8][18] = int_stack + 81360;
 Libint->vrr_classes[9][10] = int_stack + 89910;
 Libint->vrr_classes[9][11] = int_stack + 93540;
 Libint->vrr_classes[9][12] = int_stack + 97830;
 Libint->vrr_classes[9][13] = int_stack + 102835;
 Libint->vrr_classes[9][14] = int_stack + 108610;
 Libint->vrr_classes[9][15] = int_stack + 115210;
 Libint->vrr_classes[9][16] = int_stack + 122690;
 Libint->vrr_classes[9][17] = int_stack + 131105;
 Libint->vrr_classes[9][18] = int_stack + 140510;
 memset(int_stack,0,150960*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 150960;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdnl(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+150960,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+158088,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+166512,int_stack+158088,int_stack+150960,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+180768,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+190596,int_stack+180768,int_stack+158088,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+207444,int_stack+190596,int_stack+166512,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+150960,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+231204,int_stack+150960,int_stack+180768,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+162300,int_stack+231204,int_stack+190596,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+250860,int_stack+162300,int_stack+207444,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+190380,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+203340,int_stack+190380,int_stack+150960,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+286500,int_stack+203340,int_stack+231204,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+319260,int_stack+286500,int_stack+162300,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+361380,int_stack+319260,int_stack+250860,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+150960,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+226020,int_stack+150960,int_stack+190380,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+411276,int_stack+226020,int_stack+203340,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+165648,int_stack+411276,int_stack+286500,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+251940,int_stack+165648,int_stack+319260,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+449076,int_stack+251940,int_stack+361380,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+310908,int_stack+26964,int_stack+21456,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+327432,int_stack+310908,int_stack+150960,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+356808,int_stack+327432,int_stack+226020,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+515604,int_stack+356808,int_stack+411276,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+572304,int_stack+515604,int_stack+165648,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+150960,int_stack+572304,int_stack+251940,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+641100,int_stack+150960,int_stack+449076,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+229584,int_stack+33120,int_stack+26964,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+248052,int_stack+229584,int_stack+310908,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+400008,int_stack+248052,int_stack+327432,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+229584,int_stack+400008,int_stack+356808,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+294384,int_stack+229584,int_stack+515604,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+373764,int_stack+294384,int_stack+572304,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+229584,int_stack+373764,int_stack+150960,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+330672,int_stack+229584,int_stack+641100,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+150960,int_stack+42930,int_stack+39960,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+159870,int_stack+46440,int_stack+42930,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+170400,int_stack+159870,int_stack+150960,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+188220,int_stack+50535,int_stack+46440,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+200505,int_stack+188220,int_stack+159870,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+221565,int_stack+200505,int_stack+170400,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+150960,int_stack+55260,int_stack+50535,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+251265,int_stack+150960,int_stack+188220,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+165135,int_stack+251265,int_stack+200505,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+275835,int_stack+165135,int_stack+221565,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+200235,int_stack+60660,int_stack+55260,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+216435,int_stack+200235,int_stack+150960,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+437592,int_stack+216435,int_stack+251265,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+478542,int_stack+437592,int_stack+165135,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+531192,int_stack+478542,int_stack+275835,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+150960,int_stack+66780,int_stack+60660,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+244785,int_stack+150960,int_stack+200235,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+277185,int_stack+244785,int_stack+216435,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+169320,int_stack+277185,int_stack+437592,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+593562,int_stack+169320,int_stack+478542,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+437592,int_stack+593562,int_stack+531192,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+520752,int_stack+73665,int_stack+66780,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+541407,int_stack+520752,int_stack+150960,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+667272,int_stack+541407,int_stack+244785,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+667272,int_stack+277185,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+230745,int_stack+0,int_stack+169320,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+721272,int_stack+230745,int_stack+593562,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+819552,int_stack+721272,int_stack+437592,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+437592,int_stack+81360,int_stack+73665,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+460677,int_stack+437592,int_stack+520752,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+150960,int_stack+460677,int_stack+541407,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+437592,int_stack+150960,int_stack+667272,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+518592,int_stack+437592,int_stack+0,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+926472,int_stack+518592,int_stack+230745,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+437592,int_stack+926472,int_stack+721272,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+563952,int_stack+437592,int_stack+819552,45);
 /*--- compute (kp|nl) ---*/
 hrr1_build_kp(Libint->AB,int_stack+697602,int_stack+563952,int_stack+330672,2970);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+93540,int_stack+89910,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+97830,int_stack+93540,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23760,int_stack+10890,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+45540,int_stack+102835,int_stack+97830,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+60555,int_stack+45540,int_stack+10890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+150960,int_stack+60555,int_stack+23760,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+108610,int_stack+102835,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+187260,int_stack+0,int_stack+45540,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+17325,int_stack+187260,int_stack+60555,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+217290,int_stack+17325,int_stack+150960,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+150960,int_stack+115210,int_stack+108610,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+60225,int_stack+150960,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+271740,int_stack+60225,int_stack+187260,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+321790,int_stack+271740,int_stack+17325,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+386140,int_stack+321790,int_stack+217290,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+122690,int_stack+115210,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+170760,int_stack+0,int_stack+150960,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+210360,int_stack+170760,int_stack+60225,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+22440,int_stack+210360,int_stack+271740,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+462370,int_stack+22440,int_stack+321790,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+268110,int_stack+462370,int_stack+386140,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+369750,int_stack+131105,int_stack+122690,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+394995,int_stack+369750,int_stack+0,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1018362,int_stack+394995,int_stack+170760,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1084362,int_stack+1018362,int_stack+210360,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+150960,int_stack+1084362,int_stack+22440,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+150960,int_stack+462370,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1170987,int_stack+0,int_stack+268110,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+256065,int_stack+140510,int_stack+131105,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+284280,int_stack+256065,int_stack+369750,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+439875,int_stack+284280,int_stack+394995,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+256065,int_stack+439875,int_stack+1018362,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+355065,int_stack+256065,int_stack+1084362,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1018362,int_stack+355065,int_stack+150960,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+120120,int_stack+1018362,int_stack+0,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+274560,int_stack+120120,int_stack+1170987,55);
 /*--- compute (lp|nl) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1018362,int_stack+274560,int_stack+563952,2970);
 /*--- compute (kd|nl) ---*/
 hrr1_build_kd(Libint->AB,int_stack+0,int_stack+1018362,int_stack+697602,2970);
 return int_stack+0;}
