/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kflf(Libint_t*, prim_data*);

  /* Computes quartets of (kf|lf) integrals */

REALTYPE *hrr_order_kflf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[8][8] = int_stack + 8784;
 Libint->vrr_classes[8][9] = int_stack + 10809;
 Libint->vrr_classes[8][10] = int_stack + 13284;
 Libint->vrr_classes[8][11] = int_stack + 16254;
 Libint->vrr_classes[9][8] = int_stack + 19764;
 Libint->vrr_classes[9][9] = int_stack + 22239;
 Libint->vrr_classes[9][10] = int_stack + 25264;
 Libint->vrr_classes[9][11] = int_stack + 28894;
 Libint->vrr_classes[10][8] = int_stack + 33184;
 Libint->vrr_classes[10][9] = int_stack + 36154;
 Libint->vrr_classes[10][10] = int_stack + 39784;
 Libint->vrr_classes[10][11] = int_stack + 44140;
 memset(int_stack,0,49288*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 49288;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kflf(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+49288,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+54148,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+60088,int_stack+54148,int_stack+49288,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+69808,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+76936,int_stack+69808,int_stack+54148,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+88816,int_stack+76936,int_stack+60088,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+49288,int_stack+10809,int_stack+8784,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+55363,int_stack+13284,int_stack+10809,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+62788,int_stack+55363,int_stack+49288,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+74938,int_stack+16254,int_stack+13284,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+74938,int_stack+55363,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+105016,int_stack+0,int_stack+62788,45);
 /*--- compute (kp|lf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+125266,int_stack+105016,int_stack+88816,450);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+22239,int_stack+19764,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7425,int_stack+25264,int_stack+22239,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+49288,int_stack+7425,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+64138,int_stack+28894,int_stack+25264,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+75028,int_stack+64138,int_stack+7425,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+75028,int_stack+49288,55);
 /*--- compute (lp|lf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+173866,int_stack+0,int_stack+105016,450);
 /*--- compute (kd|lf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+234616,int_stack+173866,int_stack+125266,450);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+49288,int_stack+36154,int_stack+33184,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+58198,int_stack+39784,int_stack+36154,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+69088,int_stack+58198,int_stack+49288,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+86908,int_stack+44140,int_stack+39784,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+99976,int_stack+86908,int_stack+58198,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+121756,int_stack+99976,int_stack+69088,66);
 /*--- compute (mp|lf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+24750,int_stack+121756,int_stack+0,450);
 /*--- compute (ld|lf) ---*/
 hrr1_build_ld(Libint->AB,int_stack+331816,int_stack+24750,int_stack+173866,450);
 /*--- compute (kf|lf) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+331816,int_stack+234616,450);
 return int_stack+0;}
