/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kfll(Libint_t*, prim_data*);

  /* Computes quartets of (kf|ll) integrals */

REALTYPE *hrr_order_kfll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[7][13] = int_stack + 12060;
 Libint->vrr_classes[7][14] = int_stack + 15840;
 Libint->vrr_classes[7][15] = int_stack + 20160;
 Libint->vrr_classes[7][16] = int_stack + 25056;
 Libint->vrr_classes[8][8] = int_stack + 30564;
 Libint->vrr_classes[8][9] = int_stack + 32589;
 Libint->vrr_classes[8][10] = int_stack + 35064;
 Libint->vrr_classes[8][11] = int_stack + 38034;
 Libint->vrr_classes[8][12] = int_stack + 41544;
 Libint->vrr_classes[8][13] = int_stack + 45639;
 Libint->vrr_classes[8][14] = int_stack + 50364;
 Libint->vrr_classes[8][15] = int_stack + 55764;
 Libint->vrr_classes[8][16] = int_stack + 61884;
 Libint->vrr_classes[9][8] = int_stack + 68769;
 Libint->vrr_classes[9][9] = int_stack + 71244;
 Libint->vrr_classes[9][10] = int_stack + 74269;
 Libint->vrr_classes[9][11] = int_stack + 77899;
 Libint->vrr_classes[9][12] = int_stack + 82189;
 Libint->vrr_classes[9][13] = int_stack + 87194;
 Libint->vrr_classes[9][14] = int_stack + 92969;
 Libint->vrr_classes[9][15] = int_stack + 99569;
 Libint->vrr_classes[9][16] = int_stack + 107049;
 Libint->vrr_classes[10][8] = int_stack + 115464;
 Libint->vrr_classes[10][9] = int_stack + 118434;
 Libint->vrr_classes[10][10] = int_stack + 122064;
 Libint->vrr_classes[10][11] = int_stack + 126420;
 Libint->vrr_classes[10][12] = int_stack + 131568;
 Libint->vrr_classes[10][13] = int_stack + 137574;
 Libint->vrr_classes[10][14] = int_stack + 144504;
 Libint->vrr_classes[10][15] = int_stack + 152424;
 Libint->vrr_classes[10][16] = int_stack + 161400;
 memset(int_stack,0,171498*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 171498;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kfll(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+171498,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+176358,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+182298,int_stack+176358,int_stack+171498,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+192018,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+199146,int_stack+192018,int_stack+176358,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+211026,int_stack+199146,int_stack+182298,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+171498,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+227226,int_stack+171498,int_stack+192018,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+241482,int_stack+227226,int_stack+199146,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+179922,int_stack+241482,int_stack+211026,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+204222,int_stack+12060,int_stack+8784,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+261282,int_stack+204222,int_stack+171498,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+278130,int_stack+261282,int_stack+227226,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+301890,int_stack+278130,int_stack+241482,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+214050,int_stack+301890,int_stack+179922,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+171498,int_stack+15840,int_stack+12060,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+182838,int_stack+171498,int_stack+204222,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+331590,int_stack+182838,int_stack+261282,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+359670,int_stack+331590,int_stack+278130,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+248070,int_stack+359670,int_stack+301890,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+395310,int_stack+248070,int_stack+214050,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+202494,int_stack+20160,int_stack+15840,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+215454,int_stack+202494,int_stack+171498,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+289650,int_stack+215454,int_stack+182838,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+440670,int_stack+289650,int_stack+331590,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+482790,int_stack+440670,int_stack+359670,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+322410,int_stack+482790,int_stack+248070,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+532686,int_stack+322410,int_stack+395310,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+171498,int_stack+25056,int_stack+20160,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+238134,int_stack+171498,int_stack+202494,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+171498,int_stack+238134,int_stack+215454,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+209298,int_stack+171498,int_stack+289650,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+258438,int_stack+209298,int_stack+440670,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+171498,int_stack+258438,int_stack+482790,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+238026,int_stack+171498,int_stack+322410,36);
 /*--- compute (k0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+309306,int_stack+238026,int_stack+532686,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+171498,int_stack+32589,int_stack+30564,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+177573,int_stack+35064,int_stack+32589,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+184998,int_stack+177573,int_stack+171498,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+197148,int_stack+38034,int_stack+35064,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+206058,int_stack+197148,int_stack+177573,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+220908,int_stack+206058,int_stack+184998,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+171498,int_stack+41544,int_stack+38034,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+241158,int_stack+171498,int_stack+197148,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+258978,int_stack+241158,int_stack+206058,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+182028,int_stack+258978,int_stack+220908,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+212403,int_stack+45639,int_stack+41544,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+283728,int_stack+212403,int_stack+171498,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+382206,int_stack+283728,int_stack+241158,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+411906,int_stack+382206,int_stack+258978,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+224688,int_stack+411906,int_stack+182028,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+171498,int_stack+50364,int_stack+45639,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+185673,int_stack+171498,int_stack+212403,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+449031,int_stack+185673,int_stack+283728,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+484131,int_stack+449031,int_stack+382206,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+528681,int_stack+484131,int_stack+411906,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+382206,int_stack+528681,int_stack+224688,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+210243,int_stack+55764,int_stack+50364,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+226443,int_stack+210243,int_stack+171498,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+254793,int_stack+226443,int_stack+185673,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+254793,int_stack+449031,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+580656,int_stack+0,int_stack+484131,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+438906,int_stack+580656,int_stack+528681,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+643026,int_stack+438906,int_stack+382206,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+382206,int_stack+61884,int_stack+55764,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+400566,int_stack+382206,int_stack+210243,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+171498,int_stack+400566,int_stack+226443,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+508206,int_stack+171498,int_stack+254793,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+171498,int_stack+508206,int_stack+0,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+715926,int_stack+171498,int_stack+580656,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+171498,int_stack+715926,int_stack+438906,45);
 /*--- compute (l0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+382206,int_stack+171498,int_stack+643026,45);
 /*--- compute (kp|ll) ---*/
 hrr1_build_kp(Libint->AB,int_stack+473331,int_stack+382206,int_stack+309306,2025);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+171498,int_stack+71244,int_stack+68769,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+178923,int_stack+74269,int_stack+71244,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+187998,int_stack+178923,int_stack+171498,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+202848,int_stack+77899,int_stack+74269,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+213738,int_stack+202848,int_stack+178923,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+231888,int_stack+213738,int_stack+187998,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+171498,int_stack+82189,int_stack+77899,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+256638,int_stack+171498,int_stack+202848,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+278418,int_stack+256638,int_stack+213738,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+184368,int_stack+278418,int_stack+231888,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+221493,int_stack+87194,int_stack+82189,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+308668,int_stack+221493,int_stack+171498,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+334408,int_stack+308668,int_stack+256638,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+334408,int_stack+278418,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+236508,int_stack+0,int_stack+184368,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+171498,int_stack+92969,int_stack+87194,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+188823,int_stack+171498,int_stack+221493,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+45375,int_stack+188823,int_stack+308668,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+692031,int_stack+45375,int_stack+334408,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+288483,int_stack+692031,int_stack+0,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+746481,int_stack+288483,int_stack+236508,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+99569,int_stack+92969,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+218853,int_stack+0,int_stack+171498,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+815781,int_stack+218853,int_stack+188823,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+865831,int_stack+815781,int_stack+45375,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+19800,int_stack+865831,int_stack+692031,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+930181,int_stack+19800,int_stack+288483,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+253503,int_stack+930181,int_stack+746481,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+692031,int_stack+107049,int_stack+99569,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+714471,int_stack+692031,int_stack+0,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+754071,int_stack+714471,int_stack+218853,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+171498,int_stack+754071,int_stack+815781,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+692031,int_stack+171498,int_stack+865831,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+782121,int_stack+692031,int_stack+19800,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+782121,int_stack+930181,55);
 /*--- compute (m0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+692031,int_stack+0,int_stack+253503,55);
 /*--- compute (lp|ll) ---*/
 hrr1_build_lp(Libint->AB,int_stack+803406,int_stack+692031,int_stack+382206,2025);
 /*--- compute (kd|ll) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1076781,int_stack+803406,int_stack+473331,2025);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+118434,int_stack+115464,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8910,int_stack+122064,int_stack+118434,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19800,int_stack+8910,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37620,int_stack+126420,int_stack+122064,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+50688,int_stack+37620,int_stack+8910,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+72468,int_stack+50688,int_stack+19800,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+131568,int_stack+126420,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+102168,int_stack+0,int_stack+37620,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+171498,int_stack+102168,int_stack+50688,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+15444,int_stack+171498,int_stack+72468,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+59994,int_stack+137574,int_stack+131568,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+207798,int_stack+59994,int_stack+0,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+238686,int_stack+207798,int_stack+102168,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+78012,int_stack+238686,int_stack+171498,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+282246,int_stack+78012,int_stack+15444,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+171498,int_stack+144504,int_stack+137574,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+171498,int_stack+59994,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+344616,int_stack+0,int_stack+207798,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+396096,int_stack+344616,int_stack+238686,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+192288,int_stack+396096,int_stack+78012,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+36036,int_stack+192288,int_stack+282246,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+268518,int_stack+152424,int_stack+144504,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+292278,int_stack+268518,int_stack+171498,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+461436,int_stack+292278,int_stack+0,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+521496,int_stack+461436,int_stack+344616,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+598716,int_stack+521496,int_stack+396096,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+333858,int_stack+598716,int_stack+192288,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1514181,int_stack+333858,int_stack+36036,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+161400,int_stack+152424,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+26928,int_stack+0,int_stack+268518,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+74448,int_stack+26928,int_stack+292278,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+143748,int_stack+74448,int_stack+461436,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+143748,int_stack+521496,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+108108,int_stack+0,int_stack+598716,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+435498,int_stack+108108,int_stack+333858,66);
 /*--- compute (n0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+435498,int_stack+1514181,66);
 /*--- compute (mp|ll) ---*/
 hrr1_build_mp(Libint->AB,int_stack+133650,int_stack+0,int_stack+692031,2025);
 /*--- compute (ld|ll) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1514181,int_stack+133650,int_stack+803406,2025);
 /*--- compute (kf|ll) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+1514181,int_stack+1076781,2025);
 return int_stack+0;}
