/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kfmd(Libint_t*, prim_data*);

  /* Computes quartets of (kf|md) integrals */

REALTYPE *hrr_order_kfmd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[8][9] = int_stack + 7164;
 Libint->vrr_classes[8][10] = int_stack + 9639;
 Libint->vrr_classes[8][11] = int_stack + 12609;
 Libint->vrr_classes[9][9] = int_stack + 16119;
 Libint->vrr_classes[9][10] = int_stack + 19144;
 Libint->vrr_classes[9][11] = int_stack + 22774;
 Libint->vrr_classes[10][9] = int_stack + 27064;
 Libint->vrr_classes[10][10] = int_stack + 30694;
 Libint->vrr_classes[10][11] = int_stack + 35050;
 memset(int_stack,0,40198*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 40198;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kfmd(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40198,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+46138,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+53266,int_stack+46138,int_stack+40198,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40198,int_stack+9639,int_stack+7164,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+12609,int_stack+9639,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+65146,int_stack+0,int_stack+40198,45);
 /*--- compute (kp|md) ---*/
 hrr1_build_kp(Libint->AB,int_stack+79996,int_stack+65146,int_stack+53266,330);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40198,int_stack+19144,int_stack+16119,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+49273,int_stack+22774,int_stack+19144,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+49273,int_stack+40198,55);
 /*--- compute (lp|md) ---*/
 hrr1_build_lp(Libint->AB,int_stack+115636,int_stack+0,int_stack+65146,330);
 /*--- compute (kd|md) ---*/
 hrr1_build_kd(Libint->AB,int_stack+160186,int_stack+115636,int_stack+79996,330);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40198,int_stack+30694,int_stack+27064,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51088,int_stack+35050,int_stack+30694,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+64156,int_stack+51088,int_stack+40198,66);
 /*--- compute (mp|md) ---*/
 hrr1_build_mp(Libint->AB,int_stack+231466,int_stack+64156,int_stack+0,330);
 /*--- compute (ld|md) ---*/
 hrr1_build_ld(Libint->AB,int_stack+0,int_stack+231466,int_stack+115636,330);
 /*--- compute (kf|md) ---*/
 hrr1_build_kf(Libint->AB,int_stack+231466,int_stack+0,int_stack+160186,330);
 return int_stack+231466;}
