/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kfnk(Libint_t*, prim_data*);

  /* Computes quartets of (kf|nk) integrals */

REALTYPE *hrr_order_kfnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[7][17] = int_stack + 26964;
 Libint->vrr_classes[8][10] = int_stack + 33120;
 Libint->vrr_classes[8][11] = int_stack + 36090;
 Libint->vrr_classes[8][12] = int_stack + 39600;
 Libint->vrr_classes[8][13] = int_stack + 43695;
 Libint->vrr_classes[8][14] = int_stack + 48420;
 Libint->vrr_classes[8][15] = int_stack + 53820;
 Libint->vrr_classes[8][16] = int_stack + 59940;
 Libint->vrr_classes[8][17] = int_stack + 66825;
 Libint->vrr_classes[9][10] = int_stack + 74520;
 Libint->vrr_classes[9][11] = int_stack + 78150;
 Libint->vrr_classes[9][12] = int_stack + 82440;
 Libint->vrr_classes[9][13] = int_stack + 87445;
 Libint->vrr_classes[9][14] = int_stack + 93220;
 Libint->vrr_classes[9][15] = int_stack + 99820;
 Libint->vrr_classes[9][16] = int_stack + 107300;
 Libint->vrr_classes[9][17] = int_stack + 115715;
 Libint->vrr_classes[10][10] = int_stack + 125120;
 Libint->vrr_classes[10][11] = int_stack + 129476;
 Libint->vrr_classes[10][12] = int_stack + 134624;
 Libint->vrr_classes[10][13] = int_stack + 140630;
 Libint->vrr_classes[10][14] = int_stack + 147560;
 Libint->vrr_classes[10][15] = int_stack + 155480;
 Libint->vrr_classes[10][16] = int_stack + 164456;
 Libint->vrr_classes[10][17] = int_stack + 174554;
 memset(int_stack,0,185840*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 185840;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kfnk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+185840,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+192968,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+201392,int_stack+192968,int_stack+185840,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+215648,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+225476,int_stack+215648,int_stack+192968,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+242324,int_stack+225476,int_stack+201392,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+185840,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+266084,int_stack+185840,int_stack+215648,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+197180,int_stack+266084,int_stack+225476,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+285740,int_stack+197180,int_stack+242324,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+225260,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+238220,int_stack+225260,int_stack+185840,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+321380,int_stack+238220,int_stack+266084,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+354140,int_stack+321380,int_stack+197180,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+396260,int_stack+354140,int_stack+285740,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+185840,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+260900,int_stack+185840,int_stack+225260,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+446156,int_stack+260900,int_stack+238220,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+200528,int_stack+446156,int_stack+321380,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+286820,int_stack+200528,int_stack+354140,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+483956,int_stack+286820,int_stack+396260,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+345788,int_stack+26964,int_stack+21456,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+362312,int_stack+345788,int_stack+185840,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+391688,int_stack+362312,int_stack+260900,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+550484,int_stack+391688,int_stack+446156,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+345788,int_stack+550484,int_stack+200528,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+185840,int_stack+345788,int_stack+286820,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+264464,int_stack+185840,int_stack+483956,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+185840,int_stack+36090,int_stack+33120,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+194750,int_stack+39600,int_stack+36090,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+205280,int_stack+194750,int_stack+185840,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+223100,int_stack+43695,int_stack+39600,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+235385,int_stack+223100,int_stack+194750,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+350000,int_stack+235385,int_stack+205280,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+185840,int_stack+48420,int_stack+43695,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+379700,int_stack+185840,int_stack+223100,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+200015,int_stack+379700,int_stack+235385,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+404270,int_stack+200015,int_stack+350000,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+350000,int_stack+53820,int_stack+48420,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+235115,int_stack+350000,int_stack+185840,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+448820,int_stack+235115,int_stack+379700,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+489770,int_stack+448820,int_stack+200015,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+542420,int_stack+489770,int_stack+404270,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+185840,int_stack+59940,int_stack+53820,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+366200,int_stack+185840,int_stack+350000,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+398600,int_stack+366200,int_stack+235115,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+604790,int_stack+398600,int_stack+448820,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+666215,int_stack+604790,int_stack+489770,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+445850,int_stack+666215,int_stack+542420,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+204200,int_stack+66825,int_stack+59940,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+224855,int_stack+204200,int_stack+185840,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+529010,int_stack+224855,int_stack+366200,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+185840,int_stack+529010,int_stack+398600,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+350000,int_stack+185840,int_stack+604790,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+529010,int_stack+350000,int_stack+666215,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+627290,int_stack+529010,int_stack+445850,45);
 /*--- compute (kp|nk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+350000,int_stack+627290,int_stack+264464,2376);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+606608,int_stack+78150,int_stack+74520,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+185840,int_stack+82440,int_stack+78150,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+198710,int_stack+185840,int_stack+606608,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+606608,int_stack+87445,int_stack+82440,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+220490,int_stack+606608,int_stack+185840,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+246230,int_stack+220490,int_stack+198710,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+185840,int_stack+93220,int_stack+87445,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+282530,int_stack+185840,int_stack+606608,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+282530,int_stack+220490,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+734210,int_stack+0,int_stack+246230,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+606608,int_stack+99820,int_stack+93220,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+203165,int_stack+606608,int_stack+185840,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+42900,int_stack+203165,int_stack+282530,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+237815,int_stack+42900,int_stack+0,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+788660,int_stack+237815,int_stack+734210,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+734210,int_stack+107300,int_stack+99820,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+734210,int_stack+606608,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+864890,int_stack+0,int_stack+203165,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+922640,int_stack+864890,int_stack+42900,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+997715,int_stack+922640,int_stack+237815,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+185840,int_stack+997715,int_stack+788660,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+756650,int_stack+115715,int_stack+107300,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+781895,int_stack+756650,int_stack+734210,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+39600,int_stack+781895,int_stack+0,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+734210,int_stack+39600,int_stack+864890,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+734210,int_stack+922640,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+734210,int_stack+0,int_stack+997715,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+854330,int_stack+734210,int_stack+185840,55);
 /*--- compute (lp|nk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+985010,int_stack+854330,int_stack+627290,2376);
 /*--- compute (kd|nk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1305770,int_stack+985010,int_stack+350000,2376);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+185840,int_stack+129476,int_stack+125120,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+198908,int_stack+134624,int_stack+129476,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+214352,int_stack+198908,int_stack+185840,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+240488,int_stack+140630,int_stack+134624,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+258506,int_stack+240488,int_stack+198908,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+289394,int_stack+258506,int_stack+214352,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+185840,int_stack+147560,int_stack+140630,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+332954,int_stack+185840,int_stack+240488,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+206630,int_stack+332954,int_stack+258506,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+368990,int_stack+206630,int_stack+289394,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+258110,int_stack+155480,int_stack+147560,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+281870,int_stack+258110,int_stack+185840,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+434330,int_stack+281870,int_stack+332954,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+494390,int_stack+434330,int_stack+206630,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+571610,int_stack+494390,int_stack+368990,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+185840,int_stack+164456,int_stack+155480,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+323450,int_stack+185840,int_stack+258110,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+663086,int_stack+323450,int_stack+281870,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+212768,int_stack+663086,int_stack+434330,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+370970,int_stack+212768,int_stack+494390,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+370970,int_stack+571610,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+479078,int_stack+174554,int_stack+164456,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+509372,int_stack+479078,int_stack+185840,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+563228,int_stack+509372,int_stack+323450,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+732386,int_stack+563228,int_stack+663086,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+479078,int_stack+732386,int_stack+212768,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+605204,int_stack+479078,int_stack+370970,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+121968,int_stack+605204,int_stack+0,66);
 /*--- compute (mp|nk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+278784,int_stack+121968,int_stack+854330,2376);
 /*--- compute (ld|nk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1818986,int_stack+278784,int_stack+985010,2376);
 /*--- compute (kf|nk) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+1818986,int_stack+1305770,2376);
 return int_stack+0;}
