/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kfnn(Libint_t*, prim_data*);

  /* Computes quartets of (kf|nn) integrals */

REALTYPE *hrr_order_kfnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[7][17] = int_stack + 26964;
 Libint->vrr_classes[7][18] = int_stack + 33120;
 Libint->vrr_classes[7][19] = int_stack + 39960;
 Libint->vrr_classes[7][20] = int_stack + 47520;
 Libint->vrr_classes[8][10] = int_stack + 55836;
 Libint->vrr_classes[8][11] = int_stack + 58806;
 Libint->vrr_classes[8][12] = int_stack + 62316;
 Libint->vrr_classes[8][13] = int_stack + 66411;
 Libint->vrr_classes[8][14] = int_stack + 71136;
 Libint->vrr_classes[8][15] = int_stack + 76536;
 Libint->vrr_classes[8][16] = int_stack + 82656;
 Libint->vrr_classes[8][17] = int_stack + 89541;
 Libint->vrr_classes[8][18] = int_stack + 97236;
 Libint->vrr_classes[8][19] = int_stack + 105786;
 Libint->vrr_classes[8][20] = int_stack + 115236;
 Libint->vrr_classes[9][10] = int_stack + 125631;
 Libint->vrr_classes[9][11] = int_stack + 129261;
 Libint->vrr_classes[9][12] = int_stack + 133551;
 Libint->vrr_classes[9][13] = int_stack + 138556;
 Libint->vrr_classes[9][14] = int_stack + 144331;
 Libint->vrr_classes[9][15] = int_stack + 150931;
 Libint->vrr_classes[9][16] = int_stack + 158411;
 Libint->vrr_classes[9][17] = int_stack + 166826;
 Libint->vrr_classes[9][18] = int_stack + 176231;
 Libint->vrr_classes[9][19] = int_stack + 186681;
 Libint->vrr_classes[9][20] = int_stack + 198231;
 Libint->vrr_classes[10][10] = int_stack + 210936;
 Libint->vrr_classes[10][11] = int_stack + 215292;
 Libint->vrr_classes[10][12] = int_stack + 220440;
 Libint->vrr_classes[10][13] = int_stack + 226446;
 Libint->vrr_classes[10][14] = int_stack + 233376;
 Libint->vrr_classes[10][15] = int_stack + 241296;
 Libint->vrr_classes[10][16] = int_stack + 250272;
 Libint->vrr_classes[10][17] = int_stack + 260370;
 Libint->vrr_classes[10][18] = int_stack + 271656;
 Libint->vrr_classes[10][19] = int_stack + 284196;
 Libint->vrr_classes[10][20] = int_stack + 298056;
 memset(int_stack,0,313302*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 313302;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kfnn(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+313302,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+320430,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+328854,int_stack+320430,int_stack+313302,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+343110,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+352938,int_stack+343110,int_stack+320430,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+369786,int_stack+352938,int_stack+328854,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+313302,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+393546,int_stack+313302,int_stack+343110,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+324642,int_stack+393546,int_stack+352938,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+413202,int_stack+324642,int_stack+369786,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+352722,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+365682,int_stack+352722,int_stack+313302,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+448842,int_stack+365682,int_stack+393546,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+481602,int_stack+448842,int_stack+324642,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+523722,int_stack+481602,int_stack+413202,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+313302,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+388362,int_stack+313302,int_stack+352722,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+573618,int_stack+388362,int_stack+365682,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+327990,int_stack+573618,int_stack+448842,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+414282,int_stack+327990,int_stack+481602,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+611418,int_stack+414282,int_stack+523722,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+473250,int_stack+26964,int_stack+21456,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+489774,int_stack+473250,int_stack+313302,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+519150,int_stack+489774,int_stack+388362,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+677946,int_stack+519150,int_stack+573618,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+734646,int_stack+677946,int_stack+327990,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+313302,int_stack+734646,int_stack+414282,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+803442,int_stack+313302,int_stack+611418,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+391926,int_stack+33120,int_stack+26964,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+410394,int_stack+391926,int_stack+473250,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+562350,int_stack+410394,int_stack+489774,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+443442,int_stack+562350,int_stack+519150,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+888978,int_stack+443442,int_stack+677946,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+611310,int_stack+888978,int_stack+734646,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+968358,int_stack+611310,int_stack+313302,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1069446,int_stack+968358,int_stack+803442,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+313302,int_stack+39960,int_stack+33120,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+333822,int_stack+313302,int_stack+391926,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+703038,int_stack+333822,int_stack+410394,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+758118,int_stack+703038,int_stack+562350,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+508242,int_stack+758118,int_stack+443442,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+370758,int_stack+508242,int_stack+888978,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+831558,int_stack+370758,int_stack+611310,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1176366,int_stack+831558,int_stack+968358,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1302726,int_stack+1176366,int_stack+1069446,36);
 /*--- compute (k0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+476598,int_stack+47520,int_stack+39960,36);
 /*--- compute (k0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+598962,int_stack+476598,int_stack+313302,36);
 /*--- compute (k0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+640002,int_stack+598962,int_stack+333822,36);
 /*--- compute (k0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+949494,int_stack+640002,int_stack+703038,36);
 /*--- compute (k0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+598962,int_stack+949494,int_stack+758118,36);
 /*--- compute (k0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+949494,int_stack+598962,int_stack+508242,36);
 /*--- compute (k0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+476598,int_stack+949494,int_stack+370758,36);
 /*--- compute (k0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+949494,int_stack+476598,int_stack+831558,36);
 /*--- compute (k0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+313302,int_stack+949494,int_stack+1176366,36);
 /*--- compute (k0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+467742,int_stack+313302,int_stack+1302726,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+313302,int_stack+58806,int_stack+55836,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+322212,int_stack+62316,int_stack+58806,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+332742,int_stack+322212,int_stack+313302,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+350562,int_stack+66411,int_stack+62316,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+362847,int_stack+350562,int_stack+322212,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+383907,int_stack+362847,int_stack+332742,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+313302,int_stack+71136,int_stack+66411,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+413607,int_stack+313302,int_stack+350562,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+327477,int_stack+413607,int_stack+362847,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+624558,int_stack+327477,int_stack+383907,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+362577,int_stack+76536,int_stack+71136,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+378777,int_stack+362577,int_stack+313302,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+669108,int_stack+378777,int_stack+413607,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+407127,int_stack+669108,int_stack+327477,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+710058,int_stack+407127,int_stack+624558,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+624558,int_stack+82656,int_stack+76536,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+313302,int_stack+624558,int_stack+362577,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+772428,int_stack+313302,int_stack+378777,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+345702,int_stack+772428,int_stack+669108,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+819678,int_stack+345702,int_stack+407127,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+893388,int_stack+819678,int_stack+710058,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+407127,int_stack+89541,int_stack+82656,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+427782,int_stack+407127,int_stack+624558,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+624558,int_stack+427782,int_stack+313302,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+678558,int_stack+624558,int_stack+772428,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+976548,int_stack+678558,int_stack+345702,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1062543,int_stack+976548,int_stack+819678,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+749433,int_stack+1062543,int_stack+893388,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+313302,int_stack+97236,int_stack+89541,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+336387,int_stack+313302,int_stack+407127,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+856353,int_stack+336387,int_stack+427782,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+377697,int_stack+856353,int_stack+624558,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1160823,int_stack+377697,int_stack+678558,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+624558,int_stack+1160823,int_stack+976548,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+917553,int_stack+624558,int_stack+1062543,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1260048,int_stack+917553,int_stack+749433,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+739218,int_stack+105786,int_stack+97236,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+764868,int_stack+739218,int_stack+313302,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1043913,int_stack+764868,int_stack+336387,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+1043913,int_stack+856353,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1393698,int_stack+0,int_stack+377697,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+313302,int_stack+1393698,int_stack+1160823,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1507098,int_stack+313302,int_stack+624558,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1654518,int_stack+1507098,int_stack+917553,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+811038,int_stack+1654518,int_stack+1260048,45);
 /*--- compute (l0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+624558,int_stack+115236,int_stack+105786,45);
 /*--- compute (l0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+652908,int_stack+624558,int_stack+739218,45);
 /*--- compute (l0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1112763,int_stack+652908,int_stack+764868,45);
 /*--- compute (l0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+624558,int_stack+1112763,int_stack+1043913,45);
 /*--- compute (l0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+974388,int_stack+624558,int_stack+0,45);
 /*--- compute (l0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+624558,int_stack+974388,int_stack+1393698,45);
 /*--- compute (l0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+974388,int_stack+624558,int_stack+313302,45);
 /*--- compute (l0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+624558,int_stack+974388,int_stack+1507098,45);
 /*--- compute (l0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+974388,int_stack+624558,int_stack+1654518,45);
 /*--- compute (l0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1167438,int_stack+974388,int_stack+811038,45);
 /*--- compute (kp|nn) ---*/
 hrr1_build_kp(Libint->AB,int_stack+624558,int_stack+1167438,int_stack+467742,4356);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1095006,int_stack+129261,int_stack+125631,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1105896,int_stack+133551,int_stack+129261,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1118766,int_stack+1105896,int_stack+1095006,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1140546,int_stack+138556,int_stack+133551,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1363458,int_stack+1140546,int_stack+1105896,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1389198,int_stack+1363458,int_stack+1118766,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1095006,int_stack+144331,int_stack+138556,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1425498,int_stack+1095006,int_stack+1140546,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1112331,int_stack+1425498,int_stack+1363458,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1455528,int_stack+1112331,int_stack+1389198,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1363458,int_stack+150931,int_stack+144331,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1383258,int_stack+1363458,int_stack+1095006,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1509978,int_stack+1383258,int_stack+1425498,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1560028,int_stack+1509978,int_stack+1112331,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1624378,int_stack+1560028,int_stack+1455528,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1095006,int_stack+158411,int_stack+150931,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1117446,int_stack+1095006,int_stack+1363458,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1417908,int_stack+1117446,int_stack+1383258,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1700608,int_stack+1417908,int_stack+1509978,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+313302,int_stack+1700608,int_stack+1560028,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1475658,int_stack+313302,int_stack+1624378,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1363458,int_stack+166826,int_stack+158411,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1577298,int_stack+1363458,int_stack+1095006,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1622178,int_stack+1577298,int_stack+1117446,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+403392,int_stack+1622178,int_stack+1417908,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+490017,int_stack+403392,int_stack+1700608,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1688178,int_stack+490017,int_stack+313302,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1688178,int_stack+1475658,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+313302,int_stack+176231,int_stack+166826,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+341517,int_stack+313302,int_stack+1363458,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1363458,int_stack+341517,int_stack+1577298,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1438258,int_stack+1363458,int_stack+1622178,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1537258,int_stack+1438258,int_stack+403392,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1808298,int_stack+1537258,int_stack+490017,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+392007,int_stack+1808298,int_stack+1688178,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1948438,int_stack+392007,int_stack+0,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+186681,int_stack+176231,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+31350,int_stack+0,int_stack+313302,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+87780,int_stack+31350,int_stack+341517,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1658533,int_stack+87780,int_stack+1363458,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2111788,int_stack+1658533,int_stack+1438258,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1363458,int_stack+2111788,int_stack+1537258,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2250388,int_stack+1363458,int_stack+1808298,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2430568,int_stack+2250388,int_stack+392007,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+313302,int_stack+2430568,int_stack+1948438,55);
 /*--- compute (m0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1525158,int_stack+198231,int_stack+186681,55);
 /*--- compute (m0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1559808,int_stack+1525158,int_stack+0,55);
 /*--- compute (m0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+512952,int_stack+1559808,int_stack+31350,55);
 /*--- compute (m0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1525158,int_stack+512952,int_stack+87780,55);
 /*--- compute (m0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+1525158,int_stack+1658533,55);
 /*--- compute (m0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1525158,int_stack+0,int_stack+2111788,55);
 /*--- compute (m0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+1525158,int_stack+1363458,55);
 /*--- compute (m0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1363458,int_stack+0,int_stack+2250388,55);
 /*--- compute (m0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1588683,int_stack+1363458,int_stack+2430568,55);
 /*--- compute (m0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1824633,int_stack+1588683,int_stack+313302,55);
 /*--- compute (lp|nn) ---*/
 hrr1_build_lp(Libint->AB,int_stack+2064213,int_stack+1824633,int_stack+1167438,4356);
 /*--- compute (kd|nn) ---*/
 hrr1_build_kd(Libint->AB,int_stack+2652273,int_stack+2064213,int_stack+624558,4356);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+313302,int_stack+215292,int_stack+210936,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+326370,int_stack+220440,int_stack+215292,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+341814,int_stack+326370,int_stack+313302,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+367950,int_stack+226446,int_stack+220440,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+385968,int_stack+367950,int_stack+326370,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+416856,int_stack+385968,int_stack+341814,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+313302,int_stack+233376,int_stack+226446,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+460416,int_stack+313302,int_stack+367950,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+334092,int_stack+460416,int_stack+385968,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+496452,int_stack+334092,int_stack+416856,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+385572,int_stack+241296,int_stack+233376,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+409332,int_stack+385572,int_stack+313302,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+561792,int_stack+409332,int_stack+460416,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+621852,int_stack+561792,int_stack+334092,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+699072,int_stack+621852,int_stack+496452,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+313302,int_stack+250272,int_stack+241296,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+450912,int_stack+313302,int_stack+385572,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+790548,int_stack+450912,int_stack+409332,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+340230,int_stack+790548,int_stack+561792,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+498432,int_stack+340230,int_stack+621852,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+859848,int_stack+498432,int_stack+699072,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+606540,int_stack+260370,int_stack+250272,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+636834,int_stack+606540,int_stack+313302,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+690690,int_stack+636834,int_stack+450912,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+981816,int_stack+690690,int_stack+790548,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1085766,int_stack+981816,int_stack+340230,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+313302,int_stack+1085766,int_stack+498432,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1211892,int_stack+313302,int_stack+859848,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+457446,int_stack+271656,int_stack+260370,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+491304,int_stack+457446,int_stack+606540,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+769890,int_stack+491304,int_stack+636834,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+551892,int_stack+769890,int_stack+690690,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1368708,int_stack+551892,int_stack+981816,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+859650,int_stack+1368708,int_stack+1085766,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1514238,int_stack+859650,int_stack+313302,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1514238,int_stack+1211892,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+313302,int_stack+284196,int_stack+271656,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+350922,int_stack+313302,int_stack+457446,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1027818,int_stack+350922,int_stack+491304,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1128798,int_stack+1027818,int_stack+769890,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+670692,int_stack+1128798,int_stack+551892,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+418638,int_stack+670692,int_stack+1368708,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1263438,int_stack+418638,int_stack+859650,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3593169,int_stack+1263438,int_stack+1514238,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1479654,int_stack+3593169,int_stack+0,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+298056,int_stack+284196,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+41580,int_stack+0,int_stack+313302,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+116820,int_stack+41580,int_stack+350922,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+229680,int_stack+116820,int_stack+1027818,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+229680,int_stack+1128798,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+188496,int_stack+0,int_stack+670692,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+612678,int_stack+188496,int_stack+418638,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+0,int_stack+612678,int_stack+1263438,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+270270,int_stack+0,int_stack+3593169,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+553410,int_stack+270270,int_stack+1479654,66);
 /*--- compute (mp|nn) ---*/
 hrr1_build_mp(Libint->AB,int_stack+840906,int_stack+553410,int_stack+1824633,4356);
 /*--- compute (ld|nn) ---*/
 hrr1_build_ld(Libint->AB,int_stack+3593169,int_stack+840906,int_stack+2064213,4356);
 /*--- compute (kf|nn) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+3593169,int_stack+2652273,4356);
 return int_stack+0;}
