/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kgkg(Libint_t*, prim_data*);

  /* Computes quartets of (kg|kg) integrals */

REALTYPE *hrr_order_kgkg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][7] = int_stack + 0;
 Libint->vrr_classes[7][8] = int_stack + 1296;
 Libint->vrr_classes[7][9] = int_stack + 2916;
 Libint->vrr_classes[7][10] = int_stack + 4896;
 Libint->vrr_classes[7][11] = int_stack + 7272;
 Libint->vrr_classes[8][7] = int_stack + 10080;
 Libint->vrr_classes[8][8] = int_stack + 11700;
 Libint->vrr_classes[8][9] = int_stack + 13725;
 Libint->vrr_classes[8][10] = int_stack + 16200;
 Libint->vrr_classes[8][11] = int_stack + 19170;
 Libint->vrr_classes[9][7] = int_stack + 22680;
 Libint->vrr_classes[9][8] = int_stack + 24660;
 Libint->vrr_classes[9][9] = int_stack + 27135;
 Libint->vrr_classes[9][10] = int_stack + 30160;
 Libint->vrr_classes[9][11] = int_stack + 33790;
 Libint->vrr_classes[10][7] = int_stack + 38080;
 Libint->vrr_classes[10][8] = int_stack + 40456;
 Libint->vrr_classes[10][9] = int_stack + 43426;
 Libint->vrr_classes[10][10] = int_stack + 47056;
 Libint->vrr_classes[10][11] = int_stack + 51412;
 Libint->vrr_classes[11][7] = int_stack + 56560;
 Libint->vrr_classes[11][8] = int_stack + 59368;
 Libint->vrr_classes[11][9] = int_stack + 62878;
 Libint->vrr_classes[11][10] = int_stack + 67168;
 Libint->vrr_classes[11][11] = int_stack + 72316;
 memset(int_stack,0,78400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 78400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kgkg(Libint, Data);
   Data++;
 }
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+78400,int_stack+1296,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+82288,int_stack+2916,int_stack+1296,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+87148,int_stack+82288,int_stack+78400,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+94924,int_stack+4896,int_stack+2916,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+100864,int_stack+94924,int_stack+82288,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+110584,int_stack+100864,int_stack+87148,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+78400,int_stack+7272,int_stack+4896,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+123544,int_stack+78400,int_stack+94924,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+78400,int_stack+123544,int_stack+100864,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+123544,int_stack+78400,int_stack+110584,36);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+78400,int_stack+11700,int_stack+10080,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+83260,int_stack+13725,int_stack+11700,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+89335,int_stack+83260,int_stack+78400,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+99055,int_stack+16200,int_stack+13725,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+106480,int_stack+99055,int_stack+83260,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+106480,int_stack+89335,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+78400,int_stack+19170,int_stack+16200,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+142984,int_stack+78400,int_stack+99055,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+78400,int_stack+142984,int_stack+106480,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+98650,int_stack+78400,int_stack+0,45);
 /*--- compute (kp|kg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+142984,int_stack+98650,int_stack+123544,540);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+24660,int_stack+22680,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5940,int_stack+27135,int_stack+24660,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13365,int_stack+5940,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+78400,int_stack+30160,int_stack+27135,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+122950,int_stack+78400,int_stack+5940,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+201304,int_stack+122950,int_stack+13365,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+33790,int_stack+30160,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+10890,int_stack+0,int_stack+78400,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+221104,int_stack+10890,int_stack+122950,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+221104,int_stack+201304,55);
 /*--- compute (lp|kg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+201304,int_stack+0,int_stack+98650,540);
 /*--- compute (kd|kg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+274204,int_stack+201304,int_stack+142984,540);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+78400,int_stack+40456,int_stack+38080,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+85528,int_stack+43426,int_stack+40456,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+94438,int_stack+85528,int_stack+78400,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+108694,int_stack+47056,int_stack+43426,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+119584,int_stack+108694,int_stack+85528,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+137404,int_stack+119584,int_stack+94438,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+78400,int_stack+51412,int_stack+47056,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+161164,int_stack+78400,int_stack+108694,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+78400,int_stack+161164,int_stack+119584,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+161164,int_stack+78400,int_stack+137404,66);
 /*--- compute (mp|kg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+390844,int_stack+161164,int_stack+0,540);
 /*--- compute (ld|kg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+479944,int_stack+390844,int_stack+201304,540);
 /*--- compute (kf|kg) ---*/
 hrr1_build_kf(Libint->AB,int_stack+625744,int_stack+479944,int_stack+274204,540);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+59368,int_stack+56560,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8424,int_stack+62878,int_stack+59368,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+18954,int_stack+8424,int_stack+0,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+35802,int_stack+67168,int_stack+62878,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+78400,int_stack+35802,int_stack+8424,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+99460,int_stack+78400,int_stack+18954,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+72316,int_stack+67168,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+48672,int_stack+0,int_stack+35802,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+48672,int_stack+78400,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+35100,int_stack+0,int_stack+99460,78);
 /*--- compute (np|kg) ---*/
 hrr1_build_np(Libint->AB,int_stack+196804,int_stack+35100,int_stack+161164,540);
 /*--- compute (md|kg) ---*/
 hrr1_build_md(Libint->AB,int_stack+0,int_stack+196804,int_stack+390844,540);
 /*--- compute (lf|kg) ---*/
 hrr1_build_lf(Libint->AB,int_stack+178200,int_stack+0,int_stack+479944,540);
 /*--- compute (kg|kg) ---*/
 hrr1_build_kg(Libint->AB,int_stack+820144,int_stack+178200,int_stack+625744,540);
 return int_stack+820144;}
