/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kgni(Libint_t*, prim_data*);

  /* Computes quartets of (kg|ni) integrals */

REALTYPE *hrr_order_kgni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[8][10] = int_stack + 26964;
 Libint->vrr_classes[8][11] = int_stack + 29934;
 Libint->vrr_classes[8][12] = int_stack + 33444;
 Libint->vrr_classes[8][13] = int_stack + 37539;
 Libint->vrr_classes[8][14] = int_stack + 42264;
 Libint->vrr_classes[8][15] = int_stack + 47664;
 Libint->vrr_classes[8][16] = int_stack + 53784;
 Libint->vrr_classes[9][10] = int_stack + 60669;
 Libint->vrr_classes[9][11] = int_stack + 64299;
 Libint->vrr_classes[9][12] = int_stack + 68589;
 Libint->vrr_classes[9][13] = int_stack + 73594;
 Libint->vrr_classes[9][14] = int_stack + 79369;
 Libint->vrr_classes[9][15] = int_stack + 85969;
 Libint->vrr_classes[9][16] = int_stack + 93449;
 Libint->vrr_classes[10][10] = int_stack + 101864;
 Libint->vrr_classes[10][11] = int_stack + 106220;
 Libint->vrr_classes[10][12] = int_stack + 111368;
 Libint->vrr_classes[10][13] = int_stack + 117374;
 Libint->vrr_classes[10][14] = int_stack + 124304;
 Libint->vrr_classes[10][15] = int_stack + 132224;
 Libint->vrr_classes[10][16] = int_stack + 141200;
 Libint->vrr_classes[11][10] = int_stack + 151298;
 Libint->vrr_classes[11][11] = int_stack + 156446;
 Libint->vrr_classes[11][12] = int_stack + 162530;
 Libint->vrr_classes[11][13] = int_stack + 169628;
 Libint->vrr_classes[11][14] = int_stack + 177818;
 Libint->vrr_classes[11][15] = int_stack + 187178;
 Libint->vrr_classes[11][16] = int_stack + 197786;
 memset(int_stack,0,209720*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 209720;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kgni(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+209720,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+216848,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+225272,int_stack+216848,int_stack+209720,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+239528,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+249356,int_stack+239528,int_stack+216848,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+266204,int_stack+249356,int_stack+225272,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+209720,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+289964,int_stack+209720,int_stack+239528,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+221060,int_stack+289964,int_stack+249356,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+309620,int_stack+221060,int_stack+266204,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+249140,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+262100,int_stack+249140,int_stack+209720,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+345260,int_stack+262100,int_stack+289964,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+378020,int_stack+345260,int_stack+221060,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+420140,int_stack+378020,int_stack+309620,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+209720,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+284780,int_stack+209720,int_stack+249140,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+209720,int_stack+284780,int_stack+262100,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+247520,int_stack+209720,int_stack+345260,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+296660,int_stack+247520,int_stack+378020,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+209720,int_stack+296660,int_stack+420140,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+276248,int_stack+29934,int_stack+26964,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+285158,int_stack+33444,int_stack+29934,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+295688,int_stack+285158,int_stack+276248,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+313508,int_stack+37539,int_stack+33444,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+325793,int_stack+313508,int_stack+285158,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+346853,int_stack+325793,int_stack+295688,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+276248,int_stack+42264,int_stack+37539,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+376553,int_stack+276248,int_stack+313508,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+290423,int_stack+376553,int_stack+325793,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+401123,int_stack+290423,int_stack+346853,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+325523,int_stack+47664,int_stack+42264,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+341723,int_stack+325523,int_stack+276248,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+341723,int_stack+376553,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+445673,int_stack+0,int_stack+290423,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+498323,int_stack+445673,int_stack+401123,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+276248,int_stack+53784,int_stack+47664,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+370073,int_stack+276248,int_stack+325523,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+276248,int_stack+370073,int_stack+341723,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+323498,int_stack+276248,int_stack+0,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+560693,int_stack+323498,int_stack+445673,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+276248,int_stack+560693,int_stack+498323,45);
 /*--- compute (kp|ni) ---*/
 hrr1_build_kp(Libint->AB,int_stack+359408,int_stack+276248,int_stack+209720,1848);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+209720,int_stack+64299,int_stack+60669,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+220610,int_stack+68589,int_stack+64299,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+233480,int_stack+220610,int_stack+209720,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+255260,int_stack+73594,int_stack+68589,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+255260,int_stack+220610,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+25740,int_stack+0,int_stack+233480,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+209720,int_stack+79369,int_stack+73594,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+558992,int_stack+209720,int_stack+255260,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+227045,int_stack+558992,int_stack+0,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+589022,int_stack+227045,int_stack+25740,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+85969,int_stack+79369,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+19800,int_stack+0,int_stack+209720,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+643472,int_stack+19800,int_stack+558992,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+693522,int_stack+643472,int_stack+227045,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+757872,int_stack+693522,int_stack+589022,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+558992,int_stack+93449,int_stack+85969,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+581432,int_stack+558992,int_stack+0,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+209720,int_stack+581432,int_stack+19800,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+209720,int_stack+643472,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+558992,int_stack+0,int_stack+693522,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+558992,int_stack+757872,55);
 /*--- compute (lp|ni) ---*/
 hrr1_build_lp(Libint->AB,int_stack+558992,int_stack+0,int_stack+276248,1848);
 /*--- compute (kd|ni) ---*/
 hrr1_build_kd(Libint->AB,int_stack+808472,int_stack+558992,int_stack+359408,1848);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+209720,int_stack+106220,int_stack+101864,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+222788,int_stack+111368,int_stack+106220,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+238232,int_stack+222788,int_stack+209720,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+264368,int_stack+117374,int_stack+111368,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+282386,int_stack+264368,int_stack+222788,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+313274,int_stack+282386,int_stack+238232,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+209720,int_stack+124304,int_stack+117374,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+356834,int_stack+209720,int_stack+264368,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+230510,int_stack+356834,int_stack+282386,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+392870,int_stack+230510,int_stack+313274,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+281990,int_stack+132224,int_stack+124304,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+305750,int_stack+281990,int_stack+209720,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+458210,int_stack+305750,int_stack+356834,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1207640,int_stack+458210,int_stack+230510,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1284860,int_stack+1207640,int_stack+392870,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+209720,int_stack+141200,int_stack+132224,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+347330,int_stack+209720,int_stack+281990,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+209720,int_stack+347330,int_stack+305750,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+279020,int_stack+209720,int_stack+458210,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+369110,int_stack+279020,int_stack+1207640,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+209720,int_stack+369110,int_stack+1284860,66);
 /*--- compute (mp|ni) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1207640,int_stack+209720,int_stack+0,1848);
 /*--- compute (ld|ni) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1512560,int_stack+1207640,int_stack+558992,1848);
 /*--- compute (kf|ni) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2011520,int_stack+1512560,int_stack+808472,1848);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+156446,int_stack+151298,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+162530,int_stack+156446,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+169628,int_stack+162530,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+331688,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+177818,int_stack+169628,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+122382,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+122382,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+383168,int_stack+24570,int_stack+331688,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+331688,int_stack+187178,int_stack+177818,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+460388,int_stack+331688,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+509528,int_stack+460388,int_stack+122382,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+85410,int_stack+509528,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+580508,int_stack+85410,int_stack+383168,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+197786,int_stack+187178,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+359768,int_stack+0,int_stack+331688,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+359768,int_stack+460388,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+331688,int_stack+0,int_stack+509528,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+438158,int_stack+331688,int_stack+85410,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+438158,int_stack+580508,78);
 /*--- compute (np|ni) ---*/
 hrr1_build_np(Libint->AB,int_stack+331688,int_stack+0,int_stack+209720,1848);
 /*--- compute (md|ni) ---*/
 hrr1_build_md(Libint->AB,int_stack+2676800,int_stack+331688,int_stack+1207640,1848);
 /*--- compute (lf|ni) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+2676800,int_stack+1512560,1848);
 /*--- compute (kg|ni) ---*/
 hrr1_build_kg(Libint->AB,int_stack+831600,int_stack+0,int_stack+2011520,1848);
 return int_stack+831600;}
