/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kgnm(Libint_t*, prim_data*);

  /* Computes quartets of (kg|nm) integrals */

REALTYPE *hrr_order_kgnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[7][17] = int_stack + 26964;
 Libint->vrr_classes[7][18] = int_stack + 33120;
 Libint->vrr_classes[7][19] = int_stack + 39960;
 Libint->vrr_classes[8][10] = int_stack + 47520;
 Libint->vrr_classes[8][11] = int_stack + 50490;
 Libint->vrr_classes[8][12] = int_stack + 54000;
 Libint->vrr_classes[8][13] = int_stack + 58095;
 Libint->vrr_classes[8][14] = int_stack + 62820;
 Libint->vrr_classes[8][15] = int_stack + 68220;
 Libint->vrr_classes[8][16] = int_stack + 74340;
 Libint->vrr_classes[8][17] = int_stack + 81225;
 Libint->vrr_classes[8][18] = int_stack + 88920;
 Libint->vrr_classes[8][19] = int_stack + 97470;
 Libint->vrr_classes[9][10] = int_stack + 106920;
 Libint->vrr_classes[9][11] = int_stack + 110550;
 Libint->vrr_classes[9][12] = int_stack + 114840;
 Libint->vrr_classes[9][13] = int_stack + 119845;
 Libint->vrr_classes[9][14] = int_stack + 125620;
 Libint->vrr_classes[9][15] = int_stack + 132220;
 Libint->vrr_classes[9][16] = int_stack + 139700;
 Libint->vrr_classes[9][17] = int_stack + 148115;
 Libint->vrr_classes[9][18] = int_stack + 157520;
 Libint->vrr_classes[9][19] = int_stack + 167970;
 Libint->vrr_classes[10][10] = int_stack + 179520;
 Libint->vrr_classes[10][11] = int_stack + 183876;
 Libint->vrr_classes[10][12] = int_stack + 189024;
 Libint->vrr_classes[10][13] = int_stack + 195030;
 Libint->vrr_classes[10][14] = int_stack + 201960;
 Libint->vrr_classes[10][15] = int_stack + 209880;
 Libint->vrr_classes[10][16] = int_stack + 218856;
 Libint->vrr_classes[10][17] = int_stack + 228954;
 Libint->vrr_classes[10][18] = int_stack + 240240;
 Libint->vrr_classes[10][19] = int_stack + 252780;
 Libint->vrr_classes[11][10] = int_stack + 266640;
 Libint->vrr_classes[11][11] = int_stack + 271788;
 Libint->vrr_classes[11][12] = int_stack + 277872;
 Libint->vrr_classes[11][13] = int_stack + 284970;
 Libint->vrr_classes[11][14] = int_stack + 293160;
 Libint->vrr_classes[11][15] = int_stack + 302520;
 Libint->vrr_classes[11][16] = int_stack + 313128;
 Libint->vrr_classes[11][17] = int_stack + 325062;
 Libint->vrr_classes[11][18] = int_stack + 338400;
 Libint->vrr_classes[11][19] = int_stack + 353220;
 memset(int_stack,0,369600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 369600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kgnm(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+369600,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+376728,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+385152,int_stack+376728,int_stack+369600,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+399408,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+409236,int_stack+399408,int_stack+376728,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+426084,int_stack+409236,int_stack+385152,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+369600,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+449844,int_stack+369600,int_stack+399408,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+380940,int_stack+449844,int_stack+409236,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+469500,int_stack+380940,int_stack+426084,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+409020,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+421980,int_stack+409020,int_stack+369600,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+505140,int_stack+421980,int_stack+449844,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+537900,int_stack+505140,int_stack+380940,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+580020,int_stack+537900,int_stack+469500,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+369600,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+444660,int_stack+369600,int_stack+409020,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+629916,int_stack+444660,int_stack+421980,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+384288,int_stack+629916,int_stack+505140,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+470580,int_stack+384288,int_stack+537900,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+667716,int_stack+470580,int_stack+580020,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+529548,int_stack+26964,int_stack+21456,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+546072,int_stack+529548,int_stack+369600,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+575448,int_stack+546072,int_stack+444660,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+734244,int_stack+575448,int_stack+629916,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+790944,int_stack+734244,int_stack+384288,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+369600,int_stack+790944,int_stack+470580,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+859740,int_stack+369600,int_stack+667716,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+448224,int_stack+33120,int_stack+26964,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+466692,int_stack+448224,int_stack+529548,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+618648,int_stack+466692,int_stack+546072,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+499740,int_stack+618648,int_stack+575448,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+945276,int_stack+499740,int_stack+734244,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+667608,int_stack+945276,int_stack+790944,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1024656,int_stack+667608,int_stack+369600,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1125744,int_stack+1024656,int_stack+859740,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+369600,int_stack+39960,int_stack+33120,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+390120,int_stack+369600,int_stack+448224,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+759336,int_stack+390120,int_stack+466692,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+369600,int_stack+759336,int_stack+618648,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+759336,int_stack+369600,int_stack+499740,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+369600,int_stack+759336,int_stack+945276,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+759336,int_stack+369600,int_stack+667608,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+369600,int_stack+759336,int_stack+1024656,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+495960,int_stack+369600,int_stack+1125744,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+369600,int_stack+50490,int_stack+47520,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+378510,int_stack+54000,int_stack+50490,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+389040,int_stack+378510,int_stack+369600,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+406860,int_stack+58095,int_stack+54000,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+419145,int_stack+406860,int_stack+378510,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+440205,int_stack+419145,int_stack+389040,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+369600,int_stack+62820,int_stack+58095,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+469905,int_stack+369600,int_stack+406860,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+383775,int_stack+469905,int_stack+419145,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+626640,int_stack+383775,int_stack+440205,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+418875,int_stack+68220,int_stack+62820,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+435075,int_stack+418875,int_stack+369600,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+671190,int_stack+435075,int_stack+469905,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+712140,int_stack+671190,int_stack+383775,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+764790,int_stack+712140,int_stack+626640,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+626640,int_stack+74340,int_stack+68220,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+369600,int_stack+626640,int_stack+418875,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+827160,int_stack+369600,int_stack+435075,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+402000,int_stack+827160,int_stack+671190,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+874410,int_stack+402000,int_stack+712140,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+645000,int_stack+874410,int_stack+764790,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+728160,int_stack+81225,int_stack+74340,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+748815,int_stack+728160,int_stack+626640,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+948120,int_stack+748815,int_stack+369600,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1002120,int_stack+948120,int_stack+827160,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+785535,int_stack+1002120,int_stack+402000,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+369600,int_stack+785535,int_stack+874410,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1072995,int_stack+369600,int_stack+645000,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+467880,int_stack+88920,int_stack+81225,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+626640,int_stack+467880,int_stack+728160,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+667950,int_stack+626640,int_stack+748815,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+667950,int_stack+948120,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+871530,int_stack+0,int_stack+1002120,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1179915,int_stack+871530,int_stack+785535,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+729150,int_stack+1179915,int_stack+369600,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1294575,int_stack+729150,int_stack+1072995,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+369600,int_stack+97470,int_stack+88920,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+395250,int_stack+369600,int_stack+467880,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+970755,int_stack+395250,int_stack+626640,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+369600,int_stack+970755,int_stack+667950,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+970755,int_stack+369600,int_stack+0,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1428225,int_stack+970755,int_stack+871530,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+855510,int_stack+1428225,int_stack+1179915,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1002930,int_stack+855510,int_stack+729150,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+626640,int_stack+1002930,int_stack+1294575,45);
 /*--- compute (kp|nm) ---*/
 hrr1_build_kp(Libint->AB,int_stack+789990,int_stack+626640,int_stack+495960,3630);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+110550,int_stack+106920,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+114840,int_stack+110550,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23760,int_stack+10890,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+45540,int_stack+119845,int_stack+114840,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+60555,int_stack+45540,int_stack+10890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+369600,int_stack+60555,int_stack+23760,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+125620,int_stack+119845,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+86295,int_stack+0,int_stack+45540,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+17325,int_stack+86295,int_stack+60555,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+405900,int_stack+17325,int_stack+369600,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+369600,int_stack+132220,int_stack+125620,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+460350,int_stack+369600,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+495000,int_stack+460350,int_stack+86295,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+60225,int_stack+495000,int_stack+17325,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+545050,int_stack+60225,int_stack+405900,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+139700,int_stack+132220,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+389400,int_stack+0,int_stack+369600,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1182030,int_stack+389400,int_stack+460350,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1239780,int_stack+1182030,int_stack+495000,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+429000,int_stack+1239780,int_stack+60225,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+22440,int_stack+429000,int_stack+545050,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+519090,int_stack+148115,int_stack+139700,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+544335,int_stack+519090,int_stack+0,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1314855,int_stack+544335,int_stack+389400,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1380855,int_stack+1314855,int_stack+1182030,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1467480,int_stack+1380855,int_stack+1239780,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1182030,int_stack+1467480,int_stack+429000,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+369600,int_stack+1182030,int_stack+22440,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+157520,int_stack+148115,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+28215,int_stack+0,int_stack+519090,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+78705,int_stack+28215,int_stack+544335,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+500280,int_stack+78705,int_stack+1314855,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1572585,int_stack+500280,int_stack+1380855,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1302150,int_stack+1572585,int_stack+1467480,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1693860,int_stack+1302150,int_stack+1182030,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1848300,int_stack+1693860,int_stack+369600,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+369600,int_stack+167970,int_stack+157520,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+400950,int_stack+369600,int_stack+0,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1182030,int_stack+400950,int_stack+28215,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+369600,int_stack+1182030,int_stack+78705,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+369600,int_stack+500280,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+369600,int_stack+0,int_stack+1572585,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1442290,int_stack+369600,int_stack+1302150,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+369600,int_stack+1442290,int_stack+1693860,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1182030,int_stack+369600,int_stack+1848300,55);
 /*--- compute (lp|nm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1381680,int_stack+1182030,int_stack+626640,3630);
 /*--- compute (kd|nm) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1871730,int_stack+1381680,int_stack+789990,3630);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+369600,int_stack+183876,int_stack+179520,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+382668,int_stack+189024,int_stack+183876,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+398112,int_stack+382668,int_stack+369600,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+424248,int_stack+195030,int_stack+189024,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+442266,int_stack+424248,int_stack+382668,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+473154,int_stack+442266,int_stack+398112,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+369600,int_stack+201960,int_stack+195030,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+516714,int_stack+369600,int_stack+424248,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+390390,int_stack+516714,int_stack+442266,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+552750,int_stack+390390,int_stack+473154,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+441870,int_stack+209880,int_stack+201960,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+465630,int_stack+441870,int_stack+369600,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+618090,int_stack+465630,int_stack+516714,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+678150,int_stack+618090,int_stack+390390,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+755370,int_stack+678150,int_stack+552750,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+369600,int_stack+218856,int_stack+209880,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+507210,int_stack+369600,int_stack+441870,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+846846,int_stack+507210,int_stack+465630,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+396528,int_stack+846846,int_stack+618090,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+554730,int_stack+396528,int_stack+678150,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+916146,int_stack+554730,int_stack+755370,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+662838,int_stack+228954,int_stack+218856,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+693132,int_stack+662838,int_stack+369600,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+746988,int_stack+693132,int_stack+507210,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1038114,int_stack+746988,int_stack+846846,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+1038114,int_stack+396528,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+369600,int_stack+0,int_stack+554730,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2655810,int_stack+369600,int_stack+916146,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+513744,int_stack+240240,int_stack+228954,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+547602,int_stack+513744,int_stack+662838,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+826188,int_stack+547602,int_stack+693132,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+608190,int_stack+826188,int_stack+746988,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2812626,int_stack+608190,int_stack+1038114,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+915948,int_stack+2812626,int_stack+0,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+915948,int_stack+369600,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2958156,int_stack+0,int_stack+2655810,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+2655810,int_stack+252780,int_stack+240240,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+2693430,int_stack+2655810,int_stack+513744,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+369600,int_stack+2693430,int_stack+547602,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2655810,int_stack+369600,int_stack+826188,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+369600,int_stack+2655810,int_stack+608190,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+535920,int_stack+369600,int_stack+2812626,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2655810,int_stack+535920,int_stack+915948,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+369600,int_stack+2655810,int_stack+0,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+369600,int_stack+2958156,66);
 /*--- compute (mp|nm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+369600,int_stack+0,int_stack+1182030,3630);
 /*--- compute (ld|nm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2655810,int_stack+369600,int_stack+1381680,3630);
 /*--- compute (kf|nm) ---*/
 hrr1_build_kf(Libint->AB,int_stack+3635910,int_stack+2655810,int_stack+1871730,3630);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+968550,int_stack+271788,int_stack+266640,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+983994,int_stack+277872,int_stack+271788,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1002246,int_stack+983994,int_stack+968550,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1033134,int_stack+284970,int_stack+277872,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1054428,int_stack+1033134,int_stack+983994,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1090932,int_stack+1054428,int_stack+1002246,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+968550,int_stack+293160,int_stack+284970,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1142412,int_stack+968550,int_stack+1033134,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+993120,int_stack+1142412,int_stack+1054428,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1185000,int_stack+993120,int_stack+1090932,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1053960,int_stack+302520,int_stack+293160,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1082040,int_stack+1053960,int_stack+968550,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1262220,int_stack+1082040,int_stack+1142412,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1333200,int_stack+1262220,int_stack+993120,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1424460,int_stack+1333200,int_stack+1185000,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+968550,int_stack+313128,int_stack+302520,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1131180,int_stack+968550,int_stack+1053960,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1532568,int_stack+1131180,int_stack+1082040,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1000374,int_stack+1532568,int_stack+1262220,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1187340,int_stack+1000374,int_stack+1333200,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1614468,int_stack+1187340,int_stack+1424460,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1315104,int_stack+325062,int_stack+313128,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1350906,int_stack+1315104,int_stack+968550,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1414554,int_stack+1350906,int_stack+1131180,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1758612,int_stack+1414554,int_stack+1532568,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1881462,int_stack+1758612,int_stack+1000374,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+968550,int_stack+1881462,int_stack+1187340,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2030520,int_stack+968550,int_stack+1614468,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1138902,int_stack+338400,int_stack+325062,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1178916,int_stack+1138902,int_stack+1315104,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1508154,int_stack+1178916,int_stack+1350906,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1250520,int_stack+1508154,int_stack+1414554,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2215848,int_stack+1250520,int_stack+1758612,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1614234,int_stack+2215848,int_stack+1881462,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2387838,int_stack+1614234,int_stack+968550,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4942710,int_stack+2387838,int_stack+2030520,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+968550,int_stack+353220,int_stack+338400,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1013010,int_stack+968550,int_stack+1138902,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1812978,int_stack+1013010,int_stack+1178916,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+968550,int_stack+1812978,int_stack+1508154,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1812978,int_stack+968550,int_stack+1250520,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+968550,int_stack+1812978,int_stack+2215848,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1812978,int_stack+968550,int_stack+1614234,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+968550,int_stack+1812978,int_stack+2387838,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1242330,int_stack+968550,int_stack+4942710,78);
 /*--- compute (np|nm) ---*/
 hrr1_build_np(Libint->AB,int_stack+1525470,int_stack+1242330,int_stack+0,3630);
 /*--- compute (md|nm) ---*/
 hrr1_build_md(Libint->AB,int_stack+4942710,int_stack+1525470,int_stack+369600,3630);
 /*--- compute (lf|nm) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+4942710,int_stack+2655810,3630);
 /*--- compute (kg|nm) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1633500,int_stack+0,int_stack+3635910,3630);
 return int_stack+1633500;}
