/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_khlg(Libint_t*, prim_data*);

  /* Computes quartets of (kh|lg) integrals */

REALTYPE *hrr_order_khlg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[8][8] = int_stack + 12060;
 Libint->vrr_classes[8][9] = int_stack + 14085;
 Libint->vrr_classes[8][10] = int_stack + 16560;
 Libint->vrr_classes[8][11] = int_stack + 19530;
 Libint->vrr_classes[8][12] = int_stack + 23040;
 Libint->vrr_classes[9][8] = int_stack + 27135;
 Libint->vrr_classes[9][9] = int_stack + 29610;
 Libint->vrr_classes[9][10] = int_stack + 32635;
 Libint->vrr_classes[9][11] = int_stack + 36265;
 Libint->vrr_classes[9][12] = int_stack + 40555;
 Libint->vrr_classes[10][8] = int_stack + 45560;
 Libint->vrr_classes[10][9] = int_stack + 48530;
 Libint->vrr_classes[10][10] = int_stack + 52160;
 Libint->vrr_classes[10][11] = int_stack + 56516;
 Libint->vrr_classes[10][12] = int_stack + 61664;
 Libint->vrr_classes[11][8] = int_stack + 67670;
 Libint->vrr_classes[11][9] = int_stack + 71180;
 Libint->vrr_classes[11][10] = int_stack + 75470;
 Libint->vrr_classes[11][11] = int_stack + 80618;
 Libint->vrr_classes[11][12] = int_stack + 86702;
 Libint->vrr_classes[12][8] = int_stack + 93800;
 Libint->vrr_classes[12][9] = int_stack + 97895;
 Libint->vrr_classes[12][10] = int_stack + 102900;
 Libint->vrr_classes[12][11] = int_stack + 108906;
 Libint->vrr_classes[12][12] = int_stack + 116004;
 memset(int_stack,0,124285*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 124285;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_khlg(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+124285,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+129145,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+135085,int_stack+129145,int_stack+124285,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+144805,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+151933,int_stack+144805,int_stack+129145,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+163813,int_stack+151933,int_stack+135085,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+124285,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+180013,int_stack+124285,int_stack+144805,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+124285,int_stack+180013,int_stack+151933,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+180013,int_stack+124285,int_stack+163813,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+124285,int_stack+14085,int_stack+12060,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+130360,int_stack+16560,int_stack+14085,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+137785,int_stack+130360,int_stack+124285,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+149935,int_stack+19530,int_stack+16560,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+158845,int_stack+149935,int_stack+130360,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+204313,int_stack+158845,int_stack+137785,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+124285,int_stack+23040,int_stack+19530,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+124285,int_stack+149935,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+124285,int_stack+0,int_stack+158845,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+149035,int_stack+124285,int_stack+204313,45);
 /*--- compute (kp|lg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+204313,int_stack+149035,int_stack+180013,675);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+124285,int_stack+29610,int_stack+27135,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+131710,int_stack+32635,int_stack+29610,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+131710,int_stack+124285,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+14850,int_stack+36265,int_stack+32635,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+179410,int_stack+14850,int_stack+131710,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+124285,int_stack+179410,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+40555,int_stack+36265,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+277213,int_stack+0,int_stack+14850,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+277213,int_stack+179410,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+277213,int_stack+0,int_stack+124285,55);
 /*--- compute (lp|lg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+314338,int_stack+277213,int_stack+149035,675);
 /*--- compute (kd|lg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+405463,int_stack+314338,int_stack+204313,675);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+124285,int_stack+48530,int_stack+45560,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+133195,int_stack+52160,int_stack+48530,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+144085,int_stack+133195,int_stack+124285,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+161905,int_stack+56516,int_stack+52160,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+174973,int_stack+161905,int_stack+133195,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+196753,int_stack+174973,int_stack+144085,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+124285,int_stack+61664,int_stack+56516,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+226453,int_stack+124285,int_stack+161905,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+124285,int_stack+226453,int_stack+174973,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+226453,int_stack+124285,int_stack+196753,66);
 /*--- compute (mp|lg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+551263,int_stack+226453,int_stack+277213,675);
 /*--- compute (ld|lg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+662638,int_stack+551263,int_stack+314338,675);
 /*--- compute (kf|lg) ---*/
 hrr1_build_kf(Libint->AB,int_stack+844888,int_stack+662638,int_stack+405463,675);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+124285,int_stack+71180,int_stack+67670,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+134815,int_stack+75470,int_stack+71180,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+147685,int_stack+134815,int_stack+124285,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+168745,int_stack+80618,int_stack+75470,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+184189,int_stack+168745,int_stack+134815,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+271003,int_stack+184189,int_stack+147685,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+124285,int_stack+86702,int_stack+80618,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+306103,int_stack+124285,int_stack+168745,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+124285,int_stack+306103,int_stack+184189,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+306103,int_stack+124285,int_stack+271003,78);
 /*--- compute (np|lg) ---*/
 hrr1_build_np(Libint->AB,int_stack+358753,int_stack+306103,int_stack+226453,675);
 /*--- compute (md|lg) ---*/
 hrr1_build_md(Libint->AB,int_stack+1087888,int_stack+358753,int_stack+551263,675);
 /*--- compute (lf|lg) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1310638,int_stack+1087888,int_stack+662638,675);
 /*--- compute (kg|lg) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1614388,int_stack+1310638,int_stack+844888,675);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+124285,int_stack+97895,int_stack+93800,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+136570,int_stack+102900,int_stack+97895,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+151585,int_stack+136570,int_stack+124285,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+176155,int_stack+108906,int_stack+102900,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+194173,int_stack+176155,int_stack+136570,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+224203,int_stack+194173,int_stack+151585,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+124285,int_stack+116004,int_stack+108906,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+265153,int_stack+124285,int_stack+176155,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+492403,int_stack+265153,int_stack+194173,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+542453,int_stack+492403,int_stack+224203,91);
 /*--- compute (op|lg) ---*/
 hrr1_build_op(Libint->AB,int_stack+603878,int_stack+542453,int_stack+306103,675);
 /*--- compute (nd|lg) ---*/
 hrr1_build_nd(Libint->AB,int_stack+761828,int_stack+603878,int_stack+358753,675);
 /*--- compute (mf|lg) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+761828,int_stack+1087888,675);
 /*--- compute (lg|lg) ---*/
 hrr1_build_lg(Libint->AB,int_stack+371250,int_stack+0,int_stack+1310638,675);
 /*--- compute (kh|lg) ---*/
 hrr1_build_kh(Libint->AB,int_stack+826875,int_stack+371250,int_stack+1614388,675);
 return int_stack+826875;}
