/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_khll(Libint_t*, prim_data*);

  /* Computes quartets of (kh|ll) integrals */

REALTYPE *hrr_order_khll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[7][13] = int_stack + 12060;
 Libint->vrr_classes[7][14] = int_stack + 15840;
 Libint->vrr_classes[7][15] = int_stack + 20160;
 Libint->vrr_classes[7][16] = int_stack + 25056;
 Libint->vrr_classes[8][8] = int_stack + 30564;
 Libint->vrr_classes[8][9] = int_stack + 32589;
 Libint->vrr_classes[8][10] = int_stack + 35064;
 Libint->vrr_classes[8][11] = int_stack + 38034;
 Libint->vrr_classes[8][12] = int_stack + 41544;
 Libint->vrr_classes[8][13] = int_stack + 45639;
 Libint->vrr_classes[8][14] = int_stack + 50364;
 Libint->vrr_classes[8][15] = int_stack + 55764;
 Libint->vrr_classes[8][16] = int_stack + 61884;
 Libint->vrr_classes[9][8] = int_stack + 68769;
 Libint->vrr_classes[9][9] = int_stack + 71244;
 Libint->vrr_classes[9][10] = int_stack + 74269;
 Libint->vrr_classes[9][11] = int_stack + 77899;
 Libint->vrr_classes[9][12] = int_stack + 82189;
 Libint->vrr_classes[9][13] = int_stack + 87194;
 Libint->vrr_classes[9][14] = int_stack + 92969;
 Libint->vrr_classes[9][15] = int_stack + 99569;
 Libint->vrr_classes[9][16] = int_stack + 107049;
 Libint->vrr_classes[10][8] = int_stack + 115464;
 Libint->vrr_classes[10][9] = int_stack + 118434;
 Libint->vrr_classes[10][10] = int_stack + 122064;
 Libint->vrr_classes[10][11] = int_stack + 126420;
 Libint->vrr_classes[10][12] = int_stack + 131568;
 Libint->vrr_classes[10][13] = int_stack + 137574;
 Libint->vrr_classes[10][14] = int_stack + 144504;
 Libint->vrr_classes[10][15] = int_stack + 152424;
 Libint->vrr_classes[10][16] = int_stack + 161400;
 Libint->vrr_classes[11][8] = int_stack + 171498;
 Libint->vrr_classes[11][9] = int_stack + 175008;
 Libint->vrr_classes[11][10] = int_stack + 179298;
 Libint->vrr_classes[11][11] = int_stack + 184446;
 Libint->vrr_classes[11][12] = int_stack + 190530;
 Libint->vrr_classes[11][13] = int_stack + 197628;
 Libint->vrr_classes[11][14] = int_stack + 205818;
 Libint->vrr_classes[11][15] = int_stack + 215178;
 Libint->vrr_classes[11][16] = int_stack + 225786;
 Libint->vrr_classes[12][8] = int_stack + 237720;
 Libint->vrr_classes[12][9] = int_stack + 241815;
 Libint->vrr_classes[12][10] = int_stack + 246820;
 Libint->vrr_classes[12][11] = int_stack + 252826;
 Libint->vrr_classes[12][12] = int_stack + 259924;
 Libint->vrr_classes[12][13] = int_stack + 268205;
 Libint->vrr_classes[12][14] = int_stack + 277760;
 Libint->vrr_classes[12][15] = int_stack + 288680;
 Libint->vrr_classes[12][16] = int_stack + 301056;
 memset(int_stack,0,314979*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 314979;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_khll(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+314979,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+319839,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+325779,int_stack+319839,int_stack+314979,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+335499,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+342627,int_stack+335499,int_stack+319839,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+354507,int_stack+342627,int_stack+325779,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+314979,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+370707,int_stack+314979,int_stack+335499,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+384963,int_stack+370707,int_stack+342627,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+323403,int_stack+384963,int_stack+354507,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+347703,int_stack+12060,int_stack+8784,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+404763,int_stack+347703,int_stack+314979,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+421611,int_stack+404763,int_stack+370707,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+445371,int_stack+421611,int_stack+384963,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+357531,int_stack+445371,int_stack+323403,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+314979,int_stack+15840,int_stack+12060,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+326319,int_stack+314979,int_stack+347703,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+475071,int_stack+326319,int_stack+404763,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+503151,int_stack+475071,int_stack+421611,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+391551,int_stack+503151,int_stack+445371,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+538791,int_stack+391551,int_stack+357531,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+345975,int_stack+20160,int_stack+15840,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+358935,int_stack+345975,int_stack+314979,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+433131,int_stack+358935,int_stack+326319,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+584151,int_stack+433131,int_stack+475071,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+626271,int_stack+584151,int_stack+503151,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+465891,int_stack+626271,int_stack+391551,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+676167,int_stack+465891,int_stack+538791,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+314979,int_stack+25056,int_stack+20160,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+381615,int_stack+314979,int_stack+345975,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+314979,int_stack+381615,int_stack+358935,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+352779,int_stack+314979,int_stack+433131,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+401919,int_stack+352779,int_stack+584151,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+314979,int_stack+401919,int_stack+626271,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+381507,int_stack+314979,int_stack+465891,36);
 /*--- compute (k0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+452787,int_stack+381507,int_stack+676167,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+314979,int_stack+32589,int_stack+30564,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+321054,int_stack+35064,int_stack+32589,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+328479,int_stack+321054,int_stack+314979,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+340629,int_stack+38034,int_stack+35064,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+349539,int_stack+340629,int_stack+321054,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+364389,int_stack+349539,int_stack+328479,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+314979,int_stack+41544,int_stack+38034,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+384639,int_stack+314979,int_stack+340629,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+402459,int_stack+384639,int_stack+349539,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+325509,int_stack+402459,int_stack+364389,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+355884,int_stack+45639,int_stack+41544,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+427209,int_stack+355884,int_stack+314979,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+525687,int_stack+427209,int_stack+384639,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+555387,int_stack+525687,int_stack+402459,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+368169,int_stack+555387,int_stack+325509,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+314979,int_stack+50364,int_stack+45639,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+329154,int_stack+314979,int_stack+355884,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+592512,int_stack+329154,int_stack+427209,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+627612,int_stack+592512,int_stack+525687,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+672162,int_stack+627612,int_stack+555387,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+525687,int_stack+672162,int_stack+368169,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+353724,int_stack+55764,int_stack+50364,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+369924,int_stack+353724,int_stack+314979,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+398274,int_stack+369924,int_stack+329154,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+398274,int_stack+592512,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+724137,int_stack+0,int_stack+627612,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+582387,int_stack+724137,int_stack+672162,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+786507,int_stack+582387,int_stack+525687,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+525687,int_stack+61884,int_stack+55764,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+544047,int_stack+525687,int_stack+353724,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+314979,int_stack+544047,int_stack+369924,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+651687,int_stack+314979,int_stack+398274,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+314979,int_stack+651687,int_stack+0,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+859407,int_stack+314979,int_stack+724137,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+314979,int_stack+859407,int_stack+582387,45);
 /*--- compute (l0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+525687,int_stack+314979,int_stack+786507,45);
 /*--- compute (kp|ll) ---*/
 hrr1_build_kp(Libint->AB,int_stack+616812,int_stack+525687,int_stack+452787,2025);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+314979,int_stack+71244,int_stack+68769,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+322404,int_stack+74269,int_stack+71244,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+331479,int_stack+322404,int_stack+314979,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+346329,int_stack+77899,int_stack+74269,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+357219,int_stack+346329,int_stack+322404,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+375369,int_stack+357219,int_stack+331479,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+314979,int_stack+82189,int_stack+77899,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+400119,int_stack+314979,int_stack+346329,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+421899,int_stack+400119,int_stack+357219,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+327849,int_stack+421899,int_stack+375369,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+364974,int_stack+87194,int_stack+82189,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+452149,int_stack+364974,int_stack+314979,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+477889,int_stack+452149,int_stack+400119,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+477889,int_stack+421899,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+379989,int_stack+0,int_stack+327849,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+314979,int_stack+92969,int_stack+87194,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+332304,int_stack+314979,int_stack+364974,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+45375,int_stack+332304,int_stack+452149,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+835512,int_stack+45375,int_stack+477889,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+431964,int_stack+835512,int_stack+0,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+889962,int_stack+431964,int_stack+379989,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+99569,int_stack+92969,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+362334,int_stack+0,int_stack+314979,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+959262,int_stack+362334,int_stack+332304,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1009312,int_stack+959262,int_stack+45375,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+19800,int_stack+1009312,int_stack+835512,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1073662,int_stack+19800,int_stack+431964,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+396984,int_stack+1073662,int_stack+889962,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+835512,int_stack+107049,int_stack+99569,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+857952,int_stack+835512,int_stack+0,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+897552,int_stack+857952,int_stack+362334,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+314979,int_stack+897552,int_stack+959262,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+835512,int_stack+314979,int_stack+1009312,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+925602,int_stack+835512,int_stack+19800,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+925602,int_stack+1073662,55);
 /*--- compute (m0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+835512,int_stack+0,int_stack+396984,55);
 /*--- compute (lp|ll) ---*/
 hrr1_build_lp(Libint->AB,int_stack+946887,int_stack+835512,int_stack+525687,2025);
 /*--- compute (kd|ll) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1220262,int_stack+946887,int_stack+616812,2025);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+118434,int_stack+115464,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8910,int_stack+122064,int_stack+118434,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19800,int_stack+8910,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37620,int_stack+126420,int_stack+122064,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+50688,int_stack+37620,int_stack+8910,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+72468,int_stack+50688,int_stack+19800,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+131568,int_stack+126420,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+102168,int_stack+0,int_stack+37620,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+314979,int_stack+102168,int_stack+50688,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+15444,int_stack+314979,int_stack+72468,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+59994,int_stack+137574,int_stack+131568,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+351279,int_stack+59994,int_stack+0,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+382167,int_stack+351279,int_stack+102168,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+78012,int_stack+382167,int_stack+314979,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+425727,int_stack+78012,int_stack+15444,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+314979,int_stack+144504,int_stack+137574,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+314979,int_stack+59994,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+488097,int_stack+0,int_stack+351279,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+539577,int_stack+488097,int_stack+382167,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+335769,int_stack+539577,int_stack+78012,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+36036,int_stack+335769,int_stack+425727,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+411999,int_stack+152424,int_stack+144504,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+435759,int_stack+411999,int_stack+314979,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+604917,int_stack+435759,int_stack+0,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+664977,int_stack+604917,int_stack+488097,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+742197,int_stack+664977,int_stack+539577,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+477339,int_stack+742197,int_stack+335769,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1657662,int_stack+477339,int_stack+36036,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+161400,int_stack+152424,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+26928,int_stack+0,int_stack+411999,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+74448,int_stack+26928,int_stack+435759,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+314979,int_stack+74448,int_stack+604917,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+314979,int_stack+664977,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+314979,int_stack+0,int_stack+742197,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+314979,int_stack+477339,66);
 /*--- compute (n0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+314979,int_stack+0,int_stack+1657662,66);
 /*--- compute (mp|ll) ---*/
 hrr1_build_mp(Libint->AB,int_stack+448629,int_stack+314979,int_stack+835512,2025);
 /*--- compute (ld|ll) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1657662,int_stack+448629,int_stack+946887,2025);
 /*--- compute (kf|ll) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2204412,int_stack+1657662,int_stack+1220262,2025);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+175008,int_stack+171498,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10530,int_stack+179298,int_stack+175008,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23400,int_stack+10530,int_stack+0,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44460,int_stack+184446,int_stack+179298,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+59904,int_stack+44460,int_stack+10530,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+85644,int_stack+59904,int_stack+23400,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+190530,int_stack+184446,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+120744,int_stack+0,int_stack+44460,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+782754,int_stack+120744,int_stack+59904,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+18252,int_stack+782754,int_stack+85644,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+70902,int_stack+197628,int_stack+190530,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+151632,int_stack+70902,int_stack+0,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+825654,int_stack+151632,int_stack+120744,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+877134,int_stack+825654,int_stack+782754,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+941484,int_stack+877134,int_stack+18252,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+782754,int_stack+205818,int_stack+197628,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+782754,int_stack+70902,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+42588,int_stack+0,int_stack+151632,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+103428,int_stack+42588,int_stack+825654,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1015194,int_stack+103428,int_stack+877134,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+807324,int_stack+1015194,int_stack+941484,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+905604,int_stack+215178,int_stack+205818,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+933684,int_stack+905604,int_stack+782754,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1105284,int_stack+933684,int_stack+0,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1176264,int_stack+1105284,int_stack+42588,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1267524,int_stack+1176264,int_stack+103428,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+1267524,int_stack+1015194,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1375632,int_stack+0,int_stack+807324,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+120120,int_stack+225786,int_stack+215178,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+151944,int_stack+120120,int_stack+905604,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+782754,int_stack+151944,int_stack+933684,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+120120,int_stack+782754,int_stack+1105284,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+782754,int_stack+120120,int_stack+1176264,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+910518,int_stack+782754,int_stack+1267524,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1054662,int_stack+910518,int_stack+0,78);
 /*--- compute (o0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+1054662,int_stack+1375632,78);
 /*--- compute (np|ll) ---*/
 hrr1_build_np(Libint->AB,int_stack+782754,int_stack+0,int_stack+314979,2025);
 /*--- compute (md|ll) ---*/
 hrr1_build_md(Libint->AB,int_stack+2933412,int_stack+782754,int_stack+448629,2025);
 /*--- compute (lf|ll) ---*/
 hrr1_build_lf(Libint->AB,int_stack+3601662,int_stack+2933412,int_stack+1657662,2025);
 /*--- compute (kg|ll) ---*/
 hrr1_build_kg(Libint->AB,int_stack+4512912,int_stack+3601662,int_stack+2204412,2025);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+314979,int_stack+241815,int_stack+237720,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+327264,int_stack+246820,int_stack+241815,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+342279,int_stack+327264,int_stack+314979,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+366849,int_stack+252826,int_stack+246820,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+384867,int_stack+366849,int_stack+327264,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+414897,int_stack+384867,int_stack+342279,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+314979,int_stack+259924,int_stack+252826,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+455847,int_stack+314979,int_stack+366849,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+491883,int_stack+455847,int_stack+384867,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+336273,int_stack+491883,int_stack+414897,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+397698,int_stack+268205,int_stack+259924,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+541933,int_stack+397698,int_stack+314979,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+584521,int_stack+541933,int_stack+455847,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+644581,int_stack+584521,int_stack+491883,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+422541,int_stack+644581,int_stack+336273,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+314979,int_stack+277760,int_stack+268205,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+343644,int_stack+314979,int_stack+397698,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+157950,int_stack+343644,int_stack+541933,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1183704,int_stack+157950,int_stack+584521,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+508536,int_stack+1183704,int_stack+644581,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+613641,int_stack+508536,int_stack+422541,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+393330,int_stack+288680,int_stack+277760,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+426090,int_stack+393330,int_stack+314979,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1273794,int_stack+426090,int_stack+343644,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1356604,int_stack+1273794,int_stack+157950,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+157950,int_stack+1356604,int_stack+1183704,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1463074,int_stack+157950,int_stack+508536,91);
 /*--- compute (q0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1603214,int_stack+1463074,int_stack+613641,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1183704,int_stack+301056,int_stack+288680,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+284076,int_stack+1183704,int_stack+393330,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+483420,int_stack+284076,int_stack+426090,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+284076,int_stack+483420,int_stack+1273794,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+408291,int_stack+284076,int_stack+1356604,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+557349,int_stack+408291,int_stack+157950,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+157950,int_stack+557349,int_stack+1463074,91);
 /*--- compute (q0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+338130,int_stack+157950,int_stack+1603214,91);
 /*--- compute (op|ll) ---*/
 hrr1_build_op(Libint->AB,int_stack+1183704,int_stack+338130,int_stack+0,2025);
 /*--- compute (nd|ll) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1657554,int_stack+1183704,int_stack+782754,2025);
 /*--- compute (mf|ll) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+1657554,int_stack+2933412,2025);
 /*--- compute (lg|ll) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1113750,int_stack+0,int_stack+3601662,2025);
 /*--- compute (kh|ll) ---*/
 hrr1_build_kh(Libint->AB,int_stack+2480625,int_stack+1113750,int_stack+4512912,2025);
 return int_stack+2480625;}
