/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kinl(Libint_t*, prim_data*);

  /* Computes quartets of (ki|nl) integrals */

REALTYPE *hrr_order_kinl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[7][17] = int_stack + 26964;
 Libint->vrr_classes[7][18] = int_stack + 33120;
 Libint->vrr_classes[8][10] = int_stack + 39960;
 Libint->vrr_classes[8][11] = int_stack + 42930;
 Libint->vrr_classes[8][12] = int_stack + 46440;
 Libint->vrr_classes[8][13] = int_stack + 50535;
 Libint->vrr_classes[8][14] = int_stack + 55260;
 Libint->vrr_classes[8][15] = int_stack + 60660;
 Libint->vrr_classes[8][16] = int_stack + 66780;
 Libint->vrr_classes[8][17] = int_stack + 73665;
 Libint->vrr_classes[8][18] = int_stack + 81360;
 Libint->vrr_classes[9][10] = int_stack + 89910;
 Libint->vrr_classes[9][11] = int_stack + 93540;
 Libint->vrr_classes[9][12] = int_stack + 97830;
 Libint->vrr_classes[9][13] = int_stack + 102835;
 Libint->vrr_classes[9][14] = int_stack + 108610;
 Libint->vrr_classes[9][15] = int_stack + 115210;
 Libint->vrr_classes[9][16] = int_stack + 122690;
 Libint->vrr_classes[9][17] = int_stack + 131105;
 Libint->vrr_classes[9][18] = int_stack + 140510;
 Libint->vrr_classes[10][10] = int_stack + 150960;
 Libint->vrr_classes[10][11] = int_stack + 155316;
 Libint->vrr_classes[10][12] = int_stack + 160464;
 Libint->vrr_classes[10][13] = int_stack + 166470;
 Libint->vrr_classes[10][14] = int_stack + 173400;
 Libint->vrr_classes[10][15] = int_stack + 181320;
 Libint->vrr_classes[10][16] = int_stack + 190296;
 Libint->vrr_classes[10][17] = int_stack + 200394;
 Libint->vrr_classes[10][18] = int_stack + 211680;
 Libint->vrr_classes[11][10] = int_stack + 224220;
 Libint->vrr_classes[11][11] = int_stack + 229368;
 Libint->vrr_classes[11][12] = int_stack + 235452;
 Libint->vrr_classes[11][13] = int_stack + 242550;
 Libint->vrr_classes[11][14] = int_stack + 250740;
 Libint->vrr_classes[11][15] = int_stack + 260100;
 Libint->vrr_classes[11][16] = int_stack + 270708;
 Libint->vrr_classes[11][17] = int_stack + 282642;
 Libint->vrr_classes[11][18] = int_stack + 295980;
 Libint->vrr_classes[12][10] = int_stack + 310800;
 Libint->vrr_classes[12][11] = int_stack + 316806;
 Libint->vrr_classes[12][12] = int_stack + 323904;
 Libint->vrr_classes[12][13] = int_stack + 332185;
 Libint->vrr_classes[12][14] = int_stack + 341740;
 Libint->vrr_classes[12][15] = int_stack + 352660;
 Libint->vrr_classes[12][16] = int_stack + 365036;
 Libint->vrr_classes[12][17] = int_stack + 378959;
 Libint->vrr_classes[12][18] = int_stack + 394520;
 Libint->vrr_classes[13][10] = int_stack + 411810;
 Libint->vrr_classes[13][11] = int_stack + 418740;
 Libint->vrr_classes[13][12] = int_stack + 426930;
 Libint->vrr_classes[13][13] = int_stack + 436485;
 Libint->vrr_classes[13][14] = int_stack + 447510;
 Libint->vrr_classes[13][15] = int_stack + 460110;
 Libint->vrr_classes[13][16] = int_stack + 474390;
 Libint->vrr_classes[13][17] = int_stack + 490455;
 Libint->vrr_classes[13][18] = int_stack + 508410;
 memset(int_stack,0,528360*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 528360;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kinl(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+528360,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+535488,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+543912,int_stack+535488,int_stack+528360,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+558168,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+567996,int_stack+558168,int_stack+535488,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+584844,int_stack+567996,int_stack+543912,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+528360,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+608604,int_stack+528360,int_stack+558168,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+539700,int_stack+608604,int_stack+567996,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+628260,int_stack+539700,int_stack+584844,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+567780,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+580740,int_stack+567780,int_stack+528360,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+663900,int_stack+580740,int_stack+608604,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+696660,int_stack+663900,int_stack+539700,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+738780,int_stack+696660,int_stack+628260,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+528360,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+603420,int_stack+528360,int_stack+567780,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+788676,int_stack+603420,int_stack+580740,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+543048,int_stack+788676,int_stack+663900,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+629340,int_stack+543048,int_stack+696660,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+826476,int_stack+629340,int_stack+738780,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+688308,int_stack+26964,int_stack+21456,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+704832,int_stack+688308,int_stack+528360,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+734208,int_stack+704832,int_stack+603420,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+893004,int_stack+734208,int_stack+788676,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+949704,int_stack+893004,int_stack+543048,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+528360,int_stack+949704,int_stack+629340,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1018500,int_stack+528360,int_stack+826476,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+606984,int_stack+33120,int_stack+26964,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+625452,int_stack+606984,int_stack+688308,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+777408,int_stack+625452,int_stack+704832,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+606984,int_stack+777408,int_stack+734208,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+671784,int_stack+606984,int_stack+893004,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+751164,int_stack+671784,int_stack+949704,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+606984,int_stack+751164,int_stack+528360,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+708072,int_stack+606984,int_stack+1018500,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+528360,int_stack+42930,int_stack+39960,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+537270,int_stack+46440,int_stack+42930,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+547800,int_stack+537270,int_stack+528360,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+565620,int_stack+50535,int_stack+46440,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+577905,int_stack+565620,int_stack+537270,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+598965,int_stack+577905,int_stack+547800,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+528360,int_stack+55260,int_stack+50535,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+628665,int_stack+528360,int_stack+565620,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+542535,int_stack+628665,int_stack+577905,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+653235,int_stack+542535,int_stack+598965,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+577635,int_stack+60660,int_stack+55260,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+593835,int_stack+577635,int_stack+528360,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+814992,int_stack+593835,int_stack+628665,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+855942,int_stack+814992,int_stack+542535,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+908592,int_stack+855942,int_stack+653235,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+528360,int_stack+66780,int_stack+60660,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+622185,int_stack+528360,int_stack+577635,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+654585,int_stack+622185,int_stack+593835,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+546720,int_stack+654585,int_stack+814992,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+970962,int_stack+546720,int_stack+855942,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+814992,int_stack+970962,int_stack+908592,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+898152,int_stack+73665,int_stack+66780,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+918807,int_stack+898152,int_stack+528360,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1044672,int_stack+918807,int_stack+622185,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+1044672,int_stack+654585,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+608145,int_stack+0,int_stack+546720,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1098672,int_stack+608145,int_stack+970962,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1196952,int_stack+1098672,int_stack+814992,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+814992,int_stack+81360,int_stack+73665,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+838077,int_stack+814992,int_stack+898152,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+528360,int_stack+838077,int_stack+918807,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+814992,int_stack+528360,int_stack+1044672,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+895992,int_stack+814992,int_stack+0,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1303872,int_stack+895992,int_stack+608145,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+814992,int_stack+1303872,int_stack+1098672,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+941352,int_stack+814992,int_stack+1196952,45);
 /*--- compute (kp|nl) ---*/
 hrr1_build_kp(Libint->AB,int_stack+1075002,int_stack+941352,int_stack+708072,2970);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+93540,int_stack+89910,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+97830,int_stack+93540,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23760,int_stack+10890,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+45540,int_stack+102835,int_stack+97830,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+60555,int_stack+45540,int_stack+10890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+528360,int_stack+60555,int_stack+23760,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+108610,int_stack+102835,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+564660,int_stack+0,int_stack+45540,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+17325,int_stack+564660,int_stack+60555,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+594690,int_stack+17325,int_stack+528360,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+528360,int_stack+115210,int_stack+108610,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+60225,int_stack+528360,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+649140,int_stack+60225,int_stack+564660,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+699190,int_stack+649140,int_stack+17325,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+763540,int_stack+699190,int_stack+594690,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+122690,int_stack+115210,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+548160,int_stack+0,int_stack+528360,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+587760,int_stack+548160,int_stack+60225,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+22440,int_stack+587760,int_stack+649140,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+839770,int_stack+22440,int_stack+699190,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+645510,int_stack+839770,int_stack+763540,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+747150,int_stack+131105,int_stack+122690,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+772395,int_stack+747150,int_stack+0,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1395762,int_stack+772395,int_stack+548160,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1461762,int_stack+1395762,int_stack+587760,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+528360,int_stack+1461762,int_stack+22440,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+528360,int_stack+839770,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1548387,int_stack+0,int_stack+645510,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+633465,int_stack+140510,int_stack+131105,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+661680,int_stack+633465,int_stack+747150,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+817275,int_stack+661680,int_stack+772395,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+633465,int_stack+817275,int_stack+1395762,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+732465,int_stack+633465,int_stack+1461762,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1395762,int_stack+732465,int_stack+528360,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+528360,int_stack+1395762,int_stack+0,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+682800,int_stack+528360,int_stack+1548387,55);
 /*--- compute (lp|nl) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1395762,int_stack+682800,int_stack+941352,2970);
 /*--- compute (kd|nl) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1796712,int_stack+1395762,int_stack+1075002,2970);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+528360,int_stack+155316,int_stack+150960,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+541428,int_stack+160464,int_stack+155316,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+556872,int_stack+541428,int_stack+528360,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+583008,int_stack+166470,int_stack+160464,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+601026,int_stack+583008,int_stack+541428,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+631914,int_stack+601026,int_stack+556872,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+528360,int_stack+173400,int_stack+166470,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+528360,int_stack+583008,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+549150,int_stack+0,int_stack+601026,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+36036,int_stack+549150,int_stack+631914,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+600630,int_stack+181320,int_stack+173400,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+624390,int_stack+600630,int_stack+528360,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+101376,int_stack+624390,int_stack+0,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+846150,int_stack+101376,int_stack+549150,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+923370,int_stack+846150,int_stack+36036,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+190296,int_stack+181320,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+26928,int_stack+0,int_stack+600630,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+528360,int_stack+26928,int_stack+624390,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1014846,int_stack+528360,int_stack+101376,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+74448,int_stack+1014846,int_stack+846150,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1104936,int_stack+74448,int_stack+923370,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+846150,int_stack+200394,int_stack+190296,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+876444,int_stack+846150,int_stack+0,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+930300,int_stack+876444,int_stack+26928,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1226904,int_stack+930300,int_stack+528360,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+528360,int_stack+1226904,int_stack+1014846,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2438232,int_stack+528360,int_stack+74448,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2438232,int_stack+1104936,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+156816,int_stack+211680,int_stack+200394,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1009500,int_stack+156816,int_stack+846150,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1070088,int_stack+1009500,int_stack+876444,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2582376,int_stack+1070088,int_stack+930300,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+846150,int_stack+2582376,int_stack+1226904,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+991680,int_stack+846150,int_stack+528360,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1159848,int_stack+991680,int_stack+2438232,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2438232,int_stack+1159848,int_stack+0,66);
 /*--- compute (mp|nl) ---*/
 hrr1_build_mp(Libint->AB,int_stack+846150,int_stack+2438232,int_stack+682800,2970);
 /*--- compute (ld|nl) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2634252,int_stack+846150,int_stack+1395762,2970);
 /*--- compute (kf|nl) ---*/
 hrr1_build_kf(Libint->AB,int_stack+3436152,int_stack+2634252,int_stack+1796712,2970);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+229368,int_stack+224220,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+235452,int_stack+229368,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+242550,int_stack+235452,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+122382,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+250740,int_stack+242550,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+173862,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+173862,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+528360,int_stack+24570,int_stack+122382,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+85410,int_stack+260100,int_stack+250740,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113490,int_stack+85410,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+605580,int_stack+113490,int_stack+173862,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+162630,int_stack+605580,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+676560,int_stack+162630,int_stack+528360,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+528360,int_stack+270708,int_stack+260100,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+528360,int_stack+85410,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1336200,int_stack+0,int_stack+113490,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+56160,int_stack+1336200,int_stack+605580,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1418100,int_stack+56160,int_stack+162630,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1545864,int_stack+1418100,int_stack+676560,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+162630,int_stack+282642,int_stack+270708,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+198432,int_stack+162630,int_stack+528360,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+528360,int_stack+198432,int_stack+0,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+621960,int_stack+528360,int_stack+1336200,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1690008,int_stack+621960,int_stack+56160,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1839066,int_stack+1690008,int_stack+1418100,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1336200,int_stack+1839066,int_stack+1545864,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1521528,int_stack+295980,int_stack+282642,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1561542,int_stack+1521528,int_stack+162630,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+1561542,int_stack+198432,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1521528,int_stack+0,int_stack+528360,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+1521528,int_stack+621960,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+528360,int_stack+0,int_stack+1690008,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+528360,int_stack+1839066,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+528360,int_stack+0,int_stack+1336200,78);
 /*--- compute (np|nl) ---*/
 hrr1_build_np(Libint->AB,int_stack+1336200,int_stack+528360,int_stack+2438232,2970);
 /*--- compute (md|nl) ---*/
 hrr1_build_md(Libint->AB,int_stack+4505352,int_stack+1336200,int_stack+846150,2970);
 /*--- compute (lf|nl) ---*/
 hrr1_build_lf(Libint->AB,int_stack+5485452,int_stack+4505352,int_stack+2634252,2970);
 /*--- compute (kg|nl) ---*/
 hrr1_build_kg(Libint->AB,int_stack+6821952,int_stack+5485452,int_stack+3436152,2970);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1924260,int_stack+316806,int_stack+310800,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1942278,int_stack+323904,int_stack+316806,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1963572,int_stack+1942278,int_stack+1924260,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1999608,int_stack+332185,int_stack+323904,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2024451,int_stack+1999608,int_stack+1942278,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2067039,int_stack+2024451,int_stack+1963572,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1924260,int_stack+341740,int_stack+332185,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2127099,int_stack+1924260,int_stack+1999608,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1952925,int_stack+2127099,int_stack+2024451,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2176785,int_stack+1952925,int_stack+2067039,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2023905,int_stack+352660,int_stack+341740,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2056665,int_stack+2023905,int_stack+1924260,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2266875,int_stack+2056665,int_stack+2127099,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2349685,int_stack+2266875,int_stack+1952925,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2456155,int_stack+2349685,int_stack+2176785,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1924260,int_stack+365036,int_stack+352660,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2113995,int_stack+1924260,int_stack+2023905,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2582281,int_stack+2113995,int_stack+2056665,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1961388,int_stack+2582281,int_stack+2266875,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2179515,int_stack+1961388,int_stack+2349685,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2677831,int_stack+2179515,int_stack+2456155,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2328573,int_stack+378959,int_stack+365036,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2370342,int_stack+2328573,int_stack+1924260,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2444598,int_stack+2370342,int_stack+2113995,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2845999,int_stack+2444598,int_stack+2582281,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2989324,int_stack+2845999,int_stack+1961388,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1924260,int_stack+2989324,int_stack+2179515,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3163225,int_stack+1924260,int_stack+2677831,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2123004,int_stack+394520,int_stack+378959,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2169687,int_stack+2123004,int_stack+2328573,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2553798,int_stack+2169687,int_stack+2370342,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2123004,int_stack+2553798,int_stack+2444598,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2286804,int_stack+2123004,int_stack+2845999,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2487459,int_stack+2286804,int_stack+2989324,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2123004,int_stack+2487459,int_stack+1924260,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2378532,int_stack+2123004,int_stack+3163225,91);
 /*--- compute (op|nl) ---*/
 hrr1_build_op(Libint->AB,int_stack+2648802,int_stack+2378532,int_stack+528360,2970);
 /*--- compute (nd|nl) ---*/
 hrr1_build_nd(Libint->AB,int_stack+8425752,int_stack+2648802,int_stack+1336200,2970);
 /*--- compute (mf|nl) ---*/
 hrr1_build_mf(Libint->AB,int_stack+528360,int_stack+8425752,int_stack+4505352,2970);
 /*--- compute (lg|nl) ---*/
 hrr1_build_lg(Libint->AB,int_stack+3343782,int_stack+528360,int_stack+5485452,2970);
 /*--- compute (kh|nl) ---*/
 hrr1_build_kh(Libint->AB,int_stack+9601872,int_stack+3343782,int_stack+6821952,2970);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2161860,int_stack+418740,int_stack+411810,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2182650,int_stack+426930,int_stack+418740,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2207220,int_stack+2182650,int_stack+2161860,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2248800,int_stack+436485,int_stack+426930,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2277465,int_stack+2248800,int_stack+2182650,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+5348532,int_stack+2277465,int_stack+2207220,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2161860,int_stack+447510,int_stack+436485,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+5417832,int_stack+2161860,int_stack+2248800,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2194935,int_stack+5417832,int_stack+2277465,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+5475162,int_stack+2194935,int_stack+5348532,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+5348532,int_stack+460110,int_stack+447510,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2276835,int_stack+5348532,int_stack+2161860,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+5579112,int_stack+2276835,int_stack+5417832,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+5674662,int_stack+5579112,int_stack+2194935,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+5797512,int_stack+5674662,int_stack+5475162,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2161860,int_stack+474390,int_stack+460110,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+5386332,int_stack+2161860,int_stack+5348532,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+5461932,int_stack+5386332,int_stack+2276835,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2204700,int_stack+5461932,int_stack+5579112,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+5943042,int_stack+2204700,int_stack+5674662,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+5572182,int_stack+5943042,int_stack+5797512,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+5766222,int_stack+490455,int_stack+474390,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+5814417,int_stack+5766222,int_stack+2161860,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+6115032,int_stack+5814417,int_stack+5386332,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+6241032,int_stack+6115032,int_stack+5461932,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+5348532,int_stack+6241032,int_stack+2204700,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+6406407,int_stack+5348532,int_stack+5943042,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+6635727,int_stack+6406407,int_stack+5572182,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2161860,int_stack+508410,int_stack+490455,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2215725,int_stack+2161860,int_stack+5766222,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+5549187,int_stack+2215725,int_stack+5814417,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2161860,int_stack+5549187,int_stack+6115032,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+5549187,int_stack+2161860,int_stack+6241032,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+5780712,int_stack+5549187,int_stack+5348532,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+5348532,int_stack+5780712,int_stack+6406407,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5643372,int_stack+5348532,int_stack+6635727,105);
 /*--- compute (qp|nl) ---*/
 hrr1_build_qp(Libint->AB,int_stack+5955222,int_stack+5643372,int_stack+2378532,2970);
 /*--- compute (od|nl) ---*/
 hrr1_build_od(Libint->AB,int_stack+6766032,int_stack+5955222,int_stack+2648802,2970);
 /*--- compute (nf|nl) ---*/
 hrr1_build_nf(Libint->AB,int_stack+11847192,int_stack+6766032,int_stack+8425752,2970);
 /*--- compute (mg|nl) ---*/
 hrr1_build_mg(Libint->AB,int_stack+5348532,int_stack+11847192,int_stack+528360,2970);
 /*--- compute (lh|nl) ---*/
 hrr1_build_lh(Libint->AB,int_stack+0,int_stack+5348532,int_stack+3343782,2970);
 /*--- compute (ki|nl) ---*/
 hrr1_build_ki(Libint->AB,int_stack+2806650,int_stack+0,int_stack+9601872,2970);
 return int_stack+2806650;}
