/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kkml(Libint_t*, prim_data*);

  /* Computes quartets of (kk|ml) integrals */

REALTYPE *hrr_order_kkml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[7][14] = int_stack + 14220;
 Libint->vrr_classes[7][15] = int_stack + 18540;
 Libint->vrr_classes[7][16] = int_stack + 23436;
 Libint->vrr_classes[7][17] = int_stack + 28944;
 Libint->vrr_classes[8][9] = int_stack + 35100;
 Libint->vrr_classes[8][10] = int_stack + 37575;
 Libint->vrr_classes[8][11] = int_stack + 40545;
 Libint->vrr_classes[8][12] = int_stack + 44055;
 Libint->vrr_classes[8][13] = int_stack + 48150;
 Libint->vrr_classes[8][14] = int_stack + 52875;
 Libint->vrr_classes[8][15] = int_stack + 58275;
 Libint->vrr_classes[8][16] = int_stack + 64395;
 Libint->vrr_classes[8][17] = int_stack + 71280;
 Libint->vrr_classes[9][9] = int_stack + 78975;
 Libint->vrr_classes[9][10] = int_stack + 82000;
 Libint->vrr_classes[9][11] = int_stack + 85630;
 Libint->vrr_classes[9][12] = int_stack + 89920;
 Libint->vrr_classes[9][13] = int_stack + 94925;
 Libint->vrr_classes[9][14] = int_stack + 100700;
 Libint->vrr_classes[9][15] = int_stack + 107300;
 Libint->vrr_classes[9][16] = int_stack + 114780;
 Libint->vrr_classes[9][17] = int_stack + 123195;
 Libint->vrr_classes[10][9] = int_stack + 132600;
 Libint->vrr_classes[10][10] = int_stack + 136230;
 Libint->vrr_classes[10][11] = int_stack + 140586;
 Libint->vrr_classes[10][12] = int_stack + 145734;
 Libint->vrr_classes[10][13] = int_stack + 151740;
 Libint->vrr_classes[10][14] = int_stack + 158670;
 Libint->vrr_classes[10][15] = int_stack + 166590;
 Libint->vrr_classes[10][16] = int_stack + 175566;
 Libint->vrr_classes[10][17] = int_stack + 185664;
 Libint->vrr_classes[11][9] = int_stack + 196950;
 Libint->vrr_classes[11][10] = int_stack + 201240;
 Libint->vrr_classes[11][11] = int_stack + 206388;
 Libint->vrr_classes[11][12] = int_stack + 212472;
 Libint->vrr_classes[11][13] = int_stack + 219570;
 Libint->vrr_classes[11][14] = int_stack + 227760;
 Libint->vrr_classes[11][15] = int_stack + 237120;
 Libint->vrr_classes[11][16] = int_stack + 247728;
 Libint->vrr_classes[11][17] = int_stack + 259662;
 Libint->vrr_classes[12][9] = int_stack + 273000;
 Libint->vrr_classes[12][10] = int_stack + 278005;
 Libint->vrr_classes[12][11] = int_stack + 284011;
 Libint->vrr_classes[12][12] = int_stack + 291109;
 Libint->vrr_classes[12][13] = int_stack + 299390;
 Libint->vrr_classes[12][14] = int_stack + 308945;
 Libint->vrr_classes[12][15] = int_stack + 319865;
 Libint->vrr_classes[12][16] = int_stack + 332241;
 Libint->vrr_classes[12][17] = int_stack + 346164;
 Libint->vrr_classes[13][9] = int_stack + 361725;
 Libint->vrr_classes[13][10] = int_stack + 367500;
 Libint->vrr_classes[13][11] = int_stack + 374430;
 Libint->vrr_classes[13][12] = int_stack + 382620;
 Libint->vrr_classes[13][13] = int_stack + 392175;
 Libint->vrr_classes[13][14] = int_stack + 403200;
 Libint->vrr_classes[13][15] = int_stack + 415800;
 Libint->vrr_classes[13][16] = int_stack + 430080;
 Libint->vrr_classes[13][17] = int_stack + 446145;
 Libint->vrr_classes[14][9] = int_stack + 464100;
 Libint->vrr_classes[14][10] = int_stack + 470700;
 Libint->vrr_classes[14][11] = int_stack + 478620;
 Libint->vrr_classes[14][12] = int_stack + 487980;
 Libint->vrr_classes[14][13] = int_stack + 498900;
 Libint->vrr_classes[14][14] = int_stack + 511500;
 Libint->vrr_classes[14][15] = int_stack + 525900;
 Libint->vrr_classes[14][16] = int_stack + 542220;
 Libint->vrr_classes[14][17] = int_stack + 560580;
 memset(int_stack,0,581100*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 581100;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kkml(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+581100,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+587040,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+594168,int_stack+587040,int_stack+581100,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+606048,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+614472,int_stack+606048,int_stack+587040,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+628728,int_stack+614472,int_stack+594168,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+581100,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+648528,int_stack+581100,int_stack+606048,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+665376,int_stack+648528,int_stack+614472,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+590928,int_stack+665376,int_stack+628728,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+620628,int_stack+14220,int_stack+10440,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+689136,int_stack+620628,int_stack+581100,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+708792,int_stack+689136,int_stack+648528,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+736872,int_stack+708792,int_stack+665376,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+631968,int_stack+736872,int_stack+590928,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+581100,int_stack+18540,int_stack+14220,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+594060,int_stack+581100,int_stack+620628,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+772512,int_stack+594060,int_stack+689136,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+805272,int_stack+772512,int_stack+708792,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+673548,int_stack+805272,int_stack+736872,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+847392,int_stack+673548,int_stack+631968,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+616740,int_stack+23436,int_stack+18540,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+631428,int_stack+616740,int_stack+581100,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+723444,int_stack+631428,int_stack+594060,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+902832,int_stack+723444,int_stack+772512,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+951972,int_stack+902832,int_stack+805272,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+761244,int_stack+951972,int_stack+673548,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1010940,int_stack+761244,int_stack+847392,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+581100,int_stack+28944,int_stack+23436,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+657348,int_stack+581100,int_stack+616740,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+581100,int_stack+657348,int_stack+631428,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+624300,int_stack+581100,int_stack+723444,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+681000,int_stack+624300,int_stack+902832,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+581100,int_stack+681000,int_stack+951972,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+659724,int_stack+581100,int_stack+761244,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+745260,int_stack+659724,int_stack+1010940,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+581100,int_stack+37575,int_stack+35100,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+588525,int_stack+40545,int_stack+37575,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+597435,int_stack+588525,int_stack+581100,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+612285,int_stack+44055,int_stack+40545,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+622815,int_stack+612285,int_stack+588525,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+640635,int_stack+622815,int_stack+597435,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+581100,int_stack+48150,int_stack+44055,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+665385,int_stack+581100,int_stack+612285,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+686445,int_stack+665385,int_stack+622815,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+593385,int_stack+686445,int_stack+640635,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+630510,int_stack+52875,int_stack+48150,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+716145,int_stack+630510,int_stack+581100,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+834360,int_stack+716145,int_stack+665385,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+869460,int_stack+834360,int_stack+686445,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+644685,int_stack+869460,int_stack+593385,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+581100,int_stack+58275,int_stack+52875,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+597300,int_stack+581100,int_stack+630510,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+914010,int_stack+597300,int_stack+716145,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+954960,int_stack+914010,int_stack+834360,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1007610,int_stack+954960,int_stack+869460,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+834360,int_stack+1007610,int_stack+644685,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+625650,int_stack+64395,int_stack+58275,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+644010,int_stack+625650,int_stack+581100,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+676410,int_stack+644010,int_stack+597300,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+676410,int_stack+914010,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1069980,int_stack+0,int_stack+954960,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+903660,int_stack+1069980,int_stack+1007610,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1143690,int_stack+903660,int_stack+834360,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+834360,int_stack+71280,int_stack+64395,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+855015,int_stack+834360,int_stack+625650,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+581100,int_stack+855015,int_stack+644010,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+986820,int_stack+581100,int_stack+676410,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+581100,int_stack+986820,int_stack+0,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1232790,int_stack+581100,int_stack+1069980,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+581100,int_stack+1232790,int_stack+903660,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+834360,int_stack+581100,int_stack+1143690,45);
 /*--- compute (kp|ml) ---*/
 hrr1_build_kp(Libint->AB,int_stack+945735,int_stack+834360,int_stack+745260,2475);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+581100,int_stack+82000,int_stack+78975,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+590175,int_stack+85630,int_stack+82000,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+601065,int_stack+590175,int_stack+581100,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+619215,int_stack+89920,int_stack+85630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+632085,int_stack+619215,int_stack+590175,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+653865,int_stack+632085,int_stack+601065,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+581100,int_stack+94925,int_stack+89920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+684115,int_stack+581100,int_stack+619215,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+709855,int_stack+684115,int_stack+632085,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+596115,int_stack+709855,int_stack+653865,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+641490,int_stack+100700,int_stack+94925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+746155,int_stack+641490,int_stack+581100,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+776185,int_stack+746155,int_stack+684115,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+776185,int_stack+709855,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+658815,int_stack+0,int_stack+596115,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+581100,int_stack+107300,int_stack+100700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+600900,int_stack+581100,int_stack+641490,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+54450,int_stack+600900,int_stack+746155,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1213035,int_stack+54450,int_stack+776185,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+722340,int_stack+1213035,int_stack+0,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1277385,int_stack+722340,int_stack+658815,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+114780,int_stack+107300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+635550,int_stack+0,int_stack+581100,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1362085,int_stack+635550,int_stack+600900,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1419835,int_stack+1362085,int_stack+54450,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+22440,int_stack+1419835,int_stack+1213035,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1494910,int_stack+22440,int_stack+722340,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+675150,int_stack+1494910,int_stack+1277385,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1213035,int_stack+123195,int_stack+114780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1238280,int_stack+1213035,int_stack+0,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1283160,int_stack+1238280,int_stack+635550,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+581100,int_stack+1283160,int_stack+1362085,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1213035,int_stack+581100,int_stack+1419835,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1318140,int_stack+1213035,int_stack+22440,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1318140,int_stack+1494910,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1213035,int_stack+0,int_stack+675150,55);
 /*--- compute (lp|ml) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1349160,int_stack+1213035,int_stack+834360,2475);
 /*--- compute (kd|ml) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1683285,int_stack+1349160,int_stack+945735,2475);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+136230,int_stack+132600,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10890,int_stack+140586,int_stack+136230,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23958,int_stack+10890,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45738,int_stack+145734,int_stack+140586,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+61182,int_stack+45738,int_stack+10890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+87318,int_stack+61182,int_stack+23958,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+151740,int_stack+145734,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+581100,int_stack+0,int_stack+45738,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+611988,int_stack+581100,int_stack+61182,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+18018,int_stack+611988,int_stack+87318,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+72468,int_stack+158670,int_stack+151740,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+93258,int_stack+72468,int_stack+0,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+655548,int_stack+93258,int_stack+581100,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+707028,int_stack+655548,int_stack+611988,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+772368,int_stack+707028,int_stack+18018,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+581100,int_stack+166590,int_stack+158670,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+604860,int_stack+581100,int_stack+72468,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+604860,int_stack+93258,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+60060,int_stack+0,int_stack+655548,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+848598,int_stack+60060,int_stack+707028,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+646440,int_stack+848598,int_stack+772368,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+748080,int_stack+175566,int_stack+166590,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+775008,int_stack+748080,int_stack+581100,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+940074,int_stack+775008,int_stack+604860,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1009374,int_stack+940074,int_stack+0,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1099464,int_stack+1009374,int_stack+60060,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1099464,int_stack+848598,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2217885,int_stack+0,int_stack+646440,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+121968,int_stack+185664,int_stack+175566,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+581100,int_stack+121968,int_stack+748080,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+634956,int_stack+581100,int_stack+775008,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+714156,int_stack+634956,int_stack+940074,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+581100,int_stack+714156,int_stack+1009374,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+707226,int_stack+581100,int_stack+1099464,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+851370,int_stack+707226,int_stack+0,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+851370,int_stack+2217885,66);
 /*--- compute (mp|ml) ---*/
 hrr1_build_mp(Libint->AB,int_stack+581100,int_stack+0,int_stack+1213035,2475);
 /*--- compute (ld|ml) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2217885,int_stack+581100,int_stack+1349160,2475);
 /*--- compute (kf|ml) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2886135,int_stack+2217885,int_stack+1683285,2475);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+163350,int_stack+201240,int_stack+196950,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+176220,int_stack+206388,int_stack+201240,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+989475,int_stack+176220,int_stack+163350,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1015215,int_stack+212472,int_stack+206388,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1033467,int_stack+1015215,int_stack+176220,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+163350,int_stack+1033467,int_stack+989475,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+989475,int_stack+219570,int_stack+212472,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1064355,int_stack+989475,int_stack+1015215,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1100859,int_stack+1064355,int_stack+1033467,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1152339,int_stack+1100859,int_stack+163350,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+163350,int_stack+227760,int_stack+219570,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1010769,int_stack+163350,int_stack+989475,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1216689,int_stack+1010769,int_stack+1064355,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1277529,int_stack+1216689,int_stack+1100859,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1053357,int_stack+1277529,int_stack+1152339,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+187920,int_stack+237120,int_stack+227760,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1143447,int_stack+187920,int_stack+163350,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1354749,int_stack+1143447,int_stack+1010769,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1425729,int_stack+1354749,int_stack+1216689,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1516989,int_stack+1425729,int_stack+1277529,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1192587,int_stack+1516989,int_stack+1053357,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+989475,int_stack+247728,int_stack+237120,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1021299,int_stack+989475,int_stack+187920,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+163350,int_stack+1021299,int_stack+1143447,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1077459,int_stack+163350,int_stack+1354749,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1625097,int_stack+1077459,int_stack+1425729,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1312707,int_stack+1625097,int_stack+1516989,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1456851,int_stack+1312707,int_stack+1192587,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1183929,int_stack+259662,int_stack+247728,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1219731,int_stack+1183929,int_stack+989475,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1752861,int_stack+1219731,int_stack+1021299,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1183929,int_stack+1752861,int_stack+163350,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1752861,int_stack+1183929,int_stack+1077459,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1901919,int_stack+1752861,int_stack+1625097,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+989475,int_stack+1901919,int_stack+1312707,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1174803,int_stack+989475,int_stack+1456851,78);
 /*--- compute (np|ml) ---*/
 hrr1_build_np(Libint->AB,int_stack+1367853,int_stack+1174803,int_stack+0,2475);
 /*--- compute (md|ml) ---*/
 hrr1_build_md(Libint->AB,int_stack+3777135,int_stack+1367853,int_stack+581100,2475);
 /*--- compute (lf|ml) ---*/
 hrr1_build_lf(Libint->AB,int_stack+4593885,int_stack+3777135,int_stack+2217885,2475);
 /*--- compute (kg|ml) ---*/
 hrr1_build_kg(Libint->AB,int_stack+5707635,int_stack+4593885,int_stack+2886135,2475);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+581100,int_stack+278005,int_stack+273000,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+596115,int_stack+284011,int_stack+278005,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+614133,int_stack+596115,int_stack+581100,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+644163,int_stack+291109,int_stack+284011,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+665457,int_stack+644163,int_stack+596115,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+701493,int_stack+665457,int_stack+614133,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+581100,int_stack+299390,int_stack+291109,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+751543,int_stack+581100,int_stack+644163,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+794131,int_stack+751543,int_stack+665457,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+605943,int_stack+794131,int_stack+701493,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+681018,int_stack+308945,int_stack+299390,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+854191,int_stack+681018,int_stack+581100,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+903877,int_stack+854191,int_stack+751543,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+974857,int_stack+903877,int_stack+794131,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+709683,int_stack+974857,int_stack+605943,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+581100,int_stack+319865,int_stack+308945,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+613860,int_stack+581100,int_stack+681018,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1064947,int_stack+613860,int_stack+854191,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+1064947,int_stack+903877,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+814788,int_stack+0,int_stack+974857,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+106470,int_stack+814788,int_stack+709683,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+671190,int_stack+332241,int_stack+319865,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+708318,int_stack+671190,int_stack+581100,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+940914,int_stack+708318,int_stack+613860,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1857903,int_stack+940914,int_stack+1064947,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1982118,int_stack+1857903,int_stack+0,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2131176,int_stack+1982118,int_stack+814788,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2299344,int_stack+2131176,int_stack+106470,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+346164,int_stack+332241,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+41769,int_stack+0,int_stack+671190,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+116025,int_stack+41769,int_stack+708318,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+581100,int_stack+116025,int_stack+940914,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+581100,int_stack+1857903,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+581100,int_stack+0,int_stack+1982118,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+581100,int_stack+2131176,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+581100,int_stack+0,int_stack+2299344,91);
 /*--- compute (op|ml) ---*/
 hrr1_build_op(Libint->AB,int_stack+1857903,int_stack+581100,int_stack+1174803,2475);
 /*--- compute (nd|ml) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2437053,int_stack+1857903,int_stack+1367853,2475);
 /*--- compute (mf|ml) ---*/
 hrr1_build_mf(Libint->AB,int_stack+7044135,int_stack+2437053,int_stack+3777135,2475);
 /*--- compute (lg|ml) ---*/
 hrr1_build_lg(Libint->AB,int_stack+8405385,int_stack+7044135,int_stack+4593885,2475);
 /*--- compute (kh|ml) ---*/
 hrr1_build_kh(Libint->AB,int_stack+3417153,int_stack+8405385,int_stack+5707635,2475);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+367500,int_stack+361725,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17325,int_stack+374430,int_stack+367500,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+38115,int_stack+17325,int_stack+0,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+72765,int_stack+382620,int_stack+374430,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+97335,int_stack+72765,int_stack+17325,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+138915,int_stack+97335,int_stack+38115,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+392175,int_stack+382620,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+196665,int_stack+0,int_stack+72765,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+245805,int_stack+196665,int_stack+97335,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+28665,int_stack+245805,int_stack+138915,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+115290,int_stack+403200,int_stack+392175,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+315105,int_stack+115290,int_stack+0,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+806325,int_stack+315105,int_stack+196665,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+888225,int_stack+806325,int_stack+245805,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+148365,int_stack+888225,int_stack+28665,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+415800,int_stack+403200,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+37800,int_stack+0,int_stack+115290,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+992175,int_stack+37800,int_stack+315105,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+269640,int_stack+992175,int_stack+806325,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1087725,int_stack+269640,int_stack+888225,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+806325,int_stack+1087725,int_stack+148365,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+103950,int_stack+430080,int_stack+415800,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+146790,int_stack+103950,int_stack+0,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1233255,int_stack+146790,int_stack+37800,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1343505,int_stack+1233255,int_stack+992175,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1486830,int_stack+1343505,int_stack+269640,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+222390,int_stack+1486830,int_stack+1087725,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+968025,int_stack+222390,int_stack+806325,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+806325,int_stack+446145,int_stack+430080,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+854520,int_stack+806325,int_stack+103950,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+854520,int_stack+146790,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1658820,int_stack+0,int_stack+1233255,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+1658820,int_stack+1343505,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1175925,int_stack+0,int_stack+1486830,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1405245,int_stack+1175925,int_stack+222390,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+1405245,int_stack+968025,105);
 /*--- compute (qp|ml) ---*/
 hrr1_build_qp(Libint->AB,int_stack+806325,int_stack+0,int_stack+581100,2475);
 /*--- compute (od|ml) ---*/
 hrr1_build_od(Libint->AB,int_stack+5288253,int_stack+806325,int_stack+1857903,2475);
 /*--- compute (nf|ml) ---*/
 hrr1_build_nf(Libint->AB,int_stack+10076010,int_stack+5288253,int_stack+2437053,2475);
 /*--- compute (mg|ml) ---*/
 hrr1_build_mg(Libint->AB,int_stack+11709510,int_stack+10076010,int_stack+7044135,2475);
 /*--- compute (lh|ml) ---*/
 hrr1_build_lh(Libint->AB,int_stack+13751385,int_stack+11709510,int_stack+8405385,2475);
 /*--- compute (ki|ml) ---*/
 hrr1_build_ki(Libint->AB,int_stack+6446553,int_stack+13751385,int_stack+3417153,2475);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+581100,int_stack+470700,int_stack+464100,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+600900,int_stack+478620,int_stack+470700,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+624660,int_stack+600900,int_stack+581100,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+664260,int_stack+487980,int_stack+478620,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+692340,int_stack+664260,int_stack+600900,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+739860,int_stack+692340,int_stack+624660,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+581100,int_stack+498900,int_stack+487980,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+259875,int_stack+581100,int_stack+664260,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+316035,int_stack+259875,int_stack+692340,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+613860,int_stack+316035,int_stack+739860,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+712860,int_stack+511500,int_stack+498900,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+395235,int_stack+712860,int_stack+581100,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1482000,int_stack+395235,int_stack+259875,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1575600,int_stack+1482000,int_stack+316035,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1694400,int_stack+1575600,int_stack+613860,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+259875,int_stack+525900,int_stack+511500,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+303075,int_stack+259875,int_stack+712860,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+581100,int_stack+303075,int_stack+395235,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+378675,int_stack+581100,int_stack+1482000,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1833000,int_stack+378675,int_stack+1575600,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1482000,int_stack+1833000,int_stack+1694400,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1666800,int_stack+542220,int_stack+525900,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1715760,int_stack+1666800,int_stack+259875,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1999320,int_stack+1715760,int_stack+303075,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2125320,int_stack+1999320,int_stack+581100,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+581100,int_stack+2125320,int_stack+378675,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+259875,int_stack+581100,int_stack+1833000,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2289120,int_stack+259875,int_stack+1482000,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1482000,int_stack+560580,int_stack+542220,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1537080,int_stack+1482000,int_stack+1666800,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1802160,int_stack+1537080,int_stack+1715760,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1482000,int_stack+1802160,int_stack+1999320,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1671000,int_stack+1482000,int_stack+2125320,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1900320,int_stack+1671000,int_stack+581100,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1482000,int_stack+1900320,int_stack+259875,120);
 /*--- compute (t0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+259875,int_stack+1482000,int_stack+2289120,120);
 /*--- compute (rp|ml) ---*/
 hrr1_build_rp(Libint->AB,int_stack+1482000,int_stack+259875,int_stack+0,2475);
 /*--- compute (qd|ml) ---*/
 hrr1_build_qd(Libint->AB,int_stack+2261625,int_stack+1482000,int_stack+806325,2475);
 /*--- compute (of|ml) ---*/
 hrr1_build_of(Libint->AB,int_stack+0,int_stack+2261625,int_stack+5288253,2475);
 /*--- compute (ng|ml) ---*/
 hrr1_build_ng(Libint->AB,int_stack+1930500,int_stack+0,int_stack+10076010,2475);
 /*--- compute (mh|ml) ---*/
 hrr1_build_mh(Libint->AB,int_stack+16090260,int_stack+1930500,int_stack+11709510,2475);
 /*--- compute (li|ml) ---*/
 hrr1_build_li(Libint->AB,int_stack+0,int_stack+16090260,int_stack+13751385,2475);
 /*--- compute (kk|ml) ---*/
 hrr1_build_kk(Libint->AB,int_stack+3118500,int_stack+0,int_stack+6446553,2475);
 return int_stack+3118500;}
