/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kkmm(Libint_t*, prim_data*);

  /* Computes quartets of (kk|mm) integrals */

REALTYPE *hrr_order_kkmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[7][14] = int_stack + 14220;
 Libint->vrr_classes[7][15] = int_stack + 18540;
 Libint->vrr_classes[7][16] = int_stack + 23436;
 Libint->vrr_classes[7][17] = int_stack + 28944;
 Libint->vrr_classes[7][18] = int_stack + 35100;
 Libint->vrr_classes[8][9] = int_stack + 41940;
 Libint->vrr_classes[8][10] = int_stack + 44415;
 Libint->vrr_classes[8][11] = int_stack + 47385;
 Libint->vrr_classes[8][12] = int_stack + 50895;
 Libint->vrr_classes[8][13] = int_stack + 54990;
 Libint->vrr_classes[8][14] = int_stack + 59715;
 Libint->vrr_classes[8][15] = int_stack + 65115;
 Libint->vrr_classes[8][16] = int_stack + 71235;
 Libint->vrr_classes[8][17] = int_stack + 78120;
 Libint->vrr_classes[8][18] = int_stack + 85815;
 Libint->vrr_classes[9][9] = int_stack + 94365;
 Libint->vrr_classes[9][10] = int_stack + 97390;
 Libint->vrr_classes[9][11] = int_stack + 101020;
 Libint->vrr_classes[9][12] = int_stack + 105310;
 Libint->vrr_classes[9][13] = int_stack + 110315;
 Libint->vrr_classes[9][14] = int_stack + 116090;
 Libint->vrr_classes[9][15] = int_stack + 122690;
 Libint->vrr_classes[9][16] = int_stack + 130170;
 Libint->vrr_classes[9][17] = int_stack + 138585;
 Libint->vrr_classes[9][18] = int_stack + 147990;
 Libint->vrr_classes[10][9] = int_stack + 158440;
 Libint->vrr_classes[10][10] = int_stack + 162070;
 Libint->vrr_classes[10][11] = int_stack + 166426;
 Libint->vrr_classes[10][12] = int_stack + 171574;
 Libint->vrr_classes[10][13] = int_stack + 177580;
 Libint->vrr_classes[10][14] = int_stack + 184510;
 Libint->vrr_classes[10][15] = int_stack + 192430;
 Libint->vrr_classes[10][16] = int_stack + 201406;
 Libint->vrr_classes[10][17] = int_stack + 211504;
 Libint->vrr_classes[10][18] = int_stack + 222790;
 Libint->vrr_classes[11][9] = int_stack + 235330;
 Libint->vrr_classes[11][10] = int_stack + 239620;
 Libint->vrr_classes[11][11] = int_stack + 244768;
 Libint->vrr_classes[11][12] = int_stack + 250852;
 Libint->vrr_classes[11][13] = int_stack + 257950;
 Libint->vrr_classes[11][14] = int_stack + 266140;
 Libint->vrr_classes[11][15] = int_stack + 275500;
 Libint->vrr_classes[11][16] = int_stack + 286108;
 Libint->vrr_classes[11][17] = int_stack + 298042;
 Libint->vrr_classes[11][18] = int_stack + 311380;
 Libint->vrr_classes[12][9] = int_stack + 326200;
 Libint->vrr_classes[12][10] = int_stack + 331205;
 Libint->vrr_classes[12][11] = int_stack + 337211;
 Libint->vrr_classes[12][12] = int_stack + 344309;
 Libint->vrr_classes[12][13] = int_stack + 352590;
 Libint->vrr_classes[12][14] = int_stack + 362145;
 Libint->vrr_classes[12][15] = int_stack + 373065;
 Libint->vrr_classes[12][16] = int_stack + 385441;
 Libint->vrr_classes[12][17] = int_stack + 399364;
 Libint->vrr_classes[12][18] = int_stack + 414925;
 Libint->vrr_classes[13][9] = int_stack + 432215;
 Libint->vrr_classes[13][10] = int_stack + 437990;
 Libint->vrr_classes[13][11] = int_stack + 444920;
 Libint->vrr_classes[13][12] = int_stack + 453110;
 Libint->vrr_classes[13][13] = int_stack + 462665;
 Libint->vrr_classes[13][14] = int_stack + 473690;
 Libint->vrr_classes[13][15] = int_stack + 486290;
 Libint->vrr_classes[13][16] = int_stack + 500570;
 Libint->vrr_classes[13][17] = int_stack + 516635;
 Libint->vrr_classes[13][18] = int_stack + 534590;
 Libint->vrr_classes[14][9] = int_stack + 554540;
 Libint->vrr_classes[14][10] = int_stack + 561140;
 Libint->vrr_classes[14][11] = int_stack + 569060;
 Libint->vrr_classes[14][12] = int_stack + 578420;
 Libint->vrr_classes[14][13] = int_stack + 589340;
 Libint->vrr_classes[14][14] = int_stack + 601940;
 Libint->vrr_classes[14][15] = int_stack + 616340;
 Libint->vrr_classes[14][16] = int_stack + 632660;
 Libint->vrr_classes[14][17] = int_stack + 651020;
 Libint->vrr_classes[14][18] = int_stack + 671540;
 memset(int_stack,0,694340*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 694340;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kkmm(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+694340,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+700280,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+707408,int_stack+700280,int_stack+694340,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+719288,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+727712,int_stack+719288,int_stack+700280,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+741968,int_stack+727712,int_stack+707408,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+694340,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+761768,int_stack+694340,int_stack+719288,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+778616,int_stack+761768,int_stack+727712,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+704168,int_stack+778616,int_stack+741968,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+733868,int_stack+14220,int_stack+10440,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+802376,int_stack+733868,int_stack+694340,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+822032,int_stack+802376,int_stack+761768,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+850112,int_stack+822032,int_stack+778616,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+745208,int_stack+850112,int_stack+704168,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+694340,int_stack+18540,int_stack+14220,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+707300,int_stack+694340,int_stack+733868,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+885752,int_stack+707300,int_stack+802376,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+918512,int_stack+885752,int_stack+822032,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+786788,int_stack+918512,int_stack+850112,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+960632,int_stack+786788,int_stack+745208,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+729980,int_stack+23436,int_stack+18540,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+744668,int_stack+729980,int_stack+694340,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+836684,int_stack+744668,int_stack+707300,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1016072,int_stack+836684,int_stack+885752,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1065212,int_stack+1016072,int_stack+918512,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+874484,int_stack+1065212,int_stack+786788,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1124180,int_stack+874484,int_stack+960632,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+694340,int_stack+28944,int_stack+23436,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+770588,int_stack+694340,int_stack+729980,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+941012,int_stack+770588,int_stack+744668,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+710864,int_stack+941012,int_stack+836684,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+799964,int_stack+710864,int_stack+1016072,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+984212,int_stack+799964,int_stack+1065212,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1195460,int_stack+984212,int_stack+874484,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1280996,int_stack+1195460,int_stack+1124180,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+868760,int_stack+35100,int_stack+28944,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+887228,int_stack+868760,int_stack+694340,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1062836,int_stack+887228,int_stack+770588,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+868760,int_stack+1062836,int_stack+941012,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1062836,int_stack+868760,int_stack+710864,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+868760,int_stack+1062836,int_stack+799964,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1062836,int_stack+868760,int_stack+984212,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+694340,int_stack+1062836,int_stack+1195460,36);
 /*--- compute (k0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+801260,int_stack+694340,int_stack+1280996,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+694340,int_stack+44415,int_stack+41940,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+701765,int_stack+47385,int_stack+44415,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+710675,int_stack+701765,int_stack+694340,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+725525,int_stack+50895,int_stack+47385,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+736055,int_stack+725525,int_stack+701765,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+753875,int_stack+736055,int_stack+710675,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+694340,int_stack+54990,int_stack+50895,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+778625,int_stack+694340,int_stack+725525,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+910160,int_stack+778625,int_stack+736055,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+706625,int_stack+910160,int_stack+753875,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+743750,int_stack+59715,int_stack+54990,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+939860,int_stack+743750,int_stack+694340,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+964430,int_stack+939860,int_stack+778625,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+999530,int_stack+964430,int_stack+910160,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1044080,int_stack+999530,int_stack+706625,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+910160,int_stack+65115,int_stack+59715,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+694340,int_stack+910160,int_stack+743750,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+722690,int_stack+694340,int_stack+939860,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1096055,int_stack+722690,int_stack+964430,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+926360,int_stack+1096055,int_stack+999530,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1148705,int_stack+926360,int_stack+1044080,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+988730,int_stack+71235,int_stack+65115,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1007090,int_stack+988730,int_stack+910160,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1039490,int_stack+1007090,int_stack+694340,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1218005,int_stack+1039490,int_stack+722690,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+694340,int_stack+1218005,int_stack+1096055,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1279430,int_stack+694340,int_stack+926360,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1362590,int_stack+1279430,int_stack+1148705,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+768050,int_stack+78120,int_stack+71235,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+910160,int_stack+768050,int_stack+988730,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+946880,int_stack+910160,int_stack+1007090,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1086740,int_stack+946880,int_stack+1039490,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1451690,int_stack+1086740,int_stack+1218005,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1157615,int_stack+1451690,int_stack+694340,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1537685,int_stack+1157615,int_stack+1279430,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1644605,int_stack+1537685,int_stack+1362590,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+694340,int_stack+85815,int_stack+78120,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+717425,int_stack+694340,int_stack+768050,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1000880,int_stack+717425,int_stack+910160,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+694340,int_stack+1000880,int_stack+946880,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+910160,int_stack+694340,int_stack+1086740,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1009385,int_stack+910160,int_stack+1451690,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1255895,int_stack+1009385,int_stack+1157615,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+910160,int_stack+1255895,int_stack+1537685,45);
 /*--- compute (l0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1043810,int_stack+910160,int_stack+1644605,45);
 /*--- compute (kp|mm) ---*/
 hrr1_build_kp(Libint->AB,int_stack+1179935,int_stack+1043810,int_stack+801260,3025);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1506635,int_stack+97390,int_stack+94365,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1515710,int_stack+101020,int_stack+97390,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1526600,int_stack+1515710,int_stack+1506635,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1544750,int_stack+105310,int_stack+101020,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1557620,int_stack+1544750,int_stack+1515710,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1579400,int_stack+1557620,int_stack+1526600,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1506635,int_stack+110315,int_stack+105310,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1609650,int_stack+1506635,int_stack+1544750,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1635390,int_stack+1609650,int_stack+1557620,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1521650,int_stack+1635390,int_stack+1579400,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1567025,int_stack+116090,int_stack+110315,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1671690,int_stack+1567025,int_stack+1506635,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1701720,int_stack+1671690,int_stack+1609650,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+694340,int_stack+1701720,int_stack+1635390,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1584350,int_stack+694340,int_stack+1521650,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1506635,int_stack+122690,int_stack+116090,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1526435,int_stack+1506635,int_stack+1567025,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+748790,int_stack+1526435,int_stack+1671690,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+798840,int_stack+748790,int_stack+1701720,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1647875,int_stack+798840,int_stack+694340,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+863190,int_stack+1647875,int_stack+1584350,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+694340,int_stack+130170,int_stack+122690,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1561085,int_stack+694340,int_stack+1506635,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+947890,int_stack+1561085,int_stack+1526435,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+947890,int_stack+748790,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1724105,int_stack+0,int_stack+798840,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+716780,int_stack+1724105,int_stack+1647875,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1600685,int_stack+716780,int_stack+863190,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1506635,int_stack+138585,int_stack+130170,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+818420,int_stack+1506635,int_stack+694340,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+863300,int_stack+818420,int_stack+1561085,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1814195,int_stack+863300,int_stack+947890,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+929300,int_stack+1814195,int_stack+0,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+929300,int_stack+1724105,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1900820,int_stack+0,int_stack+716780,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2031500,int_stack+1900820,int_stack+1600685,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+694340,int_stack+147990,int_stack+138585,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+722555,int_stack+694340,int_stack+1506635,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1506635,int_stack+722555,int_stack+818420,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1581435,int_stack+1506635,int_stack+863300,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1680435,int_stack+1581435,int_stack+1814195,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1506635,int_stack+1680435,int_stack+929300,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1646775,int_stack+1506635,int_stack+0,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+694340,int_stack+1646775,int_stack+1900820,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1506635,int_stack+694340,int_stack+2031500,55);
 /*--- compute (lp|mm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1673010,int_stack+1506635,int_stack+1043810,3025);
 /*--- compute (kd|mm) ---*/
 hrr1_build_kd(Libint->AB,int_stack+2081385,int_stack+1673010,int_stack+1179935,3025);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+694340,int_stack+162070,int_stack+158440,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+705230,int_stack+166426,int_stack+162070,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+718298,int_stack+705230,int_stack+694340,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+740078,int_stack+171574,int_stack+166426,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+755522,int_stack+740078,int_stack+705230,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+781658,int_stack+755522,int_stack+718298,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+694340,int_stack+177580,int_stack+171574,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+817958,int_stack+694340,int_stack+740078,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+848846,int_stack+817958,int_stack+755522,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+712358,int_stack+848846,int_stack+781658,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+766808,int_stack+184510,int_stack+177580,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+892406,int_stack+766808,int_stack+694340,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+928442,int_stack+892406,int_stack+817958,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+979922,int_stack+928442,int_stack+848846,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+787598,int_stack+979922,int_stack+712358,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+694340,int_stack+192430,int_stack+184510,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+718100,int_stack+694340,int_stack+766808,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1045262,int_stack+718100,int_stack+892406,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1105322,int_stack+1045262,int_stack+928442,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+863828,int_stack+1105322,int_stack+979922,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1182542,int_stack+863828,int_stack+787598,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+759680,int_stack+201406,int_stack+192430,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+786608,int_stack+759680,int_stack+694340,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+955304,int_stack+786608,int_stack+718100,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1284182,int_stack+955304,int_stack+1045262,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1374272,int_stack+1284182,int_stack+1105322,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1024604,int_stack+1374272,int_stack+863828,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+1024604,int_stack+1182542,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+694340,int_stack+211504,int_stack+201406,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+834128,int_stack+694340,int_stack+759680,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1146572,int_stack+834128,int_stack+786608,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+724634,int_stack+1146572,int_stack+955304,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+887984,int_stack+724634,int_stack+1284182,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1225772,int_stack+887984,int_stack+1374272,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2734785,int_stack+1225772,int_stack+1024604,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2891601,int_stack+2734785,int_stack+0,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+222790,int_stack+211504,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+33858,int_stack+0,int_stack+694340,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+94446,int_stack+33858,int_stack+834128,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1014110,int_stack+94446,int_stack+1146572,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+1014110,int_stack+724634,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1014110,int_stack+0,int_stack+887984,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+1014110,int_stack+1225772,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+694340,int_stack+0,int_stack+2734785,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+0,int_stack+694340,int_stack+2891601,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+694340,int_stack+0,int_stack+1506635,3025);
 /*--- compute (ld|mm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2734785,int_stack+694340,int_stack+1673010,3025);
 /*--- compute (kf|mm) ---*/
 hrr1_build_kf(Libint->AB,int_stack+3551535,int_stack+2734785,int_stack+2081385,3025);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1193465,int_stack+239620,int_stack+235330,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1206335,int_stack+244768,int_stack+239620,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1221779,int_stack+1206335,int_stack+1193465,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1247519,int_stack+250852,int_stack+244768,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1265771,int_stack+1247519,int_stack+1206335,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1296659,int_stack+1265771,int_stack+1221779,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1193465,int_stack+257950,int_stack+250852,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1339559,int_stack+1193465,int_stack+1247519,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1376063,int_stack+1339559,int_stack+1265771,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1214759,int_stack+1376063,int_stack+1296659,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1279109,int_stack+266140,int_stack+257950,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1427543,int_stack+1279109,int_stack+1193465,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1470131,int_stack+1427543,int_stack+1339559,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1530971,int_stack+1470131,int_stack+1376063,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1303679,int_stack+1530971,int_stack+1214759,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1193465,int_stack+275500,int_stack+266140,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1221545,int_stack+1193465,int_stack+1279109,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1608191,int_stack+1221545,int_stack+1427543,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1679171,int_stack+1608191,int_stack+1470131,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1393769,int_stack+1679171,int_stack+1530971,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1770431,int_stack+1393769,int_stack+1303679,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1270685,int_stack+286108,int_stack+275500,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1302509,int_stack+1270685,int_stack+1193465,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1501877,int_stack+1302509,int_stack+1221545,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1890551,int_stack+1501877,int_stack+1608191,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1997021,int_stack+1890551,int_stack+1679171,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1583777,int_stack+1997021,int_stack+1393769,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2124785,int_stack+1583777,int_stack+1770431,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1193465,int_stack+298042,int_stack+286108,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1358669,int_stack+1193465,int_stack+1270685,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1727921,int_stack+1358669,int_stack+1302509,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1229267,int_stack+1727921,int_stack+1501877,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1422317,int_stack+1229267,int_stack+1890551,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1821521,int_stack+1422317,int_stack+1997021,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2279225,int_stack+1821521,int_stack+1583777,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2464553,int_stack+2279225,int_stack+2124785,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1571375,int_stack+311380,int_stack+298042,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1611389,int_stack+1571375,int_stack+1193465,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1991873,int_stack+1611389,int_stack+1358669,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1571375,int_stack+1991873,int_stack+1727921,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1991873,int_stack+1571375,int_stack+1229267,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1571375,int_stack+1991873,int_stack+1422317,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1991873,int_stack+1571375,int_stack+1821521,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1193465,int_stack+1991873,int_stack+2279225,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1425125,int_stack+1193465,int_stack+2464553,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+1661075,int_stack+1425125,int_stack+0,3025);
 /*--- compute (md|mm) ---*/
 hrr1_build_md(Libint->AB,int_stack+4640535,int_stack+1661075,int_stack+694340,3025);
 /*--- compute (lf|mm) ---*/
 hrr1_build_lf(Libint->AB,int_stack+5638785,int_stack+4640535,int_stack+2734785,3025);
 /*--- compute (kg|mm) ---*/
 hrr1_build_kg(Libint->AB,int_stack+7000035,int_stack+5638785,int_stack+3551535,3025);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+694340,int_stack+331205,int_stack+326200,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+709355,int_stack+337211,int_stack+331205,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+727373,int_stack+709355,int_stack+694340,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+757403,int_stack+344309,int_stack+337211,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+778697,int_stack+757403,int_stack+709355,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+814733,int_stack+778697,int_stack+727373,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+694340,int_stack+352590,int_stack+344309,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+864783,int_stack+694340,int_stack+757403,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+907371,int_stack+864783,int_stack+778697,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+719183,int_stack+907371,int_stack+814733,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+794258,int_stack+362145,int_stack+352590,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+967431,int_stack+794258,int_stack+694340,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1017117,int_stack+967431,int_stack+864783,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1088097,int_stack+1017117,int_stack+907371,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+822923,int_stack+1088097,int_stack+719183,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+694340,int_stack+373065,int_stack+362145,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+727100,int_stack+694340,int_stack+794258,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1178187,int_stack+727100,int_stack+967431,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1260997,int_stack+1178187,int_stack+1017117,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+928028,int_stack+1260997,int_stack+1088097,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+928028,int_stack+822923,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+784430,int_stack+385441,int_stack+373065,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+821558,int_stack+784430,int_stack+694340,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1054154,int_stack+821558,int_stack+727100,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+140140,int_stack+1054154,int_stack+1178187,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2260025,int_stack+140140,int_stack+1260997,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1149704,int_stack+2260025,int_stack+928028,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2409083,int_stack+1149704,int_stack+0,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+399364,int_stack+385441,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+41769,int_stack+0,int_stack+784430,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+694340,int_stack+41769,int_stack+821558,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+803540,int_stack+694340,int_stack+1054154,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+946865,int_stack+803540,int_stack+140140,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+116025,int_stack+946865,int_stack+2260025,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2589263,int_stack+116025,int_stack+1149704,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1120766,int_stack+2589263,int_stack+2409083,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2260025,int_stack+414925,int_stack+399364,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2306708,int_stack+2260025,int_stack+0,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2390246,int_stack+2306708,int_stack+41769,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2805479,int_stack+2390246,int_stack+694340,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2260025,int_stack+2805479,int_stack+803540,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2805479,int_stack+2260025,int_stack+946865,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2260025,int_stack+2805479,int_stack+116025,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2805479,int_stack+2260025,int_stack+2589263,91);
 /*--- compute (q0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+2260025,int_stack+2805479,int_stack+1120766,91);
 /*--- compute (op|mm) ---*/
 hrr1_build_op(Libint->AB,int_stack+2535300,int_stack+2260025,int_stack+1425125,3025);
 /*--- compute (nd|mm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3243150,int_stack+2535300,int_stack+1661075,3025);
 /*--- compute (mf|mm) ---*/
 hrr1_build_mf(Libint->AB,int_stack+8633535,int_stack+3243150,int_stack+4640535,3025);
 /*--- compute (lg|mm) ---*/
 hrr1_build_lg(Libint->AB,int_stack+10297285,int_stack+8633535,int_stack+5638785,3025);
 /*--- compute (kh|mm) ---*/
 hrr1_build_kh(Libint->AB,int_stack+4441050,int_stack+10297285,int_stack+7000035,3025);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+6727950,int_stack+437990,int_stack+432215,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+6745275,int_stack+444920,int_stack+437990,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+6766065,int_stack+6745275,int_stack+6727950,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+6800715,int_stack+453110,int_stack+444920,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+6825285,int_stack+6800715,int_stack+6745275,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+6866865,int_stack+6825285,int_stack+6766065,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+6727950,int_stack+462665,int_stack+453110,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+6924615,int_stack+6727950,int_stack+6800715,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+6973755,int_stack+6924615,int_stack+6825285,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+6756615,int_stack+6973755,int_stack+6866865,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+6843240,int_stack+473690,int_stack+462665,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+7043055,int_stack+6843240,int_stack+6727950,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+7100385,int_stack+7043055,int_stack+6924615,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+7182285,int_stack+7100385,int_stack+6973755,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+6876315,int_stack+7182285,int_stack+6756615,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+6727950,int_stack+486290,int_stack+473690,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+6765750,int_stack+6727950,int_stack+6843240,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+7286235,int_stack+6765750,int_stack+7043055,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+7381785,int_stack+7286235,int_stack+7100385,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+6997590,int_stack+7381785,int_stack+7182285,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+7504635,int_stack+6997590,int_stack+6876315,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+6831900,int_stack+500570,int_stack+486290,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+6874740,int_stack+6831900,int_stack+6727950,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+7143120,int_stack+6874740,int_stack+6765750,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+7666335,int_stack+7143120,int_stack+7286235,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+7809660,int_stack+7666335,int_stack+7381785,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+7253370,int_stack+7809660,int_stack+6997590,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+7981650,int_stack+7253370,int_stack+7504635,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+6727950,int_stack+516635,int_stack+500570,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+6950340,int_stack+6727950,int_stack+6831900,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+7447410,int_stack+6950340,int_stack+6874740,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+6776145,int_stack+7447410,int_stack+7143120,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+7036020,int_stack+6776145,int_stack+7666335,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+7573410,int_stack+7036020,int_stack+7809660,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+8189550,int_stack+7573410,int_stack+7253370,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+694340,int_stack+8189550,int_stack+7981650,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+7236675,int_stack+534590,int_stack+516635,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+7290540,int_stack+7236675,int_stack+6727950,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+7802730,int_stack+7290540,int_stack+6950340,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+7236675,int_stack+7802730,int_stack+7447410,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+7802730,int_stack+7236675,int_stack+6776145,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+7236675,int_stack+7802730,int_stack+7036020,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+7802730,int_stack+7236675,int_stack+7573410,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+6727950,int_stack+7802730,int_stack+8189550,105);
 /*--- compute (r0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+7039800,int_stack+6727950,int_stack+694340,105);
 /*--- compute (qp|mm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+694340,int_stack+7039800,int_stack+2260025,3025);
 /*--- compute (od|mm) ---*/
 hrr1_build_od(Libint->AB,int_stack+12339160,int_stack+694340,int_stack+2535300,3025);
 /*--- compute (nf|mm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+13754860,int_stack+12339160,int_stack+3243150,3025);
 /*--- compute (mg|mm) ---*/
 hrr1_build_mg(Libint->AB,int_stack+1520165,int_stack+13754860,int_stack+8633535,3025);
 /*--- compute (lh|mm) ---*/
 hrr1_build_lh(Libint->AB,int_stack+7357425,int_stack+1520165,int_stack+10297285,3025);
 /*--- compute (ki|mm) ---*/
 hrr1_build_ki(Libint->AB,int_stack+15751360,int_stack+7357425,int_stack+4441050,3025);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+4015790,int_stack+561140,int_stack+554540,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4035590,int_stack+569060,int_stack+561140,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+4059350,int_stack+4035590,int_stack+4015790,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+4098950,int_stack+578420,int_stack+569060,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+4127030,int_stack+4098950,int_stack+4035590,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+4174550,int_stack+4127030,int_stack+4059350,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+4015790,int_stack+589340,int_stack+578420,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+4240550,int_stack+4015790,int_stack+4098950,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+4296710,int_stack+4240550,int_stack+4127030,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+4048550,int_stack+4296710,int_stack+4174550,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+4147550,int_stack+601940,int_stack+589340,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+4375910,int_stack+4147550,int_stack+4015790,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+4441430,int_stack+4375910,int_stack+4240550,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+4535030,int_stack+4441430,int_stack+4296710,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+4185350,int_stack+4535030,int_stack+4048550,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+4015790,int_stack+616340,int_stack+601940,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+4058990,int_stack+4015790,int_stack+4147550,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+4653830,int_stack+4058990,int_stack+4375910,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+4763030,int_stack+4653830,int_stack+4441430,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+4323950,int_stack+4763030,int_stack+4535030,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+4903430,int_stack+4323950,int_stack+4185350,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+4134590,int_stack+632660,int_stack+616340,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+4183550,int_stack+4134590,int_stack+4015790,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4490270,int_stack+4183550,int_stack+4058990,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+5088230,int_stack+4490270,int_stack+4653830,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+5252030,int_stack+5088230,int_stack+4763030,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4616270,int_stack+5252030,int_stack+4323950,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+5448590,int_stack+4616270,int_stack+4903430,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+4015790,int_stack+651020,int_stack+632660,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+4269950,int_stack+4015790,int_stack+4134590,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+4838030,int_stack+4269950,int_stack+4183550,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4070870,int_stack+4838030,int_stack+4490270,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+4367870,int_stack+4070870,int_stack+5088230,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4982030,int_stack+4367870,int_stack+5252030,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+5686190,int_stack+4982030,int_stack+4616270,120);
 /*--- compute (t0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+5971310,int_stack+5686190,int_stack+5448590,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+4597190,int_stack+671540,int_stack+651020,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+4658750,int_stack+4597190,int_stack+4015790,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+5244110,int_stack+4658750,int_stack+4269950,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+4597190,int_stack+5244110,int_stack+4838030,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+5244110,int_stack+4597190,int_stack+4070870,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+4597190,int_stack+5244110,int_stack+4367870,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+5244110,int_stack+4597190,int_stack+4982030,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4015790,int_stack+5244110,int_stack+5686190,120);
 /*--- compute (t0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+4372190,int_stack+4015790,int_stack+5971310,120);
 /*--- compute (rp|mm) ---*/
 hrr1_build_rp(Libint->AB,int_stack+4735190,int_stack+4372190,int_stack+7039800,3025);
 /*--- compute (qd|mm) ---*/
 hrr1_build_qd(Libint->AB,int_stack+5688065,int_stack+4735190,int_stack+694340,3025);
 /*--- compute (of|mm) ---*/
 hrr1_build_of(Libint->AB,int_stack+18800560,int_stack+5688065,int_stack+12339160,3025);
 /*--- compute (ng|mm) ---*/
 hrr1_build_ng(Libint->AB,int_stack+4015790,int_stack+18800560,int_stack+13754860,3025);
 /*--- compute (mh|mm) ---*/
 hrr1_build_mh(Libint->AB,int_stack+10216050,int_stack+4015790,int_stack+1520165,3025);
 /*--- compute (li|mm) ---*/
 hrr1_build_li(Libint->AB,int_stack+0,int_stack+10216050,int_stack+7357425,3025);
 /*--- compute (kk|mm) ---*/
 hrr1_build_kk(Libint->AB,int_stack+3811500,int_stack+0,int_stack+15751360,3025);
 return int_stack+3811500;}
