/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kpgg(Libint_t*, prim_data*);

  /* Computes quartets of (kp|gg) integrals */

REALTYPE *hrr_order_kpgg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][4] = int_stack + 0;
 Libint->vrr_classes[7][5] = int_stack + 540;
 Libint->vrr_classes[7][6] = int_stack + 1296;
 Libint->vrr_classes[7][7] = int_stack + 2304;
 Libint->vrr_classes[7][8] = int_stack + 3600;
 Libint->vrr_classes[8][4] = int_stack + 5220;
 Libint->vrr_classes[8][5] = int_stack + 5895;
 Libint->vrr_classes[8][6] = int_stack + 6840;
 Libint->vrr_classes[8][7] = int_stack + 8100;
 Libint->vrr_classes[8][8] = int_stack + 9720;
 memset(int_stack,0,11745*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 11745;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kpgg(Libint, Data);
   Data++;
 }
 /*--- compute (k0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+11745,int_stack+540,int_stack+0,36);
 /*--- compute (k0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+13365,int_stack+1296,int_stack+540,36);
 /*--- compute (k0|gd) ---*/
 hrr3_build_gd(Libint->CD,int_stack+15633,int_stack+13365,int_stack+11745,36);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+18873,int_stack+2304,int_stack+1296,36);
 /*--- compute (k0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+21897,int_stack+18873,int_stack+13365,36);
 /*--- compute (k0|gf) ---*/
 hrr3_build_gf(Libint->CD,int_stack+26433,int_stack+21897,int_stack+15633,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+11745,int_stack+3600,int_stack+2304,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+31833,int_stack+11745,int_stack+18873,36);
 /*--- compute (k0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+11745,int_stack+31833,int_stack+21897,36);
 /*--- compute (k0|gg) ---*/
 hrr3_build_gg(Libint->CD,int_stack+31833,int_stack+11745,int_stack+26433,36);
 /*--- compute (l0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+11745,int_stack+5895,int_stack+5220,45);
 /*--- compute (l0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+13770,int_stack+6840,int_stack+5895,45);
 /*--- compute (l0|gd) ---*/
 hrr3_build_gd(Libint->CD,int_stack+16605,int_stack+13770,int_stack+11745,45);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+20655,int_stack+8100,int_stack+6840,45);
 /*--- compute (l0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+24435,int_stack+20655,int_stack+13770,45);
 /*--- compute (l0|gf) ---*/
 hrr3_build_gf(Libint->CD,int_stack+0,int_stack+24435,int_stack+16605,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+11745,int_stack+9720,int_stack+8100,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+39933,int_stack+11745,int_stack+20655,45);
 /*--- compute (l0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+6750,int_stack+39933,int_stack+24435,45);
 /*--- compute (l0|gg) ---*/
 hrr3_build_gg(Libint->CD,int_stack+16200,int_stack+6750,int_stack+0,45);
 /*--- compute (kp|gg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+39933,int_stack+16200,int_stack+31833,225);
 return int_stack+39933;}
