/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kpih(Libint_t*, prim_data*);

  /* Computes quartets of (kp|ih) integrals */

REALTYPE *hrr_order_kpih(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][6] = int_stack + 0;
 Libint->vrr_classes[7][7] = int_stack + 1008;
 Libint->vrr_classes[7][8] = int_stack + 2304;
 Libint->vrr_classes[7][9] = int_stack + 3924;
 Libint->vrr_classes[7][10] = int_stack + 5904;
 Libint->vrr_classes[7][11] = int_stack + 8280;
 Libint->vrr_classes[8][6] = int_stack + 11088;
 Libint->vrr_classes[8][7] = int_stack + 12348;
 Libint->vrr_classes[8][8] = int_stack + 13968;
 Libint->vrr_classes[8][9] = int_stack + 15993;
 Libint->vrr_classes[8][10] = int_stack + 18468;
 Libint->vrr_classes[8][11] = int_stack + 21438;
 memset(int_stack,0,24948*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 24948;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kpih(Libint, Data);
   Data++;
 }
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+24948,int_stack+1008,int_stack+0,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+27972,int_stack+2304,int_stack+1008,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+31860,int_stack+27972,int_stack+24948,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+37908,int_stack+3924,int_stack+2304,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+42768,int_stack+37908,int_stack+27972,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+50544,int_stack+42768,int_stack+31860,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+24948,int_stack+5904,int_stack+3924,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+60624,int_stack+24948,int_stack+37908,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+70344,int_stack+60624,int_stack+42768,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+30888,int_stack+70344,int_stack+50544,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+46008,int_stack+8280,int_stack+5904,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+83304,int_stack+46008,int_stack+24948,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+95184,int_stack+83304,int_stack+60624,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+46008,int_stack+95184,int_stack+70344,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+65448,int_stack+46008,int_stack+30888,36);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+24948,int_stack+12348,int_stack+11088,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+28728,int_stack+13968,int_stack+12348,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+33588,int_stack+28728,int_stack+24948,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41148,int_stack+15993,int_stack+13968,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+47223,int_stack+41148,int_stack+28728,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+86616,int_stack+47223,int_stack+33588,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+24948,int_stack+18468,int_stack+15993,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+99216,int_stack+24948,int_stack+41148,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+99216,int_stack+47223,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+32373,int_stack+0,int_stack+86616,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+86616,int_stack+21438,int_stack+18468,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+111366,int_stack+86616,int_stack+24948,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+126216,int_stack+111366,int_stack+99216,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+86616,int_stack+126216,int_stack+0,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+0,int_stack+86616,int_stack+32373,45);
 /*--- compute (kp|ih) ---*/
 hrr1_build_kp(Libint->AB,int_stack+86616,int_stack+0,int_stack+65448,588);
 return int_stack+86616;}
