/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lfkk(Libint_t*, prim_data*);

  /* Computes quartets of (lf|kk) integrals */

REALTYPE *hrr_order_lfkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][7] = int_stack + 0;
 Libint->vrr_classes[8][8] = int_stack + 1620;
 Libint->vrr_classes[8][9] = int_stack + 3645;
 Libint->vrr_classes[8][10] = int_stack + 6120;
 Libint->vrr_classes[8][11] = int_stack + 9090;
 Libint->vrr_classes[8][12] = int_stack + 12600;
 Libint->vrr_classes[8][13] = int_stack + 16695;
 Libint->vrr_classes[8][14] = int_stack + 21420;
 Libint->vrr_classes[9][7] = int_stack + 26820;
 Libint->vrr_classes[9][8] = int_stack + 28800;
 Libint->vrr_classes[9][9] = int_stack + 31275;
 Libint->vrr_classes[9][10] = int_stack + 34300;
 Libint->vrr_classes[9][11] = int_stack + 37930;
 Libint->vrr_classes[9][12] = int_stack + 42220;
 Libint->vrr_classes[9][13] = int_stack + 47225;
 Libint->vrr_classes[9][14] = int_stack + 53000;
 Libint->vrr_classes[10][7] = int_stack + 59600;
 Libint->vrr_classes[10][8] = int_stack + 61976;
 Libint->vrr_classes[10][9] = int_stack + 64946;
 Libint->vrr_classes[10][10] = int_stack + 68576;
 Libint->vrr_classes[10][11] = int_stack + 72932;
 Libint->vrr_classes[10][12] = int_stack + 78080;
 Libint->vrr_classes[10][13] = int_stack + 84086;
 Libint->vrr_classes[10][14] = int_stack + 91016;
 Libint->vrr_classes[11][7] = int_stack + 98936;
 Libint->vrr_classes[11][8] = int_stack + 101744;
 Libint->vrr_classes[11][9] = int_stack + 105254;
 Libint->vrr_classes[11][10] = int_stack + 109544;
 Libint->vrr_classes[11][11] = int_stack + 114692;
 Libint->vrr_classes[11][12] = int_stack + 120776;
 Libint->vrr_classes[11][13] = int_stack + 127874;
 Libint->vrr_classes[11][14] = int_stack + 136064;
 memset(int_stack,0,145424*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 145424;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lfkk(Libint, Data);
   Data++;
 }
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+145424,int_stack+1620,int_stack+0,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+150284,int_stack+3645,int_stack+1620,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+156359,int_stack+150284,int_stack+145424,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+166079,int_stack+6120,int_stack+3645,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+173504,int_stack+166079,int_stack+150284,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+185654,int_stack+173504,int_stack+156359,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+145424,int_stack+9090,int_stack+6120,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+201854,int_stack+145424,int_stack+166079,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+216704,int_stack+201854,int_stack+173504,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+154334,int_stack+216704,int_stack+185654,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+178634,int_stack+12600,int_stack+9090,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+236954,int_stack+178634,int_stack+145424,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+254774,int_stack+236954,int_stack+201854,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+279524,int_stack+254774,int_stack+216704,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+189164,int_stack+279524,int_stack+154334,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+145424,int_stack+16695,int_stack+12600,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+309899,int_stack+145424,int_stack+178634,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+157709,int_stack+309899,int_stack+236954,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+330959,int_stack+157709,int_stack+254774,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+223184,int_stack+330959,int_stack+279524,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+368084,int_stack+223184,int_stack+189164,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+187409,int_stack+21420,int_stack+16695,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+265709,int_stack+187409,int_stack+145424,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+187409,int_stack+265709,int_stack+309899,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+265709,int_stack+187409,int_stack+157709,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+145424,int_stack+265709,int_stack+330959,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+265709,int_stack+145424,int_stack+223184,45);
 /*--- compute (l0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+145424,int_stack+265709,int_stack+368084,45);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+203744,int_stack+28800,int_stack+26820,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+209684,int_stack+31275,int_stack+28800,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+217109,int_stack+209684,int_stack+203744,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+228989,int_stack+34300,int_stack+31275,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+238064,int_stack+228989,int_stack+209684,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+252914,int_stack+238064,int_stack+217109,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+203744,int_stack+37930,int_stack+34300,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+272714,int_stack+203744,int_stack+228989,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+290864,int_stack+272714,int_stack+238064,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+214634,int_stack+290864,int_stack+252914,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+244334,int_stack+42220,int_stack+37930,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+315614,int_stack+244334,int_stack+203744,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+337394,int_stack+315614,int_stack+272714,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+367644,int_stack+337394,int_stack+290864,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+257204,int_stack+367644,int_stack+214634,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+203744,int_stack+47225,int_stack+42220,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+203744,int_stack+244334,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+218759,int_stack+0,int_stack+315614,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+404769,int_stack+218759,int_stack+337394,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+298784,int_stack+404769,int_stack+367644,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+450144,int_stack+298784,int_stack+257204,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+255059,int_stack+53000,int_stack+47225,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+350759,int_stack+255059,int_stack+203744,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+255059,int_stack+350759,int_stack+0,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+255059,int_stack+218759,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+203744,int_stack+0,int_stack+404769,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+350759,int_stack+203744,int_stack+298784,55);
 /*--- compute (m0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+203744,int_stack+350759,int_stack+450144,55);
 /*--- compute (lp|kk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+275024,int_stack+203744,int_stack+145424,1296);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+145424,int_stack+61976,int_stack+59600,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+152552,int_stack+64946,int_stack+61976,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+161462,int_stack+152552,int_stack+145424,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+175718,int_stack+68576,int_stack+64946,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+449984,int_stack+175718,int_stack+152552,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+467804,int_stack+449984,int_stack+161462,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+145424,int_stack+72932,int_stack+68576,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+145424,int_stack+175718,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+158492,int_stack+0,int_stack+449984,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+21780,int_stack+158492,int_stack+467804,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+449984,int_stack+78080,int_stack+72932,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+465428,int_stack+449984,int_stack+145424,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+491564,int_stack+465428,int_stack+0,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+527864,int_stack+491564,int_stack+158492,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+145424,int_stack+527864,int_stack+21780,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+84086,int_stack+78080,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+18018,int_stack+0,int_stack+449984,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+572414,int_stack+18018,int_stack+465428,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+615974,int_stack+572414,int_stack+491564,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+449984,int_stack+615974,int_stack+527864,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+670424,int_stack+449984,int_stack+145424,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+145424,int_stack+91016,int_stack+84086,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+166214,int_stack+145424,int_stack+0,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+512354,int_stack+166214,int_stack+18018,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+512354,int_stack+572414,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+512354,int_stack+0,int_stack+615974,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+512354,int_stack+449984,66);
 /*--- compute (n0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+449984,int_stack+0,int_stack+670424,66);
 /*--- compute (mp|kk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+535520,int_stack+449984,int_stack+203744,1296);
 /*--- compute (ld|kk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+749360,int_stack+535520,int_stack+275024,1296);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+101744,int_stack+98936,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8424,int_stack+105254,int_stack+101744,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+18954,int_stack+8424,int_stack+0,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+35802,int_stack+109544,int_stack+105254,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+48672,int_stack+35802,int_stack+8424,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+69732,int_stack+48672,int_stack+18954,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+114692,int_stack+109544,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+145424,int_stack+0,int_stack+35802,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+171164,int_stack+145424,int_stack+48672,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+15444,int_stack+171164,int_stack+69732,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+57564,int_stack+120776,int_stack+114692,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+75816,int_stack+57564,int_stack+0,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+206264,int_stack+75816,int_stack+145424,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+249164,int_stack+206264,int_stack+171164,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+145424,int_stack+249164,int_stack+15444,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+127874,int_stack+120776,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+301814,int_stack+0,int_stack+57564,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+21294,int_stack+301814,int_stack+75816,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+338318,int_stack+21294,int_stack+206264,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1099280,int_stack+338318,int_stack+249164,78);
 /*--- compute (o0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+204392,int_stack+1099280,int_stack+145424,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+145424,int_stack+136064,int_stack+127874,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+72774,int_stack+145424,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+115362,int_stack+72774,int_stack+301814,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1172990,int_stack+115362,int_stack+21294,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+1172990,int_stack+338318,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+90090,int_stack+0,int_stack+1099280,78);
 /*--- compute (o0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+1099280,int_stack+90090,int_stack+204392,78);
 /*--- compute (np|kk) ---*/
 hrr1_build_np(Libint->AB,int_stack+0,int_stack+1099280,int_stack+449984,1296);
 /*--- compute (md|kk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1099280,int_stack+0,int_stack+535520,1296);
 /*--- compute (lf|kk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+1099280,int_stack+749360,1296);
 return int_stack+0;}
