/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lfmd(Libint_t*, prim_data*);

  /* Computes quartets of (lf|md) integrals */

REALTYPE *hrr_order_lfmd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[9][9] = int_stack + 8955;
 Libint->vrr_classes[9][10] = int_stack + 11980;
 Libint->vrr_classes[9][11] = int_stack + 15610;
 Libint->vrr_classes[10][9] = int_stack + 19900;
 Libint->vrr_classes[10][10] = int_stack + 23530;
 Libint->vrr_classes[10][11] = int_stack + 27886;
 Libint->vrr_classes[11][9] = int_stack + 33034;
 Libint->vrr_classes[11][10] = int_stack + 37324;
 Libint->vrr_classes[11][11] = int_stack + 42472;
 memset(int_stack,0,48556*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 48556;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lfmd(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+48556,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+55981,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+64891,int_stack+55981,int_stack+48556,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+48556,int_stack+11980,int_stack+8955,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+15610,int_stack+11980,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+79741,int_stack+0,int_stack+48556,55);
 /*--- compute (lp|md) ---*/
 hrr1_build_lp(Libint->AB,int_stack+97891,int_stack+79741,int_stack+64891,330);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+48556,int_stack+23530,int_stack+19900,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59446,int_stack+27886,int_stack+23530,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+59446,int_stack+48556,66);
 /*--- compute (mp|md) ---*/
 hrr1_build_mp(Libint->AB,int_stack+142441,int_stack+0,int_stack+79741,330);
 /*--- compute (ld|md) ---*/
 hrr1_build_ld(Libint->AB,int_stack+196891,int_stack+142441,int_stack+97891,330);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+48556,int_stack+37324,int_stack+33034,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+61426,int_stack+42472,int_stack+37324,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+76870,int_stack+61426,int_stack+48556,78);
 /*--- compute (np|md) ---*/
 hrr1_build_np(Libint->AB,int_stack+285991,int_stack+76870,int_stack+0,330);
 /*--- compute (md|md) ---*/
 hrr1_build_md(Libint->AB,int_stack+0,int_stack+285991,int_stack+142441,330);
 /*--- compute (lf|md) ---*/
 hrr1_build_lf(Libint->AB,int_stack+285991,int_stack+0,int_stack+196891,330);
 return int_stack+285991;}
