/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lfmm(Libint_t*, prim_data*);

  /* Computes quartets of (lf|mm) integrals */

REALTYPE *hrr_order_lfmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[8][15] = int_stack + 23175;
 Libint->vrr_classes[8][16] = int_stack + 29295;
 Libint->vrr_classes[8][17] = int_stack + 36180;
 Libint->vrr_classes[8][18] = int_stack + 43875;
 Libint->vrr_classes[9][9] = int_stack + 52425;
 Libint->vrr_classes[9][10] = int_stack + 55450;
 Libint->vrr_classes[9][11] = int_stack + 59080;
 Libint->vrr_classes[9][12] = int_stack + 63370;
 Libint->vrr_classes[9][13] = int_stack + 68375;
 Libint->vrr_classes[9][14] = int_stack + 74150;
 Libint->vrr_classes[9][15] = int_stack + 80750;
 Libint->vrr_classes[9][16] = int_stack + 88230;
 Libint->vrr_classes[9][17] = int_stack + 96645;
 Libint->vrr_classes[9][18] = int_stack + 106050;
 Libint->vrr_classes[10][9] = int_stack + 116500;
 Libint->vrr_classes[10][10] = int_stack + 120130;
 Libint->vrr_classes[10][11] = int_stack + 124486;
 Libint->vrr_classes[10][12] = int_stack + 129634;
 Libint->vrr_classes[10][13] = int_stack + 135640;
 Libint->vrr_classes[10][14] = int_stack + 142570;
 Libint->vrr_classes[10][15] = int_stack + 150490;
 Libint->vrr_classes[10][16] = int_stack + 159466;
 Libint->vrr_classes[10][17] = int_stack + 169564;
 Libint->vrr_classes[10][18] = int_stack + 180850;
 Libint->vrr_classes[11][9] = int_stack + 193390;
 Libint->vrr_classes[11][10] = int_stack + 197680;
 Libint->vrr_classes[11][11] = int_stack + 202828;
 Libint->vrr_classes[11][12] = int_stack + 208912;
 Libint->vrr_classes[11][13] = int_stack + 216010;
 Libint->vrr_classes[11][14] = int_stack + 224200;
 Libint->vrr_classes[11][15] = int_stack + 233560;
 Libint->vrr_classes[11][16] = int_stack + 244168;
 Libint->vrr_classes[11][17] = int_stack + 256102;
 Libint->vrr_classes[11][18] = int_stack + 269440;
 memset(int_stack,0,284260*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 284260;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lfmm(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+284260,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+291685,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+300595,int_stack+291685,int_stack+284260,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+315445,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+325975,int_stack+315445,int_stack+291685,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+343795,int_stack+325975,int_stack+300595,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+284260,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+368545,int_stack+284260,int_stack+315445,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+389605,int_stack+368545,int_stack+325975,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+296545,int_stack+389605,int_stack+343795,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+333670,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+419305,int_stack+333670,int_stack+284260,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+443875,int_stack+419305,int_stack+368545,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+478975,int_stack+443875,int_stack+389605,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+347845,int_stack+478975,int_stack+296545,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+284260,int_stack+23175,int_stack+17775,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+300460,int_stack+284260,int_stack+333670,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+523525,int_stack+300460,int_stack+419305,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+564475,int_stack+523525,int_stack+443875,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+399820,int_stack+564475,int_stack+478975,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+617125,int_stack+399820,int_stack+347845,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+328810,int_stack+29295,int_stack+23175,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+347170,int_stack+328810,int_stack+284260,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+462190,int_stack+347170,int_stack+300460,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+686425,int_stack+462190,int_stack+523525,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+747850,int_stack+686425,int_stack+564475,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+509440,int_stack+747850,int_stack+399820,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+821560,int_stack+509440,int_stack+617125,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+284260,int_stack+36180,int_stack+29295,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+379570,int_stack+284260,int_stack+328810,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+592600,int_stack+379570,int_stack+347170,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+304915,int_stack+592600,int_stack+462190,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+416290,int_stack+304915,int_stack+686425,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+646600,int_stack+416290,int_stack+747850,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+910660,int_stack+646600,int_stack+509440,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1017580,int_stack+910660,int_stack+821560,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+502285,int_stack+43875,int_stack+36180,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+525370,int_stack+502285,int_stack+284260,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+744880,int_stack+525370,int_stack+379570,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+502285,int_stack+744880,int_stack+592600,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+744880,int_stack+502285,int_stack+304915,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+502285,int_stack+744880,int_stack+416290,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+744880,int_stack+502285,int_stack+646600,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+284260,int_stack+744880,int_stack+910660,45);
 /*--- compute (l0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+417910,int_stack+284260,int_stack+1017580,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+284260,int_stack+55450,int_stack+52425,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+293335,int_stack+59080,int_stack+55450,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+304225,int_stack+293335,int_stack+284260,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+322375,int_stack+63370,int_stack+59080,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+335245,int_stack+322375,int_stack+293335,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+357025,int_stack+335245,int_stack+304225,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+284260,int_stack+68375,int_stack+63370,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+387275,int_stack+284260,int_stack+322375,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+554035,int_stack+387275,int_stack+335245,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+299275,int_stack+554035,int_stack+357025,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+344650,int_stack+74150,int_stack+68375,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+590335,int_stack+344650,int_stack+284260,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+620365,int_stack+590335,int_stack+387275,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+361975,int_stack+620365,int_stack+554035,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+663265,int_stack+361975,int_stack+299275,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+554035,int_stack+80750,int_stack+74150,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+284260,int_stack+554035,int_stack+344650,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+726790,int_stack+284260,int_stack+590335,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+776840,int_stack+726790,int_stack+620365,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+573835,int_stack+776840,int_stack+361975,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+318910,int_stack+573835,int_stack+663265,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+650065,int_stack+88230,int_stack+80750,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+672505,int_stack+650065,int_stack+554035,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+841190,int_stack+672505,int_stack+284260,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+898940,int_stack+841190,int_stack+726790,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+974015,int_stack+898940,int_stack+776840,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+712105,int_stack+974015,int_stack+573835,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1064105,int_stack+712105,int_stack+318910,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+284260,int_stack+96645,int_stack+88230,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+309505,int_stack+284260,int_stack+650065,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+554035,int_stack+309505,int_stack+672505,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+620035,int_stack+554035,int_stack+841190,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1173005,int_stack+620035,int_stack+898940,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+813745,int_stack+1173005,int_stack+974015,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1278110,int_stack+813745,int_stack+712105,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1408790,int_stack+1278110,int_stack+1064105,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+354385,int_stack+106050,int_stack+96645,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+706660,int_stack+354385,int_stack+284260,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+933865,int_stack+706660,int_stack+309505,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+706660,int_stack+933865,int_stack+554035,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+933865,int_stack+706660,int_stack+620035,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+554035,int_stack+933865,int_stack+1173005,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+933865,int_stack+554035,int_stack+813745,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+554035,int_stack+933865,int_stack+1278110,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+717385,int_stack+554035,int_stack+1408790,55);
 /*--- compute (lp|mm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+883760,int_stack+717385,int_stack+417910,3025);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1292135,int_stack+120130,int_stack+116500,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1303025,int_stack+124486,int_stack+120130,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1316093,int_stack+1303025,int_stack+1292135,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1337873,int_stack+129634,int_stack+124486,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1353317,int_stack+1337873,int_stack+1303025,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1379453,int_stack+1353317,int_stack+1316093,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1292135,int_stack+135640,int_stack+129634,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1415753,int_stack+1292135,int_stack+1337873,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1446641,int_stack+1415753,int_stack+1353317,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1310153,int_stack+1446641,int_stack+1379453,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1364603,int_stack+142570,int_stack+135640,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1490201,int_stack+1364603,int_stack+1292135,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+284260,int_stack+1490201,int_stack+1415753,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+335740,int_stack+284260,int_stack+1446641,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1385393,int_stack+335740,int_stack+1310153,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1292135,int_stack+150490,int_stack+142570,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1315895,int_stack+1292135,int_stack+1364603,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+401080,int_stack+1315895,int_stack+1490201,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1461623,int_stack+401080,int_stack+284260,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+461140,int_stack+1461623,int_stack+335740,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+284260,int_stack+461140,int_stack+1385393,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1357475,int_stack+159466,int_stack+150490,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1384403,int_stack+1357475,int_stack+1292135,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+552616,int_stack+1384403,int_stack+1315895,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+621916,int_stack+552616,int_stack+401080,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+621916,int_stack+1461623,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1431923,int_stack+0,int_stack+461140,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+385900,int_stack+1431923,int_stack+284260,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+284260,int_stack+169564,int_stack+159466,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+314554,int_stack+284260,int_stack+1357475,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1292135,int_stack+314554,int_stack+1384403,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1553891,int_stack+1292135,int_stack+552616,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1657841,int_stack+1553891,int_stack+621916,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+516580,int_stack+1657841,int_stack+0,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+516580,int_stack+1431923,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1371335,int_stack+0,int_stack+385900,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+368410,int_stack+180850,int_stack+169564,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+402268,int_stack+368410,int_stack+284260,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1783967,int_stack+402268,int_stack+314554,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+284260,int_stack+1783967,int_stack+1292135,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1783967,int_stack+284260,int_stack+1553891,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+284260,int_stack+1783967,int_stack+1657841,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1534685,int_stack+284260,int_stack+516580,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+284260,int_stack+1534685,int_stack+0,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1534685,int_stack+284260,int_stack+1371335,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1734335,int_stack+1534685,int_stack+717385,3025);
 /*--- compute (ld|mm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2233460,int_stack+1734335,int_stack+883760,3025);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+284260,int_stack+197680,int_stack+193390,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+297130,int_stack+202828,int_stack+197680,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+312574,int_stack+297130,int_stack+284260,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+338314,int_stack+208912,int_stack+202828,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+356566,int_stack+338314,int_stack+297130,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+387454,int_stack+356566,int_stack+312574,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+284260,int_stack+216010,int_stack+208912,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+430354,int_stack+284260,int_stack+338314,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+466858,int_stack+430354,int_stack+356566,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+305554,int_stack+466858,int_stack+387454,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+369904,int_stack+224200,int_stack+216010,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+518338,int_stack+369904,int_stack+284260,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+560926,int_stack+518338,int_stack+430354,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+621766,int_stack+560926,int_stack+466858,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+394474,int_stack+621766,int_stack+305554,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+284260,int_stack+233560,int_stack+224200,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+312340,int_stack+284260,int_stack+369904,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+698986,int_stack+312340,int_stack+518338,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+769966,int_stack+698986,int_stack+560926,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+484564,int_stack+769966,int_stack+621766,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+861226,int_stack+484564,int_stack+394474,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+361480,int_stack+244168,int_stack+233560,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+393304,int_stack+361480,int_stack+284260,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+592672,int_stack+393304,int_stack+312340,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+981346,int_stack+592672,int_stack+698986,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1087816,int_stack+981346,int_stack+769966,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+674572,int_stack+1087816,int_stack+484564,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1215580,int_stack+674572,int_stack+861226,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+284260,int_stack+256102,int_stack+244168,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+449464,int_stack+284260,int_stack+361480,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+818716,int_stack+449464,int_stack+393304,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+320062,int_stack+818716,int_stack+592672,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+513112,int_stack+320062,int_stack+981346,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+912316,int_stack+513112,int_stack+1087816,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+912316,int_stack+674572,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3050210,int_stack+0,int_stack+1215580,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+662170,int_stack+269440,int_stack+256102,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+702184,int_stack+662170,int_stack+284260,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1082668,int_stack+702184,int_stack+449464,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+662170,int_stack+1082668,int_stack+818716,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1082668,int_stack+662170,int_stack+320062,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+662170,int_stack+1082668,int_stack+513112,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1082668,int_stack+662170,int_stack+912316,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1301692,int_stack+1082668,int_stack+0,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+0,int_stack+1301692,int_stack+3050210,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+235950,int_stack+0,int_stack+1534685,3025);
 /*--- compute (md|mm) ---*/
 hrr1_build_md(Libint->AB,int_stack+3050210,int_stack+235950,int_stack+1734335,3025);
 /*--- compute (lf|mm) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+3050210,int_stack+2233460,3025);
 return int_stack+0;}
