/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lfnn(Libint_t*, prim_data*);

  /* Computes quartets of (lf|nn) integrals */

REALTYPE *hrr_order_lfnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[8][16] = int_stack + 26820;
 Libint->vrr_classes[8][17] = int_stack + 33705;
 Libint->vrr_classes[8][18] = int_stack + 41400;
 Libint->vrr_classes[8][19] = int_stack + 49950;
 Libint->vrr_classes[8][20] = int_stack + 59400;
 Libint->vrr_classes[9][10] = int_stack + 69795;
 Libint->vrr_classes[9][11] = int_stack + 73425;
 Libint->vrr_classes[9][12] = int_stack + 77715;
 Libint->vrr_classes[9][13] = int_stack + 82720;
 Libint->vrr_classes[9][14] = int_stack + 88495;
 Libint->vrr_classes[9][15] = int_stack + 95095;
 Libint->vrr_classes[9][16] = int_stack + 102575;
 Libint->vrr_classes[9][17] = int_stack + 110990;
 Libint->vrr_classes[9][18] = int_stack + 120395;
 Libint->vrr_classes[9][19] = int_stack + 130845;
 Libint->vrr_classes[9][20] = int_stack + 142395;
 Libint->vrr_classes[10][10] = int_stack + 155100;
 Libint->vrr_classes[10][11] = int_stack + 159456;
 Libint->vrr_classes[10][12] = int_stack + 164604;
 Libint->vrr_classes[10][13] = int_stack + 170610;
 Libint->vrr_classes[10][14] = int_stack + 177540;
 Libint->vrr_classes[10][15] = int_stack + 185460;
 Libint->vrr_classes[10][16] = int_stack + 194436;
 Libint->vrr_classes[10][17] = int_stack + 204534;
 Libint->vrr_classes[10][18] = int_stack + 215820;
 Libint->vrr_classes[10][19] = int_stack + 228360;
 Libint->vrr_classes[10][20] = int_stack + 242220;
 Libint->vrr_classes[11][10] = int_stack + 257466;
 Libint->vrr_classes[11][11] = int_stack + 262614;
 Libint->vrr_classes[11][12] = int_stack + 268698;
 Libint->vrr_classes[11][13] = int_stack + 275796;
 Libint->vrr_classes[11][14] = int_stack + 283986;
 Libint->vrr_classes[11][15] = int_stack + 293346;
 Libint->vrr_classes[11][16] = int_stack + 303954;
 Libint->vrr_classes[11][17] = int_stack + 315888;
 Libint->vrr_classes[11][18] = int_stack + 329226;
 Libint->vrr_classes[11][19] = int_stack + 344046;
 Libint->vrr_classes[11][20] = int_stack + 360426;
 memset(int_stack,0,378444*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 378444;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lfnn(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+378444,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+387354,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+397884,int_stack+387354,int_stack+378444,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+415704,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+427989,int_stack+415704,int_stack+387354,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+449049,int_stack+427989,int_stack+397884,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+378444,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+478749,int_stack+378444,int_stack+415704,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+392619,int_stack+478749,int_stack+427989,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+503319,int_stack+392619,int_stack+449049,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+427719,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+443919,int_stack+427719,int_stack+378444,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+547869,int_stack+443919,int_stack+478749,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+588819,int_stack+547869,int_stack+392619,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+641469,int_stack+588819,int_stack+503319,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+378444,int_stack+26820,int_stack+20700,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+472269,int_stack+378444,int_stack+427719,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+703839,int_stack+472269,int_stack+443919,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+396804,int_stack+703839,int_stack+547869,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+504669,int_stack+396804,int_stack+588819,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+751089,int_stack+504669,int_stack+641469,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+578379,int_stack+33705,int_stack+26820,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+599034,int_stack+578379,int_stack+378444,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+635754,int_stack+599034,int_stack+472269,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+834249,int_stack+635754,int_stack+703839,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+905124,int_stack+834249,int_stack+396804,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+378444,int_stack+905124,int_stack+504669,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+991119,int_stack+378444,int_stack+751089,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+476724,int_stack+41400,int_stack+33705,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+499809,int_stack+476724,int_stack+578379,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+689754,int_stack+499809,int_stack+599034,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+541119,int_stack+689754,int_stack+635754,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1098039,int_stack+541119,int_stack+834249,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+750954,int_stack+1098039,int_stack+905124,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1197264,int_stack+750954,int_stack+378444,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1323624,int_stack+1197264,int_stack+991119,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+378444,int_stack+49950,int_stack+41400,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+404094,int_stack+378444,int_stack+476724,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+865614,int_stack+404094,int_stack+499809,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+934464,int_stack+865614,int_stack+689754,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+622119,int_stack+934464,int_stack+541119,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+450264,int_stack+622119,int_stack+1098039,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1026264,int_stack+450264,int_stack+750954,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1457274,int_stack+1026264,int_stack+1197264,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1615224,int_stack+1457274,int_stack+1323624,45);
 /*--- compute (l0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+582564,int_stack+59400,int_stack+49950,45);
 /*--- compute (l0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+735519,int_stack+582564,int_stack+378444,45);
 /*--- compute (l0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+786819,int_stack+735519,int_stack+404094,45);
 /*--- compute (l0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1173684,int_stack+786819,int_stack+865614,45);
 /*--- compute (l0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+735519,int_stack+1173684,int_stack+934464,45);
 /*--- compute (l0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1173684,int_stack+735519,int_stack+622119,45);
 /*--- compute (l0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+582564,int_stack+1173684,int_stack+450264,45);
 /*--- compute (l0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1173684,int_stack+582564,int_stack+1026264,45);
 /*--- compute (l0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+378444,int_stack+1173684,int_stack+1457274,45);
 /*--- compute (l0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+571494,int_stack+378444,int_stack+1615224,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+378444,int_stack+73425,int_stack+69795,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+389334,int_stack+77715,int_stack+73425,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+402204,int_stack+389334,int_stack+378444,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+423984,int_stack+82720,int_stack+77715,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+438999,int_stack+423984,int_stack+389334,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+464739,int_stack+438999,int_stack+402204,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+378444,int_stack+88495,int_stack+82720,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+501039,int_stack+378444,int_stack+423984,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+395769,int_stack+501039,int_stack+438999,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+767514,int_stack+395769,int_stack+464739,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+438669,int_stack+95095,int_stack+88495,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+458469,int_stack+438669,int_stack+378444,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+821964,int_stack+458469,int_stack+501039,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+493119,int_stack+821964,int_stack+395769,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+872014,int_stack+493119,int_stack+767514,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+767514,int_stack+102575,int_stack+95095,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+378444,int_stack+767514,int_stack+438669,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+948244,int_stack+378444,int_stack+458469,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+418044,int_stack+948244,int_stack+821964,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1005994,int_stack+418044,int_stack+493119,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1096084,int_stack+1005994,int_stack+872014,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+493119,int_stack+110990,int_stack+102575,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+518364,int_stack+493119,int_stack+767514,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+767514,int_stack+518364,int_stack+378444,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+833514,int_stack+767514,int_stack+948244,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1197724,int_stack+833514,int_stack+418044,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1302829,int_stack+1197724,int_stack+1005994,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+920139,int_stack+1302829,int_stack+1096084,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+378444,int_stack+120395,int_stack+110990,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+406659,int_stack+378444,int_stack+493119,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1050819,int_stack+406659,int_stack+518364,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+457149,int_stack+1050819,int_stack+767514,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1422949,int_stack+457149,int_stack+833514,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+767514,int_stack+1422949,int_stack+1197724,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1125619,int_stack+767514,int_stack+1302829,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1544224,int_stack+1125619,int_stack+920139,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+907654,int_stack+130845,int_stack+120395,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+939004,int_stack+907654,int_stack+378444,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1280059,int_stack+939004,int_stack+406659,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+1280059,int_stack+1050819,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1707574,int_stack+0,int_stack+457149,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+378444,int_stack+1707574,int_stack+1422949,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1846174,int_stack+378444,int_stack+767514,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2026354,int_stack+1846174,int_stack+1125619,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+995434,int_stack+2026354,int_stack+1544224,55);
 /*--- compute (m0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+767514,int_stack+142395,int_stack+130845,55);
 /*--- compute (m0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+802164,int_stack+767514,int_stack+907654,55);
 /*--- compute (m0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1364209,int_stack+802164,int_stack+939004,55);
 /*--- compute (m0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+767514,int_stack+1364209,int_stack+1280059,55);
 /*--- compute (m0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1195084,int_stack+767514,int_stack+0,55);
 /*--- compute (m0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+767514,int_stack+1195084,int_stack+1707574,55);
 /*--- compute (m0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1195084,int_stack+767514,int_stack+378444,55);
 /*--- compute (m0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+767514,int_stack+1195084,int_stack+1846174,55);
 /*--- compute (m0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1195084,int_stack+767514,int_stack+2026354,55);
 /*--- compute (m0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1431034,int_stack+1195084,int_stack+995434,55);
 /*--- compute (lp|nn) ---*/
 hrr1_build_lp(Libint->AB,int_stack+767514,int_stack+1431034,int_stack+571494,4356);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1355574,int_stack+159456,int_stack+155100,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1368642,int_stack+164604,int_stack+159456,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1384086,int_stack+1368642,int_stack+1355574,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1410222,int_stack+170610,int_stack+164604,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1670614,int_stack+1410222,int_stack+1368642,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1701502,int_stack+1670614,int_stack+1384086,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1355574,int_stack+177540,int_stack+170610,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1745062,int_stack+1355574,int_stack+1410222,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1376364,int_stack+1745062,int_stack+1670614,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1781098,int_stack+1376364,int_stack+1701502,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1670614,int_stack+185460,int_stack+177540,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1694374,int_stack+1670614,int_stack+1355574,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1846438,int_stack+1694374,int_stack+1745062,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1906498,int_stack+1846438,int_stack+1376364,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1983718,int_stack+1906498,int_stack+1781098,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1355574,int_stack+194436,int_stack+185460,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1382502,int_stack+1355574,int_stack+1670614,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1735954,int_stack+1382502,int_stack+1694374,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2075194,int_stack+1735954,int_stack+1846438,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+378444,int_stack+2075194,int_stack+1906498,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1805254,int_stack+378444,int_stack+1983718,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1670614,int_stack+204534,int_stack+194436,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1927222,int_stack+1670614,int_stack+1355574,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1981078,int_stack+1927222,int_stack+1382502,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+486552,int_stack+1981078,int_stack+1735954,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+590502,int_stack+486552,int_stack+2075194,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2060278,int_stack+590502,int_stack+378444,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2060278,int_stack+1805254,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+378444,int_stack+215820,int_stack+204534,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+412302,int_stack+378444,int_stack+1670614,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1670614,int_stack+412302,int_stack+1927222,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1760374,int_stack+1670614,int_stack+1981078,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1879174,int_stack+1760374,int_stack+486552,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2204422,int_stack+1879174,int_stack+590502,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+472890,int_stack+2204422,int_stack+2060278,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2372590,int_stack+472890,int_stack+0,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+228360,int_stack+215820,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+37620,int_stack+0,int_stack+378444,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+105336,int_stack+37620,int_stack+412302,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2024704,int_stack+105336,int_stack+1670614,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2568610,int_stack+2024704,int_stack+1760374,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1670614,int_stack+2568610,int_stack+1879174,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2734930,int_stack+1670614,int_stack+2204422,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2951146,int_stack+2734930,int_stack+472890,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+378444,int_stack+2951146,int_stack+2372590,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1864654,int_stack+242220,int_stack+228360,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1906234,int_stack+1864654,int_stack+0,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+618024,int_stack+1906234,int_stack+37620,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1864654,int_stack+618024,int_stack+105336,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+1864654,int_stack+2024704,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1864654,int_stack+0,int_stack+2568610,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+1864654,int_stack+1670614,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1670614,int_stack+0,int_stack+2734930,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1940884,int_stack+1670614,int_stack+2951146,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2224024,int_stack+1940884,int_stack+378444,66);
 /*--- compute (mp|nn) ---*/
 hrr1_build_mp(Libint->AB,int_stack+2511520,int_stack+2224024,int_stack+1431034,4356);
 /*--- compute (ld|nn) ---*/
 hrr1_build_ld(Libint->AB,int_stack+3230260,int_stack+2511520,int_stack+767514,4356);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+378444,int_stack+262614,int_stack+257466,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+393888,int_stack+268698,int_stack+262614,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+412140,int_stack+393888,int_stack+378444,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+443028,int_stack+275796,int_stack+268698,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+464322,int_stack+443028,int_stack+393888,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+500826,int_stack+464322,int_stack+412140,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+378444,int_stack+283986,int_stack+275796,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+552306,int_stack+378444,int_stack+443028,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+403014,int_stack+552306,int_stack+464322,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+594894,int_stack+403014,int_stack+500826,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+463854,int_stack+293346,int_stack+283986,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+491934,int_stack+463854,int_stack+378444,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+672114,int_stack+491934,int_stack+552306,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+743094,int_stack+672114,int_stack+403014,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+834354,int_stack+743094,int_stack+594894,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+378444,int_stack+303954,int_stack+293346,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+541074,int_stack+378444,int_stack+463854,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+942462,int_stack+541074,int_stack+491934,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+410268,int_stack+942462,int_stack+672114,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+597234,int_stack+410268,int_stack+743094,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1024362,int_stack+597234,int_stack+834354,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+724998,int_stack+315888,int_stack+303954,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+760800,int_stack+724998,int_stack+378444,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+824448,int_stack+760800,int_stack+541074,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1168506,int_stack+824448,int_stack+942462,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1291356,int_stack+1168506,int_stack+410268,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+378444,int_stack+1291356,int_stack+597234,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1440414,int_stack+378444,int_stack+1024362,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+548796,int_stack+329226,int_stack+315888,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+588810,int_stack+548796,int_stack+724998,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+918048,int_stack+588810,int_stack+760800,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+660414,int_stack+918048,int_stack+824448,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1625742,int_stack+660414,int_stack+1168506,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1024128,int_stack+1625742,int_stack+1291356,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1797732,int_stack+1024128,int_stack+378444,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1797732,int_stack+1440414,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+378444,int_stack+344046,int_stack+329226,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+422904,int_stack+378444,int_stack+548796,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1222872,int_stack+422904,int_stack+588810,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1342212,int_stack+1222872,int_stack+918048,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+800814,int_stack+1342212,int_stack+660414,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+502932,int_stack+800814,int_stack+1625742,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1501332,int_stack+502932,int_stack+1024128,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+4406380,int_stack+1501332,int_stack+1797732,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1756860,int_stack+4406380,int_stack+0,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+360426,int_stack+344046,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+49140,int_stack+0,int_stack+378444,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+138060,int_stack+49140,int_stack+422904,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+271440,int_stack+138060,int_stack+1222872,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+271440,int_stack+1342212,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+222768,int_stack+0,int_stack+800814,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+732252,int_stack+222768,int_stack+502932,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+0,int_stack+732252,int_stack+1501332,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+319410,int_stack+0,int_stack+4406380,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+654030,int_stack+319410,int_stack+1756860,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+993798,int_stack+654030,int_stack+2224024,4356);
 /*--- compute (md|nn) ---*/
 hrr1_build_md(Libint->AB,int_stack+4406380,int_stack+993798,int_stack+2511520,4356);
 /*--- compute (lf|nn) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+4406380,int_stack+3230260,4356);
 return int_stack+0;}
