/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lglh(Libint_t*, prim_data*);

  /* Computes quartets of (lg|lh) integrals */

REALTYPE *hrr_order_lglh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][8] = int_stack + 0;
 Libint->vrr_classes[8][9] = int_stack + 2025;
 Libint->vrr_classes[8][10] = int_stack + 4500;
 Libint->vrr_classes[8][11] = int_stack + 7470;
 Libint->vrr_classes[8][12] = int_stack + 10980;
 Libint->vrr_classes[8][13] = int_stack + 15075;
 Libint->vrr_classes[9][8] = int_stack + 19800;
 Libint->vrr_classes[9][9] = int_stack + 22275;
 Libint->vrr_classes[9][10] = int_stack + 25300;
 Libint->vrr_classes[9][11] = int_stack + 28930;
 Libint->vrr_classes[9][12] = int_stack + 33220;
 Libint->vrr_classes[9][13] = int_stack + 38225;
 Libint->vrr_classes[10][8] = int_stack + 44000;
 Libint->vrr_classes[10][9] = int_stack + 46970;
 Libint->vrr_classes[10][10] = int_stack + 50600;
 Libint->vrr_classes[10][11] = int_stack + 54956;
 Libint->vrr_classes[10][12] = int_stack + 60104;
 Libint->vrr_classes[10][13] = int_stack + 66110;
 Libint->vrr_classes[11][8] = int_stack + 73040;
 Libint->vrr_classes[11][9] = int_stack + 76550;
 Libint->vrr_classes[11][10] = int_stack + 80840;
 Libint->vrr_classes[11][11] = int_stack + 85988;
 Libint->vrr_classes[11][12] = int_stack + 92072;
 Libint->vrr_classes[11][13] = int_stack + 99170;
 Libint->vrr_classes[12][8] = int_stack + 107360;
 Libint->vrr_classes[12][9] = int_stack + 111455;
 Libint->vrr_classes[12][10] = int_stack + 116460;
 Libint->vrr_classes[12][11] = int_stack + 122466;
 Libint->vrr_classes[12][12] = int_stack + 129564;
 Libint->vrr_classes[12][13] = int_stack + 137845;
 memset(int_stack,0,147400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 147400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lglh(Libint, Data);
   Data++;
 }
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+147400,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+153475,int_stack+4500,int_stack+2025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+160900,int_stack+153475,int_stack+147400,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+173050,int_stack+7470,int_stack+4500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+181960,int_stack+173050,int_stack+153475,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+196810,int_stack+181960,int_stack+160900,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+147400,int_stack+10980,int_stack+7470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+217060,int_stack+147400,int_stack+173050,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+234880,int_stack+217060,int_stack+181960,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+157930,int_stack+234880,int_stack+196810,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+188305,int_stack+15075,int_stack+10980,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+259630,int_stack+188305,int_stack+147400,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+280690,int_stack+259630,int_stack+217060,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+188305,int_stack+280690,int_stack+234880,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+225430,int_stack+188305,int_stack+157930,45);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+147400,int_stack+22275,int_stack+19800,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+154825,int_stack+25300,int_stack+22275,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+163900,int_stack+154825,int_stack+147400,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+178750,int_stack+28930,int_stack+25300,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+189640,int_stack+178750,int_stack+154825,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+267955,int_stack+189640,int_stack+163900,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+147400,int_stack+33220,int_stack+28930,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+147400,int_stack+178750,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+292705,int_stack+0,int_stack+189640,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+160270,int_stack+292705,int_stack+267955,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+267955,int_stack+38225,int_stack+33220,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+197395,int_stack+267955,int_stack+147400,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+322955,int_stack+197395,int_stack+0,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+359255,int_stack+322955,int_stack+292705,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+267955,int_stack+359255,int_stack+160270,55);
 /*--- compute (lp|lh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+319930,int_stack+267955,int_stack+225430,945);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+46970,int_stack+44000,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8910,int_stack+50600,int_stack+46970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19800,int_stack+8910,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+147400,int_stack+54956,int_stack+50600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+160468,int_stack+147400,int_stack+8910,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+182248,int_stack+160468,int_stack+19800,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+60104,int_stack+54956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15444,int_stack+0,int_stack+147400,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+211948,int_stack+15444,int_stack+160468,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+447505,int_stack+211948,int_stack+182248,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+147400,int_stack+66110,int_stack+60104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+165418,int_stack+147400,int_stack+0,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+492055,int_stack+165418,int_stack+15444,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+492055,int_stack+211948,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+147400,int_stack+0,int_stack+447505,66);
 /*--- compute (mp|lh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+447505,int_stack+147400,int_stack+267955,945);
 /*--- compute (ld|lh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+603430,int_stack+447505,int_stack+319930,945);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+76550,int_stack+73040,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10530,int_stack+80840,int_stack+76550,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23400,int_stack+10530,int_stack+0,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44460,int_stack+85988,int_stack+80840,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+59904,int_stack+44460,int_stack+10530,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+209770,int_stack+59904,int_stack+23400,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+92072,int_stack+85988,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+244870,int_stack+0,int_stack+44460,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+275758,int_stack+244870,int_stack+59904,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+18252,int_stack+275758,int_stack+209770,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+209770,int_stack+99170,int_stack+92072,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+318658,int_stack+209770,int_stack+0,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+355162,int_stack+318658,int_stack+244870,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+209770,int_stack+355162,int_stack+275758,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+274120,int_stack+209770,int_stack+18252,78);
 /*--- compute (np|lh) ---*/
 hrr1_build_np(Libint->AB,int_stack+858580,int_stack+274120,int_stack+147400,945);
 /*--- compute (md|lh) ---*/
 hrr1_build_md(Libint->AB,int_stack+1045690,int_stack+858580,int_stack+447505,945);
 /*--- compute (lf|lh) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1357540,int_stack+1045690,int_stack+603430,945);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+147400,int_stack+111455,int_stack+107360,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+159685,int_stack+116460,int_stack+111455,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+174700,int_stack+159685,int_stack+147400,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+199270,int_stack+122466,int_stack+116460,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+217288,int_stack+199270,int_stack+159685,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+217288,int_stack+174700,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+147400,int_stack+129564,int_stack+122466,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+40950,int_stack+147400,int_stack+199270,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+76986,int_stack+40950,int_stack+217288,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+168694,int_stack+76986,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+137845,int_stack+129564,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+230119,int_stack+0,int_stack+147400,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+347830,int_stack+230119,int_stack+40950,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+347830,int_stack+76986,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+347830,int_stack+0,int_stack+168694,91);
 /*--- compute (op|lh) ---*/
 hrr1_build_op(Libint->AB,int_stack+0,int_stack+347830,int_stack+274120,945);
 /*--- compute (nd|lh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+221130,int_stack+0,int_stack+858580,945);
 /*--- compute (mf|lh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+1782790,int_stack+221130,int_stack+1045690,945);
 /*--- compute (lg|lh) ---*/
 hrr1_build_lg(Libint->AB,int_stack+0,int_stack+1782790,int_stack+1357540,945);
 return int_stack+0;}
