/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lgng(Libint_t*, prim_data*);

  /* Computes quartets of (lg|ng) integrals */

REALTYPE *hrr_order_lgng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[9][10] = int_stack + 20700;
 Libint->vrr_classes[9][11] = int_stack + 24330;
 Libint->vrr_classes[9][12] = int_stack + 28620;
 Libint->vrr_classes[9][13] = int_stack + 33625;
 Libint->vrr_classes[9][14] = int_stack + 39400;
 Libint->vrr_classes[10][10] = int_stack + 46000;
 Libint->vrr_classes[10][11] = int_stack + 50356;
 Libint->vrr_classes[10][12] = int_stack + 55504;
 Libint->vrr_classes[10][13] = int_stack + 61510;
 Libint->vrr_classes[10][14] = int_stack + 68440;
 Libint->vrr_classes[11][10] = int_stack + 76360;
 Libint->vrr_classes[11][11] = int_stack + 81508;
 Libint->vrr_classes[11][12] = int_stack + 87592;
 Libint->vrr_classes[11][13] = int_stack + 94690;
 Libint->vrr_classes[11][14] = int_stack + 102880;
 Libint->vrr_classes[12][10] = int_stack + 112240;
 Libint->vrr_classes[12][11] = int_stack + 118246;
 Libint->vrr_classes[12][12] = int_stack + 125344;
 Libint->vrr_classes[12][13] = int_stack + 133625;
 Libint->vrr_classes[12][14] = int_stack + 143180;
 memset(int_stack,0,154100*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 154100;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lgng(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+154100,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+163010,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+173540,int_stack+163010,int_stack+154100,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+191360,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+203645,int_stack+191360,int_stack+163010,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+224705,int_stack+203645,int_stack+173540,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+154100,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+254405,int_stack+154100,int_stack+191360,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+154100,int_stack+254405,int_stack+203645,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+254405,int_stack+154100,int_stack+224705,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+154100,int_stack+24330,int_stack+20700,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+164990,int_stack+28620,int_stack+24330,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+177860,int_stack+164990,int_stack+154100,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+199640,int_stack+33625,int_stack+28620,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+214655,int_stack+199640,int_stack+164990,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+298955,int_stack+214655,int_stack+177860,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+154100,int_stack+39400,int_stack+33625,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+154100,int_stack+199640,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+154100,int_stack+0,int_stack+214655,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+197000,int_stack+154100,int_stack+298955,55);
 /*--- compute (lp|ng) ---*/
 hrr1_build_lp(Libint->AB,int_stack+298955,int_stack+197000,int_stack+254405,990);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+154100,int_stack+50356,int_stack+46000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+167168,int_stack+55504,int_stack+50356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+167168,int_stack+154100,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+26136,int_stack+61510,int_stack+55504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+251450,int_stack+26136,int_stack+167168,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+432605,int_stack+251450,int_stack+0,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+68440,int_stack+61510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+154100,int_stack+0,int_stack+26136,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+154100,int_stack+251450,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+476165,int_stack+0,int_stack+432605,66);
 /*--- compute (mp|ng) ---*/
 hrr1_build_mp(Libint->AB,int_stack+541505,int_stack+476165,int_stack+197000,990);
 /*--- compute (ld|ng) ---*/
 hrr1_build_ld(Libint->AB,int_stack+704855,int_stack+541505,int_stack+298955,990);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+81508,int_stack+76360,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+87592,int_stack+81508,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+94690,int_stack+87592,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+154100,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+190604,int_stack+154100,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+102880,int_stack+94690,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+242084,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+242084,int_stack+154100,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+242084,int_stack+0,int_stack+190604,78);
 /*--- compute (np|ng) ---*/
 hrr1_build_np(Libint->AB,int_stack+972155,int_stack+242084,int_stack+476165,990);
 /*--- compute (md|ng) ---*/
 hrr1_build_md(Libint->AB,int_stack+1168175,int_stack+972155,int_stack+541505,990);
 /*--- compute (lf|ng) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1494875,int_stack+1168175,int_stack+704855,990);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+118246,int_stack+112240,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+125344,int_stack+118246,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+133625,int_stack+125344,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+154100,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+319304,int_stack+154100,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+143180,int_stack+133625,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+100191,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+100191,int_stack+154100,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+70980,int_stack+0,int_stack+319304,91);
 /*--- compute (op|ng) ---*/
 hrr1_build_op(Libint->AB,int_stack+319304,int_stack+70980,int_stack+242084,990);
 /*--- compute (nd|ng) ---*/
 hrr1_build_nd(Libint->AB,int_stack+550964,int_stack+319304,int_stack+972155,990);
 /*--- compute (mf|ng) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+550964,int_stack+1168175,990);
 /*--- compute (lg|ng) ---*/
 hrr1_build_lg(Libint->AB,int_stack+544500,int_stack+0,int_stack+1494875,990);
 return int_stack+544500;}
