/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lhnn(Libint_t*, prim_data*);

  /* Computes quartets of (lh|nn) integrals */

REALTYPE *hrr_order_lhnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[8][16] = int_stack + 26820;
 Libint->vrr_classes[8][17] = int_stack + 33705;
 Libint->vrr_classes[8][18] = int_stack + 41400;
 Libint->vrr_classes[8][19] = int_stack + 49950;
 Libint->vrr_classes[8][20] = int_stack + 59400;
 Libint->vrr_classes[9][10] = int_stack + 69795;
 Libint->vrr_classes[9][11] = int_stack + 73425;
 Libint->vrr_classes[9][12] = int_stack + 77715;
 Libint->vrr_classes[9][13] = int_stack + 82720;
 Libint->vrr_classes[9][14] = int_stack + 88495;
 Libint->vrr_classes[9][15] = int_stack + 95095;
 Libint->vrr_classes[9][16] = int_stack + 102575;
 Libint->vrr_classes[9][17] = int_stack + 110990;
 Libint->vrr_classes[9][18] = int_stack + 120395;
 Libint->vrr_classes[9][19] = int_stack + 130845;
 Libint->vrr_classes[9][20] = int_stack + 142395;
 Libint->vrr_classes[10][10] = int_stack + 155100;
 Libint->vrr_classes[10][11] = int_stack + 159456;
 Libint->vrr_classes[10][12] = int_stack + 164604;
 Libint->vrr_classes[10][13] = int_stack + 170610;
 Libint->vrr_classes[10][14] = int_stack + 177540;
 Libint->vrr_classes[10][15] = int_stack + 185460;
 Libint->vrr_classes[10][16] = int_stack + 194436;
 Libint->vrr_classes[10][17] = int_stack + 204534;
 Libint->vrr_classes[10][18] = int_stack + 215820;
 Libint->vrr_classes[10][19] = int_stack + 228360;
 Libint->vrr_classes[10][20] = int_stack + 242220;
 Libint->vrr_classes[11][10] = int_stack + 257466;
 Libint->vrr_classes[11][11] = int_stack + 262614;
 Libint->vrr_classes[11][12] = int_stack + 268698;
 Libint->vrr_classes[11][13] = int_stack + 275796;
 Libint->vrr_classes[11][14] = int_stack + 283986;
 Libint->vrr_classes[11][15] = int_stack + 293346;
 Libint->vrr_classes[11][16] = int_stack + 303954;
 Libint->vrr_classes[11][17] = int_stack + 315888;
 Libint->vrr_classes[11][18] = int_stack + 329226;
 Libint->vrr_classes[11][19] = int_stack + 344046;
 Libint->vrr_classes[11][20] = int_stack + 360426;
 Libint->vrr_classes[12][10] = int_stack + 378444;
 Libint->vrr_classes[12][11] = int_stack + 384450;
 Libint->vrr_classes[12][12] = int_stack + 391548;
 Libint->vrr_classes[12][13] = int_stack + 399829;
 Libint->vrr_classes[12][14] = int_stack + 409384;
 Libint->vrr_classes[12][15] = int_stack + 420304;
 Libint->vrr_classes[12][16] = int_stack + 432680;
 Libint->vrr_classes[12][17] = int_stack + 446603;
 Libint->vrr_classes[12][18] = int_stack + 462164;
 Libint->vrr_classes[12][19] = int_stack + 479454;
 Libint->vrr_classes[12][20] = int_stack + 498564;
 Libint->vrr_classes[13][10] = int_stack + 519585;
 Libint->vrr_classes[13][11] = int_stack + 526515;
 Libint->vrr_classes[13][12] = int_stack + 534705;
 Libint->vrr_classes[13][13] = int_stack + 544260;
 Libint->vrr_classes[13][14] = int_stack + 555285;
 Libint->vrr_classes[13][15] = int_stack + 567885;
 Libint->vrr_classes[13][16] = int_stack + 582165;
 Libint->vrr_classes[13][17] = int_stack + 598230;
 Libint->vrr_classes[13][18] = int_stack + 616185;
 Libint->vrr_classes[13][19] = int_stack + 636135;
 Libint->vrr_classes[13][20] = int_stack + 658185;
 memset(int_stack,0,682440*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 682440;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lhnn(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+682440,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+691350,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+701880,int_stack+691350,int_stack+682440,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+719700,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+731985,int_stack+719700,int_stack+691350,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+753045,int_stack+731985,int_stack+701880,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+682440,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+782745,int_stack+682440,int_stack+719700,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+696615,int_stack+782745,int_stack+731985,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+807315,int_stack+696615,int_stack+753045,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+731715,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+747915,int_stack+731715,int_stack+682440,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+851865,int_stack+747915,int_stack+782745,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+892815,int_stack+851865,int_stack+696615,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+945465,int_stack+892815,int_stack+807315,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+682440,int_stack+26820,int_stack+20700,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+776265,int_stack+682440,int_stack+731715,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1007835,int_stack+776265,int_stack+747915,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+700800,int_stack+1007835,int_stack+851865,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+808665,int_stack+700800,int_stack+892815,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1055085,int_stack+808665,int_stack+945465,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+882375,int_stack+33705,int_stack+26820,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+903030,int_stack+882375,int_stack+682440,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+939750,int_stack+903030,int_stack+776265,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1138245,int_stack+939750,int_stack+1007835,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1209120,int_stack+1138245,int_stack+700800,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+682440,int_stack+1209120,int_stack+808665,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1295115,int_stack+682440,int_stack+1055085,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+780720,int_stack+41400,int_stack+33705,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+803805,int_stack+780720,int_stack+882375,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+993750,int_stack+803805,int_stack+903030,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+845115,int_stack+993750,int_stack+939750,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1402035,int_stack+845115,int_stack+1138245,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1054950,int_stack+1402035,int_stack+1209120,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1501260,int_stack+1054950,int_stack+682440,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1627620,int_stack+1501260,int_stack+1295115,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+682440,int_stack+49950,int_stack+41400,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+708090,int_stack+682440,int_stack+780720,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1169610,int_stack+708090,int_stack+803805,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1238460,int_stack+1169610,int_stack+993750,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+926115,int_stack+1238460,int_stack+845115,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+754260,int_stack+926115,int_stack+1402035,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1330260,int_stack+754260,int_stack+1054950,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1761270,int_stack+1330260,int_stack+1501260,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1919220,int_stack+1761270,int_stack+1627620,45);
 /*--- compute (l0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+886560,int_stack+59400,int_stack+49950,45);
 /*--- compute (l0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1039515,int_stack+886560,int_stack+682440,45);
 /*--- compute (l0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1090815,int_stack+1039515,int_stack+708090,45);
 /*--- compute (l0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1477680,int_stack+1090815,int_stack+1169610,45);
 /*--- compute (l0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1039515,int_stack+1477680,int_stack+1238460,45);
 /*--- compute (l0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1477680,int_stack+1039515,int_stack+926115,45);
 /*--- compute (l0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+886560,int_stack+1477680,int_stack+754260,45);
 /*--- compute (l0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1477680,int_stack+886560,int_stack+1330260,45);
 /*--- compute (l0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+682440,int_stack+1477680,int_stack+1761270,45);
 /*--- compute (l0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+875490,int_stack+682440,int_stack+1919220,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+682440,int_stack+73425,int_stack+69795,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+693330,int_stack+77715,int_stack+73425,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+706200,int_stack+693330,int_stack+682440,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+727980,int_stack+82720,int_stack+77715,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+742995,int_stack+727980,int_stack+693330,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+768735,int_stack+742995,int_stack+706200,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+682440,int_stack+88495,int_stack+82720,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+805035,int_stack+682440,int_stack+727980,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+699765,int_stack+805035,int_stack+742995,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1071510,int_stack+699765,int_stack+768735,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+742665,int_stack+95095,int_stack+88495,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+762465,int_stack+742665,int_stack+682440,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1125960,int_stack+762465,int_stack+805035,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+797115,int_stack+1125960,int_stack+699765,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1176010,int_stack+797115,int_stack+1071510,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1071510,int_stack+102575,int_stack+95095,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+682440,int_stack+1071510,int_stack+742665,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1252240,int_stack+682440,int_stack+762465,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+722040,int_stack+1252240,int_stack+1125960,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1309990,int_stack+722040,int_stack+797115,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1400080,int_stack+1309990,int_stack+1176010,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+797115,int_stack+110990,int_stack+102575,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+822360,int_stack+797115,int_stack+1071510,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1071510,int_stack+822360,int_stack+682440,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1137510,int_stack+1071510,int_stack+1252240,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1501720,int_stack+1137510,int_stack+722040,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1606825,int_stack+1501720,int_stack+1309990,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1224135,int_stack+1606825,int_stack+1400080,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+682440,int_stack+120395,int_stack+110990,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+710655,int_stack+682440,int_stack+797115,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1354815,int_stack+710655,int_stack+822360,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+761145,int_stack+1354815,int_stack+1071510,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1726945,int_stack+761145,int_stack+1137510,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1071510,int_stack+1726945,int_stack+1501720,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1429615,int_stack+1071510,int_stack+1606825,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1848220,int_stack+1429615,int_stack+1224135,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1211650,int_stack+130845,int_stack+120395,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1243000,int_stack+1211650,int_stack+682440,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1584055,int_stack+1243000,int_stack+710655,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+1584055,int_stack+1354815,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2011570,int_stack+0,int_stack+761145,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+682440,int_stack+2011570,int_stack+1726945,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2150170,int_stack+682440,int_stack+1071510,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2330350,int_stack+2150170,int_stack+1429615,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1299430,int_stack+2330350,int_stack+1848220,55);
 /*--- compute (m0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1071510,int_stack+142395,int_stack+130845,55);
 /*--- compute (m0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1106160,int_stack+1071510,int_stack+1211650,55);
 /*--- compute (m0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1668205,int_stack+1106160,int_stack+1243000,55);
 /*--- compute (m0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1071510,int_stack+1668205,int_stack+1584055,55);
 /*--- compute (m0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1499080,int_stack+1071510,int_stack+0,55);
 /*--- compute (m0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1071510,int_stack+1499080,int_stack+2011570,55);
 /*--- compute (m0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1499080,int_stack+1071510,int_stack+682440,55);
 /*--- compute (m0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1071510,int_stack+1499080,int_stack+2150170,55);
 /*--- compute (m0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1499080,int_stack+1071510,int_stack+2330350,55);
 /*--- compute (m0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1735030,int_stack+1499080,int_stack+1299430,55);
 /*--- compute (lp|nn) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1071510,int_stack+1735030,int_stack+875490,4356);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1659570,int_stack+159456,int_stack+155100,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1672638,int_stack+164604,int_stack+159456,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1688082,int_stack+1672638,int_stack+1659570,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1714218,int_stack+170610,int_stack+164604,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1974610,int_stack+1714218,int_stack+1672638,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2005498,int_stack+1974610,int_stack+1688082,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1659570,int_stack+177540,int_stack+170610,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2049058,int_stack+1659570,int_stack+1714218,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1680360,int_stack+2049058,int_stack+1974610,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2085094,int_stack+1680360,int_stack+2005498,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1974610,int_stack+185460,int_stack+177540,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1998370,int_stack+1974610,int_stack+1659570,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2150434,int_stack+1998370,int_stack+2049058,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2210494,int_stack+2150434,int_stack+1680360,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2287714,int_stack+2210494,int_stack+2085094,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1659570,int_stack+194436,int_stack+185460,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1686498,int_stack+1659570,int_stack+1974610,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2039950,int_stack+1686498,int_stack+1998370,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2379190,int_stack+2039950,int_stack+2150434,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+682440,int_stack+2379190,int_stack+2210494,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2109250,int_stack+682440,int_stack+2287714,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1974610,int_stack+204534,int_stack+194436,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2231218,int_stack+1974610,int_stack+1659570,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2285074,int_stack+2231218,int_stack+1686498,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+790548,int_stack+2285074,int_stack+2039950,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+894498,int_stack+790548,int_stack+2379190,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2364274,int_stack+894498,int_stack+682440,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2364274,int_stack+2109250,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+682440,int_stack+215820,int_stack+204534,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+716298,int_stack+682440,int_stack+1974610,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1974610,int_stack+716298,int_stack+2231218,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2064370,int_stack+1974610,int_stack+2285074,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2183170,int_stack+2064370,int_stack+790548,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2508418,int_stack+2183170,int_stack+894498,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+776886,int_stack+2508418,int_stack+2364274,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2676586,int_stack+776886,int_stack+0,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+228360,int_stack+215820,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+37620,int_stack+0,int_stack+682440,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+105336,int_stack+37620,int_stack+716298,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2328700,int_stack+105336,int_stack+1974610,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2872606,int_stack+2328700,int_stack+2064370,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1974610,int_stack+2872606,int_stack+2183170,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3038926,int_stack+1974610,int_stack+2508418,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3255142,int_stack+3038926,int_stack+776886,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+682440,int_stack+3255142,int_stack+2676586,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+2168650,int_stack+242220,int_stack+228360,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+2210230,int_stack+2168650,int_stack+0,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+922020,int_stack+2210230,int_stack+37620,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2168650,int_stack+922020,int_stack+105336,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+2168650,int_stack+2328700,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2168650,int_stack+0,int_stack+2872606,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+2168650,int_stack+1974610,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1974610,int_stack+0,int_stack+3038926,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2244880,int_stack+1974610,int_stack+3255142,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2528020,int_stack+2244880,int_stack+682440,66);
 /*--- compute (mp|nn) ---*/
 hrr1_build_mp(Libint->AB,int_stack+2815516,int_stack+2528020,int_stack+1735030,4356);
 /*--- compute (ld|nn) ---*/
 hrr1_build_ld(Libint->AB,int_stack+3534256,int_stack+2815516,int_stack+1071510,4356);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+682440,int_stack+262614,int_stack+257466,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+697884,int_stack+268698,int_stack+262614,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+716136,int_stack+697884,int_stack+682440,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+747024,int_stack+275796,int_stack+268698,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+768318,int_stack+747024,int_stack+697884,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+804822,int_stack+768318,int_stack+716136,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+682440,int_stack+283986,int_stack+275796,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+856302,int_stack+682440,int_stack+747024,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+707010,int_stack+856302,int_stack+768318,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+898890,int_stack+707010,int_stack+804822,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+767850,int_stack+293346,int_stack+283986,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+795930,int_stack+767850,int_stack+682440,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+976110,int_stack+795930,int_stack+856302,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1047090,int_stack+976110,int_stack+707010,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1138350,int_stack+1047090,int_stack+898890,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+682440,int_stack+303954,int_stack+293346,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+845070,int_stack+682440,int_stack+767850,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1246458,int_stack+845070,int_stack+795930,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+714264,int_stack+1246458,int_stack+976110,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+901230,int_stack+714264,int_stack+1047090,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1328358,int_stack+901230,int_stack+1138350,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1028994,int_stack+315888,int_stack+303954,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1064796,int_stack+1028994,int_stack+682440,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1128444,int_stack+1064796,int_stack+845070,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1472502,int_stack+1128444,int_stack+1246458,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1595352,int_stack+1472502,int_stack+714264,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+682440,int_stack+1595352,int_stack+901230,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1744410,int_stack+682440,int_stack+1328358,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+852792,int_stack+329226,int_stack+315888,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+892806,int_stack+852792,int_stack+1028994,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1222044,int_stack+892806,int_stack+1064796,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+964410,int_stack+1222044,int_stack+1128444,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1929738,int_stack+964410,int_stack+1472502,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1328124,int_stack+1929738,int_stack+1595352,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2101728,int_stack+1328124,int_stack+682440,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+2101728,int_stack+1744410,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+682440,int_stack+344046,int_stack+329226,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+726900,int_stack+682440,int_stack+852792,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1526868,int_stack+726900,int_stack+892806,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1646208,int_stack+1526868,int_stack+1222044,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1104810,int_stack+1646208,int_stack+964410,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+806928,int_stack+1104810,int_stack+1929738,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1805328,int_stack+806928,int_stack+1328124,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+4710376,int_stack+1805328,int_stack+2101728,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2060856,int_stack+4710376,int_stack+0,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+360426,int_stack+344046,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+49140,int_stack+0,int_stack+682440,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+138060,int_stack+49140,int_stack+726900,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1301370,int_stack+138060,int_stack+1526868,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+1301370,int_stack+1646208,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1301370,int_stack+0,int_stack+1104810,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+1301370,int_stack+806928,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+682440,int_stack+0,int_stack+1805328,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+682440,int_stack+4710376,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+682440,int_stack+0,int_stack+2060856,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+1022208,int_stack+682440,int_stack+2528020,4356);
 /*--- compute (md|nn) ---*/
 hrr1_build_md(Libint->AB,int_stack+4710376,int_stack+1022208,int_stack+2815516,4356);
 /*--- compute (lf|nn) ---*/
 hrr1_build_lf(Libint->AB,int_stack+6147856,int_stack+4710376,int_stack+3534256,4356);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+384450,int_stack+378444,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+391548,int_stack+384450,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+399829,int_stack+391548,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142779,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+409384,int_stack+399829,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+202839,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+202839,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+252525,int_stack+28665,int_stack+142779,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99645,int_stack+420304,int_stack+409384,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+132405,int_stack+99645,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1884696,int_stack+132405,int_stack+202839,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1967506,int_stack+1884696,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2073976,int_stack+1967506,int_stack+252525,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+432680,int_stack+420304,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+189735,int_stack+0,int_stack+99645,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+255255,int_stack+189735,int_stack+132405,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+37128,int_stack+255255,int_stack+1884696,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2200102,int_stack+37128,int_stack+1967506,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1884696,int_stack+2200102,int_stack+2073976,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2052864,int_stack+446603,int_stack+432680,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2094633,int_stack+2052864,int_stack+0,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2349160,int_stack+2094633,int_stack+189735,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2458360,int_stack+2349160,int_stack+255255,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+161343,int_stack+2458360,int_stack+37128,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2601685,int_stack+161343,int_stack+2200102,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2800429,int_stack+2601685,int_stack+1884696,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1884696,int_stack+462164,int_stack+446603,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1931379,int_stack+1884696,int_stack+2052864,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+1931379,int_stack+2094633,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2014917,int_stack+0,int_stack+2349160,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2178717,int_stack+2014917,int_stack+2458360,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3016645,int_stack+2178717,int_stack+161343,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+123760,int_stack+3016645,int_stack+2601685,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2379372,int_stack+123760,int_stack+2800429,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+2649642,int_stack+479454,int_stack+462164,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+2701512,int_stack+2649642,int_stack+1884696,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2794878,int_stack+2701512,int_stack+1931379,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+3248513,int_stack+2794878,int_stack+0,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3434153,int_stack+3248513,int_stack+2014917,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1884696,int_stack+3434153,int_stack+2178717,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3663473,int_stack+1884696,int_stack+3016645,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3961589,int_stack+3663473,int_stack+123760,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+3961589,int_stack+2379372,91);
 /*--- compute (q0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+330330,int_stack+498564,int_stack+479454,91);
 /*--- compute (q0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+387660,int_stack+330330,int_stack+2649642,91);
 /*--- compute (q0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+2152236,int_stack+387660,int_stack+2701512,91);
 /*--- compute (q0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2307846,int_stack+2152236,int_stack+2794878,91);
 /*--- compute (q0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+2516691,int_stack+2307846,int_stack+3248513,91);
 /*--- compute (q0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2152236,int_stack+2516691,int_stack+3434153,91);
 /*--- compute (q0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+2457996,int_stack+2152236,int_stack+1884696,91);
 /*--- compute (q0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1884696,int_stack+2457996,int_stack+3663473,91);
 /*--- compute (q0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2257341,int_stack+1884696,int_stack+3961589,91);
 /*--- compute (q0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2647731,int_stack+2257341,int_stack+0,91);
 /*--- compute (op|nn) ---*/
 hrr1_build_op(Libint->AB,int_stack+3044127,int_stack+2647731,int_stack+682440,4356);
 /*--- compute (nd|nn) ---*/
 hrr1_build_nd(Libint->AB,int_stack+8108056,int_stack+3044127,int_stack+1022208,4356);
 /*--- compute (mf|nn) ---*/
 hrr1_build_mf(Libint->AB,int_stack+9833032,int_stack+8108056,int_stack+4710376,4356);
 /*--- compute (lg|nn) ---*/
 hrr1_build_lg(Libint->AB,int_stack+12228832,int_stack+9833032,int_stack+6147856,4356);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+682440,int_stack+526515,int_stack+519585,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+703230,int_stack+534705,int_stack+526515,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+727800,int_stack+703230,int_stack+682440,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+769380,int_stack+544260,int_stack+534705,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+798045,int_stack+769380,int_stack+703230,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+847185,int_stack+798045,int_stack+727800,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+682440,int_stack+555285,int_stack+544260,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+916485,int_stack+682440,int_stack+769380,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+715515,int_stack+916485,int_stack+798045,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+973815,int_stack+715515,int_stack+847185,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+797415,int_stack+567885,int_stack+555285,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+835215,int_stack+797415,int_stack+682440,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1077765,int_stack+835215,int_stack+916485,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1173315,int_stack+1077765,int_stack+715515,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1296165,int_stack+1173315,int_stack+973815,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+682440,int_stack+582165,int_stack+567885,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+901365,int_stack+682440,int_stack+797415,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1441695,int_stack+901365,int_stack+835215,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+725280,int_stack+1441695,int_stack+1077765,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+976965,int_stack+725280,int_stack+1173315,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1551945,int_stack+976965,int_stack+1296165,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1148955,int_stack+598230,int_stack+582165,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1197150,int_stack+1148955,int_stack+682440,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1282830,int_stack+1197150,int_stack+901365,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1745985,int_stack+1282830,int_stack+1441695,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1911360,int_stack+1745985,int_stack+725280,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+682440,int_stack+1911360,int_stack+976965,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2112015,int_stack+682440,int_stack+1551945,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+911760,int_stack+616185,int_stack+598230,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+965625,int_stack+911760,int_stack+1148955,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1408830,int_stack+965625,int_stack+1197150,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1062015,int_stack+1408830,int_stack+1282830,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2361495,int_stack+1062015,int_stack+1745985,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1551630,int_stack+2361495,int_stack+1911360,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+1551630,int_stack+682440,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+294840,int_stack+0,int_stack+2112015,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+682440,int_stack+636135,int_stack+616185,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+742290,int_stack+682440,int_stack+911760,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1819170,int_stack+742290,int_stack+965625,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1979820,int_stack+1819170,int_stack+1408830,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1251015,int_stack+1979820,int_stack+1062015,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+850020,int_stack+1251015,int_stack+2361495,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2194020,int_stack+850020,int_stack+1551630,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+4063431,int_stack+2194020,int_stack+0,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+4431981,int_stack+4063431,int_stack+294840,105);
 /*--- compute (r0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+658185,int_stack+636135,105);
 /*--- compute (r0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+66150,int_stack+0,int_stack+682440,105);
 /*--- compute (r0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+185850,int_stack+66150,int_stack+742290,105);
 /*--- compute (r0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+365400,int_stack+185850,int_stack+1819170,105);
 /*--- compute (r0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+365400,int_stack+1979820,105);
 /*--- compute (r0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+299880,int_stack+0,int_stack+1251015,105);
 /*--- compute (r0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1158720,int_stack+299880,int_stack+850020,105);
 /*--- compute (r0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+0,int_stack+1158720,int_stack+2194020,105);
 /*--- compute (r0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+429975,int_stack+0,int_stack+4063431,105);
 /*--- compute (r0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+880425,int_stack+429975,int_stack+4431981,105);
 /*--- compute (qp|nn) ---*/
 hrr1_build_qp(Libint->AB,int_stack+4063431,int_stack+880425,int_stack+2647731,4356);
 /*--- compute (od|nn) ---*/
 hrr1_build_od(Libint->AB,int_stack+5252619,int_stack+4063431,int_stack+3044127,4356);
 /*--- compute (nf|nn) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+5252619,int_stack+8108056,4356);
 /*--- compute (mg|nn) ---*/
 hrr1_build_mg(Libint->AB,int_stack+2874960,int_stack+0,int_stack+9833032,4356);
 /*--- compute (lh|nn) ---*/
 hrr1_build_lh(Libint->AB,int_stack+6468660,int_stack+2874960,int_stack+12228832,4356);
 return int_stack+6468660;}
