/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mdii(Libint_t*, prim_data*);

  /* Computes quartets of (md|ii) integrals */

REALTYPE *hrr_order_mdii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][6] = int_stack + 0;
 Libint->vrr_classes[9][7] = int_stack + 1540;
 Libint->vrr_classes[9][8] = int_stack + 3520;
 Libint->vrr_classes[9][9] = int_stack + 5995;
 Libint->vrr_classes[9][10] = int_stack + 9020;
 Libint->vrr_classes[9][11] = int_stack + 12650;
 Libint->vrr_classes[9][12] = int_stack + 16940;
 Libint->vrr_classes[10][6] = int_stack + 21945;
 Libint->vrr_classes[10][7] = int_stack + 23793;
 Libint->vrr_classes[10][8] = int_stack + 26169;
 Libint->vrr_classes[10][9] = int_stack + 29139;
 Libint->vrr_classes[10][10] = int_stack + 32769;
 Libint->vrr_classes[10][11] = int_stack + 37125;
 Libint->vrr_classes[10][12] = int_stack + 42273;
 Libint->vrr_classes[11][6] = int_stack + 48279;
 Libint->vrr_classes[11][7] = int_stack + 50463;
 Libint->vrr_classes[11][8] = int_stack + 53271;
 Libint->vrr_classes[11][9] = int_stack + 56781;
 Libint->vrr_classes[11][10] = int_stack + 61071;
 Libint->vrr_classes[11][11] = int_stack + 66219;
 Libint->vrr_classes[11][12] = int_stack + 72303;
 memset(int_stack,0,79401*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 79401;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mdii(Libint, Data);
   Data++;
 }
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+79401,int_stack+1540,int_stack+0,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+84021,int_stack+3520,int_stack+1540,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+89961,int_stack+84021,int_stack+79401,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+99201,int_stack+5995,int_stack+3520,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+106626,int_stack+99201,int_stack+84021,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+118506,int_stack+106626,int_stack+89961,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+79401,int_stack+9020,int_stack+5995,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+133906,int_stack+79401,int_stack+99201,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+148756,int_stack+133906,int_stack+106626,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+88476,int_stack+148756,int_stack+118506,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+111576,int_stack+12650,int_stack+9020,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+168556,int_stack+111576,int_stack+79401,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+186706,int_stack+168556,int_stack+133906,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+211456,int_stack+186706,int_stack+148756,55);
 /*--- compute (m0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+122466,int_stack+211456,int_stack+88476,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+79401,int_stack+16940,int_stack+12650,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+79401,int_stack+111576,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+79401,int_stack+0,int_stack+168556,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+241156,int_stack+79401,int_stack+186706,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+79401,int_stack+241156,int_stack+211456,55);
 /*--- compute (m0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+154806,int_stack+79401,int_stack+122466,55);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+79401,int_stack+23793,int_stack+21945,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+84945,int_stack+26169,int_stack+23793,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+92073,int_stack+84945,int_stack+79401,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+103161,int_stack+29139,int_stack+26169,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+112071,int_stack+103161,int_stack+84945,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+126327,int_stack+112071,int_stack+92073,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+79401,int_stack+32769,int_stack+29139,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+79401,int_stack+103161,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+197926,int_stack+0,int_stack+112071,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+90291,int_stack+197926,int_stack+126327,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+118011,int_stack+37125,int_stack+32769,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+131079,int_stack+118011,int_stack+79401,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+221686,int_stack+131079,int_stack+0,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+221686,int_stack+197926,66);
 /*--- compute (n0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+251386,int_stack+0,int_stack+90291,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+197926,int_stack+42273,int_stack+37125,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+79401,int_stack+197926,int_stack+118011,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+290194,int_stack+79401,int_stack+131079,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+79401,int_stack+290194,int_stack+221686,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+197926,int_stack+79401,int_stack+0,66);
 /*--- compute (n0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+79401,int_stack+197926,int_stack+251386,66);
 /*--- compute (mp|ii) ---*/
 hrr1_build_mp(Libint->AB,int_stack+197926,int_stack+79401,int_stack+154806,784);
 /*--- compute (o0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+50463,int_stack+48279,78);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+6552,int_stack+53271,int_stack+50463,78);
 /*--- compute (o0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+14976,int_stack+6552,int_stack+0,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+28080,int_stack+56781,int_stack+53271,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+38610,int_stack+28080,int_stack+6552,78);
 /*--- compute (o0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+131145,int_stack+38610,int_stack+14976,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+61071,int_stack+56781,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+152985,int_stack+0,int_stack+28080,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+327286,int_stack+152985,int_stack+38610,78);
 /*--- compute (o0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+12870,int_stack+327286,int_stack+131145,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+131145,int_stack+66219,int_stack+61071,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+355366,int_stack+131145,int_stack+0,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+381106,int_stack+355366,int_stack+152985,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+146589,int_stack+381106,int_stack+327286,78);
 /*--- compute (o0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+416206,int_stack+146589,int_stack+12870,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+327286,int_stack+72303,int_stack+66219,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+327286,int_stack+131145,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+30888,int_stack+0,int_stack+355366,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+327286,int_stack+30888,int_stack+381106,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+327286,int_stack+146589,78);
 /*--- compute (o0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+327286,int_stack+0,int_stack+416206,78);
 /*--- compute (np|ii) ---*/
 hrr1_build_np(Libint->AB,int_stack+388438,int_stack+327286,int_stack+79401,784);
 /*--- compute (md|ii) ---*/
 hrr1_build_md(Libint->AB,int_stack+543670,int_stack+388438,int_stack+197926,784);
 return int_stack+543670;}
