/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mfkk(Libint_t*, prim_data*);

  /* Computes quartets of (mf|kk) integrals */

REALTYPE *hrr_order_mfkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][7] = int_stack + 0;
 Libint->vrr_classes[9][8] = int_stack + 1980;
 Libint->vrr_classes[9][9] = int_stack + 4455;
 Libint->vrr_classes[9][10] = int_stack + 7480;
 Libint->vrr_classes[9][11] = int_stack + 11110;
 Libint->vrr_classes[9][12] = int_stack + 15400;
 Libint->vrr_classes[9][13] = int_stack + 20405;
 Libint->vrr_classes[9][14] = int_stack + 26180;
 Libint->vrr_classes[10][7] = int_stack + 32780;
 Libint->vrr_classes[10][8] = int_stack + 35156;
 Libint->vrr_classes[10][9] = int_stack + 38126;
 Libint->vrr_classes[10][10] = int_stack + 41756;
 Libint->vrr_classes[10][11] = int_stack + 46112;
 Libint->vrr_classes[10][12] = int_stack + 51260;
 Libint->vrr_classes[10][13] = int_stack + 57266;
 Libint->vrr_classes[10][14] = int_stack + 64196;
 Libint->vrr_classes[11][7] = int_stack + 72116;
 Libint->vrr_classes[11][8] = int_stack + 74924;
 Libint->vrr_classes[11][9] = int_stack + 78434;
 Libint->vrr_classes[11][10] = int_stack + 82724;
 Libint->vrr_classes[11][11] = int_stack + 87872;
 Libint->vrr_classes[11][12] = int_stack + 93956;
 Libint->vrr_classes[11][13] = int_stack + 101054;
 Libint->vrr_classes[11][14] = int_stack + 109244;
 Libint->vrr_classes[12][7] = int_stack + 118604;
 Libint->vrr_classes[12][8] = int_stack + 121880;
 Libint->vrr_classes[12][9] = int_stack + 125975;
 Libint->vrr_classes[12][10] = int_stack + 130980;
 Libint->vrr_classes[12][11] = int_stack + 136986;
 Libint->vrr_classes[12][12] = int_stack + 144084;
 Libint->vrr_classes[12][13] = int_stack + 152365;
 Libint->vrr_classes[12][14] = int_stack + 161920;
 memset(int_stack,0,172840*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 172840;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mfkk(Libint, Data);
   Data++;
 }
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+172840,int_stack+1980,int_stack+0,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+178780,int_stack+4455,int_stack+1980,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+186205,int_stack+178780,int_stack+172840,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+198085,int_stack+7480,int_stack+4455,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+207160,int_stack+198085,int_stack+178780,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+222010,int_stack+207160,int_stack+186205,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+172840,int_stack+11110,int_stack+7480,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+241810,int_stack+172840,int_stack+198085,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+259960,int_stack+241810,int_stack+207160,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+183730,int_stack+259960,int_stack+222010,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+213430,int_stack+15400,int_stack+11110,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+284710,int_stack+213430,int_stack+172840,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+306490,int_stack+284710,int_stack+241810,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+336740,int_stack+306490,int_stack+259960,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+226300,int_stack+336740,int_stack+183730,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+172840,int_stack+20405,int_stack+15400,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+373865,int_stack+172840,int_stack+213430,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+187855,int_stack+373865,int_stack+284710,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+399605,int_stack+187855,int_stack+306490,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+267880,int_stack+399605,int_stack+336740,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+444980,int_stack+267880,int_stack+226300,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+224155,int_stack+26180,int_stack+20405,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+319855,int_stack+224155,int_stack+172840,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+224155,int_stack+319855,int_stack+373865,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+319855,int_stack+224155,int_stack+187855,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+172840,int_stack+319855,int_stack+399605,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+319855,int_stack+172840,int_stack+267880,55);
 /*--- compute (m0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+172840,int_stack+319855,int_stack+444980,55);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+244120,int_stack+35156,int_stack+32780,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+251248,int_stack+38126,int_stack+35156,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+260158,int_stack+251248,int_stack+244120,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+274414,int_stack+41756,int_stack+38126,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+285304,int_stack+274414,int_stack+251248,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+303124,int_stack+285304,int_stack+260158,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+244120,int_stack+46112,int_stack+41756,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+326884,int_stack+244120,int_stack+274414,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+348664,int_stack+326884,int_stack+285304,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+257188,int_stack+348664,int_stack+303124,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+292828,int_stack+51260,int_stack+46112,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+378364,int_stack+292828,int_stack+244120,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+404500,int_stack+378364,int_stack+326884,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+440800,int_stack+404500,int_stack+348664,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+308272,int_stack+440800,int_stack+257188,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+244120,int_stack+57266,int_stack+51260,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+244120,int_stack+292828,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+262138,int_stack+0,int_stack+378364,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+485350,int_stack+262138,int_stack+404500,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+358168,int_stack+485350,int_stack+440800,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+539800,int_stack+358168,int_stack+308272,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+305698,int_stack+64196,int_stack+57266,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+420538,int_stack+305698,int_stack+244120,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+305698,int_stack+420538,int_stack+0,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+305698,int_stack+262138,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+244120,int_stack+0,int_stack+485350,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+420538,int_stack+244120,int_stack+358168,66);
 /*--- compute (n0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+244120,int_stack+420538,int_stack+539800,66);
 /*--- compute (mp|kk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+329656,int_stack+244120,int_stack+172840,1296);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+172840,int_stack+74924,int_stack+72116,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+181264,int_stack+78434,int_stack+74924,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+191794,int_stack+181264,int_stack+172840,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+208642,int_stack+82724,int_stack+78434,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+221512,int_stack+208642,int_stack+181264,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+543496,int_stack+221512,int_stack+191794,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+172840,int_stack+87872,int_stack+82724,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+571576,int_stack+172840,int_stack+208642,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+571576,int_stack+221512,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+188284,int_stack+0,int_stack+543496,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+543496,int_stack+93956,int_stack+87872,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+35100,int_stack+543496,int_stack+172840,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+597316,int_stack+35100,int_stack+571576,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+640216,int_stack+597316,int_stack+0,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+692866,int_stack+640216,int_stack+188284,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+101054,int_stack+93956,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+172840,int_stack+0,int_stack+543496,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+543496,int_stack+172840,int_stack+35100,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+21294,int_stack+543496,int_stack+597316,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+751834,int_stack+21294,int_stack+640216,78);
 /*--- compute (o0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+594976,int_stack+751834,int_stack+692866,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+673600,int_stack+109244,int_stack+101054,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+698170,int_stack+673600,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+825544,int_stack+698170,int_stack+172840,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+673600,int_stack+825544,int_stack+543496,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+825544,int_stack+673600,int_stack+21294,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+825544,int_stack+751834,78);
 /*--- compute (o0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+673600,int_stack+0,int_stack+594976,78);
 /*--- compute (np|kk) ---*/
 hrr1_build_np(Libint->AB,int_stack+774688,int_stack+673600,int_stack+244120,1296);
 /*--- compute (md|kk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1031296,int_stack+774688,int_stack+329656,1296);
 /*--- compute (q0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+121880,int_stack+118604,91);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+9828,int_stack+125975,int_stack+121880,91);
 /*--- compute (q0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+22113,int_stack+9828,int_stack+0,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41769,int_stack+130980,int_stack+125975,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+56784,int_stack+41769,int_stack+9828,91);
 /*--- compute (q0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+81354,int_stack+56784,int_stack+22113,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+136986,int_stack+130980,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+172840,int_stack+0,int_stack+41769,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+202870,int_stack+172840,int_stack+56784,91);
 /*--- compute (q0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+18018,int_stack+202870,int_stack+81354,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+67158,int_stack+144084,int_stack+136986,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+88452,int_stack+67158,int_stack+0,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+243820,int_stack+88452,int_stack+172840,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+293870,int_stack+243820,int_stack+202870,91);
 /*--- compute (q0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+172840,int_stack+293870,int_stack+18018,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+152365,int_stack+144084,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+355295,int_stack+0,int_stack+67158,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+24843,int_stack+355295,int_stack+88452,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+397883,int_stack+24843,int_stack+243820,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+472958,int_stack+397883,int_stack+293870,91);
 /*--- compute (q0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+241636,int_stack+472958,int_stack+172840,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+172840,int_stack+161920,int_stack+152365,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+84903,int_stack+172840,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+134589,int_stack+84903,int_stack+355295,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+558953,int_stack+134589,int_stack+24843,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+558953,int_stack+397883,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+105105,int_stack+0,int_stack+472958,91);
 /*--- compute (q0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+333364,int_stack+105105,int_stack+241636,91);
 /*--- compute (op|kk) ---*/
 hrr1_build_op(Libint->AB,int_stack+0,int_stack+333364,int_stack+673600,1296);
 /*--- compute (nd|kk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1458976,int_stack+0,int_stack+774688,1296);
 /*--- compute (mf|kk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+1458976,int_stack+1031296,1296);
 return int_stack+0;}
