/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mfmm(Libint_t*, prim_data*);

  /* Computes quartets of (mf|mm) integrals */

REALTYPE *hrr_order_mfmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[9][15] = int_stack + 28325;
 Libint->vrr_classes[9][16] = int_stack + 35805;
 Libint->vrr_classes[9][17] = int_stack + 44220;
 Libint->vrr_classes[9][18] = int_stack + 53625;
 Libint->vrr_classes[10][9] = int_stack + 64075;
 Libint->vrr_classes[10][10] = int_stack + 67705;
 Libint->vrr_classes[10][11] = int_stack + 72061;
 Libint->vrr_classes[10][12] = int_stack + 77209;
 Libint->vrr_classes[10][13] = int_stack + 83215;
 Libint->vrr_classes[10][14] = int_stack + 90145;
 Libint->vrr_classes[10][15] = int_stack + 98065;
 Libint->vrr_classes[10][16] = int_stack + 107041;
 Libint->vrr_classes[10][17] = int_stack + 117139;
 Libint->vrr_classes[10][18] = int_stack + 128425;
 Libint->vrr_classes[11][9] = int_stack + 140965;
 Libint->vrr_classes[11][10] = int_stack + 145255;
 Libint->vrr_classes[11][11] = int_stack + 150403;
 Libint->vrr_classes[11][12] = int_stack + 156487;
 Libint->vrr_classes[11][13] = int_stack + 163585;
 Libint->vrr_classes[11][14] = int_stack + 171775;
 Libint->vrr_classes[11][15] = int_stack + 181135;
 Libint->vrr_classes[11][16] = int_stack + 191743;
 Libint->vrr_classes[11][17] = int_stack + 203677;
 Libint->vrr_classes[11][18] = int_stack + 217015;
 Libint->vrr_classes[12][9] = int_stack + 231835;
 Libint->vrr_classes[12][10] = int_stack + 236840;
 Libint->vrr_classes[12][11] = int_stack + 242846;
 Libint->vrr_classes[12][12] = int_stack + 249944;
 Libint->vrr_classes[12][13] = int_stack + 258225;
 Libint->vrr_classes[12][14] = int_stack + 267780;
 Libint->vrr_classes[12][15] = int_stack + 278700;
 Libint->vrr_classes[12][16] = int_stack + 291076;
 Libint->vrr_classes[12][17] = int_stack + 304999;
 Libint->vrr_classes[12][18] = int_stack + 320560;
 memset(int_stack,0,337850*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 337850;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mfmm(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+337850,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+346925,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+357815,int_stack+346925,int_stack+337850,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+375965,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+388835,int_stack+375965,int_stack+346925,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+410615,int_stack+388835,int_stack+357815,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+337850,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+440865,int_stack+337850,int_stack+375965,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+466605,int_stack+440865,int_stack+388835,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+352865,int_stack+466605,int_stack+410615,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+398240,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+502905,int_stack+398240,int_stack+337850,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+532935,int_stack+502905,int_stack+440865,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+575835,int_stack+532935,int_stack+466605,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+415565,int_stack+575835,int_stack+352865,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+337850,int_stack+28325,int_stack+21725,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+357650,int_stack+337850,int_stack+398240,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+630285,int_stack+357650,int_stack+502905,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+680335,int_stack+630285,int_stack+532935,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+479090,int_stack+680335,int_stack+575835,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+744685,int_stack+479090,int_stack+415565,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+392300,int_stack+35805,int_stack+28325,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+414740,int_stack+392300,int_stack+337850,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+555320,int_stack+414740,int_stack+357650,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+829385,int_stack+555320,int_stack+630285,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+904460,int_stack+829385,int_stack+680335,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+613070,int_stack+904460,int_stack+479090,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+994550,int_stack+613070,int_stack+744685,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+337850,int_stack+44220,int_stack+35805,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+454340,int_stack+337850,int_stack+392300,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+714710,int_stack+454340,int_stack+414740,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+363095,int_stack+714710,int_stack+555320,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+499220,int_stack+363095,int_stack+829385,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+780710,int_stack+499220,int_stack+904460,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1103450,int_stack+780710,int_stack+613070,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1234130,int_stack+1103450,int_stack+994550,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+604325,int_stack+53625,int_stack+44220,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+632540,int_stack+604325,int_stack+337850,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+900830,int_stack+632540,int_stack+454340,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+604325,int_stack+900830,int_stack+714710,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+900830,int_stack+604325,int_stack+363095,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+604325,int_stack+900830,int_stack+499220,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+900830,int_stack+604325,int_stack+780710,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+337850,int_stack+900830,int_stack+1103450,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+501200,int_stack+337850,int_stack+1234130,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+337850,int_stack+67705,int_stack+64075,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+348740,int_stack+72061,int_stack+67705,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+361808,int_stack+348740,int_stack+337850,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+383588,int_stack+77209,int_stack+72061,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+399032,int_stack+383588,int_stack+348740,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+425168,int_stack+399032,int_stack+361808,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+337850,int_stack+83215,int_stack+77209,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+461468,int_stack+337850,int_stack+383588,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+667575,int_stack+461468,int_stack+399032,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+355868,int_stack+667575,int_stack+425168,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+410318,int_stack+90145,int_stack+83215,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+711135,int_stack+410318,int_stack+337850,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+747171,int_stack+711135,int_stack+461468,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+431108,int_stack+747171,int_stack+667575,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+798651,int_stack+431108,int_stack+355868,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+667575,int_stack+98065,int_stack+90145,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+337850,int_stack+667575,int_stack+410318,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+874881,int_stack+337850,int_stack+711135,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+934941,int_stack+874881,int_stack+747171,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+691335,int_stack+934941,int_stack+431108,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+379430,int_stack+691335,int_stack+798651,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+782811,int_stack+107041,int_stack+98065,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+809739,int_stack+782811,int_stack+667575,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1012161,int_stack+809739,int_stack+337850,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1081461,int_stack+1012161,int_stack+874881,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1171551,int_stack+1081461,int_stack+934941,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+857259,int_stack+1171551,int_stack+691335,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1279659,int_stack+857259,int_stack+379430,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+337850,int_stack+117139,int_stack+107041,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+368144,int_stack+337850,int_stack+782811,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+422000,int_stack+368144,int_stack+809739,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+667575,int_stack+422000,int_stack+1012161,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1410339,int_stack+667575,int_stack+1081461,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+979227,int_stack+1410339,int_stack+1171551,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1536465,int_stack+979227,int_stack+857259,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+771525,int_stack+1536465,int_stack+1279659,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+934875,int_stack+128425,int_stack+117139,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1123371,int_stack+934875,int_stack+337850,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1183959,int_stack+1123371,int_stack+368144,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1273719,int_stack+1183959,int_stack+422000,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1123371,int_stack+1273719,int_stack+667575,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1693281,int_stack+1123371,int_stack+1410339,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1123371,int_stack+1693281,int_stack+979227,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1308699,int_stack+1123371,int_stack+1536465,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1504719,int_stack+1308699,int_stack+771525,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+667575,int_stack+1504719,int_stack+501200,3025);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1704369,int_stack+145255,int_stack+140965,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1717239,int_stack+150403,int_stack+145255,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1732683,int_stack+1717239,int_stack+1704369,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1758423,int_stack+156487,int_stack+150403,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1776675,int_stack+1758423,int_stack+1717239,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1807563,int_stack+1776675,int_stack+1732683,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1704369,int_stack+163585,int_stack+156487,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1166700,int_stack+1704369,int_stack+1758423,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1203204,int_stack+1166700,int_stack+1776675,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1725663,int_stack+1203204,int_stack+1807563,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1790013,int_stack+171775,int_stack+163585,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1814583,int_stack+1790013,int_stack+1704369,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1254684,int_stack+1814583,int_stack+1166700,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1315524,int_stack+1254684,int_stack+1203204,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1392744,int_stack+1315524,int_stack+1725663,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1166700,int_stack+181135,int_stack+171775,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1194780,int_stack+1166700,int_stack+1790013,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1704369,int_stack+1194780,int_stack+1814583,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+337850,int_stack+1704369,int_stack+1254684,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+429110,int_stack+337850,int_stack+1315524,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1243920,int_stack+429110,int_stack+1392744,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1364040,int_stack+191743,int_stack+181135,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1395864,int_stack+1364040,int_stack+1166700,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1775349,int_stack+1395864,int_stack+1194780,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+537218,int_stack+1775349,int_stack+1704369,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+537218,int_stack+337850,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1857249,int_stack+0,int_stack+429110,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+337850,int_stack+1857249,int_stack+1243920,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+492290,int_stack+203677,int_stack+191743,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1704369,int_stack+492290,int_stack+1364040,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1166700,int_stack+1704369,int_stack+1395864,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1260300,int_stack+1166700,int_stack+1775349,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2001393,int_stack+1260300,int_stack+537218,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2150451,int_stack+2001393,int_stack+0,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2150451,int_stack+1857249,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1768017,int_stack+0,int_stack+337850,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+337850,int_stack+217015,int_stack+203677,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+377864,int_stack+337850,int_stack+492290,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+449468,int_stack+377864,int_stack+1704369,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2320803,int_stack+449468,int_stack+1166700,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+337850,int_stack+2320803,int_stack+1260300,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1166700,int_stack+337850,int_stack+2001393,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+337850,int_stack+1166700,int_stack+2150451,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1166700,int_stack+337850,int_stack+0,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+337850,int_stack+1166700,int_stack+1768017,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+1704369,int_stack+337850,int_stack+1504719,3025);
 /*--- compute (md|mm) ---*/
 hrr1_build_md(Libint->AB,int_stack+2303319,int_stack+1704369,int_stack+667575,3025);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+236840,int_stack+231835,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+242846,int_stack+236840,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+249944,int_stack+242846,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+120393,int_stack+84357,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+258225,int_stack+249944,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+170443,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+573800,int_stack+170443,int_stack+84357,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+24843,int_stack+573800,int_stack+120393,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+99918,int_stack+267780,int_stack+258225,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+213031,int_stack+99918,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+633860,int_stack+213031,int_stack+170443,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+704840,int_stack+633860,int_stack+573800,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+794930,int_stack+704840,int_stack+24843,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+573800,int_stack+278700,int_stack+267780,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+573800,int_stack+99918,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+57330,int_stack+0,int_stack+213031,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+140140,int_stack+57330,int_stack+633860,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+900035,int_stack+140140,int_stack+704840,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+606560,int_stack+900035,int_stack+794930,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+746700,int_stack+291076,int_stack+278700,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+783828,int_stack+746700,int_stack+573800,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1026161,int_stack+783828,int_stack+0,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1121711,int_stack+1026161,int_stack+57330,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1245926,int_stack+1121711,int_stack+140140,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1245926,int_stack+900035,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1394984,int_stack+0,int_stack+606560,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+168168,int_stack+304999,int_stack+291076,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+209937,int_stack+168168,int_stack+746700,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+573800,int_stack+209937,int_stack+783828,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+683000,int_stack+573800,int_stack+1026161,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+826325,int_stack+683000,int_stack+1121711,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1000226,int_stack+826325,int_stack+1245926,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3301569,int_stack+1000226,int_stack+0,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3517785,int_stack+3301569,int_stack+1394984,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+320560,int_stack+304999,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+46683,int_stack+0,int_stack+168168,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1198970,int_stack+46683,int_stack+209937,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+1198970,int_stack+573800,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1198970,int_stack+0,int_stack+683000,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+1198970,int_stack+826325,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1198970,int_stack+0,int_stack+1000226,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1198970,int_stack+3301569,91);
 /*--- compute (q0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+573800,int_stack+0,int_stack+3517785,91);
 /*--- compute (op|mm) ---*/
 hrr1_build_op(Libint->AB,int_stack+849075,int_stack+573800,int_stack+337850,3025);
 /*--- compute (nd|mm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3301569,int_stack+849075,int_stack+1704369,3025);
 /*--- compute (mf|mm) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+3301569,int_stack+2303319,3025);
 return int_stack+0;}
