/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mgmh(Libint_t*, prim_data*);

  /* Computes quartets of (mg|mh) integrals */

REALTYPE *hrr_order_mgmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[10][9] = int_stack + 28325;
 Libint->vrr_classes[10][10] = int_stack + 31955;
 Libint->vrr_classes[10][11] = int_stack + 36311;
 Libint->vrr_classes[10][12] = int_stack + 41459;
 Libint->vrr_classes[10][13] = int_stack + 47465;
 Libint->vrr_classes[10][14] = int_stack + 54395;
 Libint->vrr_classes[11][9] = int_stack + 62315;
 Libint->vrr_classes[11][10] = int_stack + 66605;
 Libint->vrr_classes[11][11] = int_stack + 71753;
 Libint->vrr_classes[11][12] = int_stack + 77837;
 Libint->vrr_classes[11][13] = int_stack + 84935;
 Libint->vrr_classes[11][14] = int_stack + 93125;
 Libint->vrr_classes[12][9] = int_stack + 102485;
 Libint->vrr_classes[12][10] = int_stack + 107490;
 Libint->vrr_classes[12][11] = int_stack + 113496;
 Libint->vrr_classes[12][12] = int_stack + 120594;
 Libint->vrr_classes[12][13] = int_stack + 128875;
 Libint->vrr_classes[12][14] = int_stack + 138430;
 Libint->vrr_classes[13][9] = int_stack + 149350;
 Libint->vrr_classes[13][10] = int_stack + 155125;
 Libint->vrr_classes[13][11] = int_stack + 162055;
 Libint->vrr_classes[13][12] = int_stack + 170245;
 Libint->vrr_classes[13][13] = int_stack + 179800;
 Libint->vrr_classes[13][14] = int_stack + 190825;
 memset(int_stack,0,203425*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 203425;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mgmh(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+203425,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+212500,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+223390,int_stack+212500,int_stack+203425,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+241540,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+254410,int_stack+241540,int_stack+212500,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+276190,int_stack+254410,int_stack+223390,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+203425,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+306440,int_stack+203425,int_stack+241540,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+332180,int_stack+306440,int_stack+254410,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+218440,int_stack+332180,int_stack+276190,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+263815,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+368480,int_stack+263815,int_stack+203425,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+398510,int_stack+368480,int_stack+306440,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+263815,int_stack+398510,int_stack+332180,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+318265,int_stack+263815,int_stack+218440,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+203425,int_stack+31955,int_stack+28325,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+214315,int_stack+36311,int_stack+31955,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+227383,int_stack+214315,int_stack+203425,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+249163,int_stack+41459,int_stack+36311,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+264607,int_stack+249163,int_stack+214315,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+381790,int_stack+264607,int_stack+227383,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+203425,int_stack+47465,int_stack+41459,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+203425,int_stack+249163,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+418090,int_stack+0,int_stack+264607,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+221443,int_stack+418090,int_stack+381790,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+381790,int_stack+54395,int_stack+47465,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+275893,int_stack+381790,int_stack+203425,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+461650,int_stack+275893,int_stack+0,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+513130,int_stack+461650,int_stack+418090,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+381790,int_stack+513130,int_stack+221443,66);
 /*--- compute (mp|mh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+458020,int_stack+381790,int_stack+318265,1155);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+66605,int_stack+62315,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+71753,int_stack+66605,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+203425,int_stack+77837,int_stack+71753,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+221677,int_stack+203425,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+252565,int_stack+221677,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+84935,int_stack+77837,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+21294,int_stack+0,int_stack+203425,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+295465,int_stack+21294,int_stack+221677,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+648595,int_stack+295465,int_stack+252565,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+203425,int_stack+93125,int_stack+84935,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+227995,int_stack+203425,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+712945,int_stack+227995,int_stack+21294,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+712945,int_stack+295465,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+203425,int_stack+0,int_stack+648595,78);
 /*--- compute (np|mh) ---*/
 hrr1_build_np(Libint->AB,int_stack+648595,int_stack+203425,int_stack+381790,1155);
 /*--- compute (md|mh) ---*/
 hrr1_build_md(Libint->AB,int_stack+877285,int_stack+648595,int_stack+458020,1155);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+107490,int_stack+102485,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+113496,int_stack+107490,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+120594,int_stack+113496,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+293515,int_stack+84357,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+128875,int_stack+120594,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+343565,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+386153,int_stack+343565,int_stack+84357,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+24843,int_stack+386153,int_stack+293515,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+293515,int_stack+138430,int_stack+128875,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+446213,int_stack+293515,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+495899,int_stack+446213,int_stack+343565,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+293515,int_stack+495899,int_stack+386153,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+383605,int_stack+293515,int_stack+24843,91);
 /*--- compute (op|mh) ---*/
 hrr1_build_op(Libint->AB,int_stack+1258435,int_stack+383605,int_stack+203425,1155);
 /*--- compute (nd|mh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1528705,int_stack+1258435,int_stack+648595,1155);
 /*--- compute (mf|mh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+1986085,int_stack+1528705,int_stack+877285,1155);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+203425,int_stack+155125,int_stack+149350,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+220750,int_stack+162055,int_stack+155125,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+241540,int_stack+220750,int_stack+203425,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+276190,int_stack+170245,int_stack+162055,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+300760,int_stack+276190,int_stack+220750,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+300760,int_stack+241540,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+203425,int_stack+179800,int_stack+170245,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+57750,int_stack+203425,int_stack+276190,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+106890,int_stack+57750,int_stack+300760,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+232090,int_stack+106890,int_stack+0,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+190825,int_stack+179800,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+318715,int_stack+0,int_stack+203425,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+488710,int_stack+318715,int_stack+57750,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+488710,int_stack+106890,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+488710,int_stack+0,int_stack+232090,105);
 /*--- compute (qp|mh) ---*/
 hrr1_build_qp(Libint->AB,int_stack+0,int_stack+488710,int_stack+383605,1155);
 /*--- compute (od|mh) ---*/
 hrr1_build_od(Libint->AB,int_stack+315315,int_stack+0,int_stack+1258435,1155);
 /*--- compute (nf|mh) ---*/
 hrr1_build_nf(Libint->AB,int_stack+2621335,int_stack+315315,int_stack+1528705,1155);
 /*--- compute (mg|mh) ---*/
 hrr1_build_mg(Libint->AB,int_stack+0,int_stack+2621335,int_stack+1986085,1155);
 return int_stack+0;}
