/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mhnl(Libint_t*, prim_data*);

  /* Computes quartets of (mh|nl) integrals */

REALTYPE *hrr_order_mhnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[9][17] = int_stack + 41195;
 Libint->vrr_classes[9][18] = int_stack + 50600;
 Libint->vrr_classes[10][10] = int_stack + 61050;
 Libint->vrr_classes[10][11] = int_stack + 65406;
 Libint->vrr_classes[10][12] = int_stack + 70554;
 Libint->vrr_classes[10][13] = int_stack + 76560;
 Libint->vrr_classes[10][14] = int_stack + 83490;
 Libint->vrr_classes[10][15] = int_stack + 91410;
 Libint->vrr_classes[10][16] = int_stack + 100386;
 Libint->vrr_classes[10][17] = int_stack + 110484;
 Libint->vrr_classes[10][18] = int_stack + 121770;
 Libint->vrr_classes[11][10] = int_stack + 134310;
 Libint->vrr_classes[11][11] = int_stack + 139458;
 Libint->vrr_classes[11][12] = int_stack + 145542;
 Libint->vrr_classes[11][13] = int_stack + 152640;
 Libint->vrr_classes[11][14] = int_stack + 160830;
 Libint->vrr_classes[11][15] = int_stack + 170190;
 Libint->vrr_classes[11][16] = int_stack + 180798;
 Libint->vrr_classes[11][17] = int_stack + 192732;
 Libint->vrr_classes[11][18] = int_stack + 206070;
 Libint->vrr_classes[12][10] = int_stack + 220890;
 Libint->vrr_classes[12][11] = int_stack + 226896;
 Libint->vrr_classes[12][12] = int_stack + 233994;
 Libint->vrr_classes[12][13] = int_stack + 242275;
 Libint->vrr_classes[12][14] = int_stack + 251830;
 Libint->vrr_classes[12][15] = int_stack + 262750;
 Libint->vrr_classes[12][16] = int_stack + 275126;
 Libint->vrr_classes[12][17] = int_stack + 289049;
 Libint->vrr_classes[12][18] = int_stack + 304610;
 Libint->vrr_classes[13][10] = int_stack + 321900;
 Libint->vrr_classes[13][11] = int_stack + 328830;
 Libint->vrr_classes[13][12] = int_stack + 337020;
 Libint->vrr_classes[13][13] = int_stack + 346575;
 Libint->vrr_classes[13][14] = int_stack + 357600;
 Libint->vrr_classes[13][15] = int_stack + 370200;
 Libint->vrr_classes[13][16] = int_stack + 384480;
 Libint->vrr_classes[13][17] = int_stack + 400545;
 Libint->vrr_classes[13][18] = int_stack + 418500;
 Libint->vrr_classes[14][10] = int_stack + 438450;
 Libint->vrr_classes[14][11] = int_stack + 446370;
 Libint->vrr_classes[14][12] = int_stack + 455730;
 Libint->vrr_classes[14][13] = int_stack + 466650;
 Libint->vrr_classes[14][14] = int_stack + 479250;
 Libint->vrr_classes[14][15] = int_stack + 493650;
 Libint->vrr_classes[14][16] = int_stack + 509970;
 Libint->vrr_classes[14][17] = int_stack + 528330;
 Libint->vrr_classes[14][18] = int_stack + 548850;
 memset(int_stack,0,571650*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 571650;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mhnl(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+571650,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+582540,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+595410,int_stack+582540,int_stack+571650,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+617190,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+632205,int_stack+617190,int_stack+582540,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+657945,int_stack+632205,int_stack+595410,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+571650,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+694245,int_stack+571650,int_stack+617190,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+588975,int_stack+694245,int_stack+632205,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+724275,int_stack+588975,int_stack+657945,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+631875,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+651675,int_stack+631875,int_stack+571650,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+778725,int_stack+651675,int_stack+694245,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+828775,int_stack+778725,int_stack+588975,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+893125,int_stack+828775,int_stack+724275,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+571650,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+686325,int_stack+571650,int_stack+631875,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+969355,int_stack+686325,int_stack+651675,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+594090,int_stack+969355,int_stack+778725,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+725925,int_stack+594090,int_stack+828775,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1027105,int_stack+725925,int_stack+893125,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+816015,int_stack+41195,int_stack+32780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+841260,int_stack+816015,int_stack+571650,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+886140,int_stack+841260,int_stack+686325,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1128745,int_stack+886140,int_stack+969355,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1215370,int_stack+1128745,int_stack+594090,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+571650,int_stack+1215370,int_stack+725925,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1320475,int_stack+571650,int_stack+1027105,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+691770,int_stack+50600,int_stack+41195,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+719985,int_stack+691770,int_stack+816015,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+952140,int_stack+719985,int_stack+841260,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+691770,int_stack+952140,int_stack+886140,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+790770,int_stack+691770,int_stack+1128745,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+912045,int_stack+790770,int_stack+1215370,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+691770,int_stack+912045,int_stack+571650,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+846210,int_stack+691770,int_stack+1320475,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+571650,int_stack+65406,int_stack+61050,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+584718,int_stack+70554,int_stack+65406,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+600162,int_stack+584718,int_stack+571650,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+626298,int_stack+76560,int_stack+70554,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+644316,int_stack+626298,int_stack+584718,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+675204,int_stack+644316,int_stack+600162,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+571650,int_stack+83490,int_stack+76560,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+718764,int_stack+571650,int_stack+626298,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+592440,int_stack+718764,int_stack+644316,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+754800,int_stack+592440,int_stack+675204,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+643920,int_stack+91410,int_stack+83490,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+667680,int_stack+643920,int_stack+571650,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1009560,int_stack+667680,int_stack+718764,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1069620,int_stack+1009560,int_stack+592440,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1146840,int_stack+1069620,int_stack+754800,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+571650,int_stack+100386,int_stack+91410,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+709260,int_stack+571650,int_stack+643920,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+756780,int_stack+709260,int_stack+667680,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+598578,int_stack+756780,int_stack+1009560,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1238316,int_stack+598578,int_stack+1069620,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1009560,int_stack+1238316,int_stack+1146840,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1131528,int_stack+110484,int_stack+100386,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1161822,int_stack+1131528,int_stack+571650,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1346424,int_stack+1161822,int_stack+709260,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+1346424,int_stack+756780,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+688668,int_stack+0,int_stack+598578,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1425624,int_stack+688668,int_stack+1238316,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1569768,int_stack+1425624,int_stack+1009560,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1009560,int_stack+121770,int_stack+110484,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1043418,int_stack+1009560,int_stack+1131528,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+571650,int_stack+1043418,int_stack+1161822,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1009560,int_stack+571650,int_stack+1346424,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1128360,int_stack+1009560,int_stack+0,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1726584,int_stack+1128360,int_stack+688668,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1009560,int_stack+1726584,int_stack+1425624,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1194888,int_stack+1009560,int_stack+1569768,66);
 /*--- compute (mp|nl) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1390908,int_stack+1194888,int_stack+846210,2970);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+139458,int_stack+134310,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+145542,int_stack+139458,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+152640,int_stack+145542,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+571650,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+160830,int_stack+152640,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+623130,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+623130,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+665718,int_stack+24570,int_stack+571650,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+571650,int_stack+170190,int_stack+160830,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+85410,int_stack+571650,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+742938,int_stack+85410,int_stack+623130,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+813918,int_stack+742938,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+905178,int_stack+813918,int_stack+665718,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+180798,int_stack+170190,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+599730,int_stack+0,int_stack+571650,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+655890,int_stack+599730,int_stack+85410,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+31824,int_stack+655890,int_stack+742938,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1013286,int_stack+31824,int_stack+813918,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+737790,int_stack+1013286,int_stack+905178,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+138294,int_stack+192732,int_stack+180798,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+881934,int_stack+138294,int_stack+0,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1880958,int_stack+881934,int_stack+599730,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1974558,int_stack+1880958,int_stack+655890,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+571650,int_stack+1974558,int_stack+31824,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2097408,int_stack+571650,int_stack+1013286,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+945582,int_stack+2097408,int_stack+737790,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+206070,int_stack+192732,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+40014,int_stack+0,int_stack+138294,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+111618,int_stack+40014,int_stack+881934,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+720708,int_stack+111618,int_stack+1880958,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+720708,int_stack+1974558,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+720708,int_stack+0,int_stack+571650,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+720708,int_stack+2097408,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+571650,int_stack+0,int_stack+945582,78);
 /*--- compute (np|nl) ---*/
 hrr1_build_np(Libint->AB,int_stack+1880958,int_stack+571650,int_stack+1194888,2970);
 /*--- compute (md|nl) ---*/
 hrr1_build_md(Libint->AB,int_stack+2469018,int_stack+1880958,int_stack+1390908,2970);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+226896,int_stack+220890,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+233994,int_stack+226896,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+242275,int_stack+233994,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142779,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+251830,int_stack+242275,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+803310,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+803310,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+852996,int_stack+28665,int_stack+142779,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99645,int_stack+262750,int_stack+251830,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+132405,int_stack+99645,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+943086,int_stack+132405,int_stack+803310,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1025896,int_stack+943086,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1132366,int_stack+1025896,int_stack+852996,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+803310,int_stack+275126,int_stack+262750,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+840438,int_stack+803310,int_stack+99645,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+840438,int_stack+132405,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+95550,int_stack+0,int_stack+943086,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1258492,int_stack+95550,int_stack+1025896,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+905958,int_stack+1258492,int_stack+1132366,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1074126,int_stack+289049,int_stack+275126,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1115895,int_stack+1074126,int_stack+803310,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1407550,int_stack+1115895,int_stack+840438,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1516750,int_stack+1407550,int_stack+0,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1660075,int_stack+1516750,int_stack+95550,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1660075,int_stack+1258492,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1190151,int_stack+0,int_stack+905958,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+198744,int_stack+304610,int_stack+289049,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+803310,int_stack+198744,int_stack+1074126,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+886848,int_stack+803310,int_stack+1115895,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1010608,int_stack+886848,int_stack+1407550,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+803310,int_stack+1010608,int_stack+1516750,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1406367,int_stack+803310,int_stack+1660075,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+803310,int_stack+1406367,int_stack+0,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+803310,int_stack+1190151,91);
 /*--- compute (op|nl) ---*/
 hrr1_build_op(Libint->AB,int_stack+803310,int_stack+0,int_stack+571650,2970);
 /*--- compute (nd|nl) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3449118,int_stack+803310,int_stack+1880958,2970);
 /*--- compute (mf|nl) ---*/
 hrr1_build_mf(Libint->AB,int_stack+4625238,int_stack+3449118,int_stack+2469018,2970);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+571650,int_stack+328830,int_stack+321900,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+592440,int_stack+337020,int_stack+328830,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+617010,int_stack+592440,int_stack+571650,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+658590,int_stack+346575,int_stack+337020,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+687255,int_stack+658590,int_stack+592440,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1498290,int_stack+687255,int_stack+617010,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+571650,int_stack+357600,int_stack+346575,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+736395,int_stack+571650,int_stack+658590,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+604725,int_stack+736395,int_stack+687255,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1567590,int_stack+604725,int_stack+1498290,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1498290,int_stack+370200,int_stack+357600,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1671540,int_stack+1498290,int_stack+571650,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1737690,int_stack+1671540,int_stack+736395,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1833240,int_stack+1737690,int_stack+604725,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+571650,int_stack+1833240,int_stack+1567590,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+717180,int_stack+384480,int_stack+370200,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1536090,int_stack+717180,int_stack+1498290,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1956090,int_stack+1536090,int_stack+1671540,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2066340,int_stack+1956090,int_stack+1737690,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1611690,int_stack+2066340,int_stack+1833240,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2209665,int_stack+1611690,int_stack+571650,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+571650,int_stack+400545,int_stack+384480,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+619845,int_stack+571650,int_stack+717180,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1783680,int_stack+619845,int_stack+1536090,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2403705,int_stack+1783680,int_stack+1956090,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2569080,int_stack+2403705,int_stack+2066340,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1909680,int_stack+2569080,int_stack+1611690,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1498290,int_stack+1909680,int_stack+2209665,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+705525,int_stack+418500,int_stack+400545,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2139000,int_stack+705525,int_stack+571650,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2235390,int_stack+2139000,int_stack+619845,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+571650,int_stack+2235390,int_stack+1783680,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2139000,int_stack+571650,int_stack+2403705,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2769735,int_stack+2139000,int_stack+2569080,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2139000,int_stack+2769735,int_stack+1909680,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2433840,int_stack+2139000,int_stack+1498290,105);
 /*--- compute (qp|nl) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1498290,int_stack+2433840,int_stack+0,2970);
 /*--- compute (od|nl) ---*/
 hrr1_build_od(Libint->AB,int_stack+6258738,int_stack+1498290,int_stack+803310,2970);
 /*--- compute (nf|nl) ---*/
 hrr1_build_nf(Libint->AB,int_stack+7648698,int_stack+6258738,int_stack+3449118,2970);
 /*--- compute (mg|nl) ---*/
 hrr1_build_mg(Libint->AB,int_stack+9608898,int_stack+7648698,int_stack+4625238,2970);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+446370,int_stack+438450,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+23760,int_stack+455730,int_stack+446370,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51840,int_stack+23760,int_stack+0,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+99360,int_stack+466650,int_stack+455730,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+132120,int_stack+99360,int_stack+23760,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+188280,int_stack+132120,int_stack+51840,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+479250,int_stack+466650,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+267480,int_stack+0,int_stack+99360,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37800,int_stack+267480,int_stack+132120,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+333000,int_stack+37800,int_stack+188280,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+131400,int_stack+493650,int_stack+479250,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+174600,int_stack+131400,int_stack+0,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2309100,int_stack+174600,int_stack+267480,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2745690,int_stack+2309100,int_stack+37800,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2886090,int_stack+2745690,int_stack+333000,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+509970,int_stack+493650,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+250200,int_stack+0,int_stack+131400,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+336600,int_stack+250200,int_stack+174600,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+48960,int_stack+336600,int_stack+2309100,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3052410,int_stack+48960,int_stack+2745690,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3248970,int_stack+3052410,int_stack+2886090,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2745690,int_stack+528330,int_stack+509970,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2800770,int_stack+2745690,int_stack+0,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2898690,int_stack+2800770,int_stack+250200,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3470730,int_stack+2898690,int_stack+336600,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+212760,int_stack+3470730,int_stack+48960,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3659730,int_stack+212760,int_stack+3052410,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3921810,int_stack+3659730,int_stack+3248970,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+548850,int_stack+528330,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+61560,int_stack+0,int_stack+2745690,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3042690,int_stack+61560,int_stack+2800770,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3205890,int_stack+3042690,int_stack+2898690,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2745690,int_stack+3205890,int_stack+3470730,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3010290,int_stack+2745690,int_stack+212760,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3316050,int_stack+3010290,int_stack+3659730,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2745690,int_stack+3316050,int_stack+3921810,120);
 /*--- compute (rp|nl) ---*/
 hrr1_build_rp(Libint->AB,int_stack+3102090,int_stack+2745690,int_stack+2433840,2970);
 /*--- compute (qd|nl) ---*/
 hrr1_build_qd(Libint->AB,int_stack+4037640,int_stack+3102090,int_stack+1498290,2970);
 /*--- compute (of|nl) ---*/
 hrr1_build_of(Libint->AB,int_stack+0,int_stack+4037640,int_stack+6258738,2970);
 /*--- compute (ng|nl) ---*/
 hrr1_build_ng(Libint->AB,int_stack+2316600,int_stack+0,int_stack+7648698,2970);
 /*--- compute (mh|nl) ---*/
 hrr1_build_mh(Libint->AB,int_stack+5256900,int_stack+2316600,int_stack+9608898,2970);
 return int_stack+5256900;}
