/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mink(Libint_t*, prim_data*);

  /* Computes quartets of (mi|nk) integrals */

REALTYPE *hrr_order_mink(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[9][17] = int_stack + 41195;
 Libint->vrr_classes[10][10] = int_stack + 50600;
 Libint->vrr_classes[10][11] = int_stack + 54956;
 Libint->vrr_classes[10][12] = int_stack + 60104;
 Libint->vrr_classes[10][13] = int_stack + 66110;
 Libint->vrr_classes[10][14] = int_stack + 73040;
 Libint->vrr_classes[10][15] = int_stack + 80960;
 Libint->vrr_classes[10][16] = int_stack + 89936;
 Libint->vrr_classes[10][17] = int_stack + 100034;
 Libint->vrr_classes[11][10] = int_stack + 111320;
 Libint->vrr_classes[11][11] = int_stack + 116468;
 Libint->vrr_classes[11][12] = int_stack + 122552;
 Libint->vrr_classes[11][13] = int_stack + 129650;
 Libint->vrr_classes[11][14] = int_stack + 137840;
 Libint->vrr_classes[11][15] = int_stack + 147200;
 Libint->vrr_classes[11][16] = int_stack + 157808;
 Libint->vrr_classes[11][17] = int_stack + 169742;
 Libint->vrr_classes[12][10] = int_stack + 183080;
 Libint->vrr_classes[12][11] = int_stack + 189086;
 Libint->vrr_classes[12][12] = int_stack + 196184;
 Libint->vrr_classes[12][13] = int_stack + 204465;
 Libint->vrr_classes[12][14] = int_stack + 214020;
 Libint->vrr_classes[12][15] = int_stack + 224940;
 Libint->vrr_classes[12][16] = int_stack + 237316;
 Libint->vrr_classes[12][17] = int_stack + 251239;
 Libint->vrr_classes[13][10] = int_stack + 266800;
 Libint->vrr_classes[13][11] = int_stack + 273730;
 Libint->vrr_classes[13][12] = int_stack + 281920;
 Libint->vrr_classes[13][13] = int_stack + 291475;
 Libint->vrr_classes[13][14] = int_stack + 302500;
 Libint->vrr_classes[13][15] = int_stack + 315100;
 Libint->vrr_classes[13][16] = int_stack + 329380;
 Libint->vrr_classes[13][17] = int_stack + 345445;
 Libint->vrr_classes[14][10] = int_stack + 363400;
 Libint->vrr_classes[14][11] = int_stack + 371320;
 Libint->vrr_classes[14][12] = int_stack + 380680;
 Libint->vrr_classes[14][13] = int_stack + 391600;
 Libint->vrr_classes[14][14] = int_stack + 404200;
 Libint->vrr_classes[14][15] = int_stack + 418600;
 Libint->vrr_classes[14][16] = int_stack + 434920;
 Libint->vrr_classes[14][17] = int_stack + 453280;
 Libint->vrr_classes[15][10] = int_stack + 473800;
 Libint->vrr_classes[15][11] = int_stack + 482776;
 Libint->vrr_classes[15][12] = int_stack + 493384;
 Libint->vrr_classes[15][13] = int_stack + 505760;
 Libint->vrr_classes[15][14] = int_stack + 520040;
 Libint->vrr_classes[15][15] = int_stack + 536360;
 Libint->vrr_classes[15][16] = int_stack + 554856;
 Libint->vrr_classes[15][17] = int_stack + 575664;
 memset(int_stack,0,598920*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 598920;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mink(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+598920,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+609810,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+622680,int_stack+609810,int_stack+598920,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+644460,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+659475,int_stack+644460,int_stack+609810,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+685215,int_stack+659475,int_stack+622680,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+598920,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+721515,int_stack+598920,int_stack+644460,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+616245,int_stack+721515,int_stack+659475,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+751545,int_stack+616245,int_stack+685215,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+659145,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+678945,int_stack+659145,int_stack+598920,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+805995,int_stack+678945,int_stack+721515,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+856045,int_stack+805995,int_stack+616245,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+920395,int_stack+856045,int_stack+751545,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+598920,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+713595,int_stack+598920,int_stack+659145,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+996625,int_stack+713595,int_stack+678945,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+621360,int_stack+996625,int_stack+805995,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+753195,int_stack+621360,int_stack+856045,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1054375,int_stack+753195,int_stack+920395,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+843285,int_stack+41195,int_stack+32780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+868530,int_stack+843285,int_stack+598920,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+913410,int_stack+868530,int_stack+713595,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1156015,int_stack+913410,int_stack+996625,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+843285,int_stack+1156015,int_stack+621360,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+598920,int_stack+843285,int_stack+753195,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+719040,int_stack+598920,int_stack+1054375,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+598920,int_stack+54956,int_stack+50600,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+611988,int_stack+60104,int_stack+54956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+627432,int_stack+611988,int_stack+598920,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+653568,int_stack+66110,int_stack+60104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+671586,int_stack+653568,int_stack+611988,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+849720,int_stack+671586,int_stack+627432,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+598920,int_stack+73040,int_stack+66110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+893280,int_stack+598920,int_stack+653568,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+619710,int_stack+893280,int_stack+671586,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+929316,int_stack+619710,int_stack+849720,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+849720,int_stack+80960,int_stack+73040,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+671190,int_stack+849720,int_stack+598920,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+994656,int_stack+671190,int_stack+893280,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1054716,int_stack+994656,int_stack+619710,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1131936,int_stack+1054716,int_stack+929316,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+598920,int_stack+89936,int_stack+80960,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+873480,int_stack+598920,int_stack+849720,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+921000,int_stack+873480,int_stack+671190,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+625848,int_stack+921000,int_stack+994656,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1223412,int_stack+625848,int_stack+1054716,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+990300,int_stack+1223412,int_stack+1131936,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1112268,int_stack+100034,int_stack+89936,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1142562,int_stack+1112268,int_stack+598920,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+1142562,int_stack+873480,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1112268,int_stack+0,int_stack+921000,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+849720,int_stack+1112268,int_stack+625848,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1331520,int_stack+849720,int_stack+1223412,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1112268,int_stack+1331520,int_stack+990300,66);
 /*--- compute (mp|nk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1269084,int_stack+1112268,int_stack+719040,2376);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+116468,int_stack+111320,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+122552,int_stack+116468,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+129650,int_stack+122552,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+598920,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+137840,int_stack+129650,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+650400,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+650400,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+692988,int_stack+24570,int_stack+598920,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+598920,int_stack+147200,int_stack+137840,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+85410,int_stack+598920,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+770208,int_stack+85410,int_stack+650400,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+841188,int_stack+770208,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+932448,int_stack+841188,int_stack+692988,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+157808,int_stack+147200,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+627000,int_stack+0,int_stack+598920,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+683160,int_stack+627000,int_stack+85410,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+31824,int_stack+683160,int_stack+770208,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1661124,int_stack+31824,int_stack+841188,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+765060,int_stack+1661124,int_stack+932448,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+909204,int_stack+169742,int_stack+157808,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+945006,int_stack+909204,int_stack+0,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1008654,int_stack+945006,int_stack+627000,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1788888,int_stack+1008654,int_stack+683160,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+909204,int_stack+1788888,int_stack+31824,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+909204,int_stack+1661124,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1661124,int_stack+0,int_stack+765060,78);
 /*--- compute (np|nk) ---*/
 hrr1_build_np(Libint->AB,int_stack+598920,int_stack+1661124,int_stack+1112268,2376);
 /*--- compute (md|nk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1846452,int_stack+598920,int_stack+1269084,2376);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+189086,int_stack+183080,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+196184,int_stack+189086,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+204465,int_stack+196184,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142779,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+214020,int_stack+204465,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1069368,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+1069368,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1119054,int_stack+28665,int_stack+142779,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99645,int_stack+224940,int_stack+214020,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+132405,int_stack+99645,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1209144,int_stack+132405,int_stack+1069368,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1291954,int_stack+1209144,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1398424,int_stack+1291954,int_stack+1119054,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1069368,int_stack+237316,int_stack+224940,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1106496,int_stack+1069368,int_stack+99645,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+1106496,int_stack+132405,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+95550,int_stack+0,int_stack+1209144,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2630532,int_stack+95550,int_stack+1291954,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1172016,int_stack+2630532,int_stack+1398424,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1340184,int_stack+251239,int_stack+237316,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1381953,int_stack+1340184,int_stack+1069368,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1456209,int_stack+1381953,int_stack+1106496,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2779590,int_stack+1456209,int_stack+0,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1340184,int_stack+2779590,int_stack+95550,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1340184,int_stack+2630532,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2630532,int_stack+0,int_stack+1172016,91);
 /*--- compute (op|nk) ---*/
 hrr1_build_op(Libint->AB,int_stack+1069368,int_stack+2630532,int_stack+1661124,2376);
 /*--- compute (nd|nk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2846748,int_stack+1069368,int_stack+598920,2376);
 /*--- compute (mf|nk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3787644,int_stack+2846748,int_stack+1846452,2376);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+598920,int_stack+273730,int_stack+266800,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+619710,int_stack+281920,int_stack+273730,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+644280,int_stack+619710,int_stack+598920,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+685860,int_stack+291475,int_stack+281920,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+714525,int_stack+685860,int_stack+619710,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+763665,int_stack+714525,int_stack+644280,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+598920,int_stack+302500,int_stack+291475,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+832965,int_stack+598920,int_stack+685860,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+631995,int_stack+832965,int_stack+714525,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+890295,int_stack+631995,int_stack+763665,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+713895,int_stack+315100,int_stack+302500,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+751695,int_stack+713895,int_stack+598920,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+751695,int_stack+832965,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+95550,int_stack+0,int_stack+631995,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1625352,int_stack+95550,int_stack+890295,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+598920,int_stack+329380,int_stack+315100,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+817845,int_stack+598920,int_stack+713895,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+893445,int_stack+817845,int_stack+751695,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+641760,int_stack+893445,int_stack+0,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1770882,int_stack+641760,int_stack+95550,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1770882,int_stack+1625352,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1625352,int_stack+345445,int_stack+329380,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1673547,int_stack+1625352,int_stack+598920,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+194040,int_stack+1673547,int_stack+817845,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1942872,int_stack+194040,int_stack+893445,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+785085,int_stack+1942872,int_stack+641760,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1942872,int_stack+785085,int_stack+1770882,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2172192,int_stack+1942872,int_stack+0,105);
 /*--- compute (qp|nk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+5094444,int_stack+2172192,int_stack+2630532,2376);
 /*--- compute (od|nk) ---*/
 hrr1_build_od(Libint->AB,int_stack+5743092,int_stack+5094444,int_stack+1069368,2376);
 /*--- compute (nf|nk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+598920,int_stack+5743092,int_stack+2846748,2376);
 /*--- compute (mg|nk) ---*/
 hrr1_build_mg(Libint->AB,int_stack+6855060,int_stack+598920,int_stack+3787644,2376);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+371320,int_stack+363400,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+23760,int_stack+380680,int_stack+371320,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51840,int_stack+23760,int_stack+0,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+99360,int_stack+391600,int_stack+380680,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+132120,int_stack+99360,int_stack+23760,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+188280,int_stack+132120,int_stack+51840,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+404200,int_stack+391600,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+267480,int_stack+0,int_stack+99360,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37800,int_stack+267480,int_stack+132120,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2421672,int_stack+37800,int_stack+188280,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+131400,int_stack+418600,int_stack+404200,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+174600,int_stack+131400,int_stack+0,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2540472,int_stack+174600,int_stack+267480,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+250200,int_stack+2540472,int_stack+37800,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2649672,int_stack+250200,int_stack+2421672,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2421672,int_stack+434920,int_stack+418600,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+2421672,int_stack+131400,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2815992,int_stack+0,int_stack+174600,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+86400,int_stack+2815992,int_stack+2540472,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2941992,int_stack+86400,int_stack+250200,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3138552,int_stack+2941992,int_stack+2649672,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+250200,int_stack+453280,int_stack+434920,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+305280,int_stack+250200,int_stack+2421672,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2421672,int_stack+305280,int_stack+0,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2565672,int_stack+2421672,int_stack+2815992,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3360312,int_stack+2565672,int_stack+86400,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2421672,int_stack+3360312,int_stack+2941992,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3360312,int_stack+2421672,int_stack+3138552,120);
 /*--- compute (rp|nk) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2421672,int_stack+3360312,int_stack+2172192,2376);
 /*--- compute (qd|nk) ---*/
 hrr1_build_qd(Libint->AB,int_stack+3645432,int_stack+2421672,int_stack+5094444,2376);
 /*--- compute (of|nk) ---*/
 hrr1_build_of(Libint->AB,int_stack+8815260,int_stack+3645432,int_stack+5743092,2376);
 /*--- compute (ng|nk) ---*/
 hrr1_build_ng(Libint->AB,int_stack+10668540,int_stack+8815260,int_stack+598920,2376);
 /*--- compute (mh|nk) ---*/
 hrr1_build_mh(Libint->AB,int_stack+13020780,int_stack+10668540,int_stack+6855060,2376);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+598920,int_stack+482776,int_stack+473800,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+625848,int_stack+493384,int_stack+482776,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+657672,int_stack+625848,int_stack+598920,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+711528,int_stack+505760,int_stack+493384,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+748656,int_stack+711528,int_stack+625848,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+812304,int_stack+748656,int_stack+657672,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+598920,int_stack+520040,int_stack+505760,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+902064,int_stack+598920,int_stack+711528,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+641760,int_stack+902064,int_stack+748656,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+976320,int_stack+641760,int_stack+812304,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+747840,int_stack+536360,int_stack+520040,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+796800,int_stack+747840,int_stack+598920,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1110960,int_stack+796800,int_stack+902064,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1234720,int_stack+1110960,int_stack+641760,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1393840,int_stack+1234720,int_stack+976320,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+598920,int_stack+554856,int_stack+536360,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+882480,int_stack+598920,int_stack+747840,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1582336,int_stack+882480,int_stack+796800,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+654408,int_stack+1582336,int_stack+1110960,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+980400,int_stack+654408,int_stack+1234720,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1725136,int_stack+980400,int_stack+1393840,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1203168,int_stack+575664,int_stack+554856,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1265592,int_stack+1203168,int_stack+598920,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1376568,int_stack+1265592,int_stack+882480,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1976464,int_stack+1376568,int_stack+1582336,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1203168,int_stack+1976464,int_stack+654408,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1976464,int_stack+1203168,int_stack+980400,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4942728,int_stack+1976464,int_stack+1725136,136);
 /*--- compute (tp|nk) ---*/
 hrr1_build_tp(Libint->AB,int_stack+5265864,int_stack+4942728,int_stack+3360312,2376);
 /*--- compute (rd|nk) ---*/
 hrr1_build_rd(Libint->AB,int_stack+6121224,int_stack+5265864,int_stack+2421672,2376);
 /*--- compute (qf|nk) ---*/
 hrr1_build_qf(Libint->AB,int_stack+0,int_stack+6121224,int_stack+3645432,2376);
 /*--- compute (og|nk) ---*/
 hrr1_build_og(Libint->AB,int_stack+2162160,int_stack+0,int_stack+8815260,2376);
 /*--- compute (nh|nk) ---*/
 hrr1_build_nh(Libint->AB,int_stack+4942080,int_stack+2162160,int_stack+10668540,2376);
 /*--- compute (mi|nk) ---*/
 hrr1_build_mi(Libint->AB,int_stack+0,int_stack+4942080,int_stack+13020780,2376);
 return int_stack+0;}
