/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mmnl(Libint_t*, prim_data*);

  /* Computes quartets of (mm|nl) integrals */

REALTYPE *hrr_order_mmnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[9][17] = int_stack + 41195;
 Libint->vrr_classes[9][18] = int_stack + 50600;
 Libint->vrr_classes[10][10] = int_stack + 61050;
 Libint->vrr_classes[10][11] = int_stack + 65406;
 Libint->vrr_classes[10][12] = int_stack + 70554;
 Libint->vrr_classes[10][13] = int_stack + 76560;
 Libint->vrr_classes[10][14] = int_stack + 83490;
 Libint->vrr_classes[10][15] = int_stack + 91410;
 Libint->vrr_classes[10][16] = int_stack + 100386;
 Libint->vrr_classes[10][17] = int_stack + 110484;
 Libint->vrr_classes[10][18] = int_stack + 121770;
 Libint->vrr_classes[11][10] = int_stack + 134310;
 Libint->vrr_classes[11][11] = int_stack + 139458;
 Libint->vrr_classes[11][12] = int_stack + 145542;
 Libint->vrr_classes[11][13] = int_stack + 152640;
 Libint->vrr_classes[11][14] = int_stack + 160830;
 Libint->vrr_classes[11][15] = int_stack + 170190;
 Libint->vrr_classes[11][16] = int_stack + 180798;
 Libint->vrr_classes[11][17] = int_stack + 192732;
 Libint->vrr_classes[11][18] = int_stack + 206070;
 Libint->vrr_classes[12][10] = int_stack + 220890;
 Libint->vrr_classes[12][11] = int_stack + 226896;
 Libint->vrr_classes[12][12] = int_stack + 233994;
 Libint->vrr_classes[12][13] = int_stack + 242275;
 Libint->vrr_classes[12][14] = int_stack + 251830;
 Libint->vrr_classes[12][15] = int_stack + 262750;
 Libint->vrr_classes[12][16] = int_stack + 275126;
 Libint->vrr_classes[12][17] = int_stack + 289049;
 Libint->vrr_classes[12][18] = int_stack + 304610;
 Libint->vrr_classes[13][10] = int_stack + 321900;
 Libint->vrr_classes[13][11] = int_stack + 328830;
 Libint->vrr_classes[13][12] = int_stack + 337020;
 Libint->vrr_classes[13][13] = int_stack + 346575;
 Libint->vrr_classes[13][14] = int_stack + 357600;
 Libint->vrr_classes[13][15] = int_stack + 370200;
 Libint->vrr_classes[13][16] = int_stack + 384480;
 Libint->vrr_classes[13][17] = int_stack + 400545;
 Libint->vrr_classes[13][18] = int_stack + 418500;
 Libint->vrr_classes[14][10] = int_stack + 438450;
 Libint->vrr_classes[14][11] = int_stack + 446370;
 Libint->vrr_classes[14][12] = int_stack + 455730;
 Libint->vrr_classes[14][13] = int_stack + 466650;
 Libint->vrr_classes[14][14] = int_stack + 479250;
 Libint->vrr_classes[14][15] = int_stack + 493650;
 Libint->vrr_classes[14][16] = int_stack + 509970;
 Libint->vrr_classes[14][17] = int_stack + 528330;
 Libint->vrr_classes[14][18] = int_stack + 548850;
 Libint->vrr_classes[15][10] = int_stack + 571650;
 Libint->vrr_classes[15][11] = int_stack + 580626;
 Libint->vrr_classes[15][12] = int_stack + 591234;
 Libint->vrr_classes[15][13] = int_stack + 603610;
 Libint->vrr_classes[15][14] = int_stack + 617890;
 Libint->vrr_classes[15][15] = int_stack + 634210;
 Libint->vrr_classes[15][16] = int_stack + 652706;
 Libint->vrr_classes[15][17] = int_stack + 673514;
 Libint->vrr_classes[15][18] = int_stack + 696770;
 Libint->vrr_classes[16][10] = int_stack + 722610;
 Libint->vrr_classes[16][11] = int_stack + 732708;
 Libint->vrr_classes[16][12] = int_stack + 744642;
 Libint->vrr_classes[16][13] = int_stack + 758565;
 Libint->vrr_classes[16][14] = int_stack + 774630;
 Libint->vrr_classes[16][15] = int_stack + 792990;
 Libint->vrr_classes[16][16] = int_stack + 813798;
 Libint->vrr_classes[16][17] = int_stack + 837207;
 Libint->vrr_classes[16][18] = int_stack + 863370;
 Libint->vrr_classes[17][10] = int_stack + 892440;
 Libint->vrr_classes[17][11] = int_stack + 903726;
 Libint->vrr_classes[17][12] = int_stack + 917064;
 Libint->vrr_classes[17][13] = int_stack + 932625;
 Libint->vrr_classes[17][14] = int_stack + 950580;
 Libint->vrr_classes[17][15] = int_stack + 971100;
 Libint->vrr_classes[17][16] = int_stack + 994356;
 Libint->vrr_classes[17][17] = int_stack + 1020519;
 Libint->vrr_classes[17][18] = int_stack + 1049760;
 Libint->vrr_classes[18][10] = int_stack + 1082250;
 Libint->vrr_classes[18][11] = int_stack + 1094790;
 Libint->vrr_classes[18][12] = int_stack + 1109610;
 Libint->vrr_classes[18][13] = int_stack + 1126900;
 Libint->vrr_classes[18][14] = int_stack + 1146850;
 Libint->vrr_classes[18][15] = int_stack + 1169650;
 Libint->vrr_classes[18][16] = int_stack + 1195490;
 Libint->vrr_classes[18][17] = int_stack + 1224560;
 Libint->vrr_classes[18][18] = int_stack + 1257050;
 memset(int_stack,0,1293150*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1293150;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mmnl(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1293150,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1304040,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1316910,int_stack+1304040,int_stack+1293150,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1338690,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1353705,int_stack+1338690,int_stack+1304040,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1379445,int_stack+1353705,int_stack+1316910,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1293150,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1415745,int_stack+1293150,int_stack+1338690,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1310475,int_stack+1415745,int_stack+1353705,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1445775,int_stack+1310475,int_stack+1379445,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1353375,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1373175,int_stack+1353375,int_stack+1293150,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1500225,int_stack+1373175,int_stack+1415745,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1550275,int_stack+1500225,int_stack+1310475,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1614625,int_stack+1550275,int_stack+1445775,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1293150,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1407825,int_stack+1293150,int_stack+1353375,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1690855,int_stack+1407825,int_stack+1373175,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1315590,int_stack+1690855,int_stack+1500225,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1447425,int_stack+1315590,int_stack+1550275,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1748605,int_stack+1447425,int_stack+1614625,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1537515,int_stack+41195,int_stack+32780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1562760,int_stack+1537515,int_stack+1293150,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1607640,int_stack+1562760,int_stack+1407825,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1850245,int_stack+1607640,int_stack+1690855,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1936870,int_stack+1850245,int_stack+1315590,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1293150,int_stack+1936870,int_stack+1447425,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2041975,int_stack+1293150,int_stack+1748605,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1413270,int_stack+50600,int_stack+41195,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1441485,int_stack+1413270,int_stack+1537515,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1673640,int_stack+1441485,int_stack+1562760,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1413270,int_stack+1673640,int_stack+1607640,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1512270,int_stack+1413270,int_stack+1850245,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1633545,int_stack+1512270,int_stack+1936870,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1413270,int_stack+1633545,int_stack+1293150,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1567710,int_stack+1413270,int_stack+2041975,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1293150,int_stack+65406,int_stack+61050,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1306218,int_stack+70554,int_stack+65406,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1321662,int_stack+1306218,int_stack+1293150,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1347798,int_stack+76560,int_stack+70554,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1365816,int_stack+1347798,int_stack+1306218,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1396704,int_stack+1365816,int_stack+1321662,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1293150,int_stack+83490,int_stack+76560,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1440264,int_stack+1293150,int_stack+1347798,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1313940,int_stack+1440264,int_stack+1365816,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1476300,int_stack+1313940,int_stack+1396704,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1365420,int_stack+91410,int_stack+83490,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1389180,int_stack+1365420,int_stack+1293150,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1731060,int_stack+1389180,int_stack+1440264,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1791120,int_stack+1731060,int_stack+1313940,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1868340,int_stack+1791120,int_stack+1476300,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1293150,int_stack+100386,int_stack+91410,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1430760,int_stack+1293150,int_stack+1365420,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1478280,int_stack+1430760,int_stack+1389180,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1320078,int_stack+1478280,int_stack+1731060,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1959816,int_stack+1320078,int_stack+1791120,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1731060,int_stack+1959816,int_stack+1868340,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1853028,int_stack+110484,int_stack+100386,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1883322,int_stack+1853028,int_stack+1293150,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2067924,int_stack+1883322,int_stack+1430760,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+2067924,int_stack+1478280,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1410168,int_stack+0,int_stack+1320078,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2147124,int_stack+1410168,int_stack+1959816,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2291268,int_stack+2147124,int_stack+1731060,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1731060,int_stack+121770,int_stack+110484,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1764918,int_stack+1731060,int_stack+1853028,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1293150,int_stack+1764918,int_stack+1883322,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1731060,int_stack+1293150,int_stack+2067924,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1849860,int_stack+1731060,int_stack+0,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2448084,int_stack+1849860,int_stack+1410168,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1731060,int_stack+2448084,int_stack+2147124,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1916388,int_stack+1731060,int_stack+2291268,66);
 /*--- compute (mp|nl) ---*/
 hrr1_build_mp(Libint->AB,int_stack+2112408,int_stack+1916388,int_stack+1567710,2970);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+139458,int_stack+134310,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+145542,int_stack+139458,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+152640,int_stack+145542,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1293150,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+160830,int_stack+152640,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1344630,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+1344630,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1387218,int_stack+24570,int_stack+1293150,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1293150,int_stack+170190,int_stack+160830,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+85410,int_stack+1293150,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1464438,int_stack+85410,int_stack+1344630,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1535418,int_stack+1464438,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1626678,int_stack+1535418,int_stack+1387218,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+180798,int_stack+170190,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1321230,int_stack+0,int_stack+1293150,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1377390,int_stack+1321230,int_stack+85410,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+31824,int_stack+1377390,int_stack+1464438,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1734786,int_stack+31824,int_stack+1535418,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1459290,int_stack+1734786,int_stack+1626678,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+138294,int_stack+192732,int_stack+180798,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1603434,int_stack+138294,int_stack+0,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2602458,int_stack+1603434,int_stack+1321230,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2696058,int_stack+2602458,int_stack+1377390,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1293150,int_stack+2696058,int_stack+31824,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2818908,int_stack+1293150,int_stack+1734786,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1667082,int_stack+2818908,int_stack+1459290,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+206070,int_stack+192732,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+40014,int_stack+0,int_stack+138294,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+111618,int_stack+40014,int_stack+1603434,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1442208,int_stack+111618,int_stack+2602458,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+1442208,int_stack+2696058,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1442208,int_stack+0,int_stack+1293150,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+1442208,int_stack+2818908,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1293150,int_stack+0,int_stack+1667082,78);
 /*--- compute (np|nl) ---*/
 hrr1_build_np(Libint->AB,int_stack+2602458,int_stack+1293150,int_stack+1916388,2970);
 /*--- compute (md|nl) ---*/
 hrr1_build_md(Libint->AB,int_stack+3190518,int_stack+2602458,int_stack+2112408,2970);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+226896,int_stack+220890,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+233994,int_stack+226896,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+242275,int_stack+233994,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142779,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+251830,int_stack+242275,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1524810,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+1524810,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1574496,int_stack+28665,int_stack+142779,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99645,int_stack+262750,int_stack+251830,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+132405,int_stack+99645,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1664586,int_stack+132405,int_stack+1524810,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1747396,int_stack+1664586,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1853866,int_stack+1747396,int_stack+1574496,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1524810,int_stack+275126,int_stack+262750,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1561938,int_stack+1524810,int_stack+99645,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+1561938,int_stack+132405,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+95550,int_stack+0,int_stack+1664586,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1979992,int_stack+95550,int_stack+1747396,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1627458,int_stack+1979992,int_stack+1853866,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1795626,int_stack+289049,int_stack+275126,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1837395,int_stack+1795626,int_stack+1524810,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2129050,int_stack+1837395,int_stack+1561938,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2238250,int_stack+2129050,int_stack+0,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2381575,int_stack+2238250,int_stack+95550,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+2381575,int_stack+1979992,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1911651,int_stack+0,int_stack+1627458,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+198744,int_stack+304610,int_stack+289049,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1524810,int_stack+198744,int_stack+1795626,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1608348,int_stack+1524810,int_stack+1837395,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1732108,int_stack+1608348,int_stack+2129050,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1524810,int_stack+1732108,int_stack+2238250,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2127867,int_stack+1524810,int_stack+2381575,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1524810,int_stack+2127867,int_stack+0,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1524810,int_stack+1911651,91);
 /*--- compute (op|nl) ---*/
 hrr1_build_op(Libint->AB,int_stack+1524810,int_stack+0,int_stack+1293150,2970);
 /*--- compute (nd|nl) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4170618,int_stack+1524810,int_stack+2602458,2970);
 /*--- compute (mf|nl) ---*/
 hrr1_build_mf(Libint->AB,int_stack+5346738,int_stack+4170618,int_stack+3190518,2970);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1293150,int_stack+328830,int_stack+321900,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1313940,int_stack+337020,int_stack+328830,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1338510,int_stack+1313940,int_stack+1293150,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1380090,int_stack+346575,int_stack+337020,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1408755,int_stack+1380090,int_stack+1313940,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2219790,int_stack+1408755,int_stack+1338510,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1293150,int_stack+357600,int_stack+346575,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1457895,int_stack+1293150,int_stack+1380090,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1326225,int_stack+1457895,int_stack+1408755,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2289090,int_stack+1326225,int_stack+2219790,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2219790,int_stack+370200,int_stack+357600,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2393040,int_stack+2219790,int_stack+1293150,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2459190,int_stack+2393040,int_stack+1457895,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2554740,int_stack+2459190,int_stack+1326225,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1293150,int_stack+2554740,int_stack+2289090,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1438680,int_stack+384480,int_stack+370200,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2257590,int_stack+1438680,int_stack+2219790,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2677590,int_stack+2257590,int_stack+2393040,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2787840,int_stack+2677590,int_stack+2459190,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2333190,int_stack+2787840,int_stack+2554740,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2931165,int_stack+2333190,int_stack+1293150,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1293150,int_stack+400545,int_stack+384480,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1341345,int_stack+1293150,int_stack+1438680,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2505180,int_stack+1341345,int_stack+2257590,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3125205,int_stack+2505180,int_stack+2677590,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3290580,int_stack+3125205,int_stack+2787840,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2631180,int_stack+3290580,int_stack+2333190,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2219790,int_stack+2631180,int_stack+2931165,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1427025,int_stack+418500,int_stack+400545,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2860500,int_stack+1427025,int_stack+1293150,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2956890,int_stack+2860500,int_stack+1341345,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1293150,int_stack+2956890,int_stack+2505180,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2860500,int_stack+1293150,int_stack+3125205,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3491235,int_stack+2860500,int_stack+3290580,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2860500,int_stack+3491235,int_stack+2631180,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3155340,int_stack+2860500,int_stack+2219790,105);
 /*--- compute (qp|nl) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2219790,int_stack+3155340,int_stack+0,2970);
 /*--- compute (od|nl) ---*/
 hrr1_build_od(Libint->AB,int_stack+6980238,int_stack+2219790,int_stack+1524810,2970);
 /*--- compute (nf|nl) ---*/
 hrr1_build_nf(Libint->AB,int_stack+8370198,int_stack+6980238,int_stack+4170618,2970);
 /*--- compute (mg|nl) ---*/
 hrr1_build_mg(Libint->AB,int_stack+10330398,int_stack+8370198,int_stack+5346738,2970);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+446370,int_stack+438450,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+23760,int_stack+455730,int_stack+446370,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51840,int_stack+23760,int_stack+0,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+99360,int_stack+466650,int_stack+455730,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+132120,int_stack+99360,int_stack+23760,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+188280,int_stack+132120,int_stack+51840,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+479250,int_stack+466650,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+267480,int_stack+0,int_stack+99360,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37800,int_stack+267480,int_stack+132120,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+333000,int_stack+37800,int_stack+188280,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+131400,int_stack+493650,int_stack+479250,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+174600,int_stack+131400,int_stack+0,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3030600,int_stack+174600,int_stack+267480,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3467190,int_stack+3030600,int_stack+37800,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3607590,int_stack+3467190,int_stack+333000,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+509970,int_stack+493650,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+250200,int_stack+0,int_stack+131400,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+336600,int_stack+250200,int_stack+174600,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+48960,int_stack+336600,int_stack+3030600,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3773910,int_stack+48960,int_stack+3467190,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3970470,int_stack+3773910,int_stack+3607590,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3467190,int_stack+528330,int_stack+509970,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3522270,int_stack+3467190,int_stack+0,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3620190,int_stack+3522270,int_stack+250200,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4192230,int_stack+3620190,int_stack+336600,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+212760,int_stack+4192230,int_stack+48960,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4381230,int_stack+212760,int_stack+3773910,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4643310,int_stack+4381230,int_stack+3970470,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+548850,int_stack+528330,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+61560,int_stack+0,int_stack+3467190,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3764190,int_stack+61560,int_stack+3522270,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3927390,int_stack+3764190,int_stack+3620190,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3467190,int_stack+3927390,int_stack+4192230,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3731790,int_stack+3467190,int_stack+212760,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4037550,int_stack+3731790,int_stack+4381230,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3467190,int_stack+4037550,int_stack+4643310,120);
 /*--- compute (rp|nl) ---*/
 hrr1_build_rp(Libint->AB,int_stack+3823590,int_stack+3467190,int_stack+3155340,2970);
 /*--- compute (qd|nl) ---*/
 hrr1_build_qd(Libint->AB,int_stack+4759140,int_stack+3823590,int_stack+2219790,2970);
 /*--- compute (of|nl) ---*/
 hrr1_build_of(Libint->AB,int_stack+12780648,int_stack+4759140,int_stack+6980238,2970);
 /*--- compute (ng|nl) ---*/
 hrr1_build_ng(Libint->AB,int_stack+15097248,int_stack+12780648,int_stack+8370198,2970);
 /*--- compute (mh|nl) ---*/
 hrr1_build_mh(Libint->AB,int_stack+6380760,int_stack+15097248,int_stack+10330398,2970);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9811110,int_stack+580626,int_stack+571650,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+9838038,int_stack+591234,int_stack+580626,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+9869862,int_stack+9838038,int_stack+9811110,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+9923718,int_stack+603610,int_stack+591234,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+9960846,int_stack+9923718,int_stack+9838038,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+10024494,int_stack+9960846,int_stack+9869862,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+9811110,int_stack+617890,int_stack+603610,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+10114254,int_stack+9811110,int_stack+9923718,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+9853950,int_stack+10114254,int_stack+9960846,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+10188510,int_stack+9853950,int_stack+10024494,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+9960030,int_stack+634210,int_stack+617890,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+10008990,int_stack+9960030,int_stack+9811110,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+10323150,int_stack+10008990,int_stack+10114254,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+10446910,int_stack+10323150,int_stack+9853950,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+10606030,int_stack+10446910,int_stack+10188510,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+9811110,int_stack+652706,int_stack+634210,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+10094670,int_stack+9811110,int_stack+9960030,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+10794526,int_stack+10094670,int_stack+10008990,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+9866598,int_stack+10794526,int_stack+10323150,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+10192590,int_stack+9866598,int_stack+10446910,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+10937326,int_stack+10192590,int_stack+10606030,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+10415358,int_stack+673514,int_stack+652706,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+10477782,int_stack+10415358,int_stack+9811110,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+10588758,int_stack+10477782,int_stack+10094670,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+11188654,int_stack+10588758,int_stack+10794526,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+11402854,int_stack+11188654,int_stack+9866598,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+9811110,int_stack+11402854,int_stack+10192590,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+11662750,int_stack+9811110,int_stack+10937326,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+10108134,int_stack+696770,int_stack+673514,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+10177902,int_stack+10108134,int_stack+10415358,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+10751958,int_stack+10177902,int_stack+10477782,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+10108134,int_stack+10751958,int_stack+10588758,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+10352934,int_stack+10108134,int_stack+11188654,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+10652814,int_stack+10352934,int_stack+11402854,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+10108134,int_stack+10652814,int_stack+9811110,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+10490022,int_stack+10108134,int_stack+11662750,136);
 /*--- compute (tp|nl) ---*/
 hrr1_build_tp(Libint->AB,int_stack+10893942,int_stack+10490022,int_stack+3467190,2970);
 /*--- compute (rd|nl) ---*/
 hrr1_build_rd(Libint->AB,int_stack+1293150,int_stack+10893942,int_stack+3823590,2970);
 /*--- compute (qf|nl) ---*/
 hrr1_build_qf(Libint->AB,int_stack+18037548,int_stack+1293150,int_stack+4759140,2970);
 /*--- compute (og|nl) ---*/
 hrr1_build_og(Libint->AB,int_stack+20740248,int_stack+18037548,int_stack+12780648,2970);
 /*--- compute (nh|nl) ---*/
 hrr1_build_nh(Libint->AB,int_stack+24215148,int_stack+20740248,int_stack+15097248,2970);
 /*--- compute (mi|nl) ---*/
 hrr1_build_mi(Libint->AB,int_stack+11963142,int_stack+24215148,int_stack+6380760,2970);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+16536942,int_stack+732708,int_stack+722610,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+16567236,int_stack+744642,int_stack+732708,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+16603038,int_stack+16567236,int_stack+16536942,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+16663626,int_stack+758565,int_stack+744642,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+16705395,int_stack+16663626,int_stack+16567236,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+16776999,int_stack+16705395,int_stack+16603038,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+16536942,int_stack+774630,int_stack+758565,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+16877979,int_stack+16536942,int_stack+16663626,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+16585137,int_stack+16877979,int_stack+16705395,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+16961517,int_stack+16585137,int_stack+16776999,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+16704477,int_stack+792990,int_stack+774630,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+16759557,int_stack+16704477,int_stack+16536942,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+17112987,int_stack+16759557,int_stack+16877979,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+17252217,int_stack+17112987,int_stack+16585137,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+17431227,int_stack+17252217,int_stack+16961517,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+16536942,int_stack+813798,int_stack+792990,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+16855947,int_stack+16536942,int_stack+16704477,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+17643285,int_stack+16855947,int_stack+16759557,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+16599366,int_stack+17643285,int_stack+17112987,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+16966107,int_stack+16599366,int_stack+17252217,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+16966107,int_stack+17431227,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+17216721,int_stack+837207,int_stack+813798,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+17286948,int_stack+17216721,int_stack+16536942,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+17411796,int_stack+17286948,int_stack+16855947,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+282744,int_stack+17411796,int_stack+17643285,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+17595396,int_stack+282744,int_stack+16599366,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+16536942,int_stack+17595396,int_stack+16966107,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3164250,int_stack+16536942,int_stack+0,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+863370,int_stack+837207,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+78489,int_stack+0,int_stack+17216721,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+16871094,int_stack+78489,int_stack+17286948,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+16871094,int_stack+17411796,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+16871094,int_stack+0,int_stack+282744,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+16871094,int_stack+17595396,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+16871094,int_stack+0,int_stack+16536942,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+16871094,int_stack+3164250,153);
 /*--- compute (up|nl) ---*/
 hrr1_build_up(Libint->AB,int_stack+3164250,int_stack+0,int_stack+10490022,2970);
 /*--- compute (td|nl) ---*/
 hrr1_build_td(Libint->AB,int_stack+4376010,int_stack+3164250,int_stack+10893942,2970);
 /*--- compute (rf|nl) ---*/
 hrr1_build_rf(Libint->AB,int_stack+6514410,int_stack+4376010,int_stack+1293150,2970);
 /*--- compute (qg|nl) ---*/
 hrr1_build_qg(Libint->AB,int_stack+28331568,int_stack+6514410,int_stack+18037548,2970);
 /*--- compute (oh|nl) ---*/
 hrr1_build_oh(Libint->AB,int_stack+32385618,int_stack+28331568,int_stack+20740248,2970);
 /*--- compute (ni|nl) ---*/
 hrr1_build_ni(Libint->AB,int_stack+16536942,int_stack+32385618,int_stack+24215148,2970);
 /*--- compute (mk|nl) ---*/
 hrr1_build_mk(Libint->AB,int_stack+22025502,int_stack+16536942,int_stack+11963142,2970);
 /*--- compute (w0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1293150,int_stack+903726,int_stack+892440,171);
 /*--- compute (w0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1327008,int_stack+917064,int_stack+903726,171);
 /*--- compute (w0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1367022,int_stack+1327008,int_stack+1293150,171);
 /*--- compute (w0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1434738,int_stack+932625,int_stack+917064,171);
 /*--- compute (w0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1481421,int_stack+1434738,int_stack+1327008,171);
 /*--- compute (w0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1561449,int_stack+1481421,int_stack+1367022,171);
 /*--- compute (w0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1293150,int_stack+950580,int_stack+932625,171);
 /*--- compute (w0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1674309,int_stack+1293150,int_stack+1434738,171);
 /*--- compute (w0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1347015,int_stack+1674309,int_stack+1481421,171);
 /*--- compute (w0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1767675,int_stack+1347015,int_stack+1561449,171);
 /*--- compute (w0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1480395,int_stack+971100,int_stack+950580,171);
 /*--- compute (w0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1541955,int_stack+1480395,int_stack+1293150,171);
 /*--- compute (w0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1936965,int_stack+1541955,int_stack+1674309,171);
 /*--- compute (w0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2092575,int_stack+1936965,int_stack+1347015,171);
 /*--- compute (w0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2292645,int_stack+2092575,int_stack+1767675,171);
 /*--- compute (w0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1293150,int_stack+994356,int_stack+971100,171);
 /*--- compute (w0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1649685,int_stack+1293150,int_stack+1480395,171);
 /*--- compute (w0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2529651,int_stack+1649685,int_stack+1541955,171);
 /*--- compute (w0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1362918,int_stack+2529651,int_stack+1936965,171);
 /*--- compute (w0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1772805,int_stack+1362918,int_stack+2092575,171);
 /*--- compute (w0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2709201,int_stack+1772805,int_stack+2292645,171);
 /*--- compute (w0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2052903,int_stack+1020519,int_stack+994356,171);
 /*--- compute (w0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2131392,int_stack+2052903,int_stack+1293150,171);
 /*--- compute (w0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2270928,int_stack+2131392,int_stack+1649685,171);
 /*--- compute (w0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+9632910,int_stack+2270928,int_stack+2529651,171);
 /*--- compute (w0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+9902235,int_stack+9632910,int_stack+1362918,171);
 /*--- compute (w0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1293150,int_stack+9902235,int_stack+1772805,171);
 /*--- compute (w0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+10229016,int_stack+1293150,int_stack+2709201,171);
 /*--- compute (w0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1666614,int_stack+1049760,int_stack+1020519,171);
 /*--- compute (w0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1754337,int_stack+1666614,int_stack+2052903,171);
 /*--- compute (w0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2476128,int_stack+1754337,int_stack+2131392,171);
 /*--- compute (w0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1666614,int_stack+2476128,int_stack+2270928,171);
 /*--- compute (w0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1974414,int_stack+1666614,int_stack+9632910,171);
 /*--- compute (w0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2351469,int_stack+1974414,int_stack+9902235,171);
 /*--- compute (w0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+9632910,int_stack+2351469,int_stack+1293150,171);
 /*--- compute (w0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1293150,int_stack+9632910,int_stack+10229016,171);
 /*--- compute (vp|nl) ---*/
 hrr1_build_vp(Libint->AB,int_stack+1801020,int_stack+1293150,int_stack+0,2970);
 /*--- compute (ud|nl) ---*/
 hrr1_build_ud(Libint->AB,int_stack+9632910,int_stack+1801020,int_stack+3164250,2970);
 /*--- compute (tf|nl) ---*/
 hrr1_build_tf(Libint->AB,int_stack+12056430,int_stack+9632910,int_stack+4376010,2970);
 /*--- compute (rg|nl) ---*/
 hrr1_build_rg(Libint->AB,int_stack+37250478,int_stack+12056430,int_stack+6514410,2970);
 /*--- compute (qh|nl) ---*/
 hrr1_build_qh(Libint->AB,int_stack+3164250,int_stack+37250478,int_stack+28331568,2970);
 /*--- compute (oi|nl) ---*/
 hrr1_build_oi(Libint->AB,int_stack+41928228,int_stack+3164250,int_stack+32385618,2970);
 /*--- compute (nk|nl) ---*/
 hrr1_build_nk(Libint->AB,int_stack+27906102,int_stack+41928228,int_stack+16536942,2970);
 /*--- compute (ml|nl) ---*/
 hrr1_build_ml(Libint->AB,int_stack+48414708,int_stack+27906102,int_stack+22025502,2970);
 /*--- compute (x0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+8839920,int_stack+1094790,int_stack+1082250,190);
 /*--- compute (x0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8877540,int_stack+1109610,int_stack+1094790,190);
 /*--- compute (x0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+8922000,int_stack+8877540,int_stack+8839920,190);
 /*--- compute (x0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+8997240,int_stack+1126900,int_stack+1109610,190);
 /*--- compute (x0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+9049110,int_stack+8997240,int_stack+8877540,190);
 /*--- compute (x0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+9138030,int_stack+9049110,int_stack+8922000,190);
 /*--- compute (x0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+8839920,int_stack+1146850,int_stack+1126900,190);
 /*--- compute (x0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+9263430,int_stack+8839920,int_stack+8997240,190);
 /*--- compute (x0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+8899770,int_stack+9263430,int_stack+9049110,190);
 /*--- compute (x0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+9367170,int_stack+8899770,int_stack+9138030,190);
 /*--- compute (x0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+9047970,int_stack+1169650,int_stack+1146850,190);
 /*--- compute (x0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+9116370,int_stack+9047970,int_stack+8839920,190);
 /*--- compute (x0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+9116370,int_stack+9263430,190);
 /*--- compute (x0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+172900,int_stack+0,int_stack+8899770,190);
 /*--- compute (x0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+395200,int_stack+172900,int_stack+9367170,190);
 /*--- compute (x0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+8839920,int_stack+1195490,int_stack+1169650,190);
 /*--- compute (x0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+9236070,int_stack+8839920,int_stack+9047970,190);
 /*--- compute (x0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+9372870,int_stack+9236070,int_stack+9116370,190);
 /*--- compute (x0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+8917440,int_stack+9372870,int_stack+0,190);
 /*--- compute (x0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+658540,int_stack+8917440,int_stack+172900,190);
 /*--- compute (x0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+658540,int_stack+395200,190);
 /*--- compute (x0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+351120,int_stack+1224560,int_stack+1195490,190);
 /*--- compute (x0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+438330,int_stack+351120,int_stack+8839920,190);
 /*--- compute (x0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+969760,int_stack+438330,int_stack+9236070,190);
 /*--- compute (x0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+15620430,int_stack+969760,int_stack+9372870,190);
 /*--- compute (x0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+9176790,int_stack+15620430,int_stack+8917440,190);
 /*--- compute (x0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+15919680,int_stack+9176790,int_stack+658540,190);
 /*--- compute (x0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+16334640,int_stack+15919680,int_stack+0,190);
 /*--- compute (x0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+1257050,int_stack+1224560,190);
 /*--- compute (x0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+97470,int_stack+0,int_stack+351120,190);
 /*--- compute (x0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+8839920,int_stack+97470,int_stack+438330,190);
 /*--- compute (x0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+8839920,int_stack+969760,190);
 /*--- compute (x0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+342000,int_stack+0,int_stack+15620430,190);
 /*--- compute (x0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+760950,int_stack+342000,int_stack+9176790,190);
 /*--- compute (x0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+760950,int_stack+15919680,190);
 /*--- compute (x0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+15620430,int_stack+0,int_stack+16334640,190);
 /*--- compute (wp|nl) ---*/
 hrr1_build_wp(Libint->AB,int_stack+16184730,int_stack+15620430,int_stack+1293150,2970);
 /*--- compute (vd|nl) ---*/
 hrr1_build_vd(Libint->AB,int_stack+17708340,int_stack+16184730,int_stack+1801020,2970);
 /*--- compute (uf|nl) ---*/
 hrr1_build_uf(Libint->AB,int_stack+20434800,int_stack+17708340,int_stack+9632910,2970);
 /*--- compute (tg|nl) ---*/
 hrr1_build_tg(Libint->AB,int_stack+55765458,int_stack+20434800,int_stack+12056430,2970);
 /*--- compute (rh|nl) ---*/
 hrr1_build_rh(Libint->AB,int_stack+8839920,int_stack+55765458,int_stack+37250478,2970);
 /*--- compute (qi|nl) ---*/
 hrr1_build_qi(Libint->AB,int_stack+15388770,int_stack+8839920,int_stack+3164250,2970);
 /*--- compute (ok|nl) ---*/
 hrr1_build_ok(Libint->AB,int_stack+0,int_stack+15388770,int_stack+41928228,2970);
 /*--- compute (nl|nl) ---*/
 hrr1_build_nl(Libint->AB,int_stack+8339760,int_stack+0,int_stack+27906102,2970);
 /*--- compute (mm|nl) ---*/
 hrr1_build_mm(Libint->AB,int_stack+17160660,int_stack+8339760,int_stack+48414708,2970);
 return int_stack+17160660;}
