/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ndmh(Libint_t*, prim_data*);

  /* Computes quartets of (nd|mh) integrals */

REALTYPE *hrr_order_ndmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[11][9] = int_stack + 33990;
 Libint->vrr_classes[11][10] = int_stack + 38280;
 Libint->vrr_classes[11][11] = int_stack + 43428;
 Libint->vrr_classes[11][12] = int_stack + 49512;
 Libint->vrr_classes[11][13] = int_stack + 56610;
 Libint->vrr_classes[11][14] = int_stack + 64800;
 Libint->vrr_classes[12][9] = int_stack + 74160;
 Libint->vrr_classes[12][10] = int_stack + 79165;
 Libint->vrr_classes[12][11] = int_stack + 85171;
 Libint->vrr_classes[12][12] = int_stack + 92269;
 Libint->vrr_classes[12][13] = int_stack + 100550;
 Libint->vrr_classes[12][14] = int_stack + 110105;
 memset(int_stack,0,121025*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 121025;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ndmh(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+121025,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+131915,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+144983,int_stack+131915,int_stack+121025,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+166763,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+182207,int_stack+166763,int_stack+131915,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+208343,int_stack+182207,int_stack+144983,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+121025,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+244643,int_stack+121025,int_stack+166763,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+275531,int_stack+244643,int_stack+182207,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+139043,int_stack+275531,int_stack+208343,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+193493,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+319091,int_stack+193493,int_stack+121025,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+355127,int_stack+319091,int_stack+244643,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+193493,int_stack+355127,int_stack+275531,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+258833,int_stack+193493,int_stack+139043,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+121025,int_stack+38280,int_stack+33990,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+133895,int_stack+43428,int_stack+38280,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+149339,int_stack+133895,int_stack+121025,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+175079,int_stack+49512,int_stack+43428,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+193331,int_stack+175079,int_stack+133895,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+335063,int_stack+193331,int_stack+149339,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+121025,int_stack+56610,int_stack+49512,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+121025,int_stack+175079,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+377963,int_stack+0,int_stack+193331,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+142319,int_stack+377963,int_stack+335063,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+335063,int_stack+64800,int_stack+56610,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+206669,int_stack+335063,int_stack+121025,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+429443,int_stack+206669,int_stack+0,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+490283,int_stack+429443,int_stack+377963,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+335063,int_stack+490283,int_stack+142319,78);
 /*--- compute (np|mh) ---*/
 hrr1_build_np(Libint->AB,int_stack+425153,int_stack+335063,int_stack+258833,1155);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+79165,int_stack+74160,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+85171,int_stack+79165,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+92269,int_stack+85171,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+121025,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+157061,int_stack+121025,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+100550,int_stack+92269,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+207111,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+24843,int_stack+207111,int_stack+121025,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+249699,int_stack+24843,int_stack+157061,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+121025,int_stack+110105,int_stack+100550,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+149690,int_stack+121025,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+653843,int_stack+149690,int_stack+207111,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+84903,int_stack+653843,int_stack+24843,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+653843,int_stack+84903,int_stack+249699,91);
 /*--- compute (op|mh) ---*/
 hrr1_build_op(Libint->AB,int_stack+0,int_stack+653843,int_stack+335063,1155);
 /*--- compute (nd|mh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+653843,int_stack+0,int_stack+425153,1155);
 return int_stack+653843;}
