/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ndnm(Libint_t*, prim_data*);

  /* Computes quartets of (nd|nm) integrals */

REALTYPE *hrr_order_ndnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[10][18] = int_stack + 60720;
 Libint->vrr_classes[10][19] = int_stack + 73260;
 Libint->vrr_classes[11][10] = int_stack + 87120;
 Libint->vrr_classes[11][11] = int_stack + 92268;
 Libint->vrr_classes[11][12] = int_stack + 98352;
 Libint->vrr_classes[11][13] = int_stack + 105450;
 Libint->vrr_classes[11][14] = int_stack + 113640;
 Libint->vrr_classes[11][15] = int_stack + 123000;
 Libint->vrr_classes[11][16] = int_stack + 133608;
 Libint->vrr_classes[11][17] = int_stack + 145542;
 Libint->vrr_classes[11][18] = int_stack + 158880;
 Libint->vrr_classes[11][19] = int_stack + 173700;
 Libint->vrr_classes[12][10] = int_stack + 190080;
 Libint->vrr_classes[12][11] = int_stack + 196086;
 Libint->vrr_classes[12][12] = int_stack + 203184;
 Libint->vrr_classes[12][13] = int_stack + 211465;
 Libint->vrr_classes[12][14] = int_stack + 221020;
 Libint->vrr_classes[12][15] = int_stack + 231940;
 Libint->vrr_classes[12][16] = int_stack + 244316;
 Libint->vrr_classes[12][17] = int_stack + 258239;
 Libint->vrr_classes[12][18] = int_stack + 273800;
 Libint->vrr_classes[12][19] = int_stack + 291090;
 memset(int_stack,0,310200*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 310200;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ndnm(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+310200,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+323268,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+338712,int_stack+323268,int_stack+310200,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+364848,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+382866,int_stack+364848,int_stack+323268,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+413754,int_stack+382866,int_stack+338712,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+310200,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+457314,int_stack+310200,int_stack+364848,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+330990,int_stack+457314,int_stack+382866,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+493350,int_stack+330990,int_stack+413754,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+382470,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+406230,int_stack+382470,int_stack+310200,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+558690,int_stack+406230,int_stack+457314,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+618750,int_stack+558690,int_stack+330990,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+695970,int_stack+618750,int_stack+493350,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+310200,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+447810,int_stack+310200,int_stack+382470,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+787446,int_stack+447810,int_stack+406230,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+337128,int_stack+787446,int_stack+558690,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+495330,int_stack+337128,int_stack+618750,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+856746,int_stack+495330,int_stack+695970,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+603438,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+633732,int_stack+603438,int_stack+310200,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+687588,int_stack+633732,int_stack+447810,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+978714,int_stack+687588,int_stack+787446,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1082664,int_stack+978714,int_stack+337128,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+310200,int_stack+1082664,int_stack+495330,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1208790,int_stack+310200,int_stack+856746,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+454344,int_stack+60720,int_stack+49434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+488202,int_stack+454344,int_stack+603438,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+766788,int_stack+488202,int_stack+633732,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+548790,int_stack+766788,int_stack+687588,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1365606,int_stack+548790,int_stack+978714,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+856548,int_stack+1365606,int_stack+1082664,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1511136,int_stack+856548,int_stack+310200,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1696464,int_stack+1511136,int_stack+1208790,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+310200,int_stack+73260,int_stack+60720,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+347820,int_stack+310200,int_stack+454344,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1024716,int_stack+347820,int_stack+488202,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+310200,int_stack+1024716,int_stack+766788,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1024716,int_stack+310200,int_stack+548790,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+310200,int_stack+1024716,int_stack+1365606,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1024716,int_stack+310200,int_stack+856548,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+310200,int_stack+1024716,int_stack+1511136,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+541860,int_stack+310200,int_stack+1696464,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+310200,int_stack+92268,int_stack+87120,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+325644,int_stack+98352,int_stack+92268,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+343896,int_stack+325644,int_stack+310200,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+374784,int_stack+105450,int_stack+98352,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+396078,int_stack+374784,int_stack+325644,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+432582,int_stack+396078,int_stack+343896,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+310200,int_stack+113640,int_stack+105450,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+484062,int_stack+310200,int_stack+374784,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+334770,int_stack+484062,int_stack+396078,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+781440,int_stack+334770,int_stack+432582,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+395610,int_stack+123000,int_stack+113640,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+423690,int_stack+395610,int_stack+310200,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+858660,int_stack+423690,int_stack+484062,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+929640,int_stack+858660,int_stack+334770,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1020900,int_stack+929640,int_stack+781440,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+781440,int_stack+133608,int_stack+123000,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+310200,int_stack+781440,int_stack+395610,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1129008,int_stack+310200,int_stack+423690,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+366360,int_stack+1129008,int_stack+858660,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1210908,int_stack+366360,int_stack+929640,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+813264,int_stack+1210908,int_stack+1020900,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+957408,int_stack+145542,int_stack+133608,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+993210,int_stack+957408,int_stack+781440,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1338672,int_stack+993210,int_stack+310200,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1432272,int_stack+1338672,int_stack+1129008,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1056858,int_stack+1432272,int_stack+366360,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+310200,int_stack+1056858,int_stack+1210908,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1555122,int_stack+310200,int_stack+813264,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+480552,int_stack+158880,int_stack+145542,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+781440,int_stack+480552,int_stack+957408,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+853044,int_stack+781440,int_stack+993210,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1740450,int_stack+853044,int_stack+1338672,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1205916,int_stack+1740450,int_stack+1432272,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1880850,int_stack+1205916,int_stack+1056858,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+959124,int_stack+1880850,int_stack+310200,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2079594,int_stack+959124,int_stack+1555122,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+310200,int_stack+173700,int_stack+158880,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+354660,int_stack+310200,int_stack+480552,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1377906,int_stack+354660,int_stack+781440,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+310200,int_stack+1377906,int_stack+853044,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1377906,int_stack+310200,int_stack+1740450,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+310200,int_stack+1377906,int_stack+1205916,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1178148,int_stack+310200,int_stack+1880850,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1433676,int_stack+1178148,int_stack+959124,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+781440,int_stack+1433676,int_stack+2079594,78);
 /*--- compute (np|nm) ---*/
 hrr1_build_np(Libint->AB,int_stack+1064580,int_stack+781440,int_stack+541860,3630);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+310200,int_stack+196086,int_stack+190080,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+328218,int_stack+203184,int_stack+196086,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+349512,int_stack+328218,int_stack+310200,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+385548,int_stack+211465,int_stack+203184,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+410391,int_stack+385548,int_stack+328218,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+452979,int_stack+410391,int_stack+349512,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+310200,int_stack+221020,int_stack+211465,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+513039,int_stack+310200,int_stack+385548,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+338865,int_stack+513039,int_stack+410391,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+562725,int_stack+338865,int_stack+452979,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+409845,int_stack+231940,int_stack+221020,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+442605,int_stack+409845,int_stack+310200,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+652815,int_stack+442605,int_stack+513039,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1783320,int_stack+652815,int_stack+338865,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1889790,int_stack+1783320,int_stack+562725,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+310200,int_stack+244316,int_stack+231940,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+499935,int_stack+310200,int_stack+409845,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2015916,int_stack+499935,int_stack+442605,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+347328,int_stack+2015916,int_stack+652815,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+565455,int_stack+347328,int_stack+1783320,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2111466,int_stack+565455,int_stack+1889790,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1783320,int_stack+258239,int_stack+244316,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1825089,int_stack+1783320,int_stack+310200,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1899345,int_stack+1825089,int_stack+499935,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+1899345,int_stack+2015916,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2279634,int_stack+0,int_stack+347328,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+310200,int_stack+2279634,int_stack+565455,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+508944,int_stack+310200,int_stack+2111466,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+725160,int_stack+273800,int_stack+258239,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2008545,int_stack+725160,int_stack+1783320,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2092083,int_stack+2008545,int_stack+1825089,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2453535,int_stack+2092083,int_stack+1899345,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1783320,int_stack+2453535,int_stack+0,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+1783320,int_stack+2279634,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2617335,int_stack+0,int_stack+310200,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2872863,int_stack+2617335,int_stack+508944,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+310200,int_stack+291090,int_stack+273800,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+362070,int_stack+310200,int_stack+725160,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+455436,int_stack+362070,int_stack+2008545,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+594666,int_stack+455436,int_stack+2092083,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+231868,int_stack+594666,int_stack+2453535,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+461188,int_stack+231868,int_stack+1783320,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1783320,int_stack+461188,int_stack+0,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+1783320,int_stack+2617335,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1783320,int_stack+0,int_stack+2872863,91);
 /*--- compute (op|nm) ---*/
 hrr1_build_op(Libint->AB,int_stack+2113650,int_stack+1783320,int_stack+781440,3630);
 /*--- compute (nd|nm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2963070,int_stack+2113650,int_stack+1064580,3630);
 return int_stack+2963070;}
