/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ndnn(Libint_t*, prim_data*);

  /* Computes quartets of (nd|nn) integrals */

REALTYPE *hrr_order_ndnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[10][18] = int_stack + 60720;
 Libint->vrr_classes[10][19] = int_stack + 73260;
 Libint->vrr_classes[10][20] = int_stack + 87120;
 Libint->vrr_classes[11][10] = int_stack + 102366;
 Libint->vrr_classes[11][11] = int_stack + 107514;
 Libint->vrr_classes[11][12] = int_stack + 113598;
 Libint->vrr_classes[11][13] = int_stack + 120696;
 Libint->vrr_classes[11][14] = int_stack + 128886;
 Libint->vrr_classes[11][15] = int_stack + 138246;
 Libint->vrr_classes[11][16] = int_stack + 148854;
 Libint->vrr_classes[11][17] = int_stack + 160788;
 Libint->vrr_classes[11][18] = int_stack + 174126;
 Libint->vrr_classes[11][19] = int_stack + 188946;
 Libint->vrr_classes[11][20] = int_stack + 205326;
 Libint->vrr_classes[12][10] = int_stack + 223344;
 Libint->vrr_classes[12][11] = int_stack + 229350;
 Libint->vrr_classes[12][12] = int_stack + 236448;
 Libint->vrr_classes[12][13] = int_stack + 244729;
 Libint->vrr_classes[12][14] = int_stack + 254284;
 Libint->vrr_classes[12][15] = int_stack + 265204;
 Libint->vrr_classes[12][16] = int_stack + 277580;
 Libint->vrr_classes[12][17] = int_stack + 291503;
 Libint->vrr_classes[12][18] = int_stack + 307064;
 Libint->vrr_classes[12][19] = int_stack + 324354;
 Libint->vrr_classes[12][20] = int_stack + 343464;
 memset(int_stack,0,364485*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 364485;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ndnn(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+364485,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+377553,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+392997,int_stack+377553,int_stack+364485,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+419133,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+437151,int_stack+419133,int_stack+377553,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+468039,int_stack+437151,int_stack+392997,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+364485,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+511599,int_stack+364485,int_stack+419133,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+385275,int_stack+511599,int_stack+437151,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+547635,int_stack+385275,int_stack+468039,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+436755,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+460515,int_stack+436755,int_stack+364485,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+612975,int_stack+460515,int_stack+511599,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+673035,int_stack+612975,int_stack+385275,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+750255,int_stack+673035,int_stack+547635,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+364485,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+502095,int_stack+364485,int_stack+436755,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+841731,int_stack+502095,int_stack+460515,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+391413,int_stack+841731,int_stack+612975,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+549615,int_stack+391413,int_stack+673035,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+911031,int_stack+549615,int_stack+750255,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+657723,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+688017,int_stack+657723,int_stack+364485,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+741873,int_stack+688017,int_stack+502095,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1032999,int_stack+741873,int_stack+841731,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1136949,int_stack+1032999,int_stack+391413,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+364485,int_stack+1136949,int_stack+549615,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1263075,int_stack+364485,int_stack+911031,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+508629,int_stack+60720,int_stack+49434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+542487,int_stack+508629,int_stack+657723,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+821073,int_stack+542487,int_stack+688017,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+603075,int_stack+821073,int_stack+741873,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1419891,int_stack+603075,int_stack+1032999,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+910833,int_stack+1419891,int_stack+1136949,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1565421,int_stack+910833,int_stack+364485,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1750749,int_stack+1565421,int_stack+1263075,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+364485,int_stack+73260,int_stack+60720,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+402105,int_stack+364485,int_stack+508629,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1079001,int_stack+402105,int_stack+542487,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1179981,int_stack+1079001,int_stack+821073,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+721875,int_stack+1179981,int_stack+603075,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+469821,int_stack+721875,int_stack+1419891,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1314621,int_stack+469821,int_stack+910833,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1946769,int_stack+1314621,int_stack+1565421,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2178429,int_stack+1946769,int_stack+1750749,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+663861,int_stack+87120,int_stack+73260,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+888195,int_stack+663861,int_stack+364485,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+963435,int_stack+888195,int_stack+402105,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1530837,int_stack+963435,int_stack+1079001,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+888195,int_stack+1530837,int_stack+1179981,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1530837,int_stack+888195,int_stack+721875,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+663861,int_stack+1530837,int_stack+469821,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1530837,int_stack+663861,int_stack+1314621,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+364485,int_stack+1530837,int_stack+1946769,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+647625,int_stack+364485,int_stack+2178429,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+364485,int_stack+107514,int_stack+102366,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+379929,int_stack+113598,int_stack+107514,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+398181,int_stack+379929,int_stack+364485,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+429069,int_stack+120696,int_stack+113598,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+450363,int_stack+429069,int_stack+379929,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+486867,int_stack+450363,int_stack+398181,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+364485,int_stack+128886,int_stack+120696,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+538347,int_stack+364485,int_stack+429069,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+389055,int_stack+538347,int_stack+450363,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+935121,int_stack+389055,int_stack+486867,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+449895,int_stack+138246,int_stack+128886,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+477975,int_stack+449895,int_stack+364485,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1012341,int_stack+477975,int_stack+538347,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+527115,int_stack+1012341,int_stack+389055,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1083321,int_stack+527115,int_stack+935121,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+935121,int_stack+148854,int_stack+138246,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+364485,int_stack+935121,int_stack+449895,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1191429,int_stack+364485,int_stack+477975,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+420645,int_stack+1191429,int_stack+1012341,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1273329,int_stack+420645,int_stack+527115,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1401093,int_stack+1273329,int_stack+1083321,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+527115,int_stack+160788,int_stack+148854,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+562917,int_stack+527115,int_stack+935121,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+935121,int_stack+562917,int_stack+364485,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1028721,int_stack+935121,int_stack+1191429,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1545237,int_stack+1028721,int_stack+420645,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1694295,int_stack+1545237,int_stack+1273329,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1151571,int_stack+1694295,int_stack+1401093,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+364485,int_stack+174126,int_stack+160788,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+404499,int_stack+364485,int_stack+527115,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1336899,int_stack+404499,int_stack+562917,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+476103,int_stack+1336899,int_stack+935121,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1864647,int_stack+476103,int_stack+1028721,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+935121,int_stack+1864647,int_stack+1545237,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1442979,int_stack+935121,int_stack+1694295,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2036637,int_stack+1442979,int_stack+1151571,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1133865,int_stack+188946,int_stack+174126,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1178325,int_stack+1133865,int_stack+364485,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1662003,int_stack+1178325,int_stack+404499,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+1662003,int_stack+1336899,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2268297,int_stack+0,int_stack+476103,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+364485,int_stack+2268297,int_stack+1864647,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2464857,int_stack+364485,int_stack+935121,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2720385,int_stack+2464857,int_stack+1442979,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1258353,int_stack+2720385,int_stack+2036637,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+935121,int_stack+205326,int_stack+188946,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+984261,int_stack+935121,int_stack+1133865,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1781343,int_stack+984261,int_stack+1178325,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+935121,int_stack+1781343,int_stack+1662003,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1541493,int_stack+935121,int_stack+0,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+935121,int_stack+1541493,int_stack+2268297,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1541493,int_stack+935121,int_stack+364485,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+935121,int_stack+1541493,int_stack+2464857,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1541493,int_stack+935121,int_stack+2720385,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1876113,int_stack+1541493,int_stack+1258353,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+935121,int_stack+1876113,int_stack+647625,4356);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1797609,int_stack+229350,int_stack+223344,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1815627,int_stack+236448,int_stack+229350,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1836921,int_stack+1815627,int_stack+1797609,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2215881,int_stack+244729,int_stack+236448,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2240724,int_stack+2215881,int_stack+1815627,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2283312,int_stack+2240724,int_stack+1836921,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1797609,int_stack+254284,int_stack+244729,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1826274,int_stack+1797609,int_stack+2215881,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2343372,int_stack+1826274,int_stack+2240724,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2414352,int_stack+2343372,int_stack+2283312,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2215881,int_stack+265204,int_stack+254284,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2248641,int_stack+2215881,int_stack+1797609,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2504442,int_stack+2248641,int_stack+1826274,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2587252,int_stack+2504442,int_stack+2343372,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2693722,int_stack+2587252,int_stack+2414352,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1797609,int_stack+277580,int_stack+265204,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2305971,int_stack+1797609,int_stack+2215881,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2371491,int_stack+2305971,int_stack+2248641,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2819848,int_stack+2371491,int_stack+2504442,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+364485,int_stack+2819848,int_stack+2587252,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2467041,int_stack+364485,int_stack+2693722,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2215881,int_stack+291503,int_stack+277580,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2635209,int_stack+2215881,int_stack+1797609,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2709465,int_stack+2635209,int_stack+2305971,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+513543,int_stack+2709465,int_stack+2371491,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2257650,int_stack+513543,int_stack+2819848,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+656868,int_stack+2257650,int_stack+364485,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+656868,int_stack+2467041,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+364485,int_stack+307064,int_stack+291503,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+411168,int_stack+364485,int_stack+2215881,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2431551,int_stack+411168,int_stack+2635209,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2818665,int_stack+2431551,int_stack+2709465,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2555311,int_stack+2818665,int_stack+513543,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2982465,int_stack+2555311,int_stack+2257650,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3214333,int_stack+2982465,int_stack+656868,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+494706,int_stack+3214333,int_stack+0,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+324354,int_stack+307064,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+51870,int_stack+0,int_stack+364485,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+145236,int_stack+51870,int_stack+411168,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2215881,int_stack+145236,int_stack+2431551,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3469861,int_stack+2215881,int_stack+2818665,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+3699181,int_stack+3469861,int_stack+2555311,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2401521,int_stack+3699181,int_stack+2982465,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2699637,int_stack+2401521,int_stack+3214333,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+3019047,int_stack+2699637,int_stack+494706,91);
 /*--- compute (q0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+364485,int_stack+343464,int_stack+324354,91);
 /*--- compute (q0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+421815,int_stack+364485,int_stack+0,91);
 /*--- compute (q0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+525555,int_stack+421815,int_stack+51870,91);
 /*--- compute (q0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+681165,int_stack+525555,int_stack+145236,91);
 /*--- compute (q0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+681165,int_stack+2215881,91);
 /*--- compute (q0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+259896,int_stack+0,int_stack+3469861,91);
 /*--- compute (q0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+565656,int_stack+259896,int_stack+3699181,91);
 /*--- compute (q0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+0,int_stack+565656,int_stack+2401521,91);
 /*--- compute (q0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+372645,int_stack+0,int_stack+2699637,91);
 /*--- compute (q0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2215881,int_stack+372645,int_stack+3019047,91);
 /*--- compute (op|nn) ---*/
 hrr1_build_op(Libint->AB,int_stack+2612277,int_stack+2215881,int_stack+1876113,4356);
 /*--- compute (nd|nn) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3631581,int_stack+2612277,int_stack+935121,4356);
 return int_stack+3631581;}
