/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nhnk(Libint_t*, prim_data*);

  /* Computes quartets of (nh|nk) integrals */

REALTYPE *hrr_order_nhnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[11][10] = int_stack + 60720;
 Libint->vrr_classes[11][11] = int_stack + 65868;
 Libint->vrr_classes[11][12] = int_stack + 71952;
 Libint->vrr_classes[11][13] = int_stack + 79050;
 Libint->vrr_classes[11][14] = int_stack + 87240;
 Libint->vrr_classes[11][15] = int_stack + 96600;
 Libint->vrr_classes[11][16] = int_stack + 107208;
 Libint->vrr_classes[11][17] = int_stack + 119142;
 Libint->vrr_classes[12][10] = int_stack + 132480;
 Libint->vrr_classes[12][11] = int_stack + 138486;
 Libint->vrr_classes[12][12] = int_stack + 145584;
 Libint->vrr_classes[12][13] = int_stack + 153865;
 Libint->vrr_classes[12][14] = int_stack + 163420;
 Libint->vrr_classes[12][15] = int_stack + 174340;
 Libint->vrr_classes[12][16] = int_stack + 186716;
 Libint->vrr_classes[12][17] = int_stack + 200639;
 Libint->vrr_classes[13][10] = int_stack + 216200;
 Libint->vrr_classes[13][11] = int_stack + 223130;
 Libint->vrr_classes[13][12] = int_stack + 231320;
 Libint->vrr_classes[13][13] = int_stack + 240875;
 Libint->vrr_classes[13][14] = int_stack + 251900;
 Libint->vrr_classes[13][15] = int_stack + 264500;
 Libint->vrr_classes[13][16] = int_stack + 278780;
 Libint->vrr_classes[13][17] = int_stack + 294845;
 Libint->vrr_classes[14][10] = int_stack + 312800;
 Libint->vrr_classes[14][11] = int_stack + 320720;
 Libint->vrr_classes[14][12] = int_stack + 330080;
 Libint->vrr_classes[14][13] = int_stack + 341000;
 Libint->vrr_classes[14][14] = int_stack + 353600;
 Libint->vrr_classes[14][15] = int_stack + 368000;
 Libint->vrr_classes[14][16] = int_stack + 384320;
 Libint->vrr_classes[14][17] = int_stack + 402680;
 Libint->vrr_classes[15][10] = int_stack + 423200;
 Libint->vrr_classes[15][11] = int_stack + 432176;
 Libint->vrr_classes[15][12] = int_stack + 442784;
 Libint->vrr_classes[15][13] = int_stack + 455160;
 Libint->vrr_classes[15][14] = int_stack + 469440;
 Libint->vrr_classes[15][15] = int_stack + 485760;
 Libint->vrr_classes[15][16] = int_stack + 504256;
 Libint->vrr_classes[15][17] = int_stack + 525064;
 memset(int_stack,0,548320*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 548320;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nhnk(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+548320,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+561388,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+576832,int_stack+561388,int_stack+548320,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+602968,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+620986,int_stack+602968,int_stack+561388,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+651874,int_stack+620986,int_stack+576832,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+548320,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+695434,int_stack+548320,int_stack+602968,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+569110,int_stack+695434,int_stack+620986,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+731470,int_stack+569110,int_stack+651874,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+620590,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+644350,int_stack+620590,int_stack+548320,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+796810,int_stack+644350,int_stack+695434,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+856870,int_stack+796810,int_stack+569110,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+934090,int_stack+856870,int_stack+731470,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+548320,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+685930,int_stack+548320,int_stack+620590,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1025566,int_stack+685930,int_stack+644350,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+575248,int_stack+1025566,int_stack+796810,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+733450,int_stack+575248,int_stack+856870,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1094866,int_stack+733450,int_stack+934090,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+841558,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+871852,int_stack+841558,int_stack+548320,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+925708,int_stack+871852,int_stack+685930,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1216834,int_stack+925708,int_stack+1025566,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+841558,int_stack+1216834,int_stack+575248,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+548320,int_stack+841558,int_stack+733450,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+692464,int_stack+548320,int_stack+1094866,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+548320,int_stack+65868,int_stack+60720,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+563764,int_stack+71952,int_stack+65868,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+582016,int_stack+563764,int_stack+548320,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+612904,int_stack+79050,int_stack+71952,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+634198,int_stack+612904,int_stack+563764,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+849280,int_stack+634198,int_stack+582016,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+548320,int_stack+87240,int_stack+79050,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+900760,int_stack+548320,int_stack+612904,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+572890,int_stack+900760,int_stack+634198,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+943348,int_stack+572890,int_stack+849280,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+849280,int_stack+96600,int_stack+87240,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+633730,int_stack+849280,int_stack+548320,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1020568,int_stack+633730,int_stack+900760,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1091548,int_stack+1020568,int_stack+572890,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1182808,int_stack+1091548,int_stack+943348,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+548320,int_stack+107208,int_stack+96600,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+877360,int_stack+548320,int_stack+849280,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+933520,int_stack+877360,int_stack+633730,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+580144,int_stack+933520,int_stack+1020568,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1290916,int_stack+580144,int_stack+1091548,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1015420,int_stack+1290916,int_stack+1182808,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1159564,int_stack+119142,int_stack+107208,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1195366,int_stack+1159564,int_stack+548320,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+1195366,int_stack+877360,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1159564,int_stack+0,int_stack+933520,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+849280,int_stack+1159564,int_stack+580144,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1418680,int_stack+849280,int_stack+1290916,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1159564,int_stack+1418680,int_stack+1015420,78);
 /*--- compute (np|nk) ---*/
 hrr1_build_np(Libint->AB,int_stack+1344892,int_stack+1159564,int_stack+692464,2376);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+138486,int_stack+132480,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+145584,int_stack+138486,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+153865,int_stack+145584,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+548320,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+163420,int_stack+153865,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+608380,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+608380,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+658066,int_stack+28665,int_stack+548320,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+548320,int_stack+174340,int_stack+163420,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+99645,int_stack+548320,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+748156,int_stack+99645,int_stack+608380,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+830966,int_stack+748156,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+937436,int_stack+830966,int_stack+658066,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+186716,int_stack+174340,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+581080,int_stack+0,int_stack+548320,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+646600,int_stack+581080,int_stack+99645,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+37128,int_stack+646600,int_stack+748156,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1815340,int_stack+37128,int_stack+830966,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+742150,int_stack+1815340,int_stack+937436,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+910318,int_stack+200639,int_stack+186716,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+952087,int_stack+910318,int_stack+0,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1026343,int_stack+952087,int_stack+581080,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1964398,int_stack+1026343,int_stack+646600,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+910318,int_stack+1964398,int_stack+37128,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+910318,int_stack+1815340,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1815340,int_stack+0,int_stack+742150,91);
 /*--- compute (op|nk) ---*/
 hrr1_build_op(Libint->AB,int_stack+548320,int_stack+1815340,int_stack+1159564,2376);
 /*--- compute (nd|nk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2031556,int_stack+548320,int_stack+1344892,2376);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+223130,int_stack+216200,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20790,int_stack+231320,int_stack+223130,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45360,int_stack+20790,int_stack+0,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86940,int_stack+240875,int_stack+231320,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115605,int_stack+86940,int_stack+20790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+164745,int_stack+115605,int_stack+45360,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+251900,int_stack+240875,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1104304,int_stack+0,int_stack+86940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+33075,int_stack+1104304,int_stack+115605,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1161634,int_stack+33075,int_stack+164745,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+114975,int_stack+264500,int_stack+251900,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+152775,int_stack+114975,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1265584,int_stack+152775,int_stack+1104304,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1361134,int_stack+1265584,int_stack+33075,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1483984,int_stack+1361134,int_stack+1161634,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1104304,int_stack+278780,int_stack+264500,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1147144,int_stack+1104304,int_stack+114975,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+1147144,int_stack+152775,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+110250,int_stack+0,int_stack+1265584,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1629514,int_stack+110250,int_stack+1361134,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1222744,int_stack+1629514,int_stack+1483984,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1416784,int_stack+294845,int_stack+278780,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1464979,int_stack+1416784,int_stack+1104304,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2972452,int_stack+1464979,int_stack+1147144,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1416784,int_stack+2972452,int_stack+0,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2972452,int_stack+1416784,int_stack+110250,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+2972452,int_stack+1629514,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1416784,int_stack+0,int_stack+1222744,105);
 /*--- compute (qp|nk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2972452,int_stack+1416784,int_stack+1815340,2376);
 /*--- compute (od|nk) ---*/
 hrr1_build_od(Libint->AB,int_stack+3621100,int_stack+2972452,int_stack+548320,2376);
 /*--- compute (nf|nk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+4733068,int_stack+3621100,int_stack+2031556,2376);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+548320,int_stack+320720,int_stack+312800,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+572080,int_stack+330080,int_stack+320720,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+600160,int_stack+572080,int_stack+548320,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+647680,int_stack+341000,int_stack+330080,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+680440,int_stack+647680,int_stack+572080,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+736600,int_stack+680440,int_stack+600160,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+548320,int_stack+353600,int_stack+341000,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+815800,int_stack+548320,int_stack+647680,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+586120,int_stack+815800,int_stack+680440,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+881320,int_stack+586120,int_stack+736600,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+679720,int_stack+368000,int_stack+353600,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+722920,int_stack+679720,int_stack+548320,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1000120,int_stack+722920,int_stack+815800,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1109320,int_stack+1000120,int_stack+586120,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1249720,int_stack+1109320,int_stack+881320,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+548320,int_stack+384320,int_stack+368000,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+798520,int_stack+548320,int_stack+679720,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+798520,int_stack+722920,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+597280,int_stack+0,int_stack+1000120,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+884920,int_stack+597280,int_stack+1109320,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+126000,int_stack+884920,int_stack+1249720,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1081480,int_stack+402680,int_stack+384320,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1136560,int_stack+1081480,int_stack+548320,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1234480,int_stack+1136560,int_stack+798520,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1666264,int_stack+1234480,int_stack+0,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1081480,int_stack+1666264,int_stack+597280,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1666264,int_stack+1081480,int_stack+884920,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1928344,int_stack+1666264,int_stack+126000,120);
 /*--- compute (rp|nk) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2213464,int_stack+1928344,int_stack+1416784,2376);
 /*--- compute (qd|nk) ---*/
 hrr1_build_qd(Libint->AB,int_stack+548320,int_stack+2213464,int_stack+2972452,2376);
 /*--- compute (of|nk) ---*/
 hrr1_build_of(Libint->AB,int_stack+6301228,int_stack+548320,int_stack+3621100,2376);
 /*--- compute (ng|nk) ---*/
 hrr1_build_ng(Libint->AB,int_stack+8154508,int_stack+6301228,int_stack+4733068,2376);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2961904,int_stack+432176,int_stack+423200,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2988832,int_stack+442784,int_stack+432176,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+3020656,int_stack+2988832,int_stack+2961904,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3074512,int_stack+455160,int_stack+442784,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3111640,int_stack+3074512,int_stack+2988832,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3175288,int_stack+3111640,int_stack+3020656,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2961904,int_stack+469440,int_stack+455160,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3265048,int_stack+2961904,int_stack+3074512,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3004744,int_stack+3265048,int_stack+3111640,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3339304,int_stack+3004744,int_stack+3175288,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3110824,int_stack+485760,int_stack+469440,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3159784,int_stack+3110824,int_stack+2961904,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3473944,int_stack+3159784,int_stack+3265048,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3597704,int_stack+3473944,int_stack+3004744,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3756824,int_stack+3597704,int_stack+3339304,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2961904,int_stack+504256,int_stack+485760,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+3245464,int_stack+2961904,int_stack+3110824,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3945320,int_stack+3245464,int_stack+3159784,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+3017392,int_stack+3945320,int_stack+3473944,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3343384,int_stack+3017392,int_stack+3597704,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4088120,int_stack+3343384,int_stack+3756824,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3566152,int_stack+525064,int_stack+504256,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3628576,int_stack+3566152,int_stack+2961904,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3739552,int_stack+3628576,int_stack+3245464,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4339448,int_stack+3739552,int_stack+3945320,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3566152,int_stack+4339448,int_stack+3017392,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4339448,int_stack+3566152,int_stack+3343384,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4636472,int_stack+4339448,int_stack+4088120,136);
 /*--- compute (tp|nk) ---*/
 hrr1_build_tp(Libint->AB,int_stack+4959608,int_stack+4636472,int_stack+1928344,2376);
 /*--- compute (rd|nk) ---*/
 hrr1_build_rd(Libint->AB,int_stack+2961904,int_stack+4959608,int_stack+2213464,2376);
 /*--- compute (qf|nk) ---*/
 hrr1_build_qf(Libint->AB,int_stack+10506748,int_stack+2961904,int_stack+548320,2376);
 /*--- compute (og|nk) ---*/
 hrr1_build_og(Libint->AB,int_stack+0,int_stack+10506748,int_stack+6301228,2376);
 /*--- compute (nh|nk) ---*/
 hrr1_build_nh(Libint->AB,int_stack+2779920,int_stack+0,int_stack+8154508,2376);
 return int_stack+2779920;}
