/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ninn(Libint_t*, prim_data*);

  /* Computes quartets of (ni|nn) integrals */

REALTYPE *hrr_order_ninn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[10][18] = int_stack + 60720;
 Libint->vrr_classes[10][19] = int_stack + 73260;
 Libint->vrr_classes[10][20] = int_stack + 87120;
 Libint->vrr_classes[11][10] = int_stack + 102366;
 Libint->vrr_classes[11][11] = int_stack + 107514;
 Libint->vrr_classes[11][12] = int_stack + 113598;
 Libint->vrr_classes[11][13] = int_stack + 120696;
 Libint->vrr_classes[11][14] = int_stack + 128886;
 Libint->vrr_classes[11][15] = int_stack + 138246;
 Libint->vrr_classes[11][16] = int_stack + 148854;
 Libint->vrr_classes[11][17] = int_stack + 160788;
 Libint->vrr_classes[11][18] = int_stack + 174126;
 Libint->vrr_classes[11][19] = int_stack + 188946;
 Libint->vrr_classes[11][20] = int_stack + 205326;
 Libint->vrr_classes[12][10] = int_stack + 223344;
 Libint->vrr_classes[12][11] = int_stack + 229350;
 Libint->vrr_classes[12][12] = int_stack + 236448;
 Libint->vrr_classes[12][13] = int_stack + 244729;
 Libint->vrr_classes[12][14] = int_stack + 254284;
 Libint->vrr_classes[12][15] = int_stack + 265204;
 Libint->vrr_classes[12][16] = int_stack + 277580;
 Libint->vrr_classes[12][17] = int_stack + 291503;
 Libint->vrr_classes[12][18] = int_stack + 307064;
 Libint->vrr_classes[12][19] = int_stack + 324354;
 Libint->vrr_classes[12][20] = int_stack + 343464;
 Libint->vrr_classes[13][10] = int_stack + 364485;
 Libint->vrr_classes[13][11] = int_stack + 371415;
 Libint->vrr_classes[13][12] = int_stack + 379605;
 Libint->vrr_classes[13][13] = int_stack + 389160;
 Libint->vrr_classes[13][14] = int_stack + 400185;
 Libint->vrr_classes[13][15] = int_stack + 412785;
 Libint->vrr_classes[13][16] = int_stack + 427065;
 Libint->vrr_classes[13][17] = int_stack + 443130;
 Libint->vrr_classes[13][18] = int_stack + 461085;
 Libint->vrr_classes[13][19] = int_stack + 481035;
 Libint->vrr_classes[13][20] = int_stack + 503085;
 Libint->vrr_classes[14][10] = int_stack + 527340;
 Libint->vrr_classes[14][11] = int_stack + 535260;
 Libint->vrr_classes[14][12] = int_stack + 544620;
 Libint->vrr_classes[14][13] = int_stack + 555540;
 Libint->vrr_classes[14][14] = int_stack + 568140;
 Libint->vrr_classes[14][15] = int_stack + 582540;
 Libint->vrr_classes[14][16] = int_stack + 598860;
 Libint->vrr_classes[14][17] = int_stack + 617220;
 Libint->vrr_classes[14][18] = int_stack + 637740;
 Libint->vrr_classes[14][19] = int_stack + 660540;
 Libint->vrr_classes[14][20] = int_stack + 685740;
 Libint->vrr_classes[15][10] = int_stack + 713460;
 Libint->vrr_classes[15][11] = int_stack + 722436;
 Libint->vrr_classes[15][12] = int_stack + 733044;
 Libint->vrr_classes[15][13] = int_stack + 745420;
 Libint->vrr_classes[15][14] = int_stack + 759700;
 Libint->vrr_classes[15][15] = int_stack + 776020;
 Libint->vrr_classes[15][16] = int_stack + 794516;
 Libint->vrr_classes[15][17] = int_stack + 815324;
 Libint->vrr_classes[15][18] = int_stack + 838580;
 Libint->vrr_classes[15][19] = int_stack + 864420;
 Libint->vrr_classes[15][20] = int_stack + 892980;
 Libint->vrr_classes[16][10] = int_stack + 924396;
 Libint->vrr_classes[16][11] = int_stack + 934494;
 Libint->vrr_classes[16][12] = int_stack + 946428;
 Libint->vrr_classes[16][13] = int_stack + 960351;
 Libint->vrr_classes[16][14] = int_stack + 976416;
 Libint->vrr_classes[16][15] = int_stack + 994776;
 Libint->vrr_classes[16][16] = int_stack + 1015584;
 Libint->vrr_classes[16][17] = int_stack + 1038993;
 Libint->vrr_classes[16][18] = int_stack + 1065156;
 Libint->vrr_classes[16][19] = int_stack + 1094226;
 Libint->vrr_classes[16][20] = int_stack + 1126356;
 memset(int_stack,0,1161699*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1161699;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ninn(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1161699,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1174767,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1190211,int_stack+1174767,int_stack+1161699,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1216347,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1234365,int_stack+1216347,int_stack+1174767,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1265253,int_stack+1234365,int_stack+1190211,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1161699,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1308813,int_stack+1161699,int_stack+1216347,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1182489,int_stack+1308813,int_stack+1234365,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1344849,int_stack+1182489,int_stack+1265253,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1233969,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1257729,int_stack+1233969,int_stack+1161699,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1410189,int_stack+1257729,int_stack+1308813,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1470249,int_stack+1410189,int_stack+1182489,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1547469,int_stack+1470249,int_stack+1344849,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1161699,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1299309,int_stack+1161699,int_stack+1233969,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1638945,int_stack+1299309,int_stack+1257729,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1188627,int_stack+1638945,int_stack+1410189,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1346829,int_stack+1188627,int_stack+1470249,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1708245,int_stack+1346829,int_stack+1547469,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1454937,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1485231,int_stack+1454937,int_stack+1161699,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1539087,int_stack+1485231,int_stack+1299309,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1830213,int_stack+1539087,int_stack+1638945,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1934163,int_stack+1830213,int_stack+1188627,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1161699,int_stack+1934163,int_stack+1346829,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2060289,int_stack+1161699,int_stack+1708245,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1305843,int_stack+60720,int_stack+49434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1339701,int_stack+1305843,int_stack+1454937,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1618287,int_stack+1339701,int_stack+1485231,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1400289,int_stack+1618287,int_stack+1539087,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2217105,int_stack+1400289,int_stack+1830213,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1708047,int_stack+2217105,int_stack+1934163,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2362635,int_stack+1708047,int_stack+1161699,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2547963,int_stack+2362635,int_stack+2060289,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1161699,int_stack+73260,int_stack+60720,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1199319,int_stack+1161699,int_stack+1305843,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1876215,int_stack+1199319,int_stack+1339701,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1977195,int_stack+1876215,int_stack+1618287,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1519089,int_stack+1977195,int_stack+1400289,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1267035,int_stack+1519089,int_stack+2217105,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2111835,int_stack+1267035,int_stack+1708047,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2743983,int_stack+2111835,int_stack+2362635,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2975643,int_stack+2743983,int_stack+2547963,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1461075,int_stack+87120,int_stack+73260,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1685409,int_stack+1461075,int_stack+1161699,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1760649,int_stack+1685409,int_stack+1199319,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2328051,int_stack+1760649,int_stack+1876215,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1685409,int_stack+2328051,int_stack+1977195,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2328051,int_stack+1685409,int_stack+1519089,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1461075,int_stack+2328051,int_stack+1267035,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2328051,int_stack+1461075,int_stack+2111835,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1161699,int_stack+2328051,int_stack+2743983,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1444839,int_stack+1161699,int_stack+2975643,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1161699,int_stack+107514,int_stack+102366,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1177143,int_stack+113598,int_stack+107514,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1195395,int_stack+1177143,int_stack+1161699,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1226283,int_stack+120696,int_stack+113598,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1247577,int_stack+1226283,int_stack+1177143,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1284081,int_stack+1247577,int_stack+1195395,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1161699,int_stack+128886,int_stack+120696,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1335561,int_stack+1161699,int_stack+1226283,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1186269,int_stack+1335561,int_stack+1247577,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1732335,int_stack+1186269,int_stack+1284081,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1247109,int_stack+138246,int_stack+128886,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1275189,int_stack+1247109,int_stack+1161699,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1809555,int_stack+1275189,int_stack+1335561,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1324329,int_stack+1809555,int_stack+1186269,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1880535,int_stack+1324329,int_stack+1732335,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1732335,int_stack+148854,int_stack+138246,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1161699,int_stack+1732335,int_stack+1247109,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1988643,int_stack+1161699,int_stack+1275189,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1217859,int_stack+1988643,int_stack+1809555,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2070543,int_stack+1217859,int_stack+1324329,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2198307,int_stack+2070543,int_stack+1880535,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1324329,int_stack+160788,int_stack+148854,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1360131,int_stack+1324329,int_stack+1732335,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1732335,int_stack+1360131,int_stack+1161699,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1825935,int_stack+1732335,int_stack+1988643,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2342451,int_stack+1825935,int_stack+1217859,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2491509,int_stack+2342451,int_stack+2070543,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1948785,int_stack+2491509,int_stack+2198307,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1161699,int_stack+174126,int_stack+160788,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1201713,int_stack+1161699,int_stack+1324329,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2134113,int_stack+1201713,int_stack+1360131,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1273317,int_stack+2134113,int_stack+1732335,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2661861,int_stack+1273317,int_stack+1825935,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1732335,int_stack+2661861,int_stack+2342451,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2240193,int_stack+1732335,int_stack+2491509,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2833851,int_stack+2240193,int_stack+1948785,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1931079,int_stack+188946,int_stack+174126,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1975539,int_stack+1931079,int_stack+1161699,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2459217,int_stack+1975539,int_stack+1201713,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+2459217,int_stack+2134113,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3065511,int_stack+0,int_stack+1273317,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1161699,int_stack+3065511,int_stack+2661861,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3262071,int_stack+1161699,int_stack+1732335,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3517599,int_stack+3262071,int_stack+2240193,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2055567,int_stack+3517599,int_stack+2833851,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1732335,int_stack+205326,int_stack+188946,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1781475,int_stack+1732335,int_stack+1931079,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+2578557,int_stack+1781475,int_stack+1975539,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1732335,int_stack+2578557,int_stack+2459217,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+2338707,int_stack+1732335,int_stack+0,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1732335,int_stack+2338707,int_stack+3065511,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+2338707,int_stack+1732335,int_stack+1161699,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1732335,int_stack+2338707,int_stack+3262071,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2338707,int_stack+1732335,int_stack+3517599,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2673327,int_stack+2338707,int_stack+2055567,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+1732335,int_stack+2673327,int_stack+1444839,4356);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2594823,int_stack+229350,int_stack+223344,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2612841,int_stack+236448,int_stack+229350,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2634135,int_stack+2612841,int_stack+2594823,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3013095,int_stack+244729,int_stack+236448,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3037938,int_stack+3013095,int_stack+2612841,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3080526,int_stack+3037938,int_stack+2634135,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2594823,int_stack+254284,int_stack+244729,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2623488,int_stack+2594823,int_stack+3013095,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3140586,int_stack+2623488,int_stack+3037938,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3211566,int_stack+3140586,int_stack+3080526,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3013095,int_stack+265204,int_stack+254284,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3045855,int_stack+3013095,int_stack+2594823,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3301656,int_stack+3045855,int_stack+2623488,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3384466,int_stack+3301656,int_stack+3140586,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3490936,int_stack+3384466,int_stack+3211566,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2594823,int_stack+277580,int_stack+265204,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+3103185,int_stack+2594823,int_stack+3013095,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3168705,int_stack+3103185,int_stack+3045855,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+3617062,int_stack+3168705,int_stack+3301656,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1161699,int_stack+3617062,int_stack+3384466,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3264255,int_stack+1161699,int_stack+3490936,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3013095,int_stack+291503,int_stack+277580,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3432423,int_stack+3013095,int_stack+2594823,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3506679,int_stack+3432423,int_stack+3103185,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1310757,int_stack+3506679,int_stack+3168705,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3054864,int_stack+1310757,int_stack+3617062,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1454082,int_stack+3054864,int_stack+1161699,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1454082,int_stack+3264255,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1161699,int_stack+307064,int_stack+291503,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1208382,int_stack+1161699,int_stack+3013095,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3228765,int_stack+1208382,int_stack+3432423,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3615879,int_stack+3228765,int_stack+3506679,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3352525,int_stack+3615879,int_stack+1310757,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3779679,int_stack+3352525,int_stack+3054864,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4011547,int_stack+3779679,int_stack+1454082,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1291920,int_stack+4011547,int_stack+0,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+324354,int_stack+307064,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+51870,int_stack+0,int_stack+1161699,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+145236,int_stack+51870,int_stack+1208382,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+3013095,int_stack+145236,int_stack+3228765,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+4267075,int_stack+3013095,int_stack+3615879,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+4496395,int_stack+4267075,int_stack+3352525,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3198735,int_stack+4496395,int_stack+3779679,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3496851,int_stack+3198735,int_stack+4011547,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+3816261,int_stack+3496851,int_stack+1291920,91);
 /*--- compute (q0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1161699,int_stack+343464,int_stack+324354,91);
 /*--- compute (q0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1219029,int_stack+1161699,int_stack+0,91);
 /*--- compute (q0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1322769,int_stack+1219029,int_stack+51870,91);
 /*--- compute (q0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1478379,int_stack+1322769,int_stack+145236,91);
 /*--- compute (q0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+1478379,int_stack+3013095,91);
 /*--- compute (q0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1161699,int_stack+0,int_stack+4267075,91);
 /*--- compute (q0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+1161699,int_stack+4496395,91);
 /*--- compute (q0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1161699,int_stack+0,int_stack+3198735,91);
 /*--- compute (q0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+3013095,int_stack+1161699,int_stack+3496851,91);
 /*--- compute (q0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1161699,int_stack+3013095,int_stack+3816261,91);
 /*--- compute (op|nn) ---*/
 hrr1_build_op(Libint->AB,int_stack+3013095,int_stack+1161699,int_stack+2673327,4356);
 /*--- compute (nd|nn) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4032399,int_stack+3013095,int_stack+1732335,4356);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1558095,int_stack+371415,int_stack+364485,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1578885,int_stack+379605,int_stack+371415,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1603455,int_stack+1578885,int_stack+1558095,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1645035,int_stack+389160,int_stack+379605,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1673700,int_stack+1645035,int_stack+1578885,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1722840,int_stack+1673700,int_stack+1603455,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1558095,int_stack+400185,int_stack+389160,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1792140,int_stack+1558095,int_stack+1645035,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1591170,int_stack+1792140,int_stack+1673700,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1849470,int_stack+1591170,int_stack+1722840,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1673070,int_stack+412785,int_stack+400185,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1710870,int_stack+1673070,int_stack+1558095,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1953420,int_stack+1710870,int_stack+1792140,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2048970,int_stack+1953420,int_stack+1591170,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2171820,int_stack+2048970,int_stack+1849470,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1558095,int_stack+427065,int_stack+412785,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1777020,int_stack+1558095,int_stack+1673070,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2317350,int_stack+1777020,int_stack+1710870,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1600935,int_stack+2317350,int_stack+1953420,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1852620,int_stack+1600935,int_stack+2048970,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2427600,int_stack+1852620,int_stack+2171820,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2024610,int_stack+443130,int_stack+427065,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2072805,int_stack+2024610,int_stack+1558095,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2158485,int_stack+2072805,int_stack+1777020,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2621640,int_stack+2158485,int_stack+2317350,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2787015,int_stack+2621640,int_stack+1600935,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1558095,int_stack+2787015,int_stack+1852620,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1558095,int_stack+2427600,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1787415,int_stack+461085,int_stack+443130,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1841280,int_stack+1787415,int_stack+2024610,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2284485,int_stack+1841280,int_stack+2072805,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1937670,int_stack+2284485,int_stack+2158485,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+5757375,int_stack+1937670,int_stack+2621640,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2427285,int_stack+5757375,int_stack+2787015,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2694825,int_stack+2427285,int_stack+1558095,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5988900,int_stack+2694825,int_stack+0,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+481035,int_stack+461085,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+59850,int_stack+0,int_stack+1787415,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+167580,int_stack+59850,int_stack+1841280,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1558095,int_stack+167580,int_stack+2284485,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2126670,int_stack+1558095,int_stack+1937670,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1772295,int_stack+2126670,int_stack+5757375,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+6300750,int_stack+1772295,int_stack+2427285,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+6644730,int_stack+6300750,int_stack+2694825,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2391270,int_stack+6644730,int_stack+5988900,105);
 /*--- compute (r0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+5757375,int_stack+503085,int_stack+481035,105);
 /*--- compute (r0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+5823525,int_stack+5757375,int_stack+0,105);
 /*--- compute (r0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+5943225,int_stack+5823525,int_stack+59850,105);
 /*--- compute (r0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+7013280,int_stack+5943225,int_stack+167580,105);
 /*--- compute (r0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+7013280,int_stack+1558095,105);
 /*--- compute (r0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+5757375,int_stack+0,int_stack+2126670,105);
 /*--- compute (r0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+5757375,int_stack+1772295,105);
 /*--- compute (r0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+5757375,int_stack+0,int_stack+6300750,105);
 /*--- compute (r0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+5757375,int_stack+6644730,105);
 /*--- compute (r0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+5757375,int_stack+0,int_stack+2391270,105);
 /*--- compute (qp|nn) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1558095,int_stack+5757375,int_stack+1161699,4356);
 /*--- compute (od|nn) ---*/
 hrr1_build_od(Libint->AB,int_stack+6214755,int_stack+1558095,int_stack+3013095,4356);
 /*--- compute (nf|nn) ---*/
 hrr1_build_nf(Libint->AB,int_stack+8253363,int_stack+6214755,int_stack+4032399,4356);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1161699,int_stack+535260,int_stack+527340,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1185459,int_stack+544620,int_stack+535260,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1213539,int_stack+1185459,int_stack+1161699,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1261059,int_stack+555540,int_stack+544620,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1293819,int_stack+1261059,int_stack+1185459,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1349979,int_stack+1293819,int_stack+1213539,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1161699,int_stack+568140,int_stack+555540,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1429179,int_stack+1161699,int_stack+1261059,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1199499,int_stack+1429179,int_stack+1293819,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+1199499,int_stack+1349979,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1293099,int_stack+582540,int_stack+568140,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1336299,int_stack+1293099,int_stack+1161699,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+118800,int_stack+1336299,int_stack+1429179,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1411899,int_stack+118800,int_stack+1199499,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+228000,int_stack+1411899,int_stack+0,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+598860,int_stack+582540,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1161699,int_stack+0,int_stack+1293099,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+394320,int_stack+1161699,int_stack+1336299,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1248099,int_stack+394320,int_stack+118800,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2747283,int_stack+1248099,int_stack+1411899,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2943843,int_stack+2747283,int_stack+228000,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1411899,int_stack+617220,int_stack+598860,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+48960,int_stack+1411899,int_stack+0,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+146880,int_stack+48960,int_stack+1161699,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3165603,int_stack+146880,int_stack+394320,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+290880,int_stack+3165603,int_stack+1248099,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3354603,int_stack+290880,int_stack+2747283,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3616683,int_stack+3354603,int_stack+2943843,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2747283,int_stack+637740,int_stack+617220,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2808843,int_stack+2747283,int_stack+1411899,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2919003,int_stack+2808843,int_stack+48960,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1161699,int_stack+2919003,int_stack+146880,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+1161699,int_stack+3165603,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3901803,int_stack+0,int_stack+290880,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+264600,int_stack+3901803,int_stack+3354603,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3082203,int_stack+264600,int_stack+3616683,120);
 /*--- compute (t0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+3438603,int_stack+660540,int_stack+637740,120);
 /*--- compute (t0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+3507003,int_stack+3438603,int_stack+2747283,120);
 /*--- compute (t0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+3630123,int_stack+3507003,int_stack+2808843,120);
 /*--- compute (t0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+4207563,int_stack+3630123,int_stack+2919003,120);
 /*--- compute (t0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2747283,int_stack+4207563,int_stack+1161699,120);
 /*--- compute (t0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1161699,int_stack+2747283,int_stack+0,120);
 /*--- compute (t0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+4452363,int_stack+1161699,int_stack+3901803,120);
 /*--- compute (t0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+4845483,int_stack+4452363,int_stack+264600,120);
 /*--- compute (t0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+4845483,int_stack+3082203,120);
 /*--- compute (t0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+435600,int_stack+685740,int_stack+660540,120);
 /*--- compute (t0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+511200,int_stack+435600,int_stack+3438603,120);
 /*--- compute (t0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+3049683,int_stack+511200,int_stack+3507003,120);
 /*--- compute (t0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+435600,int_stack+3049683,int_stack+3630123,120);
 /*--- compute (t0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+3049683,int_stack+435600,int_stack+4207563,120);
 /*--- compute (t0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+3392403,int_stack+3049683,int_stack+2747283,120);
 /*--- compute (t0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+2747283,int_stack+3392403,int_stack+1161699,120);
 /*--- compute (t0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+3200883,int_stack+2747283,int_stack+4452363,120);
 /*--- compute (t0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+3692283,int_stack+3200883,int_stack+4845483,120);
 /*--- compute (t0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2747283,int_stack+3692283,int_stack+0,120);
 /*--- compute (rp|nn) ---*/
 hrr1_build_rp(Libint->AB,int_stack+3270003,int_stack+2747283,int_stack+5757375,4356);
 /*--- compute (qd|nn) ---*/
 hrr1_build_qd(Libint->AB,int_stack+11128323,int_stack+3270003,int_stack+1558095,4356);
 /*--- compute (of|nn) ---*/
 hrr1_build_of(Libint->AB,int_stack+13506699,int_stack+11128323,int_stack+6214755,4356);
 /*--- compute (ng|nn) ---*/
 hrr1_build_ng(Libint->AB,int_stack+16904379,int_stack+13506699,int_stack+8253363,4356);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+722436,int_stack+713460,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+26928,int_stack+733044,int_stack+722436,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58752,int_stack+26928,int_stack+0,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+112608,int_stack+745420,int_stack+733044,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+149736,int_stack+112608,int_stack+26928,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+213384,int_stack+149736,int_stack+58752,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+759700,int_stack+745420,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+303144,int_stack+0,int_stack+112608,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+42840,int_stack+303144,int_stack+149736,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+377400,int_stack+42840,int_stack+213384,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+148920,int_stack+776020,int_stack+759700,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+197880,int_stack+148920,int_stack+0,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+512040,int_stack+197880,int_stack+303144,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+4642143,int_stack+512040,int_stack+42840,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+4801263,int_stack+4642143,int_stack+377400,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+794516,int_stack+776020,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+283560,int_stack+0,int_stack+148920,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+635800,int_stack+283560,int_stack+197880,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+55488,int_stack+635800,int_stack+512040,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+381480,int_stack+55488,int_stack+4642143,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4989759,int_stack+381480,int_stack+4801263,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+4642143,int_stack+815324,int_stack+794516,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+4704567,int_stack+4642143,int_stack+0,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+4815543,int_stack+4704567,int_stack+283560,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+5241087,int_stack+4815543,int_stack+635800,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+5455287,int_stack+5241087,int_stack+55488,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+5455287,int_stack+381480,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+297024,int_stack+0,int_stack+4989759,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+620160,int_stack+838580,int_stack+815324,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+689928,int_stack+620160,int_stack+4642143,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+4978743,int_stack+689928,int_stack+4704567,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+5715183,int_stack+4978743,int_stack+4815543,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4642143,int_stack+5715183,int_stack+5241087,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+5959983,int_stack+4642143,int_stack+5455287,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+5163703,int_stack+5959983,int_stack+0,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+6306511,int_stack+5163703,int_stack+297024,136);
 /*--- compute (u0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+864420,int_stack+838580,136);
 /*--- compute (u0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+77520,int_stack+0,int_stack+620160,136);
 /*--- compute (u0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+217056,int_stack+77520,int_stack+689928,136);
 /*--- compute (u0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+425136,int_stack+217056,int_stack+4978743,136);
 /*--- compute (u0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+6710431,int_stack+425136,int_stack+5715183,136);
 /*--- compute (u0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+5545591,int_stack+6710431,int_stack+4642143,136);
 /*--- compute (u0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+4642143,int_stack+5545591,int_stack+5959983,136);
 /*--- compute (u0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+7053151,int_stack+4642143,int_stack+5163703,136);
 /*--- compute (u0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+7530511,int_stack+7053151,int_stack+6306511,136);
 /*--- compute (u0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+5087679,int_stack+892980,int_stack+864420,136);
 /*--- compute (u0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+5173359,int_stack+5087679,int_stack+0,136);
 /*--- compute (u0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+5945431,int_stack+5173359,int_stack+77520,136);
 /*--- compute (u0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+5087679,int_stack+5945431,int_stack+217056,136);
 /*--- compute (u0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+5945431,int_stack+5087679,int_stack+425136,136);
 /*--- compute (u0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+5087679,int_stack+5945431,int_stack+6710431,136);
 /*--- compute (u0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+5945431,int_stack+5087679,int_stack+5545591,136);
 /*--- compute (u0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+5087679,int_stack+5945431,int_stack+4642143,136);
 /*--- compute (u0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+5644599,int_stack+5087679,int_stack+7053151,136);
 /*--- compute (u0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+4642143,int_stack+5644599,int_stack+7530511,136);
 /*--- compute (tp|nn) ---*/
 hrr1_build_tp(Libint->AB,int_stack+5234559,int_stack+4642143,int_stack+2747283,4356);
 /*--- compute (rd|nn) ---*/
 hrr1_build_rd(Libint->AB,int_stack+6802719,int_stack+5234559,int_stack+3270003,4356);
 /*--- compute (qf|nn) ---*/
 hrr1_build_qf(Libint->AB,int_stack+21216819,int_stack+6802719,int_stack+11128323,4356);
 /*--- compute (og|nn) ---*/
 hrr1_build_og(Libint->AB,int_stack+25180779,int_stack+21216819,int_stack+13506699,4356);
 /*--- compute (nh|nn) ---*/
 hrr1_build_nh(Libint->AB,int_stack+9546999,int_stack+25180779,int_stack+16904379,4356);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15584415,int_stack+934494,int_stack+924396,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15614709,int_stack+946428,int_stack+934494,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15650511,int_stack+15614709,int_stack+15584415,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+15711099,int_stack+960351,int_stack+946428,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+15752868,int_stack+15711099,int_stack+15614709,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+15824472,int_stack+15752868,int_stack+15650511,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+15584415,int_stack+976416,int_stack+960351,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+15925452,int_stack+15584415,int_stack+15711099,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+15632610,int_stack+15925452,int_stack+15752868,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+16008990,int_stack+15632610,int_stack+15824472,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+15751950,int_stack+994776,int_stack+976416,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+15807030,int_stack+15751950,int_stack+15584415,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+16160460,int_stack+15807030,int_stack+15925452,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+16299690,int_stack+16160460,int_stack+15632610,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+16478700,int_stack+16299690,int_stack+16008990,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+15584415,int_stack+1015584,int_stack+994776,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+15903420,int_stack+15584415,int_stack+15751950,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+16690758,int_stack+15903420,int_stack+15807030,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+15646839,int_stack+16690758,int_stack+16160460,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+16013580,int_stack+15646839,int_stack+16299690,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+16851408,int_stack+16013580,int_stack+16478700,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+16264194,int_stack+1038993,int_stack+1015584,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+16334421,int_stack+16264194,int_stack+15584415,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+16459269,int_stack+16334421,int_stack+15903420,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+17134152,int_stack+16459269,int_stack+16690758,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+17375127,int_stack+17134152,int_stack+15646839,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+15584415,int_stack+17375127,int_stack+16013580,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+17667510,int_stack+15584415,int_stack+16851408,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+15918567,int_stack+1065156,int_stack+1038993,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+15997056,int_stack+15918567,int_stack+16264194,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+16642869,int_stack+15997056,int_stack+16334421,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+16137510,int_stack+16642869,int_stack+16459269,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+18031038,int_stack+16137510,int_stack+17134152,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+16850949,int_stack+18031038,int_stack+17375127,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+18368403,int_stack+16850949,int_stack+15584415,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+18798027,int_stack+18368403,int_stack+17667510,153);
 /*--- compute (v0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+15584415,int_stack+1094226,int_stack+1065156,153);
 /*--- compute (v0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+15671625,int_stack+15584415,int_stack+15918567,153);
 /*--- compute (v0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+17240793,int_stack+15671625,int_stack+15997056,153);
 /*--- compute (v0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+17474883,int_stack+17240793,int_stack+16642869,153);
 /*--- compute (v0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+16412910,int_stack+17474883,int_stack+16137510,153);
 /*--- compute (v0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+15828603,int_stack+16412910,int_stack+18031038,153);
 /*--- compute (v0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+17787003,int_stack+15828603,int_stack+16850949,153);
 /*--- compute (v0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+19252437,int_stack+17787003,int_stack+18368403,153);
 /*--- compute (v0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+19789467,int_stack+19252437,int_stack+18798027,153);
 /*--- compute (v0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+16278423,int_stack+1126356,int_stack+1094226,153);
 /*--- compute (v0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+16798470,int_stack+16278423,int_stack+15584415,153);
 /*--- compute (v0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+16972890,int_stack+16798470,int_stack+15671625,153);
 /*--- compute (v0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+18288231,int_stack+16972890,int_stack+17240793,153);
 /*--- compute (v0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+16798470,int_stack+18288231,int_stack+17474883,153);
 /*--- compute (v0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+18288231,int_stack+16798470,int_stack+16412910,153);
 /*--- compute (v0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+16278423,int_stack+18288231,int_stack+15828603,153);
 /*--- compute (v0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+18288231,int_stack+16278423,int_stack+17787003,153);
 /*--- compute (v0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+15584415,int_stack+18288231,int_stack+19252437,153);
 /*--- compute (v0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+16240785,int_stack+15584415,int_stack+19789467,153);
 /*--- compute (up|nn) ---*/
 hrr1_build_up(Libint->AB,int_stack+16907253,int_stack+16240785,int_stack+4642143,4356);
 /*--- compute (td|nn) ---*/
 hrr1_build_td(Libint->AB,int_stack+0,int_stack+16907253,int_stack+5234559,4356);
 /*--- compute (rf|nn) ---*/
 hrr1_build_rf(Libint->AB,int_stack+15584415,int_stack+0,int_stack+6802719,4356);
 /*--- compute (qg|nn) ---*/
 hrr1_build_qg(Libint->AB,int_stack+0,int_stack+15584415,int_stack+21216819,4356);
 /*--- compute (oh|nn) ---*/
 hrr1_build_oh(Libint->AB,int_stack+15584415,int_stack+0,int_stack+25180779,4356);
 /*--- compute (ni|nn) ---*/
 hrr1_build_ni(Libint->AB,int_stack+0,int_stack+15584415,int_stack+9546999,4356);
 return int_stack+0;}
