/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nknm(Libint_t*, prim_data*);

  /* Computes quartets of (nk|nm) integrals */

REALTYPE *hrr_order_nknm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[10][18] = int_stack + 60720;
 Libint->vrr_classes[10][19] = int_stack + 73260;
 Libint->vrr_classes[11][10] = int_stack + 87120;
 Libint->vrr_classes[11][11] = int_stack + 92268;
 Libint->vrr_classes[11][12] = int_stack + 98352;
 Libint->vrr_classes[11][13] = int_stack + 105450;
 Libint->vrr_classes[11][14] = int_stack + 113640;
 Libint->vrr_classes[11][15] = int_stack + 123000;
 Libint->vrr_classes[11][16] = int_stack + 133608;
 Libint->vrr_classes[11][17] = int_stack + 145542;
 Libint->vrr_classes[11][18] = int_stack + 158880;
 Libint->vrr_classes[11][19] = int_stack + 173700;
 Libint->vrr_classes[12][10] = int_stack + 190080;
 Libint->vrr_classes[12][11] = int_stack + 196086;
 Libint->vrr_classes[12][12] = int_stack + 203184;
 Libint->vrr_classes[12][13] = int_stack + 211465;
 Libint->vrr_classes[12][14] = int_stack + 221020;
 Libint->vrr_classes[12][15] = int_stack + 231940;
 Libint->vrr_classes[12][16] = int_stack + 244316;
 Libint->vrr_classes[12][17] = int_stack + 258239;
 Libint->vrr_classes[12][18] = int_stack + 273800;
 Libint->vrr_classes[12][19] = int_stack + 291090;
 Libint->vrr_classes[13][10] = int_stack + 310200;
 Libint->vrr_classes[13][11] = int_stack + 317130;
 Libint->vrr_classes[13][12] = int_stack + 325320;
 Libint->vrr_classes[13][13] = int_stack + 334875;
 Libint->vrr_classes[13][14] = int_stack + 345900;
 Libint->vrr_classes[13][15] = int_stack + 358500;
 Libint->vrr_classes[13][16] = int_stack + 372780;
 Libint->vrr_classes[13][17] = int_stack + 388845;
 Libint->vrr_classes[13][18] = int_stack + 406800;
 Libint->vrr_classes[13][19] = int_stack + 426750;
 Libint->vrr_classes[14][10] = int_stack + 448800;
 Libint->vrr_classes[14][11] = int_stack + 456720;
 Libint->vrr_classes[14][12] = int_stack + 466080;
 Libint->vrr_classes[14][13] = int_stack + 477000;
 Libint->vrr_classes[14][14] = int_stack + 489600;
 Libint->vrr_classes[14][15] = int_stack + 504000;
 Libint->vrr_classes[14][16] = int_stack + 520320;
 Libint->vrr_classes[14][17] = int_stack + 538680;
 Libint->vrr_classes[14][18] = int_stack + 559200;
 Libint->vrr_classes[14][19] = int_stack + 582000;
 Libint->vrr_classes[15][10] = int_stack + 607200;
 Libint->vrr_classes[15][11] = int_stack + 616176;
 Libint->vrr_classes[15][12] = int_stack + 626784;
 Libint->vrr_classes[15][13] = int_stack + 639160;
 Libint->vrr_classes[15][14] = int_stack + 653440;
 Libint->vrr_classes[15][15] = int_stack + 669760;
 Libint->vrr_classes[15][16] = int_stack + 688256;
 Libint->vrr_classes[15][17] = int_stack + 709064;
 Libint->vrr_classes[15][18] = int_stack + 732320;
 Libint->vrr_classes[15][19] = int_stack + 758160;
 Libint->vrr_classes[16][10] = int_stack + 786720;
 Libint->vrr_classes[16][11] = int_stack + 796818;
 Libint->vrr_classes[16][12] = int_stack + 808752;
 Libint->vrr_classes[16][13] = int_stack + 822675;
 Libint->vrr_classes[16][14] = int_stack + 838740;
 Libint->vrr_classes[16][15] = int_stack + 857100;
 Libint->vrr_classes[16][16] = int_stack + 877908;
 Libint->vrr_classes[16][17] = int_stack + 901317;
 Libint->vrr_classes[16][18] = int_stack + 927480;
 Libint->vrr_classes[16][19] = int_stack + 956550;
 Libint->vrr_classes[17][10] = int_stack + 988680;
 Libint->vrr_classes[17][11] = int_stack + 999966;
 Libint->vrr_classes[17][12] = int_stack + 1013304;
 Libint->vrr_classes[17][13] = int_stack + 1028865;
 Libint->vrr_classes[17][14] = int_stack + 1046820;
 Libint->vrr_classes[17][15] = int_stack + 1067340;
 Libint->vrr_classes[17][16] = int_stack + 1090596;
 Libint->vrr_classes[17][17] = int_stack + 1116759;
 Libint->vrr_classes[17][18] = int_stack + 1146000;
 Libint->vrr_classes[17][19] = int_stack + 1178490;
 memset(int_stack,0,1214400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1214400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nknm(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1214400,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1227468,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1242912,int_stack+1227468,int_stack+1214400,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1269048,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1287066,int_stack+1269048,int_stack+1227468,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1317954,int_stack+1287066,int_stack+1242912,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1214400,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1361514,int_stack+1214400,int_stack+1269048,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1235190,int_stack+1361514,int_stack+1287066,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1397550,int_stack+1235190,int_stack+1317954,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1286670,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1310430,int_stack+1286670,int_stack+1214400,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1462890,int_stack+1310430,int_stack+1361514,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1522950,int_stack+1462890,int_stack+1235190,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1600170,int_stack+1522950,int_stack+1397550,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1214400,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1352010,int_stack+1214400,int_stack+1286670,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1691646,int_stack+1352010,int_stack+1310430,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1241328,int_stack+1691646,int_stack+1462890,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1399530,int_stack+1241328,int_stack+1522950,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1760946,int_stack+1399530,int_stack+1600170,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1507638,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1537932,int_stack+1507638,int_stack+1214400,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1591788,int_stack+1537932,int_stack+1352010,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1882914,int_stack+1591788,int_stack+1691646,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1986864,int_stack+1882914,int_stack+1241328,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1214400,int_stack+1986864,int_stack+1399530,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2112990,int_stack+1214400,int_stack+1760946,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1358544,int_stack+60720,int_stack+49434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1392402,int_stack+1358544,int_stack+1507638,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1670988,int_stack+1392402,int_stack+1537932,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1452990,int_stack+1670988,int_stack+1591788,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2269806,int_stack+1452990,int_stack+1882914,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1760748,int_stack+2269806,int_stack+1986864,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2415336,int_stack+1760748,int_stack+1214400,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2600664,int_stack+2415336,int_stack+2112990,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1214400,int_stack+73260,int_stack+60720,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1252020,int_stack+1214400,int_stack+1358544,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1928916,int_stack+1252020,int_stack+1392402,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1214400,int_stack+1928916,int_stack+1670988,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1928916,int_stack+1214400,int_stack+1452990,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1214400,int_stack+1928916,int_stack+2269806,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1928916,int_stack+1214400,int_stack+1760748,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1214400,int_stack+1928916,int_stack+2415336,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1446060,int_stack+1214400,int_stack+2600664,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1214400,int_stack+92268,int_stack+87120,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1229844,int_stack+98352,int_stack+92268,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1248096,int_stack+1229844,int_stack+1214400,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1278984,int_stack+105450,int_stack+98352,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1300278,int_stack+1278984,int_stack+1229844,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1336782,int_stack+1300278,int_stack+1248096,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1214400,int_stack+113640,int_stack+105450,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1388262,int_stack+1214400,int_stack+1278984,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1238970,int_stack+1388262,int_stack+1300278,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1685640,int_stack+1238970,int_stack+1336782,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1299810,int_stack+123000,int_stack+113640,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1327890,int_stack+1299810,int_stack+1214400,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1762860,int_stack+1327890,int_stack+1388262,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1833840,int_stack+1762860,int_stack+1238970,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1925100,int_stack+1833840,int_stack+1685640,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1685640,int_stack+133608,int_stack+123000,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1214400,int_stack+1685640,int_stack+1299810,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2033208,int_stack+1214400,int_stack+1327890,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1270560,int_stack+2033208,int_stack+1762860,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2115108,int_stack+1270560,int_stack+1833840,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1717464,int_stack+2115108,int_stack+1925100,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1861608,int_stack+145542,int_stack+133608,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1897410,int_stack+1861608,int_stack+1685640,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2242872,int_stack+1897410,int_stack+1214400,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2336472,int_stack+2242872,int_stack+2033208,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1961058,int_stack+2336472,int_stack+1270560,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1214400,int_stack+1961058,int_stack+2115108,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2459322,int_stack+1214400,int_stack+1717464,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1384752,int_stack+158880,int_stack+145542,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1685640,int_stack+1384752,int_stack+1861608,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1757244,int_stack+1685640,int_stack+1897410,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2644650,int_stack+1757244,int_stack+2242872,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2110116,int_stack+2644650,int_stack+2336472,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2785050,int_stack+2110116,int_stack+1961058,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1863324,int_stack+2785050,int_stack+1214400,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2983794,int_stack+1863324,int_stack+2459322,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1214400,int_stack+173700,int_stack+158880,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1258860,int_stack+1214400,int_stack+1384752,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2282106,int_stack+1258860,int_stack+1685640,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1214400,int_stack+2282106,int_stack+1757244,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2282106,int_stack+1214400,int_stack+2644650,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1214400,int_stack+2282106,int_stack+2110116,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2082348,int_stack+1214400,int_stack+2785050,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2337876,int_stack+2082348,int_stack+1863324,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1685640,int_stack+2337876,int_stack+2983794,78);
 /*--- compute (np|nm) ---*/
 hrr1_build_np(Libint->AB,int_stack+1968780,int_stack+1685640,int_stack+1446060,3630);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1214400,int_stack+196086,int_stack+190080,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1232418,int_stack+203184,int_stack+196086,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1253712,int_stack+1232418,int_stack+1214400,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1289748,int_stack+211465,int_stack+203184,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1314591,int_stack+1289748,int_stack+1232418,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1357179,int_stack+1314591,int_stack+1253712,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1214400,int_stack+221020,int_stack+211465,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1417239,int_stack+1214400,int_stack+1289748,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1243065,int_stack+1417239,int_stack+1314591,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1466925,int_stack+1243065,int_stack+1357179,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1314045,int_stack+231940,int_stack+221020,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1346805,int_stack+1314045,int_stack+1214400,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1557015,int_stack+1346805,int_stack+1417239,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2687520,int_stack+1557015,int_stack+1243065,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2793990,int_stack+2687520,int_stack+1466925,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1214400,int_stack+244316,int_stack+231940,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1404135,int_stack+1214400,int_stack+1314045,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2920116,int_stack+1404135,int_stack+1346805,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1251528,int_stack+2920116,int_stack+1557015,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1469655,int_stack+1251528,int_stack+2687520,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3015666,int_stack+1469655,int_stack+2793990,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2687520,int_stack+258239,int_stack+244316,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2729289,int_stack+2687520,int_stack+1214400,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2803545,int_stack+2729289,int_stack+1404135,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+2803545,int_stack+2920116,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3183834,int_stack+0,int_stack+1251528,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1214400,int_stack+3183834,int_stack+1469655,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1413144,int_stack+1214400,int_stack+3015666,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1629360,int_stack+273800,int_stack+258239,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2912745,int_stack+1629360,int_stack+2687520,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2996283,int_stack+2912745,int_stack+2729289,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3357735,int_stack+2996283,int_stack+2803545,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2687520,int_stack+3357735,int_stack+0,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+2687520,int_stack+3183834,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3521535,int_stack+0,int_stack+1214400,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3777063,int_stack+3521535,int_stack+1413144,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1214400,int_stack+291090,int_stack+273800,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1266270,int_stack+1214400,int_stack+1629360,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1359636,int_stack+1266270,int_stack+2912745,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1498866,int_stack+1359636,int_stack+2996283,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1214400,int_stack+1498866,int_stack+3357735,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2888175,int_stack+1214400,int_stack+2687520,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1214400,int_stack+2888175,int_stack+0,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2687520,int_stack+1214400,int_stack+3521535,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1214400,int_stack+2687520,int_stack+3777063,91);
 /*--- compute (op|nm) ---*/
 hrr1_build_op(Libint->AB,int_stack+2687520,int_stack+1214400,int_stack+1685640,3630);
 /*--- compute (nd|nm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3536940,int_stack+2687520,int_stack+1968780,3630);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1544730,int_stack+317130,int_stack+310200,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1565520,int_stack+325320,int_stack+317130,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1590090,int_stack+1565520,int_stack+1544730,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1631670,int_stack+334875,int_stack+325320,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1660335,int_stack+1631670,int_stack+1565520,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1709475,int_stack+1660335,int_stack+1590090,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1544730,int_stack+345900,int_stack+334875,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1778775,int_stack+1544730,int_stack+1631670,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1577805,int_stack+1778775,int_stack+1660335,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1836105,int_stack+1577805,int_stack+1709475,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1659705,int_stack+358500,int_stack+345900,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1697505,int_stack+1659705,int_stack+1544730,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1940055,int_stack+1697505,int_stack+1778775,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2035605,int_stack+1940055,int_stack+1577805,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2158455,int_stack+2035605,int_stack+1836105,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1544730,int_stack+372780,int_stack+358500,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1763655,int_stack+1544730,int_stack+1659705,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2303985,int_stack+1763655,int_stack+1697505,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1587570,int_stack+2303985,int_stack+1940055,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1839255,int_stack+1587570,int_stack+2035605,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2414235,int_stack+1839255,int_stack+2158455,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2011245,int_stack+388845,int_stack+372780,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2059440,int_stack+2011245,int_stack+1544730,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2145120,int_stack+2059440,int_stack+1763655,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+2145120,int_stack+2303985,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+165375,int_stack+0,int_stack+1587570,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1544730,int_stack+165375,int_stack+1839255,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4974420,int_stack+1544730,int_stack+2414235,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1774050,int_stack+406800,int_stack+388845,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1827915,int_stack+1774050,int_stack+2011245,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2271120,int_stack+1827915,int_stack+2059440,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1924305,int_stack+2271120,int_stack+2145120,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2413920,int_stack+1924305,int_stack+0,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+5223900,int_stack+2413920,int_stack+165375,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+5223900,int_stack+1544730,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5491440,int_stack+0,int_stack+4974420,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+4974420,int_stack+426750,int_stack+406800,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+5034270,int_stack+4974420,int_stack+1774050,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1544730,int_stack+5034270,int_stack+1827915,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+4974420,int_stack+1544730,int_stack+2271120,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1544730,int_stack+4974420,int_stack+1924305,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1809330,int_stack+1544730,int_stack+2413920,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2118030,int_stack+1809330,int_stack+5223900,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1544730,int_stack+2118030,int_stack+0,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+1544730,int_stack+5491440,105);
 /*--- compute (qp|nm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1544730,int_stack+0,int_stack+1214400,3630);
 /*--- compute (od|nm) ---*/
 hrr1_build_od(Libint->AB,int_stack+4974420,int_stack+1544730,int_stack+2687520,3630);
 /*--- compute (nf|nm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+6673260,int_stack+4974420,int_stack+3536940,3630);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1214400,int_stack+456720,int_stack+448800,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1238160,int_stack+466080,int_stack+456720,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1266240,int_stack+1238160,int_stack+1214400,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1313760,int_stack+477000,int_stack+466080,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1346520,int_stack+1313760,int_stack+1238160,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1402680,int_stack+1346520,int_stack+1266240,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1214400,int_stack+489600,int_stack+477000,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2535720,int_stack+1214400,int_stack+1313760,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1252200,int_stack+2535720,int_stack+1346520,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2601240,int_stack+1252200,int_stack+1402680,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1345800,int_stack+504000,int_stack+489600,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1389000,int_stack+1345800,int_stack+1214400,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2720040,int_stack+1389000,int_stack+2535720,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2829240,int_stack+2720040,int_stack+1252200,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2969640,int_stack+2829240,int_stack+2601240,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2535720,int_stack+520320,int_stack+504000,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2584680,int_stack+2535720,int_stack+1345800,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1214400,int_stack+2584680,int_stack+1389000,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1340400,int_stack+1214400,int_stack+2720040,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3135960,int_stack+1340400,int_stack+2829240,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2671080,int_stack+3135960,int_stack+2969640,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2892840,int_stack+538680,int_stack+520320,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2947920,int_stack+2892840,int_stack+2535720,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3332520,int_stack+2947920,int_stack+2584680,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3476520,int_stack+3332520,int_stack+1214400,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3665520,int_stack+3476520,int_stack+1340400,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1214400,int_stack+3665520,int_stack+3135960,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3045840,int_stack+1214400,int_stack+2671080,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1476480,int_stack+559200,int_stack+538680,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2535720,int_stack+1476480,int_stack+2892840,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2645880,int_stack+2535720,int_stack+2947920,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2809080,int_stack+2645880,int_stack+3332520,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3894840,int_stack+2809080,int_stack+3476520,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3330960,int_stack+3894840,int_stack+3665520,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4159440,int_stack+3330960,int_stack+1214400,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4496400,int_stack+4159440,int_stack+3045840,120);
 /*--- compute (t0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1214400,int_stack+582000,int_stack+559200,120);
 /*--- compute (t0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1282800,int_stack+1214400,int_stack+1476480,120);
 /*--- compute (t0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+3025080,int_stack+1282800,int_stack+2535720,120);
 /*--- compute (t0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1214400,int_stack+3025080,int_stack+2645880,120);
 /*--- compute (t0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3025080,int_stack+1214400,int_stack+2809080,120);
 /*--- compute (t0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2535720,int_stack+3025080,int_stack+3894840,120);
 /*--- compute (t0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2888520,int_stack+2535720,int_stack+3330960,120);
 /*--- compute (t0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3281640,int_stack+2888520,int_stack+4159440,120);
 /*--- compute (t0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2535720,int_stack+3281640,int_stack+4496400,120);
 /*--- compute (rp|nm) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2971320,int_stack+2535720,int_stack+0,3630);
 /*--- compute (qd|nm) ---*/
 hrr1_build_qd(Libint->AB,int_stack+9069060,int_stack+2971320,int_stack+1544730,3630);
 /*--- compute (of|nm) ---*/
 hrr1_build_of(Libint->AB,int_stack+11051040,int_stack+9069060,int_stack+4974420,3630);
 /*--- compute (ng|nm) ---*/
 hrr1_build_ng(Libint->AB,int_stack+13882440,int_stack+11051040,int_stack+6673260,3630);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+616176,int_stack+607200,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+26928,int_stack+626784,int_stack+616176,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58752,int_stack+26928,int_stack+0,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+112608,int_stack+639160,int_stack+626784,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+149736,int_stack+112608,int_stack+26928,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+213384,int_stack+149736,int_stack+58752,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+653440,int_stack+639160,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+303144,int_stack+0,int_stack+112608,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+42840,int_stack+303144,int_stack+149736,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+377400,int_stack+42840,int_stack+213384,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+148920,int_stack+669760,int_stack+653440,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+197880,int_stack+148920,int_stack+0,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+512040,int_stack+197880,int_stack+303144,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+4114770,int_stack+512040,int_stack+42840,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+4273890,int_stack+4114770,int_stack+377400,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+688256,int_stack+669760,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+283560,int_stack+0,int_stack+148920,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4462386,int_stack+283560,int_stack+197880,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+55488,int_stack+4462386,int_stack+512040,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+381480,int_stack+55488,int_stack+4114770,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4605186,int_stack+381480,int_stack+4273890,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+4114770,int_stack+709064,int_stack+688256,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+4177194,int_stack+4114770,int_stack+0,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+4288170,int_stack+4177194,int_stack+283560,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4856514,int_stack+4288170,int_stack+4462386,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+5070714,int_stack+4856514,int_stack+55488,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+5070714,int_stack+381480,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+297024,int_stack+0,int_stack+4605186,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+620160,int_stack+732320,int_stack+709064,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+4451370,int_stack+620160,int_stack+4114770,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+4576218,int_stack+4451370,int_stack+4177194,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+5330610,int_stack+4576218,int_stack+4288170,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4114770,int_stack+5330610,int_stack+4856514,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+5575410,int_stack+4114770,int_stack+5070714,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4761178,int_stack+5575410,int_stack+0,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5921938,int_stack+4761178,int_stack+297024,136);
 /*--- compute (u0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+758160,int_stack+732320,136);
 /*--- compute (u0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+77520,int_stack+0,int_stack+620160,136);
 /*--- compute (u0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+217056,int_stack+77520,int_stack+4451370,136);
 /*--- compute (u0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+425136,int_stack+217056,int_stack+4576218,136);
 /*--- compute (u0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+425136,int_stack+5330610,136);
 /*--- compute (u0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+342720,int_stack+0,int_stack+4114770,136);
 /*--- compute (u0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+4114770,int_stack+342720,int_stack+5575410,136);
 /*--- compute (u0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+4114770,int_stack+4761178,136);
 /*--- compute (u0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+4114770,int_stack+0,int_stack+5921938,136);
 /*--- compute (tp|nm) ---*/
 hrr1_build_tp(Libint->AB,int_stack+4608450,int_stack+4114770,int_stack+2535720,3630);
 /*--- compute (rd|nm) ---*/
 hrr1_build_rd(Libint->AB,int_stack+5915250,int_stack+4608450,int_stack+2971320,3630);
 /*--- compute (qf|nm) ---*/
 hrr1_build_qf(Libint->AB,int_stack+17476140,int_stack+5915250,int_stack+9069060,3630);
 /*--- compute (og|nm) ---*/
 hrr1_build_og(Libint->AB,int_stack+20779440,int_stack+17476140,int_stack+11051040,3630);
 /*--- compute (nh|nm) ---*/
 hrr1_build_nh(Libint->AB,int_stack+8202150,int_stack+20779440,int_stack+13882440,3630);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+796818,int_stack+786720,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+30294,int_stack+808752,int_stack+796818,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+66096,int_stack+30294,int_stack+0,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+126684,int_stack+822675,int_stack+808752,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+168453,int_stack+126684,int_stack+30294,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+240057,int_stack+168453,int_stack+66096,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+838740,int_stack+822675,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+341037,int_stack+0,int_stack+126684,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+48195,int_stack+341037,int_stack+168453,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+424575,int_stack+48195,int_stack+240057,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+167535,int_stack+857100,int_stack+838740,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+222615,int_stack+167535,int_stack+0,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+576045,int_stack+222615,int_stack+341037,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+13233330,int_stack+576045,int_stack+48195,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+13412340,int_stack+13233330,int_stack+424575,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+877908,int_stack+857100,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+319005,int_stack+0,int_stack+167535,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+715275,int_stack+319005,int_stack+222615,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+62424,int_stack+715275,int_stack+576045,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+429165,int_stack+62424,int_stack+13233330,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+13624398,int_stack+429165,int_stack+13412340,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+13233330,int_stack+901317,int_stack+877908,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+13303557,int_stack+13233330,int_stack+0,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+13428405,int_stack+13303557,int_stack+319005,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+13907142,int_stack+13428405,int_stack+715275,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+14148117,int_stack+13907142,int_stack+62424,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+14148117,int_stack+429165,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+334152,int_stack+0,int_stack+13624398,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+697680,int_stack+927480,int_stack+901317,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+776169,int_stack+697680,int_stack+13233330,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+13612005,int_stack+776169,int_stack+13303557,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+14440500,int_stack+13612005,int_stack+13428405,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+13233330,int_stack+14440500,int_stack+13907142,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+14715900,int_stack+13233330,int_stack+14148117,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+13820085,int_stack+14715900,int_stack+0,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+15105744,int_stack+13820085,int_stack+334152,153);
 /*--- compute (v0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+956550,int_stack+927480,153);
 /*--- compute (v0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+87210,int_stack+0,int_stack+697680,153);
 /*--- compute (v0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+244188,int_stack+87210,int_stack+776169,153);
 /*--- compute (v0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+478278,int_stack+244188,int_stack+13612005,153);
 /*--- compute (v0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+478278,int_stack+14440500,153);
 /*--- compute (v0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+385560,int_stack+0,int_stack+13233330,153);
 /*--- compute (v0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+13233330,int_stack+385560,int_stack+14715900,153);
 /*--- compute (v0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+13233330,int_stack+13820085,153);
 /*--- compute (v0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+13233330,int_stack+0,int_stack+15105744,153);
 /*--- compute (up|nm) ---*/
 hrr1_build_up(Libint->AB,int_stack+13788720,int_stack+13233330,int_stack+4114770,3630);
 /*--- compute (td|nm) ---*/
 hrr1_build_td(Libint->AB,int_stack+1214400,int_stack+13788720,int_stack+4608450,3630);
 /*--- compute (rf|nm) ---*/
 hrr1_build_rf(Libint->AB,int_stack+25026540,int_stack+1214400,int_stack+5915250,3630);
 /*--- compute (qg|nm) ---*/
 hrr1_build_qg(Libint->AB,int_stack+28838040,int_stack+25026540,int_stack+17476140,3630);
 /*--- compute (oh|nm) ---*/
 hrr1_build_oh(Libint->AB,int_stack+33792990,int_stack+28838040,int_stack+20779440,3630);
 /*--- compute (ni|nm) ---*/
 hrr1_build_ni(Libint->AB,int_stack+15269760,int_stack+33792990,int_stack+8202150,3630);
 /*--- compute (w0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+999966,int_stack+988680,171);
 /*--- compute (w0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33858,int_stack+1013304,int_stack+999966,171);
 /*--- compute (w0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+73872,int_stack+33858,int_stack+0,171);
 /*--- compute (w0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+141588,int_stack+1028865,int_stack+1013304,171);
 /*--- compute (w0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+188271,int_stack+141588,int_stack+33858,171);
 /*--- compute (w0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+268299,int_stack+188271,int_stack+73872,171);
 /*--- compute (w0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+1046820,int_stack+1028865,171);
 /*--- compute (w0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+381159,int_stack+0,int_stack+141588,171);
 /*--- compute (w0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+53865,int_stack+381159,int_stack+188271,171);
 /*--- compute (w0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+474525,int_stack+53865,int_stack+268299,171);
 /*--- compute (w0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+187245,int_stack+1067340,int_stack+1046820,171);
 /*--- compute (w0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+248805,int_stack+187245,int_stack+0,171);
 /*--- compute (w0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+643815,int_stack+248805,int_stack+381159,171);
 /*--- compute (w0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+799425,int_stack+643815,int_stack+53865,171);
 /*--- compute (w0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+21978000,int_stack+799425,int_stack+474525,171);
 /*--- compute (w0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+1090596,int_stack+1067340,171);
 /*--- compute (w0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+356535,int_stack+0,int_stack+187245,171);
 /*--- compute (w0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+22215006,int_stack+356535,int_stack+248805,171);
 /*--- compute (w0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+69768,int_stack+22215006,int_stack+643815,171);
 /*--- compute (w0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+479655,int_stack+69768,int_stack+799425,171);
 /*--- compute (w0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+759753,int_stack+479655,int_stack+21978000,171);
 /*--- compute (w0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+21978000,int_stack+1116759,int_stack+1090596,171);
 /*--- compute (w0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+22056489,int_stack+21978000,int_stack+0,171);
 /*--- compute (w0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+22394556,int_stack+22056489,int_stack+356535,171);
 /*--- compute (w0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+22599756,int_stack+22394556,int_stack+22215006,171);
 /*--- compute (w0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+22869081,int_stack+22599756,int_stack+69768,171);
 /*--- compute (w0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+22869081,int_stack+479655,171);
 /*--- compute (w0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+23195862,int_stack+0,int_stack+759753,171);
 /*--- compute (w0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+373464,int_stack+1146000,int_stack+1116759,171);
 /*--- compute (w0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+461187,int_stack+373464,int_stack+21978000,171);
 /*--- compute (w0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+618165,int_stack+461187,int_stack+22056489,171);
 /*--- compute (w0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+21978000,int_stack+618165,int_stack+22394556,171);
 /*--- compute (w0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+23602158,int_stack+21978000,int_stack+22599756,171);
 /*--- compute (w0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+22285800,int_stack+23602158,int_stack+22869081,171);
 /*--- compute (w0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+23979213,int_stack+22285800,int_stack+0,171);
 /*--- compute (w0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+24459381,int_stack+23979213,int_stack+23195862,171);
 /*--- compute (w0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+1178490,int_stack+1146000,171);
 /*--- compute (w0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+97470,int_stack+0,int_stack+373464,171);
 /*--- compute (w0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+22721508,int_stack+97470,int_stack+461187,171);
 /*--- compute (w0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+22721508,int_stack+618165,171);
 /*--- compute (w0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+22721508,int_stack+0,int_stack+21978000,171);
 /*--- compute (w0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+0,int_stack+22721508,int_stack+23602158,171);
 /*--- compute (w0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+22721508,int_stack+0,int_stack+22285800,171);
 /*--- compute (w0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+22721508,int_stack+23979213,171);
 /*--- compute (w0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+21978000,int_stack+0,int_stack+24459381,171);
 /*--- compute (vp|nm) ---*/
 hrr1_build_vp(Libint->AB,int_stack+22598730,int_stack+21978000,int_stack+13233330,3630);
 /*--- compute (ud|nm) ---*/
 hrr1_build_ud(Libint->AB,int_stack+3828000,int_stack+22598730,int_stack+13788720,3630);
 /*--- compute (tf|nm) ---*/
 hrr1_build_tf(Libint->AB,int_stack+6790080,int_stack+3828000,int_stack+1214400,3630);
 /*--- compute (rg|nm) ---*/
 hrr1_build_rg(Libint->AB,int_stack+0,int_stack+6790080,int_stack+25026540,3630);
 /*--- compute (qh|nm) ---*/
 hrr1_build_qh(Libint->AB,int_stack+5717250,int_stack+0,int_stack+28838040,3630);
 /*--- compute (oi|nm) ---*/
 hrr1_build_oi(Libint->AB,int_stack+21978000,int_stack+5717250,int_stack+33792990,3630);
 /*--- compute (nk|nm) ---*/
 hrr1_build_nk(Libint->AB,int_stack+0,int_stack+21978000,int_stack+15269760,3630);
 return int_stack+0;}
