/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nlnn(Libint_t*, prim_data*);

  /* Computes quartets of (nl|nn) integrals */

REALTYPE *hrr_order_nlnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[10][18] = int_stack + 60720;
 Libint->vrr_classes[10][19] = int_stack + 73260;
 Libint->vrr_classes[10][20] = int_stack + 87120;
 Libint->vrr_classes[11][10] = int_stack + 102366;
 Libint->vrr_classes[11][11] = int_stack + 107514;
 Libint->vrr_classes[11][12] = int_stack + 113598;
 Libint->vrr_classes[11][13] = int_stack + 120696;
 Libint->vrr_classes[11][14] = int_stack + 128886;
 Libint->vrr_classes[11][15] = int_stack + 138246;
 Libint->vrr_classes[11][16] = int_stack + 148854;
 Libint->vrr_classes[11][17] = int_stack + 160788;
 Libint->vrr_classes[11][18] = int_stack + 174126;
 Libint->vrr_classes[11][19] = int_stack + 188946;
 Libint->vrr_classes[11][20] = int_stack + 205326;
 Libint->vrr_classes[12][10] = int_stack + 223344;
 Libint->vrr_classes[12][11] = int_stack + 229350;
 Libint->vrr_classes[12][12] = int_stack + 236448;
 Libint->vrr_classes[12][13] = int_stack + 244729;
 Libint->vrr_classes[12][14] = int_stack + 254284;
 Libint->vrr_classes[12][15] = int_stack + 265204;
 Libint->vrr_classes[12][16] = int_stack + 277580;
 Libint->vrr_classes[12][17] = int_stack + 291503;
 Libint->vrr_classes[12][18] = int_stack + 307064;
 Libint->vrr_classes[12][19] = int_stack + 324354;
 Libint->vrr_classes[12][20] = int_stack + 343464;
 Libint->vrr_classes[13][10] = int_stack + 364485;
 Libint->vrr_classes[13][11] = int_stack + 371415;
 Libint->vrr_classes[13][12] = int_stack + 379605;
 Libint->vrr_classes[13][13] = int_stack + 389160;
 Libint->vrr_classes[13][14] = int_stack + 400185;
 Libint->vrr_classes[13][15] = int_stack + 412785;
 Libint->vrr_classes[13][16] = int_stack + 427065;
 Libint->vrr_classes[13][17] = int_stack + 443130;
 Libint->vrr_classes[13][18] = int_stack + 461085;
 Libint->vrr_classes[13][19] = int_stack + 481035;
 Libint->vrr_classes[13][20] = int_stack + 503085;
 Libint->vrr_classes[14][10] = int_stack + 527340;
 Libint->vrr_classes[14][11] = int_stack + 535260;
 Libint->vrr_classes[14][12] = int_stack + 544620;
 Libint->vrr_classes[14][13] = int_stack + 555540;
 Libint->vrr_classes[14][14] = int_stack + 568140;
 Libint->vrr_classes[14][15] = int_stack + 582540;
 Libint->vrr_classes[14][16] = int_stack + 598860;
 Libint->vrr_classes[14][17] = int_stack + 617220;
 Libint->vrr_classes[14][18] = int_stack + 637740;
 Libint->vrr_classes[14][19] = int_stack + 660540;
 Libint->vrr_classes[14][20] = int_stack + 685740;
 Libint->vrr_classes[15][10] = int_stack + 713460;
 Libint->vrr_classes[15][11] = int_stack + 722436;
 Libint->vrr_classes[15][12] = int_stack + 733044;
 Libint->vrr_classes[15][13] = int_stack + 745420;
 Libint->vrr_classes[15][14] = int_stack + 759700;
 Libint->vrr_classes[15][15] = int_stack + 776020;
 Libint->vrr_classes[15][16] = int_stack + 794516;
 Libint->vrr_classes[15][17] = int_stack + 815324;
 Libint->vrr_classes[15][18] = int_stack + 838580;
 Libint->vrr_classes[15][19] = int_stack + 864420;
 Libint->vrr_classes[15][20] = int_stack + 892980;
 Libint->vrr_classes[16][10] = int_stack + 924396;
 Libint->vrr_classes[16][11] = int_stack + 934494;
 Libint->vrr_classes[16][12] = int_stack + 946428;
 Libint->vrr_classes[16][13] = int_stack + 960351;
 Libint->vrr_classes[16][14] = int_stack + 976416;
 Libint->vrr_classes[16][15] = int_stack + 994776;
 Libint->vrr_classes[16][16] = int_stack + 1015584;
 Libint->vrr_classes[16][17] = int_stack + 1038993;
 Libint->vrr_classes[16][18] = int_stack + 1065156;
 Libint->vrr_classes[16][19] = int_stack + 1094226;
 Libint->vrr_classes[16][20] = int_stack + 1126356;
 Libint->vrr_classes[17][10] = int_stack + 1161699;
 Libint->vrr_classes[17][11] = int_stack + 1172985;
 Libint->vrr_classes[17][12] = int_stack + 1186323;
 Libint->vrr_classes[17][13] = int_stack + 1201884;
 Libint->vrr_classes[17][14] = int_stack + 1219839;
 Libint->vrr_classes[17][15] = int_stack + 1240359;
 Libint->vrr_classes[17][16] = int_stack + 1263615;
 Libint->vrr_classes[17][17] = int_stack + 1289778;
 Libint->vrr_classes[17][18] = int_stack + 1319019;
 Libint->vrr_classes[17][19] = int_stack + 1351509;
 Libint->vrr_classes[17][20] = int_stack + 1387419;
 Libint->vrr_classes[18][10] = int_stack + 1426920;
 Libint->vrr_classes[18][11] = int_stack + 1439460;
 Libint->vrr_classes[18][12] = int_stack + 1454280;
 Libint->vrr_classes[18][13] = int_stack + 1471570;
 Libint->vrr_classes[18][14] = int_stack + 1491520;
 Libint->vrr_classes[18][15] = int_stack + 1514320;
 Libint->vrr_classes[18][16] = int_stack + 1540160;
 Libint->vrr_classes[18][17] = int_stack + 1569230;
 Libint->vrr_classes[18][18] = int_stack + 1601720;
 Libint->vrr_classes[18][19] = int_stack + 1637820;
 Libint->vrr_classes[18][20] = int_stack + 1677720;
 memset(int_stack,0,1721610*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1721610;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nlnn(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1721610,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1734678,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1750122,int_stack+1734678,int_stack+1721610,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1776258,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1794276,int_stack+1776258,int_stack+1734678,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1825164,int_stack+1794276,int_stack+1750122,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1721610,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1868724,int_stack+1721610,int_stack+1776258,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1742400,int_stack+1868724,int_stack+1794276,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1904760,int_stack+1742400,int_stack+1825164,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1793880,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1817640,int_stack+1793880,int_stack+1721610,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1970100,int_stack+1817640,int_stack+1868724,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2030160,int_stack+1970100,int_stack+1742400,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2107380,int_stack+2030160,int_stack+1904760,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1721610,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1859220,int_stack+1721610,int_stack+1793880,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2198856,int_stack+1859220,int_stack+1817640,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1748538,int_stack+2198856,int_stack+1970100,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1906740,int_stack+1748538,int_stack+2030160,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2268156,int_stack+1906740,int_stack+2107380,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2014848,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2045142,int_stack+2014848,int_stack+1721610,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2098998,int_stack+2045142,int_stack+1859220,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2390124,int_stack+2098998,int_stack+2198856,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2494074,int_stack+2390124,int_stack+1748538,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1721610,int_stack+2494074,int_stack+1906740,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2620200,int_stack+1721610,int_stack+2268156,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1865754,int_stack+60720,int_stack+49434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1899612,int_stack+1865754,int_stack+2014848,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2178198,int_stack+1899612,int_stack+2045142,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1960200,int_stack+2178198,int_stack+2098998,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2777016,int_stack+1960200,int_stack+2390124,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2267958,int_stack+2777016,int_stack+2494074,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2922546,int_stack+2267958,int_stack+1721610,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3107874,int_stack+2922546,int_stack+2620200,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1721610,int_stack+73260,int_stack+60720,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1759230,int_stack+1721610,int_stack+1865754,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2436126,int_stack+1759230,int_stack+1899612,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2537106,int_stack+2436126,int_stack+2178198,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2079000,int_stack+2537106,int_stack+1960200,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1826946,int_stack+2079000,int_stack+2777016,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2671746,int_stack+1826946,int_stack+2267958,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3303894,int_stack+2671746,int_stack+2922546,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+3535554,int_stack+3303894,int_stack+3107874,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+2020986,int_stack+87120,int_stack+73260,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+2245320,int_stack+2020986,int_stack+1721610,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+2320560,int_stack+2245320,int_stack+1759230,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2887962,int_stack+2320560,int_stack+2436126,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+2245320,int_stack+2887962,int_stack+2537106,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2887962,int_stack+2245320,int_stack+2079000,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+2020986,int_stack+2887962,int_stack+1826946,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2887962,int_stack+2020986,int_stack+2671746,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1721610,int_stack+2887962,int_stack+3303894,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2004750,int_stack+1721610,int_stack+3535554,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1721610,int_stack+107514,int_stack+102366,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1737054,int_stack+113598,int_stack+107514,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1755306,int_stack+1737054,int_stack+1721610,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1786194,int_stack+120696,int_stack+113598,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1807488,int_stack+1786194,int_stack+1737054,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1843992,int_stack+1807488,int_stack+1755306,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1721610,int_stack+128886,int_stack+120696,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1895472,int_stack+1721610,int_stack+1786194,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1746180,int_stack+1895472,int_stack+1807488,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2292246,int_stack+1746180,int_stack+1843992,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1807020,int_stack+138246,int_stack+128886,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1835100,int_stack+1807020,int_stack+1721610,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2369466,int_stack+1835100,int_stack+1895472,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1884240,int_stack+2369466,int_stack+1746180,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2440446,int_stack+1884240,int_stack+2292246,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2292246,int_stack+148854,int_stack+138246,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1721610,int_stack+2292246,int_stack+1807020,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2548554,int_stack+1721610,int_stack+1835100,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1777770,int_stack+2548554,int_stack+2369466,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2630454,int_stack+1777770,int_stack+1884240,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2758218,int_stack+2630454,int_stack+2440446,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1884240,int_stack+160788,int_stack+148854,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1920042,int_stack+1884240,int_stack+2292246,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2292246,int_stack+1920042,int_stack+1721610,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2385846,int_stack+2292246,int_stack+2548554,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2902362,int_stack+2385846,int_stack+1777770,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3051420,int_stack+2902362,int_stack+2630454,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2508696,int_stack+3051420,int_stack+2758218,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1721610,int_stack+174126,int_stack+160788,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1761624,int_stack+1721610,int_stack+1884240,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2694024,int_stack+1761624,int_stack+1920042,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1833228,int_stack+2694024,int_stack+2292246,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3221772,int_stack+1833228,int_stack+2385846,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2292246,int_stack+3221772,int_stack+2902362,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2800104,int_stack+2292246,int_stack+3051420,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3393762,int_stack+2800104,int_stack+2508696,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+2490990,int_stack+188946,int_stack+174126,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+2535450,int_stack+2490990,int_stack+1721610,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+3019128,int_stack+2535450,int_stack+1761624,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+3019128,int_stack+2694024,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3625422,int_stack+0,int_stack+1833228,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1721610,int_stack+3625422,int_stack+3221772,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3821982,int_stack+1721610,int_stack+2292246,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+4077510,int_stack+3821982,int_stack+2800104,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2615478,int_stack+4077510,int_stack+3393762,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+2292246,int_stack+205326,int_stack+188946,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+2341386,int_stack+2292246,int_stack+2490990,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+3138468,int_stack+2341386,int_stack+2535450,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2292246,int_stack+3138468,int_stack+3019128,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+2898618,int_stack+2292246,int_stack+0,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2292246,int_stack+2898618,int_stack+3625422,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+2898618,int_stack+2292246,int_stack+1721610,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2292246,int_stack+2898618,int_stack+3821982,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2898618,int_stack+2292246,int_stack+4077510,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+3233238,int_stack+2898618,int_stack+2615478,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+2292246,int_stack+3233238,int_stack+2004750,4356);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3154734,int_stack+229350,int_stack+223344,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3172752,int_stack+236448,int_stack+229350,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+3194046,int_stack+3172752,int_stack+3154734,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3573006,int_stack+244729,int_stack+236448,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3597849,int_stack+3573006,int_stack+3172752,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3640437,int_stack+3597849,int_stack+3194046,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+3154734,int_stack+254284,int_stack+244729,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3183399,int_stack+3154734,int_stack+3573006,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3700497,int_stack+3183399,int_stack+3597849,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3771477,int_stack+3700497,int_stack+3640437,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3573006,int_stack+265204,int_stack+254284,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3605766,int_stack+3573006,int_stack+3154734,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3861567,int_stack+3605766,int_stack+3183399,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3944377,int_stack+3861567,int_stack+3700497,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+4050847,int_stack+3944377,int_stack+3771477,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+3154734,int_stack+277580,int_stack+265204,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+3663096,int_stack+3154734,int_stack+3573006,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3728616,int_stack+3663096,int_stack+3605766,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+4176973,int_stack+3728616,int_stack+3861567,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1721610,int_stack+4176973,int_stack+3944377,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3824166,int_stack+1721610,int_stack+4050847,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3573006,int_stack+291503,int_stack+277580,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3992334,int_stack+3573006,int_stack+3154734,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+4066590,int_stack+3992334,int_stack+3663096,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1870668,int_stack+4066590,int_stack+3728616,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3614775,int_stack+1870668,int_stack+4176973,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2013993,int_stack+3614775,int_stack+1721610,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2013993,int_stack+3824166,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1721610,int_stack+307064,int_stack+291503,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1768293,int_stack+1721610,int_stack+3573006,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3788676,int_stack+1768293,int_stack+3992334,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+4175790,int_stack+3788676,int_stack+4066590,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3912436,int_stack+4175790,int_stack+1870668,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+4339590,int_stack+3912436,int_stack+3614775,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4571458,int_stack+4339590,int_stack+2013993,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1851831,int_stack+4571458,int_stack+0,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+324354,int_stack+307064,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+51870,int_stack+0,int_stack+1721610,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+145236,int_stack+51870,int_stack+1768293,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+3573006,int_stack+145236,int_stack+3788676,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+4826986,int_stack+3573006,int_stack+4175790,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+5056306,int_stack+4826986,int_stack+3912436,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3758646,int_stack+5056306,int_stack+4339590,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+4056762,int_stack+3758646,int_stack+4571458,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+4376172,int_stack+4056762,int_stack+1851831,91);
 /*--- compute (q0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1721610,int_stack+343464,int_stack+324354,91);
 /*--- compute (q0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1778940,int_stack+1721610,int_stack+0,91);
 /*--- compute (q0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1882680,int_stack+1778940,int_stack+51870,91);
 /*--- compute (q0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2038290,int_stack+1882680,int_stack+145236,91);
 /*--- compute (q0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+2038290,int_stack+3573006,91);
 /*--- compute (q0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1721610,int_stack+0,int_stack+4826986,91);
 /*--- compute (q0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+1721610,int_stack+5056306,91);
 /*--- compute (q0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1721610,int_stack+0,int_stack+3758646,91);
 /*--- compute (q0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+3573006,int_stack+1721610,int_stack+4056762,91);
 /*--- compute (q0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1721610,int_stack+3573006,int_stack+4376172,91);
 /*--- compute (op|nn) ---*/
 hrr1_build_op(Libint->AB,int_stack+3573006,int_stack+1721610,int_stack+3233238,4356);
 /*--- compute (nd|nn) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4592310,int_stack+3573006,int_stack+2292246,4356);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2118006,int_stack+371415,int_stack+364485,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2138796,int_stack+379605,int_stack+371415,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2163366,int_stack+2138796,int_stack+2118006,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2204946,int_stack+389160,int_stack+379605,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2233611,int_stack+2204946,int_stack+2138796,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2282751,int_stack+2233611,int_stack+2163366,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2118006,int_stack+400185,int_stack+389160,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2352051,int_stack+2118006,int_stack+2204946,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2151081,int_stack+2352051,int_stack+2233611,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2409381,int_stack+2151081,int_stack+2282751,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2232981,int_stack+412785,int_stack+400185,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2270781,int_stack+2232981,int_stack+2118006,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2513331,int_stack+2270781,int_stack+2352051,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2608881,int_stack+2513331,int_stack+2151081,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2731731,int_stack+2608881,int_stack+2409381,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2118006,int_stack+427065,int_stack+412785,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2336931,int_stack+2118006,int_stack+2232981,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2877261,int_stack+2336931,int_stack+2270781,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2160846,int_stack+2877261,int_stack+2513331,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2412531,int_stack+2160846,int_stack+2608881,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2987511,int_stack+2412531,int_stack+2731731,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2584521,int_stack+443130,int_stack+427065,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2632716,int_stack+2584521,int_stack+2118006,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2718396,int_stack+2632716,int_stack+2336931,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3181551,int_stack+2718396,int_stack+2877261,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3346926,int_stack+3181551,int_stack+2160846,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2118006,int_stack+3346926,int_stack+2412531,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2118006,int_stack+2987511,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2347326,int_stack+461085,int_stack+443130,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2401191,int_stack+2347326,int_stack+2584521,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2844396,int_stack+2401191,int_stack+2632716,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2497581,int_stack+2844396,int_stack+2718396,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+6317286,int_stack+2497581,int_stack+3181551,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2987196,int_stack+6317286,int_stack+3346926,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3254736,int_stack+2987196,int_stack+2118006,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+6548811,int_stack+3254736,int_stack+0,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+481035,int_stack+461085,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+59850,int_stack+0,int_stack+2347326,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+167580,int_stack+59850,int_stack+2401191,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2118006,int_stack+167580,int_stack+2844396,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2686581,int_stack+2118006,int_stack+2497581,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2332206,int_stack+2686581,int_stack+6317286,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+6860661,int_stack+2332206,int_stack+2987196,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+7204641,int_stack+6860661,int_stack+3254736,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2951181,int_stack+7204641,int_stack+6548811,105);
 /*--- compute (r0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+6317286,int_stack+503085,int_stack+481035,105);
 /*--- compute (r0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+6383436,int_stack+6317286,int_stack+0,105);
 /*--- compute (r0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+6503136,int_stack+6383436,int_stack+59850,105);
 /*--- compute (r0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+7573191,int_stack+6503136,int_stack+167580,105);
 /*--- compute (r0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+7573191,int_stack+2118006,105);
 /*--- compute (r0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+6317286,int_stack+0,int_stack+2686581,105);
 /*--- compute (r0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+6317286,int_stack+2332206,105);
 /*--- compute (r0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+6317286,int_stack+0,int_stack+6860661,105);
 /*--- compute (r0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+6317286,int_stack+7204641,105);
 /*--- compute (r0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+6317286,int_stack+0,int_stack+2951181,105);
 /*--- compute (qp|nn) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2118006,int_stack+6317286,int_stack+1721610,4356);
 /*--- compute (od|nn) ---*/
 hrr1_build_od(Libint->AB,int_stack+6774666,int_stack+2118006,int_stack+3573006,4356);
 /*--- compute (nf|nn) ---*/
 hrr1_build_nf(Libint->AB,int_stack+8813274,int_stack+6774666,int_stack+4592310,4356);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1721610,int_stack+535260,int_stack+527340,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1745370,int_stack+544620,int_stack+535260,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1773450,int_stack+1745370,int_stack+1721610,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1820970,int_stack+555540,int_stack+544620,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1853730,int_stack+1820970,int_stack+1745370,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1909890,int_stack+1853730,int_stack+1773450,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1721610,int_stack+568140,int_stack+555540,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1989090,int_stack+1721610,int_stack+1820970,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1759410,int_stack+1989090,int_stack+1853730,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+1759410,int_stack+1909890,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1853010,int_stack+582540,int_stack+568140,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1896210,int_stack+1853010,int_stack+1721610,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+118800,int_stack+1896210,int_stack+1989090,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1971810,int_stack+118800,int_stack+1759410,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+228000,int_stack+1971810,int_stack+0,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+598860,int_stack+582540,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1721610,int_stack+0,int_stack+1853010,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+394320,int_stack+1721610,int_stack+1896210,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1808010,int_stack+394320,int_stack+118800,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3307194,int_stack+1808010,int_stack+1971810,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3503754,int_stack+3307194,int_stack+228000,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1971810,int_stack+617220,int_stack+598860,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+48960,int_stack+1971810,int_stack+0,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+146880,int_stack+48960,int_stack+1721610,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3725514,int_stack+146880,int_stack+394320,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+290880,int_stack+3725514,int_stack+1808010,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3914514,int_stack+290880,int_stack+3307194,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4176594,int_stack+3914514,int_stack+3503754,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+3307194,int_stack+637740,int_stack+617220,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+3368754,int_stack+3307194,int_stack+1971810,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3478914,int_stack+3368754,int_stack+48960,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1721610,int_stack+3478914,int_stack+146880,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+1721610,int_stack+3725514,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+4461714,int_stack+0,int_stack+290880,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+264600,int_stack+4461714,int_stack+3914514,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3642114,int_stack+264600,int_stack+4176594,120);
 /*--- compute (t0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+3998514,int_stack+660540,int_stack+637740,120);
 /*--- compute (t0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+4066914,int_stack+3998514,int_stack+3307194,120);
 /*--- compute (t0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+4190034,int_stack+4066914,int_stack+3368754,120);
 /*--- compute (t0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+4767474,int_stack+4190034,int_stack+3478914,120);
 /*--- compute (t0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3307194,int_stack+4767474,int_stack+1721610,120);
 /*--- compute (t0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1721610,int_stack+3307194,int_stack+0,120);
 /*--- compute (t0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+5012274,int_stack+1721610,int_stack+4461714,120);
 /*--- compute (t0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+5405394,int_stack+5012274,int_stack+264600,120);
 /*--- compute (t0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+5405394,int_stack+3642114,120);
 /*--- compute (t0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+435600,int_stack+685740,int_stack+660540,120);
 /*--- compute (t0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+511200,int_stack+435600,int_stack+3998514,120);
 /*--- compute (t0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+3609594,int_stack+511200,int_stack+4066914,120);
 /*--- compute (t0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+435600,int_stack+3609594,int_stack+4190034,120);
 /*--- compute (t0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+3609594,int_stack+435600,int_stack+4767474,120);
 /*--- compute (t0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+3952314,int_stack+3609594,int_stack+3307194,120);
 /*--- compute (t0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+3307194,int_stack+3952314,int_stack+1721610,120);
 /*--- compute (t0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+3760794,int_stack+3307194,int_stack+5012274,120);
 /*--- compute (t0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+4252194,int_stack+3760794,int_stack+5405394,120);
 /*--- compute (t0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+3307194,int_stack+4252194,int_stack+0,120);
 /*--- compute (rp|nn) ---*/
 hrr1_build_rp(Libint->AB,int_stack+3829914,int_stack+3307194,int_stack+6317286,4356);
 /*--- compute (qd|nn) ---*/
 hrr1_build_qd(Libint->AB,int_stack+11688234,int_stack+3829914,int_stack+2118006,4356);
 /*--- compute (of|nn) ---*/
 hrr1_build_of(Libint->AB,int_stack+14066610,int_stack+11688234,int_stack+6774666,4356);
 /*--- compute (ng|nn) ---*/
 hrr1_build_ng(Libint->AB,int_stack+17464290,int_stack+14066610,int_stack+8813274,4356);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+722436,int_stack+713460,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+26928,int_stack+733044,int_stack+722436,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58752,int_stack+26928,int_stack+0,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+112608,int_stack+745420,int_stack+733044,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+149736,int_stack+112608,int_stack+26928,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+213384,int_stack+149736,int_stack+58752,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+759700,int_stack+745420,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+303144,int_stack+0,int_stack+112608,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+42840,int_stack+303144,int_stack+149736,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+377400,int_stack+42840,int_stack+213384,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+148920,int_stack+776020,int_stack+759700,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+197880,int_stack+148920,int_stack+0,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+512040,int_stack+197880,int_stack+303144,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+5202054,int_stack+512040,int_stack+42840,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+5361174,int_stack+5202054,int_stack+377400,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+794516,int_stack+776020,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+283560,int_stack+0,int_stack+148920,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+635800,int_stack+283560,int_stack+197880,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+55488,int_stack+635800,int_stack+512040,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+381480,int_stack+55488,int_stack+5202054,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+5549670,int_stack+381480,int_stack+5361174,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+5202054,int_stack+815324,int_stack+794516,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+5264478,int_stack+5202054,int_stack+0,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+5375454,int_stack+5264478,int_stack+283560,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+5800998,int_stack+5375454,int_stack+635800,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+6015198,int_stack+5800998,int_stack+55488,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+6015198,int_stack+381480,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+297024,int_stack+0,int_stack+5549670,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+620160,int_stack+838580,int_stack+815324,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+689928,int_stack+620160,int_stack+5202054,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+5538654,int_stack+689928,int_stack+5264478,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+6275094,int_stack+5538654,int_stack+5375454,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+5202054,int_stack+6275094,int_stack+5800998,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+6519894,int_stack+5202054,int_stack+6015198,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+5723614,int_stack+6519894,int_stack+0,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+6866422,int_stack+5723614,int_stack+297024,136);
 /*--- compute (u0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+864420,int_stack+838580,136);
 /*--- compute (u0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+77520,int_stack+0,int_stack+620160,136);
 /*--- compute (u0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+217056,int_stack+77520,int_stack+689928,136);
 /*--- compute (u0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+425136,int_stack+217056,int_stack+5538654,136);
 /*--- compute (u0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+7270342,int_stack+425136,int_stack+6275094,136);
 /*--- compute (u0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+6105502,int_stack+7270342,int_stack+5202054,136);
 /*--- compute (u0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+5202054,int_stack+6105502,int_stack+6519894,136);
 /*--- compute (u0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+7613062,int_stack+5202054,int_stack+5723614,136);
 /*--- compute (u0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+8090422,int_stack+7613062,int_stack+6866422,136);
 /*--- compute (u0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+5647590,int_stack+892980,int_stack+864420,136);
 /*--- compute (u0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+5733270,int_stack+5647590,int_stack+0,136);
 /*--- compute (u0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+6505342,int_stack+5733270,int_stack+77520,136);
 /*--- compute (u0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+5647590,int_stack+6505342,int_stack+217056,136);
 /*--- compute (u0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+6505342,int_stack+5647590,int_stack+425136,136);
 /*--- compute (u0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+5647590,int_stack+6505342,int_stack+7270342,136);
 /*--- compute (u0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+6505342,int_stack+5647590,int_stack+6105502,136);
 /*--- compute (u0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+5647590,int_stack+6505342,int_stack+5202054,136);
 /*--- compute (u0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+6204510,int_stack+5647590,int_stack+7613062,136);
 /*--- compute (u0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+5202054,int_stack+6204510,int_stack+8090422,136);
 /*--- compute (tp|nn) ---*/
 hrr1_build_tp(Libint->AB,int_stack+5794470,int_stack+5202054,int_stack+3307194,4356);
 /*--- compute (rd|nn) ---*/
 hrr1_build_rd(Libint->AB,int_stack+7362630,int_stack+5794470,int_stack+3829914,4356);
 /*--- compute (qf|nn) ---*/
 hrr1_build_qf(Libint->AB,int_stack+21776730,int_stack+7362630,int_stack+11688234,4356);
 /*--- compute (og|nn) ---*/
 hrr1_build_og(Libint->AB,int_stack+25740690,int_stack+21776730,int_stack+14066610,4356);
 /*--- compute (nh|nn) ---*/
 hrr1_build_nh(Libint->AB,int_stack+10106910,int_stack+25740690,int_stack+17464290,4356);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+16144326,int_stack+934494,int_stack+924396,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+16174620,int_stack+946428,int_stack+934494,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+16210422,int_stack+16174620,int_stack+16144326,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+16271010,int_stack+960351,int_stack+946428,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+16312779,int_stack+16271010,int_stack+16174620,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+16384383,int_stack+16312779,int_stack+16210422,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+16144326,int_stack+976416,int_stack+960351,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+16485363,int_stack+16144326,int_stack+16271010,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+16192521,int_stack+16485363,int_stack+16312779,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+16568901,int_stack+16192521,int_stack+16384383,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+16311861,int_stack+994776,int_stack+976416,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+16366941,int_stack+16311861,int_stack+16144326,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+16720371,int_stack+16366941,int_stack+16485363,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+16859601,int_stack+16720371,int_stack+16192521,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+17038611,int_stack+16859601,int_stack+16568901,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+16144326,int_stack+1015584,int_stack+994776,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+16463331,int_stack+16144326,int_stack+16311861,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+17250669,int_stack+16463331,int_stack+16366941,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+16206750,int_stack+17250669,int_stack+16720371,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+16573491,int_stack+16206750,int_stack+16859601,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+17411319,int_stack+16573491,int_stack+17038611,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+16824105,int_stack+1038993,int_stack+1015584,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+16894332,int_stack+16824105,int_stack+16144326,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+17019180,int_stack+16894332,int_stack+16463331,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+17694063,int_stack+17019180,int_stack+17250669,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+17935038,int_stack+17694063,int_stack+16206750,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+16144326,int_stack+17935038,int_stack+16573491,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+18227421,int_stack+16144326,int_stack+17411319,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+16478478,int_stack+1065156,int_stack+1038993,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+16556967,int_stack+16478478,int_stack+16824105,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+17202780,int_stack+16556967,int_stack+16894332,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+16697421,int_stack+17202780,int_stack+17019180,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+18590949,int_stack+16697421,int_stack+17694063,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+17410860,int_stack+18590949,int_stack+17935038,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+18928314,int_stack+17410860,int_stack+16144326,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+19357938,int_stack+18928314,int_stack+18227421,153);
 /*--- compute (v0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+16144326,int_stack+1094226,int_stack+1065156,153);
 /*--- compute (v0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+16231536,int_stack+16144326,int_stack+16478478,153);
 /*--- compute (v0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+17800704,int_stack+16231536,int_stack+16556967,153);
 /*--- compute (v0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+18034794,int_stack+17800704,int_stack+17202780,153);
 /*--- compute (v0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+16972821,int_stack+18034794,int_stack+16697421,153);
 /*--- compute (v0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+16388514,int_stack+16972821,int_stack+18590949,153);
 /*--- compute (v0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+18346914,int_stack+16388514,int_stack+17410860,153);
 /*--- compute (v0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+19812348,int_stack+18346914,int_stack+18928314,153);
 /*--- compute (v0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+20349378,int_stack+19812348,int_stack+19357938,153);
 /*--- compute (v0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+16838334,int_stack+1126356,int_stack+1094226,153);
 /*--- compute (v0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+17358381,int_stack+16838334,int_stack+16144326,153);
 /*--- compute (v0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+17532801,int_stack+17358381,int_stack+16231536,153);
 /*--- compute (v0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+18848142,int_stack+17532801,int_stack+17800704,153);
 /*--- compute (v0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+17358381,int_stack+18848142,int_stack+18034794,153);
 /*--- compute (v0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+18848142,int_stack+17358381,int_stack+16972821,153);
 /*--- compute (v0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+16838334,int_stack+18848142,int_stack+16388514,153);
 /*--- compute (v0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+18848142,int_stack+16838334,int_stack+18346914,153);
 /*--- compute (v0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+16144326,int_stack+18848142,int_stack+19812348,153);
 /*--- compute (v0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+16800696,int_stack+16144326,int_stack+20349378,153);
 /*--- compute (up|nn) ---*/
 hrr1_build_up(Libint->AB,int_stack+17467164,int_stack+16800696,int_stack+5202054,4356);
 /*--- compute (td|nn) ---*/
 hrr1_build_td(Libint->AB,int_stack+1721610,int_stack+17467164,int_stack+5794470,4356);
 /*--- compute (rf|nn) ---*/
 hrr1_build_rf(Libint->AB,int_stack+30837210,int_stack+1721610,int_stack+7362630,4356);
 /*--- compute (qg|nn) ---*/
 hrr1_build_qg(Libint->AB,int_stack+35411010,int_stack+30837210,int_stack+21776730,4356);
 /*--- compute (oh|nn) ---*/
 hrr1_build_oh(Libint->AB,int_stack+41356950,int_stack+35411010,int_stack+25740690,4356);
 /*--- compute (ni|nn) ---*/
 hrr1_build_ni(Libint->AB,int_stack+19244412,int_stack+41356950,int_stack+10106910,4356);
 /*--- compute (w0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+27294300,int_stack+1172985,int_stack+1161699,171);
 /*--- compute (w0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+27328158,int_stack+1186323,int_stack+1172985,171);
 /*--- compute (w0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+27368172,int_stack+27328158,int_stack+27294300,171);
 /*--- compute (w0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+27435888,int_stack+1201884,int_stack+1186323,171);
 /*--- compute (w0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+27482571,int_stack+27435888,int_stack+27328158,171);
 /*--- compute (w0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+27562599,int_stack+27482571,int_stack+27368172,171);
 /*--- compute (w0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+27294300,int_stack+1219839,int_stack+1201884,171);
 /*--- compute (w0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+27675459,int_stack+27294300,int_stack+27435888,171);
 /*--- compute (w0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+27348165,int_stack+27675459,int_stack+27482571,171);
 /*--- compute (w0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+27768825,int_stack+27348165,int_stack+27562599,171);
 /*--- compute (w0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+27481545,int_stack+1240359,int_stack+1219839,171);
 /*--- compute (w0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+27543105,int_stack+27481545,int_stack+27294300,171);
 /*--- compute (w0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+27938115,int_stack+27543105,int_stack+27675459,171);
 /*--- compute (w0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+28093725,int_stack+27938115,int_stack+27348165,171);
 /*--- compute (w0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+28293795,int_stack+28093725,int_stack+27768825,171);
 /*--- compute (w0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+27294300,int_stack+1263615,int_stack+1240359,171);
 /*--- compute (w0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+27650835,int_stack+27294300,int_stack+27481545,171);
 /*--- compute (w0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+28530801,int_stack+27650835,int_stack+27543105,171);
 /*--- compute (w0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+27364068,int_stack+28530801,int_stack+27938115,171);
 /*--- compute (w0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+27773955,int_stack+27364068,int_stack+28093725,171);
 /*--- compute (w0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+28710351,int_stack+27773955,int_stack+28293795,171);
 /*--- compute (w0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+28054053,int_stack+1289778,int_stack+1263615,171);
 /*--- compute (w0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+28132542,int_stack+28054053,int_stack+27294300,171);
 /*--- compute (w0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+28272078,int_stack+28132542,int_stack+27650835,171);
 /*--- compute (w0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+29026359,int_stack+28272078,int_stack+28530801,171);
 /*--- compute (w0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+29295684,int_stack+29026359,int_stack+27364068,171);
 /*--- compute (w0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+27294300,int_stack+29295684,int_stack+27773955,171);
 /*--- compute (w0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+29622465,int_stack+27294300,int_stack+28710351,171);
 /*--- compute (w0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+27667764,int_stack+1319019,int_stack+1289778,171);
 /*--- compute (w0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+27755487,int_stack+27667764,int_stack+28054053,171);
 /*--- compute (w0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+28477278,int_stack+27755487,int_stack+28132542,171);
 /*--- compute (w0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+27912465,int_stack+28477278,int_stack+28272078,171);
 /*--- compute (w0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+30028761,int_stack+27912465,int_stack+29026359,171);
 /*--- compute (w0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+28709838,int_stack+30028761,int_stack+29295684,171);
 /*--- compute (w0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+28709838,int_stack+27294300,171);
 /*--- compute (w0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+480168,int_stack+0,int_stack+29622465,171);
 /*--- compute (w0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+27294300,int_stack+1351509,int_stack+1319019,171);
 /*--- compute (w0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+27391770,int_stack+27294300,int_stack+27667764,171);
 /*--- compute (w0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+29145546,int_stack+27391770,int_stack+27755487,171);
 /*--- compute (w0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+29407176,int_stack+29145546,int_stack+28477278,171);
 /*--- compute (w0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+28220265,int_stack+29407176,int_stack+27912465,171);
 /*--- compute (w0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+27567216,int_stack+28220265,int_stack+30028761,171);
 /*--- compute (w0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+29756016,int_stack+27567216,int_stack+28709838,171);
 /*--- compute (w0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+4857930,int_stack+29756016,int_stack+0,171);
 /*--- compute (w0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+5458140,int_stack+4857930,int_stack+480168,171);
 /*--- compute (w0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+1387419,int_stack+1351509,171);
 /*--- compute (w0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+107730,int_stack+0,int_stack+27294300,171);
 /*--- compute (w0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+302670,int_stack+107730,int_stack+27391770,171);
 /*--- compute (w0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+595080,int_stack+302670,int_stack+29145546,171);
 /*--- compute (w0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+595080,int_stack+29407176,171);
 /*--- compute (w0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+488376,int_stack+0,int_stack+28220265,171);
 /*--- compute (w0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+28069956,int_stack+488376,int_stack+27567216,171);
 /*--- compute (w0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+0,int_stack+28069956,int_stack+29756016,171);
 /*--- compute (w0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+27294300,int_stack+0,int_stack+4857930,171);
 /*--- compute (w0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+0,int_stack+27294300,int_stack+5458140,171);
 /*--- compute (vp|nn) ---*/
 hrr1_build_vp(Libint->AB,int_stack+27294300,int_stack+0,int_stack+16800696,4356);
 /*--- compute (ud|nn) ---*/
 hrr1_build_ud(Libint->AB,int_stack+4857930,int_stack+27294300,int_stack+17467164,4356);
 /*--- compute (tf|nn) ---*/
 hrr1_build_tf(Libint->AB,int_stack+8412426,int_stack+4857930,int_stack+1721610,4356);
 /*--- compute (rg|nn) ---*/
 hrr1_build_rg(Libint->AB,int_stack+48492078,int_stack+8412426,int_stack+30837210,4356);
 /*--- compute (qh|nn) ---*/
 hrr1_build_qh(Libint->AB,int_stack+55352778,int_stack+48492078,int_stack+35411010,4356);
 /*--- compute (oi|nn) ---*/
 hrr1_build_oi(Libint->AB,int_stack+29293704,int_stack+55352778,int_stack+41356950,4356);
 /*--- compute (nk|nn) ---*/
 hrr1_build_nk(Libint->AB,int_stack+63677094,int_stack+29293704,int_stack+19244412,4356);
 /*--- compute (x0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1721610,int_stack+1439460,int_stack+1426920,190);
 /*--- compute (x0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1759230,int_stack+1454280,int_stack+1439460,190);
 /*--- compute (x0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1803690,int_stack+1759230,int_stack+1721610,190);
 /*--- compute (x0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1878930,int_stack+1471570,int_stack+1454280,190);
 /*--- compute (x0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1930800,int_stack+1878930,int_stack+1759230,190);
 /*--- compute (x0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2019720,int_stack+1930800,int_stack+1803690,190);
 /*--- compute (x0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1721610,int_stack+1491520,int_stack+1471570,190);
 /*--- compute (x0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2145120,int_stack+1721610,int_stack+1878930,190);
 /*--- compute (x0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1781460,int_stack+2145120,int_stack+1930800,190);
 /*--- compute (x0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2248860,int_stack+1781460,int_stack+2019720,190);
 /*--- compute (x0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1929660,int_stack+1514320,int_stack+1491520,190);
 /*--- compute (x0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1998060,int_stack+1929660,int_stack+1721610,190);
 /*--- compute (x0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2436960,int_stack+1998060,int_stack+2145120,190);
 /*--- compute (x0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2609860,int_stack+2436960,int_stack+1781460,190);
 /*--- compute (x0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2832160,int_stack+2609860,int_stack+2248860,190);
 /*--- compute (x0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1721610,int_stack+1540160,int_stack+1514320,190);
 /*--- compute (x0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2117760,int_stack+1721610,int_stack+1929660,190);
 /*--- compute (x0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3095500,int_stack+2117760,int_stack+1998060,190);
 /*--- compute (x0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1799130,int_stack+3095500,int_stack+2436960,190);
 /*--- compute (x0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2254560,int_stack+1799130,int_stack+2609860,190);
 /*--- compute (x0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3295000,int_stack+2254560,int_stack+2832160,190);
 /*--- compute (x0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2565780,int_stack+1569230,int_stack+1540160,190);
 /*--- compute (x0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2652990,int_stack+2565780,int_stack+1721610,190);
 /*--- compute (x0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2808030,int_stack+2652990,int_stack+2117760,190);
 /*--- compute (x0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3646120,int_stack+2808030,int_stack+3095500,190);
 /*--- compute (x0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3945370,int_stack+3646120,int_stack+1799130,190);
 /*--- compute (x0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1721610,int_stack+3945370,int_stack+2254560,190);
 /*--- compute (x0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4308460,int_stack+1721610,int_stack+3295000,190);
 /*--- compute (x0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2136570,int_stack+1601720,int_stack+1569230,190);
 /*--- compute (x0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2234040,int_stack+2136570,int_stack+2565780,190);
 /*--- compute (x0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3036030,int_stack+2234040,int_stack+2652990,190);
 /*--- compute (x0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2408460,int_stack+3036030,int_stack+2808030,190);
 /*--- compute (x0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+38807208,int_stack+2408460,int_stack+3646120,190);
 /*--- compute (x0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3294430,int_stack+38807208,int_stack+3945370,190);
 /*--- compute (x0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+39226158,int_stack+3294430,int_stack+1721610,190);
 /*--- compute (x0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+39759678,int_stack+39226158,int_stack+4308460,190);
 /*--- compute (x0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1721610,int_stack+1637820,int_stack+1601720,190);
 /*--- compute (x0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1829910,int_stack+1721610,int_stack+2136570,190);
 /*--- compute (x0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+3778550,int_stack+1829910,int_stack+2234040,190);
 /*--- compute (x0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+4069250,int_stack+3778550,int_stack+3036030,190);
 /*--- compute (x0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2750460,int_stack+4069250,int_stack+2408460,190);
 /*--- compute (x0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2024850,int_stack+2750460,int_stack+38807208,190);
 /*--- compute (x0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+40323978,int_stack+2024850,int_stack+3294430,190);
 /*--- compute (x0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+40946418,int_stack+40323978,int_stack+39226158,190);
 /*--- compute (x0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+38807208,int_stack+40946418,int_stack+39759678,190);
 /*--- compute (x0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+39496908,int_stack+1677720,int_stack+1637820,190);
 /*--- compute (x0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+39616608,int_stack+39496908,int_stack+1721610,190);
 /*--- compute (x0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+39833208,int_stack+39616608,int_stack+1829910,190);
 /*--- compute (x0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+3229260,int_stack+39833208,int_stack+3778550,190);
 /*--- compute (x0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+39496908,int_stack+3229260,int_stack+4069250,190);
 /*--- compute (x0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+3229260,int_stack+39496908,int_stack+2750460,190);
 /*--- compute (x0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+39496908,int_stack+3229260,int_stack+2024850,190);
 /*--- compute (x0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+41613318,int_stack+39496908,int_stack+40323978,190);
 /*--- compute (x0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+39496908,int_stack+41613318,int_stack+40946418,190);
 /*--- compute (x0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+40312008,int_stack+39496908,int_stack+38807208,190);
 /*--- compute (wp|nn) ---*/
 hrr1_build_wp(Libint->AB,int_stack+41139648,int_stack+40312008,int_stack+0,4356);
 /*--- compute (vd|nn) ---*/
 hrr1_build_vd(Libint->AB,int_stack+0,int_stack+41139648,int_stack+27294300,4356);
 /*--- compute (uf|nn) ---*/
 hrr1_build_uf(Libint->AB,int_stack+38807208,int_stack+0,int_stack+4857930,4356);
 /*--- compute (tg|nn) ---*/
 hrr1_build_tg(Libint->AB,int_stack+0,int_stack+38807208,int_stack+8412426,4356);
 /*--- compute (rh|nn) ---*/
 hrr1_build_rh(Libint->AB,int_stack+38807208,int_stack+0,int_stack+48492078,4356);
 /*--- compute (qi|nn) ---*/
 hrr1_build_qi(Libint->AB,int_stack+0,int_stack+38807208,int_stack+55352778,4356);
 /*--- compute (ok|nn) ---*/
 hrr1_build_ok(Libint->AB,int_stack+38807208,int_stack+0,int_stack+29293704,4356);
 /*--- compute (nl|nn) ---*/
 hrr1_build_nl(Libint->AB,int_stack+0,int_stack+38807208,int_stack+63677094,4356);
 return int_stack+0;}
