/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_npmh(Libint_t*, prim_data*);

  /* Computes quartets of (np|mh) integrals */

REALTYPE *hrr_order_npmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[11][9] = int_stack + 33990;
 Libint->vrr_classes[11][10] = int_stack + 38280;
 Libint->vrr_classes[11][11] = int_stack + 43428;
 Libint->vrr_classes[11][12] = int_stack + 49512;
 Libint->vrr_classes[11][13] = int_stack + 56610;
 Libint->vrr_classes[11][14] = int_stack + 64800;
 memset(int_stack,0,74160*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 74160;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_npmh(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+74160,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85050,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+98118,int_stack+85050,int_stack+74160,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+119898,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+135342,int_stack+119898,int_stack+85050,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+161478,int_stack+135342,int_stack+98118,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+74160,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+197778,int_stack+74160,int_stack+119898,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+228666,int_stack+197778,int_stack+135342,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+92178,int_stack+228666,int_stack+161478,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+146628,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+272226,int_stack+146628,int_stack+74160,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+308262,int_stack+272226,int_stack+197778,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+146628,int_stack+308262,int_stack+228666,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+211968,int_stack+146628,int_stack+92178,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+74160,int_stack+38280,int_stack+33990,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+87030,int_stack+43428,int_stack+38280,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+102474,int_stack+87030,int_stack+74160,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+128214,int_stack+49512,int_stack+43428,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+146466,int_stack+128214,int_stack+87030,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+288198,int_stack+146466,int_stack+102474,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+74160,int_stack+56610,int_stack+49512,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+74160,int_stack+128214,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+331098,int_stack+0,int_stack+146466,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+95454,int_stack+331098,int_stack+288198,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+288198,int_stack+64800,int_stack+56610,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+159804,int_stack+288198,int_stack+74160,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+382578,int_stack+159804,int_stack+0,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+382578,int_stack+331098,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+288198,int_stack+0,int_stack+95454,78);
 /*--- compute (np|mh) ---*/
 hrr1_build_np(Libint->AB,int_stack+378288,int_stack+288198,int_stack+211968,1155);
 return int_stack+378288;}
