/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_p0ml(Libint_t*, prim_data*);

  /* Computes quartets of (p0|ml) integrals */

REALTYPE *hrr_order_p0ml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][9] = int_stack + 0;
 Libint->vrr_classes[1][10] = int_stack + 165;
 Libint->vrr_classes[1][11] = int_stack + 363;
 Libint->vrr_classes[1][12] = int_stack + 597;
 Libint->vrr_classes[1][13] = int_stack + 870;
 Libint->vrr_classes[1][14] = int_stack + 1185;
 Libint->vrr_classes[1][15] = int_stack + 1545;
 Libint->vrr_classes[1][16] = int_stack + 1953;
 Libint->vrr_classes[1][17] = int_stack + 2412;
 memset(int_stack,0,2925*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 2925;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_p0ml(Libint, Data);
   Data++;
 }
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2925,int_stack+165,int_stack+0,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3420,int_stack+363,int_stack+165,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+4014,int_stack+3420,int_stack+2925,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5004,int_stack+597,int_stack+363,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+5706,int_stack+5004,int_stack+3420,3);
 /*--- compute (p0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+6894,int_stack+5706,int_stack+4014,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2925,int_stack+870,int_stack+597,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+8544,int_stack+2925,int_stack+5004,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+9948,int_stack+8544,int_stack+5706,3);
 /*--- compute (p0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+3744,int_stack+9948,int_stack+6894,3);
 /*--- compute (p0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+6219,int_stack+1185,int_stack+870,3);
 /*--- compute (p0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+11928,int_stack+6219,int_stack+2925,3);
 /*--- compute (p0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+13566,int_stack+11928,int_stack+8544,3);
 /*--- compute (p0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+15906,int_stack+13566,int_stack+9948,3);
 /*--- compute (p0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+7164,int_stack+15906,int_stack+3744,3);
 /*--- compute (p0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2925,int_stack+1545,int_stack+1185,3);
 /*--- compute (p0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+4005,int_stack+2925,int_stack+6219,3);
 /*--- compute (p0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+18876,int_stack+4005,int_stack+11928,3);
 /*--- compute (p0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+21606,int_stack+18876,int_stack+13566,3);
 /*--- compute (p0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+10629,int_stack+21606,int_stack+15906,3);
 /*--- compute (p0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+25116,int_stack+10629,int_stack+7164,3);
 /*--- compute (p0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+5895,int_stack+1953,int_stack+1545,3);
 /*--- compute (p0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+7119,int_stack+5895,int_stack+2925,3);
 /*--- compute (p0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+14787,int_stack+7119,int_stack+4005,3);
 /*--- compute (p0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+29736,int_stack+14787,int_stack+18876,3);
 /*--- compute (p0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+33831,int_stack+29736,int_stack+21606,3);
 /*--- compute (p0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+17937,int_stack+33831,int_stack+10629,3);
 /*--- compute (p0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+38745,int_stack+17937,int_stack+25116,3);
 /*--- compute (p0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2925,int_stack+2412,int_stack+1953,3);
 /*--- compute (p0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+9279,int_stack+2925,int_stack+5895,3);
 /*--- compute (p0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+23481,int_stack+9279,int_stack+7119,3);
 /*--- compute (p0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+23481,int_stack+14787,3);
 /*--- compute (p0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+23481,int_stack+0,int_stack+29736,3);
 /*--- compute (p0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+23481,int_stack+33831,3);
 /*--- compute (p0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+23481,int_stack+0,int_stack+17937,3);
 /*--- compute (p0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+23481,int_stack+38745,3);
 return int_stack+0;}
