/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ppnf(Libint_t*, prim_data*);

  /* Computes quartets of (pp|nf) integrals */

REALTYPE *hrr_order_ppnf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][10] = int_stack + 0;
 Libint->vrr_classes[1][11] = int_stack + 198;
 Libint->vrr_classes[1][12] = int_stack + 432;
 Libint->vrr_classes[1][13] = int_stack + 705;
 Libint->vrr_classes[2][10] = int_stack + 1020;
 Libint->vrr_classes[2][11] = int_stack + 1416;
 Libint->vrr_classes[2][12] = int_stack + 1884;
 Libint->vrr_classes[2][13] = int_stack + 2430;
 memset(int_stack,0,3060*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 3060;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ppnf(Libint, Data);
   Data++;
 }
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3060,int_stack+198,int_stack+0,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3654,int_stack+432,int_stack+198,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+4356,int_stack+3654,int_stack+3060,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+5544,int_stack+705,int_stack+432,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+6363,int_stack+5544,int_stack+3654,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+7767,int_stack+6363,int_stack+4356,3);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3060,int_stack+1416,int_stack+1020,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+4248,int_stack+1884,int_stack+1416,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+9747,int_stack+4248,int_stack+3060,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+5652,int_stack+2430,int_stack+1884,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+5652,int_stack+4248,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2808,int_stack+0,int_stack+9747,6);
 /*--- compute (pp|nf) ---*/
 hrr1_build_pp(Libint->AB,int_stack+9747,int_stack+2808,int_stack+7767,660);
 return int_stack+9747;}
