/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (fd|nd) integrals */

void vrr_order_fdnd(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+7, Data->F+8, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+34, vrr_stack+15, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+50, vrr_stack+6, vrr_stack+3, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+56, vrr_stack+9, vrr_stack+50, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+66, vrr_stack+21, vrr_stack+56, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+81, vrr_stack+66, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+50, vrr_stack+15, vrr_stack+6, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+127, vrr_stack+56, vrr_stack+117, vrr_stack+9, vrr_stack+50, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+66, vrr_stack+127, vrr_stack+21, vrr_stack+56, NULL);
 _BUILD_00i0(Data,vrr_stack+163, vrr_stack+96, vrr_stack+142, vrr_stack+81, vrr_stack+66, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+21, vrr_stack+31, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+191, vrr_stack+24, vrr_stack+34, vrr_stack+21, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+201, vrr_stack+191, vrr_stack+40, vrr_stack+24, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+216, vrr_stack+201, vrr_stack+81, vrr_stack+191, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+237, vrr_stack+216, vrr_stack+96, vrr_stack+201, vrr_stack+81, NULL);
 _BUILD_p0i0(Data,vrr_stack+265, vrr_stack+237, vrr_stack+163, NULL, NULL, vrr_stack+96);
 _BUILD_00k0(Data,vrr_stack+349, vrr_stack+237, vrr_stack+163, vrr_stack+216, vrr_stack+96, NULL);
 _BUILD_00p0(Data,vrr_stack+81, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+84, vrr_stack+81, vrr_stack+21, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+84, vrr_stack+24, vrr_stack+81, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+385, vrr_stack+30, vrr_stack+191, vrr_stack+84, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+400, vrr_stack+385, vrr_stack+201, vrr_stack+30, vrr_stack+191, NULL);
 _BUILD_00i0(Data,vrr_stack+421, vrr_stack+400, vrr_stack+216, vrr_stack+385, vrr_stack+201, NULL);
 _BUILD_00k0(Data,vrr_stack+449, vrr_stack+421, vrr_stack+237, vrr_stack+400, vrr_stack+216, NULL);
 _BUILD_00p0(Data,vrr_stack+191, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+90, vrr_stack+0, vrr_stack+191, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+90, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+194, vrr_stack+117, vrr_stack+40, vrr_stack+50, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+209, vrr_stack+127, vrr_stack+194, vrr_stack+56, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+485, vrr_stack+142, vrr_stack+209, vrr_stack+66, vrr_stack+127, NULL);
 _BUILD_00k0(Data,vrr_stack+513, vrr_stack+163, vrr_stack+485, vrr_stack+96, vrr_stack+142, NULL);
 _BUILD_p0k0(Data,vrr_stack+549, vrr_stack+349, vrr_stack+513, NULL, NULL, vrr_stack+163);
 _BUILD_p0k0(Data,vrr_stack+657, vrr_stack+449, vrr_stack+349, NULL, NULL, vrr_stack+237);
 _BUILD_d0k0(Data,vrr_stack+765, vrr_stack+657, vrr_stack+549, vrr_stack+449, vrr_stack+349, vrr_stack+265);
 _BUILD_00l0(Data,vrr_stack+265, vrr_stack+349, vrr_stack+513, vrr_stack+237, vrr_stack+163, NULL);
 _BUILD_00l0(Data,vrr_stack+981, vrr_stack+449, vrr_stack+349, vrr_stack+421, vrr_stack+237, NULL);
 _BUILD_p0l0(Data,vrr_stack+1026, vrr_stack+981, vrr_stack+265, NULL, NULL, vrr_stack+349);
 _BUILD_00p0(Data,vrr_stack+310, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+313, vrr_stack+310, vrr_stack+81, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+319, vrr_stack+313, vrr_stack+84, vrr_stack+310, vrr_stack+81, NULL);
 _BUILD_00g0(Data,vrr_stack+329, vrr_stack+319, vrr_stack+30, vrr_stack+313, vrr_stack+84, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+329, vrr_stack+385, vrr_stack+319, vrr_stack+30, NULL);
 _BUILD_00i0(Data,vrr_stack+50, vrr_stack+96, vrr_stack+400, vrr_stack+329, vrr_stack+385, NULL);
 _BUILD_00k0(Data,vrr_stack+1161, vrr_stack+50, vrr_stack+421, vrr_stack+96, vrr_stack+400, NULL);
 _BUILD_00l0(Data,vrr_stack+1197, vrr_stack+1161, vrr_stack+449, vrr_stack+50, vrr_stack+421, NULL);
 _BUILD_p0l0(Data,vrr_stack+1242, vrr_stack+1197, vrr_stack+981, NULL, NULL, vrr_stack+449);
 _BUILD_00p0(Data,vrr_stack+385, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+388, vrr_stack+191, vrr_stack+385, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+394, vrr_stack+90, vrr_stack+388, vrr_stack+0, vrr_stack+191, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+40, vrr_stack+394, vrr_stack+15, vrr_stack+90, NULL);
 _BUILD_00h0(Data,vrr_stack+15, vrr_stack+194, vrr_stack+0, vrr_stack+117, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+404, vrr_stack+209, vrr_stack+15, vrr_stack+127, vrr_stack+194, NULL);
 _BUILD_00k0(Data,vrr_stack+1377, vrr_stack+485, vrr_stack+404, vrr_stack+142, vrr_stack+209, NULL);
 _BUILD_00l0(Data,vrr_stack+117, vrr_stack+513, vrr_stack+1377, vrr_stack+163, vrr_stack+485, NULL);
 _BUILD_p0l0(Data,vrr_stack+1413, vrr_stack+265, vrr_stack+117, NULL, NULL, vrr_stack+513);
 _BUILD_d0l0(Data,vrr_stack+1548, vrr_stack+1026, vrr_stack+1413, vrr_stack+981, vrr_stack+265, vrr_stack+549);
 _BUILD_d0l0(Data,vrr_stack+1818, vrr_stack+1242, vrr_stack+1026, vrr_stack+1197, vrr_stack+981, vrr_stack+657);
 _BUILD_f0l0(Data,vrr_stack+2088, vrr_stack+1818, vrr_stack+1548, vrr_stack+1242, vrr_stack+1026, vrr_stack+765);
 _BUILD_00m0(Data,vrr_stack+549, vrr_stack+981, vrr_stack+265, vrr_stack+449, vrr_stack+349, NULL);
 _BUILD_00m0(Data,vrr_stack+604, vrr_stack+1197, vrr_stack+981, vrr_stack+1161, vrr_stack+449, NULL);
 _BUILD_00m0(Data,vrr_stack+659, vrr_stack+265, vrr_stack+117, vrr_stack+349, vrr_stack+513, NULL);
 _BUILD_p0m0(Data,vrr_stack+714, vrr_stack+549, vrr_stack+659, NULL, NULL, vrr_stack+265);
 _BUILD_p0m0(Data,vrr_stack+2538, vrr_stack+604, vrr_stack+549, NULL, NULL, vrr_stack+981);
 _BUILD_d0m0(Data,vrr_stack+2703, vrr_stack+2538, vrr_stack+714, vrr_stack+604, vrr_stack+549, vrr_stack+1026);
 _BUILD_00p0(Data,vrr_stack+1026, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1029, vrr_stack+1026, vrr_stack+310, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+1035, vrr_stack+1029, vrr_stack+313, vrr_stack+1026, vrr_stack+310, NULL);
 _BUILD_00g0(Data,vrr_stack+1045, vrr_stack+1035, vrr_stack+319, vrr_stack+1029, vrr_stack+313, NULL);
 _BUILD_00h0(Data,vrr_stack+1060, vrr_stack+1045, vrr_stack+329, vrr_stack+1035, vrr_stack+319, NULL);
 _BUILD_00i0(Data,vrr_stack+1081, vrr_stack+1060, vrr_stack+96, vrr_stack+1045, vrr_stack+329, NULL);
 _BUILD_00k0(Data,vrr_stack+310, vrr_stack+1081, vrr_stack+50, vrr_stack+1060, vrr_stack+96, NULL);
 _BUILD_00l0(Data,vrr_stack+1109, vrr_stack+310, vrr_stack+1161, vrr_stack+1081, vrr_stack+50, NULL);
 _BUILD_00m0(Data,vrr_stack+879, vrr_stack+1109, vrr_stack+1197, vrr_stack+310, vrr_stack+1161, NULL);
 _BUILD_p0m0(Data,vrr_stack+3033, vrr_stack+879, vrr_stack+604, NULL, NULL, vrr_stack+1197);
 _BUILD_d0m0(Data,vrr_stack+3198, vrr_stack+3033, vrr_stack+2538, vrr_stack+879, vrr_stack+604, vrr_stack+1242);
 _BUILD_00p0(Data,vrr_stack+1242, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1245, vrr_stack+385, vrr_stack+1242, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+1251, vrr_stack+388, vrr_stack+1245, vrr_stack+191, vrr_stack+385, NULL);
 _BUILD_00g0(Data,vrr_stack+1261, vrr_stack+394, vrr_stack+1251, vrr_stack+90, vrr_stack+388, NULL);
 _BUILD_00h0(Data,vrr_stack+1276, vrr_stack+0, vrr_stack+1261, vrr_stack+40, vrr_stack+394, NULL);
 _BUILD_00i0(Data,vrr_stack+1297, vrr_stack+15, vrr_stack+1276, vrr_stack+194, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+1325, vrr_stack+404, vrr_stack+1297, vrr_stack+209, vrr_stack+15, NULL);
 _BUILD_00l0(Data,vrr_stack+934, vrr_stack+1377, vrr_stack+1325, vrr_stack+485, vrr_stack+404, NULL);
 _BUILD_00m0(Data,vrr_stack+162, vrr_stack+117, vrr_stack+934, vrr_stack+513, vrr_stack+1377, NULL);
 _BUILD_p0m0(Data,vrr_stack+3528, vrr_stack+659, vrr_stack+162, NULL, NULL, vrr_stack+117);
 _BUILD_d0m0(Data,vrr_stack+3693, vrr_stack+714, vrr_stack+3528, vrr_stack+549, vrr_stack+659, vrr_stack+1413);
 _BUILD_f0m0(Data,vrr_stack+4023, vrr_stack+2703, vrr_stack+3693, vrr_stack+2538, vrr_stack+714, vrr_stack+1548);
 _BUILD_f0m0(Data,vrr_stack+4573, vrr_stack+3198, vrr_stack+2703, vrr_stack+3033, vrr_stack+2538, vrr_stack+1818);
 _BUILD_g0m0(Data,vrr_stack+5123, vrr_stack+4573, vrr_stack+4023, vrr_stack+3198, vrr_stack+2703, vrr_stack+2088);
 _BUILD_00n0(Data,vrr_stack+1413, vrr_stack+549, vrr_stack+659, vrr_stack+981, vrr_stack+265, NULL);
 _BUILD_00n0(Data,vrr_stack+1479, vrr_stack+604, vrr_stack+549, vrr_stack+1197, vrr_stack+981, NULL);
 _BUILD_p0n0(Data,vrr_stack+1545, vrr_stack+1479, vrr_stack+1413, NULL, NULL, vrr_stack+549);
 _BUILD_00n0(Data,vrr_stack+1743, vrr_stack+879, vrr_stack+604, vrr_stack+1109, vrr_stack+1197, NULL);
 _BUILD_p0n0(Data,vrr_stack+1809, vrr_stack+1743, vrr_stack+1479, NULL, NULL, vrr_stack+604);
 _BUILD_00n0(Data,vrr_stack+2007, vrr_stack+659, vrr_stack+162, vrr_stack+265, vrr_stack+117, NULL);
 _BUILD_p0n0(Data,vrr_stack+2073, vrr_stack+1413, vrr_stack+2007, NULL, NULL, vrr_stack+659);
 _BUILD_d0n0(Data,vrr_stack+5948, vrr_stack+1545, vrr_stack+2073, vrr_stack+1479, vrr_stack+1413, vrr_stack+714);
 _BUILD_d0n0(Data,vrr_stack+6344, vrr_stack+1809, vrr_stack+1545, vrr_stack+1743, vrr_stack+1479, vrr_stack+2538);
 _BUILD_f0n0(Data,vrr_stack+6740, vrr_stack+6344, vrr_stack+5948, vrr_stack+1809, vrr_stack+1545, vrr_stack+2703);
 _BUILD_00p0(Data,vrr_stack+714, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+717, vrr_stack+714, vrr_stack+1026, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+723, vrr_stack+717, vrr_stack+1029, vrr_stack+714, vrr_stack+1026, NULL);
 _BUILD_00g0(Data,vrr_stack+733, vrr_stack+723, vrr_stack+1035, vrr_stack+717, vrr_stack+1029, NULL);
 _BUILD_00h0(Data,vrr_stack+748, vrr_stack+733, vrr_stack+1045, vrr_stack+723, vrr_stack+1035, NULL);
 _BUILD_00i0(Data,vrr_stack+769, vrr_stack+748, vrr_stack+1060, vrr_stack+733, vrr_stack+1045, NULL);
 _BUILD_00k0(Data,vrr_stack+797, vrr_stack+769, vrr_stack+1081, vrr_stack+748, vrr_stack+1060, NULL);
 _BUILD_00l0(Data,vrr_stack+714, vrr_stack+797, vrr_stack+310, vrr_stack+769, vrr_stack+1081, NULL);
 _BUILD_00m0(Data,vrr_stack+2271, vrr_stack+714, vrr_stack+1109, vrr_stack+797, vrr_stack+310, NULL);
 _BUILD_00n0(Data,vrr_stack+759, vrr_stack+2271, vrr_stack+879, vrr_stack+714, vrr_stack+1109, NULL);
 _BUILD_p0n0(Data,vrr_stack+2326, vrr_stack+759, vrr_stack+1743, NULL, NULL, vrr_stack+879);
 _BUILD_d0n0(Data,vrr_stack+2524, vrr_stack+2326, vrr_stack+1809, vrr_stack+759, vrr_stack+1743, vrr_stack+3033);
 _BUILD_f0n0(Data,vrr_stack+7400, vrr_stack+2524, vrr_stack+6344, vrr_stack+2326, vrr_stack+1809, vrr_stack+3198);
   tmp = vrr_stack + 7400;
   target_ptr = Libint->vrr_classes[3][10];
   for(i=0;i<660;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+2326, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2329, vrr_stack+1242, vrr_stack+2326, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+2335, vrr_stack+1245, vrr_stack+2329, vrr_stack+385, vrr_stack+1242, NULL);
 _BUILD_00g0(Data,vrr_stack+2345, vrr_stack+1251, vrr_stack+2335, vrr_stack+388, vrr_stack+1245, NULL);
 _BUILD_00h0(Data,vrr_stack+2360, vrr_stack+1261, vrr_stack+2345, vrr_stack+394, vrr_stack+1251, NULL);
 _BUILD_00i0(Data,vrr_stack+2381, vrr_stack+1276, vrr_stack+2360, vrr_stack+0, vrr_stack+1261, NULL);
 _BUILD_00k0(Data,vrr_stack+2409, vrr_stack+1297, vrr_stack+2381, vrr_stack+15, vrr_stack+1276, NULL);
 _BUILD_00l0(Data,vrr_stack+714, vrr_stack+1325, vrr_stack+2409, vrr_stack+404, vrr_stack+1297, NULL);
 _BUILD_00m0(Data,vrr_stack+0, vrr_stack+934, vrr_stack+714, vrr_stack+1377, vrr_stack+1325, NULL);
 _BUILD_00n0(Data,vrr_stack+2445, vrr_stack+162, vrr_stack+0, vrr_stack+117, vrr_stack+934, NULL);
 _BUILD_p0n0(Data,vrr_stack+2920, vrr_stack+2007, vrr_stack+2445, NULL, NULL, vrr_stack+162);
 _BUILD_d0n0(Data,vrr_stack+3118, vrr_stack+2073, vrr_stack+2920, vrr_stack+1413, vrr_stack+2007, vrr_stack+3528);
 _BUILD_f0n0(Data,vrr_stack+8060, vrr_stack+5948, vrr_stack+3118, vrr_stack+1545, vrr_stack+2073, vrr_stack+3693);
 _BUILD_g0n0(Data,vrr_stack+8720, vrr_stack+6740, vrr_stack+8060, vrr_stack+6344, vrr_stack+5948, vrr_stack+4023);
 _BUILD_g0n0(Data,vrr_stack+3514, vrr_stack+7400, vrr_stack+6740, vrr_stack+2524, vrr_stack+6344, vrr_stack+4573);
   tmp = vrr_stack + 3514;
   target_ptr = Libint->vrr_classes[4][10];
   for(i=0;i<990;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+55, vrr_stack+1413, vrr_stack+2007, vrr_stack+549, vrr_stack+659, NULL);
 _BUILD_00o0(Data,vrr_stack+2511, vrr_stack+1479, vrr_stack+1413, vrr_stack+604, vrr_stack+549, NULL);
 _BUILD_p0o0(Data,vrr_stack+2589, vrr_stack+2511, vrr_stack+55, NULL, NULL, vrr_stack+1413);
 _BUILD_00o0(Data,vrr_stack+2823, vrr_stack+1743, vrr_stack+1479, vrr_stack+879, vrr_stack+604, NULL);
 _BUILD_p0o0(Data,vrr_stack+4504, vrr_stack+2823, vrr_stack+2511, NULL, NULL, vrr_stack+1479);
 _BUILD_00o0(Data,vrr_stack+4738, vrr_stack+2007, vrr_stack+2445, vrr_stack+659, vrr_stack+162, NULL);
 _BUILD_p0o0(Data,vrr_stack+4816, vrr_stack+55, vrr_stack+4738, NULL, NULL, vrr_stack+2007);
 _BUILD_d0o0(Data,vrr_stack+217, vrr_stack+2589, vrr_stack+4816, vrr_stack+2511, vrr_stack+55, vrr_stack+2073);
 _BUILD_d0o0(Data,vrr_stack+9710, vrr_stack+4504, vrr_stack+2589, vrr_stack+2823, vrr_stack+2511, vrr_stack+1545);
 _BUILD_f0o0(Data,vrr_stack+10178, vrr_stack+9710, vrr_stack+217, vrr_stack+4504, vrr_stack+2589, vrr_stack+5948);
 _BUILD_00o0(Data,vrr_stack+5948, vrr_stack+759, vrr_stack+1743, vrr_stack+2271, vrr_stack+879, NULL);
 _BUILD_p0o0(Data,vrr_stack+6026, vrr_stack+5948, vrr_stack+2823, NULL, NULL, vrr_stack+1743);
 _BUILD_d0o0(Data,vrr_stack+10958, vrr_stack+6026, vrr_stack+4504, vrr_stack+5948, vrr_stack+2823, vrr_stack+1809);
 _BUILD_f0o0(Data,vrr_stack+11426, vrr_stack+10958, vrr_stack+9710, vrr_stack+6026, vrr_stack+4504, vrr_stack+6344);
   tmp = vrr_stack + 11426;
   target_ptr = Libint->vrr_classes[3][11];
   for(i=0;i<780;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+6026, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6029, vrr_stack+2326, vrr_stack+6026, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+6035, vrr_stack+2329, vrr_stack+6029, vrr_stack+1242, vrr_stack+2326, NULL);
 _BUILD_00g0(Data,vrr_stack+6045, vrr_stack+2335, vrr_stack+6035, vrr_stack+1245, vrr_stack+2329, NULL);
 _BUILD_00h0(Data,vrr_stack+6060, vrr_stack+2345, vrr_stack+6045, vrr_stack+1251, vrr_stack+2335, NULL);
 _BUILD_00i0(Data,vrr_stack+6081, vrr_stack+2360, vrr_stack+6060, vrr_stack+1261, vrr_stack+2345, NULL);
 _BUILD_00k0(Data,vrr_stack+6109, vrr_stack+2381, vrr_stack+6081, vrr_stack+1276, vrr_stack+2360, NULL);
 _BUILD_00l0(Data,vrr_stack+6145, vrr_stack+2409, vrr_stack+6109, vrr_stack+1297, vrr_stack+2381, NULL);
 _BUILD_00m0(Data,vrr_stack+6190, vrr_stack+714, vrr_stack+6145, vrr_stack+1325, vrr_stack+2409, NULL);
 _BUILD_00n0(Data,vrr_stack+6245, vrr_stack+0, vrr_stack+6190, vrr_stack+934, vrr_stack+714, NULL);
 _BUILD_00o0(Data,vrr_stack+6311, vrr_stack+2445, vrr_stack+6245, vrr_stack+162, vrr_stack+0, NULL);
 _BUILD_p0o0(Data,vrr_stack+6389, vrr_stack+4738, vrr_stack+6311, NULL, NULL, vrr_stack+2445);
 _BUILD_d0o0(Data,vrr_stack+825, vrr_stack+4816, vrr_stack+6389, vrr_stack+55, vrr_stack+4738, vrr_stack+2920);
 _BUILD_f0o0(Data,vrr_stack+12206, vrr_stack+217, vrr_stack+825, vrr_stack+2589, vrr_stack+4816, vrr_stack+3118);
 _BUILD_g0o0(Data,vrr_stack+12986, vrr_stack+10178, vrr_stack+12206, vrr_stack+9710, vrr_stack+217, vrr_stack+8060);
 _BUILD_g0o0(Data,vrr_stack+14156, vrr_stack+11426, vrr_stack+10178, vrr_stack+10958, vrr_stack+9710, vrr_stack+6740);
   tmp = vrr_stack + 14156;
   target_ptr = Libint->vrr_classes[4][11];
   for(i=0;i<1170;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+10958, vrr_stack+55, vrr_stack+4738, vrr_stack+1413, vrr_stack+2007, NULL);
 _BUILD_00q0(Data,vrr_stack+11049, vrr_stack+2511, vrr_stack+55, vrr_stack+1479, vrr_stack+1413, NULL);
 _BUILD_p0q0(Data,vrr_stack+11140, vrr_stack+11049, vrr_stack+10958, NULL, NULL, vrr_stack+55);
 _BUILD_00q0(Data,vrr_stack+55, vrr_stack+2823, vrr_stack+2511, vrr_stack+1743, vrr_stack+1479, NULL);
 _BUILD_p0q0(Data,vrr_stack+8060, vrr_stack+55, vrr_stack+11049, NULL, NULL, vrr_stack+2511);
 _BUILD_00q0(Data,vrr_stack+8333, vrr_stack+4738, vrr_stack+6311, vrr_stack+2007, vrr_stack+2445, NULL);
 _BUILD_p0q0(Data,vrr_stack+8424, vrr_stack+10958, vrr_stack+8333, NULL, NULL, vrr_stack+4738);
 _BUILD_d0q0(Data,vrr_stack+2901, vrr_stack+11140, vrr_stack+8424, vrr_stack+11049, vrr_stack+10958, vrr_stack+4816);
 _BUILD_d0q0(Data,vrr_stack+15326, vrr_stack+8060, vrr_stack+11140, vrr_stack+55, vrr_stack+11049, vrr_stack+2589);
 _BUILD_f0q0(Data,vrr_stack+15872, vrr_stack+15326, vrr_stack+2901, vrr_stack+8060, vrr_stack+11140, vrr_stack+217);
 _BUILD_00q0(Data,vrr_stack+11049, vrr_stack+5948, vrr_stack+2823, vrr_stack+759, vrr_stack+1743, NULL);
 _BUILD_p0q0(Data,vrr_stack+4738, vrr_stack+11049, vrr_stack+55, NULL, NULL, vrr_stack+2823);
 _BUILD_d0q0(Data,vrr_stack+146, vrr_stack+4738, vrr_stack+8060, vrr_stack+11049, vrr_stack+55, vrr_stack+4504);
 _BUILD_f0q0(Data,vrr_stack+1293, vrr_stack+146, vrr_stack+15326, vrr_stack+4738, vrr_stack+8060, vrr_stack+9710);
   tmp = vrr_stack + 1293;
   target_ptr = Libint->vrr_classes[3][12];
   for(i=0;i<910;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+9710, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9713, vrr_stack+6026, vrr_stack+9710, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+9719, vrr_stack+6029, vrr_stack+9713, vrr_stack+2326, vrr_stack+6026, NULL);
 _BUILD_00g0(Data,vrr_stack+9729, vrr_stack+6035, vrr_stack+9719, vrr_stack+2329, vrr_stack+6029, NULL);
 _BUILD_00h0(Data,vrr_stack+9744, vrr_stack+6045, vrr_stack+9729, vrr_stack+2335, vrr_stack+6035, NULL);
 _BUILD_00i0(Data,vrr_stack+9710, vrr_stack+6060, vrr_stack+9744, vrr_stack+2345, vrr_stack+6045, NULL);
 _BUILD_00k0(Data,vrr_stack+9738, vrr_stack+6081, vrr_stack+9710, vrr_stack+2360, vrr_stack+6060, NULL);
 _BUILD_00l0(Data,vrr_stack+9774, vrr_stack+6109, vrr_stack+9738, vrr_stack+2381, vrr_stack+6081, NULL);
 _BUILD_00m0(Data,vrr_stack+9710, vrr_stack+6145, vrr_stack+9774, vrr_stack+2409, vrr_stack+6109, NULL);
 _BUILD_00n0(Data,vrr_stack+759, vrr_stack+6190, vrr_stack+9710, vrr_stack+714, vrr_stack+6145, NULL);
 _BUILD_00o0(Data,vrr_stack+9710, vrr_stack+6245, vrr_stack+759, vrr_stack+0, vrr_stack+6190, NULL);
 _BUILD_00q0(Data,vrr_stack+11049, vrr_stack+6311, vrr_stack+9710, vrr_stack+2445, vrr_stack+6245, NULL);
 _BUILD_p0q0(Data,vrr_stack+8060, vrr_stack+8333, vrr_stack+11049, NULL, NULL, vrr_stack+6311);
 _BUILD_d0q0(Data,vrr_stack+4504, vrr_stack+8424, vrr_stack+8060, vrr_stack+10958, vrr_stack+8333, vrr_stack+6389);
 _BUILD_f0q0(Data,vrr_stack+16782, vrr_stack+2901, vrr_stack+4504, vrr_stack+11140, vrr_stack+8424, vrr_stack+825);
 _BUILD_g0q0(Data,vrr_stack+17692, vrr_stack+15872, vrr_stack+16782, vrr_stack+15326, vrr_stack+2901, vrr_stack+12206);
 _BUILD_g0q0(Data,vrr_stack+19057, vrr_stack+1293, vrr_stack+15872, vrr_stack+146, vrr_stack+15326, vrr_stack+10178);
   tmp = vrr_stack + 19057;
   target_ptr = Libint->vrr_classes[4][12];
   for(i=0;i<1365;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0n0(Data,vrr_stack+20422, vrr_stack+3514, vrr_stack+8720, vrr_stack+7400, vrr_stack+6740, vrr_stack+5123);
   tmp = vrr_stack + 20422;
   target_ptr = Libint->vrr_classes[5][10];
   for(i=0;i<1386;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0o0(Data,vrr_stack+2203, vrr_stack+14156, vrr_stack+12986, vrr_stack+11426, vrr_stack+10178, vrr_stack+8720);
   tmp = vrr_stack + 2203;
   target_ptr = Libint->vrr_classes[5][11];
   for(i=0;i<1638;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0q0(Data,vrr_stack+3841, vrr_stack+19057, vrr_stack+17692, vrr_stack+1293, vrr_stack+15872, vrr_stack+12986);
   tmp = vrr_stack + 3841;
   target_ptr = Libint->vrr_classes[5][12];
   for(i=0;i<1911;i++)
     target_ptr[i] += tmp[i];

}

