/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (hp|mk) integrals */

void vrr_order_hpmk(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+7, Data->F+8, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+6, vrr_stack+31, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+9, vrr_stack+34, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+50, vrr_stack+21, vrr_stack+40, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+0, vrr_stack+3, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+65, vrr_stack+15, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+71, vrr_stack+21, vrr_stack+65, vrr_stack+15, NULL);
 _BUILD_p0g0(Data,vrr_stack+96, vrr_stack+81, vrr_stack+50, NULL, NULL, vrr_stack+21);
 _BUILD_00h0(Data,vrr_stack+141, vrr_stack+81, vrr_stack+50, vrr_stack+71, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+162, vrr_stack+15, vrr_stack+65, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+172, vrr_stack+162, vrr_stack+71, vrr_stack+15, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+187, vrr_stack+172, vrr_stack+81, vrr_stack+162, vrr_stack+71, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+31, vrr_stack+0, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+34, vrr_stack+65, vrr_stack+6, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+208, vrr_stack+40, vrr_stack+71, vrr_stack+9, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+223, vrr_stack+50, vrr_stack+208, vrr_stack+21, vrr_stack+40, NULL);
 _BUILD_p0h0(Data,vrr_stack+244, vrr_stack+141, vrr_stack+223, NULL, NULL, vrr_stack+50);
 _BUILD_p0h0(Data,vrr_stack+307, vrr_stack+187, vrr_stack+141, NULL, NULL, vrr_stack+81);
 _BUILD_d0h0(Data,vrr_stack+370, vrr_stack+307, vrr_stack+244, vrr_stack+187, vrr_stack+141, vrr_stack+96);
 _BUILD_00i0(Data,vrr_stack+96, vrr_stack+141, vrr_stack+223, vrr_stack+81, vrr_stack+50, NULL);
 _BUILD_00i0(Data,vrr_stack+496, vrr_stack+187, vrr_stack+141, vrr_stack+172, vrr_stack+81, NULL);
 _BUILD_p0i0(Data,vrr_stack+524, vrr_stack+496, vrr_stack+96, NULL, NULL, vrr_stack+141);
 _BUILD_00p0(Data,vrr_stack+81, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+84, vrr_stack+81, vrr_stack+3, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+84, vrr_stack+15, vrr_stack+81, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+124, vrr_stack+21, vrr_stack+162, vrr_stack+84, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+608, vrr_stack+124, vrr_stack+172, vrr_stack+21, vrr_stack+162, NULL);
 _BUILD_00i0(Data,vrr_stack+629, vrr_stack+608, vrr_stack+187, vrr_stack+124, vrr_stack+172, NULL);
 _BUILD_p0i0(Data,vrr_stack+657, vrr_stack+629, vrr_stack+496, NULL, NULL, vrr_stack+187);
 _BUILD_00p0(Data,vrr_stack+162, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+90, vrr_stack+0, vrr_stack+162, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+165, vrr_stack+65, vrr_stack+90, vrr_stack+31, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+71, vrr_stack+165, vrr_stack+34, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+741, vrr_stack+208, vrr_stack+3, vrr_stack+40, vrr_stack+71, NULL);
 _BUILD_00i0(Data,vrr_stack+762, vrr_stack+223, vrr_stack+741, vrr_stack+50, vrr_stack+208, NULL);
 _BUILD_p0i0(Data,vrr_stack+790, vrr_stack+96, vrr_stack+762, NULL, NULL, vrr_stack+223);
 _BUILD_d0i0(Data,vrr_stack+874, vrr_stack+524, vrr_stack+790, vrr_stack+496, vrr_stack+96, vrr_stack+244);
 _BUILD_d0i0(Data,vrr_stack+1042, vrr_stack+657, vrr_stack+524, vrr_stack+629, vrr_stack+496, vrr_stack+307);
 _BUILD_f0i0(Data,vrr_stack+1210, vrr_stack+1042, vrr_stack+874, vrr_stack+657, vrr_stack+524, vrr_stack+370);
 _BUILD_00k0(Data,vrr_stack+244, vrr_stack+496, vrr_stack+96, vrr_stack+187, vrr_stack+141, NULL);
 _BUILD_00k0(Data,vrr_stack+280, vrr_stack+629, vrr_stack+496, vrr_stack+608, vrr_stack+187, NULL);
 _BUILD_00k0(Data,vrr_stack+316, vrr_stack+96, vrr_stack+762, vrr_stack+141, vrr_stack+223, NULL);
 _BUILD_p0k0(Data,vrr_stack+352, vrr_stack+244, vrr_stack+316, NULL, NULL, vrr_stack+96);
 _BUILD_p0k0(Data,vrr_stack+1490, vrr_stack+280, vrr_stack+244, NULL, NULL, vrr_stack+496);
 _BUILD_d0k0(Data,vrr_stack+1598, vrr_stack+1490, vrr_stack+352, vrr_stack+280, vrr_stack+244, vrr_stack+524);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+524, vrr_stack+18, vrr_stack+81, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+530, vrr_stack+524, vrr_stack+84, vrr_stack+18, vrr_stack+81, NULL);
 _BUILD_00g0(Data,vrr_stack+540, vrr_stack+530, vrr_stack+21, vrr_stack+524, vrr_stack+84, NULL);
 _BUILD_00h0(Data,vrr_stack+555, vrr_stack+540, vrr_stack+124, vrr_stack+530, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+21, vrr_stack+555, vrr_stack+608, vrr_stack+540, vrr_stack+124, NULL);
 _BUILD_00k0(Data,vrr_stack+460, vrr_stack+21, vrr_stack+629, vrr_stack+555, vrr_stack+608, NULL);
 _BUILD_p0k0(Data,vrr_stack+1814, vrr_stack+460, vrr_stack+280, NULL, NULL, vrr_stack+629);
 _BUILD_d0k0(Data,vrr_stack+1922, vrr_stack+1814, vrr_stack+1490, vrr_stack+460, vrr_stack+280, vrr_stack+657);
 _BUILD_00p0(Data,vrr_stack+657, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+660, vrr_stack+162, vrr_stack+657, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+666, vrr_stack+90, vrr_stack+660, vrr_stack+0, vrr_stack+162, NULL);
 _BUILD_00g0(Data,vrr_stack+676, vrr_stack+165, vrr_stack+666, vrr_stack+65, vrr_stack+90, NULL);
 _BUILD_00h0(Data,vrr_stack+691, vrr_stack+3, vrr_stack+676, vrr_stack+71, vrr_stack+165, NULL);
 _BUILD_00i0(Data,vrr_stack+712, vrr_stack+741, vrr_stack+691, vrr_stack+208, vrr_stack+3, NULL);
 _BUILD_00k0(Data,vrr_stack+124, vrr_stack+762, vrr_stack+712, vrr_stack+223, vrr_stack+741, NULL);
 _BUILD_p0k0(Data,vrr_stack+2138, vrr_stack+316, vrr_stack+124, NULL, NULL, vrr_stack+762);
 _BUILD_d0k0(Data,vrr_stack+2246, vrr_stack+352, vrr_stack+2138, vrr_stack+244, vrr_stack+316, vrr_stack+790);
 _BUILD_f0k0(Data,vrr_stack+2462, vrr_stack+1598, vrr_stack+2246, vrr_stack+1490, vrr_stack+352, vrr_stack+874);
 _BUILD_f0k0(Data,vrr_stack+2822, vrr_stack+1922, vrr_stack+1598, vrr_stack+1814, vrr_stack+1490, vrr_stack+1042);
 _BUILD_g0k0(Data,vrr_stack+3182, vrr_stack+2822, vrr_stack+2462, vrr_stack+1922, vrr_stack+1598, vrr_stack+1210);
 _BUILD_00l0(Data,vrr_stack+790, vrr_stack+244, vrr_stack+316, vrr_stack+496, vrr_stack+96, NULL);
 _BUILD_00l0(Data,vrr_stack+835, vrr_stack+280, vrr_stack+244, vrr_stack+629, vrr_stack+496, NULL);
 _BUILD_p0l0(Data,vrr_stack+880, vrr_stack+835, vrr_stack+790, NULL, NULL, vrr_stack+244);
 _BUILD_00l0(Data,vrr_stack+1015, vrr_stack+460, vrr_stack+280, vrr_stack+21, vrr_stack+629, NULL);
 _BUILD_p0l0(Data,vrr_stack+1060, vrr_stack+1015, vrr_stack+835, NULL, NULL, vrr_stack+280);
 _BUILD_00l0(Data,vrr_stack+1195, vrr_stack+316, vrr_stack+124, vrr_stack+96, vrr_stack+762, NULL);
 _BUILD_p0l0(Data,vrr_stack+1240, vrr_stack+790, vrr_stack+1195, NULL, NULL, vrr_stack+316);
 _BUILD_d0l0(Data,vrr_stack+3722, vrr_stack+880, vrr_stack+1240, vrr_stack+835, vrr_stack+790, vrr_stack+352);
 _BUILD_d0l0(Data,vrr_stack+3992, vrr_stack+1060, vrr_stack+880, vrr_stack+1015, vrr_stack+835, vrr_stack+1490);
 _BUILD_f0l0(Data,vrr_stack+4262, vrr_stack+3992, vrr_stack+3722, vrr_stack+1060, vrr_stack+880, vrr_stack+1598);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+352, vrr_stack+0, vrr_stack+18, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+358, vrr_stack+352, vrr_stack+524, vrr_stack+0, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+368, vrr_stack+358, vrr_stack+530, vrr_stack+352, vrr_stack+524, NULL);
 _BUILD_00h0(Data,vrr_stack+383, vrr_stack+368, vrr_stack+540, vrr_stack+358, vrr_stack+530, NULL);
 _BUILD_00i0(Data,vrr_stack+96, vrr_stack+383, vrr_stack+555, vrr_stack+368, vrr_stack+540, NULL);
 _BUILD_00k0(Data,vrr_stack+404, vrr_stack+96, vrr_stack+21, vrr_stack+383, vrr_stack+555, NULL);
 _BUILD_00l0(Data,vrr_stack+496, vrr_stack+404, vrr_stack+460, vrr_stack+96, vrr_stack+21, NULL);
 _BUILD_p0l0(Data,vrr_stack+1375, vrr_stack+496, vrr_stack+1015, NULL, NULL, vrr_stack+460);
 _BUILD_d0l0(Data,vrr_stack+1510, vrr_stack+1375, vrr_stack+1060, vrr_stack+496, vrr_stack+1015, vrr_stack+1814);
 _BUILD_f0l0(Data,vrr_stack+4712, vrr_stack+1510, vrr_stack+3992, vrr_stack+1375, vrr_stack+1060, vrr_stack+1922);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+657, vrr_stack+18, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+27, vrr_stack+660, vrr_stack+21, vrr_stack+162, vrr_stack+657, NULL);
 _BUILD_00g0(Data,vrr_stack+37, vrr_stack+666, vrr_stack+27, vrr_stack+90, vrr_stack+660, NULL);
 _BUILD_00h0(Data,vrr_stack+52, vrr_stack+676, vrr_stack+37, vrr_stack+165, vrr_stack+666, NULL);
 _BUILD_00i0(Data,vrr_stack+541, vrr_stack+691, vrr_stack+52, vrr_stack+3, vrr_stack+676, NULL);
 _BUILD_00k0(Data,vrr_stack+569, vrr_stack+712, vrr_stack+541, vrr_stack+741, vrr_stack+691, NULL);
 _BUILD_00l0(Data,vrr_stack+605, vrr_stack+124, vrr_stack+569, vrr_stack+762, vrr_stack+712, NULL);
 _BUILD_p0l0(Data,vrr_stack+1780, vrr_stack+1195, vrr_stack+605, NULL, NULL, vrr_stack+124);
 _BUILD_d0l0(Data,vrr_stack+5162, vrr_stack+1240, vrr_stack+1780, vrr_stack+790, vrr_stack+1195, vrr_stack+2138);
 _BUILD_f0l0(Data,vrr_stack+5432, vrr_stack+3722, vrr_stack+5162, vrr_stack+880, vrr_stack+1240, vrr_stack+2246);
 _BUILD_g0l0(Data,vrr_stack+5882, vrr_stack+4262, vrr_stack+5432, vrr_stack+3992, vrr_stack+3722, vrr_stack+2462);
 _BUILD_g0l0(Data,vrr_stack+1915, vrr_stack+4712, vrr_stack+4262, vrr_stack+1510, vrr_stack+3992, vrr_stack+2822);
 _BUILD_h0l0(Data,vrr_stack+6557, vrr_stack+1915, vrr_stack+5882, vrr_stack+4712, vrr_stack+4262, vrr_stack+3182);
 _BUILD_00m0(Data,vrr_stack+2590, vrr_stack+835, vrr_stack+790, vrr_stack+280, vrr_stack+244, NULL);
 _BUILD_00m0(Data,vrr_stack+2645, vrr_stack+1015, vrr_stack+835, vrr_stack+460, vrr_stack+280, NULL);
 _BUILD_00m0(Data,vrr_stack+2700, vrr_stack+790, vrr_stack+1195, vrr_stack+244, vrr_stack+316, NULL);
 _BUILD_p0m0(Data,vrr_stack+2755, vrr_stack+2590, vrr_stack+2700, NULL, NULL, vrr_stack+790);
 _BUILD_p0m0(Data,vrr_stack+2920, vrr_stack+2645, vrr_stack+2590, NULL, NULL, vrr_stack+835);
 _BUILD_d0m0(Data,vrr_stack+3085, vrr_stack+2920, vrr_stack+2755, vrr_stack+2645, vrr_stack+2590, vrr_stack+880);
 _BUILD_00m0(Data,vrr_stack+880, vrr_stack+496, vrr_stack+1015, vrr_stack+404, vrr_stack+460, NULL);
 _BUILD_p0m0(Data,vrr_stack+3415, vrr_stack+880, vrr_stack+2645, NULL, NULL, vrr_stack+1015);
 _BUILD_d0m0(Data,vrr_stack+7502, vrr_stack+3415, vrr_stack+2920, vrr_stack+880, vrr_stack+2645, vrr_stack+1060);
 _BUILD_00m0(Data,vrr_stack+1060, vrr_stack+1195, vrr_stack+605, vrr_stack+316, vrr_stack+124, NULL);
 _BUILD_p0m0(Data,vrr_stack+160, vrr_stack+2700, vrr_stack+1060, NULL, NULL, vrr_stack+1195);
 _BUILD_d0m0(Data,vrr_stack+7832, vrr_stack+2755, vrr_stack+160, vrr_stack+2590, vrr_stack+2700, vrr_stack+1240);
 _BUILD_f0m0(Data,vrr_stack+8162, vrr_stack+3085, vrr_stack+7832, vrr_stack+2920, vrr_stack+2755, vrr_stack+3722);
 _BUILD_f0m0(Data,vrr_stack+8712, vrr_stack+7502, vrr_stack+3085, vrr_stack+3415, vrr_stack+2920, vrr_stack+3992);
 _BUILD_g0m0(Data,vrr_stack+9262, vrr_stack+8712, vrr_stack+8162, vrr_stack+7502, vrr_stack+3085, vrr_stack+4262);
 _BUILD_00p0(Data,vrr_stack+1240, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1243, vrr_stack+1240, vrr_stack+0, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+1249, vrr_stack+1243, vrr_stack+352, vrr_stack+1240, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+1249, vrr_stack+358, vrr_stack+1243, vrr_stack+352, NULL);
 _BUILD_00h0(Data,vrr_stack+1259, vrr_stack+0, vrr_stack+368, vrr_stack+1249, vrr_stack+358, NULL);
 _BUILD_00i0(Data,vrr_stack+1280, vrr_stack+1259, vrr_stack+383, vrr_stack+0, vrr_stack+368, NULL);
 _BUILD_00k0(Data,vrr_stack+1308, vrr_stack+1280, vrr_stack+96, vrr_stack+1259, vrr_stack+383, NULL);
 _BUILD_00l0(Data,vrr_stack+1115, vrr_stack+1308, vrr_stack+404, vrr_stack+1280, vrr_stack+96, NULL);
 _BUILD_00m0(Data,vrr_stack+1240, vrr_stack+1115, vrr_stack+496, vrr_stack+1308, vrr_stack+404, NULL);
 _BUILD_p0m0(Data,vrr_stack+3580, vrr_stack+1240, vrr_stack+880, NULL, NULL, vrr_stack+496);
 _BUILD_d0m0(Data,vrr_stack+3745, vrr_stack+3580, vrr_stack+3415, vrr_stack+1240, vrr_stack+880, vrr_stack+1375);
 _BUILD_f0m0(Data,vrr_stack+4075, vrr_stack+3745, vrr_stack+7502, vrr_stack+3580, vrr_stack+3415, vrr_stack+1510);
 _BUILD_g0m0(Data,vrr_stack+10087, vrr_stack+4075, vrr_stack+8712, vrr_stack+3745, vrr_stack+7502, vrr_stack+4712);
 _BUILD_00p0(Data,vrr_stack+3580, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3583, vrr_stack+18, vrr_stack+3580, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+3589, vrr_stack+21, vrr_stack+3583, vrr_stack+657, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+3599, vrr_stack+27, vrr_stack+3589, vrr_stack+660, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+3614, vrr_stack+37, vrr_stack+3599, vrr_stack+666, vrr_stack+27, NULL);
 _BUILD_00i0(Data,vrr_stack+3635, vrr_stack+52, vrr_stack+3614, vrr_stack+676, vrr_stack+37, NULL);
 _BUILD_00k0(Data,vrr_stack+3663, vrr_stack+541, vrr_stack+3635, vrr_stack+691, vrr_stack+52, NULL);
 _BUILD_00l0(Data,vrr_stack+3699, vrr_stack+569, vrr_stack+3663, vrr_stack+712, vrr_stack+541, NULL);
 _BUILD_00m0(Data,vrr_stack+3744, vrr_stack+605, vrr_stack+3699, vrr_stack+124, vrr_stack+569, NULL);
 _BUILD_p0m0(Data,vrr_stack+3799, vrr_stack+1060, vrr_stack+3744, NULL, NULL, vrr_stack+605);
 _BUILD_d0m0(Data,vrr_stack+1295, vrr_stack+160, vrr_stack+3799, vrr_stack+2700, vrr_stack+1060, vrr_stack+1780);
 _BUILD_f0m0(Data,vrr_stack+10912, vrr_stack+7832, vrr_stack+1295, vrr_stack+2755, vrr_stack+160, vrr_stack+5162);
 _BUILD_g0m0(Data,vrr_stack+11462, vrr_stack+8162, vrr_stack+10912, vrr_stack+3085, vrr_stack+7832, vrr_stack+5432);
 _BUILD_h0m0(Data,vrr_stack+4625, vrr_stack+9262, vrr_stack+11462, vrr_stack+8712, vrr_stack+8162, vrr_stack+5882);
 _BUILD_h0m0(Data,vrr_stack+12287, vrr_stack+10087, vrr_stack+9262, vrr_stack+4075, vrr_stack+8712, vrr_stack+1915);
   tmp = vrr_stack + 12287;
   target_ptr = Libint->vrr_classes[5][9];
   for(i=0;i<1155;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+3964, vrr_stack+2590, vrr_stack+2700, vrr_stack+835, vrr_stack+790, NULL);
 _BUILD_00n0(Data,vrr_stack+4030, vrr_stack+2645, vrr_stack+2590, vrr_stack+1015, vrr_stack+835, NULL);
 _BUILD_00n0(Data,vrr_stack+4096, vrr_stack+2700, vrr_stack+1060, vrr_stack+790, vrr_stack+1195, NULL);
 _BUILD_p0n0(Data,vrr_stack+4162, vrr_stack+3964, vrr_stack+4096, NULL, NULL, vrr_stack+2700);
 _BUILD_p0n0(Data,vrr_stack+4360, vrr_stack+4030, vrr_stack+3964, NULL, NULL, vrr_stack+2590);
 _BUILD_d0n0(Data,vrr_stack+1625, vrr_stack+4360, vrr_stack+4162, vrr_stack+4030, vrr_stack+3964, vrr_stack+2755);
 _BUILD_00n0(Data,vrr_stack+2755, vrr_stack+880, vrr_stack+2645, vrr_stack+496, vrr_stack+1015, NULL);
 _BUILD_p0n0(Data,vrr_stack+2021, vrr_stack+2755, vrr_stack+4030, NULL, NULL, vrr_stack+2645);
 _BUILD_d0n0(Data,vrr_stack+5780, vrr_stack+2021, vrr_stack+4360, vrr_stack+2755, vrr_stack+4030, vrr_stack+2920);
 _BUILD_00n0(Data,vrr_stack+2821, vrr_stack+1060, vrr_stack+3744, vrr_stack+1195, vrr_stack+605, NULL);
 _BUILD_p0n0(Data,vrr_stack+2887, vrr_stack+4096, vrr_stack+2821, NULL, NULL, vrr_stack+1060);
 _BUILD_d0n0(Data,vrr_stack+13442, vrr_stack+4162, vrr_stack+2887, vrr_stack+3964, vrr_stack+4096, vrr_stack+160);
 _BUILD_f0n0(Data,vrr_stack+13838, vrr_stack+1625, vrr_stack+13442, vrr_stack+4360, vrr_stack+4162, vrr_stack+7832);
 _BUILD_f0n0(Data,vrr_stack+14498, vrr_stack+5780, vrr_stack+1625, vrr_stack+2021, vrr_stack+4360, vrr_stack+3085);
 _BUILD_g0n0(Data,vrr_stack+15158, vrr_stack+14498, vrr_stack+13838, vrr_stack+5780, vrr_stack+1625, vrr_stack+8162);
 _BUILD_00n0(Data,vrr_stack+3085, vrr_stack+1240, vrr_stack+880, vrr_stack+1115, vrr_stack+496, NULL);
 _BUILD_p0n0(Data,vrr_stack+3151, vrr_stack+3085, vrr_stack+2755, NULL, NULL, vrr_stack+880);
 _BUILD_d0n0(Data,vrr_stack+7832, vrr_stack+3151, vrr_stack+2021, vrr_stack+3085, vrr_stack+2755, vrr_stack+3415);
 _BUILD_f0n0(Data,vrr_stack+16148, vrr_stack+7832, vrr_stack+5780, vrr_stack+3151, vrr_stack+2021, vrr_stack+7502);
 _BUILD_g0n0(Data,vrr_stack+16808, vrr_stack+16148, vrr_stack+14498, vrr_stack+7832, vrr_stack+5780, vrr_stack+8712);
 _BUILD_00p0(Data,vrr_stack+7502, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+7505, vrr_stack+3580, vrr_stack+7502, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+7511, vrr_stack+3583, vrr_stack+7505, vrr_stack+18, vrr_stack+3580, NULL);
 _BUILD_00g0(Data,vrr_stack+7521, vrr_stack+3589, vrr_stack+7511, vrr_stack+21, vrr_stack+3583, NULL);
 _BUILD_00h0(Data,vrr_stack+7536, vrr_stack+3599, vrr_stack+7521, vrr_stack+27, vrr_stack+3589, NULL);
 _BUILD_00i0(Data,vrr_stack+7557, vrr_stack+3614, vrr_stack+7536, vrr_stack+37, vrr_stack+3599, NULL);
 _BUILD_00k0(Data,vrr_stack+7585, vrr_stack+3635, vrr_stack+7557, vrr_stack+52, vrr_stack+3614, NULL);
 _BUILD_00l0(Data,vrr_stack+7621, vrr_stack+3663, vrr_stack+7585, vrr_stack+541, vrr_stack+3635, NULL);
 _BUILD_00m0(Data,vrr_stack+7666, vrr_stack+3699, vrr_stack+7621, vrr_stack+569, vrr_stack+3663, NULL);
 _BUILD_00n0(Data,vrr_stack+7721, vrr_stack+3744, vrr_stack+7666, vrr_stack+605, vrr_stack+3699, NULL);
 _BUILD_p0n0(Data,vrr_stack+7787, vrr_stack+2821, vrr_stack+7721, NULL, NULL, vrr_stack+3744);
 _BUILD_d0n0(Data,vrr_stack+7985, vrr_stack+2887, vrr_stack+7787, vrr_stack+4096, vrr_stack+2821, vrr_stack+3799);
 _BUILD_f0n0(Data,vrr_stack+8381, vrr_stack+13442, vrr_stack+7985, vrr_stack+4162, vrr_stack+2887, vrr_stack+1295);
 _BUILD_g0n0(Data,vrr_stack+17798, vrr_stack+13838, vrr_stack+8381, vrr_stack+1625, vrr_stack+13442, vrr_stack+10912);
 _BUILD_h0n0(Data,vrr_stack+18788, vrr_stack+15158, vrr_stack+17798, vrr_stack+14498, vrr_stack+13838, vrr_stack+11462);
 _BUILD_h0n0(Data,vrr_stack+20174, vrr_stack+16808, vrr_stack+15158, vrr_stack+16148, vrr_stack+14498, vrr_stack+9262);
   tmp = vrr_stack + 20174;
   target_ptr = Libint->vrr_classes[5][10];
   for(i=0;i<1386;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+16148, vrr_stack+3964, vrr_stack+4096, vrr_stack+2590, vrr_stack+2700, NULL);
 _BUILD_00o0(Data,vrr_stack+16226, vrr_stack+4030, vrr_stack+3964, vrr_stack+2645, vrr_stack+2590, NULL);
 _BUILD_00o0(Data,vrr_stack+16304, vrr_stack+4096, vrr_stack+2821, vrr_stack+2700, vrr_stack+1060, NULL);
 _BUILD_p0o0(Data,vrr_stack+16382, vrr_stack+16148, vrr_stack+16304, NULL, NULL, vrr_stack+4096);
 _BUILD_p0o0(Data,vrr_stack+10912, vrr_stack+16226, vrr_stack+16148, NULL, NULL, vrr_stack+3964);
 _BUILD_d0o0(Data,vrr_stack+11146, vrr_stack+10912, vrr_stack+16382, vrr_stack+16226, vrr_stack+16148, vrr_stack+4162);
 _BUILD_00o0(Data,vrr_stack+4162, vrr_stack+2755, vrr_stack+4030, vrr_stack+880, vrr_stack+2645, NULL);
 _BUILD_p0o0(Data,vrr_stack+11614, vrr_stack+4162, vrr_stack+16226, NULL, NULL, vrr_stack+4030);
 _BUILD_d0o0(Data,vrr_stack+0, vrr_stack+11614, vrr_stack+10912, vrr_stack+4162, vrr_stack+16226, vrr_stack+4360);
 _BUILD_00o0(Data,vrr_stack+4240, vrr_stack+2821, vrr_stack+7721, vrr_stack+1060, vrr_stack+3744, NULL);
 _BUILD_p0o0(Data,vrr_stack+4318, vrr_stack+16304, vrr_stack+4240, NULL, NULL, vrr_stack+2821);
 _BUILD_d0o0(Data,vrr_stack+2219, vrr_stack+16382, vrr_stack+4318, vrr_stack+16148, vrr_stack+16304, vrr_stack+2887);
 _BUILD_f0o0(Data,vrr_stack+21560, vrr_stack+11146, vrr_stack+2219, vrr_stack+10912, vrr_stack+16382, vrr_stack+13442);
 _BUILD_f0o0(Data,vrr_stack+22340, vrr_stack+0, vrr_stack+11146, vrr_stack+11614, vrr_stack+10912, vrr_stack+1625);
 _BUILD_g0o0(Data,vrr_stack+23120, vrr_stack+22340, vrr_stack+21560, vrr_stack+0, vrr_stack+11146, vrr_stack+13838);
 _BUILD_00o0(Data,vrr_stack+13442, vrr_stack+3085, vrr_stack+2755, vrr_stack+1240, vrr_stack+880, NULL);
 _BUILD_p0o0(Data,vrr_stack+13520, vrr_stack+13442, vrr_stack+4162, NULL, NULL, vrr_stack+2755);
 _BUILD_d0o0(Data,vrr_stack+13754, vrr_stack+13520, vrr_stack+11614, vrr_stack+13442, vrr_stack+4162, vrr_stack+2021);
 _BUILD_f0o0(Data,vrr_stack+468, vrr_stack+13754, vrr_stack+0, vrr_stack+13520, vrr_stack+11614, vrr_stack+5780);
 _BUILD_g0o0(Data,vrr_stack+24290, vrr_stack+468, vrr_stack+22340, vrr_stack+13754, vrr_stack+0, vrr_stack+14498);
 _BUILD_00p0(Data,vrr_stack+5780, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+5783, vrr_stack+7502, vrr_stack+5780, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+5789, vrr_stack+7505, vrr_stack+5783, vrr_stack+3580, vrr_stack+7502, NULL);
 _BUILD_00g0(Data,vrr_stack+5799, vrr_stack+7511, vrr_stack+5789, vrr_stack+3583, vrr_stack+7505, NULL);
 _BUILD_00h0(Data,vrr_stack+5814, vrr_stack+7521, vrr_stack+5799, vrr_stack+3589, vrr_stack+7511, NULL);
 _BUILD_00i0(Data,vrr_stack+5835, vrr_stack+7536, vrr_stack+5814, vrr_stack+3599, vrr_stack+7521, NULL);
 _BUILD_00k0(Data,vrr_stack+5863, vrr_stack+7557, vrr_stack+5835, vrr_stack+3614, vrr_stack+7536, NULL);
 _BUILD_00l0(Data,vrr_stack+5899, vrr_stack+7585, vrr_stack+5863, vrr_stack+3635, vrr_stack+7557, NULL);
 _BUILD_00m0(Data,vrr_stack+5944, vrr_stack+7621, vrr_stack+5899, vrr_stack+3663, vrr_stack+7585, NULL);
 _BUILD_00n0(Data,vrr_stack+5999, vrr_stack+7666, vrr_stack+5944, vrr_stack+3699, vrr_stack+7621, NULL);
 _BUILD_00o0(Data,vrr_stack+6065, vrr_stack+7721, vrr_stack+5999, vrr_stack+3744, vrr_stack+7666, NULL);
 _BUILD_p0o0(Data,vrr_stack+6143, vrr_stack+4240, vrr_stack+6065, NULL, NULL, vrr_stack+7721);
 _BUILD_d0o0(Data,vrr_stack+13520, vrr_stack+4318, vrr_stack+6143, vrr_stack+16304, vrr_stack+4240, vrr_stack+7787);
 _BUILD_f0o0(Data,vrr_stack+13988, vrr_stack+2219, vrr_stack+13520, vrr_stack+16382, vrr_stack+4318, vrr_stack+7985);
 _BUILD_g0o0(Data,vrr_stack+25460, vrr_stack+21560, vrr_stack+13988, vrr_stack+11146, vrr_stack+2219, vrr_stack+8381);
 _BUILD_h0o0(Data,vrr_stack+26630, vrr_stack+23120, vrr_stack+25460, vrr_stack+22340, vrr_stack+21560, vrr_stack+17798);
 _BUILD_h0o0(Data,vrr_stack+28268, vrr_stack+24290, vrr_stack+23120, vrr_stack+468, vrr_stack+22340, vrr_stack+15158);
   tmp = vrr_stack + 28268;
   target_ptr = Libint->vrr_classes[5][11];
   for(i=0;i<1638;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+468, vrr_stack+16148, vrr_stack+16304, vrr_stack+3964, vrr_stack+4096, NULL);
 _BUILD_00q0(Data,vrr_stack+559, vrr_stack+16226, vrr_stack+16148, vrr_stack+4030, vrr_stack+3964, NULL);
 _BUILD_00q0(Data,vrr_stack+650, vrr_stack+16304, vrr_stack+4240, vrr_stack+4096, vrr_stack+2821, NULL);
 _BUILD_p0q0(Data,vrr_stack+741, vrr_stack+468, vrr_stack+650, NULL, NULL, vrr_stack+16304);
 _BUILD_p0q0(Data,vrr_stack+1014, vrr_stack+559, vrr_stack+468, NULL, NULL, vrr_stack+16148);
 _BUILD_d0q0(Data,vrr_stack+1287, vrr_stack+1014, vrr_stack+741, vrr_stack+559, vrr_stack+468, vrr_stack+16382);
 _BUILD_00q0(Data,vrr_stack+16382, vrr_stack+4162, vrr_stack+16226, vrr_stack+2755, vrr_stack+4030, NULL);
 _BUILD_p0q0(Data,vrr_stack+16473, vrr_stack+16382, vrr_stack+559, NULL, NULL, vrr_stack+16226);
 _BUILD_d0q0(Data,vrr_stack+17798, vrr_stack+16473, vrr_stack+1014, vrr_stack+16382, vrr_stack+559, vrr_stack+10912);
 _BUILD_00q0(Data,vrr_stack+10912, vrr_stack+4240, vrr_stack+6065, vrr_stack+2821, vrr_stack+7721, NULL);
 _BUILD_p0q0(Data,vrr_stack+1833, vrr_stack+650, vrr_stack+10912, NULL, NULL, vrr_stack+4240);
 _BUILD_d0q0(Data,vrr_stack+7787, vrr_stack+741, vrr_stack+1833, vrr_stack+468, vrr_stack+650, vrr_stack+4318);
 _BUILD_f0q0(Data,vrr_stack+8333, vrr_stack+1287, vrr_stack+7787, vrr_stack+1014, vrr_stack+741, vrr_stack+2219);
 _BUILD_f0q0(Data,vrr_stack+3151, vrr_stack+17798, vrr_stack+1287, vrr_stack+16473, vrr_stack+1014, vrr_stack+11146);
 _BUILD_g0q0(Data,vrr_stack+29906, vrr_stack+3151, vrr_stack+8333, vrr_stack+17798, vrr_stack+1287, vrr_stack+21560);
 _BUILD_00q0(Data,vrr_stack+21560, vrr_stack+13442, vrr_stack+4162, vrr_stack+3085, vrr_stack+2755, NULL);
 _BUILD_p0q0(Data,vrr_stack+21651, vrr_stack+21560, vrr_stack+16382, NULL, NULL, vrr_stack+4162);
 _BUILD_d0q0(Data,vrr_stack+11003, vrr_stack+21651, vrr_stack+16473, vrr_stack+21560, vrr_stack+16382, vrr_stack+11614);
 _BUILD_f0q0(Data,vrr_stack+2106, vrr_stack+11003, vrr_stack+17798, vrr_stack+21651, vrr_stack+16473, vrr_stack+0);
 _BUILD_g0q0(Data,vrr_stack+31271, vrr_stack+2106, vrr_stack+3151, vrr_stack+11003, vrr_stack+17798, vrr_stack+22340);
 _BUILD_00p0(Data,vrr_stack+11003, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+11006, vrr_stack+5780, vrr_stack+11003, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+11012, vrr_stack+5783, vrr_stack+11006, vrr_stack+7502, vrr_stack+5780, NULL);
 _BUILD_00g0(Data,vrr_stack+11022, vrr_stack+5789, vrr_stack+11012, vrr_stack+7505, vrr_stack+5783, NULL);
 _BUILD_00h0(Data,vrr_stack+11037, vrr_stack+5799, vrr_stack+11022, vrr_stack+7511, vrr_stack+5789, NULL);
 _BUILD_00i0(Data,vrr_stack+11058, vrr_stack+5814, vrr_stack+11037, vrr_stack+7521, vrr_stack+5799, NULL);
 _BUILD_00k0(Data,vrr_stack+11086, vrr_stack+5835, vrr_stack+11058, vrr_stack+7536, vrr_stack+5814, NULL);
 _BUILD_00l0(Data,vrr_stack+7502, vrr_stack+5863, vrr_stack+11086, vrr_stack+7557, vrr_stack+5835, NULL);
 _BUILD_00m0(Data,vrr_stack+11122, vrr_stack+5899, vrr_stack+7502, vrr_stack+7585, vrr_stack+5863, NULL);
 _BUILD_00n0(Data,vrr_stack+7547, vrr_stack+5944, vrr_stack+11122, vrr_stack+7621, vrr_stack+5899, NULL);
 _BUILD_00o0(Data,vrr_stack+11177, vrr_stack+5999, vrr_stack+7547, vrr_stack+7666, vrr_stack+5944, NULL);
 _BUILD_00q0(Data,vrr_stack+7613, vrr_stack+6065, vrr_stack+11177, vrr_stack+7721, vrr_stack+5999, NULL);
 _BUILD_p0q0(Data,vrr_stack+11255, vrr_stack+10912, vrr_stack+7613, NULL, NULL, vrr_stack+6065);
 _BUILD_d0q0(Data,vrr_stack+11528, vrr_stack+1833, vrr_stack+11255, vrr_stack+650, vrr_stack+10912, vrr_stack+6143);
 _BUILD_f0q0(Data,vrr_stack+21651, vrr_stack+7787, vrr_stack+11528, vrr_stack+741, vrr_stack+1833, vrr_stack+13520);
 _BUILD_g0q0(Data,vrr_stack+32636, vrr_stack+8333, vrr_stack+21651, vrr_stack+1287, vrr_stack+7787, vrr_stack+13988);
 _BUILD_h0q0(Data,vrr_stack+34001, vrr_stack+29906, vrr_stack+32636, vrr_stack+3151, vrr_stack+8333, vrr_stack+25460);
 _BUILD_h0q0(Data,vrr_stack+35912, vrr_stack+31271, vrr_stack+29906, vrr_stack+2106, vrr_stack+3151, vrr_stack+23120);
   tmp = vrr_stack + 35912;
   target_ptr = Libint->vrr_classes[5][12];
   for(i=0;i<1911;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2106, vrr_stack+468, vrr_stack+650, vrr_stack+16148, vrr_stack+16304, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2211, vrr_stack+559, vrr_stack+468, vrr_stack+16226, vrr_stack+16148, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2316, vrr_stack+650, vrr_stack+10912, vrr_stack+16304, vrr_stack+4240, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2421, vrr_stack+2106, vrr_stack+2316, NULL, NULL, vrr_stack+650);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2736, vrr_stack+2211, vrr_stack+2106, NULL, NULL, vrr_stack+468);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+25460, vrr_stack+2736, vrr_stack+2421, vrr_stack+2211, vrr_stack+2106, vrr_stack+741);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+741, vrr_stack+16382, vrr_stack+559, vrr_stack+4162, vrr_stack+16226, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+26090, vrr_stack+741, vrr_stack+2211, NULL, NULL, vrr_stack+559);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+13520, vrr_stack+26090, vrr_stack+2736, vrr_stack+741, vrr_stack+2211, vrr_stack+1014);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+846, vrr_stack+10912, vrr_stack+7613, vrr_stack+4240, vrr_stack+6065, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+4240, vrr_stack+2316, vrr_stack+846, NULL, NULL, vrr_stack+10912);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+14150, vrr_stack+2421, vrr_stack+4240, vrr_stack+2106, vrr_stack+2316, vrr_stack+1833);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+37823, vrr_stack+25460, vrr_stack+14150, vrr_stack+2736, vrr_stack+2421, vrr_stack+7787);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+38873, vrr_stack+13520, vrr_stack+25460, vrr_stack+26090, vrr_stack+2736, vrr_stack+1287);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+39923, vrr_stack+38873, vrr_stack+37823, vrr_stack+13520, vrr_stack+25460, vrr_stack+8333);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+951, vrr_stack+21560, vrr_stack+16382, vrr_stack+13442, vrr_stack+4162, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1056, vrr_stack+951, vrr_stack+741, NULL, NULL, vrr_stack+16382);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1371, vrr_stack+1056, vrr_stack+26090, vrr_stack+951, vrr_stack+741, vrr_stack+16473);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+7704, vrr_stack+1371, vrr_stack+13520, vrr_stack+1056, vrr_stack+26090, vrr_stack+17798);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+41498, vrr_stack+7704, vrr_stack+38873, vrr_stack+1371, vrr_stack+13520, vrr_stack+3151);
 _BUILD_00p0(Data,vrr_stack+17798, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+17801, vrr_stack+11003, vrr_stack+17798, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+17807, vrr_stack+11006, vrr_stack+17801, vrr_stack+5780, vrr_stack+11003, NULL);
 _BUILD_00g0(Data,vrr_stack+17817, vrr_stack+11012, vrr_stack+17807, vrr_stack+5783, vrr_stack+11006, NULL);
 _BUILD_00h0(Data,vrr_stack+17832, vrr_stack+11022, vrr_stack+17817, vrr_stack+5789, vrr_stack+11012, NULL);
 _BUILD_00i0(Data,vrr_stack+17853, vrr_stack+11037, vrr_stack+17832, vrr_stack+5799, vrr_stack+11022, NULL);
 _BUILD_00k0(Data,vrr_stack+17881, vrr_stack+11058, vrr_stack+17853, vrr_stack+5814, vrr_stack+11037, NULL);
 _BUILD_00l0(Data,vrr_stack+5780, vrr_stack+11086, vrr_stack+17881, vrr_stack+5835, vrr_stack+11058, NULL);
 _BUILD_00m0(Data,vrr_stack+17917, vrr_stack+7502, vrr_stack+5780, vrr_stack+5863, vrr_stack+11086, NULL);
 _BUILD_00n0(Data,vrr_stack+5825, vrr_stack+11122, vrr_stack+17917, vrr_stack+5899, vrr_stack+7502, NULL);
 _BUILD_00o0(Data,vrr_stack+13442, vrr_stack+7547, vrr_stack+5825, vrr_stack+5944, vrr_stack+11122, NULL);
 _BUILD_00q0(Data,vrr_stack+5891, vrr_stack+11177, vrr_stack+13442, vrr_stack+5999, vrr_stack+7547, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+17972, vrr_stack+7613, vrr_stack+5891, vrr_stack+6065, vrr_stack+11177, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+5982, vrr_stack+846, vrr_stack+17972, NULL, NULL, vrr_stack+7613);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+18077, vrr_stack+4240, vrr_stack+5982, vrr_stack+2316, vrr_stack+846, vrr_stack+11255);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1056, vrr_stack+14150, vrr_stack+18077, vrr_stack+2421, vrr_stack+4240, vrr_stack+11528);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+43073, vrr_stack+37823, vrr_stack+1056, vrr_stack+25460, vrr_stack+14150, vrr_stack+21651);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+44648, vrr_stack+39923, vrr_stack+43073, vrr_stack+38873, vrr_stack+37823, vrr_stack+32636);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+46853, vrr_stack+41498, vrr_stack+39923, vrr_stack+7704, vrr_stack+38873, vrr_stack+29906);
   tmp = vrr_stack + 46853;
   target_ptr = Libint->vrr_classes[5][13];
   for(i=0;i<2205;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+7704, vrr_stack+2106, vrr_stack+2316, vrr_stack+468, vrr_stack+650, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+7824, vrr_stack+2211, vrr_stack+2106, vrr_stack+559, vrr_stack+468, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+7944, vrr_stack+2316, vrr_stack+846, vrr_stack+650, vrr_stack+10912, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+8064, vrr_stack+7704, vrr_stack+7944, NULL, NULL, vrr_stack+2316);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+8424, vrr_stack+7824, vrr_stack+7704, NULL, NULL, vrr_stack+2106);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+32636, vrr_stack+8424, vrr_stack+8064, vrr_stack+7824, vrr_stack+7704, vrr_stack+2421);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2421, vrr_stack+741, vrr_stack+2211, vrr_stack+16382, vrr_stack+559, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+8784, vrr_stack+2421, vrr_stack+7824, NULL, NULL, vrr_stack+2211);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+21651, vrr_stack+8784, vrr_stack+8424, vrr_stack+2421, vrr_stack+7824, vrr_stack+2736);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2541, vrr_stack+846, vrr_stack+17972, vrr_stack+10912, vrr_stack+7613, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2661, vrr_stack+7944, vrr_stack+2541, NULL, NULL, vrr_stack+846);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+3021, vrr_stack+8064, vrr_stack+2661, vrr_stack+7704, vrr_stack+7944, vrr_stack+4240);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+49058, vrr_stack+32636, vrr_stack+3021, vrr_stack+8424, vrr_stack+8064, vrr_stack+14150);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+50258, vrr_stack+21651, vrr_stack+32636, vrr_stack+8784, vrr_stack+8424, vrr_stack+25460);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+51458, vrr_stack+50258, vrr_stack+49058, vrr_stack+21651, vrr_stack+32636, vrr_stack+37823);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+37823, vrr_stack+951, vrr_stack+741, vrr_stack+21560, vrr_stack+16382, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+37943, vrr_stack+37823, vrr_stack+2421, NULL, NULL, vrr_stack+741);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+14150, vrr_stack+37943, vrr_stack+8784, vrr_stack+37823, vrr_stack+2421, vrr_stack+26090);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+53258, vrr_stack+14150, vrr_stack+21651, vrr_stack+37943, vrr_stack+8784, vrr_stack+13520);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+54458, vrr_stack+53258, vrr_stack+50258, vrr_stack+14150, vrr_stack+21651, vrr_stack+38873);
 _BUILD_00p0(Data,vrr_stack+13520, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+13523, vrr_stack+17798, vrr_stack+13520, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+13529, vrr_stack+17801, vrr_stack+13523, vrr_stack+11003, vrr_stack+17798, NULL);
 _BUILD_00g0(Data,vrr_stack+13539, vrr_stack+17807, vrr_stack+13529, vrr_stack+11006, vrr_stack+17801, NULL);
 _BUILD_00h0(Data,vrr_stack+13554, vrr_stack+17817, vrr_stack+13539, vrr_stack+11012, vrr_stack+17807, NULL);
 _BUILD_00i0(Data,vrr_stack+13575, vrr_stack+17832, vrr_stack+13554, vrr_stack+11022, vrr_stack+17817, NULL);
 _BUILD_00k0(Data,vrr_stack+13603, vrr_stack+17853, vrr_stack+13575, vrr_stack+11037, vrr_stack+17832, NULL);
 _BUILD_00l0(Data,vrr_stack+13639, vrr_stack+17881, vrr_stack+13603, vrr_stack+11058, vrr_stack+17853, NULL);
 _BUILD_00m0(Data,vrr_stack+13684, vrr_stack+5780, vrr_stack+13639, vrr_stack+11086, vrr_stack+17881, NULL);
 _BUILD_00n0(Data,vrr_stack+13739, vrr_stack+17917, vrr_stack+13684, vrr_stack+7502, vrr_stack+5780, NULL);
 _BUILD_00o0(Data,vrr_stack+13805, vrr_stack+5825, vrr_stack+13739, vrr_stack+11122, vrr_stack+17917, NULL);
 _BUILD_00q0(Data,vrr_stack+21560, vrr_stack+13442, vrr_stack+13805, vrr_stack+7547, vrr_stack+5825, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+7502, vrr_stack+5891, vrr_stack+21560, vrr_stack+11177, vrr_stack+13442, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+13883, vrr_stack+17972, vrr_stack+7502, vrr_stack+7613, vrr_stack+5891, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+14003, vrr_stack+2541, vrr_stack+13883, NULL, NULL, vrr_stack+17972);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+14363, vrr_stack+2661, vrr_stack+14003, vrr_stack+7944, vrr_stack+2541, vrr_stack+5982);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+37943, vrr_stack+3021, vrr_stack+14363, vrr_stack+8064, vrr_stack+2661, vrr_stack+18077);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+56258, vrr_stack+49058, vrr_stack+37943, vrr_stack+32636, vrr_stack+3021, vrr_stack+1056);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+58058, vrr_stack+51458, vrr_stack+56258, vrr_stack+50258, vrr_stack+49058, vrr_stack+43073);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+60578, vrr_stack+54458, vrr_stack+51458, vrr_stack+53258, vrr_stack+50258, vrr_stack+39923);
   tmp = vrr_stack + 60578;
   target_ptr = Libint->vrr_classes[5][14];
   for(i=0;i<2520;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+53258, vrr_stack+7704, vrr_stack+7944, vrr_stack+2106, vrr_stack+2316, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+53394, vrr_stack+7824, vrr_stack+7704, vrr_stack+2211, vrr_stack+2106, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+53530, vrr_stack+7944, vrr_stack+2541, vrr_stack+2316, vrr_stack+846, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+53666, vrr_stack+53258, vrr_stack+53530, NULL, NULL, vrr_stack+7944);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+43073, vrr_stack+53394, vrr_stack+53258, NULL, NULL, vrr_stack+7704);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+43481, vrr_stack+43073, vrr_stack+53666, vrr_stack+53394, vrr_stack+53258, vrr_stack+8064);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+8064, vrr_stack+2421, vrr_stack+7824, vrr_stack+741, vrr_stack+2211, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+1056, vrr_stack+8064, vrr_stack+53394, NULL, NULL, vrr_stack+7824);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+1464, vrr_stack+1056, vrr_stack+43073, vrr_stack+8064, vrr_stack+53394, vrr_stack+8424);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+8200, vrr_stack+2541, vrr_stack+13883, vrr_stack+846, vrr_stack+17972, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+8336, vrr_stack+53530, vrr_stack+8200, NULL, NULL, vrr_stack+2541);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+25460, vrr_stack+53666, vrr_stack+8336, vrr_stack+53258, vrr_stack+53530, vrr_stack+2661);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+10912, vrr_stack+43481, vrr_stack+25460, vrr_stack+43073, vrr_stack+53666, vrr_stack+3021);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+2661, vrr_stack+1464, vrr_stack+43481, vrr_stack+1056, vrr_stack+43073, vrr_stack+32636);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+63098, vrr_stack+2661, vrr_stack+10912, vrr_stack+1464, vrr_stack+43481, vrr_stack+49058);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+49058, vrr_stack+37823, vrr_stack+2421, vrr_stack+951, vrr_stack+741, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+49194, vrr_stack+49058, vrr_stack+8064, NULL, NULL, vrr_stack+2421);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+32636, vrr_stack+49194, vrr_stack+1056, vrr_stack+49058, vrr_stack+8064, vrr_stack+8784);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+65138, vrr_stack+32636, vrr_stack+1464, vrr_stack+49194, vrr_stack+1056, vrr_stack+21651);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+66498, vrr_stack+65138, vrr_stack+2661, vrr_stack+32636, vrr_stack+1464, vrr_stack+50258);
 _BUILD_00p0(Data,vrr_stack+32636, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+32639, vrr_stack+13520, vrr_stack+32636, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+32645, vrr_stack+13523, vrr_stack+32639, vrr_stack+17798, vrr_stack+13520, NULL);
 _BUILD_00g0(Data,vrr_stack+12272, vrr_stack+13529, vrr_stack+32645, vrr_stack+17801, vrr_stack+13523, NULL);
 _BUILD_00h0(Data,vrr_stack+32655, vrr_stack+13539, vrr_stack+12272, vrr_stack+17807, vrr_stack+13529, NULL);
 _BUILD_00i0(Data,vrr_stack+32676, vrr_stack+13554, vrr_stack+32655, vrr_stack+17817, vrr_stack+13539, NULL);
 _BUILD_00k0(Data,vrr_stack+32704, vrr_stack+13575, vrr_stack+32676, vrr_stack+17832, vrr_stack+13554, NULL);
 _BUILD_00l0(Data,vrr_stack+17798, vrr_stack+13603, vrr_stack+32704, vrr_stack+17853, vrr_stack+13575, NULL);
 _BUILD_00m0(Data,vrr_stack+32740, vrr_stack+13639, vrr_stack+17798, vrr_stack+17881, vrr_stack+13603, NULL);
 _BUILD_00n0(Data,vrr_stack+17843, vrr_stack+13684, vrr_stack+32740, vrr_stack+5780, vrr_stack+13639, NULL);
 _BUILD_00o0(Data,vrr_stack+32795, vrr_stack+13739, vrr_stack+17843, vrr_stack+17917, vrr_stack+13684, NULL);
 _BUILD_00q0(Data,vrr_stack+32873, vrr_stack+13805, vrr_stack+32795, vrr_stack+5825, vrr_stack+13739, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+5780, vrr_stack+21560, vrr_stack+32873, vrr_stack+13442, vrr_stack+13805, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+32964, vrr_stack+7502, vrr_stack+5780, vrr_stack+5891, vrr_stack+21560, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+5885, vrr_stack+13883, vrr_stack+32964, vrr_stack+17972, vrr_stack+7502, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+6021, vrr_stack+8200, vrr_stack+5885, NULL, NULL, vrr_stack+13883);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+17909, vrr_stack+8336, vrr_stack+6021, vrr_stack+53530, vrr_stack+8200, vrr_stack+14003);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+21651, vrr_stack+25460, vrr_stack+17909, vrr_stack+53666, vrr_stack+8336, vrr_stack+14363);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+49194, vrr_stack+10912, vrr_stack+21651, vrr_stack+43481, vrr_stack+25460, vrr_stack+37943);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+68538, vrr_stack+63098, vrr_stack+49194, vrr_stack+2661, vrr_stack+10912, vrr_stack+56258);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+71394, vrr_stack+66498, vrr_stack+63098, vrr_stack+65138, vrr_stack+2661, vrr_stack+51458);
   tmp = vrr_stack + 71394;
   target_ptr = Libint->vrr_classes[5][15];
   for(i=0;i<2856;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+65138, vrr_stack+53258, vrr_stack+53530, vrr_stack+7704, vrr_stack+7944, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+65291, vrr_stack+53394, vrr_stack+53258, vrr_stack+7824, vrr_stack+7704, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+65444, vrr_stack+53530, vrr_stack+8200, vrr_stack+7944, vrr_stack+2541, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+65597, vrr_stack+65138, vrr_stack+65444, NULL, NULL, vrr_stack+53530);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+56258, vrr_stack+65291, vrr_stack+65138, NULL, NULL, vrr_stack+53258);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+56717, vrr_stack+56258, vrr_stack+65597, vrr_stack+65291, vrr_stack+65138, vrr_stack+53666);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+53530, vrr_stack+8064, vrr_stack+53394, vrr_stack+2421, vrr_stack+7824, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+53683, vrr_stack+53530, vrr_stack+65291, NULL, NULL, vrr_stack+53394);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+37943, vrr_stack+53683, vrr_stack+56258, vrr_stack+53530, vrr_stack+65291, vrr_stack+43073);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+65291, vrr_stack+8200, vrr_stack+5885, vrr_stack+2541, vrr_stack+13883, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+38861, vrr_stack+65444, vrr_stack+65291, NULL, NULL, vrr_stack+8200);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+14003, vrr_stack+65597, vrr_stack+38861, vrr_stack+65138, vrr_stack+65444, vrr_stack+8336);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+74250, vrr_stack+56717, vrr_stack+14003, vrr_stack+56258, vrr_stack+65597, vrr_stack+25460);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+75780, vrr_stack+37943, vrr_stack+56717, vrr_stack+53683, vrr_stack+56258, vrr_stack+43481);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+77310, vrr_stack+75780, vrr_stack+74250, vrr_stack+37943, vrr_stack+56717, vrr_stack+10912);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+65138, vrr_stack+49058, vrr_stack+8064, vrr_stack+37823, vrr_stack+2421, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+56258, vrr_stack+65138, vrr_stack+53530, NULL, NULL, vrr_stack+8064);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+10912, vrr_stack+56258, vrr_stack+53683, vrr_stack+65138, vrr_stack+53530, vrr_stack+1056);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+43073, vrr_stack+10912, vrr_stack+37943, vrr_stack+56258, vrr_stack+53683, vrr_stack+1464);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+43073, vrr_stack+75780, vrr_stack+10912, vrr_stack+37943, vrr_stack+2661);
 _BUILD_00p0(Data,vrr_stack+10912, Data->F+21, Data->F+22, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+10915, vrr_stack+32636, vrr_stack+10912, Data->F+20, Data->F+21, NULL);
 _BUILD_00f0(Data,vrr_stack+10921, vrr_stack+32639, vrr_stack+10915, vrr_stack+13520, vrr_stack+32636, NULL);
 _BUILD_00g0(Data,vrr_stack+10931, vrr_stack+32645, vrr_stack+10921, vrr_stack+13523, vrr_stack+32639, NULL);
 _BUILD_00h0(Data,vrr_stack+10946, vrr_stack+12272, vrr_stack+10931, vrr_stack+13529, vrr_stack+32645, NULL);
 _BUILD_00i0(Data,vrr_stack+10912, vrr_stack+32655, vrr_stack+10946, vrr_stack+13539, vrr_stack+12272, NULL);
 _BUILD_00k0(Data,vrr_stack+10940, vrr_stack+32676, vrr_stack+10912, vrr_stack+13554, vrr_stack+32655, NULL);
 _BUILD_00l0(Data,vrr_stack+44603, vrr_stack+32704, vrr_stack+10940, vrr_stack+13575, vrr_stack+32676, NULL);
 _BUILD_00m0(Data,vrr_stack+10912, vrr_stack+17798, vrr_stack+44603, vrr_stack+13603, vrr_stack+32704, NULL);
 _BUILD_00n0(Data,vrr_stack+10967, vrr_stack+32740, vrr_stack+10912, vrr_stack+13639, vrr_stack+17798, NULL);
 _BUILD_00o0(Data,vrr_stack+11033, vrr_stack+17843, vrr_stack+10967, vrr_stack+13684, vrr_stack+32740, NULL);
 _BUILD_00q0(Data,vrr_stack+10912, vrr_stack+32795, vrr_stack+11033, vrr_stack+13739, vrr_stack+17843, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+17798, vrr_stack+32873, vrr_stack+10912, vrr_stack+13805, vrr_stack+32795, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+10912, vrr_stack+5780, vrr_stack+17798, vrr_stack+21560, vrr_stack+32873, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+49058, vrr_stack+32964, vrr_stack+10912, vrr_stack+7502, vrr_stack+5780, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+65138, vrr_stack+5885, vrr_stack+49058, vrr_stack+13883, vrr_stack+32964, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+56258, vrr_stack+65291, vrr_stack+65138, NULL, NULL, vrr_stack+5885);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+7502, vrr_stack+38861, vrr_stack+56258, vrr_stack+65444, vrr_stack+65291, vrr_stack+6021);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+2295, vrr_stack+14003, vrr_stack+7502, vrr_stack+65597, vrr_stack+38861, vrr_stack+17909);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+79605, vrr_stack+74250, vrr_stack+2295, vrr_stack+56717, vrr_stack+14003, vrr_stack+21651);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+81900, vrr_stack+77310, vrr_stack+79605, vrr_stack+75780, vrr_stack+74250, vrr_stack+49194);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+85113, vrr_stack+0, vrr_stack+77310, vrr_stack+43073, vrr_stack+75780, vrr_stack+63098);
   tmp = vrr_stack + 85113;
   target_ptr = Libint->vrr_classes[5][16];
   for(i=0;i<3213;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0m0(Data,vrr_stack+43073, vrr_stack+12287, vrr_stack+4625, vrr_stack+10087, vrr_stack+9262, vrr_stack+6557);
   tmp = vrr_stack + 43073;
   target_ptr = Libint->vrr_classes[6][9];
   for(i=0;i<1540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0n0(Data,vrr_stack+74250, vrr_stack+20174, vrr_stack+18788, vrr_stack+16808, vrr_stack+15158, vrr_stack+4625);
   tmp = vrr_stack + 74250;
   target_ptr = Libint->vrr_classes[6][10];
   for(i=0;i<1848;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0o0(Data,vrr_stack+20174, vrr_stack+28268, vrr_stack+26630, vrr_stack+24290, vrr_stack+23120, vrr_stack+18788);
   tmp = vrr_stack + 20174;
   target_ptr = Libint->vrr_classes[6][11];
   for(i=0;i<2184;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0q0(Data,vrr_stack+22358, vrr_stack+35912, vrr_stack+34001, vrr_stack+31271, vrr_stack+29906, vrr_stack+26630);
   tmp = vrr_stack + 22358;
   target_ptr = Libint->vrr_classes[6][12];
   for(i=0;i<2548;i++)
     target_ptr[i] += tmp[i];
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+35912, vrr_stack+46853, vrr_stack+44648, vrr_stack+41498, vrr_stack+39923, vrr_stack+34001);
   tmp = vrr_stack + 35912;
   target_ptr = Libint->vrr_classes[6][13];
   for(i=0;i<2940;i++)
     target_ptr[i] += tmp[i];
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+46853, vrr_stack+60578, vrr_stack+58058, vrr_stack+54458, vrr_stack+51458, vrr_stack+44648);
   tmp = vrr_stack + 46853;
   target_ptr = Libint->vrr_classes[6][14];
   for(i=0;i<3360;i++)
     target_ptr[i] += tmp[i];
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+50213, vrr_stack+71394, vrr_stack+68538, vrr_stack+66498, vrr_stack+63098, vrr_stack+58058);
   tmp = vrr_stack + 50213;
   target_ptr = Libint->vrr_classes[6][15];
   for(i=0;i<3808;i++)
     target_ptr[i] += tmp[i];
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+54021, vrr_stack+85113, vrr_stack+81900, vrr_stack+0, vrr_stack+77310, vrr_stack+68538);
   tmp = vrr_stack + 54021;
   target_ptr = Libint->vrr_classes[6][16];
   for(i=0;i<4284;i++)
     target_ptr[i] += tmp[i];

}

