/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (k0|hf) integrals */

void vrr_order_k0hf(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+3, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+5, Data->F+6, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+15, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+18, vrr_stack+15, vrr_stack+12, NULL, NULL, Data->F+6);
 _BUILD_00p0(Data,vrr_stack+27, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+30, vrr_stack+27, vrr_stack+15, NULL, NULL, Data->F+5);
 _BUILD_00p0(Data,vrr_stack+39, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+42, vrr_stack+12, vrr_stack+39, NULL, NULL, Data->F+7);
 _BUILD_d0p0(Data,vrr_stack+51, vrr_stack+18, vrr_stack+42, vrr_stack+15, vrr_stack+12, vrr_stack+0);
 _BUILD_d0p0(Data,vrr_stack+69, vrr_stack+30, vrr_stack+18, vrr_stack+27, vrr_stack+15, vrr_stack+3);
 _BUILD_f0p0(Data,vrr_stack+87, vrr_stack+69, vrr_stack+51, vrr_stack+30, vrr_stack+18, vrr_stack+6);
 _BUILD_00d0(Data,vrr_stack+0, vrr_stack+15, vrr_stack+12, Data->F+5, Data->F+6, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+27, vrr_stack+15, Data->F+4, Data->F+5, NULL);
 _BUILD_00d0(Data,vrr_stack+117, vrr_stack+12, vrr_stack+39, Data->F+6, Data->F+7, NULL);
 _BUILD_p0d0(Data,vrr_stack+123, vrr_stack+0, vrr_stack+117, NULL, NULL, vrr_stack+12);
 _BUILD_p0d0(Data,vrr_stack+141, vrr_stack+6, vrr_stack+0, NULL, NULL, vrr_stack+15);
 _BUILD_d0d0(Data,vrr_stack+159, vrr_stack+141, vrr_stack+123, vrr_stack+6, vrr_stack+0, vrr_stack+18);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+18, vrr_stack+27, Data->F+3, Data->F+4, NULL);
 _BUILD_p0d0(Data,vrr_stack+195, vrr_stack+21, vrr_stack+6, NULL, NULL, vrr_stack+27);
 _BUILD_d0d0(Data,vrr_stack+213, vrr_stack+195, vrr_stack+141, vrr_stack+21, vrr_stack+6, vrr_stack+30);
 _BUILD_00p0(Data,vrr_stack+30, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+33, vrr_stack+39, vrr_stack+30, Data->F+7, Data->F+8, NULL);
 _BUILD_p0d0(Data,vrr_stack+249, vrr_stack+117, vrr_stack+33, NULL, NULL, vrr_stack+39);
 _BUILD_d0d0(Data,vrr_stack+267, vrr_stack+123, vrr_stack+249, vrr_stack+0, vrr_stack+117, vrr_stack+42);
 _BUILD_f0d0(Data,vrr_stack+303, vrr_stack+159, vrr_stack+267, vrr_stack+141, vrr_stack+123, vrr_stack+51);
 _BUILD_f0d0(Data,vrr_stack+363, vrr_stack+213, vrr_stack+159, vrr_stack+195, vrr_stack+141, vrr_stack+69);
 _BUILD_g0d0(Data,vrr_stack+423, vrr_stack+363, vrr_stack+303, vrr_stack+213, vrr_stack+159, vrr_stack+87);
 _BUILD_00f0(Data,vrr_stack+42, vrr_stack+0, vrr_stack+117, vrr_stack+15, vrr_stack+12, NULL);
 _BUILD_00f0(Data,vrr_stack+52, vrr_stack+6, vrr_stack+0, vrr_stack+27, vrr_stack+15, NULL);
 _BUILD_p0f0(Data,vrr_stack+62, vrr_stack+52, vrr_stack+42, NULL, NULL, vrr_stack+0);
 _BUILD_00f0(Data,vrr_stack+92, vrr_stack+21, vrr_stack+6, vrr_stack+18, vrr_stack+27, NULL);
 _BUILD_p0f0(Data,vrr_stack+513, vrr_stack+92, vrr_stack+52, NULL, NULL, vrr_stack+6);
 _BUILD_00f0(Data,vrr_stack+102, vrr_stack+117, vrr_stack+33, vrr_stack+12, vrr_stack+39, NULL);
 _BUILD_p0f0(Data,vrr_stack+543, vrr_stack+42, vrr_stack+102, NULL, NULL, vrr_stack+117);
 _BUILD_d0f0(Data,vrr_stack+573, vrr_stack+62, vrr_stack+543, vrr_stack+52, vrr_stack+42, vrr_stack+123);
 _BUILD_d0f0(Data,vrr_stack+633, vrr_stack+513, vrr_stack+62, vrr_stack+92, vrr_stack+52, vrr_stack+141);
 _BUILD_f0f0(Data,vrr_stack+693, vrr_stack+633, vrr_stack+573, vrr_stack+513, vrr_stack+62, vrr_stack+159);
 _BUILD_00p0(Data,vrr_stack+27, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+12, vrr_stack+27, vrr_stack+18, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+123, vrr_stack+12, vrr_stack+21, vrr_stack+27, vrr_stack+18, NULL);
 _BUILD_p0f0(Data,vrr_stack+133, vrr_stack+123, vrr_stack+92, NULL, NULL, vrr_stack+21);
 _BUILD_d0f0(Data,vrr_stack+793, vrr_stack+133, vrr_stack+513, vrr_stack+123, vrr_stack+92, vrr_stack+195);
 _BUILD_f0f0(Data,vrr_stack+853, vrr_stack+793, vrr_stack+633, vrr_stack+133, vrr_stack+513, vrr_stack+213);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+163, vrr_stack+30, vrr_stack+18, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+169, vrr_stack+33, vrr_stack+163, vrr_stack+39, vrr_stack+30, NULL);
 _BUILD_p0f0(Data,vrr_stack+179, vrr_stack+102, vrr_stack+169, NULL, NULL, vrr_stack+33);
 _BUILD_d0f0(Data,vrr_stack+953, vrr_stack+543, vrr_stack+179, vrr_stack+42, vrr_stack+102, vrr_stack+249);
 _BUILD_f0f0(Data,vrr_stack+1013, vrr_stack+573, vrr_stack+953, vrr_stack+62, vrr_stack+543, vrr_stack+267);
 _BUILD_g0f0(Data,vrr_stack+1113, vrr_stack+693, vrr_stack+1013, vrr_stack+633, vrr_stack+573, vrr_stack+303);
 _BUILD_g0f0(Data,vrr_stack+209, vrr_stack+853, vrr_stack+693, vrr_stack+793, vrr_stack+633, vrr_stack+363);
 _BUILD_h0f0(Data,vrr_stack+1263, vrr_stack+209, vrr_stack+1113, vrr_stack+853, vrr_stack+693, vrr_stack+423);
 _BUILD_00g0(Data,vrr_stack+359, vrr_stack+52, vrr_stack+42, vrr_stack+6, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+374, vrr_stack+92, vrr_stack+52, vrr_stack+21, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+389, vrr_stack+42, vrr_stack+102, vrr_stack+0, vrr_stack+117, NULL);
 _BUILD_p0g0(Data,vrr_stack+404, vrr_stack+359, vrr_stack+389, NULL, NULL, vrr_stack+42);
 _BUILD_p0g0(Data,vrr_stack+449, vrr_stack+374, vrr_stack+359, NULL, NULL, vrr_stack+52);
 _BUILD_d0g0(Data,vrr_stack+1473, vrr_stack+449, vrr_stack+404, vrr_stack+374, vrr_stack+359, vrr_stack+62);
 _BUILD_00g0(Data,vrr_stack+62, vrr_stack+123, vrr_stack+92, vrr_stack+12, vrr_stack+21, NULL);
 _BUILD_p0g0(Data,vrr_stack+1563, vrr_stack+62, vrr_stack+374, NULL, NULL, vrr_stack+92);
 _BUILD_d0g0(Data,vrr_stack+1608, vrr_stack+1563, vrr_stack+449, vrr_stack+62, vrr_stack+374, vrr_stack+513);
 _BUILD_00g0(Data,vrr_stack+77, vrr_stack+102, vrr_stack+169, vrr_stack+117, vrr_stack+33, NULL);
 _BUILD_p0g0(Data,vrr_stack+494, vrr_stack+389, vrr_stack+77, NULL, NULL, vrr_stack+102);
 _BUILD_d0g0(Data,vrr_stack+1698, vrr_stack+404, vrr_stack+494, vrr_stack+359, vrr_stack+389, vrr_stack+543);
 _BUILD_f0g0(Data,vrr_stack+1788, vrr_stack+1473, vrr_stack+1698, vrr_stack+449, vrr_stack+404, vrr_stack+573);
 _BUILD_f0g0(Data,vrr_stack+1938, vrr_stack+1608, vrr_stack+1473, vrr_stack+1563, vrr_stack+449, vrr_stack+633);
 _BUILD_g0g0(Data,vrr_stack+2088, vrr_stack+1938, vrr_stack+1788, vrr_stack+1608, vrr_stack+1473, vrr_stack+693);
 _BUILD_00p0(Data,vrr_stack+39, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+39, vrr_stack+27, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+0, vrr_stack+21, vrr_stack+12, vrr_stack+39, vrr_stack+27, NULL);
 _BUILD_00g0(Data,vrr_stack+539, vrr_stack+0, vrr_stack+123, vrr_stack+21, vrr_stack+12, NULL);
 _BUILD_p0g0(Data,vrr_stack+554, vrr_stack+539, vrr_stack+62, NULL, NULL, vrr_stack+123);
 _BUILD_d0g0(Data,vrr_stack+599, vrr_stack+554, vrr_stack+1563, vrr_stack+539, vrr_stack+62, vrr_stack+133);
 _BUILD_f0g0(Data,vrr_stack+2313, vrr_stack+599, vrr_stack+1608, vrr_stack+554, vrr_stack+1563, vrr_stack+793);
 _BUILD_g0g0(Data,vrr_stack+2463, vrr_stack+2313, vrr_stack+1938, vrr_stack+599, vrr_stack+1608, vrr_stack+853);
 _BUILD_00p0(Data,vrr_stack+27, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+133, vrr_stack+18, vrr_stack+27, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+139, vrr_stack+163, vrr_stack+133, vrr_stack+30, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+689, vrr_stack+169, vrr_stack+139, vrr_stack+33, vrr_stack+163, NULL);
 _BUILD_p0g0(Data,vrr_stack+704, vrr_stack+77, vrr_stack+689, NULL, NULL, vrr_stack+169);
 _BUILD_d0g0(Data,vrr_stack+749, vrr_stack+494, vrr_stack+704, vrr_stack+389, vrr_stack+77, vrr_stack+179);
 _BUILD_f0g0(Data,vrr_stack+2688, vrr_stack+1698, vrr_stack+749, vrr_stack+404, vrr_stack+494, vrr_stack+953);
 _BUILD_g0g0(Data,vrr_stack+2838, vrr_stack+1788, vrr_stack+2688, vrr_stack+1473, vrr_stack+1698, vrr_stack+1013);
 _BUILD_h0g0(Data,vrr_stack+3063, vrr_stack+2088, vrr_stack+2838, vrr_stack+1938, vrr_stack+1788, vrr_stack+1113);
 _BUILD_h0g0(Data,vrr_stack+839, vrr_stack+2463, vrr_stack+2088, vrr_stack+2313, vrr_stack+1938, vrr_stack+209);
 _BUILD_i0g0(Data,vrr_stack+3378, vrr_stack+839, vrr_stack+3063, vrr_stack+2463, vrr_stack+2088, vrr_stack+1263);
 _BUILD_00h0(Data,vrr_stack+179, vrr_stack+359, vrr_stack+389, vrr_stack+52, vrr_stack+42, NULL);
 _BUILD_00h0(Data,vrr_stack+200, vrr_stack+374, vrr_stack+359, vrr_stack+92, vrr_stack+52, NULL);
 _BUILD_p0h0(Data,vrr_stack+221, vrr_stack+200, vrr_stack+179, NULL, NULL, vrr_stack+359);
 _BUILD_00h0(Data,vrr_stack+284, vrr_stack+62, vrr_stack+374, vrr_stack+123, vrr_stack+92, NULL);
 _BUILD_p0h0(Data,vrr_stack+1154, vrr_stack+284, vrr_stack+200, NULL, NULL, vrr_stack+374);
 _BUILD_00h0(Data,vrr_stack+305, vrr_stack+389, vrr_stack+77, vrr_stack+42, vrr_stack+102, NULL);
 _BUILD_p0h0(Data,vrr_stack+1217, vrr_stack+179, vrr_stack+305, NULL, NULL, vrr_stack+389);
 _BUILD_d0h0(Data,vrr_stack+1280, vrr_stack+221, vrr_stack+1217, vrr_stack+200, vrr_stack+179, vrr_stack+404);
 _BUILD_d0h0(Data,vrr_stack+3798, vrr_stack+1154, vrr_stack+221, vrr_stack+284, vrr_stack+200, vrr_stack+449);
 _BUILD_f0h0(Data,vrr_stack+3924, vrr_stack+3798, vrr_stack+1280, vrr_stack+1154, vrr_stack+221, vrr_stack+1473);
 _BUILD_00h0(Data,vrr_stack+404, vrr_stack+539, vrr_stack+62, vrr_stack+0, vrr_stack+123, NULL);
 _BUILD_p0h0(Data,vrr_stack+425, vrr_stack+404, vrr_stack+284, NULL, NULL, vrr_stack+62);
 _BUILD_d0h0(Data,vrr_stack+1406, vrr_stack+425, vrr_stack+1154, vrr_stack+404, vrr_stack+284, vrr_stack+1563);
 _BUILD_f0h0(Data,vrr_stack+4134, vrr_stack+1406, vrr_stack+3798, vrr_stack+425, vrr_stack+1154, vrr_stack+1608);
 _BUILD_00h0(Data,vrr_stack+112, vrr_stack+77, vrr_stack+689, vrr_stack+102, vrr_stack+169, NULL);
 _BUILD_p0h0(Data,vrr_stack+1532, vrr_stack+305, vrr_stack+112, NULL, NULL, vrr_stack+77);
 _BUILD_d0h0(Data,vrr_stack+4344, vrr_stack+1217, vrr_stack+1532, vrr_stack+179, vrr_stack+305, vrr_stack+494);
 _BUILD_f0h0(Data,vrr_stack+4470, vrr_stack+1280, vrr_stack+4344, vrr_stack+221, vrr_stack+1217, vrr_stack+1698);
 _BUILD_g0h0(Data,vrr_stack+4680, vrr_stack+3924, vrr_stack+4470, vrr_stack+3798, vrr_stack+1280, vrr_stack+1788);
 _BUILD_g0h0(Data,vrr_stack+1595, vrr_stack+4134, vrr_stack+3924, vrr_stack+1406, vrr_stack+3798, vrr_stack+1938);
 _BUILD_h0h0(Data,vrr_stack+4995, vrr_stack+1595, vrr_stack+4680, vrr_stack+4134, vrr_stack+3924, vrr_stack+2088);
 _BUILD_00p0(Data,vrr_stack+488, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+491, vrr_stack+488, vrr_stack+39, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+497, vrr_stack+491, vrr_stack+21, vrr_stack+488, vrr_stack+39, NULL);
 _BUILD_00g0(Data,vrr_stack+507, vrr_stack+497, vrr_stack+0, vrr_stack+491, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+326, vrr_stack+507, vrr_stack+539, vrr_stack+497, vrr_stack+0, NULL);
 _BUILD_p0h0(Data,vrr_stack+1910, vrr_stack+326, vrr_stack+404, NULL, NULL, vrr_stack+539);
 _BUILD_d0h0(Data,vrr_stack+1973, vrr_stack+1910, vrr_stack+425, vrr_stack+326, vrr_stack+404, vrr_stack+554);
 _BUILD_f0h0(Data,vrr_stack+2099, vrr_stack+1973, vrr_stack+1406, vrr_stack+1910, vrr_stack+425, vrr_stack+599);
 _BUILD_g0h0(Data,vrr_stack+5436, vrr_stack+2099, vrr_stack+4134, vrr_stack+1973, vrr_stack+1406, vrr_stack+2313);
 _BUILD_h0h0(Data,vrr_stack+5751, vrr_stack+5436, vrr_stack+1595, vrr_stack+2099, vrr_stack+4134, vrr_stack+2463);
 _BUILD_00p0(Data,vrr_stack+1910, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+27, vrr_stack+1910, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+1913, vrr_stack+133, vrr_stack+21, vrr_stack+18, vrr_stack+27, NULL);
 _BUILD_00g0(Data,vrr_stack+1923, vrr_stack+139, vrr_stack+1913, vrr_stack+163, vrr_stack+133, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+689, vrr_stack+1923, vrr_stack+169, vrr_stack+139, NULL);
 _BUILD_p0h0(Data,vrr_stack+1938, vrr_stack+112, vrr_stack+0, NULL, NULL, vrr_stack+689);
 _BUILD_d0h0(Data,vrr_stack+2001, vrr_stack+1532, vrr_stack+1938, vrr_stack+305, vrr_stack+112, vrr_stack+704);
 _BUILD_f0h0(Data,vrr_stack+2127, vrr_stack+4344, vrr_stack+2001, vrr_stack+1217, vrr_stack+1532, vrr_stack+749);
 _BUILD_g0h0(Data,vrr_stack+2337, vrr_stack+4470, vrr_stack+2127, vrr_stack+1280, vrr_stack+4344, vrr_stack+2688);
 _BUILD_h0h0(Data,vrr_stack+6192, vrr_stack+4680, vrr_stack+2337, vrr_stack+3924, vrr_stack+4470, vrr_stack+2838);
 _BUILD_i0h0(Data,vrr_stack+6633, vrr_stack+4995, vrr_stack+6192, vrr_stack+1595, vrr_stack+4680, vrr_stack+3063);
 _BUILD_i0h0(Data,vrr_stack+2652, vrr_stack+5751, vrr_stack+4995, vrr_stack+5436, vrr_stack+1595, vrr_stack+839);
 _BUILD_00i0(Data,vrr_stack+5436, vrr_stack+179, vrr_stack+305, vrr_stack+359, vrr_stack+389, NULL);
 _BUILD_00i0(Data,vrr_stack+5464, vrr_stack+200, vrr_stack+179, vrr_stack+374, vrr_stack+359, NULL);
 _BUILD_p0i0(Data,vrr_stack+5492, vrr_stack+5464, vrr_stack+5436, NULL, NULL, vrr_stack+179);
 _BUILD_00i0(Data,vrr_stack+5576, vrr_stack+284, vrr_stack+200, vrr_stack+62, vrr_stack+374, NULL);
 _BUILD_p0i0(Data,vrr_stack+5604, vrr_stack+5576, vrr_stack+5464, NULL, NULL, vrr_stack+200);
 _BUILD_00i0(Data,vrr_stack+5688, vrr_stack+305, vrr_stack+112, vrr_stack+389, vrr_stack+77, NULL);
 _BUILD_p0i0(Data,vrr_stack+704, vrr_stack+5436, vrr_stack+5688, NULL, NULL, vrr_stack+305);
 _BUILD_d0i0(Data,vrr_stack+788, vrr_stack+5492, vrr_stack+704, vrr_stack+5464, vrr_stack+5436, vrr_stack+1217);
 _BUILD_d0i0(Data,vrr_stack+956, vrr_stack+5604, vrr_stack+5492, vrr_stack+5576, vrr_stack+5464, vrr_stack+221);
 _BUILD_f0i0(Data,vrr_stack+7221, vrr_stack+956, vrr_stack+788, vrr_stack+5604, vrr_stack+5492, vrr_stack+1280);
 _BUILD_00i0(Data,vrr_stack+221, vrr_stack+404, vrr_stack+284, vrr_stack+539, vrr_stack+62, NULL);
 _BUILD_p0i0(Data,vrr_stack+1217, vrr_stack+221, vrr_stack+5576, NULL, NULL, vrr_stack+284);
 _BUILD_d0i0(Data,vrr_stack+7501, vrr_stack+1217, vrr_stack+5604, vrr_stack+221, vrr_stack+5576, vrr_stack+1154);
 _BUILD_f0i0(Data,vrr_stack+7669, vrr_stack+7501, vrr_stack+956, vrr_stack+1217, vrr_stack+5604, vrr_stack+3798);
 _BUILD_00i0(Data,vrr_stack+3798, vrr_stack+112, vrr_stack+0, vrr_stack+77, vrr_stack+689, NULL);
 _BUILD_p0i0(Data,vrr_stack+3826, vrr_stack+5688, vrr_stack+3798, NULL, NULL, vrr_stack+112);
 _BUILD_d0i0(Data,vrr_stack+7949, vrr_stack+704, vrr_stack+3826, vrr_stack+5436, vrr_stack+5688, vrr_stack+1532);
 _BUILD_f0i0(Data,vrr_stack+8117, vrr_stack+788, vrr_stack+7949, vrr_stack+5492, vrr_stack+704, vrr_stack+4344);
 _BUILD_g0i0(Data,vrr_stack+8397, vrr_stack+7221, vrr_stack+8117, vrr_stack+956, vrr_stack+788, vrr_stack+4470);
 _BUILD_g0i0(Data,vrr_stack+8817, vrr_stack+7669, vrr_stack+7221, vrr_stack+7501, vrr_stack+956, vrr_stack+3924);
 _BUILD_h0i0(Data,vrr_stack+9237, vrr_stack+8817, vrr_stack+8397, vrr_stack+7669, vrr_stack+7221, vrr_stack+4680);
 _BUILD_00i0(Data,vrr_stack+4344, vrr_stack+326, vrr_stack+404, vrr_stack+507, vrr_stack+539, NULL);
 _BUILD_p0i0(Data,vrr_stack+4372, vrr_stack+4344, vrr_stack+221, NULL, NULL, vrr_stack+404);
 _BUILD_d0i0(Data,vrr_stack+4456, vrr_stack+4372, vrr_stack+1217, vrr_stack+4344, vrr_stack+221, vrr_stack+425);
 _BUILD_f0i0(Data,vrr_stack+4624, vrr_stack+4456, vrr_stack+7501, vrr_stack+4372, vrr_stack+1217, vrr_stack+1406);
 _BUILD_g0i0(Data,vrr_stack+9825, vrr_stack+4624, vrr_stack+7669, vrr_stack+4456, vrr_stack+7501, vrr_stack+4134);
 _BUILD_h0i0(Data,vrr_stack+10245, vrr_stack+9825, vrr_stack+8817, vrr_stack+4624, vrr_stack+7669, vrr_stack+1595);
 _BUILD_00p0(Data,vrr_stack+4372, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+4375, vrr_stack+1910, vrr_stack+4372, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+4381, vrr_stack+21, vrr_stack+4375, vrr_stack+27, vrr_stack+1910, NULL);
 _BUILD_00g0(Data,vrr_stack+27, vrr_stack+1913, vrr_stack+4381, vrr_stack+133, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+42, vrr_stack+1923, vrr_stack+27, vrr_stack+139, vrr_stack+1913, NULL);
 _BUILD_00i0(Data,vrr_stack+133, vrr_stack+0, vrr_stack+42, vrr_stack+689, vrr_stack+1923, NULL);
 _BUILD_p0i0(Data,vrr_stack+4391, vrr_stack+3798, vrr_stack+133, NULL, NULL, vrr_stack+0);
 _BUILD_d0i0(Data,vrr_stack+10833, vrr_stack+3826, vrr_stack+4391, vrr_stack+5688, vrr_stack+3798, vrr_stack+1938);
 _BUILD_f0i0(Data,vrr_stack+4475, vrr_stack+7949, vrr_stack+10833, vrr_stack+704, vrr_stack+3826, vrr_stack+2001);
 _BUILD_g0i0(Data,vrr_stack+3910, vrr_stack+8117, vrr_stack+4475, vrr_stack+788, vrr_stack+7949, vrr_stack+2127);
 _BUILD_h0i0(Data,vrr_stack+1301, vrr_stack+8397, vrr_stack+3910, vrr_stack+7221, vrr_stack+8117, vrr_stack+2337);
 _BUILD_i0i0(Data,vrr_stack+11001, vrr_stack+9237, vrr_stack+1301, vrr_stack+8817, vrr_stack+8397, vrr_stack+6192);
 _BUILD_i0i0(Data,vrr_stack+11785, vrr_stack+10245, vrr_stack+9237, vrr_stack+9825, vrr_stack+8817, vrr_stack+4995);
 _BUILD_00k0(Data,vrr_stack+9825, vrr_stack+5436, vrr_stack+5688, vrr_stack+179, vrr_stack+305, NULL);
 _BUILD_00k0(Data,vrr_stack+9861, vrr_stack+5464, vrr_stack+5436, vrr_stack+200, vrr_stack+179, NULL);
 _BUILD_p0k0(Data,vrr_stack+9897, vrr_stack+9861, vrr_stack+9825, NULL, NULL, vrr_stack+5436);
 _BUILD_00k0(Data,vrr_stack+10005, vrr_stack+5576, vrr_stack+5464, vrr_stack+284, vrr_stack+200, NULL);
 _BUILD_p0k0(Data,vrr_stack+10041, vrr_stack+10005, vrr_stack+9861, NULL, NULL, vrr_stack+5464);
 _BUILD_00k0(Data,vrr_stack+10149, vrr_stack+5688, vrr_stack+3798, vrr_stack+305, vrr_stack+112, NULL);
 _BUILD_p0k0(Data,vrr_stack+6192, vrr_stack+9825, vrr_stack+10149, NULL, NULL, vrr_stack+5688);
 _BUILD_d0k0(Data,vrr_stack+6300, vrr_stack+9897, vrr_stack+6192, vrr_stack+9861, vrr_stack+9825, vrr_stack+704);
 _BUILD_d0k0(Data,vrr_stack+1938, vrr_stack+10041, vrr_stack+9897, vrr_stack+10005, vrr_stack+9861, vrr_stack+5492);
 _BUILD_f0k0(Data,vrr_stack+2154, vrr_stack+1938, vrr_stack+6300, vrr_stack+10041, vrr_stack+9897, vrr_stack+788);
 _BUILD_00k0(Data,vrr_stack+5492, vrr_stack+221, vrr_stack+5576, vrr_stack+404, vrr_stack+284, NULL);
 _BUILD_p0k0(Data,vrr_stack+6516, vrr_stack+5492, vrr_stack+10005, NULL, NULL, vrr_stack+5576);
 _BUILD_d0k0(Data,vrr_stack+4755, vrr_stack+6516, vrr_stack+10041, vrr_stack+5492, vrr_stack+10005, vrr_stack+5604);
 _BUILD_f0k0(Data,vrr_stack+425, vrr_stack+4755, vrr_stack+1938, vrr_stack+6516, vrr_stack+10041, vrr_stack+956);
 _BUILD_00k0(Data,vrr_stack+5604, vrr_stack+3798, vrr_stack+133, vrr_stack+112, vrr_stack+0, NULL);
 _BUILD_p0k0(Data,vrr_stack+2514, vrr_stack+10149, vrr_stack+5604, NULL, NULL, vrr_stack+3798);
 _BUILD_d0k0(Data,vrr_stack+785, vrr_stack+6192, vrr_stack+2514, vrr_stack+9825, vrr_stack+10149, vrr_stack+3826);
 _BUILD_f0k0(Data,vrr_stack+12569, vrr_stack+6300, vrr_stack+785, vrr_stack+9897, vrr_stack+6192, vrr_stack+7949);
 _BUILD_g0k0(Data,vrr_stack+12929, vrr_stack+2154, vrr_stack+12569, vrr_stack+1938, vrr_stack+6300, vrr_stack+8117);
 _BUILD_g0k0(Data,vrr_stack+13469, vrr_stack+425, vrr_stack+2154, vrr_stack+4755, vrr_stack+1938, vrr_stack+7221);
 _BUILD_h0k0(Data,vrr_stack+14009, vrr_stack+13469, vrr_stack+12929, vrr_stack+425, vrr_stack+2154, vrr_stack+8397);
 _BUILD_00k0(Data,vrr_stack+7221, vrr_stack+4344, vrr_stack+221, vrr_stack+326, vrr_stack+404, NULL);
 _BUILD_p0k0(Data,vrr_stack+7257, vrr_stack+7221, vrr_stack+5492, NULL, NULL, vrr_stack+221);
 _BUILD_d0k0(Data,vrr_stack+1001, vrr_stack+7257, vrr_stack+6516, vrr_stack+7221, vrr_stack+5492, vrr_stack+1217);
 _BUILD_f0k0(Data,vrr_stack+7949, vrr_stack+1001, vrr_stack+4755, vrr_stack+7257, vrr_stack+6516, vrr_stack+7501);
 _BUILD_g0k0(Data,vrr_stack+14765, vrr_stack+7949, vrr_stack+425, vrr_stack+1001, vrr_stack+4755, vrr_stack+7669);
 _BUILD_h0k0(Data,vrr_stack+15305, vrr_stack+14765, vrr_stack+13469, vrr_stack+7949, vrr_stack+425, vrr_stack+8817);
 _BUILD_00p0(Data,vrr_stack+1001, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1004, vrr_stack+4372, vrr_stack+1001, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+1010, vrr_stack+4375, vrr_stack+1004, vrr_stack+1910, vrr_stack+4372, NULL);
 _BUILD_00g0(Data,vrr_stack+1020, vrr_stack+4381, vrr_stack+1010, vrr_stack+21, vrr_stack+4375, NULL);
 _BUILD_00h0(Data,vrr_stack+1035, vrr_stack+27, vrr_stack+1020, vrr_stack+1913, vrr_stack+4381, NULL);
 _BUILD_00i0(Data,vrr_stack+1056, vrr_stack+42, vrr_stack+1035, vrr_stack+1923, vrr_stack+27, NULL);
 _BUILD_00k0(Data,vrr_stack+1084, vrr_stack+133, vrr_stack+1056, vrr_stack+0, vrr_stack+42, NULL);
 _BUILD_p0k0(Data,vrr_stack+1120, vrr_stack+5604, vrr_stack+1084, NULL, NULL, vrr_stack+133);
 _BUILD_d0k0(Data,vrr_stack+7257, vrr_stack+2514, vrr_stack+1120, vrr_stack+10149, vrr_stack+5604, vrr_stack+4391);
 _BUILD_f0k0(Data,vrr_stack+7473, vrr_stack+785, vrr_stack+7257, vrr_stack+6192, vrr_stack+2514, vrr_stack+10833);
 _BUILD_g0k0(Data,vrr_stack+7833, vrr_stack+12569, vrr_stack+7473, vrr_stack+6300, vrr_stack+785, vrr_stack+4475);
 _BUILD_h0k0(Data,vrr_stack+8373, vrr_stack+12929, vrr_stack+7833, vrr_stack+2154, vrr_stack+12569, vrr_stack+3910);
 _BUILD_i0k0(Data,vrr_stack+16061, vrr_stack+14009, vrr_stack+8373, vrr_stack+13469, vrr_stack+12929, vrr_stack+1301);
 _BUILD_i0k0(Data,vrr_stack+17069, vrr_stack+15305, vrr_stack+14009, vrr_stack+14765, vrr_stack+13469, vrr_stack+9237);
 _BUILD_00l0(Data,vrr_stack+14765, vrr_stack+9825, vrr_stack+10149, vrr_stack+5436, vrr_stack+5688, NULL);
 _BUILD_00l0(Data,vrr_stack+14810, vrr_stack+9861, vrr_stack+9825, vrr_stack+5464, vrr_stack+5436, NULL);
 _BUILD_p0l0(Data,vrr_stack+14855, vrr_stack+14810, vrr_stack+14765, NULL, NULL, vrr_stack+9825);
 _BUILD_00l0(Data,vrr_stack+14990, vrr_stack+10005, vrr_stack+9861, vrr_stack+5576, vrr_stack+5464, NULL);
 _BUILD_p0l0(Data,vrr_stack+15035, vrr_stack+14990, vrr_stack+14810, NULL, NULL, vrr_stack+9861);
 _BUILD_00l0(Data,vrr_stack+9825, vrr_stack+10149, vrr_stack+5604, vrr_stack+5688, vrr_stack+3798, NULL);
 _BUILD_p0l0(Data,vrr_stack+15170, vrr_stack+14765, vrr_stack+9825, NULL, NULL, vrr_stack+10149);
 _BUILD_d0l0(Data,vrr_stack+4391, vrr_stack+14855, vrr_stack+15170, vrr_stack+14810, vrr_stack+14765, vrr_stack+6192);
 _BUILD_d0l0(Data,vrr_stack+1228, vrr_stack+15035, vrr_stack+14855, vrr_stack+14990, vrr_stack+14810, vrr_stack+9897);
 _BUILD_f0l0(Data,vrr_stack+3826, vrr_stack+1228, vrr_stack+4391, vrr_stack+15035, vrr_stack+14855, vrr_stack+6300);
 _BUILD_00l0(Data,vrr_stack+14810, vrr_stack+5492, vrr_stack+10005, vrr_stack+221, vrr_stack+5576, NULL);
 _BUILD_p0l0(Data,vrr_stack+9870, vrr_stack+14810, vrr_stack+14990, NULL, NULL, vrr_stack+10005);
 _BUILD_d0l0(Data,vrr_stack+6192, vrr_stack+9870, vrr_stack+15035, vrr_stack+14810, vrr_stack+14990, vrr_stack+10041);
 _BUILD_f0l0(Data,vrr_stack+18077, vrr_stack+6192, vrr_stack+1228, vrr_stack+9870, vrr_stack+15035, vrr_stack+1938);
 _BUILD_00l0(Data,vrr_stack+14990, vrr_stack+5604, vrr_stack+1084, vrr_stack+3798, vrr_stack+133, NULL);
 _BUILD_p0l0(Data,vrr_stack+15035, vrr_stack+9825, vrr_stack+14990, NULL, NULL, vrr_stack+5604);
 _BUILD_d0l0(Data,vrr_stack+1498, vrr_stack+15170, vrr_stack+15035, vrr_stack+14765, vrr_stack+9825, vrr_stack+2514);
 _BUILD_f0l0(Data,vrr_stack+18527, vrr_stack+4391, vrr_stack+1498, vrr_stack+14855, vrr_stack+15170, vrr_stack+785);
 _BUILD_g0l0(Data,vrr_stack+18977, vrr_stack+3826, vrr_stack+18527, vrr_stack+1228, vrr_stack+4391, vrr_stack+12569);
 _BUILD_g0l0(Data,vrr_stack+19652, vrr_stack+18077, vrr_stack+3826, vrr_stack+6192, vrr_stack+1228, vrr_stack+2154);
 _BUILD_h0l0(Data,vrr_stack+20327, vrr_stack+19652, vrr_stack+18977, vrr_stack+18077, vrr_stack+3826, vrr_stack+12929);
 _BUILD_00l0(Data,vrr_stack+14765, vrr_stack+7221, vrr_stack+5492, vrr_stack+4344, vrr_stack+221, NULL);
 _BUILD_p0l0(Data,vrr_stack+14855, vrr_stack+14765, vrr_stack+14810, NULL, NULL, vrr_stack+5492);
 _BUILD_d0l0(Data,vrr_stack+1228, vrr_stack+14855, vrr_stack+9870, vrr_stack+14765, vrr_stack+14810, vrr_stack+6516);
 _BUILD_f0l0(Data,vrr_stack+12569, vrr_stack+1228, vrr_stack+6192, vrr_stack+14855, vrr_stack+9870, vrr_stack+4755);
 _BUILD_g0l0(Data,vrr_stack+1768, vrr_stack+12569, vrr_stack+18077, vrr_stack+1228, vrr_stack+6192, vrr_stack+425);
 _BUILD_h0l0(Data,vrr_stack+21272, vrr_stack+1768, vrr_stack+19652, vrr_stack+12569, vrr_stack+18077, vrr_stack+13469);
 _BUILD_00p0(Data,vrr_stack+18077, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+18080, vrr_stack+1001, vrr_stack+18077, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+18086, vrr_stack+1004, vrr_stack+18080, vrr_stack+4372, vrr_stack+1001, NULL);
 _BUILD_00g0(Data,vrr_stack+18096, vrr_stack+1010, vrr_stack+18086, vrr_stack+4375, vrr_stack+1004, NULL);
 _BUILD_00h0(Data,vrr_stack+18111, vrr_stack+1020, vrr_stack+18096, vrr_stack+4381, vrr_stack+1010, NULL);
 _BUILD_00i0(Data,vrr_stack+3798, vrr_stack+1035, vrr_stack+18111, vrr_stack+27, vrr_stack+1020, NULL);
 _BUILD_00k0(Data,vrr_stack+7221, vrr_stack+1056, vrr_stack+3798, vrr_stack+42, vrr_stack+1035, NULL);
 _BUILD_00l0(Data,vrr_stack+18077, vrr_stack+1084, vrr_stack+7221, vrr_stack+133, vrr_stack+1056, NULL);
 _BUILD_p0l0(Data,vrr_stack+18122, vrr_stack+14990, vrr_stack+18077, NULL, NULL, vrr_stack+1084);
 _BUILD_d0l0(Data,vrr_stack+18257, vrr_stack+15035, vrr_stack+18122, vrr_stack+9825, vrr_stack+14990, vrr_stack+1120);
 _BUILD_f0l0(Data,vrr_stack+12569, vrr_stack+1498, vrr_stack+18257, vrr_stack+15170, vrr_stack+15035, vrr_stack+7257);
 _BUILD_g0l0(Data,vrr_stack+13019, vrr_stack+18527, vrr_stack+12569, vrr_stack+4391, vrr_stack+1498, vrr_stack+7473);
 _BUILD_h0l0(Data,vrr_stack+0, vrr_stack+18977, vrr_stack+13019, vrr_stack+3826, vrr_stack+18527, vrr_stack+7833);
 _BUILD_i0l0(Data,vrr_stack+12569, vrr_stack+20327, vrr_stack+0, vrr_stack+19652, vrr_stack+18977, vrr_stack+8373);
 _BUILD_i0l0(Data,vrr_stack+0, vrr_stack+21272, vrr_stack+20327, vrr_stack+1768, vrr_stack+19652, vrr_stack+14009);
 _BUILD_k0h0(Data,vrr_stack+1260, vrr_stack+2652, vrr_stack+6633, vrr_stack+5751, vrr_stack+4995, vrr_stack+3378);
   tmp = vrr_stack + 1260;
   target_ptr = Libint->vrr_classes[7][5];
   for(i=0;i<756;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0i0(Data,vrr_stack+2016, vrr_stack+11785, vrr_stack+11001, vrr_stack+10245, vrr_stack+9237, vrr_stack+6633);
   tmp = vrr_stack + 2016;
   target_ptr = Libint->vrr_classes[7][6];
   for(i=0;i<1008;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0k0(Data,vrr_stack+3024, vrr_stack+17069, vrr_stack+16061, vrr_stack+15305, vrr_stack+14009, vrr_stack+11001);
   tmp = vrr_stack + 3024;
   target_ptr = Libint->vrr_classes[7][7];
   for(i=0;i<1296;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0l0(Data,vrr_stack+17069, vrr_stack+0, vrr_stack+12569, vrr_stack+21272, vrr_stack+20327, vrr_stack+16061);
   tmp = vrr_stack + 17069;
   target_ptr = Libint->vrr_classes[7][8];
   for(i=0;i<1620;i++)
     target_ptr[i] += tmp[i];

}

