/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_d0hp(Libr12_t *, prim_data *);

  /* Computes (d0|hp) integrals for linear R12-methods */

void hrr_grt_order_d0hp(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->gvrr_classes[3][5] = int_stack + 0;
 Libr12->t2vrr_classes[2][5] = int_stack + 210;
 Libr12->t2vrr_classes[2][6] = int_stack + 336;
 Libr12->t1vrr_classes[2][5] = int_stack + 504;
 Libr12->t1vrr_classes[2][6] = int_stack + 630;
 Libr12->rvrr_classes[2][5] = int_stack + 798;
 Libr12->rvrr_classes[2][6] = int_stack + 924;
 Libr12->gvrr_classes[2][5] = int_stack + 1092;
 Libr12->gvrr_classes[2][6] = int_stack + 1218;
 memset(int_stack,0,1386*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 1386;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_d0hp(Libr12, Data);
   Data++;
 }

 /*--- compute (d0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+1386, int_stack+336, int_stack+210, int_stack+1218, int_stack+0, int_stack+1092, 2, 0);
     Libr12->te_ptr[3] = int_stack + 1386;
 /*--- compute (d0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+630, int_stack+504, 6);
     Libr12->te_ptr[2] = int_stack + 0;
 /*--- compute (d0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+378, int_stack+924, int_stack+798, 6);
     Libr12->te_ptr[1] = int_stack + 378;
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1764, int_stack+1218, int_stack+1092, 6);
     Libr12->te_ptr[0] = int_stack + 1764;

}
