/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_gdhh(Libr12_t *, prim_data *);

  /* Computes (gd|hh) integrals for linear R12-methods */

void hrr_grt_order_gdhh(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->t2vrr_classes[4][5] = int_stack + 0;
 Libr12->t2vrr_classes[4][6] = int_stack + 315;
 Libr12->t2vrr_classes[4][7] = int_stack + 735;
 Libr12->t2vrr_classes[4][8] = int_stack + 1275;
 Libr12->t2vrr_classes[4][9] = int_stack + 1950;
 Libr12->t2vrr_classes[4][10] = int_stack + 2775;
 Libr12->t2vrr_classes[5][5] = int_stack + 3765;
 Libr12->t2vrr_classes[5][6] = int_stack + 4206;
 Libr12->t2vrr_classes[5][7] = int_stack + 4794;
 Libr12->t2vrr_classes[5][8] = int_stack + 5550;
 Libr12->t2vrr_classes[5][9] = int_stack + 6495;
 Libr12->t2vrr_classes[5][10] = int_stack + 7650;
 Libr12->gvrr_classes[7][5] = int_stack + 9036;
 Libr12->t2vrr_classes[6][5] = int_stack + 9792;
 Libr12->gvrr_classes[7][6] = int_stack + 10380;
 Libr12->t2vrr_classes[6][6] = int_stack + 11388;
 Libr12->gvrr_classes[7][7] = int_stack + 12172;
 Libr12->t2vrr_classes[6][7] = int_stack + 13468;
 Libr12->gvrr_classes[7][8] = int_stack + 14476;
 Libr12->t2vrr_classes[6][8] = int_stack + 16096;
 Libr12->gvrr_classes[7][9] = int_stack + 17356;
 Libr12->t2vrr_classes[6][9] = int_stack + 19336;
 Libr12->t2vrr_classes[6][10] = int_stack + 20876;
 Libr12->gvrr_classes[4][11] = int_stack + 22724;
 Libr12->t1vrr_classes[4][5] = int_stack + 23894;
 Libr12->t1vrr_classes[4][6] = int_stack + 24209;
 Libr12->t1vrr_classes[4][7] = int_stack + 24629;
 Libr12->t1vrr_classes[4][8] = int_stack + 25169;
 Libr12->t1vrr_classes[4][9] = int_stack + 25844;
 Libr12->t1vrr_classes[4][10] = int_stack + 26669;
 Libr12->gvrr_classes[5][11] = int_stack + 27659;
 Libr12->t1vrr_classes[5][5] = int_stack + 29297;
 Libr12->t1vrr_classes[5][6] = int_stack + 29738;
 Libr12->t1vrr_classes[5][7] = int_stack + 30326;
 Libr12->t1vrr_classes[5][8] = int_stack + 31082;
 Libr12->t1vrr_classes[5][9] = int_stack + 32027;
 Libr12->t1vrr_classes[5][10] = int_stack + 33182;
 Libr12->t1vrr_classes[6][5] = int_stack + 34568;
 Libr12->t1vrr_classes[6][6] = int_stack + 35156;
 Libr12->t1vrr_classes[6][7] = int_stack + 35940;
 Libr12->t1vrr_classes[6][8] = int_stack + 36948;
 Libr12->t1vrr_classes[6][9] = int_stack + 38208;
 Libr12->t1vrr_classes[6][10] = int_stack + 39748;
 Libr12->rvrr_classes[4][5] = int_stack + 41596;
 Libr12->rvrr_classes[4][6] = int_stack + 41911;
 Libr12->rvrr_classes[4][7] = int_stack + 42331;
 Libr12->rvrr_classes[4][8] = int_stack + 42871;
 Libr12->rvrr_classes[4][9] = int_stack + 43546;
 Libr12->rvrr_classes[4][10] = int_stack + 44371;
 Libr12->rvrr_classes[5][5] = int_stack + 45361;
 Libr12->rvrr_classes[5][6] = int_stack + 45802;
 Libr12->rvrr_classes[5][7] = int_stack + 46390;
 Libr12->rvrr_classes[5][8] = int_stack + 47146;
 Libr12->rvrr_classes[5][9] = int_stack + 48091;
 Libr12->rvrr_classes[5][10] = int_stack + 49246;
 Libr12->rvrr_classes[6][5] = int_stack + 50632;
 Libr12->rvrr_classes[6][6] = int_stack + 51220;
 Libr12->rvrr_classes[6][7] = int_stack + 52004;
 Libr12->rvrr_classes[6][8] = int_stack + 53012;
 Libr12->rvrr_classes[6][9] = int_stack + 54272;
 Libr12->rvrr_classes[6][10] = int_stack + 55812;
 Libr12->gvrr_classes[4][5] = int_stack + 57660;
 Libr12->gvrr_classes[4][6] = int_stack + 57975;
 Libr12->gvrr_classes[4][7] = int_stack + 58395;
 Libr12->gvrr_classes[4][8] = int_stack + 58935;
 Libr12->gvrr_classes[4][9] = int_stack + 59610;
 Libr12->gvrr_classes[4][10] = int_stack + 60435;
 Libr12->gvrr_classes[5][5] = int_stack + 61425;
 Libr12->gvrr_classes[5][6] = int_stack + 61866;
 Libr12->gvrr_classes[5][7] = int_stack + 62454;
 Libr12->gvrr_classes[5][8] = int_stack + 63210;
 Libr12->gvrr_classes[5][9] = int_stack + 64155;
 Libr12->gvrr_classes[5][10] = int_stack + 65310;
 Libr12->gvrr_classes[6][5] = int_stack + 66696;
 Libr12->gvrr_classes[6][6] = int_stack + 67284;
 Libr12->gvrr_classes[6][7] = int_stack + 68068;
 Libr12->gvrr_classes[6][8] = int_stack + 69076;
 Libr12->gvrr_classes[6][9] = int_stack + 70336;
 Libr12->gvrr_classes[6][10] = int_stack + 71876;
 memset(int_stack,0,73724*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 73724;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_gdhh(Libr12, Data);
   Data++;
 }

 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+73724, int_stack+57975, int_stack+57660, 15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+74669, int_stack+58395, int_stack+57975, 15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+75929, int_stack+74669, int_stack+73724, 15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+77819, int_stack+58935, int_stack+58395, 15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+79439, int_stack+77819, int_stack+74669, 15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+81959, int_stack+79439, int_stack+75929, 15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+85109, int_stack+59610, int_stack+58935, 15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+87134, int_stack+85109, int_stack+77819, 15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+90374, int_stack+87134, int_stack+79439, 15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+94574, int_stack+90374, int_stack+81959, 15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+99299, int_stack+61866, int_stack+61425, 21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+100622, int_stack+62454, int_stack+61866, 21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+102386, int_stack+100622, int_stack+99299, 21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+105032, int_stack+63210, int_stack+62454, 21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+107300, int_stack+105032, int_stack+100622, 21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+110828, int_stack+107300, int_stack+102386, 21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+115238, int_stack+64155, int_stack+63210, 21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+118073, int_stack+115238, int_stack+105032, 21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+122609, int_stack+118073, int_stack+107300, 21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+128489, int_stack+122609, int_stack+110828, 21);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+135104, int_stack+60435, int_stack+59610, 15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+137579, int_stack+135104, int_stack+85109, 15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+141629, int_stack+137579, int_stack+87134, 15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+147029, int_stack+141629, int_stack+90374, 15);
 /*--- compute (g0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+153329, int_stack+315, int_stack+0, int_stack+57975, int_stack+61425, int_stack+57660, 4, 0);
 /*--- compute (g0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+154274, int_stack+735, int_stack+315, int_stack+58395, int_stack+61866, int_stack+57975, 4, 0);
 /*--- compute (g0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+155534, int_stack+154274, int_stack+153329, int_stack+74669, int_stack+99299, int_stack+73724, 4, 0);
 /*--- compute (g0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+157424, int_stack+1275, int_stack+735, int_stack+58935, int_stack+62454, int_stack+58395, 4, 0);
 /*--- compute (g0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+159044, int_stack+157424, int_stack+154274, int_stack+77819, int_stack+100622, int_stack+74669, 4, 0);
 /*--- compute (g0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+161564, int_stack+159044, int_stack+155534, int_stack+79439, int_stack+102386, int_stack+75929, 4, 0);
 /*--- compute (g0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+73724, int_stack+1950, int_stack+1275, int_stack+59610, int_stack+63210, int_stack+58935, 4, 0);
 /*--- compute (g0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+153329, int_stack+73724, int_stack+157424, int_stack+85109, int_stack+105032, int_stack+77819, 4, 0);
 /*--- compute (g0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+164714, int_stack+153329, int_stack+159044, int_stack+87134, int_stack+107300, int_stack+79439, 4, 0);
 /*--- compute (g0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+75749, int_stack+164714, int_stack+161564, int_stack+90374, int_stack+110828, int_stack+81959, 4, 0);
 /*--- compute (g0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+80474, int_stack+2775, int_stack+1950, int_stack+60435, int_stack+64155, int_stack+59610, 4, 0);
 /*--- compute (g0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+156569, int_stack+80474, int_stack+73724, int_stack+135104, int_stack+115238, int_stack+85109, 4, 0);
 /*--- compute (g0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+80474, int_stack+156569, int_stack+153329, int_stack+137579, int_stack+118073, int_stack+87134, 4, 0);
 /*--- compute (g0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+153329, int_stack+80474, int_stack+164714, int_stack+141629, int_stack+122609, int_stack+90374, 4, 0);
 /*--- compute (g0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+80474, int_stack+153329, int_stack+75749, int_stack+147029, int_stack+128489, int_stack+94574, 4, 0);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+153329, int_stack+67284, int_stack+66696, 28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+155093, int_stack+68068, int_stack+67284, 28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+157445, int_stack+155093, int_stack+153329, 28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+160973, int_stack+69076, int_stack+68068, 28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+163997, int_stack+160973, int_stack+155093, 28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+87089, int_stack+163997, int_stack+157445, 28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+73724, int_stack+70336, int_stack+69076, 28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+168701, int_stack+73724, int_stack+160973, 28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+174749, int_stack+168701, int_stack+163997, 28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+182589, int_stack+174749, int_stack+87089, 28);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+65310, int_stack+64155, 21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+191409, int_stack+0, int_stack+115238, 21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+197079, int_stack+191409, int_stack+118073, 21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+204639, int_stack+197079, int_stack+122609, 21);
 /*--- compute (h0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+92969, int_stack+4206, int_stack+3765, int_stack+61866, int_stack+66696, int_stack+61425, 5, 0);
 /*--- compute (h0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+77504, int_stack+4794, int_stack+4206, int_stack+62454, int_stack+67284, int_stack+61866, 5, 0);
 /*--- compute (h0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+57660, int_stack+77504, int_stack+92969, int_stack+100622, int_stack+153329, int_stack+99299, 5, 0);
 /*--- compute (h0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+213459, int_stack+5550, int_stack+4794, int_stack+63210, int_stack+68068, int_stack+62454, 5, 0);
 /*--- compute (h0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+215727, int_stack+213459, int_stack+77504, int_stack+105032, int_stack+155093, int_stack+100622, 5, 0);
 /*--- compute (h0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+219255, int_stack+215727, int_stack+57660, int_stack+107300, int_stack+157445, int_stack+102386, 5, 0);
 /*--- compute (h0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+77504, int_stack+6495, int_stack+5550, int_stack+64155, int_stack+69076, int_stack+63210, 5, 0);
 /*--- compute (h0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+99299, int_stack+77504, int_stack+213459, int_stack+115238, int_stack+160973, int_stack+105032, 5, 0);
 /*--- compute (h0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+223665, int_stack+99299, int_stack+215727, int_stack+118073, int_stack+163997, int_stack+107300, 5, 0);
 /*--- compute (h0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+103835, int_stack+223665, int_stack+219255, int_stack+122609, int_stack+87089, int_stack+110828, 5, 0);
 /*--- compute (h0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+213459, int_stack+7650, int_stack+6495, int_stack+65310, int_stack+70336, int_stack+64155, 5, 0);
 /*--- compute (h0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+216924, int_stack+213459, int_stack+77504, int_stack+0, int_stack+73724, int_stack+115238, 5, 0);
 /*--- compute (h0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+110450, int_stack+216924, int_stack+99299, int_stack+191409, int_stack+168701, int_stack+118073, 5, 0);
 /*--- compute (h0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+213459, int_stack+110450, int_stack+223665, int_stack+197079, int_stack+174749, int_stack+122609, 5, 0);
 /*--- compute (h0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+110450, int_stack+213459, int_stack+103835, int_stack+204639, int_stack+182589, int_stack+128489, 5, 0);
 /*--- compute (gp|[r12,T2]|hh) ---*/
   hrr1_build_gp(Libr12->ShellQuartet.AB,int_stack+213459, int_stack+110450, int_stack+80474, 441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+119711, int_stack+10380, int_stack+9036, 36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+121979, int_stack+12172, int_stack+10380, 36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+99299, int_stack+121979, int_stack+119711, 36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+103835, int_stack+14476, int_stack+12172, 36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+77504, int_stack+103835, int_stack+121979, 36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+233304, int_stack+77504, int_stack+99299, 36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+3465, int_stack+17356, int_stack+14476, 36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+240864, int_stack+3465, int_stack+103835, 36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+248640, int_stack+240864, int_stack+77504, 36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+258720, int_stack+248640, int_stack+233304, 36);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+270060, int_stack+71876, int_stack+70336, 28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+274680, int_stack+270060, int_stack+73724, 28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+282240, int_stack+274680, int_stack+168701, 28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+292320, int_stack+282240, int_stack+174749, 28);
 /*--- compute (i0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+125003, int_stack+11388, int_stack+9792, int_stack+67284, int_stack+9036, int_stack+66696, 6, 0);
 /*--- compute (i0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+107723, int_stack+13468, int_stack+11388, int_stack+68068, int_stack+10380, int_stack+67284, 6, 0);
 /*--- compute (i0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+83552, int_stack+107723, int_stack+125003, int_stack+155093, int_stack+119711, int_stack+153329, 6, 0);
 /*--- compute (i0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+125003, int_stack+16096, int_stack+13468, int_stack+69076, int_stack+12172, int_stack+68068, 6, 0);
 /*--- compute (i0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+8325, int_stack+125003, int_stack+107723, int_stack+160973, int_stack+121979, int_stack+155093, 6, 0);
 /*--- compute (i0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+304080, int_stack+8325, int_stack+83552, int_stack+163997, int_stack+99299, int_stack+157445, 6, 0);
 /*--- compute (i0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+99299, int_stack+19336, int_stack+16096, int_stack+70336, int_stack+14476, int_stack+69076, 6, 0);
 /*--- compute (i0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+153329, int_stack+99299, int_stack+125003, int_stack+73724, int_stack+103835, int_stack+160973, 6, 0);
 /*--- compute (i0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+119711, int_stack+153329, int_stack+8325, int_stack+168701, int_stack+77504, int_stack+163997, 6, 0);
 /*--- compute (i0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+77504, int_stack+119711, int_stack+304080, int_stack+174749, int_stack+233304, int_stack+87089, 6, 0);
 /*--- compute (i0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+233304, int_stack+20876, int_stack+19336, int_stack+71876, int_stack+17356, int_stack+70336, 6, 0);
 /*--- compute (i0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+86324, int_stack+233304, int_stack+99299, int_stack+270060, int_stack+3465, int_stack+73724, 6, 0);
 /*--- compute (i0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+3465, int_stack+86324, int_stack+153329, int_stack+274680, int_stack+240864, int_stack+168701, 6, 0);
 /*--- compute (i0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+153329, int_stack+3465, int_stack+119711, int_stack+282240, int_stack+248640, int_stack+174749, 6, 0);
 /*--- compute (i0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+3465, int_stack+153329, int_stack+77504, int_stack+292320, int_stack+258720, int_stack+182589, 6, 0);
 /*--- compute (hp|[r12,T2]|hh) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+153329, int_stack+3465, int_stack+110450, 441);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+3465, int_stack+147029, int_stack+94574, 15);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+10080, int_stack+204639, int_stack+128489, 21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libr12->ShellQuartet.AB,int_stack+233304, int_stack+10080, int_stack+3465, 441);
 /*--- compute (g0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+19341, int_stack+22724, int_stack+60435, 15);
 /*--- compute (g0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+253149, int_stack+19341, int_stack+135104, 15);
 /*--- compute (g0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+258099, int_stack+253149, int_stack+137579, 15);
 /*--- compute (g0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+264849, int_stack+258099, int_stack+141629, 15);
 /*--- compute (g0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+253149, int_stack+264849, int_stack+147029, 15);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+261969, int_stack+27659, int_stack+65310, 21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+266127, int_stack+261969, int_stack+0, 21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+273057, int_stack+266127, int_stack+191409, 21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+57660, int_stack+273057, int_stack+197079, 21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+191409, int_stack+57660, int_stack+204639, 21);
 /*--- compute (gp|ih) ---*/
   hrr1_build_gp(Libr12->ShellQuartet.AB,int_stack+57660, int_stack+191409, int_stack+253149, 588);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+84120, int_stack+292320, int_stack+182589, 28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+96468, int_stack+84120, int_stack+10080, 441);
 /*--- compute (g0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+124251, int_stack+24209, int_stack+23894, 15);
 /*--- compute (g0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+125196, int_stack+24629, int_stack+24209, 15);
 /*--- compute (g0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+126456, int_stack+125196, int_stack+124251, 15);
 /*--- compute (g0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+128346, int_stack+25169, int_stack+24629, 15);
 /*--- compute (g0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+129966, int_stack+128346, int_stack+125196, 15);
 /*--- compute (g0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+132486, int_stack+129966, int_stack+126456, 15);
 /*--- compute (g0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+124251, int_stack+25844, int_stack+25169, 15);
 /*--- compute (g0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+135636, int_stack+124251, int_stack+128346, 15);
 /*--- compute (g0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+138876, int_stack+135636, int_stack+129966, 15);
 /*--- compute (g0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+126276, int_stack+138876, int_stack+132486, 15);
 /*--- compute (g0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+131001, int_stack+26669, int_stack+25844, 15);
 /*--- compute (g0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+143076, int_stack+131001, int_stack+124251, 15);
 /*--- compute (g0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+147126, int_stack+143076, int_stack+135636, 15);
 /*--- compute (g0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+131001, int_stack+147126, int_stack+138876, 15);
 /*--- compute (g0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+137301, int_stack+131001, int_stack+126276, 15);
 /*--- compute (h0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+124251, int_stack+29738, int_stack+29297, 21);
 /*--- compute (h0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+125574, int_stack+30326, int_stack+29738, 21);
 /*--- compute (h0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+127338, int_stack+125574, int_stack+124251, 21);
 /*--- compute (h0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+129984, int_stack+31082, int_stack+30326, 21);
 /*--- compute (h0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+132252, int_stack+129984, int_stack+125574, 21);
 /*--- compute (h0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+143916, int_stack+132252, int_stack+127338, 21);
 /*--- compute (h0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+124251, int_stack+32027, int_stack+31082, 21);
 /*--- compute (h0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+148326, int_stack+124251, int_stack+129984, 21);
 /*--- compute (h0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+203757, int_stack+148326, int_stack+132252, 21);
 /*--- compute (h0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+127086, int_stack+203757, int_stack+143916, 21);
 /*--- compute (h0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+33182, int_stack+32027, 21);
 /*--- compute (h0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+261969, int_stack+0, int_stack+124251, 21);
 /*--- compute (h0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+267639, int_stack+261969, int_stack+148326, 21);
 /*--- compute (h0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+143916, int_stack+267639, int_stack+203757, 21);
 /*--- compute (h0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+203757, int_stack+143916, int_stack+127086, 21);
 /*--- compute (gp|[r12,T1]|hh) ---*/
   t1hrr1_build_gp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+261969, int_stack+203757, int_stack+137301, int_stack+10080, int_stack+253149, int_stack+3465, 5, 5);
 /*--- compute (i0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+253149, int_stack+35156, int_stack+34568, 28);
 /*--- compute (i0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+254913, int_stack+35940, int_stack+35156, 28);
 /*--- compute (i0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+257265, int_stack+254913, int_stack+253149, 28);
 /*--- compute (i0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+281814, int_stack+36948, int_stack+35940, 28);
 /*--- compute (i0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+284838, int_stack+281814, int_stack+254913, 28);
 /*--- compute (i0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+289542, int_stack+284838, int_stack+257265, 28);
 /*--- compute (i0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+253149, int_stack+38208, int_stack+36948, 28);
 /*--- compute (i0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+295422, int_stack+253149, int_stack+281814, 28);
 /*--- compute (i0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+301470, int_stack+295422, int_stack+284838, 28);
 /*--- compute (i0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+124251, int_stack+301470, int_stack+289542, 28);
 /*--- compute (i0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+281814, int_stack+39748, int_stack+38208, 28);
 /*--- compute (i0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+286434, int_stack+281814, int_stack+253149, 28);
 /*--- compute (i0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+0, int_stack+286434, int_stack+295422, 28);
 /*--- compute (i0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+281814, int_stack+0, int_stack+301470, 28);
 /*--- compute (i0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+293574, int_stack+281814, int_stack+124251, 28);
 /*--- compute (hp|[r12,T1]|hh) ---*/
   t1hrr1_build_hp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+124251, int_stack+293574, int_stack+203757, int_stack+84120, int_stack+191409, int_stack+10080, 5, 5);
 /*--- compute (g0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+84120, int_stack+41911, int_stack+41596, 15);
 /*--- compute (g0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+85065, int_stack+42331, int_stack+41911, 15);
 /*--- compute (g0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+86325, int_stack+85065, int_stack+84120, 15);
 /*--- compute (g0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+88215, int_stack+42871, int_stack+42331, 15);
 /*--- compute (g0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+89835, int_stack+88215, int_stack+85065, 15);
 /*--- compute (g0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+92355, int_stack+89835, int_stack+86325, 15);
 /*--- compute (g0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+84120, int_stack+43546, int_stack+42871, 15);
 /*--- compute (g0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+281814, int_stack+84120, int_stack+88215, 15);
 /*--- compute (g0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+285054, int_stack+281814, int_stack+89835, 15);
 /*--- compute (g0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+86145, int_stack+285054, int_stack+92355, 15);
 /*--- compute (g0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+90870, int_stack+44371, int_stack+43546, 15);
 /*--- compute (g0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+289254, int_stack+90870, int_stack+84120, 15);
 /*--- compute (g0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+90870, int_stack+289254, int_stack+281814, 15);
 /*--- compute (g0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+289254, int_stack+90870, int_stack+285054, 15);
 /*--- compute (g0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+281814, int_stack+289254, int_stack+86145, 15);
 /*--- compute (h0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+288429, int_stack+45802, int_stack+45361, 21);
 /*--- compute (h0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+289752, int_stack+46390, int_stack+45802, 21);
 /*--- compute (h0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+291516, int_stack+289752, int_stack+288429, 21);
 /*--- compute (h0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+294162, int_stack+47146, int_stack+46390, 21);
 /*--- compute (h0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+296430, int_stack+294162, int_stack+289752, 21);
 /*--- compute (h0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+299958, int_stack+296430, int_stack+291516, 21);
 /*--- compute (h0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+288429, int_stack+48091, int_stack+47146, 21);
 /*--- compute (h0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+304368, int_stack+288429, int_stack+294162, 21);
 /*--- compute (h0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+84120, int_stack+304368, int_stack+296430, 21);
 /*--- compute (h0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+291264, int_stack+84120, int_stack+299958, 21);
 /*--- compute (h0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+297879, int_stack+49246, int_stack+48091, 21);
 /*--- compute (h0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+90000, int_stack+297879, int_stack+288429, 21);
 /*--- compute (h0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+0, int_stack+90000, int_stack+304368, 21);
 /*--- compute (h0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+253149, int_stack+0, int_stack+84120, 21);
 /*--- compute (h0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+84120, int_stack+253149, int_stack+291264, 21);
 /*--- compute (gp||hh) ---*/
   hrr1_build_gp(Libr12->ShellQuartet.AB,int_stack+0, int_stack+84120, int_stack+281814, 441);
 /*--- compute (i0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+281814, int_stack+51220, int_stack+50632, 28);
 /*--- compute (i0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+283578, int_stack+52004, int_stack+51220, 28);
 /*--- compute (i0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+285930, int_stack+283578, int_stack+281814, 28);
 /*--- compute (i0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+289458, int_stack+53012, int_stack+52004, 28);
 /*--- compute (i0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+292482, int_stack+289458, int_stack+283578, 28);
 /*--- compute (i0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+297186, int_stack+292482, int_stack+285930, 28);
 /*--- compute (i0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+281814, int_stack+54272, int_stack+53012, 28);
 /*--- compute (i0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+303066, int_stack+281814, int_stack+289458, 28);
 /*--- compute (i0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+253149, int_stack+303066, int_stack+292482, 28);
 /*--- compute (i0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+285594, int_stack+253149, int_stack+297186, 28);
 /*--- compute (i0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+294414, int_stack+55812, int_stack+54272, 28);
 /*--- compute (i0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+19845, int_stack+294414, int_stack+281814, 28);
 /*--- compute (i0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+27405, int_stack+19845, int_stack+303066, 28);
 /*--- compute (i0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+294414, int_stack+27405, int_stack+253149, 28);
 /*--- compute (i0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+19845, int_stack+294414, int_stack+285594, 28);
 /*--- compute (hp||hh) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+281814, int_stack+19845, int_stack+84120, 441);
 /*--- compute (gd|[r12,T2]|hh) ---*/
   hrr1_build_gd(Libr12->ShellQuartet.AB,int_stack+309597, int_stack+153329, int_stack+213459, 441);
     Libr12->te_ptr[3] = int_stack + 309597;
 /*--- compute (gd|[r12,T1]|hh) ---*/
   t1hrr1_build_gd(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+152034, int_stack+124251, int_stack+261969, int_stack+96468, int_stack+57660, int_stack+233304, 5, 5);
     Libr12->te_ptr[2] = int_stack + 152034;
 /*--- compute (gd||hh) ---*/
   hrr1_build_gd(Libr12->ShellQuartet.AB,int_stack+19845, int_stack+281814, int_stack+0, 441);
     Libr12->te_ptr[1] = int_stack + 19845;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libr12->ShellQuartet.AB,int_stack+253149, int_stack+96468, int_stack+233304, 441);
     Libr12->te_ptr[0] = int_stack + 253149;

}
