/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (gs||ks) integrals */

#include <libint/libint.h>
#include "libr12.h"

REALTYPE *_r_build_g0k0_0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE seveno4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  seveno4zn = 7.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (threeo2z)*I1[0] - (threeo4zn)*I4[0] - (seveno4zn)*I5[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1]
        + (threeo2z)*I1[1] - (threeo4zn)*I4[1] - (sixo4zn)*I5[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2]
        + (threeo2z)*I1[2] - (threeo4zn)*I4[2] - (sixo4zn)*I5[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3]
        + (threeo2z)*I1[3] - (threeo4zn)*I4[3] - (fiveo4zn)*I5[3];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4]
        + (threeo2z)*I1[4] - (threeo4zn)*I4[4] - (fiveo4zn)*I5[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5]
        + (threeo2z)*I1[5] - (threeo4zn)*I4[5] - (fiveo4zn)*I5[5];
*(vp++) = U00*I0[6] - U10*I3[6] + loo2p*I2[6]
        + (threeo2z)*I1[6] - (threeo4zn)*I4[6] - (fouro4zn)*I5[6];
*(vp++) = U00*I0[7] - U10*I3[7] + loo2p*I2[7]
        + (threeo2z)*I1[7] - (threeo4zn)*I4[7] - (fouro4zn)*I5[7];
*(vp++) = U00*I0[8] - U10*I3[8] + loo2p*I2[8]
        + (threeo2z)*I1[8] - (threeo4zn)*I4[8] - (fouro4zn)*I5[8];
*(vp++) = U00*I0[9] - U10*I3[9] + loo2p*I2[9]
        + (threeo2z)*I1[9] - (threeo4zn)*I4[9] - (fouro4zn)*I5[9];
*(vp++) = U00*I0[10] - U10*I3[10] + loo2p*I2[10]
        + (threeo2z)*I1[10] - (threeo4zn)*I4[10] - (threeo4zn)*I5[10];
*(vp++) = U00*I0[11] - U10*I3[11] + loo2p*I2[11]
        + (threeo2z)*I1[11] - (threeo4zn)*I4[11] - (threeo4zn)*I5[11];
*(vp++) = U00*I0[12] - U10*I3[12] + loo2p*I2[12]
        + (threeo2z)*I1[12] - (threeo4zn)*I4[12] - (threeo4zn)*I5[12];
*(vp++) = U00*I0[13] - U10*I3[13] + loo2p*I2[13]
        + (threeo2z)*I1[13] - (threeo4zn)*I4[13] - (threeo4zn)*I5[13];
*(vp++) = U00*I0[14] - U10*I3[14] + loo2p*I2[14]
        + (threeo2z)*I1[14] - (threeo4zn)*I4[14] - (threeo4zn)*I5[14];
*(vp++) = U00*I0[15] - U10*I3[15] + loo2p*I2[15]
        + (threeo2z)*I1[15] - (threeo4zn)*I4[15] - (twoo4zn)*I5[15];
*(vp++) = U00*I0[16] - U10*I3[16] + loo2p*I2[16]
        + (threeo2z)*I1[16] - (threeo4zn)*I4[16] - (twoo4zn)*I5[16];
*(vp++) = U00*I0[17] - U10*I3[17] + loo2p*I2[17]
        + (threeo2z)*I1[17] - (threeo4zn)*I4[17] - (twoo4zn)*I5[17];
*(vp++) = U00*I0[18] - U10*I3[18] + loo2p*I2[18]
        + (threeo2z)*I1[18] - (threeo4zn)*I4[18] - (twoo4zn)*I5[18];
*(vp++) = U00*I0[19] - U10*I3[19] + loo2p*I2[19]
        + (threeo2z)*I1[19] - (threeo4zn)*I4[19] - (twoo4zn)*I5[19];
*(vp++) = U00*I0[20] - U10*I3[20] + loo2p*I2[20]
        + (threeo2z)*I1[20] - (threeo4zn)*I4[20] - (twoo4zn)*I5[20];
*(vp++) = U00*I0[21] - U10*I3[21] + loo2p*I2[21]
        + (threeo2z)*I1[21] - (threeo4zn)*I4[21] - (oneo4zn)*I5[21];
*(vp++) = U00*I0[22] - U10*I3[22] + loo2p*I2[22]
        + (threeo2z)*I1[22] - (threeo4zn)*I4[22] - (oneo4zn)*I5[22];
*(vp++) = U00*I0[23] - U10*I3[23] + loo2p*I2[23]
        + (threeo2z)*I1[23] - (threeo4zn)*I4[23] - (oneo4zn)*I5[23];
*(vp++) = U00*I0[24] - U10*I3[24] + loo2p*I2[24]
        + (threeo2z)*I1[24] - (threeo4zn)*I4[24] - (oneo4zn)*I5[24];
*(vp++) = U00*I0[25] - U10*I3[25] + loo2p*I2[25]
        + (threeo2z)*I1[25] - (threeo4zn)*I4[25] - (oneo4zn)*I5[25];
*(vp++) = U00*I0[26] - U10*I3[26] + loo2p*I2[26]
        + (threeo2z)*I1[26] - (threeo4zn)*I4[26] - (oneo4zn)*I5[26];
*(vp++) = U00*I0[27] - U10*I3[27] + loo2p*I2[27]
        + (threeo2z)*I1[27] - (threeo4zn)*I4[27] - (oneo4zn)*I5[27];
*(vp++) = U00*I0[28] - U10*I3[28] + loo2p*I2[28]
        + (threeo2z)*I1[28] - (threeo4zn)*I4[28];
*(vp++) = U00*I0[29] - U10*I3[29] + loo2p*I2[29]
        + (threeo2z)*I1[29] - (threeo4zn)*I4[29];
*(vp++) = U00*I0[30] - U10*I3[30] + loo2p*I2[30]
        + (threeo2z)*I1[30] - (threeo4zn)*I4[30];
*(vp++) = U00*I0[31] - U10*I3[31] + loo2p*I2[31]
        + (threeo2z)*I1[31] - (threeo4zn)*I4[31];
*(vp++) = U00*I0[32] - U10*I3[32] + loo2p*I2[32]
        + (threeo2z)*I1[32] - (threeo4zn)*I4[32];
*(vp++) = U00*I0[33] - U10*I3[33] + loo2p*I2[33]
        + (threeo2z)*I1[33] - (threeo4zn)*I4[33];
*(vp++) = U00*I0[34] - U10*I3[34] + loo2p*I2[34]
        + (threeo2z)*I1[34] - (threeo4zn)*I4[34];
*(vp++) = U00*I0[35] - U10*I3[35] + loo2p*I2[35]
        + (threeo2z)*I1[35] - (threeo4zn)*I4[35];
*(vp++) = U00*I0[36] - U10*I3[36] + loo2p*I2[36]
        + (twoo2z)*I1[36] - (twoo4zn)*I4[36] - (seveno4zn)*I5[28];
*(vp++) = U00*I0[37] - U10*I3[37] + loo2p*I2[37]
        + (twoo2z)*I1[37] - (twoo4zn)*I4[37] - (sixo4zn)*I5[29];
*(vp++) = U00*I0[38] - U10*I3[38] + loo2p*I2[38]
        + (twoo2z)*I1[38] - (twoo4zn)*I4[38] - (sixo4zn)*I5[30];
*(vp++) = U00*I0[39] - U10*I3[39] + loo2p*I2[39]
        + (twoo2z)*I1[39] - (twoo4zn)*I4[39] - (fiveo4zn)*I5[31];
*(vp++) = U00*I0[40] - U10*I3[40] + loo2p*I2[40]
        + (twoo2z)*I1[40] - (twoo4zn)*I4[40] - (fiveo4zn)*I5[32];
*(vp++) = U00*I0[41] - U10*I3[41] + loo2p*I2[41]
        + (twoo2z)*I1[41] - (twoo4zn)*I4[41] - (fiveo4zn)*I5[33];
*(vp++) = U00*I0[42] - U10*I3[42] + loo2p*I2[42]
        + (twoo2z)*I1[42] - (twoo4zn)*I4[42] - (fouro4zn)*I5[34];
*(vp++) = U00*I0[43] - U10*I3[43] + loo2p*I2[43]
        + (twoo2z)*I1[43] - (twoo4zn)*I4[43] - (fouro4zn)*I5[35];
*(vp++) = U00*I0[44] - U10*I3[44] + loo2p*I2[44]
        + (twoo2z)*I1[44] - (twoo4zn)*I4[44] - (fouro4zn)*I5[36];
*(vp++) = U00*I0[45] - U10*I3[45] + loo2p*I2[45]
        + (twoo2z)*I1[45] - (twoo4zn)*I4[45] - (fouro4zn)*I5[37];
*(vp++) = U00*I0[46] - U10*I3[46] + loo2p*I2[46]
        + (twoo2z)*I1[46] - (twoo4zn)*I4[46] - (threeo4zn)*I5[38];
*(vp++) = U00*I0[47] - U10*I3[47] + loo2p*I2[47]
        + (twoo2z)*I1[47] - (twoo4zn)*I4[47] - (threeo4zn)*I5[39];
*(vp++) = U00*I0[48] - U10*I3[48] + loo2p*I2[48]
        + (twoo2z)*I1[48] - (twoo4zn)*I4[48] - (threeo4zn)*I5[40];
*(vp++) = U00*I0[49] - U10*I3[49] + loo2p*I2[49]
        + (twoo2z)*I1[49] - (twoo4zn)*I4[49] - (threeo4zn)*I5[41];
*(vp++) = U00*I0[50] - U10*I3[50] + loo2p*I2[50]
        + (twoo2z)*I1[50] - (twoo4zn)*I4[50] - (threeo4zn)*I5[42];
*(vp++) = U00*I0[51] - U10*I3[51] + loo2p*I2[51]
        + (twoo2z)*I1[51] - (twoo4zn)*I4[51] - (twoo4zn)*I5[43];
*(vp++) = U00*I0[52] - U10*I3[52] + loo2p*I2[52]
        + (twoo2z)*I1[52] - (twoo4zn)*I4[52] - (twoo4zn)*I5[44];
*(vp++) = U00*I0[53] - U10*I3[53] + loo2p*I2[53]
        + (twoo2z)*I1[53] - (twoo4zn)*I4[53] - (twoo4zn)*I5[45];
*(vp++) = U00*I0[54] - U10*I3[54] + loo2p*I2[54]
        + (twoo2z)*I1[54] - (twoo4zn)*I4[54] - (twoo4zn)*I5[46];
*(vp++) = U00*I0[55] - U10*I3[55] + loo2p*I2[55]
        + (twoo2z)*I1[55] - (twoo4zn)*I4[55] - (twoo4zn)*I5[47];
*(vp++) = U00*I0[56] - U10*I3[56] + loo2p*I2[56]
        + (twoo2z)*I1[56] - (twoo4zn)*I4[56] - (twoo4zn)*I5[48];
*(vp++) = U00*I0[57] - U10*I3[57] + loo2p*I2[57]
        + (twoo2z)*I1[57] - (twoo4zn)*I4[57] - (oneo4zn)*I5[49];
*(vp++) = U00*I0[58] - U10*I3[58] + loo2p*I2[58]
        + (twoo2z)*I1[58] - (twoo4zn)*I4[58] - (oneo4zn)*I5[50];
*(vp++) = U00*I0[59] - U10*I3[59] + loo2p*I2[59]
        + (twoo2z)*I1[59] - (twoo4zn)*I4[59] - (oneo4zn)*I5[51];
*(vp++) = U00*I0[60] - U10*I3[60] + loo2p*I2[60]
        + (twoo2z)*I1[60] - (twoo4zn)*I4[60] - (oneo4zn)*I5[52];
*(vp++) = U00*I0[61] - U10*I3[61] + loo2p*I2[61]
        + (twoo2z)*I1[61] - (twoo4zn)*I4[61] - (oneo4zn)*I5[53];
*(vp++) = U00*I0[62] - U10*I3[62] + loo2p*I2[62]
        + (twoo2z)*I1[62] - (twoo4zn)*I4[62] - (oneo4zn)*I5[54];
*(vp++) = U00*I0[63] - U10*I3[63] + loo2p*I2[63]
        + (twoo2z)*I1[63] - (twoo4zn)*I4[63] - (oneo4zn)*I5[55];
*(vp++) = U00*I0[64] - U10*I3[64] + loo2p*I2[64]
        + (twoo2z)*I1[64] - (twoo4zn)*I4[64];
*(vp++) = U00*I0[65] - U10*I3[65] + loo2p*I2[65]
        + (twoo2z)*I1[65] - (twoo4zn)*I4[65];
*(vp++) = U00*I0[66] - U10*I3[66] + loo2p*I2[66]
        + (twoo2z)*I1[66] - (twoo4zn)*I4[66];
*(vp++) = U00*I0[67] - U10*I3[67] + loo2p*I2[67]
        + (twoo2z)*I1[67] - (twoo4zn)*I4[67];
*(vp++) = U00*I0[68] - U10*I3[68] + loo2p*I2[68]
        + (twoo2z)*I1[68] - (twoo4zn)*I4[68];
*(vp++) = U00*I0[69] - U10*I3[69] + loo2p*I2[69]
        + (twoo2z)*I1[69] - (twoo4zn)*I4[69];
*(vp++) = U00*I0[70] - U10*I3[70] + loo2p*I2[70]
        + (twoo2z)*I1[70] - (twoo4zn)*I4[70];
*(vp++) = U00*I0[71] - U10*I3[71] + loo2p*I2[71]
        + (twoo2z)*I1[71] - (twoo4zn)*I4[71];
*(vp++) = U00*I0[72] - U10*I3[72] + loo2p*I2[72]
        + (twoo2z)*I1[72] - (twoo4zn)*I4[72] - (seveno4zn)*I5[56];
*(vp++) = U00*I0[73] - U10*I3[73] + loo2p*I2[73]
        + (twoo2z)*I1[73] - (twoo4zn)*I4[73] - (sixo4zn)*I5[57];
*(vp++) = U00*I0[74] - U10*I3[74] + loo2p*I2[74]
        + (twoo2z)*I1[74] - (twoo4zn)*I4[74] - (sixo4zn)*I5[58];
*(vp++) = U00*I0[75] - U10*I3[75] + loo2p*I2[75]
        + (twoo2z)*I1[75] - (twoo4zn)*I4[75] - (fiveo4zn)*I5[59];
*(vp++) = U00*I0[76] - U10*I3[76] + loo2p*I2[76]
        + (twoo2z)*I1[76] - (twoo4zn)*I4[76] - (fiveo4zn)*I5[60];
*(vp++) = U00*I0[77] - U10*I3[77] + loo2p*I2[77]
        + (twoo2z)*I1[77] - (twoo4zn)*I4[77] - (fiveo4zn)*I5[61];
*(vp++) = U00*I0[78] - U10*I3[78] + loo2p*I2[78]
        + (twoo2z)*I1[78] - (twoo4zn)*I4[78] - (fouro4zn)*I5[62];
*(vp++) = U00*I0[79] - U10*I3[79] + loo2p*I2[79]
        + (twoo2z)*I1[79] - (twoo4zn)*I4[79] - (fouro4zn)*I5[63];
*(vp++) = U00*I0[80] - U10*I3[80] + loo2p*I2[80]
        + (twoo2z)*I1[80] - (twoo4zn)*I4[80] - (fouro4zn)*I5[64];
*(vp++) = U00*I0[81] - U10*I3[81] + loo2p*I2[81]
        + (twoo2z)*I1[81] - (twoo4zn)*I4[81] - (fouro4zn)*I5[65];
*(vp++) = U00*I0[82] - U10*I3[82] + loo2p*I2[82]
        + (twoo2z)*I1[82] - (twoo4zn)*I4[82] - (threeo4zn)*I5[66];
*(vp++) = U00*I0[83] - U10*I3[83] + loo2p*I2[83]
        + (twoo2z)*I1[83] - (twoo4zn)*I4[83] - (threeo4zn)*I5[67];
*(vp++) = U00*I0[84] - U10*I3[84] + loo2p*I2[84]
        + (twoo2z)*I1[84] - (twoo4zn)*I4[84] - (threeo4zn)*I5[68];
*(vp++) = U00*I0[85] - U10*I3[85] + loo2p*I2[85]
        + (twoo2z)*I1[85] - (twoo4zn)*I4[85] - (threeo4zn)*I5[69];
*(vp++) = U00*I0[86] - U10*I3[86] + loo2p*I2[86]
        + (twoo2z)*I1[86] - (twoo4zn)*I4[86] - (threeo4zn)*I5[70];
*(vp++) = U00*I0[87] - U10*I3[87] + loo2p*I2[87]
        + (twoo2z)*I1[87] - (twoo4zn)*I4[87] - (twoo4zn)*I5[71];
*(vp++) = U00*I0[88] - U10*I3[88] + loo2p*I2[88]
        + (twoo2z)*I1[88] - (twoo4zn)*I4[88] - (twoo4zn)*I5[72];
*(vp++) = U00*I0[89] - U10*I3[89] + loo2p*I2[89]
        + (twoo2z)*I1[89] - (twoo4zn)*I4[89] - (twoo4zn)*I5[73];
*(vp++) = U00*I0[90] - U10*I3[90] + loo2p*I2[90]
        + (twoo2z)*I1[90] - (twoo4zn)*I4[90] - (twoo4zn)*I5[74];
*(vp++) = U00*I0[91] - U10*I3[91] + loo2p*I2[91]
        + (twoo2z)*I1[91] - (twoo4zn)*I4[91] - (twoo4zn)*I5[75];
*(vp++) = U00*I0[92] - U10*I3[92] + loo2p*I2[92]
        + (twoo2z)*I1[92] - (twoo4zn)*I4[92] - (twoo4zn)*I5[76];
*(vp++) = U00*I0[93] - U10*I3[93] + loo2p*I2[93]
        + (twoo2z)*I1[93] - (twoo4zn)*I4[93] - (oneo4zn)*I5[77];
*(vp++) = U00*I0[94] - U10*I3[94] + loo2p*I2[94]
        + (twoo2z)*I1[94] - (twoo4zn)*I4[94] - (oneo4zn)*I5[78];
*(vp++) = U00*I0[95] - U10*I3[95] + loo2p*I2[95]
        + (twoo2z)*I1[95] - (twoo4zn)*I4[95] - (oneo4zn)*I5[79];
*(vp++) = U00*I0[96] - U10*I3[96] + loo2p*I2[96]
        + (twoo2z)*I1[96] - (twoo4zn)*I4[96] - (oneo4zn)*I5[80];
*(vp++) = U00*I0[97] - U10*I3[97] + loo2p*I2[97]
        + (twoo2z)*I1[97] - (twoo4zn)*I4[97] - (oneo4zn)*I5[81];
*(vp++) = U00*I0[98] - U10*I3[98] + loo2p*I2[98]
        + (twoo2z)*I1[98] - (twoo4zn)*I4[98] - (oneo4zn)*I5[82];
*(vp++) = U00*I0[99] - U10*I3[99] + loo2p*I2[99]
        + (twoo2z)*I1[99] - (twoo4zn)*I4[99] - (oneo4zn)*I5[83];
*(vp++) = U00*I0[100] - U10*I3[100] + loo2p*I2[100]
        + (twoo2z)*I1[100] - (twoo4zn)*I4[100];
*(vp++) = U00*I0[101] - U10*I3[101] + loo2p*I2[101]
        + (twoo2z)*I1[101] - (twoo4zn)*I4[101];
*(vp++) = U00*I0[102] - U10*I3[102] + loo2p*I2[102]
        + (twoo2z)*I1[102] - (twoo4zn)*I4[102];
*(vp++) = U00*I0[103] - U10*I3[103] + loo2p*I2[103]
        + (twoo2z)*I1[103] - (twoo4zn)*I4[103];
*(vp++) = U00*I0[104] - U10*I3[104] + loo2p*I2[104]
        + (twoo2z)*I1[104] - (twoo4zn)*I4[104];
*(vp++) = U00*I0[105] - U10*I3[105] + loo2p*I2[105]
        + (twoo2z)*I1[105] - (twoo4zn)*I4[105];
*(vp++) = U00*I0[106] - U10*I3[106] + loo2p*I2[106]
        + (twoo2z)*I1[106] - (twoo4zn)*I4[106];
*(vp++) = U00*I0[107] - U10*I3[107] + loo2p*I2[107]
        + (twoo2z)*I1[107] - (twoo4zn)*I4[107];
*(vp++) = U00*I0[108] - U10*I3[108] + loo2p*I2[108]
        + (oneo2z)*I1[108] - (oneo4zn)*I4[108] - (seveno4zn)*I5[84];
*(vp++) = U00*I0[109] - U10*I3[109] + loo2p*I2[109]
        + (oneo2z)*I1[109] - (oneo4zn)*I4[109] - (sixo4zn)*I5[85];
*(vp++) = U00*I0[110] - U10*I3[110] + loo2p*I2[110]
        + (oneo2z)*I1[110] - (oneo4zn)*I4[110] - (sixo4zn)*I5[86];
*(vp++) = U00*I0[111] - U10*I3[111] + loo2p*I2[111]
        + (oneo2z)*I1[111] - (oneo4zn)*I4[111] - (fiveo4zn)*I5[87];
*(vp++) = U00*I0[112] - U10*I3[112] + loo2p*I2[112]
        + (oneo2z)*I1[112] - (oneo4zn)*I4[112] - (fiveo4zn)*I5[88];
*(vp++) = U00*I0[113] - U10*I3[113] + loo2p*I2[113]
        + (oneo2z)*I1[113] - (oneo4zn)*I4[113] - (fiveo4zn)*I5[89];
*(vp++) = U00*I0[114] - U10*I3[114] + loo2p*I2[114]
        + (oneo2z)*I1[114] - (oneo4zn)*I4[114] - (fouro4zn)*I5[90];
*(vp++) = U00*I0[115] - U10*I3[115] + loo2p*I2[115]
        + (oneo2z)*I1[115] - (oneo4zn)*I4[115] - (fouro4zn)*I5[91];
*(vp++) = U00*I0[116] - U10*I3[116] + loo2p*I2[116]
        + (oneo2z)*I1[116] - (oneo4zn)*I4[116] - (fouro4zn)*I5[92];
*(vp++) = U00*I0[117] - U10*I3[117] + loo2p*I2[117]
        + (oneo2z)*I1[117] - (oneo4zn)*I4[117] - (fouro4zn)*I5[93];
*(vp++) = U00*I0[118] - U10*I3[118] + loo2p*I2[118]
        + (oneo2z)*I1[118] - (oneo4zn)*I4[118] - (threeo4zn)*I5[94];
*(vp++) = U00*I0[119] - U10*I3[119] + loo2p*I2[119]
        + (oneo2z)*I1[119] - (oneo4zn)*I4[119] - (threeo4zn)*I5[95];
*(vp++) = U00*I0[120] - U10*I3[120] + loo2p*I2[120]
        + (oneo2z)*I1[120] - (oneo4zn)*I4[120] - (threeo4zn)*I5[96];
*(vp++) = U00*I0[121] - U10*I3[121] + loo2p*I2[121]
        + (oneo2z)*I1[121] - (oneo4zn)*I4[121] - (threeo4zn)*I5[97];
*(vp++) = U00*I0[122] - U10*I3[122] + loo2p*I2[122]
        + (oneo2z)*I1[122] - (oneo4zn)*I4[122] - (threeo4zn)*I5[98];
*(vp++) = U00*I0[123] - U10*I3[123] + loo2p*I2[123]
        + (oneo2z)*I1[123] - (oneo4zn)*I4[123] - (twoo4zn)*I5[99];
*(vp++) = U00*I0[124] - U10*I3[124] + loo2p*I2[124]
        + (oneo2z)*I1[124] - (oneo4zn)*I4[124] - (twoo4zn)*I5[100];
*(vp++) = U00*I0[125] - U10*I3[125] + loo2p*I2[125]
        + (oneo2z)*I1[125] - (oneo4zn)*I4[125] - (twoo4zn)*I5[101];
*(vp++) = U00*I0[126] - U10*I3[126] + loo2p*I2[126]
        + (oneo2z)*I1[126] - (oneo4zn)*I4[126] - (twoo4zn)*I5[102];
*(vp++) = U00*I0[127] - U10*I3[127] + loo2p*I2[127]
        + (oneo2z)*I1[127] - (oneo4zn)*I4[127] - (twoo4zn)*I5[103];
*(vp++) = U00*I0[128] - U10*I3[128] + loo2p*I2[128]
        + (oneo2z)*I1[128] - (oneo4zn)*I4[128] - (twoo4zn)*I5[104];
*(vp++) = U00*I0[129] - U10*I3[129] + loo2p*I2[129]
        + (oneo2z)*I1[129] - (oneo4zn)*I4[129] - (oneo4zn)*I5[105];
*(vp++) = U00*I0[130] - U10*I3[130] + loo2p*I2[130]
        + (oneo2z)*I1[130] - (oneo4zn)*I4[130] - (oneo4zn)*I5[106];
*(vp++) = U00*I0[131] - U10*I3[131] + loo2p*I2[131]
        + (oneo2z)*I1[131] - (oneo4zn)*I4[131] - (oneo4zn)*I5[107];
*(vp++) = U00*I0[132] - U10*I3[132] + loo2p*I2[132]
        + (oneo2z)*I1[132] - (oneo4zn)*I4[132] - (oneo4zn)*I5[108];
*(vp++) = U00*I0[133] - U10*I3[133] + loo2p*I2[133]
        + (oneo2z)*I1[133] - (oneo4zn)*I4[133] - (oneo4zn)*I5[109];
*(vp++) = U00*I0[134] - U10*I3[134] + loo2p*I2[134]
        + (oneo2z)*I1[134] - (oneo4zn)*I4[134] - (oneo4zn)*I5[110];
*(vp++) = U00*I0[135] - U10*I3[135] + loo2p*I2[135]
        + (oneo2z)*I1[135] - (oneo4zn)*I4[135] - (oneo4zn)*I5[111];
*(vp++) = U00*I0[136] - U10*I3[136] + loo2p*I2[136]
        + (oneo2z)*I1[136] - (oneo4zn)*I4[136];
*(vp++) = U00*I0[137] - U10*I3[137] + loo2p*I2[137]
        + (oneo2z)*I1[137] - (oneo4zn)*I4[137];
*(vp++) = U00*I0[138] - U10*I3[138] + loo2p*I2[138]
        + (oneo2z)*I1[138] - (oneo4zn)*I4[138];
*(vp++) = U00*I0[139] - U10*I3[139] + loo2p*I2[139]
        + (oneo2z)*I1[139] - (oneo4zn)*I4[139];
*(vp++) = U00*I0[140] - U10*I3[140] + loo2p*I2[140]
        + (oneo2z)*I1[140] - (oneo4zn)*I4[140];
*(vp++) = U00*I0[141] - U10*I3[141] + loo2p*I2[141]
        + (oneo2z)*I1[141] - (oneo4zn)*I4[141];
*(vp++) = U00*I0[142] - U10*I3[142] + loo2p*I2[142]
        + (oneo2z)*I1[142] - (oneo4zn)*I4[142];
*(vp++) = U00*I0[143] - U10*I3[143] + loo2p*I2[143]
        + (oneo2z)*I1[143] - (oneo4zn)*I4[143];
*(vp++) = U00*I0[144] - U10*I3[144] + loo2p*I2[144]
        + (oneo2z)*I1[144] - (oneo4zn)*I4[144] - (seveno4zn)*I5[112];
*(vp++) = U00*I0[145] - U10*I3[145] + loo2p*I2[145]
        + (oneo2z)*I1[145] - (oneo4zn)*I4[145] - (sixo4zn)*I5[113];
*(vp++) = U00*I0[146] - U10*I3[146] + loo2p*I2[146]
        + (oneo2z)*I1[146] - (oneo4zn)*I4[146] - (sixo4zn)*I5[114];
*(vp++) = U00*I0[147] - U10*I3[147] + loo2p*I2[147]
        + (oneo2z)*I1[147] - (oneo4zn)*I4[147] - (fiveo4zn)*I5[115];
*(vp++) = U00*I0[148] - U10*I3[148] + loo2p*I2[148]
        + (oneo2z)*I1[148] - (oneo4zn)*I4[148] - (fiveo4zn)*I5[116];
*(vp++) = U00*I0[149] - U10*I3[149] + loo2p*I2[149]
        + (oneo2z)*I1[149] - (oneo4zn)*I4[149] - (fiveo4zn)*I5[117];
*(vp++) = U00*I0[150] - U10*I3[150] + loo2p*I2[150]
        + (oneo2z)*I1[150] - (oneo4zn)*I4[150] - (fouro4zn)*I5[118];
*(vp++) = U00*I0[151] - U10*I3[151] + loo2p*I2[151]
        + (oneo2z)*I1[151] - (oneo4zn)*I4[151] - (fouro4zn)*I5[119];
*(vp++) = U00*I0[152] - U10*I3[152] + loo2p*I2[152]
        + (oneo2z)*I1[152] - (oneo4zn)*I4[152] - (fouro4zn)*I5[120];
*(vp++) = U00*I0[153] - U10*I3[153] + loo2p*I2[153]
        + (oneo2z)*I1[153] - (oneo4zn)*I4[153] - (fouro4zn)*I5[121];
*(vp++) = U00*I0[154] - U10*I3[154] + loo2p*I2[154]
        + (oneo2z)*I1[154] - (oneo4zn)*I4[154] - (threeo4zn)*I5[122];
*(vp++) = U00*I0[155] - U10*I3[155] + loo2p*I2[155]
        + (oneo2z)*I1[155] - (oneo4zn)*I4[155] - (threeo4zn)*I5[123];
*(vp++) = U00*I0[156] - U10*I3[156] + loo2p*I2[156]
        + (oneo2z)*I1[156] - (oneo4zn)*I4[156] - (threeo4zn)*I5[124];
*(vp++) = U00*I0[157] - U10*I3[157] + loo2p*I2[157]
        + (oneo2z)*I1[157] - (oneo4zn)*I4[157] - (threeo4zn)*I5[125];
*(vp++) = U00*I0[158] - U10*I3[158] + loo2p*I2[158]
        + (oneo2z)*I1[158] - (oneo4zn)*I4[158] - (threeo4zn)*I5[126];
*(vp++) = U00*I0[159] - U10*I3[159] + loo2p*I2[159]
        + (oneo2z)*I1[159] - (oneo4zn)*I4[159] - (twoo4zn)*I5[127];
*(vp++) = U00*I0[160] - U10*I3[160] + loo2p*I2[160]
        + (oneo2z)*I1[160] - (oneo4zn)*I4[160] - (twoo4zn)*I5[128];
*(vp++) = U00*I0[161] - U10*I3[161] + loo2p*I2[161]
        + (oneo2z)*I1[161] - (oneo4zn)*I4[161] - (twoo4zn)*I5[129];
*(vp++) = U00*I0[162] - U10*I3[162] + loo2p*I2[162]
        + (oneo2z)*I1[162] - (oneo4zn)*I4[162] - (twoo4zn)*I5[130];
*(vp++) = U00*I0[163] - U10*I3[163] + loo2p*I2[163]
        + (oneo2z)*I1[163] - (oneo4zn)*I4[163] - (twoo4zn)*I5[131];
*(vp++) = U00*I0[164] - U10*I3[164] + loo2p*I2[164]
        + (oneo2z)*I1[164] - (oneo4zn)*I4[164] - (twoo4zn)*I5[132];
*(vp++) = U00*I0[165] - U10*I3[165] + loo2p*I2[165]
        + (oneo2z)*I1[165] - (oneo4zn)*I4[165] - (oneo4zn)*I5[133];
*(vp++) = U00*I0[166] - U10*I3[166] + loo2p*I2[166]
        + (oneo2z)*I1[166] - (oneo4zn)*I4[166] - (oneo4zn)*I5[134];
*(vp++) = U00*I0[167] - U10*I3[167] + loo2p*I2[167]
        + (oneo2z)*I1[167] - (oneo4zn)*I4[167] - (oneo4zn)*I5[135];
*(vp++) = U00*I0[168] - U10*I3[168] + loo2p*I2[168]
        + (oneo2z)*I1[168] - (oneo4zn)*I4[168] - (oneo4zn)*I5[136];
*(vp++) = U00*I0[169] - U10*I3[169] + loo2p*I2[169]
        + (oneo2z)*I1[169] - (oneo4zn)*I4[169] - (oneo4zn)*I5[137];
*(vp++) = U00*I0[170] - U10*I3[170] + loo2p*I2[170]
        + (oneo2z)*I1[170] - (oneo4zn)*I4[170] - (oneo4zn)*I5[138];
*(vp++) = U00*I0[171] - U10*I3[171] + loo2p*I2[171]
        + (oneo2z)*I1[171] - (oneo4zn)*I4[171] - (oneo4zn)*I5[139];
*(vp++) = U00*I0[172] - U10*I3[172] + loo2p*I2[172]
        + (oneo2z)*I1[172] - (oneo4zn)*I4[172];
*(vp++) = U00*I0[173] - U10*I3[173] + loo2p*I2[173]
        + (oneo2z)*I1[173] - (oneo4zn)*I4[173];
*(vp++) = U00*I0[174] - U10*I3[174] + loo2p*I2[174]
        + (oneo2z)*I1[174] - (oneo4zn)*I4[174];
*(vp++) = U00*I0[175] - U10*I3[175] + loo2p*I2[175]
        + (oneo2z)*I1[175] - (oneo4zn)*I4[175];
*(vp++) = U00*I0[176] - U10*I3[176] + loo2p*I2[176]
        + (oneo2z)*I1[176] - (oneo4zn)*I4[176];
*(vp++) = U00*I0[177] - U10*I3[177] + loo2p*I2[177]
        + (oneo2z)*I1[177] - (oneo4zn)*I4[177];
*(vp++) = U00*I0[178] - U10*I3[178] + loo2p*I2[178]
        + (oneo2z)*I1[178] - (oneo4zn)*I4[178];
*(vp++) = U00*I0[179] - U10*I3[179] + loo2p*I2[179]
        + (oneo2z)*I1[179] - (oneo4zn)*I4[179];
*(vp++) = U00*I0[180] - U10*I3[180] + loo2p*I2[180]
        + (oneo2z)*I1[180] - (oneo4zn)*I4[180] - (seveno4zn)*I5[140];
*(vp++) = U00*I0[181] - U10*I3[181] + loo2p*I2[181]
        + (oneo2z)*I1[181] - (oneo4zn)*I4[181] - (sixo4zn)*I5[141];
*(vp++) = U00*I0[182] - U10*I3[182] + loo2p*I2[182]
        + (oneo2z)*I1[182] - (oneo4zn)*I4[182] - (sixo4zn)*I5[142];
*(vp++) = U00*I0[183] - U10*I3[183] + loo2p*I2[183]
        + (oneo2z)*I1[183] - (oneo4zn)*I4[183] - (fiveo4zn)*I5[143];
*(vp++) = U00*I0[184] - U10*I3[184] + loo2p*I2[184]
        + (oneo2z)*I1[184] - (oneo4zn)*I4[184] - (fiveo4zn)*I5[144];
*(vp++) = U00*I0[185] - U10*I3[185] + loo2p*I2[185]
        + (oneo2z)*I1[185] - (oneo4zn)*I4[185] - (fiveo4zn)*I5[145];
*(vp++) = U00*I0[186] - U10*I3[186] + loo2p*I2[186]
        + (oneo2z)*I1[186] - (oneo4zn)*I4[186] - (fouro4zn)*I5[146];
*(vp++) = U00*I0[187] - U10*I3[187] + loo2p*I2[187]
        + (oneo2z)*I1[187] - (oneo4zn)*I4[187] - (fouro4zn)*I5[147];
*(vp++) = U00*I0[188] - U10*I3[188] + loo2p*I2[188]
        + (oneo2z)*I1[188] - (oneo4zn)*I4[188] - (fouro4zn)*I5[148];
*(vp++) = U00*I0[189] - U10*I3[189] + loo2p*I2[189]
        + (oneo2z)*I1[189] - (oneo4zn)*I4[189] - (fouro4zn)*I5[149];
*(vp++) = U00*I0[190] - U10*I3[190] + loo2p*I2[190]
        + (oneo2z)*I1[190] - (oneo4zn)*I4[190] - (threeo4zn)*I5[150];
*(vp++) = U00*I0[191] - U10*I3[191] + loo2p*I2[191]
        + (oneo2z)*I1[191] - (oneo4zn)*I4[191] - (threeo4zn)*I5[151];
*(vp++) = U00*I0[192] - U10*I3[192] + loo2p*I2[192]
        + (oneo2z)*I1[192] - (oneo4zn)*I4[192] - (threeo4zn)*I5[152];
*(vp++) = U00*I0[193] - U10*I3[193] + loo2p*I2[193]
        + (oneo2z)*I1[193] - (oneo4zn)*I4[193] - (threeo4zn)*I5[153];
*(vp++) = U00*I0[194] - U10*I3[194] + loo2p*I2[194]
        + (oneo2z)*I1[194] - (oneo4zn)*I4[194] - (threeo4zn)*I5[154];
*(vp++) = U00*I0[195] - U10*I3[195] + loo2p*I2[195]
        + (oneo2z)*I1[195] - (oneo4zn)*I4[195] - (twoo4zn)*I5[155];
*(vp++) = U00*I0[196] - U10*I3[196] + loo2p*I2[196]
        + (oneo2z)*I1[196] - (oneo4zn)*I4[196] - (twoo4zn)*I5[156];
*(vp++) = U00*I0[197] - U10*I3[197] + loo2p*I2[197]
        + (oneo2z)*I1[197] - (oneo4zn)*I4[197] - (twoo4zn)*I5[157];
*(vp++) = U00*I0[198] - U10*I3[198] + loo2p*I2[198]
        + (oneo2z)*I1[198] - (oneo4zn)*I4[198] - (twoo4zn)*I5[158];
*(vp++) = U00*I0[199] - U10*I3[199] + loo2p*I2[199]
        + (oneo2z)*I1[199] - (oneo4zn)*I4[199] - (twoo4zn)*I5[159];
*(vp++) = U00*I0[200] - U10*I3[200] + loo2p*I2[200]
        + (oneo2z)*I1[200] - (oneo4zn)*I4[200] - (twoo4zn)*I5[160];
*(vp++) = U00*I0[201] - U10*I3[201] + loo2p*I2[201]
        + (oneo2z)*I1[201] - (oneo4zn)*I4[201] - (oneo4zn)*I5[161];
*(vp++) = U00*I0[202] - U10*I3[202] + loo2p*I2[202]
        + (oneo2z)*I1[202] - (oneo4zn)*I4[202] - (oneo4zn)*I5[162];
*(vp++) = U00*I0[203] - U10*I3[203] + loo2p*I2[203]
        + (oneo2z)*I1[203] - (oneo4zn)*I4[203] - (oneo4zn)*I5[163];
*(vp++) = U00*I0[204] - U10*I3[204] + loo2p*I2[204]
        + (oneo2z)*I1[204] - (oneo4zn)*I4[204] - (oneo4zn)*I5[164];
*(vp++) = U00*I0[205] - U10*I3[205] + loo2p*I2[205]
        + (oneo2z)*I1[205] - (oneo4zn)*I4[205] - (oneo4zn)*I5[165];
*(vp++) = U00*I0[206] - U10*I3[206] + loo2p*I2[206]
        + (oneo2z)*I1[206] - (oneo4zn)*I4[206] - (oneo4zn)*I5[166];
*(vp++) = U00*I0[207] - U10*I3[207] + loo2p*I2[207]
        + (oneo2z)*I1[207] - (oneo4zn)*I4[207] - (oneo4zn)*I5[167];
*(vp++) = U00*I0[208] - U10*I3[208] + loo2p*I2[208]
        + (oneo2z)*I1[208] - (oneo4zn)*I4[208];
*(vp++) = U00*I0[209] - U10*I3[209] + loo2p*I2[209]
        + (oneo2z)*I1[209] - (oneo4zn)*I4[209];
*(vp++) = U00*I0[210] - U10*I3[210] + loo2p*I2[210]
        + (oneo2z)*I1[210] - (oneo4zn)*I4[210];
*(vp++) = U00*I0[211] - U10*I3[211] + loo2p*I2[211]
        + (oneo2z)*I1[211] - (oneo4zn)*I4[211];
*(vp++) = U00*I0[212] - U10*I3[212] + loo2p*I2[212]
        + (oneo2z)*I1[212] - (oneo4zn)*I4[212];
*(vp++) = U00*I0[213] - U10*I3[213] + loo2p*I2[213]
        + (oneo2z)*I1[213] - (oneo4zn)*I4[213];
*(vp++) = U00*I0[214] - U10*I3[214] + loo2p*I2[214]
        + (oneo2z)*I1[214] - (oneo4zn)*I4[214];
*(vp++) = U00*I0[215] - U10*I3[215] + loo2p*I2[215]
        + (oneo2z)*I1[215] - (oneo4zn)*I4[215];
*(vp++) = U00*I0[216] - U10*I3[216] + loo2p*I2[216] - (seveno4zn)*I5[168];
*(vp++) = U00*I0[217] - U10*I3[217] + loo2p*I2[217] - (sixo4zn)*I5[169];
*(vp++) = U00*I0[218] - U10*I3[218] + loo2p*I2[218] - (sixo4zn)*I5[170];
*(vp++) = U00*I0[219] - U10*I3[219] + loo2p*I2[219] - (fiveo4zn)*I5[171];
*(vp++) = U00*I0[220] - U10*I3[220] + loo2p*I2[220] - (fiveo4zn)*I5[172];
*(vp++) = U00*I0[221] - U10*I3[221] + loo2p*I2[221] - (fiveo4zn)*I5[173];
*(vp++) = U00*I0[222] - U10*I3[222] + loo2p*I2[222] - (fouro4zn)*I5[174];
*(vp++) = U00*I0[223] - U10*I3[223] + loo2p*I2[223] - (fouro4zn)*I5[175];
*(vp++) = U00*I0[224] - U10*I3[224] + loo2p*I2[224] - (fouro4zn)*I5[176];
*(vp++) = U00*I0[225] - U10*I3[225] + loo2p*I2[225] - (fouro4zn)*I5[177];
*(vp++) = U00*I0[226] - U10*I3[226] + loo2p*I2[226] - (threeo4zn)*I5[178];
*(vp++) = U00*I0[227] - U10*I3[227] + loo2p*I2[227] - (threeo4zn)*I5[179];
*(vp++) = U00*I0[228] - U10*I3[228] + loo2p*I2[228] - (threeo4zn)*I5[180];
*(vp++) = U00*I0[229] - U10*I3[229] + loo2p*I2[229] - (threeo4zn)*I5[181];
*(vp++) = U00*I0[230] - U10*I3[230] + loo2p*I2[230] - (threeo4zn)*I5[182];
*(vp++) = U00*I0[231] - U10*I3[231] + loo2p*I2[231] - (twoo4zn)*I5[183];
*(vp++) = U00*I0[232] - U10*I3[232] + loo2p*I2[232] - (twoo4zn)*I5[184];
*(vp++) = U00*I0[233] - U10*I3[233] + loo2p*I2[233] - (twoo4zn)*I5[185];
*(vp++) = U00*I0[234] - U10*I3[234] + loo2p*I2[234] - (twoo4zn)*I5[186];
*(vp++) = U00*I0[235] - U10*I3[235] + loo2p*I2[235] - (twoo4zn)*I5[187];
*(vp++) = U00*I0[236] - U10*I3[236] + loo2p*I2[236] - (twoo4zn)*I5[188];
*(vp++) = U00*I0[237] - U10*I3[237] + loo2p*I2[237] - (oneo4zn)*I5[189];
*(vp++) = U00*I0[238] - U10*I3[238] + loo2p*I2[238] - (oneo4zn)*I5[190];
*(vp++) = U00*I0[239] - U10*I3[239] + loo2p*I2[239] - (oneo4zn)*I5[191];
*(vp++) = U00*I0[240] - U10*I3[240] + loo2p*I2[240] - (oneo4zn)*I5[192];
*(vp++) = U00*I0[241] - U10*I3[241] + loo2p*I2[241] - (oneo4zn)*I5[193];
*(vp++) = U00*I0[242] - U10*I3[242] + loo2p*I2[242] - (oneo4zn)*I5[194];
*(vp++) = U00*I0[243] - U10*I3[243] + loo2p*I2[243] - (oneo4zn)*I5[195];
*(vp++) = U00*I0[244] - U10*I3[244] + loo2p*I2[244];
*(vp++) = U00*I0[245] - U10*I3[245] + loo2p*I2[245];
*(vp++) = U00*I0[246] - U10*I3[246] + loo2p*I2[246];
*(vp++) = U00*I0[247] - U10*I3[247] + loo2p*I2[247];
*(vp++) = U00*I0[248] - U10*I3[248] + loo2p*I2[248];
*(vp++) = U00*I0[249] - U10*I3[249] + loo2p*I2[249];
*(vp++) = U00*I0[250] - U10*I3[250] + loo2p*I2[250];
*(vp++) = U00*I0[251] - U10*I3[251] + loo2p*I2[251];
*(vp++) = U00*I0[252] - U10*I3[252] + loo2p*I2[252] - (seveno4zn)*I5[196];
*(vp++) = U00*I0[253] - U10*I3[253] + loo2p*I2[253] - (sixo4zn)*I5[197];
*(vp++) = U00*I0[254] - U10*I3[254] + loo2p*I2[254] - (sixo4zn)*I5[198];
*(vp++) = U00*I0[255] - U10*I3[255] + loo2p*I2[255] - (fiveo4zn)*I5[199];
*(vp++) = U00*I0[256] - U10*I3[256] + loo2p*I2[256] - (fiveo4zn)*I5[200];
*(vp++) = U00*I0[257] - U10*I3[257] + loo2p*I2[257] - (fiveo4zn)*I5[201];
*(vp++) = U00*I0[258] - U10*I3[258] + loo2p*I2[258] - (fouro4zn)*I5[202];
*(vp++) = U00*I0[259] - U10*I3[259] + loo2p*I2[259] - (fouro4zn)*I5[203];
*(vp++) = U00*I0[260] - U10*I3[260] + loo2p*I2[260] - (fouro4zn)*I5[204];
*(vp++) = U00*I0[261] - U10*I3[261] + loo2p*I2[261] - (fouro4zn)*I5[205];
*(vp++) = U00*I0[262] - U10*I3[262] + loo2p*I2[262] - (threeo4zn)*I5[206];
*(vp++) = U00*I0[263] - U10*I3[263] + loo2p*I2[263] - (threeo4zn)*I5[207];
*(vp++) = U00*I0[264] - U10*I3[264] + loo2p*I2[264] - (threeo4zn)*I5[208];
*(vp++) = U00*I0[265] - U10*I3[265] + loo2p*I2[265] - (threeo4zn)*I5[209];
*(vp++) = U00*I0[266] - U10*I3[266] + loo2p*I2[266] - (threeo4zn)*I5[210];
*(vp++) = U00*I0[267] - U10*I3[267] + loo2p*I2[267] - (twoo4zn)*I5[211];
*(vp++) = U00*I0[268] - U10*I3[268] + loo2p*I2[268] - (twoo4zn)*I5[212];
*(vp++) = U00*I0[269] - U10*I3[269] + loo2p*I2[269] - (twoo4zn)*I5[213];
*(vp++) = U00*I0[270] - U10*I3[270] + loo2p*I2[270] - (twoo4zn)*I5[214];
return vp;
}

REALTYPE *_r_build_g0k0_1(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE seveno4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  seveno4zn = 7.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[271] - U10*I3[271] + loo2p*I2[271] - (twoo4zn)*I5[215];
*(vp++) = U00*I0[272] - U10*I3[272] + loo2p*I2[272] - (twoo4zn)*I5[216];
*(vp++) = U00*I0[273] - U10*I3[273] + loo2p*I2[273] - (oneo4zn)*I5[217];
*(vp++) = U00*I0[274] - U10*I3[274] + loo2p*I2[274] - (oneo4zn)*I5[218];
*(vp++) = U00*I0[275] - U10*I3[275] + loo2p*I2[275] - (oneo4zn)*I5[219];
*(vp++) = U00*I0[276] - U10*I3[276] + loo2p*I2[276] - (oneo4zn)*I5[220];
*(vp++) = U00*I0[277] - U10*I3[277] + loo2p*I2[277] - (oneo4zn)*I5[221];
*(vp++) = U00*I0[278] - U10*I3[278] + loo2p*I2[278] - (oneo4zn)*I5[222];
*(vp++) = U00*I0[279] - U10*I3[279] + loo2p*I2[279] - (oneo4zn)*I5[223];
*(vp++) = U00*I0[280] - U10*I3[280] + loo2p*I2[280];
*(vp++) = U00*I0[281] - U10*I3[281] + loo2p*I2[281];
*(vp++) = U00*I0[282] - U10*I3[282] + loo2p*I2[282];
*(vp++) = U00*I0[283] - U10*I3[283] + loo2p*I2[283];
*(vp++) = U00*I0[284] - U10*I3[284] + loo2p*I2[284];
*(vp++) = U00*I0[285] - U10*I3[285] + loo2p*I2[285];
*(vp++) = U00*I0[286] - U10*I3[286] + loo2p*I2[286];
*(vp++) = U00*I0[287] - U10*I3[287] + loo2p*I2[287];
*(vp++) = U00*I0[288] - U10*I3[288] + loo2p*I2[288] - (seveno4zn)*I5[224];
*(vp++) = U00*I0[289] - U10*I3[289] + loo2p*I2[289] - (sixo4zn)*I5[225];
*(vp++) = U00*I0[290] - U10*I3[290] + loo2p*I2[290] - (sixo4zn)*I5[226];
*(vp++) = U00*I0[291] - U10*I3[291] + loo2p*I2[291] - (fiveo4zn)*I5[227];
*(vp++) = U00*I0[292] - U10*I3[292] + loo2p*I2[292] - (fiveo4zn)*I5[228];
*(vp++) = U00*I0[293] - U10*I3[293] + loo2p*I2[293] - (fiveo4zn)*I5[229];
*(vp++) = U00*I0[294] - U10*I3[294] + loo2p*I2[294] - (fouro4zn)*I5[230];
*(vp++) = U00*I0[295] - U10*I3[295] + loo2p*I2[295] - (fouro4zn)*I5[231];
*(vp++) = U00*I0[296] - U10*I3[296] + loo2p*I2[296] - (fouro4zn)*I5[232];
*(vp++) = U00*I0[297] - U10*I3[297] + loo2p*I2[297] - (fouro4zn)*I5[233];
*(vp++) = U00*I0[298] - U10*I3[298] + loo2p*I2[298] - (threeo4zn)*I5[234];
*(vp++) = U00*I0[299] - U10*I3[299] + loo2p*I2[299] - (threeo4zn)*I5[235];
*(vp++) = U00*I0[300] - U10*I3[300] + loo2p*I2[300] - (threeo4zn)*I5[236];
*(vp++) = U00*I0[301] - U10*I3[301] + loo2p*I2[301] - (threeo4zn)*I5[237];
*(vp++) = U00*I0[302] - U10*I3[302] + loo2p*I2[302] - (threeo4zn)*I5[238];
*(vp++) = U00*I0[303] - U10*I3[303] + loo2p*I2[303] - (twoo4zn)*I5[239];
*(vp++) = U00*I0[304] - U10*I3[304] + loo2p*I2[304] - (twoo4zn)*I5[240];
*(vp++) = U00*I0[305] - U10*I3[305] + loo2p*I2[305] - (twoo4zn)*I5[241];
*(vp++) = U00*I0[306] - U10*I3[306] + loo2p*I2[306] - (twoo4zn)*I5[242];
*(vp++) = U00*I0[307] - U10*I3[307] + loo2p*I2[307] - (twoo4zn)*I5[243];
*(vp++) = U00*I0[308] - U10*I3[308] + loo2p*I2[308] - (twoo4zn)*I5[244];
*(vp++) = U00*I0[309] - U10*I3[309] + loo2p*I2[309] - (oneo4zn)*I5[245];
*(vp++) = U00*I0[310] - U10*I3[310] + loo2p*I2[310] - (oneo4zn)*I5[246];
*(vp++) = U00*I0[311] - U10*I3[311] + loo2p*I2[311] - (oneo4zn)*I5[247];
*(vp++) = U00*I0[312] - U10*I3[312] + loo2p*I2[312] - (oneo4zn)*I5[248];
*(vp++) = U00*I0[313] - U10*I3[313] + loo2p*I2[313] - (oneo4zn)*I5[249];
*(vp++) = U00*I0[314] - U10*I3[314] + loo2p*I2[314] - (oneo4zn)*I5[250];
*(vp++) = U00*I0[315] - U10*I3[315] + loo2p*I2[315] - (oneo4zn)*I5[251];
*(vp++) = U00*I0[316] - U10*I3[316] + loo2p*I2[316];
*(vp++) = U00*I0[317] - U10*I3[317] + loo2p*I2[317];
*(vp++) = U00*I0[318] - U10*I3[318] + loo2p*I2[318];
*(vp++) = U00*I0[319] - U10*I3[319] + loo2p*I2[319];
*(vp++) = U00*I0[320] - U10*I3[320] + loo2p*I2[320];
*(vp++) = U00*I0[321] - U10*I3[321] + loo2p*I2[321];
*(vp++) = U00*I0[322] - U10*I3[322] + loo2p*I2[322];
*(vp++) = U00*I0[323] - U10*I3[323] + loo2p*I2[323];
*(vp++) = U00*I0[324] - U10*I3[324] + loo2p*I2[324] - (seveno4zn)*I5[252];
*(vp++) = U00*I0[325] - U10*I3[325] + loo2p*I2[325] - (sixo4zn)*I5[253];
*(vp++) = U00*I0[326] - U10*I3[326] + loo2p*I2[326] - (sixo4zn)*I5[254];
*(vp++) = U00*I0[327] - U10*I3[327] + loo2p*I2[327] - (fiveo4zn)*I5[255];
*(vp++) = U00*I0[328] - U10*I3[328] + loo2p*I2[328] - (fiveo4zn)*I5[256];
*(vp++) = U00*I0[329] - U10*I3[329] + loo2p*I2[329] - (fiveo4zn)*I5[257];
*(vp++) = U00*I0[330] - U10*I3[330] + loo2p*I2[330] - (fouro4zn)*I5[258];
*(vp++) = U00*I0[331] - U10*I3[331] + loo2p*I2[331] - (fouro4zn)*I5[259];
*(vp++) = U00*I0[332] - U10*I3[332] + loo2p*I2[332] - (fouro4zn)*I5[260];
*(vp++) = U00*I0[333] - U10*I3[333] + loo2p*I2[333] - (fouro4zn)*I5[261];
*(vp++) = U00*I0[334] - U10*I3[334] + loo2p*I2[334] - (threeo4zn)*I5[262];
*(vp++) = U00*I0[335] - U10*I3[335] + loo2p*I2[335] - (threeo4zn)*I5[263];
*(vp++) = U00*I0[336] - U10*I3[336] + loo2p*I2[336] - (threeo4zn)*I5[264];
*(vp++) = U00*I0[337] - U10*I3[337] + loo2p*I2[337] - (threeo4zn)*I5[265];
*(vp++) = U00*I0[338] - U10*I3[338] + loo2p*I2[338] - (threeo4zn)*I5[266];
*(vp++) = U00*I0[339] - U10*I3[339] + loo2p*I2[339] - (twoo4zn)*I5[267];
*(vp++) = U00*I0[340] - U10*I3[340] + loo2p*I2[340] - (twoo4zn)*I5[268];
*(vp++) = U00*I0[341] - U10*I3[341] + loo2p*I2[341] - (twoo4zn)*I5[269];
*(vp++) = U00*I0[342] - U10*I3[342] + loo2p*I2[342] - (twoo4zn)*I5[270];
*(vp++) = U00*I0[343] - U10*I3[343] + loo2p*I2[343] - (twoo4zn)*I5[271];
*(vp++) = U00*I0[344] - U10*I3[344] + loo2p*I2[344] - (twoo4zn)*I5[272];
*(vp++) = U00*I0[345] - U10*I3[345] + loo2p*I2[345] - (oneo4zn)*I5[273];
*(vp++) = U00*I0[346] - U10*I3[346] + loo2p*I2[346] - (oneo4zn)*I5[274];
*(vp++) = U00*I0[347] - U10*I3[347] + loo2p*I2[347] - (oneo4zn)*I5[275];
*(vp++) = U00*I0[348] - U10*I3[348] + loo2p*I2[348] - (oneo4zn)*I5[276];
*(vp++) = U00*I0[349] - U10*I3[349] + loo2p*I2[349] - (oneo4zn)*I5[277];
*(vp++) = U00*I0[350] - U10*I3[350] + loo2p*I2[350] - (oneo4zn)*I5[278];
*(vp++) = U00*I0[351] - U10*I3[351] + loo2p*I2[351] - (oneo4zn)*I5[279];
*(vp++) = U00*I0[352] - U10*I3[352] + loo2p*I2[352];
*(vp++) = U00*I0[353] - U10*I3[353] + loo2p*I2[353];
*(vp++) = U00*I0[354] - U10*I3[354] + loo2p*I2[354];
*(vp++) = U00*I0[355] - U10*I3[355] + loo2p*I2[355];
*(vp++) = U00*I0[356] - U10*I3[356] + loo2p*I2[356];
*(vp++) = U00*I0[357] - U10*I3[357] + loo2p*I2[357];
*(vp++) = U00*I0[358] - U10*I3[358] + loo2p*I2[358];
*(vp++) = U00*I0[359] - U10*I3[359] + loo2p*I2[359];
*(vp++) = U01*I0[216] - U11*I3[216] + loo2p*I2[360]
        + (threeo2z)*I1[108] - (threeo4zn)*I4[108];
*(vp++) = U01*I0[217] - U11*I3[217] + loo2p*I2[361]
        + (threeo2z)*I1[109] - (threeo4zn)*I4[109] - (oneo4zn)*I5[168];
*(vp++) = U01*I0[218] - U11*I3[218] + loo2p*I2[362]
        + (threeo2z)*I1[110] - (threeo4zn)*I4[110];
*(vp++) = U01*I0[219] - U11*I3[219] + loo2p*I2[363]
        + (threeo2z)*I1[111] - (threeo4zn)*I4[111] - (twoo4zn)*I5[169];
*(vp++) = U01*I0[220] - U11*I3[220] + loo2p*I2[364]
        + (threeo2z)*I1[112] - (threeo4zn)*I4[112] - (oneo4zn)*I5[170];
*(vp++) = U01*I0[221] - U11*I3[221] + loo2p*I2[365]
        + (threeo2z)*I1[113] - (threeo4zn)*I4[113];
*(vp++) = U01*I0[222] - U11*I3[222] + loo2p*I2[366]
        + (threeo2z)*I1[114] - (threeo4zn)*I4[114] - (threeo4zn)*I5[171];
*(vp++) = U01*I0[223] - U11*I3[223] + loo2p*I2[367]
        + (threeo2z)*I1[115] - (threeo4zn)*I4[115] - (twoo4zn)*I5[172];
*(vp++) = U01*I0[224] - U11*I3[224] + loo2p*I2[368]
        + (threeo2z)*I1[116] - (threeo4zn)*I4[116] - (oneo4zn)*I5[173];
*(vp++) = U01*I0[225] - U11*I3[225] + loo2p*I2[369]
        + (threeo2z)*I1[117] - (threeo4zn)*I4[117];
*(vp++) = U01*I0[226] - U11*I3[226] + loo2p*I2[370]
        + (threeo2z)*I1[118] - (threeo4zn)*I4[118] - (fouro4zn)*I5[174];
*(vp++) = U01*I0[227] - U11*I3[227] + loo2p*I2[371]
        + (threeo2z)*I1[119] - (threeo4zn)*I4[119] - (threeo4zn)*I5[175];
*(vp++) = U01*I0[228] - U11*I3[228] + loo2p*I2[372]
        + (threeo2z)*I1[120] - (threeo4zn)*I4[120] - (twoo4zn)*I5[176];
*(vp++) = U01*I0[229] - U11*I3[229] + loo2p*I2[373]
        + (threeo2z)*I1[121] - (threeo4zn)*I4[121] - (oneo4zn)*I5[177];
*(vp++) = U01*I0[230] - U11*I3[230] + loo2p*I2[374]
        + (threeo2z)*I1[122] - (threeo4zn)*I4[122];
*(vp++) = U01*I0[231] - U11*I3[231] + loo2p*I2[375]
        + (threeo2z)*I1[123] - (threeo4zn)*I4[123] - (fiveo4zn)*I5[178];
*(vp++) = U01*I0[232] - U11*I3[232] + loo2p*I2[376]
        + (threeo2z)*I1[124] - (threeo4zn)*I4[124] - (fouro4zn)*I5[179];
*(vp++) = U01*I0[233] - U11*I3[233] + loo2p*I2[377]
        + (threeo2z)*I1[125] - (threeo4zn)*I4[125] - (threeo4zn)*I5[180];
*(vp++) = U01*I0[234] - U11*I3[234] + loo2p*I2[378]
        + (threeo2z)*I1[126] - (threeo4zn)*I4[126] - (twoo4zn)*I5[181];
*(vp++) = U01*I0[235] - U11*I3[235] + loo2p*I2[379]
        + (threeo2z)*I1[127] - (threeo4zn)*I4[127] - (oneo4zn)*I5[182];
*(vp++) = U01*I0[236] - U11*I3[236] + loo2p*I2[380]
        + (threeo2z)*I1[128] - (threeo4zn)*I4[128];
*(vp++) = U01*I0[237] - U11*I3[237] + loo2p*I2[381]
        + (threeo2z)*I1[129] - (threeo4zn)*I4[129] - (sixo4zn)*I5[183];
*(vp++) = U01*I0[238] - U11*I3[238] + loo2p*I2[382]
        + (threeo2z)*I1[130] - (threeo4zn)*I4[130] - (fiveo4zn)*I5[184];
*(vp++) = U01*I0[239] - U11*I3[239] + loo2p*I2[383]
        + (threeo2z)*I1[131] - (threeo4zn)*I4[131] - (fouro4zn)*I5[185];
*(vp++) = U01*I0[240] - U11*I3[240] + loo2p*I2[384]
        + (threeo2z)*I1[132] - (threeo4zn)*I4[132] - (threeo4zn)*I5[186];
*(vp++) = U01*I0[241] - U11*I3[241] + loo2p*I2[385]
        + (threeo2z)*I1[133] - (threeo4zn)*I4[133] - (twoo4zn)*I5[187];
*(vp++) = U01*I0[242] - U11*I3[242] + loo2p*I2[386]
        + (threeo2z)*I1[134] - (threeo4zn)*I4[134] - (oneo4zn)*I5[188];
*(vp++) = U01*I0[243] - U11*I3[243] + loo2p*I2[387]
        + (threeo2z)*I1[135] - (threeo4zn)*I4[135];
*(vp++) = U01*I0[244] - U11*I3[244] + loo2p*I2[388]
        + (threeo2z)*I1[136] - (threeo4zn)*I4[136] - (seveno4zn)*I5[189];
*(vp++) = U01*I0[245] - U11*I3[245] + loo2p*I2[389]
        + (threeo2z)*I1[137] - (threeo4zn)*I4[137] - (sixo4zn)*I5[190];
*(vp++) = U01*I0[246] - U11*I3[246] + loo2p*I2[390]
        + (threeo2z)*I1[138] - (threeo4zn)*I4[138] - (fiveo4zn)*I5[191];
*(vp++) = U01*I0[247] - U11*I3[247] + loo2p*I2[391]
        + (threeo2z)*I1[139] - (threeo4zn)*I4[139] - (fouro4zn)*I5[192];
*(vp++) = U01*I0[248] - U11*I3[248] + loo2p*I2[392]
        + (threeo2z)*I1[140] - (threeo4zn)*I4[140] - (threeo4zn)*I5[193];
*(vp++) = U01*I0[249] - U11*I3[249] + loo2p*I2[393]
        + (threeo2z)*I1[141] - (threeo4zn)*I4[141] - (twoo4zn)*I5[194];
*(vp++) = U01*I0[250] - U11*I3[250] + loo2p*I2[394]
        + (threeo2z)*I1[142] - (threeo4zn)*I4[142] - (oneo4zn)*I5[195];
*(vp++) = U01*I0[251] - U11*I3[251] + loo2p*I2[395]
        + (threeo2z)*I1[143] - (threeo4zn)*I4[143];
*(vp++) = U01*I0[252] - U11*I3[252] + loo2p*I2[396]
        + (twoo2z)*I1[144] - (twoo4zn)*I4[144];
*(vp++) = U01*I0[253] - U11*I3[253] + loo2p*I2[397]
        + (twoo2z)*I1[145] - (twoo4zn)*I4[145] - (oneo4zn)*I5[196];
*(vp++) = U01*I0[254] - U11*I3[254] + loo2p*I2[398]
        + (twoo2z)*I1[146] - (twoo4zn)*I4[146];
*(vp++) = U01*I0[255] - U11*I3[255] + loo2p*I2[399]
        + (twoo2z)*I1[147] - (twoo4zn)*I4[147] - (twoo4zn)*I5[197];
*(vp++) = U01*I0[256] - U11*I3[256] + loo2p*I2[400]
        + (twoo2z)*I1[148] - (twoo4zn)*I4[148] - (oneo4zn)*I5[198];
*(vp++) = U01*I0[257] - U11*I3[257] + loo2p*I2[401]
        + (twoo2z)*I1[149] - (twoo4zn)*I4[149];
*(vp++) = U01*I0[258] - U11*I3[258] + loo2p*I2[402]
        + (twoo2z)*I1[150] - (twoo4zn)*I4[150] - (threeo4zn)*I5[199];
*(vp++) = U01*I0[259] - U11*I3[259] + loo2p*I2[403]
        + (twoo2z)*I1[151] - (twoo4zn)*I4[151] - (twoo4zn)*I5[200];
*(vp++) = U01*I0[260] - U11*I3[260] + loo2p*I2[404]
        + (twoo2z)*I1[152] - (twoo4zn)*I4[152] - (oneo4zn)*I5[201];
*(vp++) = U01*I0[261] - U11*I3[261] + loo2p*I2[405]
        + (twoo2z)*I1[153] - (twoo4zn)*I4[153];
*(vp++) = U01*I0[262] - U11*I3[262] + loo2p*I2[406]
        + (twoo2z)*I1[154] - (twoo4zn)*I4[154] - (fouro4zn)*I5[202];
*(vp++) = U01*I0[263] - U11*I3[263] + loo2p*I2[407]
        + (twoo2z)*I1[155] - (twoo4zn)*I4[155] - (threeo4zn)*I5[203];
*(vp++) = U01*I0[264] - U11*I3[264] + loo2p*I2[408]
        + (twoo2z)*I1[156] - (twoo4zn)*I4[156] - (twoo4zn)*I5[204];
*(vp++) = U01*I0[265] - U11*I3[265] + loo2p*I2[409]
        + (twoo2z)*I1[157] - (twoo4zn)*I4[157] - (oneo4zn)*I5[205];
*(vp++) = U01*I0[266] - U11*I3[266] + loo2p*I2[410]
        + (twoo2z)*I1[158] - (twoo4zn)*I4[158];
*(vp++) = U01*I0[267] - U11*I3[267] + loo2p*I2[411]
        + (twoo2z)*I1[159] - (twoo4zn)*I4[159] - (fiveo4zn)*I5[206];
*(vp++) = U01*I0[268] - U11*I3[268] + loo2p*I2[412]
        + (twoo2z)*I1[160] - (twoo4zn)*I4[160] - (fouro4zn)*I5[207];
*(vp++) = U01*I0[269] - U11*I3[269] + loo2p*I2[413]
        + (twoo2z)*I1[161] - (twoo4zn)*I4[161] - (threeo4zn)*I5[208];
*(vp++) = U01*I0[270] - U11*I3[270] + loo2p*I2[414]
        + (twoo2z)*I1[162] - (twoo4zn)*I4[162] - (twoo4zn)*I5[209];
*(vp++) = U01*I0[271] - U11*I3[271] + loo2p*I2[415]
        + (twoo2z)*I1[163] - (twoo4zn)*I4[163] - (oneo4zn)*I5[210];
*(vp++) = U01*I0[272] - U11*I3[272] + loo2p*I2[416]
        + (twoo2z)*I1[164] - (twoo4zn)*I4[164];
*(vp++) = U01*I0[273] - U11*I3[273] + loo2p*I2[417]
        + (twoo2z)*I1[165] - (twoo4zn)*I4[165] - (sixo4zn)*I5[211];
*(vp++) = U01*I0[274] - U11*I3[274] + loo2p*I2[418]
        + (twoo2z)*I1[166] - (twoo4zn)*I4[166] - (fiveo4zn)*I5[212];
*(vp++) = U01*I0[275] - U11*I3[275] + loo2p*I2[419]
        + (twoo2z)*I1[167] - (twoo4zn)*I4[167] - (fouro4zn)*I5[213];
*(vp++) = U01*I0[276] - U11*I3[276] + loo2p*I2[420]
        + (twoo2z)*I1[168] - (twoo4zn)*I4[168] - (threeo4zn)*I5[214];
*(vp++) = U01*I0[277] - U11*I3[277] + loo2p*I2[421]
        + (twoo2z)*I1[169] - (twoo4zn)*I4[169] - (twoo4zn)*I5[215];
*(vp++) = U01*I0[278] - U11*I3[278] + loo2p*I2[422]
        + (twoo2z)*I1[170] - (twoo4zn)*I4[170] - (oneo4zn)*I5[216];
*(vp++) = U01*I0[279] - U11*I3[279] + loo2p*I2[423]
        + (twoo2z)*I1[171] - (twoo4zn)*I4[171];
*(vp++) = U01*I0[280] - U11*I3[280] + loo2p*I2[424]
        + (twoo2z)*I1[172] - (twoo4zn)*I4[172] - (seveno4zn)*I5[217];
*(vp++) = U01*I0[281] - U11*I3[281] + loo2p*I2[425]
        + (twoo2z)*I1[173] - (twoo4zn)*I4[173] - (sixo4zn)*I5[218];
*(vp++) = U01*I0[282] - U11*I3[282] + loo2p*I2[426]
        + (twoo2z)*I1[174] - (twoo4zn)*I4[174] - (fiveo4zn)*I5[219];
*(vp++) = U01*I0[283] - U11*I3[283] + loo2p*I2[427]
        + (twoo2z)*I1[175] - (twoo4zn)*I4[175] - (fouro4zn)*I5[220];
*(vp++) = U01*I0[284] - U11*I3[284] + loo2p*I2[428]
        + (twoo2z)*I1[176] - (twoo4zn)*I4[176] - (threeo4zn)*I5[221];
*(vp++) = U01*I0[285] - U11*I3[285] + loo2p*I2[429]
        + (twoo2z)*I1[177] - (twoo4zn)*I4[177] - (twoo4zn)*I5[222];
*(vp++) = U01*I0[286] - U11*I3[286] + loo2p*I2[430]
        + (twoo2z)*I1[178] - (twoo4zn)*I4[178] - (oneo4zn)*I5[223];
*(vp++) = U01*I0[287] - U11*I3[287] + loo2p*I2[431]
        + (twoo2z)*I1[179] - (twoo4zn)*I4[179];
*(vp++) = U01*I0[288] - U11*I3[288] + loo2p*I2[432]
        + (oneo2z)*I1[180] - (oneo4zn)*I4[180];
*(vp++) = U01*I0[289] - U11*I3[289] + loo2p*I2[433]
        + (oneo2z)*I1[181] - (oneo4zn)*I4[181] - (oneo4zn)*I5[224];
*(vp++) = U01*I0[290] - U11*I3[290] + loo2p*I2[434]
        + (oneo2z)*I1[182] - (oneo4zn)*I4[182];
*(vp++) = U01*I0[291] - U11*I3[291] + loo2p*I2[435]
        + (oneo2z)*I1[183] - (oneo4zn)*I4[183] - (twoo4zn)*I5[225];
*(vp++) = U01*I0[292] - U11*I3[292] + loo2p*I2[436]
        + (oneo2z)*I1[184] - (oneo4zn)*I4[184] - (oneo4zn)*I5[226];
*(vp++) = U01*I0[293] - U11*I3[293] + loo2p*I2[437]
        + (oneo2z)*I1[185] - (oneo4zn)*I4[185];
*(vp++) = U01*I0[294] - U11*I3[294] + loo2p*I2[438]
        + (oneo2z)*I1[186] - (oneo4zn)*I4[186] - (threeo4zn)*I5[227];
*(vp++) = U01*I0[295] - U11*I3[295] + loo2p*I2[439]
        + (oneo2z)*I1[187] - (oneo4zn)*I4[187] - (twoo4zn)*I5[228];
*(vp++) = U01*I0[296] - U11*I3[296] + loo2p*I2[440]
        + (oneo2z)*I1[188] - (oneo4zn)*I4[188] - (oneo4zn)*I5[229];
*(vp++) = U01*I0[297] - U11*I3[297] + loo2p*I2[441]
        + (oneo2z)*I1[189] - (oneo4zn)*I4[189];
*(vp++) = U01*I0[298] - U11*I3[298] + loo2p*I2[442]
        + (oneo2z)*I1[190] - (oneo4zn)*I4[190] - (fouro4zn)*I5[230];
*(vp++) = U01*I0[299] - U11*I3[299] + loo2p*I2[443]
        + (oneo2z)*I1[191] - (oneo4zn)*I4[191] - (threeo4zn)*I5[231];
*(vp++) = U01*I0[300] - U11*I3[300] + loo2p*I2[444]
        + (oneo2z)*I1[192] - (oneo4zn)*I4[192] - (twoo4zn)*I5[232];
*(vp++) = U01*I0[301] - U11*I3[301] + loo2p*I2[445]
        + (oneo2z)*I1[193] - (oneo4zn)*I4[193] - (oneo4zn)*I5[233];
*(vp++) = U01*I0[302] - U11*I3[302] + loo2p*I2[446]
        + (oneo2z)*I1[194] - (oneo4zn)*I4[194];
*(vp++) = U01*I0[303] - U11*I3[303] + loo2p*I2[447]
        + (oneo2z)*I1[195] - (oneo4zn)*I4[195] - (fiveo4zn)*I5[234];
*(vp++) = U01*I0[304] - U11*I3[304] + loo2p*I2[448]
        + (oneo2z)*I1[196] - (oneo4zn)*I4[196] - (fouro4zn)*I5[235];
*(vp++) = U01*I0[305] - U11*I3[305] + loo2p*I2[449]
        + (oneo2z)*I1[197] - (oneo4zn)*I4[197] - (threeo4zn)*I5[236];
*(vp++) = U01*I0[306] - U11*I3[306] + loo2p*I2[450]
        + (oneo2z)*I1[198] - (oneo4zn)*I4[198] - (twoo4zn)*I5[237];
*(vp++) = U01*I0[307] - U11*I3[307] + loo2p*I2[451]
        + (oneo2z)*I1[199] - (oneo4zn)*I4[199] - (oneo4zn)*I5[238];
*(vp++) = U01*I0[308] - U11*I3[308] + loo2p*I2[452]
        + (oneo2z)*I1[200] - (oneo4zn)*I4[200];
*(vp++) = U01*I0[309] - U11*I3[309] + loo2p*I2[453]
        + (oneo2z)*I1[201] - (oneo4zn)*I4[201] - (sixo4zn)*I5[239];
*(vp++) = U01*I0[310] - U11*I3[310] + loo2p*I2[454]
        + (oneo2z)*I1[202] - (oneo4zn)*I4[202] - (fiveo4zn)*I5[240];
*(vp++) = U01*I0[311] - U11*I3[311] + loo2p*I2[455]
        + (oneo2z)*I1[203] - (oneo4zn)*I4[203] - (fouro4zn)*I5[241];
*(vp++) = U01*I0[312] - U11*I3[312] + loo2p*I2[456]
        + (oneo2z)*I1[204] - (oneo4zn)*I4[204] - (threeo4zn)*I5[242];
*(vp++) = U01*I0[313] - U11*I3[313] + loo2p*I2[457]
        + (oneo2z)*I1[205] - (oneo4zn)*I4[205] - (twoo4zn)*I5[243];
*(vp++) = U01*I0[314] - U11*I3[314] + loo2p*I2[458]
        + (oneo2z)*I1[206] - (oneo4zn)*I4[206] - (oneo4zn)*I5[244];
*(vp++) = U01*I0[315] - U11*I3[315] + loo2p*I2[459]
        + (oneo2z)*I1[207] - (oneo4zn)*I4[207];
*(vp++) = U01*I0[316] - U11*I3[316] + loo2p*I2[460]
        + (oneo2z)*I1[208] - (oneo4zn)*I4[208] - (seveno4zn)*I5[245];
*(vp++) = U01*I0[317] - U11*I3[317] + loo2p*I2[461]
        + (oneo2z)*I1[209] - (oneo4zn)*I4[209] - (sixo4zn)*I5[246];
*(vp++) = U01*I0[318] - U11*I3[318] + loo2p*I2[462]
        + (oneo2z)*I1[210] - (oneo4zn)*I4[210] - (fiveo4zn)*I5[247];
*(vp++) = U01*I0[319] - U11*I3[319] + loo2p*I2[463]
        + (oneo2z)*I1[211] - (oneo4zn)*I4[211] - (fouro4zn)*I5[248];
*(vp++) = U01*I0[320] - U11*I3[320] + loo2p*I2[464]
        + (oneo2z)*I1[212] - (oneo4zn)*I4[212] - (threeo4zn)*I5[249];
*(vp++) = U01*I0[321] - U11*I3[321] + loo2p*I2[465]
        + (oneo2z)*I1[213] - (oneo4zn)*I4[213] - (twoo4zn)*I5[250];
*(vp++) = U01*I0[322] - U11*I3[322] + loo2p*I2[466]
        + (oneo2z)*I1[214] - (oneo4zn)*I4[214] - (oneo4zn)*I5[251];
*(vp++) = U01*I0[323] - U11*I3[323] + loo2p*I2[467]
        + (oneo2z)*I1[215] - (oneo4zn)*I4[215];
*(vp++) = U01*I0[324] - U11*I3[324] + loo2p*I2[468];
*(vp++) = U01*I0[325] - U11*I3[325] + loo2p*I2[469] - (oneo4zn)*I5[252];
*(vp++) = U01*I0[326] - U11*I3[326] + loo2p*I2[470];
*(vp++) = U01*I0[327] - U11*I3[327] + loo2p*I2[471] - (twoo4zn)*I5[253];
*(vp++) = U01*I0[328] - U11*I3[328] + loo2p*I2[472] - (oneo4zn)*I5[254];
*(vp++) = U01*I0[329] - U11*I3[329] + loo2p*I2[473];
*(vp++) = U01*I0[330] - U11*I3[330] + loo2p*I2[474] - (threeo4zn)*I5[255];
*(vp++) = U01*I0[331] - U11*I3[331] + loo2p*I2[475] - (twoo4zn)*I5[256];
*(vp++) = U01*I0[332] - U11*I3[332] + loo2p*I2[476] - (oneo4zn)*I5[257];
*(vp++) = U01*I0[333] - U11*I3[333] + loo2p*I2[477];
*(vp++) = U01*I0[334] - U11*I3[334] + loo2p*I2[478] - (fouro4zn)*I5[258];
*(vp++) = U01*I0[335] - U11*I3[335] + loo2p*I2[479] - (threeo4zn)*I5[259];
*(vp++) = U01*I0[336] - U11*I3[336] + loo2p*I2[480] - (twoo4zn)*I5[260];
*(vp++) = U01*I0[337] - U11*I3[337] + loo2p*I2[481] - (oneo4zn)*I5[261];
*(vp++) = U01*I0[338] - U11*I3[338] + loo2p*I2[482];
*(vp++) = U01*I0[339] - U11*I3[339] + loo2p*I2[483] - (fiveo4zn)*I5[262];
*(vp++) = U01*I0[340] - U11*I3[340] + loo2p*I2[484] - (fouro4zn)*I5[263];
*(vp++) = U01*I0[341] - U11*I3[341] + loo2p*I2[485] - (threeo4zn)*I5[264];
*(vp++) = U01*I0[342] - U11*I3[342] + loo2p*I2[486] - (twoo4zn)*I5[265];
*(vp++) = U01*I0[343] - U11*I3[343] + loo2p*I2[487] - (oneo4zn)*I5[266];
*(vp++) = U01*I0[344] - U11*I3[344] + loo2p*I2[488];
*(vp++) = U01*I0[345] - U11*I3[345] + loo2p*I2[489] - (sixo4zn)*I5[267];
*(vp++) = U01*I0[346] - U11*I3[346] + loo2p*I2[490] - (fiveo4zn)*I5[268];
*(vp++) = U01*I0[347] - U11*I3[347] + loo2p*I2[491] - (fouro4zn)*I5[269];
*(vp++) = U01*I0[348] - U11*I3[348] + loo2p*I2[492] - (threeo4zn)*I5[270];
*(vp++) = U01*I0[349] - U11*I3[349] + loo2p*I2[493] - (twoo4zn)*I5[271];
*(vp++) = U01*I0[350] - U11*I3[350] + loo2p*I2[494] - (oneo4zn)*I5[272];
*(vp++) = U01*I0[351] - U11*I3[351] + loo2p*I2[495];
*(vp++) = U01*I0[352] - U11*I3[352] + loo2p*I2[496] - (seveno4zn)*I5[273];
*(vp++) = U01*I0[353] - U11*I3[353] + loo2p*I2[497] - (sixo4zn)*I5[274];
*(vp++) = U01*I0[354] - U11*I3[354] + loo2p*I2[498] - (fiveo4zn)*I5[275];
*(vp++) = U01*I0[355] - U11*I3[355] + loo2p*I2[499] - (fouro4zn)*I5[276];
*(vp++) = U01*I0[356] - U11*I3[356] + loo2p*I2[500] - (threeo4zn)*I5[277];
*(vp++) = U01*I0[357] - U11*I3[357] + loo2p*I2[501] - (twoo4zn)*I5[278];
*(vp++) = U01*I0[358] - U11*I3[358] + loo2p*I2[502] - (oneo4zn)*I5[279];
*(vp++) = U01*I0[359] - U11*I3[359] + loo2p*I2[503];
*(vp++) = U02*I0[324] - U12*I3[324] + loo2p*I2[504]
        + (threeo2z)*I1[180] - (threeo4zn)*I4[180];
*(vp++) = U02*I0[325] - U12*I3[325] + loo2p*I2[505]
        + (threeo2z)*I1[181] - (threeo4zn)*I4[181];
*(vp++) = U02*I0[326] - U12*I3[326] + loo2p*I2[506]
        + (threeo2z)*I1[182] - (threeo4zn)*I4[182] - (oneo4zn)*I5[252];
*(vp++) = U02*I0[327] - U12*I3[327] + loo2p*I2[507]
        + (threeo2z)*I1[183] - (threeo4zn)*I4[183];
*(vp++) = U02*I0[328] - U12*I3[328] + loo2p*I2[508]
        + (threeo2z)*I1[184] - (threeo4zn)*I4[184] - (oneo4zn)*I5[253];
*(vp++) = U02*I0[329] - U12*I3[329] + loo2p*I2[509]
        + (threeo2z)*I1[185] - (threeo4zn)*I4[185] - (twoo4zn)*I5[254];
*(vp++) = U02*I0[330] - U12*I3[330] + loo2p*I2[510]
        + (threeo2z)*I1[186] - (threeo4zn)*I4[186];
*(vp++) = U02*I0[331] - U12*I3[331] + loo2p*I2[511]
        + (threeo2z)*I1[187] - (threeo4zn)*I4[187] - (oneo4zn)*I5[255];
*(vp++) = U02*I0[332] - U12*I3[332] + loo2p*I2[512]
        + (threeo2z)*I1[188] - (threeo4zn)*I4[188] - (twoo4zn)*I5[256];
*(vp++) = U02*I0[333] - U12*I3[333] + loo2p*I2[513]
        + (threeo2z)*I1[189] - (threeo4zn)*I4[189] - (threeo4zn)*I5[257];
*(vp++) = U02*I0[334] - U12*I3[334] + loo2p*I2[514]
        + (threeo2z)*I1[190] - (threeo4zn)*I4[190];
*(vp++) = U02*I0[335] - U12*I3[335] + loo2p*I2[515]
        + (threeo2z)*I1[191] - (threeo4zn)*I4[191] - (oneo4zn)*I5[258];
*(vp++) = U02*I0[336] - U12*I3[336] + loo2p*I2[516]
        + (threeo2z)*I1[192] - (threeo4zn)*I4[192] - (twoo4zn)*I5[259];
*(vp++) = U02*I0[337] - U12*I3[337] + loo2p*I2[517]
        + (threeo2z)*I1[193] - (threeo4zn)*I4[193] - (threeo4zn)*I5[260];
*(vp++) = U02*I0[338] - U12*I3[338] + loo2p*I2[518]
        + (threeo2z)*I1[194] - (threeo4zn)*I4[194] - (fouro4zn)*I5[261];
*(vp++) = U02*I0[339] - U12*I3[339] + loo2p*I2[519]
        + (threeo2z)*I1[195] - (threeo4zn)*I4[195];
*(vp++) = U02*I0[340] - U12*I3[340] + loo2p*I2[520]
        + (threeo2z)*I1[196] - (threeo4zn)*I4[196] - (oneo4zn)*I5[262];
*(vp++) = U02*I0[341] - U12*I3[341] + loo2p*I2[521]
        + (threeo2z)*I1[197] - (threeo4zn)*I4[197] - (twoo4zn)*I5[263];
*(vp++) = U02*I0[342] - U12*I3[342] + loo2p*I2[522]
        + (threeo2z)*I1[198] - (threeo4zn)*I4[198] - (threeo4zn)*I5[264];
*(vp++) = U02*I0[343] - U12*I3[343] + loo2p*I2[523]
        + (threeo2z)*I1[199] - (threeo4zn)*I4[199] - (fouro4zn)*I5[265];
*(vp++) = U02*I0[344] - U12*I3[344] + loo2p*I2[524]
        + (threeo2z)*I1[200] - (threeo4zn)*I4[200] - (fiveo4zn)*I5[266];
*(vp++) = U02*I0[345] - U12*I3[345] + loo2p*I2[525]
        + (threeo2z)*I1[201] - (threeo4zn)*I4[201];
*(vp++) = U02*I0[346] - U12*I3[346] + loo2p*I2[526]
        + (threeo2z)*I1[202] - (threeo4zn)*I4[202] - (oneo4zn)*I5[267];
*(vp++) = U02*I0[347] - U12*I3[347] + loo2p*I2[527]
        + (threeo2z)*I1[203] - (threeo4zn)*I4[203] - (twoo4zn)*I5[268];
*(vp++) = U02*I0[348] - U12*I3[348] + loo2p*I2[528]
        + (threeo2z)*I1[204] - (threeo4zn)*I4[204] - (threeo4zn)*I5[269];
*(vp++) = U02*I0[349] - U12*I3[349] + loo2p*I2[529]
        + (threeo2z)*I1[205] - (threeo4zn)*I4[205] - (fouro4zn)*I5[270];
*(vp++) = U02*I0[350] - U12*I3[350] + loo2p*I2[530]
        + (threeo2z)*I1[206] - (threeo4zn)*I4[206] - (fiveo4zn)*I5[271];
*(vp++) = U02*I0[351] - U12*I3[351] + loo2p*I2[531]
        + (threeo2z)*I1[207] - (threeo4zn)*I4[207] - (sixo4zn)*I5[272];
*(vp++) = U02*I0[352] - U12*I3[352] + loo2p*I2[532]
        + (threeo2z)*I1[208] - (threeo4zn)*I4[208];
*(vp++) = U02*I0[353] - U12*I3[353] + loo2p*I2[533]
        + (threeo2z)*I1[209] - (threeo4zn)*I4[209] - (oneo4zn)*I5[273];
*(vp++) = U02*I0[354] - U12*I3[354] + loo2p*I2[534]
        + (threeo2z)*I1[210] - (threeo4zn)*I4[210] - (twoo4zn)*I5[274];
*(vp++) = U02*I0[355] - U12*I3[355] + loo2p*I2[535]
        + (threeo2z)*I1[211] - (threeo4zn)*I4[211] - (threeo4zn)*I5[275];
*(vp++) = U02*I0[356] - U12*I3[356] + loo2p*I2[536]
        + (threeo2z)*I1[212] - (threeo4zn)*I4[212] - (fouro4zn)*I5[276];
*(vp++) = U02*I0[357] - U12*I3[357] + loo2p*I2[537]
        + (threeo2z)*I1[213] - (threeo4zn)*I4[213] - (fiveo4zn)*I5[277];
*(vp++) = U02*I0[358] - U12*I3[358] + loo2p*I2[538]
        + (threeo2z)*I1[214] - (threeo4zn)*I4[214] - (sixo4zn)*I5[278];
*(vp++) = U02*I0[359] - U12*I3[359] + loo2p*I2[539]
        + (threeo2z)*I1[215] - (threeo4zn)*I4[215] - (seveno4zn)*I5[279];
return vp;
}
