/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* This machine-generated function computes a quartet of (0p|[r12,T1] integrals */

#include<libint/libint.h>

void t1hrr1_build_0p(REALTYPE *AB, REALTYPE *AC, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, int lc, int ld)
{
  int cd, cd_num, c_num, cp1_num, d_num;
  int pc, qc, d, ind_c, ind_cp1d;
  const REALTYPE *i0, *i1, *i2, *i3, *i4;
  const REALTYPE AB0 = AB[0];
  const REALTYPE AB1 = AB[1];
  const REALTYPE AB2 = AB[2];
  const REALTYPE AC0 = AC[0];
  const REALTYPE AC1 = AC[1];
  const REALTYPE AC2 = AC[2];
  static int io[] = { 1, 3, 6, 10, 15, 21, 28, 36, 45, 55, 66, 78};

  c_num = io[lc];
  cp1_num = io[lc+1];
  d_num = io[ld];

  i0 = I0;
  i2 = I2;
  i1 = I1;
  i3 = I3;
  i4 = I4;
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 1*(c_num*d_num);
  i2 = I2 + 1*(c_num*d_num);
  i1 = I1;
  i3 = I3;
  i4 = I4;
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 2*(c_num*d_num);
  i2 = I2 + 2*(c_num*d_num);
  i1 = I1;
  i3 = I3;
  i4 = I4;
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

}
