/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ds|[r12,T2]|hs) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _t2_build_d0h0(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  REALTYPE onezdon;
  REALTYPE twozdon;
  REALTYPE threezdon;
  REALTYPE fourzdon;
  REALTYPE fivezdon;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  onezdon = 1.0*(Data->twozeta_d*Data->oo2n);
  twozdon = 2.0*(Data->twozeta_d*Data->oo2n);
  threezdon = 3.0*(Data->twozeta_d*Data->oo2n);
  fourzdon = 4.0*(Data->twozeta_d*Data->oo2n);
  fivezdon = 5.0*(Data->twozeta_d*Data->oo2n);
  U10 = ShellData->CD[0]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U11 = ShellData->CD[1]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U12 = ShellData->CD[2]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U0  = (Data->twozeta_c - Data->twozeta_d*(Data->twozeta_c*ShellData->CDdotCA + 6.000000))*Data->oo2n;

*(vp++) = U0*I0[0]
          - U10*(I1[0] - I2[0])
          - U11*(I1[1] - I2[21])
          - U12*(I1[2] - I2[42])
          + (fivezdon)*(I3[0] + AC0*I4[0]);
*(vp++) = U0*I0[1]
          - U10*(I1[1] - I2[1])
          - U11*(I1[3] - I2[22])
          - U12*(I1[4] - I2[43])
          + (fourzdon)*(I3[1] + AC0*I4[1])
          + (onezdon)*(I3[15] + AC1*I4[0]);
*(vp++) = U0*I0[2]
          - U10*(I1[2] - I2[2])
          - U11*(I1[4] - I2[23])
          - U12*(I1[5] - I2[44])
          + (fourzdon)*(I3[2] + AC0*I4[2])
          + (onezdon)*(I3[30] + AC2*I4[0]);
*(vp++) = U0*I0[3]
          - U10*(I1[3] - I2[3])
          - U11*(I1[6] - I2[24])
          - U12*(I1[7] - I2[45])
          + (threezdon)*(I3[3] + AC0*I4[3])
          + (twozdon)*(I3[16] + AC1*I4[1]);
*(vp++) = U0*I0[4]
          - U10*(I1[4] - I2[4])
          - U11*(I1[7] - I2[25])
          - U12*(I1[8] - I2[46])
          + (threezdon)*(I3[4] + AC0*I4[4])
          + (onezdon)*(I3[17] + AC1*I4[2])
          + (onezdon)*(I3[31] + AC2*I4[1]);
*(vp++) = U0*I0[5]
          - U10*(I1[5] - I2[5])
          - U11*(I1[8] - I2[26])
          - U12*(I1[9] - I2[47])
          + (threezdon)*(I3[5] + AC0*I4[5])
          + (twozdon)*(I3[32] + AC2*I4[2]);
*(vp++) = U0*I0[6]
          - U10*(I1[6] - I2[6])
          - U11*(I1[10] - I2[27])
          - U12*(I1[11] - I2[48])
          + (twozdon)*(I3[6] + AC0*I4[6])
          + (threezdon)*(I3[18] + AC1*I4[3]);
*(vp++) = U0*I0[7]
          - U10*(I1[7] - I2[7])
          - U11*(I1[11] - I2[28])
          - U12*(I1[12] - I2[49])
          + (twozdon)*(I3[7] + AC0*I4[7])
          + (twozdon)*(I3[19] + AC1*I4[4])
          + (onezdon)*(I3[33] + AC2*I4[3]);
*(vp++) = U0*I0[8]
          - U10*(I1[8] - I2[8])
          - U11*(I1[12] - I2[29])
          - U12*(I1[13] - I2[50])
          + (twozdon)*(I3[8] + AC0*I4[8])
          + (onezdon)*(I3[20] + AC1*I4[5])
          + (twozdon)*(I3[34] + AC2*I4[4]);
*(vp++) = U0*I0[9]
          - U10*(I1[9] - I2[9])
          - U11*(I1[13] - I2[30])
          - U12*(I1[14] - I2[51])
          + (twozdon)*(I3[9] + AC0*I4[9])
          + (threezdon)*(I3[35] + AC2*I4[5]);
*(vp++) = U0*I0[10]
          - U10*(I1[10] - I2[10])
          - U11*(I1[15] - I2[31])
          - U12*(I1[16] - I2[52])
          + (onezdon)*(I3[10] + AC0*I4[10])
          + (fourzdon)*(I3[21] + AC1*I4[6]);
*(vp++) = U0*I0[11]
          - U10*(I1[11] - I2[11])
          - U11*(I1[16] - I2[32])
          - U12*(I1[17] - I2[53])
          + (onezdon)*(I3[11] + AC0*I4[11])
          + (threezdon)*(I3[22] + AC1*I4[7])
          + (onezdon)*(I3[36] + AC2*I4[6]);
*(vp++) = U0*I0[12]
          - U10*(I1[12] - I2[12])
          - U11*(I1[17] - I2[33])
          - U12*(I1[18] - I2[54])
          + (onezdon)*(I3[12] + AC0*I4[12])
          + (twozdon)*(I3[23] + AC1*I4[8])
          + (twozdon)*(I3[37] + AC2*I4[7]);
*(vp++) = U0*I0[13]
          - U10*(I1[13] - I2[13])
          - U11*(I1[18] - I2[34])
          - U12*(I1[19] - I2[55])
          + (onezdon)*(I3[13] + AC0*I4[13])
          + (onezdon)*(I3[24] + AC1*I4[9])
          + (threezdon)*(I3[38] + AC2*I4[8]);
*(vp++) = U0*I0[14]
          - U10*(I1[14] - I2[14])
          - U11*(I1[19] - I2[35])
          - U12*(I1[20] - I2[56])
          + (onezdon)*(I3[14] + AC0*I4[14])
          + (fourzdon)*(I3[39] + AC2*I4[9]);
*(vp++) = U0*I0[15]
          - U10*(I1[15] - I2[15])
          - U11*(I1[21] - I2[36])
          - U12*(I1[22] - I2[57])
          + (fivezdon)*(I3[25] + AC1*I4[10]);
*(vp++) = U0*I0[16]
          - U10*(I1[16] - I2[16])
          - U11*(I1[22] - I2[37])
          - U12*(I1[23] - I2[58])
          + (fourzdon)*(I3[26] + AC1*I4[11])
          + (onezdon)*(I3[40] + AC2*I4[10]);
*(vp++) = U0*I0[17]
          - U10*(I1[17] - I2[17])
          - U11*(I1[23] - I2[38])
          - U12*(I1[24] - I2[59])
          + (threezdon)*(I3[27] + AC1*I4[12])
          + (twozdon)*(I3[41] + AC2*I4[11]);
*(vp++) = U0*I0[18]
          - U10*(I1[18] - I2[18])
          - U11*(I1[24] - I2[39])
          - U12*(I1[25] - I2[60])
          + (twozdon)*(I3[28] + AC1*I4[13])
          + (threezdon)*(I3[42] + AC2*I4[12]);
*(vp++) = U0*I0[19]
          - U10*(I1[19] - I2[19])
          - U11*(I1[25] - I2[40])
          - U12*(I1[26] - I2[61])
          + (onezdon)*(I3[29] + AC1*I4[14])
          + (fourzdon)*(I3[43] + AC2*I4[13]);
*(vp++) = U0*I0[20]
          - U10*(I1[20] - I2[20])
          - U11*(I1[26] - I2[41])
          - U12*(I1[27] - I2[62])
          + (fivezdon)*(I3[44] + AC2*I4[14]);
*(vp++) = U0*I0[21]
          - U10*(I1[28] - I2[21])
          - U11*(I1[29] - I2[63])
          - U12*(I1[30] - I2[84])
          + (fivezdon)*(I3[15] + AC0*I4[15]);
*(vp++) = U0*I0[22]
          - U10*(I1[29] - I2[22])
          - U11*(I1[31] - I2[64])
          - U12*(I1[32] - I2[85])
          + (fourzdon)*(I3[16] + AC0*I4[16])
          + (onezdon)*(I3[45] + AC1*I4[15]);
*(vp++) = U0*I0[23]
          - U10*(I1[30] - I2[23])
          - U11*(I1[32] - I2[65])
          - U12*(I1[33] - I2[86])
          + (fourzdon)*(I3[17] + AC0*I4[17])
          + (onezdon)*(I3[60] + AC2*I4[15]);
*(vp++) = U0*I0[24]
          - U10*(I1[31] - I2[24])
          - U11*(I1[34] - I2[66])
          - U12*(I1[35] - I2[87])
          + (threezdon)*(I3[18] + AC0*I4[18])
          + (twozdon)*(I3[46] + AC1*I4[16]);
*(vp++) = U0*I0[25]
          - U10*(I1[32] - I2[25])
          - U11*(I1[35] - I2[67])
          - U12*(I1[36] - I2[88])
          + (threezdon)*(I3[19] + AC0*I4[19])
          + (onezdon)*(I3[47] + AC1*I4[17])
          + (onezdon)*(I3[61] + AC2*I4[16]);
*(vp++) = U0*I0[26]
          - U10*(I1[33] - I2[26])
          - U11*(I1[36] - I2[68])
          - U12*(I1[37] - I2[89])
          + (threezdon)*(I3[20] + AC0*I4[20])
          + (twozdon)*(I3[62] + AC2*I4[17]);
*(vp++) = U0*I0[27]
          - U10*(I1[34] - I2[27])
          - U11*(I1[38] - I2[69])
          - U12*(I1[39] - I2[90])
          + (twozdon)*(I3[21] + AC0*I4[21])
          + (threezdon)*(I3[48] + AC1*I4[18]);
*(vp++) = U0*I0[28]
          - U10*(I1[35] - I2[28])
          - U11*(I1[39] - I2[70])
          - U12*(I1[40] - I2[91])
          + (twozdon)*(I3[22] + AC0*I4[22])
          + (twozdon)*(I3[49] + AC1*I4[19])
          + (onezdon)*(I3[63] + AC2*I4[18]);
*(vp++) = U0*I0[29]
          - U10*(I1[36] - I2[29])
          - U11*(I1[40] - I2[71])
          - U12*(I1[41] - I2[92])
          + (twozdon)*(I3[23] + AC0*I4[23])
          + (onezdon)*(I3[50] + AC1*I4[20])
          + (twozdon)*(I3[64] + AC2*I4[19]);
*(vp++) = U0*I0[30]
          - U10*(I1[37] - I2[30])
          - U11*(I1[41] - I2[72])
          - U12*(I1[42] - I2[93])
          + (twozdon)*(I3[24] + AC0*I4[24])
          + (threezdon)*(I3[65] + AC2*I4[20]);
*(vp++) = U0*I0[31]
          - U10*(I1[38] - I2[31])
          - U11*(I1[43] - I2[73])
          - U12*(I1[44] - I2[94])
          + (onezdon)*(I3[25] + AC0*I4[25])
          + (fourzdon)*(I3[51] + AC1*I4[21]);
*(vp++) = U0*I0[32]
          - U10*(I1[39] - I2[32])
          - U11*(I1[44] - I2[74])
          - U12*(I1[45] - I2[95])
          + (onezdon)*(I3[26] + AC0*I4[26])
          + (threezdon)*(I3[52] + AC1*I4[22])
          + (onezdon)*(I3[66] + AC2*I4[21]);
*(vp++) = U0*I0[33]
          - U10*(I1[40] - I2[33])
          - U11*(I1[45] - I2[75])
          - U12*(I1[46] - I2[96])
          + (onezdon)*(I3[27] + AC0*I4[27])
          + (twozdon)*(I3[53] + AC1*I4[23])
          + (twozdon)*(I3[67] + AC2*I4[22]);
*(vp++) = U0*I0[34]
          - U10*(I1[41] - I2[34])
          - U11*(I1[46] - I2[76])
          - U12*(I1[47] - I2[97])
          + (onezdon)*(I3[28] + AC0*I4[28])
          + (onezdon)*(I3[54] + AC1*I4[24])
          + (threezdon)*(I3[68] + AC2*I4[23]);
*(vp++) = U0*I0[35]
          - U10*(I1[42] - I2[35])
          - U11*(I1[47] - I2[77])
          - U12*(I1[48] - I2[98])
          + (onezdon)*(I3[29] + AC0*I4[29])
          + (fourzdon)*(I3[69] + AC2*I4[24]);
*(vp++) = U0*I0[36]
          - U10*(I1[43] - I2[36])
          - U11*(I1[49] - I2[78])
          - U12*(I1[50] - I2[99])
          + (fivezdon)*(I3[55] + AC1*I4[25]);
*(vp++) = U0*I0[37]
          - U10*(I1[44] - I2[37])
          - U11*(I1[50] - I2[79])
          - U12*(I1[51] - I2[100])
          + (fourzdon)*(I3[56] + AC1*I4[26])
          + (onezdon)*(I3[70] + AC2*I4[25]);
*(vp++) = U0*I0[38]
          - U10*(I1[45] - I2[38])
          - U11*(I1[51] - I2[80])
          - U12*(I1[52] - I2[101])
          + (threezdon)*(I3[57] + AC1*I4[27])
          + (twozdon)*(I3[71] + AC2*I4[26]);
*(vp++) = U0*I0[39]
          - U10*(I1[46] - I2[39])
          - U11*(I1[52] - I2[81])
          - U12*(I1[53] - I2[102])
          + (twozdon)*(I3[58] + AC1*I4[28])
          + (threezdon)*(I3[72] + AC2*I4[27]);
*(vp++) = U0*I0[40]
          - U10*(I1[47] - I2[40])
          - U11*(I1[53] - I2[82])
          - U12*(I1[54] - I2[103])
          + (onezdon)*(I3[59] + AC1*I4[29])
          + (fourzdon)*(I3[73] + AC2*I4[28]);
*(vp++) = U0*I0[41]
          - U10*(I1[48] - I2[41])
          - U11*(I1[54] - I2[83])
          - U12*(I1[55] - I2[104])
          + (fivezdon)*(I3[74] + AC2*I4[29]);
*(vp++) = U0*I0[42]
          - U10*(I1[56] - I2[42])
          - U11*(I1[57] - I2[84])
          - U12*(I1[58] - I2[105])
          + (fivezdon)*(I3[30] + AC0*I4[30]);
*(vp++) = U0*I0[43]
          - U10*(I1[57] - I2[43])
          - U11*(I1[59] - I2[85])
          - U12*(I1[60] - I2[106])
          + (fourzdon)*(I3[31] + AC0*I4[31])
          + (onezdon)*(I3[60] + AC1*I4[30]);
*(vp++) = U0*I0[44]
          - U10*(I1[58] - I2[44])
          - U11*(I1[60] - I2[86])
          - U12*(I1[61] - I2[107])
          + (fourzdon)*(I3[32] + AC0*I4[32])
          + (onezdon)*(I3[75] + AC2*I4[30]);
*(vp++) = U0*I0[45]
          - U10*(I1[59] - I2[45])
          - U11*(I1[62] - I2[87])
          - U12*(I1[63] - I2[108])
          + (threezdon)*(I3[33] + AC0*I4[33])
          + (twozdon)*(I3[61] + AC1*I4[31]);
*(vp++) = U0*I0[46]
          - U10*(I1[60] - I2[46])
          - U11*(I1[63] - I2[88])
          - U12*(I1[64] - I2[109])
          + (threezdon)*(I3[34] + AC0*I4[34])
          + (onezdon)*(I3[62] + AC1*I4[32])
          + (onezdon)*(I3[76] + AC2*I4[31]);
*(vp++) = U0*I0[47]
          - U10*(I1[61] - I2[47])
          - U11*(I1[64] - I2[89])
          - U12*(I1[65] - I2[110])
          + (threezdon)*(I3[35] + AC0*I4[35])
          + (twozdon)*(I3[77] + AC2*I4[32]);
*(vp++) = U0*I0[48]
          - U10*(I1[62] - I2[48])
          - U11*(I1[66] - I2[90])
          - U12*(I1[67] - I2[111])
          + (twozdon)*(I3[36] + AC0*I4[36])
          + (threezdon)*(I3[63] + AC1*I4[33]);
*(vp++) = U0*I0[49]
          - U10*(I1[63] - I2[49])
          - U11*(I1[67] - I2[91])
          - U12*(I1[68] - I2[112])
          + (twozdon)*(I3[37] + AC0*I4[37])
          + (twozdon)*(I3[64] + AC1*I4[34])
          + (onezdon)*(I3[78] + AC2*I4[33]);
*(vp++) = U0*I0[50]
          - U10*(I1[64] - I2[50])
          - U11*(I1[68] - I2[92])
          - U12*(I1[69] - I2[113])
          + (twozdon)*(I3[38] + AC0*I4[38])
          + (onezdon)*(I3[65] + AC1*I4[35])
          + (twozdon)*(I3[79] + AC2*I4[34]);
*(vp++) = U0*I0[51]
          - U10*(I1[65] - I2[51])
          - U11*(I1[69] - I2[93])
          - U12*(I1[70] - I2[114])
          + (twozdon)*(I3[39] + AC0*I4[39])
          + (threezdon)*(I3[80] + AC2*I4[35]);
*(vp++) = U0*I0[52]
          - U10*(I1[66] - I2[52])
          - U11*(I1[71] - I2[94])
          - U12*(I1[72] - I2[115])
          + (onezdon)*(I3[40] + AC0*I4[40])
          + (fourzdon)*(I3[66] + AC1*I4[36]);
*(vp++) = U0*I0[53]
          - U10*(I1[67] - I2[53])
          - U11*(I1[72] - I2[95])
          - U12*(I1[73] - I2[116])
          + (onezdon)*(I3[41] + AC0*I4[41])
          + (threezdon)*(I3[67] + AC1*I4[37])
          + (onezdon)*(I3[81] + AC2*I4[36]);
*(vp++) = U0*I0[54]
          - U10*(I1[68] - I2[54])
          - U11*(I1[73] - I2[96])
          - U12*(I1[74] - I2[117])
          + (onezdon)*(I3[42] + AC0*I4[42])
          + (twozdon)*(I3[68] + AC1*I4[38])
          + (twozdon)*(I3[82] + AC2*I4[37]);
*(vp++) = U0*I0[55]
          - U10*(I1[69] - I2[55])
          - U11*(I1[74] - I2[97])
          - U12*(I1[75] - I2[118])
          + (onezdon)*(I3[43] + AC0*I4[43])
          + (onezdon)*(I3[69] + AC1*I4[39])
          + (threezdon)*(I3[83] + AC2*I4[38]);
*(vp++) = U0*I0[56]
          - U10*(I1[70] - I2[56])
          - U11*(I1[75] - I2[98])
          - U12*(I1[76] - I2[119])
          + (onezdon)*(I3[44] + AC0*I4[44])
          + (fourzdon)*(I3[84] + AC2*I4[39]);
*(vp++) = U0*I0[57]
          - U10*(I1[71] - I2[57])
          - U11*(I1[77] - I2[99])
          - U12*(I1[78] - I2[120])
          + (fivezdon)*(I3[70] + AC1*I4[40]);
*(vp++) = U0*I0[58]
          - U10*(I1[72] - I2[58])
          - U11*(I1[78] - I2[100])
          - U12*(I1[79] - I2[121])
          + (fourzdon)*(I3[71] + AC1*I4[41])
          + (onezdon)*(I3[85] + AC2*I4[40]);
*(vp++) = U0*I0[59]
          - U10*(I1[73] - I2[59])
          - U11*(I1[79] - I2[101])
          - U12*(I1[80] - I2[122])
          + (threezdon)*(I3[72] + AC1*I4[42])
          + (twozdon)*(I3[86] + AC2*I4[41]);
*(vp++) = U0*I0[60]
          - U10*(I1[74] - I2[60])
          - U11*(I1[80] - I2[102])
          - U12*(I1[81] - I2[123])
          + (twozdon)*(I3[73] + AC1*I4[43])
          + (threezdon)*(I3[87] + AC2*I4[42]);
*(vp++) = U0*I0[61]
          - U10*(I1[75] - I2[61])
          - U11*(I1[81] - I2[103])
          - U12*(I1[82] - I2[124])
          + (onezdon)*(I3[74] + AC1*I4[44])
          + (fourzdon)*(I3[88] + AC2*I4[43]);
*(vp++) = U0*I0[62]
          - U10*(I1[76] - I2[62])
          - U11*(I1[82] - I2[104])
          - U12*(I1[83] - I2[125])
          + (fivezdon)*(I3[89] + AC2*I4[44]);
*(vp++) = U0*I0[63]
          - U10*(I1[84] - I2[63])
          - U11*(I1[85] - I2[126])
          - U12*(I1[86] - I2[147])
          + (fivezdon)*(I3[45] + AC0*I4[45]);
*(vp++) = U0*I0[64]
          - U10*(I1[85] - I2[64])
          - U11*(I1[87] - I2[127])
          - U12*(I1[88] - I2[148])
          + (fourzdon)*(I3[46] + AC0*I4[46])
          + (onezdon)*(I3[90] + AC1*I4[45]);
*(vp++) = U0*I0[65]
          - U10*(I1[86] - I2[65])
          - U11*(I1[88] - I2[128])
          - U12*(I1[89] - I2[149])
          + (fourzdon)*(I3[47] + AC0*I4[47])
          + (onezdon)*(I3[105] + AC2*I4[45]);
*(vp++) = U0*I0[66]
          - U10*(I1[87] - I2[66])
          - U11*(I1[90] - I2[129])
          - U12*(I1[91] - I2[150])
          + (threezdon)*(I3[48] + AC0*I4[48])
          + (twozdon)*(I3[91] + AC1*I4[46]);
*(vp++) = U0*I0[67]
          - U10*(I1[88] - I2[67])
          - U11*(I1[91] - I2[130])
          - U12*(I1[92] - I2[151])
          + (threezdon)*(I3[49] + AC0*I4[49])
          + (onezdon)*(I3[92] + AC1*I4[47])
          + (onezdon)*(I3[106] + AC2*I4[46]);
*(vp++) = U0*I0[68]
          - U10*(I1[89] - I2[68])
          - U11*(I1[92] - I2[131])
          - U12*(I1[93] - I2[152])
          + (threezdon)*(I3[50] + AC0*I4[50])
          + (twozdon)*(I3[107] + AC2*I4[47]);
*(vp++) = U0*I0[69]
          - U10*(I1[90] - I2[69])
          - U11*(I1[94] - I2[132])
          - U12*(I1[95] - I2[153])
          + (twozdon)*(I3[51] + AC0*I4[51])
          + (threezdon)*(I3[93] + AC1*I4[48]);
*(vp++) = U0*I0[70]
          - U10*(I1[91] - I2[70])
          - U11*(I1[95] - I2[133])
          - U12*(I1[96] - I2[154])
          + (twozdon)*(I3[52] + AC0*I4[52])
          + (twozdon)*(I3[94] + AC1*I4[49])
          + (onezdon)*(I3[108] + AC2*I4[48]);
*(vp++) = U0*I0[71]
          - U10*(I1[92] - I2[71])
          - U11*(I1[96] - I2[134])
          - U12*(I1[97] - I2[155])
          + (twozdon)*(I3[53] + AC0*I4[53])
          + (onezdon)*(I3[95] + AC1*I4[50])
          + (twozdon)*(I3[109] + AC2*I4[49]);
*(vp++) = U0*I0[72]
          - U10*(I1[93] - I2[72])
          - U11*(I1[97] - I2[135])
          - U12*(I1[98] - I2[156])
          + (twozdon)*(I3[54] + AC0*I4[54])
          + (threezdon)*(I3[110] + AC2*I4[50]);
*(vp++) = U0*I0[73]
          - U10*(I1[94] - I2[73])
          - U11*(I1[99] - I2[136])
          - U12*(I1[100] - I2[157])
          + (onezdon)*(I3[55] + AC0*I4[55])
          + (fourzdon)*(I3[96] + AC1*I4[51]);
*(vp++) = U0*I0[74]
          - U10*(I1[95] - I2[74])
          - U11*(I1[100] - I2[137])
          - U12*(I1[101] - I2[158])
          + (onezdon)*(I3[56] + AC0*I4[56])
          + (threezdon)*(I3[97] + AC1*I4[52])
          + (onezdon)*(I3[111] + AC2*I4[51]);
*(vp++) = U0*I0[75]
          - U10*(I1[96] - I2[75])
          - U11*(I1[101] - I2[138])
          - U12*(I1[102] - I2[159])
          + (onezdon)*(I3[57] + AC0*I4[57])
          + (twozdon)*(I3[98] + AC1*I4[53])
          + (twozdon)*(I3[112] + AC2*I4[52]);
*(vp++) = U0*I0[76]
          - U10*(I1[97] - I2[76])
          - U11*(I1[102] - I2[139])
          - U12*(I1[103] - I2[160])
          + (onezdon)*(I3[58] + AC0*I4[58])
          + (onezdon)*(I3[99] + AC1*I4[54])
          + (threezdon)*(I3[113] + AC2*I4[53]);
*(vp++) = U0*I0[77]
          - U10*(I1[98] - I2[77])
          - U11*(I1[103] - I2[140])
          - U12*(I1[104] - I2[161])
          + (onezdon)*(I3[59] + AC0*I4[59])
          + (fourzdon)*(I3[114] + AC2*I4[54]);
*(vp++) = U0*I0[78]
          - U10*(I1[99] - I2[78])
          - U11*(I1[105] - I2[141])
          - U12*(I1[106] - I2[162])
          + (fivezdon)*(I3[100] + AC1*I4[55]);
*(vp++) = U0*I0[79]
          - U10*(I1[100] - I2[79])
          - U11*(I1[106] - I2[142])
          - U12*(I1[107] - I2[163])
          + (fourzdon)*(I3[101] + AC1*I4[56])
          + (onezdon)*(I3[115] + AC2*I4[55]);
*(vp++) = U0*I0[80]
          - U10*(I1[101] - I2[80])
          - U11*(I1[107] - I2[143])
          - U12*(I1[108] - I2[164])
          + (threezdon)*(I3[102] + AC1*I4[57])
          + (twozdon)*(I3[116] + AC2*I4[56]);
*(vp++) = U0*I0[81]
          - U10*(I1[102] - I2[81])
          - U11*(I1[108] - I2[144])
          - U12*(I1[109] - I2[165])
          + (twozdon)*(I3[103] + AC1*I4[58])
          + (threezdon)*(I3[117] + AC2*I4[57]);
*(vp++) = U0*I0[82]
          - U10*(I1[103] - I2[82])
          - U11*(I1[109] - I2[145])
          - U12*(I1[110] - I2[166])
          + (onezdon)*(I3[104] + AC1*I4[59])
          + (fourzdon)*(I3[118] + AC2*I4[58]);
*(vp++) = U0*I0[83]
          - U10*(I1[104] - I2[83])
          - U11*(I1[110] - I2[146])
          - U12*(I1[111] - I2[167])
          + (fivezdon)*(I3[119] + AC2*I4[59]);
*(vp++) = U0*I0[84]
          - U10*(I1[112] - I2[84])
          - U11*(I1[113] - I2[147])
          - U12*(I1[114] - I2[168])
          + (fivezdon)*(I3[60] + AC0*I4[60]);
*(vp++) = U0*I0[85]
          - U10*(I1[113] - I2[85])
          - U11*(I1[115] - I2[148])
          - U12*(I1[116] - I2[169])
          + (fourzdon)*(I3[61] + AC0*I4[61])
          + (onezdon)*(I3[105] + AC1*I4[60]);
*(vp++) = U0*I0[86]
          - U10*(I1[114] - I2[86])
          - U11*(I1[116] - I2[149])
          - U12*(I1[117] - I2[170])
          + (fourzdon)*(I3[62] + AC0*I4[62])
          + (onezdon)*(I3[120] + AC2*I4[60]);
*(vp++) = U0*I0[87]
          - U10*(I1[115] - I2[87])
          - U11*(I1[118] - I2[150])
          - U12*(I1[119] - I2[171])
          + (threezdon)*(I3[63] + AC0*I4[63])
          + (twozdon)*(I3[106] + AC1*I4[61]);
*(vp++) = U0*I0[88]
          - U10*(I1[116] - I2[88])
          - U11*(I1[119] - I2[151])
          - U12*(I1[120] - I2[172])
          + (threezdon)*(I3[64] + AC0*I4[64])
          + (onezdon)*(I3[107] + AC1*I4[62])
          + (onezdon)*(I3[121] + AC2*I4[61]);
*(vp++) = U0*I0[89]
          - U10*(I1[117] - I2[89])
          - U11*(I1[120] - I2[152])
          - U12*(I1[121] - I2[173])
          + (threezdon)*(I3[65] + AC0*I4[65])
          + (twozdon)*(I3[122] + AC2*I4[62]);
*(vp++) = U0*I0[90]
          - U10*(I1[118] - I2[90])
          - U11*(I1[122] - I2[153])
          - U12*(I1[123] - I2[174])
          + (twozdon)*(I3[66] + AC0*I4[66])
          + (threezdon)*(I3[108] + AC1*I4[63]);
*(vp++) = U0*I0[91]
          - U10*(I1[119] - I2[91])
          - U11*(I1[123] - I2[154])
          - U12*(I1[124] - I2[175])
          + (twozdon)*(I3[67] + AC0*I4[67])
          + (twozdon)*(I3[109] + AC1*I4[64])
          + (onezdon)*(I3[123] + AC2*I4[63]);
*(vp++) = U0*I0[92]
          - U10*(I1[120] - I2[92])
          - U11*(I1[124] - I2[155])
          - U12*(I1[125] - I2[176])
          + (twozdon)*(I3[68] + AC0*I4[68])
          + (onezdon)*(I3[110] + AC1*I4[65])
          + (twozdon)*(I3[124] + AC2*I4[64]);
*(vp++) = U0*I0[93]
          - U10*(I1[121] - I2[93])
          - U11*(I1[125] - I2[156])
          - U12*(I1[126] - I2[177])
          + (twozdon)*(I3[69] + AC0*I4[69])
          + (threezdon)*(I3[125] + AC2*I4[65]);
*(vp++) = U0*I0[94]
          - U10*(I1[122] - I2[94])
          - U11*(I1[127] - I2[157])
          - U12*(I1[128] - I2[178])
          + (onezdon)*(I3[70] + AC0*I4[70])
          + (fourzdon)*(I3[111] + AC1*I4[66]);
*(vp++) = U0*I0[95]
          - U10*(I1[123] - I2[95])
          - U11*(I1[128] - I2[158])
          - U12*(I1[129] - I2[179])
          + (onezdon)*(I3[71] + AC0*I4[71])
          + (threezdon)*(I3[112] + AC1*I4[67])
          + (onezdon)*(I3[126] + AC2*I4[66]);
*(vp++) = U0*I0[96]
          - U10*(I1[124] - I2[96])
          - U11*(I1[129] - I2[159])
          - U12*(I1[130] - I2[180])
          + (onezdon)*(I3[72] + AC0*I4[72])
          + (twozdon)*(I3[113] + AC1*I4[68])
          + (twozdon)*(I3[127] + AC2*I4[67]);
*(vp++) = U0*I0[97]
          - U10*(I1[125] - I2[97])
          - U11*(I1[130] - I2[160])
          - U12*(I1[131] - I2[181])
          + (onezdon)*(I3[73] + AC0*I4[73])
          + (onezdon)*(I3[114] + AC1*I4[69])
          + (threezdon)*(I3[128] + AC2*I4[68]);
*(vp++) = U0*I0[98]
          - U10*(I1[126] - I2[98])
          - U11*(I1[131] - I2[161])
          - U12*(I1[132] - I2[182])
          + (onezdon)*(I3[74] + AC0*I4[74])
          + (fourzdon)*(I3[129] + AC2*I4[69]);
*(vp++) = U0*I0[99]
          - U10*(I1[127] - I2[99])
          - U11*(I1[133] - I2[162])
          - U12*(I1[134] - I2[183])
          + (fivezdon)*(I3[115] + AC1*I4[70]);
*(vp++) = U0*I0[100]
          - U10*(I1[128] - I2[100])
          - U11*(I1[134] - I2[163])
          - U12*(I1[135] - I2[184])
          + (fourzdon)*(I3[116] + AC1*I4[71])
          + (onezdon)*(I3[130] + AC2*I4[70]);
*(vp++) = U0*I0[101]
          - U10*(I1[129] - I2[101])
          - U11*(I1[135] - I2[164])
          - U12*(I1[136] - I2[185])
          + (threezdon)*(I3[117] + AC1*I4[72])
          + (twozdon)*(I3[131] + AC2*I4[71]);
*(vp++) = U0*I0[102]
          - U10*(I1[130] - I2[102])
          - U11*(I1[136] - I2[165])
          - U12*(I1[137] - I2[186])
          + (twozdon)*(I3[118] + AC1*I4[73])
          + (threezdon)*(I3[132] + AC2*I4[72]);
*(vp++) = U0*I0[103]
          - U10*(I1[131] - I2[103])
          - U11*(I1[137] - I2[166])
          - U12*(I1[138] - I2[187])
          + (onezdon)*(I3[119] + AC1*I4[74])
          + (fourzdon)*(I3[133] + AC2*I4[73]);
*(vp++) = U0*I0[104]
          - U10*(I1[132] - I2[104])
          - U11*(I1[138] - I2[167])
          - U12*(I1[139] - I2[188])
          + (fivezdon)*(I3[134] + AC2*I4[74]);
*(vp++) = U0*I0[105]
          - U10*(I1[140] - I2[105])
          - U11*(I1[141] - I2[168])
          - U12*(I1[142] - I2[189])
          + (fivezdon)*(I3[75] + AC0*I4[75]);
*(vp++) = U0*I0[106]
          - U10*(I1[141] - I2[106])
          - U11*(I1[143] - I2[169])
          - U12*(I1[144] - I2[190])
          + (fourzdon)*(I3[76] + AC0*I4[76])
          + (onezdon)*(I3[120] + AC1*I4[75]);
*(vp++) = U0*I0[107]
          - U10*(I1[142] - I2[107])
          - U11*(I1[144] - I2[170])
          - U12*(I1[145] - I2[191])
          + (fourzdon)*(I3[77] + AC0*I4[77])
          + (onezdon)*(I3[135] + AC2*I4[75]);
*(vp++) = U0*I0[108]
          - U10*(I1[143] - I2[108])
          - U11*(I1[146] - I2[171])
          - U12*(I1[147] - I2[192])
          + (threezdon)*(I3[78] + AC0*I4[78])
          + (twozdon)*(I3[121] + AC1*I4[76]);
*(vp++) = U0*I0[109]
          - U10*(I1[144] - I2[109])
          - U11*(I1[147] - I2[172])
          - U12*(I1[148] - I2[193])
          + (threezdon)*(I3[79] + AC0*I4[79])
          + (onezdon)*(I3[122] + AC1*I4[77])
          + (onezdon)*(I3[136] + AC2*I4[76]);
*(vp++) = U0*I0[110]
          - U10*(I1[145] - I2[110])
          - U11*(I1[148] - I2[173])
          - U12*(I1[149] - I2[194])
          + (threezdon)*(I3[80] + AC0*I4[80])
          + (twozdon)*(I3[137] + AC2*I4[77]);
*(vp++) = U0*I0[111]
          - U10*(I1[146] - I2[111])
          - U11*(I1[150] - I2[174])
          - U12*(I1[151] - I2[195])
          + (twozdon)*(I3[81] + AC0*I4[81])
          + (threezdon)*(I3[123] + AC1*I4[78]);
*(vp++) = U0*I0[112]
          - U10*(I1[147] - I2[112])
          - U11*(I1[151] - I2[175])
          - U12*(I1[152] - I2[196])
          + (twozdon)*(I3[82] + AC0*I4[82])
          + (twozdon)*(I3[124] + AC1*I4[79])
          + (onezdon)*(I3[138] + AC2*I4[78]);
*(vp++) = U0*I0[113]
          - U10*(I1[148] - I2[113])
          - U11*(I1[152] - I2[176])
          - U12*(I1[153] - I2[197])
          + (twozdon)*(I3[83] + AC0*I4[83])
          + (onezdon)*(I3[125] + AC1*I4[80])
          + (twozdon)*(I3[139] + AC2*I4[79]);
*(vp++) = U0*I0[114]
          - U10*(I1[149] - I2[114])
          - U11*(I1[153] - I2[177])
          - U12*(I1[154] - I2[198])
          + (twozdon)*(I3[84] + AC0*I4[84])
          + (threezdon)*(I3[140] + AC2*I4[80]);
*(vp++) = U0*I0[115]
          - U10*(I1[150] - I2[115])
          - U11*(I1[155] - I2[178])
          - U12*(I1[156] - I2[199])
          + (onezdon)*(I3[85] + AC0*I4[85])
          + (fourzdon)*(I3[126] + AC1*I4[81]);
*(vp++) = U0*I0[116]
          - U10*(I1[151] - I2[116])
          - U11*(I1[156] - I2[179])
          - U12*(I1[157] - I2[200])
          + (onezdon)*(I3[86] + AC0*I4[86])
          + (threezdon)*(I3[127] + AC1*I4[82])
          + (onezdon)*(I3[141] + AC2*I4[81]);
*(vp++) = U0*I0[117]
          - U10*(I1[152] - I2[117])
          - U11*(I1[157] - I2[180])
          - U12*(I1[158] - I2[201])
          + (onezdon)*(I3[87] + AC0*I4[87])
          + (twozdon)*(I3[128] + AC1*I4[83])
          + (twozdon)*(I3[142] + AC2*I4[82]);
*(vp++) = U0*I0[118]
          - U10*(I1[153] - I2[118])
          - U11*(I1[158] - I2[181])
          - U12*(I1[159] - I2[202])
          + (onezdon)*(I3[88] + AC0*I4[88])
          + (onezdon)*(I3[129] + AC1*I4[84])
          + (threezdon)*(I3[143] + AC2*I4[83]);
*(vp++) = U0*I0[119]
          - U10*(I1[154] - I2[119])
          - U11*(I1[159] - I2[182])
          - U12*(I1[160] - I2[203])
          + (onezdon)*(I3[89] + AC0*I4[89])
          + (fourzdon)*(I3[144] + AC2*I4[84]);
*(vp++) = U0*I0[120]
          - U10*(I1[155] - I2[120])
          - U11*(I1[161] - I2[183])
          - U12*(I1[162] - I2[204])
          + (fivezdon)*(I3[130] + AC1*I4[85]);
*(vp++) = U0*I0[121]
          - U10*(I1[156] - I2[121])
          - U11*(I1[162] - I2[184])
          - U12*(I1[163] - I2[205])
          + (fourzdon)*(I3[131] + AC1*I4[86])
          + (onezdon)*(I3[145] + AC2*I4[85]);
*(vp++) = U0*I0[122]
          - U10*(I1[157] - I2[122])
          - U11*(I1[163] - I2[185])
          - U12*(I1[164] - I2[206])
          + (threezdon)*(I3[132] + AC1*I4[87])
          + (twozdon)*(I3[146] + AC2*I4[86]);
*(vp++) = U0*I0[123]
          - U10*(I1[158] - I2[123])
          - U11*(I1[164] - I2[186])
          - U12*(I1[165] - I2[207])
          + (twozdon)*(I3[133] + AC1*I4[88])
          + (threezdon)*(I3[147] + AC2*I4[87]);
*(vp++) = U0*I0[124]
          - U10*(I1[159] - I2[124])
          - U11*(I1[165] - I2[187])
          - U12*(I1[166] - I2[208])
          + (onezdon)*(I3[134] + AC1*I4[89])
          + (fourzdon)*(I3[148] + AC2*I4[88]);
*(vp++) = U0*I0[125]
          - U10*(I1[160] - I2[125])
          - U11*(I1[166] - I2[188])
          - U12*(I1[167] - I2[209])
          + (fivezdon)*(I3[149] + AC2*I4[89]);

}
